/* $Id: dumpfake.c,v 1.3 2002/06/10 16:40:20 es7 Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * dumpfake.c: produce file for fake_NID module
 */
/*
 * Technology License for Research and Education Purposes
 *
 * Washington University ("University") in St. Louis has
 * developed and is the owner of the copyright for Field-programmable
 * Port Extender (FPX) Technology.
 *
 * The University grants to select not-for-profit educational institution
 * ("Licensee") receiving the Technology the right to use its Technology
 * solely for Licensee's internal nonprofit research and academic purposes.
 * This License is nontransferrable, royalty free and non-exclusive.
 * the licensee may reproduce Technology only for educational,
 * research, backup or archival purposes
 *
 * UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATIONS, EITHER EXPRESS
 * OR IMPLIED, FOR THE DESIGNS AND/OR DOCUMENTATION PROVIDED UNDER THIS
 * AGREEMENT, INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY
 * AND/OR WARRANTY OF FITNESS FOR A PARTICULAR USE AND/OR WARRANTY OF FREEDOM
 * OF INFRINGEMENT FROM THIRD PARTY PROPRIETARY RIGHTS.
 *
 * Licensee assumes the entire risk as to the performance of Technology and/or
 * associated materials, and to the performance and validity of information
 * generated using Technology.
 *
 * For complete terms of the agreement, review FPX-license.txt,
 * which is included in this file distribution.
 *
 *
 * Washington University
 * Applied Research Laboratory
 * 1 Brookings Drive
 * Campus Box 1045
 * Saint Louis, MO 63130  USA
 * Phone: (314) 935-4460
 * Web: http://www.arl.wustl.edu/arl/projects/fpx/
 *
 */

#include "testbench.h"
#include <stdio.h>

void DumpFake (char *outfile, StreamBlock *sblock)
{
  FILE *file;
  unsigned count;

  /* open file */
  file = fopen (outfile, "w");
  if (!file) {
    printf ("Error! cannot open file %s\n", outfile);
    return;
  }

  /* dump raw blocks */
  while (sblock) {
    if (sblock->btype == RAW) {
      fprintf (file, "new_cell\n");
      /* dump data */
      for (count=0; count<sblock->data->entries; count+=4)
	fprintf (file, "%02X%02X%02X%02X\n", sblock->data->data[count], sblock->data->data[count+1], sblock->data->data[count+2], sblock->data->data[count+3]);
    } /* it's a raw block */
    else if (sblock->btype == PAD) {
      unsigned pad=0;
      if (sblock->options)
	sscanf (sblock->options, "%d", &pad);
      for (count=0; count<pad; count++)
	fprintf (file, "00000000\n");
    }

    /* get next block */
    sblock = sblock->next;
  }


  /* close file */
  fclose (file);
}

