/* $Id: dumptb.c,v 1.5 2002/06/10 16:40:21 es7 Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * dumptb.c: output description file
 */
/*
 * Technology License for Research and Education Purposes
 *
 * Washington University ("University") in St. Louis has
 * developed and is the owner of the copyright for Field-programmable
 * Port Extender (FPX) Technology.
 *
 * The University grants to select not-for-profit educational institution
 * ("Licensee") receiving the Technology the right to use its Technology
 * solely for Licensee's internal nonprofit research and academic purposes.
 * This License is nontransferrable, royalty free and non-exclusive.
 * the licensee may reproduce Technology only for educational,
 * research, backup or archival purposes
 *
 * UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATIONS, EITHER EXPRESS
 * OR IMPLIED, FOR THE DESIGNS AND/OR DOCUMENTATION PROVIDED UNDER THIS
 * AGREEMENT, INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY
 * AND/OR WARRANTY OF FITNESS FOR A PARTICULAR USE AND/OR WARRANTY OF FREEDOM
 * OF INFRINGEMENT FROM THIRD PARTY PROPRIETARY RIGHTS.
 *
 * Licensee assumes the entire risk as to the performance of Technology and/or
 * associated materials, and to the performance and validity of information
 * generated using Technology.
 *
 * For complete terms of the agreement, review FPX-license.txt,
 * which is included in this file distribution.
 *
 *
 * Washington University
 * Applied Research Laboratory
 * 1 Brookings Drive
 * Campus Box 1045
 * Saint Louis, MO 63130  USA
 * Phone: (314) 935-4460
 * Web: http://www.arl.wustl.edu/arl/projects/fpx/
 *
 */

#include "testbench.h"
#include <stdio.h>

void DumpTB (char *outfile, StreamBlock *sblock)
{
  FILE *file;
  unsigned count;

  /* open file */
  file = fopen (outfile, "w");
  if (!file) {
    printf ("Error! cannot open file %s\n", outfile);
    return;
  }

  /* header */
  /*  fprintf (file, "# generated file\n");
   fprintf (file, "# do not edit!\n");
   fprintf (file, "#\n"); */

  /* dump every block */
  while (sblock) {
    if (sblock->btype != NONE) {
      /* print type */
      switch (sblock->btype)
	{
	case RAW:   fprintf (file, "!RAW"); break;
	case ERROR: fprintf (file, "!ERROR"); break;
	case PAD:   fprintf (file, "!PAD"); break;
	case CTRLCELL: fprintf (file, "!CTRLCELL"); break;
	case CELL:  fprintf (file, "!CELL"); break;
	case FRAME: fprintf (file, "!FRAME"); break;
	case IPv4:  fprintf (file, "!IPv4"); break;
	case IPv6:  fprintf (file, "!IPv6"); break;
	case UDP:   fprintf (file, "!UDP"); break;
	default:    fprintf (file, "!UNKNOWN"); break;
	}
      /* print options */
      if (sblock->options)
	fprintf (file, " %s\n", sblock->options);
      else
	fprintf (file, "\n");
      /* dump data */
      for (count=0; count<(sblock->data->entries ); count+=4)
	fprintf (file, "%02X%02X%02X%02X\n", sblock->data->data[count], sblock->data->data[count + 1], sblock->data->data[count + 2], sblock->data->data[count + 3]);
    } /* it's a real block */

    /* get next block */
    sblock = sblock->next;
  }


  /* close file */
  fclose (file);
}
