/* $Id: fake2raw.c,v 1.2 2002/01/23 12:43:06 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * fake2raw.c: read file from fake module and create raw blocks
 */
/*
 * Technology License for Research and Education Purposes
 * 
 * Washington University ("University") in St. Louis has 
 * developed and is the owner of the copyright for Field-programmable 
 * Port Extender (FPX) Technology.
 * 
 * The University grants to select not-for-profit educational institution 
 * ("Licensee") receiving the Technology the right to use its Technology 
 * solely for Licensee's internal nonprofit research and academic purposes.  
 * This License is nontransferrable, royalty free and non-exclusive.
 * the licensee may reproduce Technology only for educational, 
 * research, backup or archival purposes
 * 
 * UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATIONS, EITHER EXPRESS 
 * OR IMPLIED, FOR THE DESIGNS AND/OR DOCUMENTATION PROVIDED UNDER THIS 
 * AGREEMENT, INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY 
 * AND/OR WARRANTY OF FITNESS FOR A PARTICULAR USE AND/OR WARRANTY OF FREEDOM 
 * OF INFRINGEMENT FROM THIRD PARTY PROPRIETARY RIGHTS.  
 * 
 * Licensee assumes the entire risk as to the performance of Technology and/or 
 * associated materials, and to the performance and validity of information 
 * generated using Technology.  
 *
 * For complete terms of the agreement, review FPX-license.txt,
 * which is included in this file distribution.
 *
 * 
 * Washington University
 * Applied Research Laboratory
 * 1 Brookings Drive
 * Campus Box 1045
 * Saint Louis, MO 63130  USA
 * Phone: (314) 935-4460
 * Web: http://www.arl.wustl.edu/arl/projects/fpx/
 *
 */

#include "testbench.h"
#include <stdio.h>

StreamBlock *ParseSim (char *filename)
{
  FILE *file;
  char line[81], *options, *p;
  StreamBlock *start, *sblock;
  unsigned idx, word;

  /* open file */
  file = fopen (filename, "r");
  if (!file) {
    printf ("error opening file %s\n", filename);
    return NULL;
  }

  /* create new stream block */
  start = sblock = NewStreamBlock (NONE);

  /* parse file */
  while (!feof(file)) {
    /* read line */
    if (fgets (line, 80, file) ) {
      /* read ok */
      if (line[0] == '\0' || line[0] == '\n' || line[0] == '\r')
	continue;		/* empty line */
      if (line[0] == '#')	
	continue;		/* comment */

      if (!strncmp (line, "new_cell", 8)) {
	/* create new block for command */
	sblock->next = NewStreamBlock (RAW);
	sblock = sblock->next;
      }
      else {
	sscanf (line, "%x", &word);
	/* add word to block */
	AddToDataBlock (sblock->data, word);
      } /* parse number */
    } /* read line */
    
  } /* not end of file */

  /* close file */
  fclose (file);
  
  /* return stream */
  return start;
}

main (int argc, char**argv)
{
  char *infile = "CELLSOUT.DAT";
  char *outfile = "TBRAW.TBP";
  StreamBlock *sblock;

  if (argc > 1)
    infile = argv[1];
  if (argc > 2)
    outfile = argv[2];

  sblock = ParseSim (infile);

  DumpTB (outfile, sblock); 

  return 0;
}
