/* $Id: inccrc32.c,v 1.2 2002/01/23 12:43:06 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * ttldec.c: decrement ttl in ip header, update aal5 crc, works on cells
 */
/*
 * Technology License for Research and Education Purposes
 * 
 * Washington University ("University") in St. Louis has 
 * developed and is the owner of the copyright for Field-programmable 
 * Port Extender (FPX) Technology.
 * 
 * The University grants to select not-for-profit educational institution 
 * ("Licensee") receiving the Technology the right to use its Technology 
 * solely for Licensee's internal nonprofit research and academic purposes.  
 * This License is nontransferrable, royalty free and non-exclusive.
 * the licensee may reproduce Technology only for educational, 
 * research, backup or archival purposes
 * 
 * UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATIONS, EITHER EXPRESS 
 * OR IMPLIED, FOR THE DESIGNS AND/OR DOCUMENTATION PROVIDED UNDER THIS 
 * AGREEMENT, INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY 
 * AND/OR WARRANTY OF FITNESS FOR A PARTICULAR USE AND/OR WARRANTY OF FREEDOM 
 * OF INFRINGEMENT FROM THIRD PARTY PROPRIETARY RIGHTS.  
 * 
 * Licensee assumes the entire risk as to the performance of Technology and/or 
 * associated materials, and to the performance and validity of information 
 * generated using Technology.  
 *
 * For complete terms of the agreement, review FPX-license.txt,
 * which is included in this file distribution.
 *
 * 
 * Washington University
 * Applied Research Laboratory
 * 1 Brookings Drive
 * Campus Box 1045
 * Saint Louis, MO 63130  USA
 * Phone: (314) 935-4460
 * Web: http://www.arl.wustl.edu/arl/projects/fpx/
 *
 */

#include <stdlib.h>

int tabs_initialized = 0;
unsigned long crc_ttl_tab[256];
unsigned long crc_hcslo_tab[256];
unsigned long crc_hcshi_tab[256];
unsigned long crc_inc_tab[4][256];
extern unsigned long crc_tab[256];
extern int crc_tab_defined;

void gen_inc_tab (unsigned long* tab, int offs)
{
  unsigned i, j, update;

  for (i=0; i<256; i++) {
    update = i << 24;
    for (j=0; j<offs; j++) {
      update = (update << 8) ^ crc_tab [(update >> 24) & 0xFF];
    }
    tab[i] = update;
  }
}

void gen_tabs()
{
  if (!crc_tab_defined)
    gen_crc_tab();
  
  gen_inc_tab (crc_ttl_tab, 36);
  gen_inc_tab (crc_hcshi_tab, 34);
  gen_inc_tab (crc_hcslo_tab, 33);
  gen_inc_tab (crc_inc_tab[3], 48);
  gen_inc_tab (crc_inc_tab[2], 47);
  gen_inc_tab (crc_inc_tab[1], 46);
  gen_inc_tab (crc_inc_tab[0], 45);
}

