----------------------------------------------------------------------
-- This file is owned and controlled by Xilinx and must be used     --
-- solely for design, simulation, implementation and creation of    --
-- design files limited to Xilinx devices or technologies. Use      --
-- with non-Xilinx devices or technologies is expressly prohibited  --
-- and immediately terminates your license.                         --
--                                                                  --
-- Xilinx products are not intended for use in life support         --
-- appliances, devices, or systems. Use in such applications are    --
-- expressly prohibited.                                            --
--                                                                  --
-- Copyright (C) 2001, Xilinx, Inc.  All Rights Reserved.           --
----------------------------------------------------------------------

-- You must compile the wrapper file my_request_fifo.vhd when simulating
-- the core, my_request_fifo. When compiling the wrapper file, be sure to
-- reference the XilinxCoreLib VHDL simulation library. For detailed
-- instructions, please refer to the "Coregen Users Guide".

-- The synopsys directives "translate_off/translate_on" specified
-- below are supported by XST, FPGA Express, Exemplar and Synplicity
-- synthesis tools. Ensure they are correct for your synthesis tool(s).

-- synopsys translate_off
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

Library XilinxCoreLib;
ENTITY my_request_fifo IS
	port (
	clk: IN std_logic;
	sinit: IN std_logic;
	din: IN std_logic_VECTOR(31 downto 0);
	wr_en: IN std_logic;
	rd_en: IN std_logic;
	dout: OUT std_logic_VECTOR(31 downto 0);
	full: OUT std_logic;
	empty: OUT std_logic);
END my_request_fifo;

ARCHITECTURE my_request_fifo_a OF my_request_fifo IS

component wrapped_my_request_fifo
	port (
	clk: IN std_logic;
	sinit: IN std_logic;
	din: IN std_logic_VECTOR(31 downto 0);
	wr_en: IN std_logic;
	rd_en: IN std_logic;
	dout: OUT std_logic_VECTOR(31 downto 0);
	full: OUT std_logic;
	empty: OUT std_logic);
end component;

-- Configuration specification 
	for all : wrapped_my_request_fifo use entity XilinxCoreLib.sync_fifo_v3_0(behavioral)
		generic map(
			c_has_rd_err => 0,
			c_read_data_width => 32,
			c_rd_err_low => 1,
			c_has_wr_ack => 0,
			c_write_data_width => 32,
			c_wr_ack_low => 1,
			c_has_wr_err => 0,
			c_has_dcount => 0,
			c_ports_differ => 0,
			c_rd_ack_low => 1,
			c_memory_type => 1,
			c_write_depth => 32,
			c_has_rd_ack => 0,
			c_read_depth => 32,
			c_dcount_width => 1,
			c_wr_err_low => 1,
			c_enable_rlocs => 0);
BEGIN

U0 : wrapped_my_request_fifo
		port map (
			clk => clk,
			sinit => sinit,
			din => din,
			wr_en => wr_en,
			rd_en => rd_en,
			dout => dout,
			full => full,
			empty => empty);
END my_request_fifo_a;

-- synopsys translate_on

