LIBRARY ieee;
LIBRARY work;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;
--USE ieee.std_logic_textio.ALL;
--USE std.textio.ALL;
--USE work.util_1164.ALL;
--USE work.mti_pkg.ALL;
use work.PkgSdramController.all;
use work.PkgPsm.all;


entity FreePtrManager is
port (
       --Packet reader Interface
       FreePtrIn           : in std_logic_vector(c_ChunkPointerWidth-1 downto 0);
       FreePtrValidIn      : in std_logic;
       WriteError        : out std_logic;

       --Chunk Writer Interface
       GetFreePtr    : in std_logic;
       FreePtrValidOut  : out std_logic;
       BufferFull    : out std_logic;
       FreePtrOut    : out std_logic_vector(c_ChunkPointerWidth-1 downto 0);

       Clk           : in std_logic;
       Reset         : in std_logic);
end FreePtrManager;


architecture behave of FreePtrManager is

begin

process(Clk)

type           integer_file is  file of integer;
file           FreePtrFifo            : integer_file is in "FreePtrFifo.txt";
variable       v_FreePtr              : integer := 0;

begin

if Clk = '1' and Clk'event then
   if Reset = '0' then
      WriteError <= '0';
      FreePtrValidOut <= '0';
      BufferFull <= '0';
      FreePtrOut <= (others => '0');
      v_FreePtr := 0;
   else
      --Giving out a pointer
      FreePtrValidOut <= '0';
      BufferFull      <= '0';
      FreePtrOut      <= (others => '0');
      v_FreePtr := 0;
      if GetFreePtr = '1' then
         if not endfile(FreePtrFifo) then 
            read(FreePtrFifo,v_FreePtr);
            FreePtrOut <= conv_std_logic_vector(v_FreePtr,c_ChunkPointerWidth);
            FreePtrValidOut <= '1';
         else
            BufferFull <= '1';
         end if;
      end if;

      --Accepting a pointer

   end if;
end if;
end process;
end behave;
