------------------------------------------------------------------------------
--Execute the second state machine
------------------------------------------------------------------------------

      if StateMc1.PresentState = e_Start then
         if StateMc1.Run = '1'  then
            if StateMc1.OpType = '1' then
               if StateMc1.ModuleNum = 0 then
                  GetData <= '1';
               elsif StateMc1.ModuleNum = 1 then
                  SdramFreePtrGrant <= '1';
               end if;
            elsif StateMc1.OpType = '0' then
               if StateMc1.ModuleNum = 2 then
                  Clk1ReceiveData <= '1';
               elsif StateMc1.ModuleNum = 1 then
                  Clk1SdramFreePtrGrant <= '1';
               end if;
            end if;
         end if; --if StateMachine1.Run = '1'
      elsif StateMc1.PresentState = e_Act then
         -- execute the ACT command
         --if StateMc1.ActValid = '1' or BankPrecharged(conv_integer(StateMc1.Address(10 downto 8)))  = '1' then
         if BankPrecharged(conv_integer(StateMc1.Address(10 downto 8)))  = '1' then
            SdramRas  <= '0';       
            SdramCas  <= '1';
            SdramWe   <= '1';
            SdramS(conv_integer(StateMc1.Address(10))) <= '0';
            SdramAddr <= StateMc1.Address(22 downto 11); --rowaddress
            SdramBa   <= StateMc1.Address(9 downto 8);
            BankPrecharged(conv_integer(StateMc1.Address(10 downto 8))) <= '0';
         end if;
         ------------------------------------------------------------------
         --if the last burst of the current operation 
         if StateMc1.BurstLength = "00000000" then 
            --Other state machine is not in the use
            if StateMc0.Run = '0' then 
               --There is a WRSH type operation waiting
               if Tran = e_WRSH then  
                  --Load the state machine
                  StateMcLoaded         <= '1';
                  StateMc0.TranType     <= Tran;
                  StateMc0.ActValid     <= ActValid;
                  StateMc0.PchValid     <= '1';
                  StateMc1.PchValid     <= PrePchValid;
                  StateMc0.Address      <= Address;
                  StateMc0.BurstLength  <= "00" & BurstLength(7 downto 2);
                  StateMc0.OpType       <= OpType;
                  StateMc0.Valid        <= '1';
                  StateMc0.ModuleNum    <= ModuleNum;
                  --Trigger the state machine
                  StateMc0.Run <= '1'; 
                  --Update the current operation
                  CurrentOpType         <= OpType;
                  CurrentAddress        <= Address;
                  CurrentOpValid        <= '1';
                  --Pull the request from the appropriate module
                  if ModuleNum = 0 then
                     PullWrRequest <= '1';
                  elsif ModuleNum = 1 then
                     SdramFreePtrPullReq <= '1';
                  else
                     PullRdRequest <= '1';
                  end if;

               end if;
            end if;
         end if;
         ------------------------------------------------------------------

      elsif StateMc1.PresentState = e_Nop0 then
         if StateMc1.OpType = '1' then
            DriveSdramDataBus <= '1';
            DriveSdramDataBusModuleNum <= StateMc1.ModuleNum;
         end if;
         ------------------------------------------------------------------
         --if the last burst of the current operation 
         if StateMc1.BurstLength = "00000000" then 
            --Other state machine is not in the use
            if StateMc0.Run = '0' then 
               --There is a WRD type operation waiting
               if Tran = e_WRD then  
                  --Load the state machine
                  StateMcLoaded         <= '1';
                  StateMc0.TranType     <= Tran;
                  StateMc0.ActValid     <= ActValid;
                  StateMc0.PchValid     <= '1';
                  StateMc1.PchValid     <= PrePchValid;
                  StateMc0.Address      <= Address;
                  StateMc0.BurstLength  <= "00" & BurstLength(7 downto 2);
                  StateMc0.OpType       <= OpType;
                  StateMc0.Valid        <= '1';
                  StateMc0.ModuleNum    <= ModuleNum;
                  --Trigger the state machine
                  StateMc0.Run <= '1'; 
                  --Update the current operation
                  CurrentOpType         <= OpType;
                  CurrentAddress        <= Address;
                  CurrentOpValid        <= '1';
                  --Pull the request from the appropriate module
                  if ModuleNum = 0 then
                     PullWrRequest <= '1';
                  elsif ModuleNum = 1 then
                     SdramFreePtrPullReq <= '1';
                  else
                     PullRdRequest <= '1';
                  end if;

               end if;
            end if;
         end if;
         ------------------------------------------------------------------
      elsif StateMc1.PresentState = e_Rd then
         SdramRas  <= '1';       -- execute the RD command
         SdramCas  <= '0';
         SdramWe   <= '1';
         SdramS(conv_integer(StateMc1.Address(10))) <= '0';
         SdramAddr(7 downto 0) <= StateMc1.Address(7 downto 0); --col address
         SdramBa   <= StateMc1.Address(9 downto 8);
         DriveUserDataBus <= '1';
         DriveUserDataBusModuleNum <= StateMc1.ModuleNum;
         ------------------------------------------------------------------
         --if the last burst of the current operation 
         if StateMc1.BurstLength = "00000000" then 
            --Other state machine is not in the use
            if StateMc0.Run = '0' then 
               --There is a RRD RRSH type operation waiting
               if Tran = e_RRD or Tran = e_RRSH then  
                  --Load the state machine
                  StateMcLoaded         <= '1';
                  StateMc0.TranType     <= Tran;
                  StateMc0.ActValid     <= ActValid;
                  StateMc0.PchValid     <= '1';
                  StateMc1.PchValid     <= PrePchValid;
                  StateMc0.Address      <= Address;
                  StateMc0.BurstLength  <= "00" & BurstLength(7 downto 2);
                  StateMc0.OpType       <= OpType;
                  StateMc0.Valid        <= '1';
                  StateMc0.ModuleNum    <= ModuleNum;
                  --Trigger the state machine
                  StateMc0.Run <= '1'; 
                  --Update the current operation
                  CurrentOpType         <= OpType;
                  CurrentAddress        <= Address;
                  CurrentOpValid        <= '1';
                  --Pull the request from the appropriate module
                  if ModuleNum = 0 then
                     PullWrRequest <= '1';
                  elsif ModuleNum = 1 then
                     SdramFreePtrPullReq <= '1';
                  else
                     PullRdRequest <= '1';
                  end if;

               end if;
            end if;
         end if;
         ------------------------------------------------------------------
      elsif StateMc1.PresentState = e_Wr then
         SdramRas  <= '1';       -- execute the WR command
         SdramCas  <= '0';
         SdramWe   <= '0';
         SdramS(conv_integer(StateMc1.Address(10))) <= '0';
         SdramAddr(7 downto 0) <= StateMc1.Address(7 downto 0); --col address
         SdramBa   <= StateMc1.Address(9 downto 8);
         ------------------------------------------------------------------
         --if the last burst of the current operation 
         if StateMc1.BurstLength = "00000000" then 
            --Other state machine is not in the use
            if StateMc0.Run = '0' then 
               --There is a WWD WWSH type operation waiting
               if Tran = e_WWD or Tran = e_WWSH then  
                  --Load the state machine
                  StateMcLoaded         <= '1';
                  StateMc0.TranType     <= Tran;
                  StateMc0.ActValid     <= ActValid;
                  StateMc0.PchValid     <= '1';
                  StateMc1.PchValid     <= PrePchValid;
                  StateMc0.Address      <= Address;
                  StateMc0.BurstLength  <= "00" & BurstLength(7 downto 2);
                  StateMc0.OpType       <= OpType;
                  StateMc0.Valid        <= '1';
                  StateMc0.ModuleNum    <= ModuleNum;
                  --Trigger the state machine
                  StateMc0.Run <= '1'; 
                  --Update the current operation
                  CurrentOpType         <= OpType;
                  CurrentAddress        <= Address;
                  CurrentOpValid        <= '1';
                  --Pull the request from the appropriate module
                  if ModuleNum = 0 then
                     PullWrRequest <= '1';
                  elsif ModuleNum = 1 then
                     SdramFreePtrPullReq <= '1';
                  else
                     PullRdRequest <= '1';
                  end if;

               end if;
            end if;
         end if;
         ------------------------------------------------------------------
      elsif StateMc1.PresentState = e_Nop1 then
         if StateMc1.BurstLength /= "00000000" then
            StateMc1.ActValid <= '0';
            StateMc1.Address <= StateMc1.Address + "100";
            StateMc1.BurstLength <= StateMc1.BurstLength - '1';
         end if;
      elsif StateMc1.PresentState = e_Nop3 then
         if StateMc1.OpType = '1' and not (StateMc0.PresentState = e_Nop0 and StateMc0.OpType = '1') then
            DriveSdramDataBus <= '0';
            DriveSdramDataBusModuleNum <= 3;
         end if;
      elsif StateMc1.PresentState = e_Nop4 then
         if StateMc1.OpType = '0' and StateMc0.PresentState /= e_rd then
            DriveUserDataBus <= '0';
            DriveUserDataBusModuleNum <= 3;
         end if;
         ------------------------------------------------------------------
         --if the last burst of the current operation 
         if StateMc1.BurstLength = "00000000" then 
            --Other state machine is not in the use
            if StateMc0.Run = '0' then 
               --There is a WWD WWSH type operation waiting
               if Tran = e_RWD or Tran = e_RWSH then  
                  --Load the state machine
                  StateMcLoaded         <= '1';
                  StateMc0.TranType     <= Tran;
                  StateMc0.ActValid     <= ActValid;
                  StateMc0.PchValid     <= '1';
                  StateMc1.PchValid     <= PrePchValid;
                  StateMc0.Address      <= Address;
                  StateMc0.BurstLength  <= "00" & BurstLength(7 downto 2);
                  StateMc0.OpType       <= OpType;
                  StateMc0.Valid        <= '1';
                  StateMc0.ModuleNum    <= ModuleNum;
                  --Trigger the state machine
                  StateMc0.Run <= '1'; 
                  --Update the current operation
                  CurrentOpType         <= OpType;
                  CurrentAddress        <= Address;
                  CurrentOpValid        <= '1';
                  --Pull the request from the appropriate module
                  if ModuleNum = 0 then
                     PullWrRequest <= '1';
                  elsif ModuleNum = 1 then
                     SdramFreePtrPullReq <= '1';
                  else
                     PullRdRequest <= '1';
                  end if;

               end if;
            end if;
         end if;
         ------------------------------------------------------------------
      elsif StateMc1.PresentState = e_Pch  then
         if StateMc1.PchValid = '1' then
            SdramRas  <= '0';       -- execute the PCH command
            SdramCas  <= '1';
            SdramWe   <= '0';
            SdramS(conv_integer(StateMc1.Address(10))) <= '0';
            SdramBa   <= StateMc1.Address(9 downto 8);
            BankPrecharged(conv_integer(StateMc1.Address(10 downto 8))) <= '1';
         end if;
         --State machine should be reset after the use????Make sure that nothing else is writing to this above
         StateMc1.TranType     <= e_NoTran;
         StateMc1.ActValid     <= '0';
         StateMc1.PchValid     <= '0';
         StateMc1.Address      <= (others => '0');
         StateMc1.OpType       <= '0';
         StateMc1.Run          <= '0';
         StateMc1.Valid        <= '0';
         StateMc1.ModuleNum    <= 3;
         if StateMc0.Valid = '0' then
            CurrentOpValid        <= '0';
         end if;
         ------------------------------------------------------------------
         --if the last burst of the current operation 
         if StateMc1.BurstLength = "00000000" then 
            --Other state machine is not in the use
            if StateMc0.Run = '0' then 
               --There is a WWD WWSH type operation waiting
               if Tran = e_RRSM or Tran = e_RWSM or Tran = e_WWSM or Tran = e_WRSM then  
                  --Load the state machine
                  StateMcLoaded         <= '1';
                  StateMc0.TranType     <= Tran;
                  StateMc0.ActValid     <= ActValid;
                  StateMc0.PchValid     <= '1';
                  StateMc1.PchValid     <= PrePchValid;
                  StateMc0.Address      <= Address;
                  StateMc0.BurstLength  <= "00" & BurstLength(7 downto 2);
                  StateMc0.OpType       <= OpType;
                  StateMc0.Valid        <= '1';
                  StateMc0.ModuleNum    <= ModuleNum;
                  --Trigger the state machine
                  StateMc0.Run <= '1'; 
                  --Update the current operation
                  CurrentOpType         <= OpType;
                  CurrentAddress        <= Address;
                  CurrentOpValid        <= '1';
                  --Pull the request from the appropriate module
                  if ModuleNum = 0 then
                     PullWrRequest <= '1';
                  elsif ModuleNum = 1 then
                     SdramFreePtrPullReq <= '1';
                  else
                     PullRdRequest <= '1';
                  end if;

               end if;
            end if;
         end if;
         ------------------------------------------------------------------
     end if; --if StateMc1.PresentState = 
