       if LmrValid = '1' then
          SdramS <= (others => '0');  -- Select both
          Ready  <= '0';
          EnLmrCounter <= '1';

          if EnLmrCounter  = '1' then
             LmrCounter <= LmrCounter + 1;
          end if; 

          if LmrCounter = 10 then
             --On reset, precharge all the banks (this is the first command in
             --the power up/initialization command sequence)
             SdramRas         <= '0';
             SdramCas         <= '1';
             SdramWe          <= '0';

             --PRECHARGE all  the banks
             SdramAddr(10)    <= '1';
            BankPrecharged <= (others => '1');

          elsif LmrCounter = 22  then
             --LMR
             SdramRas  <= '0';
             SdramCas  <= '0';
             SdramWe   <= '0';

             --Reserved bits
             SdramAddr(11 downto 10) <= "00";
             --Use programmed burst length
             SdramAddr(9)            <= '0';
             --Op mode is standard operation
             SdramAddr(8 downto 7)   <= "00";
             --Cas latency = 2
             SdramAddr(6 downto 4)   <= "010";
             --Burst type is sequential
             SdramAddr(3)            <= '0';
             --Burst length = 8
             SdramAddr(2 downto 0)   <= "010";

          elsif LmrCounter = 24 then
             --AUTO REFRESH
             SdramRas  <= '0';
             SdramCas  <= '0';
             SdramWe   <= '1';
          elsif LmrCounter = 31 then
             --AUTO REFRESH
             SdramRas  <= '0';
             SdramCas  <= '0';
             SdramWe   <= '1';
          elsif LmrCounter =  37 then
             --Reset the counter and end the Init cycle
             LmrValid   <= '0';
             --SDRAM_EN the access to the SDRAM
             Ready         <= '1';
             EnLmrCounter <= '0';
          end if; -- what is the count number
      end if;--if LmrValid = '1'
