--
-- Technology License for Research and Education Purposes
-- 
-- Washington University ("University") in St. Louis has 
-- developed and is the owner of the copyright for Field-programmable 
-- Port Extender (FPX) Technology.
-- 
-- The University grants to select not-for-profit educational institution 
-- ("Licensee") receiving the Technology the right to use its Technology 
-- solely for Licensee's internal nonprofit research and academic purposes.  
-- This License is nontransferrable, royalty free and non-exclusive.
-- the licensee may reproduce Technology only for educational, 
-- research, backup or archival purposes
-- 
-- UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATIONS, EITHER EXPRESS 
-- OR IMPLIED, FOR THE DESIGNS AND/OR DOCUMENTATION PROVIDED UNDER THIS 
-- AGREEMENT, INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY 
-- AND/OR WARRANTY OF FITNESS FOR A PARTICULAR USE AND/OR WARRANTY OF FREEDOM 
-- OF INFRINGEMENT FROM THIRD PARTY PROPRIETARY RIGHTS.  
-- 
-- Licensee assumes the entire risk as to the performance of Technology and/or 
-- associated materials, and to the performance and validity of information 
-- generated using Technology.  
--
-- For complete terms of the agreement, review FPX-license.txt,
-- which is included in this file distribution.
--
-- 
-- Washington University
-- Applied Research Laboratory
-- 1 Brookings Drive
-- Campus Box 1045
-- Saint Louis, MO 63130  USA
-- Phone: (314) 935-4460
-- Web: http://www.arl.wustl.edu/arl/projects/fpx/
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package PkgSdramController is
constant c_DataWidth : integer := 64;
constant c_BLwidth : integer := 8;
constant c_AddressWidth : integer := 23;
constant c_MaxRefreshCount : integer := 200;
constant c_Priori : std_logic_vector(2 downto 0) := "010";
constant c_PipeLineDelay : std_logic_vector(2 downto 0):="001";
type t_State is (e_Start, 
                 e_Act, e_ActTrig, e_PseudoAct, e_PseudoActTrig, 
                 e_Rd, e_RdTrig, 
                 e_Wr, e_WrTrig, 
                 e_Nop0, e_Nop0Drive, e_Nop0Trig, e_Nop0DriveTrig, 
                 e_Nop1, 
                 e_Nop2, 
                 e_Nop3, e_Nop3Nodrive, 
                 e_Nop4, e_Nop4Nodrive, e_Nop4Trig, e_Nop4NodriveTrig, 
                 e_Pch, e_PseudoPch, e_PchTrig, e_PseudoPchTrig
                );
type t_TranType is (e_RRSH, e_RRSM, e_RRD, e_WRSH, e_WRSM, e_WRD, e_WWSH, 
                    e_WWSM, e_WWD, e_RWSH, e_RWSM, e_RWD, e_NewRd, e_NewWr, e_NoTran);

 
end PkgSdramController;
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
package body  PkgSdramController is


end PkgSdramController;



