library work;
use work.PkgSdramController.all;
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package PkgPsm is
constant c_ChunkPointerWidth : integer := 32;
constant c_Queues          : integer := 65;
constant c_NullPtr           : std_logic_vector(c_ChunkPointerWidth-1 downto 0) := (others => '1');

constant c_ChunkLength       : integer := 16;  --in terms of 8 byte words
constant c_TotalChunks       : integer := (2**c_AddressWidth)/c_ChunkLength;
constant c_FreePtrFifoSize   : integer := c_TotalChunks/2;  --each word accomodates 2 pointers 
constant c_ChunksReserved    : integer := c_FreePtrFifoSize/c_ChunkLength;
constant c_EffectiveChunks   : integer := c_TotalChunks - c_ChunksReserved; 
constant c_SdramFifoEndMarker  : std_logic_vector(c_AddressWidth-1 downto 0) 
                                   := (others => '1'); 
constant c_SdramFifoStartMarker  : std_logic_vector(c_AddressWidth-1 downto 0) 
                                   := c_SdramFifoEndMarker - conv_std_logic_vector(c_ChunksReserved*c_ChunkLength-1,c_AddressWidth); 
constant c_ActualFifoLengthInChunks : integer := c_EffectiveChunks/(c_ChunkLength*2);
constant c_Threshold1 : integer := 16*2;
constant c_Threshold2 : integer := 248*2;
constant c_Mtu : integer := 2000;
constant c_PtrOnchip : integer := (c_Queues + 1 + 512);
end PkgPsm;

package body PkgPsm is
end PkgPsm;
