

ARCHITECTURE behavioral OF fake_NID_in IS

  file out_file : text open write_mode is outfile;

  signal word_count : integer := 13;

BEGIN  -- behavioral
  tcaff <= '1';                         -- always accept data
  write_process : process(clock)
    variable line_out : LINE;
    VARIABLE newcell  : STRING(8 DOWNTO 1) := "new_cell";
    
  begin
    if (clock = '1' and clock'event) then
      if soc_in = '1' then
        assert word_count = 13 report "Multiple SOCs in 1 Cell Time" severity WARNING;
        word_count <= 0;
        write(line_out, newcell);
        writeline(out_file, line_out);
      end if;
      if soc_in = '1' or word_count < 13 then
        hwrite(line_out, data_in);      -- put the hex value in a line buffer
        writeline(out_file, line_out);
        if soc_in = '0' then
          word_count <= word_count + 1;
        end if;
      end if;
    end if;
  end process;
END behavioral;
