-- Xilinx Vhdl produced by program ngd2vhdl E.35
-- Command: -w regex_app.ngd regex_app_sim.vhd 
-- Input file: regex_app.ngd
-- Output file: regex_app_sim.vhd
-- Design name: regex_app
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: v2000efg680-6

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity regex_app is
  port (
    sod_appl_in : out STD_LOGIC; 
    dataen_out_appl : in STD_LOGIC := 'X'; 
    reset_l : in STD_LOGIC := 'X'; 
    dataen_appl_in : out STD_LOGIC; 
    tca_out_appl : out STD_LOGIC; 
    tca_appl_in : in STD_LOGIC := 'X'; 
    sod_out_appl : in STD_LOGIC := 'X'; 
    eof_out_appl : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    sof_out_appl : in STD_LOGIC := 'X'; 
    ready_l : out STD_LOGIC; 
    eof_appl_in : out STD_LOGIC; 
    sof_appl_in : out STD_LOGIC; 
    enable_l : in STD_LOGIC := 'X'; 
    d_out_appl : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    d_appl_in : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    matched : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end regex_app;

architecture STRUCTURE of regex_app is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal regex_in_2_1_Q : STD_LOGIC; 
  signal regex_in_2_4_Q : STD_LOGIC; 
  signal regex_in_2_2_Q : STD_LOGIC; 
  signal regex_in_2_5_Q : STD_LOGIC; 
  signal reset_l_0 : STD_LOGIC; 
  signal reset_l_1 : STD_LOGIC; 
  signal reset_l_2 : STD_LOGIC; 
  signal dataen_out : STD_LOGIC; 
  signal eof_out : STD_LOGIC; 
  signal sod_out : STD_LOGIC; 
  signal sof_out : STD_LOGIC; 
  signal reset_l_i_8 : STD_LOGIC; 
  signal reset_l_i_7 : STD_LOGIC; 
  signal reset_l_i_6 : STD_LOGIC; 
  signal reset_l_i_5 : STD_LOGIC; 
  signal reset_l_i_4 : STD_LOGIC; 
  signal reset_l_i_3 : STD_LOGIC; 
  signal reset_l_i_2 : STD_LOGIC; 
  signal reset_l_i_1 : STD_LOGIC; 
  signal reset_l_i : STD_LOGIC; 
  signal regular_expression_machine5_N_2119 : STD_LOGIC; 
  signal regular_expression_machine5_N_2047 : STD_LOGIC; 
  signal G_723_sx : STD_LOGIC; 
  signal G_723 : STD_LOGIC; 
  signal regular_expression_machine5_N_2099 : STD_LOGIC; 
  signal regular_expression_machine5_N_2101 : STD_LOGIC; 
  signal regular_expression_machine5_N_2102 : STD_LOGIC; 
  signal regular_expression_machine5_N_2083 : STD_LOGIC; 
  signal cntrlr_out_state_8_Q : STD_LOGIC; 
  signal G_702 : STD_LOGIC; 
  signal G_703 : STD_LOGIC; 
  signal G_704 : STD_LOGIC; 
  signal G_705 : STD_LOGIC; 
  signal G_706 : STD_LOGIC; 
  signal G_707 : STD_LOGIC; 
  signal G_708 : STD_LOGIC; 
  signal G_709 : STD_LOGIC; 
  signal cntrlr_out_buf_out_34_Q : STD_LOGIC; 
  signal G_711 : STD_LOGIC; 
  signal cntrlr_fifo_we_2 : STD_LOGIC; 
  signal cntrlr_out_state_2_Q : STD_LOGIC; 
  signal cntrlr_out_buf_out_32_Q : STD_LOGIC; 
  signal G_715 : STD_LOGIC; 
  signal cntrlr_match_fifo_un1_rddone_buf : STD_LOGIC; 
  signal cntrlr_match_fifo_rddone_buf : STD_LOGIC; 
  signal G_716 : STD_LOGIC; 
  signal G_717 : STD_LOGIC; 
  signal cntrlr_match_fifo_un1_tail_19_c2 : STD_LOGIC; 
  signal G_718 : STD_LOGIC; 
  signal G_719 : STD_LOGIC; 
  signal regular_expression_machine5_N_2085 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_5_Q : STD_LOGIC; 
  signal regex_en_2 : STD_LOGIC; 
  signal G_727 : STD_LOGIC; 
  signal regex_restart : STD_LOGIC; 
  signal regular_expression_machine2_N_639 : STD_LOGIC; 
  signal G_730 : STD_LOGIC; 
  signal regular_expression_machine2_N_668 : STD_LOGIC; 
  signal G_731 : STD_LOGIC; 
  signal regular_expression_machine2_N_696 : STD_LOGIC; 
  signal G_732 : STD_LOGIC; 
  signal regular_expression_machine2_N_709 : STD_LOGIC; 
  signal G_733 : STD_LOGIC; 
  signal regular_expression_machine2_N_596 : STD_LOGIC; 
  signal G_734 : STD_LOGIC; 
  signal regular_expression_machine0_N_688 : STD_LOGIC; 
  signal G_736 : STD_LOGIC; 
  signal regular_expression_machine0_N_717 : STD_LOGIC; 
  signal G_737 : STD_LOGIC; 
  signal regular_expression_machine0_N_746 : STD_LOGIC; 
  signal G_738 : STD_LOGIC; 
  signal regular_expression_machine0_N_772 : STD_LOGIC; 
  signal G_739 : STD_LOGIC; 
  signal regular_expression_machine0_N_638 : STD_LOGIC; 
  signal G_740 : STD_LOGIC; 
  signal cntrlr_N_811_1_i : STD_LOGIC; 
  signal cntrlr_out_state_0_Q : STD_LOGIC; 
  signal cntrlr_un20_dataen_out_6 : STD_LOGIC; 
  signal N_816_i : STD_LOGIC; 
  signal regular_expression_machine5_N_2098 : STD_LOGIC; 
  signal state_ns_246_0_and2_2_514 : STD_LOGIC; 
  signal regular_expression_machine5_N_2215 : STD_LOGIC; 
  signal N_826_2 : STD_LOGIC; 
  signal regular_expression_machine5_N_2094 : STD_LOGIC; 
  signal state_ns_246_0_and2_1_679 : STD_LOGIC; 
  signal regular_expression_machine5_N_1470 : STD_LOGIC; 
  signal G_724 : STD_LOGIC; 
  signal regular_expression_machine5_N_2092 : STD_LOGIC; 
  signal regular_expression_machine5_N_2140 : STD_LOGIC; 
  signal regular_expression_machine5_N_2126 : STD_LOGIC; 
  signal N_827_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_3_Q : STD_LOGIC; 
  signal G_725 : STD_LOGIC; 
  signal regular_expression_machine5_N_2086 : STD_LOGIC; 
  signal regular_expression_machine5_N_2087 : STD_LOGIC; 
  signal state_ns_322_0_and2_1_678 : STD_LOGIC; 
  signal regular_expression_machine5_N_2044 : STD_LOGIC; 
  signal G_726 : STD_LOGIC; 
  signal cntrlr_out_state_11_Q : STD_LOGIC; 
  signal cntrlr_fifo_empty : STD_LOGIC; 
  signal N_812_1 : STD_LOGIC; 
  signal cntrlr_mfifo_avail : STD_LOGIC; 
  signal G_710 : STD_LOGIC; 
  signal regex_en_0_0_and2_1_226 : STD_LOGIC; 
  signal cntrlr_N_1066 : STD_LOGIC; 
  signal regex_en_0_0_and2_0_208 : STD_LOGIC; 
  signal regex_en_0_0_and2_2_206 : STD_LOGIC; 
  signal G_713 : STD_LOGIC; 
  signal regular_expression_machine0_N_920_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_288 : STD_LOGIC; 
  signal regular_expression_machine6_N_308 : STD_LOGIC; 
  signal regular_expression_machine6_N_308_fast : STD_LOGIC; 
  signal regular_expression_machine6_N_308_rep1 : STD_LOGIC; 
  signal regular_expression_machine0_N_907_2 : STD_LOGIC; 
  signal cntrlr_N_882_1_i_2 : STD_LOGIC; 
  signal G_1_fast : STD_LOGIC; 
  signal regular_expression_machine6_N_307 : STD_LOGIC; 
  signal regular_expression_machine6_N_308_1 : STD_LOGIC; 
  signal regex_en : STD_LOGIC; 
  signal regular_expression_machine3_N_394_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_340_2 : STD_LOGIC; 
  signal regular_expression_machine7_N_344 : STD_LOGIC; 
  signal regular_expression_machine3_N_361 : STD_LOGIC; 
  signal regular_expression_machine1_N_520 : STD_LOGIC; 
  signal regular_expression_machine7_N_328 : STD_LOGIC; 
  signal regular_expression_machine1_N_561 : STD_LOGIC; 
  signal regular_expression_machine1_N_443 : STD_LOGIC; 
  signal regular_expression_machine6_N_342_2 : STD_LOGIC; 
  signal regular_expression_machine7_N_322_1 : STD_LOGIC; 
  signal regular_expression_machine3_N_418 : STD_LOGIC; 
  signal regular_expression_machine1_N_491_3 : STD_LOGIC; 
  signal regular_expression_machine6_N_310 : STD_LOGIC; 
  signal regular_expression_machine6_N_311 : STD_LOGIC; 
  signal regular_expression_machine7_N_104_1 : STD_LOGIC; 
  signal regular_expression_machine1_N_433_i : STD_LOGIC; 
  signal regular_expression_machine2_N_595_1 : STD_LOGIC; 
  signal regex_en_1 : STD_LOGIC; 
  signal cntrlr_N_882_1_i_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_374_1 : STD_LOGIC; 
  signal regular_expression_machine3_N_388_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_341_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_339_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_375_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_288_rep1 : STD_LOGIC; 
  signal regular_expression_machine6_N_329_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_340_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_367_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_394 : STD_LOGIC; 
  signal regular_expression_machine7_N_368_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_271_2 : STD_LOGIC; 
  signal regular_expression_machine7_N_365_1 : STD_LOGIC; 
  signal cntrlr_N_882_1_i : STD_LOGIC; 
  signal regular_expression_machine0_G_88_s : STD_LOGIC; 
  signal regular_expression_machine0_G_109_sx : STD_LOGIC; 
  signal regular_expression_machine0_N_965 : STD_LOGIC; 
  signal regular_expression_machine0_G_97_sx : STD_LOGIC; 
  signal regular_expression_machine0_N_953 : STD_LOGIC; 
  signal regular_expression_machine0_N_946 : STD_LOGIC; 
  signal regular_expression_machine0_G_127_bm_1 : STD_LOGIC; 
  signal regular_expression_machine0_N_962 : STD_LOGIC; 
  signal regular_expression_machine0_G_127_bm : STD_LOGIC; 
  signal regular_expression_machine0_N_947 : STD_LOGIC; 
  signal regular_expression_machine0_N_884 : STD_LOGIC; 
  signal regular_expression_machine0_N_897 : STD_LOGIC; 
  signal regular_expression_machine0_G_127_am : STD_LOGIC; 
  signal regular_expression_machine0_N_895 : STD_LOGIC; 
  signal regular_expression_machine0_N_708 : STD_LOGIC; 
  signal regular_expression_machine0_N_958 : STD_LOGIC; 
  signal regular_expression_machine0_N_882 : STD_LOGIC; 
  signal regular_expression_machine0_N_964 : STD_LOGIC; 
  signal regular_expression_machine0_N_952 : STD_LOGIC; 
  signal regular_expression_machine0_N_945 : STD_LOGIC; 
  signal regular_expression_machine0_state_ns_30_s : STD_LOGIC; 
  signal regular_expression_machine0_G_87_s : STD_LOGIC; 
  signal regular_expression_machine0_G_94_s : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_710 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_180_sx : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_744 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_922 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_634 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_224_i_55_1 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_224_i_55 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_57_bm_1 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_57_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_624 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_920 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_722 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_610 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_637 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_679 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_921 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_671 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_666 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_919 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_827 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_127_0_and2_0_619 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_693 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_316_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_316_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_757 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_216_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_216_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_761 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_771 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_209_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_209_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_635 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_707 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_737 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_199_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_199_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_759 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_750_1 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_731 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_745 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_741 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_177_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_177_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_701 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_736 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_172_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_172_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_280_278 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_246_263 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_167_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_167_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_729 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_645 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_603 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_298_605 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_725 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_151_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_151_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_715 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_706 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_697 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_141_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_141_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_140_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_140_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_139_0_683 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_918 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_314_671 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_138_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_138_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_704 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_659 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_687 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_119_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_119_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_685 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_43 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_103_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_103_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_658 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_90_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_90_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_914 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_656 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_309_234 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_606 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_644 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_266_308 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_907 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_262_317 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_627 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_630 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_64_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_64_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_60_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_60_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_57_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_302_643 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_609 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_34_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_34_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_N_607 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_32_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_32_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_23_s : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_28_am : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_28_bm : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_312_642 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_89_0_and2_0_300 : STD_LOGIC; 
  signal regular_expression_machine0_state_h_state_ns_280_275 : STD_LOGIC; 
  signal regular_expression_machine1_N_560 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_4_Q : STD_LOGIC; 
  signal regular_expression_machine1_N_547 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_2_Q : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_16_Q : STD_LOGIC; 
  signal regular_expression_machine1_N_303 : STD_LOGIC; 
  signal regular_expression_machine1_N_431 : STD_LOGIC; 
  signal regular_expression_machine1_N_398_1 : STD_LOGIC; 
  signal regular_expression_machine1_N_468 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_12_Q : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_14_Q : STD_LOGIC; 
  signal regular_expression_machine1_N_521 : STD_LOGIC; 
  signal regular_expression_machine1_N_482_4 : STD_LOGIC; 
  signal regular_expression_machine1_N_484 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_6_Q : STD_LOGIC; 
  signal regular_expression_machine1_N_438 : STD_LOGIC; 
  signal regular_expression_machine1_N_442 : STD_LOGIC; 
  signal regular_expression_machine1_N_502 : STD_LOGIC; 
  signal regular_expression_machine1_G_200_280 : STD_LOGIC; 
  signal regular_expression_machine1_N_430 : STD_LOGIC; 
  signal regular_expression_machine1_G_198_235 : STD_LOGIC; 
  signal regular_expression_machine1_N_429 : STD_LOGIC; 
  signal regular_expression_machine1_N_428 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_11_20_498 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_0_and2_21_570 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_21_Q : STD_LOGIC; 
  signal regular_expression_machine1_N_525 : STD_LOGIC; 
  signal regular_expression_machine1_N_524 : STD_LOGIC; 
  signal regular_expression_machine1_N_509 : STD_LOGIC; 
  signal regular_expression_machine1_N_285 : STD_LOGIC; 
  signal regular_expression_machine1_G_221_119 : STD_LOGIC; 
  signal regular_expression_machine1_G_221_117 : STD_LOGIC; 
  signal regular_expression_machine1_G_239_135 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_0_and2_10_301 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_10_Q : STD_LOGIC; 
  signal regular_expression_machine1_N_555 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_12_20_420 : STD_LOGIC; 
  signal regular_expression_machine1_N_491 : STD_LOGIC; 
  signal regular_expression_machine1_N_488 : STD_LOGIC; 
  signal regular_expression_machine1_N_485 : STD_LOGIC; 
  signal regular_expression_machine1_N_470 : STD_LOGIC; 
  signal regular_expression_machine1_N_469 : STD_LOGIC; 
  signal regular_expression_machine1_N_467 : STD_LOGIC; 
  signal regular_expression_machine1_N_466 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_18_Q : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_20_578 : STD_LOGIC; 
  signal regular_expression_machine1_N_478 : STD_LOGIC; 
  signal regular_expression_machine1_un1_state_83_0_and2_581 : STD_LOGIC; 
  signal regular_expression_machine1_N_553 : STD_LOGIC; 
  signal regular_expression_machine1_N_554 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_20_64 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_20_65 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_20_66 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_2_20_527 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_3_20_438 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_20_69 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_0_20_366 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_20_70 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_20_72 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_97_i_and2_218 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_99_i_and2_222 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_3_20_435 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_2_20_524 : STD_LOGIC; 
  signal regular_expression_machine1_nxt_state_47_99_i_579 : STD_LOGIC; 
  signal regular_expression_machine1_N_59_i : STD_LOGIC; 
  signal regular_expression_machine1_N_401_i : STD_LOGIC; 
  signal regular_expression_machine1_N_398_i : STD_LOGIC; 
  signal regular_expression_machine1_N_513_i : STD_LOGIC; 
  signal regular_expression_machine1_GND : STD_LOGIC; 
  signal regular_expression_machine2_G_67_sx : STD_LOGIC; 
  signal regular_expression_machine2_G_83_sx : STD_LOGIC; 
  signal regular_expression_machine2_N_847 : STD_LOGIC; 
  signal regular_expression_machine2_G_82_243 : STD_LOGIC; 
  signal regular_expression_machine2_G_81_sx_0 : STD_LOGIC; 
  signal regular_expression_machine2_N_845 : STD_LOGIC; 
  signal regular_expression_machine2_N_831 : STD_LOGIC; 
  signal regular_expression_machine2_N_829 : STD_LOGIC; 
  signal regular_expression_machine2_G_76_sx : STD_LOGIC; 
  signal regular_expression_machine2_N_840 : STD_LOGIC; 
  signal regular_expression_machine2_G_76_fast_sx : STD_LOGIC; 
  signal regular_expression_machine2_G_76_fast : STD_LOGIC; 
  signal regular_expression_machine2_N_827 : STD_LOGIC; 
  signal regular_expression_machine2_G_81_sx : STD_LOGIC; 
  signal regular_expression_machine2_N_600 : STD_LOGIC; 
  signal regular_expression_machine2_N_557 : STD_LOGIC; 
  signal regular_expression_machine2_N_796 : STD_LOGIC; 
  signal regular_expression_machine2_G_90_am : STD_LOGIC; 
  signal regular_expression_machine2_G_90_bm : STD_LOGIC; 
  signal regular_expression_machine2_N_794 : STD_LOGIC; 
  signal regular_expression_machine2_N_579 : STD_LOGIC; 
  signal regular_expression_machine2_N_545 : STD_LOGIC; 
  signal regular_expression_machine2_N_844 : STD_LOGIC; 
  signal regular_expression_machine2_N_841 : STD_LOGIC; 
  signal regular_expression_machine2_G_2_fast : STD_LOGIC; 
  signal regular_expression_machine2_N_832 : STD_LOGIC; 
  signal regular_expression_machine2_state_ns_224_282 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_133_bm_1 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_198_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_G_3_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_133_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_230_475 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_61_1 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_60_sx_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_52_sx_0 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_220_sx_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_571 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_92_sx_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_92_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_587 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_62_bm_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_62_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_52_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_90_0_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_195_bm_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_195_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_643 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_48_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_575 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_47_0_and2_s : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_90_0_sx_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_818 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_617 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_8_sx : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_540 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_536 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_208_1 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_660 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_666 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_633 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_824 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_562 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_205_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_760 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_638 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_815 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_814 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_630 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_88_0_and2_0_602 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_613 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_218_273 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_685 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_732 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_205_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_649 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_644 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_195_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_682 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_707 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_694 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_700 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_706 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_187_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_187_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_651 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_274_0_and2_552 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_266_0_and2_496 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_181_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_181_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_676 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_550 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_175_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_175_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_286_504 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_690 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_679 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_693 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_569 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_689 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_688 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_167_am_0 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_167_bm_0 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_673 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_678 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_256_505 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_152_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_152_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_145_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_145_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_657 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_656 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_133_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_599 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_632 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_218_274 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_101_0_623 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_820 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_622 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_592 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_65_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_65_bm : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_590 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_563 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_551 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_589 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_62_am : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_260_572 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_101_0_and2_601 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_N_823 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_286_502 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_101_0_and2_0_599 : STD_LOGIC; 
  signal regular_expression_machine2_state_h_state_ns_101_0_622 : STD_LOGIC; 
  signal regular_expression_machine3_N_360 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_428 : STD_LOGIC; 
  signal regular_expression_machine3_N_390 : STD_LOGIC; 
  signal regular_expression_machine3_N_366 : STD_LOGIC; 
  signal regular_expression_machine3_G_238_1_0 : STD_LOGIC; 
  signal regular_expression_machine3_N_362 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_0_12_346 : STD_LOGIC; 
  signal regular_expression_machine3_N_375 : STD_LOGIC; 
  signal regular_expression_machine3_N_423 : STD_LOGIC; 
  signal regular_expression_machine3_N_401_1 : STD_LOGIC; 
  signal regular_expression_machine3_N_391_1 : STD_LOGIC; 
  signal regular_expression_machine3_N_391 : STD_LOGIC; 
  signal regular_expression_machine3_N_403 : STD_LOGIC; 
  signal regular_expression_machine3_N_390_6 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_426 : STD_LOGIC; 
  signal regular_expression_machine3_G_230_158 : STD_LOGIC; 
  signal regular_expression_machine3_G_230_157 : STD_LOGIC; 
  signal regular_expression_machine3_N_385 : STD_LOGIC; 
  signal regular_expression_machine3_N_359 : STD_LOGIC; 
  signal regular_expression_machine3_N_393_3 : STD_LOGIC; 
  signal regular_expression_machine3_N_420 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_13_Q : STD_LOGIC; 
  signal regular_expression_machine3_N_429 : STD_LOGIC; 
  signal regular_expression_machine3_N_427 : STD_LOGIC; 
  signal regular_expression_machine3_N_426 : STD_LOGIC; 
  signal regular_expression_machine3_N_424 : STD_LOGIC; 
  signal regular_expression_machine3_G_217 : STD_LOGIC; 
  signal regular_expression_machine3_N_414 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_5_Q : STD_LOGIC; 
  signal regular_expression_machine3_N_405 : STD_LOGIC; 
  signal regular_expression_machine3_N_404 : STD_LOGIC; 
  signal regular_expression_machine3_un1_state_49_0_and2_0_and2_500 : STD_LOGIC; 
  signal regular_expression_machine3_N_402 : STD_LOGIC; 
  signal regular_expression_machine3_N_401 : STD_LOGIC; 
  signal regular_expression_machine3_N_400 : STD_LOGIC; 
  signal regular_expression_machine3_N_399 : STD_LOGIC; 
  signal regular_expression_machine3_N_398 : STD_LOGIC; 
  signal regular_expression_machine3_N_387 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_1_12_450 : STD_LOGIC; 
  signal regular_expression_machine3_N_389 : STD_LOGIC; 
  signal regular_expression_machine3_G_47_i_0_415 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_424 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_516 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_519 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_520 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_523 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_12_624 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_12_626 : STD_LOGIC; 
  signal regular_expression_machine3_nxt_state_31_i_0_0_12_627 : STD_LOGIC; 
  signal regular_expression_machine3_N_43_i : STD_LOGIC; 
  signal regular_expression_machine3_N_251_i : STD_LOGIC; 
  signal regular_expression_machine3_N_253_i : STD_LOGIC; 
  signal regular_expression_machine3_N_131_i : STD_LOGIC; 
  signal regular_expression_machine3_N_419_i : STD_LOGIC; 
  signal regular_expression_machine3_GND : STD_LOGIC; 
  signal regular_expression_machine3_VCC : STD_LOGIC; 
  signal regular_expression_machine4_N_514 : STD_LOGIC; 
  signal regular_expression_machine4_N_503 : STD_LOGIC; 
  signal regular_expression_machine4_N_502 : STD_LOGIC; 
  signal regular_expression_machine4_N_482 : STD_LOGIC; 
  signal regular_expression_machine4_N_486 : STD_LOGIC; 
  signal regular_expression_machine4_N_487 : STD_LOGIC; 
  signal regular_expression_machine4_N_493 : STD_LOGIC; 
  signal regular_expression_machine4_N_494 : STD_LOGIC; 
  signal regular_expression_machine4_N_495 : STD_LOGIC; 
  signal regular_expression_machine4_N_513 : STD_LOGIC; 
  signal regular_expression_machine4_G_284 : STD_LOGIC; 
  signal regular_expression_machine4_N_473_4 : STD_LOGIC; 
  signal regular_expression_machine4_N_131_1 : STD_LOGIC; 
  signal regular_expression_machine4_N_492_2 : STD_LOGIC; 
  signal regular_expression_machine4_N_449 : STD_LOGIC; 
  signal regular_expression_machine4_N_453 : STD_LOGIC; 
  signal regular_expression_machine4_N_446 : STD_LOGIC; 
  signal regular_expression_machine4_N_442 : STD_LOGIC; 
  signal regular_expression_machine4_N_440 : STD_LOGIC; 
  signal regular_expression_machine4_N_438 : STD_LOGIC; 
  signal regular_expression_machine4_N_496 : STD_LOGIC; 
  signal regular_expression_machine4_N_436 : STD_LOGIC; 
  signal regular_expression_machine4_N_479 : STD_LOGIC; 
  signal regular_expression_machine4_N_516 : STD_LOGIC; 
  signal regular_expression_machine4_N_501 : STD_LOGIC; 
  signal regular_expression_machine4_G_293_131 : STD_LOGIC; 
  signal regular_expression_machine4_G_293_128 : STD_LOGIC; 
  signal regular_expression_machine4_N_492 : STD_LOGIC; 
  signal regular_expression_machine4_N_491 : STD_LOGIC; 
  signal regular_expression_machine4_un1_state_40_0_and2_0_and2_556 : STD_LOGIC; 
  signal regular_expression_machine4_N_489 : STD_LOGIC; 
  signal regular_expression_machine4_N_488 : STD_LOGIC; 
  signal regular_expression_machine4_un1_state_17_0_and2_0_and2_401 : STD_LOGIC; 
  signal regular_expression_machine4_N_485 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_11_192 : STD_LOGIC; 
  signal regular_expression_machine4_N_484 : STD_LOGIC; 
  signal regular_expression_machine4_N_481 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_10_16_351 : STD_LOGIC; 
  signal regular_expression_machine4_N_480 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_9_16_334 : STD_LOGIC; 
  signal regular_expression_machine4_N_475 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_509 : STD_LOGIC; 
  signal regular_expression_machine4_N_473 : STD_LOGIC; 
  signal regular_expression_machine4_N_470 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_16_418 : STD_LOGIC; 
  signal regular_expression_machine4_N_469 : STD_LOGIC; 
  signal regular_expression_machine4_G_299_211 : STD_LOGIC; 
  signal regular_expression_machine4_N_518 : STD_LOGIC; 
  signal regular_expression_machine4_N_499 : STD_LOGIC; 
  signal regular_expression_machine4_N_519 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_86 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_1_16_470 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_87 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_88 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_89 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_6_16_445 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_90 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_7_16_342 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_405 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_408 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_410 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_411 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_507 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_645 : STD_LOGIC; 
  signal regular_expression_machine4_nxt_state_39_i_0_0_16_648 : STD_LOGIC; 
  signal regular_expression_machine4_N_51_i : STD_LOGIC; 
  signal regular_expression_machine4_N_131_i : STD_LOGIC; 
  signal regular_expression_machine4_N_423_i : STD_LOGIC; 
  signal regular_expression_machine4_N_135_i : STD_LOGIC; 
  signal regular_expression_machine4_N_504_i : STD_LOGIC; 
  signal regular_expression_machine4_GND : STD_LOGIC; 
  signal regular_expression_machine4_VCC : STD_LOGIC; 
  signal regular_expression_machine5_N_1898 : STD_LOGIC; 
  signal regular_expression_machine5_state_4_Q : STD_LOGIC; 
  signal regular_expression_machine5_state_2_Q : STD_LOGIC; 
  signal regular_expression_machine5_N_1989 : STD_LOGIC; 
  signal regular_expression_machine5_un10_state_1 : STD_LOGIC; 
  signal regular_expression_machine5_N_2127 : STD_LOGIC; 
  signal regular_expression_machine5_N_1891 : STD_LOGIC; 
  signal regular_expression_machine5_N_2243 : STD_LOGIC; 
  signal regular_expression_machine5_N_1877 : STD_LOGIC; 
  signal regular_expression_machine5_N_1903 : STD_LOGIC; 
  signal regular_expression_machine5_G_223_fast : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_184_0_653 : STD_LOGIC; 
  signal regular_expression_machine5_N_1722 : STD_LOGIC; 
  signal regular_expression_machine5_G_443_bm_sx : STD_LOGIC; 
  signal regular_expression_machine5_G_443_bm : STD_LOGIC; 
  signal regular_expression_machine5_N_1393 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_184_0_and2_0_607 : STD_LOGIC; 
  signal regular_expression_machine5_N_1805 : STD_LOGIC; 
  signal regular_expression_machine5_G_439_bm_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_350_0_608 : STD_LOGIC; 
  signal regular_expression_machine5_N_1564 : STD_LOGIC; 
  signal regular_expression_machine5_G_439_bm : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_350_0_609 : STD_LOGIC; 
  signal regular_expression_machine5_N_1298_3 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_350_0_and2_1_562 : STD_LOGIC; 
  signal regular_expression_machine5_state_0_Q : STD_LOGIC; 
  signal regular_expression_machine5_state_1_Q : STD_LOGIC; 
  signal regular_expression_machine5_N_1704 : STD_LOGIC; 
  signal regular_expression_machine5_N_1718 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_216_0_and2_136 : STD_LOGIC; 
  signal regular_expression_machine5_N_2124 : STD_LOGIC; 
  signal regular_expression_machine5_N_1752 : STD_LOGIC; 
  signal regular_expression_machine5_N_2113 : STD_LOGIC; 
  signal regular_expression_machine5_N_2114 : STD_LOGIC; 
  signal regular_expression_machine5_N_2128 : STD_LOGIC; 
  signal regular_expression_machine5_N_1908 : STD_LOGIC; 
  signal regular_expression_machine5_N_2116 : STD_LOGIC; 
  signal regular_expression_machine5_N_2237 : STD_LOGIC; 
  signal regular_expression_machine5_G_485_s : STD_LOGIC; 
  signal regular_expression_machine5_N_1717_i : STD_LOGIC; 
  signal regular_expression_machine5_N_2196 : STD_LOGIC; 
  signal regular_expression_machine5_N_2246 : STD_LOGIC; 
  signal regular_expression_machine5_N_2244 : STD_LOGIC; 
  signal regular_expression_machine5_N_2242 : STD_LOGIC; 
  signal regular_expression_machine5_N_2240 : STD_LOGIC; 
  signal regular_expression_machine5_N_2236 : STD_LOGIC; 
  signal regular_expression_machine5_N_2040_i : STD_LOGIC; 
  signal regular_expression_machine5_N_2050 : STD_LOGIC; 
  signal regular_expression_machine5_G_443_am : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_160_0_96 : STD_LOGIC; 
  signal regular_expression_machine5_N_1733 : STD_LOGIC; 
  signal regular_expression_machine5_G_440_am : STD_LOGIC; 
  signal regular_expression_machine5_G_440_bm : STD_LOGIC; 
  signal regular_expression_machine5_N_1832_1 : STD_LOGIC; 
  signal regular_expression_machine5_N_1854_1 : STD_LOGIC; 
  signal regular_expression_machine5_N_1848 : STD_LOGIC; 
  signal regular_expression_machine5_N_1847 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_296_0_641 : STD_LOGIC; 
  signal regular_expression_machine5_G_439_am : STD_LOGIC; 
  signal regular_expression_machine5_N_2043 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_337_0_666 : STD_LOGIC; 
  signal regular_expression_machine5_N_1830 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_337_0_663 : STD_LOGIC; 
  signal regular_expression_machine5_N_1856 : STD_LOGIC; 
  signal regular_expression_machine5_N_2111 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_397_3_0_and2_267 : STD_LOGIC; 
  signal regular_expression_machine5_N_1741 : STD_LOGIC; 
  signal regular_expression_machine5_N_1738 : STD_LOGIC; 
  signal regular_expression_machine5_N_2074 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_236_i_546 : STD_LOGIC; 
  signal regular_expression_machine5_N_2225 : STD_LOGIC; 
  signal regular_expression_machine5_N_1732 : STD_LOGIC; 
  signal regular_expression_machine5_N_1868 : STD_LOGIC; 
  signal regular_expression_machine5_N_1707 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_265_0_and2_1_373 : STD_LOGIC; 
  signal regular_expression_machine5_N_1710 : STD_LOGIC; 
  signal regular_expression_machine5_N_1912 : STD_LOGIC; 
  signal regular_expression_machine5_state_ns_435_0_and2_255 : STD_LOGIC; 
  signal regular_expression_machine5_N_1895 : STD_LOGIC; 
  signal regular_expression_machine5_un10_state : STD_LOGIC; 
  signal regular_expression_machine5_N_1884 : STD_LOGIC; 
  signal regular_expression_machine5_N_2208 : STD_LOGIC; 
  signal regular_expression_machine5_N_1883 : STD_LOGIC; 
  signal regular_expression_machine5_N_1879 : STD_LOGIC; 
  signal regular_expression_machine5_N_1993 : STD_LOGIC; 
  signal regular_expression_machine5_G_226_455 : STD_LOGIC; 
  signal regular_expression_machine5_G_484_s : STD_LOGIC; 
  signal regular_expression_machine5_G_487_s : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_184_0_653_1_0 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_184_0_653_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_279_0_and2_sx : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx_sx : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_157_0_and2_252 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_157_0_and2_0_359 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_84_i_and2_sx : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1841 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1798 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2219 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_80 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_83_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_sx : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1511 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1840 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1838 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1837 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_265_0_674_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1831 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_265_0_674 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1303 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1807 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2102_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2057_2 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_633_1_0 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_76 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_633_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_633 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_and2_7_391 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_and2_3_279 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1507 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_634 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2063 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1671 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2156 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2222 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2229 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1816 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2070 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1436 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2212 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2213 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1774 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2210 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2209_2 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1291 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1821_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1852_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2075 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1495_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2226 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1493 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2080 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1534 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1367 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1858 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2079 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1772 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1462 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_71_am : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_71_bm : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1306 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_70_i_660 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1766 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_37_0_75 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_340_0_56 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2106_1 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_189_0_and2_1_394 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_246_0_and2_3_531 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_175_i_and2_312 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2069 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1844 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_and2_4_375 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_102_i_and2_7_390 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1799 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_and2_1_547 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1796 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_240_0_670 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1825 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_222_0_78 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_222_0_and2_3_443 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1452 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1435 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2095 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2093 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_316_0_639 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_316_0_and2_620 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2089 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1862 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1857 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_and2_2_331 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1794 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_37_0_and2_2_571 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1765 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1764 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_355_0_and2_563 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2104 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2105 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2106 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_108_i_and2_3_540 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_2107 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_222_0_and2_1_566 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1817 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1853 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1813 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_205_0_60 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1818 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1824 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_37_0_and2_357 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_283_0_and2_595 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_91 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_and2_6_343 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_92 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_and2_5_356 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_160_0_95 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_316_0_98 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_316_0_99 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_157_0_and2_250 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_240_0_and2_4_378 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_337_0_and2_1_400 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_246_0_and2_2_513 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_70_i_658 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_240_0_667 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_240_0_669 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_state_ns_108_i_690 : STD_LOGIC; 
  signal regular_expression_machine5_state_h_N_1951_i : STD_LOGIC; 
  signal regular_expression_machine6_N_269_i_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_312 : STD_LOGIC; 
  signal regular_expression_machine6_N_306 : STD_LOGIC; 
  signal regular_expression_machine6_N_269_i : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179_1_0 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_175 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179 : STD_LOGIC; 
  signal regular_expression_machine6_N_258 : STD_LOGIC; 
  signal regular_expression_machine6_N_314 : STD_LOGIC; 
  signal regular_expression_machine6_N_316 : STD_LOGIC; 
  signal regular_expression_machine6_N_347_7 : STD_LOGIC; 
  signal regular_expression_machine6_G_176_171 : STD_LOGIC; 
  signal regular_expression_machine6_G_176_170 : STD_LOGIC; 
  signal regular_expression_machine6_N_309 : STD_LOGIC; 
  signal regular_expression_machine6_N_354 : STD_LOGIC; 
  signal regular_expression_machine6_N_353 : STD_LOGIC; 
  signal regular_expression_machine6_N_313 : STD_LOGIC; 
  signal regular_expression_machine6_N_298_1 : STD_LOGIC; 
  signal regular_expression_machine6_N_321 : STD_LOGIC; 
  signal regular_expression_machine6_N_340 : STD_LOGIC; 
  signal regular_expression_machine6_N_348 : STD_LOGIC; 
  signal regular_expression_machine6_N_352 : STD_LOGIC; 
  signal regular_expression_machine6_N_339 : STD_LOGIC; 
  signal regular_expression_machine6_N_338 : STD_LOGIC; 
  signal regular_expression_machine6_N_343 : STD_LOGIC; 
  signal regular_expression_machine6_N_341 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_54 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_53 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_575 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_52 : STD_LOGIC; 
  signal regular_expression_machine6_N_121 : STD_LOGIC; 
  signal regular_expression_machine6_N_326 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_and2_15_0_and2_0_and2_14_383 : STD_LOGIC; 
  signal regular_expression_machine6_N_342 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_48 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_50 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_and2_0_14_260 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_51 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_and2_9_14_248 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_and2_8_14_238 : STD_LOGIC; 
  signal regular_expression_machine6_nxt_state_35_i_i_0_14_573 : STD_LOGIC; 
  signal regular_expression_machine6_N_296_i : STD_LOGIC; 
  signal regular_expression_machine6_N_277_i : STD_LOGIC; 
  signal regular_expression_machine6_N_273_i : STD_LOGIC; 
  signal regular_expression_machine6_N_298_i : STD_LOGIC; 
  signal regular_expression_machine6_N_275_i : STD_LOGIC; 
  signal regular_expression_machine6_N_302_i : STD_LOGIC; 
  signal regular_expression_machine6_N_271_i : STD_LOGIC; 
  signal regular_expression_machine6_N_300_i : STD_LOGIC; 
  signal regular_expression_machine6_N_345_i : STD_LOGIC; 
  signal regular_expression_machine6_VCC : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_37 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_40_sx : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_40 : STD_LOGIC; 
  signal regular_expression_machine7_N_361 : STD_LOGIC; 
  signal regular_expression_machine7_N_338 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_41 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_43 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_46_sx : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_46 : STD_LOGIC; 
  signal regular_expression_machine7_N_371 : STD_LOGIC; 
  signal regular_expression_machine7_N_389 : STD_LOGIC; 
  signal regular_expression_machine7_N_331 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_37_1 : STD_LOGIC; 
  signal regular_expression_machine7_N_363 : STD_LOGIC; 
  signal regular_expression_machine7_N_358 : STD_LOGIC; 
  signal regular_expression_machine7_N_339 : STD_LOGIC; 
  signal regular_expression_machine7_N_329 : STD_LOGIC; 
  signal regular_expression_machine7_N_388 : STD_LOGIC; 
  signal regular_expression_machine7_N_391 : STD_LOGIC; 
  signal regular_expression_machine7_N_333 : STD_LOGIC; 
  signal regular_expression_machine7_N_382_2 : STD_LOGIC; 
  signal regular_expression_machine7_N_386 : STD_LOGIC; 
  signal regular_expression_machine7_N_381_2 : STD_LOGIC; 
  signal regular_expression_machine7_N_375 : STD_LOGIC; 
  signal regular_expression_machine7_N_335 : STD_LOGIC; 
  signal regular_expression_machine7_N_377 : STD_LOGIC; 
  signal regular_expression_machine7_N_390 : STD_LOGIC; 
  signal regular_expression_machine7_N_397 : STD_LOGIC; 
  signal regular_expression_machine7_N_353 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_0_0_and2_0_15_305 : STD_LOGIC; 
  signal regular_expression_machine7_N_336 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_15_Q : STD_LOGIC; 
  signal regular_expression_machine7_N_376 : STD_LOGIC; 
  signal regular_expression_machine7_N_330 : STD_LOGIC; 
  signal regular_expression_machine7_N_370_2 : STD_LOGIC; 
  signal regular_expression_machine7_N_365 : STD_LOGIC; 
  signal regular_expression_machine7_N_370 : STD_LOGIC; 
  signal regular_expression_machine7_N_369 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_13_Q : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_9_Q : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_165 : STD_LOGIC; 
  signal regular_expression_machine7_N_355_6 : STD_LOGIC; 
  signal regular_expression_machine7_N_119 : STD_LOGIC; 
  signal regular_expression_machine7_un1_state_47_0_and2_0_and2_388 : STD_LOGIC; 
  signal regular_expression_machine7_N_374 : STD_LOGIC; 
  signal regular_expression_machine7_N_372_3 : STD_LOGIC; 
  signal regular_expression_machine7_N_355_8 : STD_LOGIC; 
  signal regular_expression_machine7_N_373 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_7_Q : STD_LOGIC; 
  signal regular_expression_machine7_N_381 : STD_LOGIC; 
  signal regular_expression_machine7_N_382 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_0_and2_0_and2_2_364 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_2_Q : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_14_39 : STD_LOGIC; 
  signal regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_162 : STD_LOGIC; 
  signal regular_expression_machine7_N_108_i : STD_LOGIC; 
  signal regular_expression_machine7_N_104_i : STD_LOGIC; 
  signal regular_expression_machine7_N_322_i : STD_LOGIC; 
  signal regular_expression_machine7_N_380_i : STD_LOGIC; 
  signal regular_expression_machine7_GND : STD_LOGIC; 
  signal regular_expression_machine7_VCC : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_0 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_0_0 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_1 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_2 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_3 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_4 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_5 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_6 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_7 : STD_LOGIC; 
  signal cntrlr_N_372_i : STD_LOGIC; 
  signal cntrlr_N_373_i : STD_LOGIC; 
  signal cntrlr_N_374_i : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_axb_3 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_axb_4 : STD_LOGIC; 
  signal cntrlr_N_375_i : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_axb_6 : STD_LOGIC; 
  signal cntrlr_GND : STD_LOGIC; 
  signal cntrlr_out_ptr_lcry : STD_LOGIC; 
  signal cntrlr_N_838_i : STD_LOGIC; 
  signal cntrlr_un1_reset_l_29_i : STD_LOGIC; 
  signal cntrlr_N_836_i : STD_LOGIC; 
  signal cntrlr_N_834_i : STD_LOGIC; 
  signal cntrlr_fsm_state_34_5_Q : STD_LOGIC; 
  signal cntrlr_fsm_state_34_4_Q : STD_LOGIC; 
  signal cntrlr_fsm_state_34_3_Q : STD_LOGIC; 
  signal cntrlr_fsm_state_34_2_Q : STD_LOGIC; 
  signal cntrlr_N_845 : STD_LOGIC; 
  signal cntrlr_N_828_i : STD_LOGIC; 
  signal cntrlr_fsm_state_34_12_Q : STD_LOGIC; 
  signal cntrlr_fsm_state_34_11_Q : STD_LOGIC; 
  signal cntrlr_fsm_state_34_10_Q : STD_LOGIC; 
  signal cntrlr_N_840_i : STD_LOGIC; 
  signal cntrlr_N_1105_i : STD_LOGIC; 
  signal cntrlr_N_1217_i : STD_LOGIC; 
  signal cntrlr_N_1194_i : STD_LOGIC; 
  signal cntrlr_un8_ready_l_NE_i : STD_LOGIC; 
  signal cntrlr_un8_ready_l_NE_i_i : STD_LOGIC; 
  signal cntrlr_buf_full6_NE : STD_LOGIC; 
  signal cntrlr_buf_full6_NE_i : STD_LOGIC; 
  signal cntrlr_prev_ptr_1_rep1 : STD_LOGIC; 
  signal cntrlr_N_868 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_axb_8 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_axb_7 : STD_LOGIC; 
  signal cntrlr_N_852 : STD_LOGIC; 
  signal cntrlr_N_890 : STD_LOGIC; 
  signal cntrlr_N_891 : STD_LOGIC; 
  signal cntrlr_fsm_state_34_0_and2_2_214 : STD_LOGIC; 
  signal cntrlr_N_856 : STD_LOGIC; 
  signal cntrlr_fsm_state_34_0_and2_0_10_189 : STD_LOGIC; 
  signal cntrlr_out_state_3_Q : STD_LOGIC; 
  signal cntrlr_un16_input_ptr_NE_2 : STD_LOGIC; 
  signal cntrlr_un16_input_ptr_NE_1 : STD_LOGIC; 
  signal cntrlr_un16_input_ptr_NE_4 : STD_LOGIC; 
  signal cntrlr_un16_input_ptr_NE_3 : STD_LOGIC; 
  signal cntrlr_un16_input_ptr_NE_7 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_6 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_7 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_4 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_5 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_2 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_3 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_1 : STD_LOGIC; 
  signal cntrlr_buf_full6_NE_7 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_7 : STD_LOGIC; 
  signal cntrlr_buf_full6_NE_2 : STD_LOGIC; 
  signal cntrlr_buf_full6_NE_1 : STD_LOGIC; 
  signal cntrlr_buf_full6_NE_4 : STD_LOGIC; 
  signal cntrlr_buf_full6_NE_3 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_5 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_6 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_3 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_4 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_1 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_s_2 : STD_LOGIC; 
  signal cntrlr_N_1074 : STD_LOGIC; 
  signal cntrlr_out_state_10_Q : STD_LOGIC; 
  signal cntrlr_N_853 : STD_LOGIC; 
  signal cntrlr_N_861 : STD_LOGIC; 
  signal cntrlr_N_857 : STD_LOGIC; 
  signal cntrlr_dataen_in : STD_LOGIC; 
  signal cntrlr_sof_in : STD_LOGIC; 
  signal cntrlr_un9_sof_in : STD_LOGIC; 
  signal cntrlr_fsm_state_34_i_and2_0_203 : STD_LOGIC; 
  signal cntrlr_N_872 : STD_LOGIC; 
  signal cntrlr_G_619_146 : STD_LOGIC; 
  signal cntrlr_G_619_144 : STD_LOGIC; 
  signal cntrlr_G_619_141 : STD_LOGIC; 
  signal cntrlr_G_619_140 : STD_LOGIC; 
  signal cntrlr_buf_full : STD_LOGIC; 
  signal cntrlr_un67_char_buf_out : STD_LOGIC; 
  signal cntrlr_out_state_6_Q : STD_LOGIC; 
  signal cntrlr_out_state_7_Q : STD_LOGIC; 
  signal cntrlr_out_state_4_Q : STD_LOGIC; 
  signal cntrlr_out_state_5_Q : STD_LOGIC; 
  signal cntrlr_I_122_i_228 : STD_LOGIC; 
  signal cntrlr_G_619_143 : STD_LOGIC; 
  signal cntrlr_regex_en_0_0_and2_0_207 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_s_8 : STD_LOGIC; 
  signal cntrlr_un1_un1_buf_full6_i : STD_LOGIC; 
  signal cntrlr_out_ptr_lcry_i : STD_LOGIC; 
  signal cntrlr_N_412_i : STD_LOGIC; 
  signal cntrlr_sod_out : STD_LOGIC; 
  signal cntrlr_fifo_we : STD_LOGIC; 
  signal cntrlr_eof_in : STD_LOGIC; 
  signal cntrlr_sod_in : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_6 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_5 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_4 : STD_LOGIC; 
  signal cntrlr_VCC : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_3 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_2 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_1 : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_0 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_7 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_6 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_5 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_4 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_3 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_2 : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_1 : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_7_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_6_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_5_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_4_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_3_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_2_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_1_O : STD_LOGIC; 
  signal cntrlr_input_ptr_cry_0_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_7_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_6_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_5_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_4_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_3_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_2_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_1_O : STD_LOGIC; 
  signal cntrlr_out_ptr_cry_0_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_9_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_8_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_7_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_6_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_5_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_4_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_3_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_2_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_1_O : STD_LOGIC; 
  signal cntrlr_regex_ptr_cry_0_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_6_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_5_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_4_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_3_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_2_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_1_O : STD_LOGIC; 
  signal cntrlr_un1_input_ptr_2_cry_0_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_7_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_6_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_5_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_4_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_3_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_2_O : STD_LOGIC; 
  signal cntrlr_un14_input_ptr_cry_1_O : STD_LOGIC; 
  signal cntrlr_output_fifo_N2147483644 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2147483641 : STD_LOGIC; 
  signal cntrlr_output_fifo_N114 : STD_LOGIC; 
  signal cntrlr_output_fifo_N113 : STD_LOGIC; 
  signal cntrlr_output_fifo_N116 : STD_LOGIC; 
  signal cntrlr_output_fifo_N112 : STD_LOGIC; 
  signal cntrlr_output_fifo_N111 : STD_LOGIC; 
  signal cntrlr_output_fifo_N109 : STD_LOGIC; 
  signal cntrlr_output_fifo_N108 : STD_LOGIC; 
  signal cntrlr_output_fifo_N107 : STD_LOGIC; 
  signal cntrlr_output_fifo_N118 : STD_LOGIC; 
  signal cntrlr_output_fifo_N106 : STD_LOGIC; 
  signal cntrlr_output_fifo_N760 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1078 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1092 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1073 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1108 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1122 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1074 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1138 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1152 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1075 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1168 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1076 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1339 : STD_LOGIC; 
  signal cntrlr_output_fifo_N805 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1415 : STD_LOGIC; 
  signal cntrlr_output_fifo_N804 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1491 : STD_LOGIC; 
  signal cntrlr_output_fifo_N803 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1567 : STD_LOGIC; 
  signal cntrlr_output_fifo_N802 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1636 : STD_LOGIC; 
  signal cntrlr_output_fifo_N764 : STD_LOGIC; 
  signal cntrlr_output_fifo_N845 : STD_LOGIC; 
  signal cntrlr_output_fifo_N855 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1640 : STD_LOGIC; 
  signal cntrlr_output_fifo_N844 : STD_LOGIC; 
  signal cntrlr_output_fifo_N854 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1628 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1633 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1627 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1632 : STD_LOGIC; 
  signal cntrlr_output_fifo_N843 : STD_LOGIC; 
  signal cntrlr_output_fifo_N853 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1626 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1631 : STD_LOGIC; 
  signal cntrlr_output_fifo_N842 : STD_LOGIC; 
  signal cntrlr_output_fifo_N852 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1625 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1630 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1638 : STD_LOGIC; 
  signal cntrlr_output_fifo_full : STD_LOGIC; 
  signal cntrlr_output_fifo_N1907 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1921 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1902 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1937 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1951 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1903 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1967 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1981 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1904 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1997 : STD_LOGIC; 
  signal cntrlr_output_fifo_N1905 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2168 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2244 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2320 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2396 : STD_LOGIC; 
  signal cntrlr_output_fifo_N815 : STD_LOGIC; 
  signal cntrlr_output_fifo_N814 : STD_LOGIC; 
  signal cntrlr_output_fifo_N813 : STD_LOGIC; 
  signal cntrlr_output_fifo_N812 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2563 : STD_LOGIC; 
  signal cntrlr_output_fifo_N820 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2567 : STD_LOGIC; 
  signal cntrlr_output_fifo_N819 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2555 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2560 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2554 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2559 : STD_LOGIC; 
  signal cntrlr_output_fifo_N818 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2553 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2558 : STD_LOGIC; 
  signal cntrlr_output_fifo_N817 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2552 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2557 : STD_LOGIC; 
  signal cntrlr_output_fifo_N2565 : STD_LOGIC; 
  signal cntrlr_output_fifo_BU27_O : STD_LOGIC; 
  signal cntrlr_output_fifo_BU27_LO : STD_LOGIC; 
  signal cntrlr_output_fifo_BU30_O : STD_LOGIC; 
  signal cntrlr_output_fifo_BU30_LO : STD_LOGIC; 
  signal cntrlr_output_fifo_BU42_O : STD_LOGIC; 
  signal cntrlr_output_fifo_BU76_O : STD_LOGIC; 
  signal cntrlr_output_fifo_BU76_LO : STD_LOGIC; 
  signal cntrlr_output_fifo_BU79_O : STD_LOGIC; 
  signal cntrlr_output_fifo_BU79_LO : STD_LOGIC; 
  signal cntrlr_output_fifo_BU91_O : STD_LOGIC; 
  signal cntrlr_output_buffer_N2147483644 : STD_LOGIC; 
  signal cntrlr_output_buffer_N2147483641 : STD_LOGIC; 
  signal cntrlr_regex_buffer_N2147483644 : STD_LOGIC; 
  signal cntrlr_regex_buffer_N2147483641 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_322 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_327 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_338 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_343 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_347 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_352 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_357 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_362 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_365 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_370 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_18 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_16 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_463 : STD_LOGIC; 
  signal cntrlr_match_fifo_mfifo_avail_1 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_324 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_340 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_345 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_349 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_359 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_364 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_367 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_372 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_354 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_490 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_487 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_472 : STD_LOGIC; 
  signal cntrlr_match_fifo_un1_head_1_c1 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_475 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_489 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_468 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_442 : STD_LOGIC; 
  signal cntrlr_match_fifo_wren_buf : STD_LOGIC; 
  signal cntrlr_match_fifo_N_473 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_479 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_460 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_477 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_353 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_344 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_371 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_363 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_351 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_342 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_369 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_361 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_350 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_341 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_368 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_360 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_348 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_339 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_366 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_358 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_329 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_328 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_326 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_325 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_323 : STD_LOGIC; 
  signal cntrlr_match_fifo_un1_rddone_buf_197 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_480 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_467 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_471 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_478 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_476 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_474 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_470 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_469 : STD_LOGIC; 
  signal cntrlr_match_fifo_N_450_i : STD_LOGIC; 
  signal cntrlr_match_fifo_N_448_i : STD_LOGIC; 
  signal cntrlr_match_fifo_N_446_i : STD_LOGIC; 
  signal cntrlr_match_fifo_N_444_i : STD_LOGIC; 
  signal cntrlr_out_state_h_N_1103 : STD_LOGIC; 
  signal cntrlr_out_state_h_N_790_i : STD_LOGIC; 
  signal cntrlr_out_state_h_GND : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU6_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU10_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU14_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU17_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU19_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU21_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU23_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU25_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU28_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU31_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU37_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU40_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU45_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU51_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU55_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU59_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU62_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU64_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU66_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU68_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU70_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU71_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU72_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU73_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU74_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU77_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU80_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU86_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU89_GSR_OR : STD_LOGIC; 
  signal cntrlr_output_fifo_BU94_GSR_OR : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_13_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_9_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_14_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_15_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_8_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_9_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_10_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_11_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_12_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_13_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_14_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_15_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_10_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_11_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOB_12_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU0_DOA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU34_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU43_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU83_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU92_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU27_SEL_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_fifo_BU76_SEL_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU0_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU1_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU2_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU3_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_output_buffer_BU4_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU0_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU1_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU2_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU3_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_cntrlr_regex_buffer_BU4_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal regex_in : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal regex_in_0 : STD_LOGIC_VECTOR ( 5 downto 0 ); 
  signal regex_in_1 : STD_LOGIC_VECTOR ( 5 downto 0 ); 
  signal data_out : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal matched_flop : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_accept_arr_out : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_fsm_state : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal cntrlr_prev_ptr : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal cntrlr_match_fifo_tail : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal regular_expression_machine2_state_h_state : STD_LOGIC_VECTOR ( 4 downto 0 ); 
  signal regular_expression_machine0_state_h_state : STD_LOGIC_VECTOR ( 4 downto 0 ); 
  signal accepted : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal regular_expression_machine6_state : STD_LOGIC_VECTOR ( 17 downto 16 ); 
  signal regular_expression_machine0_state_d : STD_LOGIC_VECTOR ( 29 downto 29 ); 
  signal regular_expression_machine1_state : STD_LOGIC_VECTOR ( 23 downto 0 ); 
  signal regular_expression_machine1_nxt_state_47_i_0_and2_1_s : STD_LOGIC_VECTOR ( 20 downto 20 ); 
  signal regular_expression_machine2_state_d : STD_LOGIC_VECTOR ( 27 downto 27 ); 
  signal regular_expression_machine3_nxt_state_31_i_0_0_and2_2_1 : STD_LOGIC_VECTOR ( 12 downto 12 ); 
  signal regular_expression_machine3_state : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal regular_expression_machine4_state : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal regular_expression_machine4_nxt_state_39 : STD_LOGIC_VECTOR ( 17 downto 17 ); 
  signal regular_expression_machine6_state_0 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal regular_expression_machine7_state : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal cntrlr_regex_ptr : STD_LOGIC_VECTOR ( 10 downto 0 ); 
  signal cntrlr_input_ptr : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_regex_ptr_qxu : STD_LOGIC_VECTOR ( 10 downto 0 ); 
  signal cntrlr_out_ptr_4 : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_out_ptr : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_out_ptr_qxu : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_input_ptr_qxu : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_fsm_state_1 : STD_LOGIC_VECTOR ( 12 downto 1 ); 
  signal cntrlr_regex_ptr_s : STD_LOGIC_VECTOR ( 10 downto 0 ); 
  signal cntrlr_out_ptr_s : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_input_ptr_s : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_prev_ptr_fast_fast : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal cntrlr_prev_ptr_fast : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal cntrlr_regex_in_3_am : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_regex_in_3_bm : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_char_buf_out : STD_LOGIC_VECTOR ( 32 downto 0 ); 
  signal cntrlr_fifo_dout : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_length : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal cntrlr_passed_ptr : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_prev_ptr_2 : STD_LOGIC_VECTOR ( 10 downto 2 ); 
  signal cntrlr_fifo_din : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal cntrlr_mfifo_out : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_out_state_i : STD_LOGIC_VECTOR ( 2 downto 2 ); 
  signal cntrlr_data_in : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal cntrlr_out_buf_out : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal cntrlr_input_ptr_cry : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_out_ptr_cry : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_regex_ptr_cry : STD_LOGIC_VECTOR ( 9 downto 0 ); 
  signal cntrlr_output_buffer_doa : STD_LOGIC_VECTOR ( 33 downto 33 ); 
  signal cntrlr_regex_buffer_doa : STD_LOGIC_VECTOR ( 33 downto 33 ); 
  signal cntrlr_match_fifo_tail_1 : STD_LOGIC_VECTOR ( 2 downto 2 ); 
  signal cntrlr_match_fifo_fifo_11 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_7 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_7_am : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_7_bm : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_6 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_4 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_2 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_0 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_3 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_9_am : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_9_bm : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_12 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_5 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_8 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_1 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_10_am : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_10_bm : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_14 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_13 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_10 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_fifo_9 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_am : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_data_out_bm : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_match_fifo_head : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal cntrlr_match_fifo_data_buf : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal cntrlr_out_state_h_out_state : STD_LOGIC_VECTOR ( 9 downto 9 ); 
begin
  regex_in_2_2_Q_3 : X_BUF
    port map (
      I => regex_in(2),
      O => regex_in_2_2_Q
    );
  regex_in_1_2_Q : X_BUF
    port map (
      I => regex_in(2),
      O => regex_in_1(2)
    );
  regex_in_0_2_Q : X_BUF
    port map (
      I => regex_in(2),
      O => regex_in_0(2)
    );
  regex_in_1_3_Q : X_BUF
    port map (
      I => regex_in(3),
      O => regex_in_1(3)
    );
  regex_in_0_3_Q : X_BUF
    port map (
      I => regex_in(3),
      O => regex_in_0(3)
    );
  regex_in_1_0_Q : X_BUF
    port map (
      I => regex_in(0),
      O => regex_in_1(0)
    );
  regex_in_0_0_Q : X_BUF
    port map (
      I => regex_in(0),
      O => regex_in_0(0)
    );
  regex_in_2_4_Q_4 : X_BUF
    port map (
      I => regex_in(4),
      O => regex_in_2_4_Q
    );
  regex_in_1_4_Q : X_BUF
    port map (
      I => regex_in(4),
      O => regex_in_1(4)
    );
  regex_in_0_4_Q : X_BUF
    port map (
      I => regex_in(4),
      O => regex_in_0(4)
    );
  regex_in_2_1_Q_5 : X_BUF
    port map (
      I => regex_in(1),
      O => regex_in_2_1_Q
    );
  regex_in_1_1_Q : X_BUF
    port map (
      I => regex_in(1),
      O => regex_in_1(1)
    );
  regex_in_0_1_Q : X_BUF
    port map (
      I => regex_in(1),
      O => regex_in_0(1)
    );
  reset_l_2_6 : X_BUF
    port map (
      I => reset_l,
      O => reset_l_2
    );
  reset_l_1_7 : X_BUF
    port map (
      I => reset_l,
      O => reset_l_1
    );
  reset_l_0_8 : X_BUF
    port map (
      I => reset_l,
      O => reset_l_0
    );
  regex_in_2_5_Q_9 : X_BUF
    port map (
      I => regex_in(5),
      O => regex_in_2_5_Q
    );
  regex_in_1_5_Q : X_BUF
    port map (
      I => regex_in(5),
      O => regex_in_1(5)
    );
  regex_in_0_5_Q : X_BUF
    port map (
      I => regex_in(5),
      O => regex_in_0(5)
    );
  d_appl_in_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(22),
      O => d_appl_in(22),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(23),
      O => d_appl_in(23),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(24),
      O => d_appl_in(24),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(25),
      O => d_appl_in(25),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(26),
      O => d_appl_in(26),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(27),
      O => d_appl_in(27),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(28),
      O => d_appl_in(28),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(29),
      O => d_appl_in(29),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(30),
      O => d_appl_in(30),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(31),
      O => d_appl_in(31),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(7),
      O => d_appl_in(7),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(8),
      O => d_appl_in(8),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(9),
      O => d_appl_in(9),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(10),
      O => d_appl_in(10),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(11),
      O => d_appl_in(11),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(12),
      O => d_appl_in(12),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(13),
      O => d_appl_in(13),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(14),
      O => d_appl_in(14),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(15),
      O => d_appl_in(15),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(16),
      O => d_appl_in(16),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(17),
      O => d_appl_in(17),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(18),
      O => d_appl_in(18),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(19),
      O => d_appl_in(19),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(20),
      O => d_appl_in(20),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(21),
      O => d_appl_in(21),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(0),
      O => matched(0),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(1),
      O => matched(1),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(2),
      O => matched(2),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(3),
      O => matched(3),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(4),
      O => matched(4),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(5),
      O => matched(5),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(6),
      O => matched(6),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  matched_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => matched_flop(7),
      O => matched(7),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(0),
      O => d_appl_in(0),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(1),
      O => d_appl_in(1),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(2),
      O => d_appl_in(2),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(3),
      O => d_appl_in(3),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(4),
      O => d_appl_in(4),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(5),
      O => d_appl_in(5),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  d_appl_in_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => data_out(6),
      O => d_appl_in(6),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  dataen_appl_in_10 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => dataen_out,
      O => dataen_appl_in,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  eof_appl_in_11 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => eof_out,
      O => eof_appl_in,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  sod_appl_in_12 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => sod_out,
      O => sod_appl_in,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  sof_appl_in_13 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => sof_out,
      O => sof_appl_in,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  reset_l_i_8_14 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_8
    );
  reset_l_i_7_15 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_7
    );
  reset_l_i_6_16 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_6
    );
  reset_l_i_5_17 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_5
    );
  reset_l_i_4_18 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_4
    );
  reset_l_i_3_19 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_3
    );
  reset_l_i_2_20 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_2
    );
  reset_l_i_1_21 : X_INV
    port map (
      I => reset_l_0,
      O => reset_l_i_1
    );
  reset_l_i_22 : X_INV
    port map (
      I => reset_l_2,
      O => reset_l_i
    );
  G_723_23 : X_LUT3
    generic map(
      INIT => X"F8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2119,
      ADR1 => regular_expression_machine5_N_2047,
      ADR2 => G_723_sx,
      O => G_723
    );
  G_723_sx_24 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2099,
      ADR1 => regular_expression_machine5_N_2101,
      ADR2 => regular_expression_machine5_N_2102,
      ADR3 => regular_expression_machine5_N_2083,
      O => G_723_sx
    );
  G_702_25 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(1),
      O => G_702
    );
  G_703_26 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(2),
      O => G_703
    );
  G_704_27 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(3),
      O => G_704
    );
  G_705_28 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(4),
      O => G_705
    );
  G_706_29 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(5),
      O => G_706
    );
  G_707_30 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(6),
      O => G_707
    );
  G_708_31 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(7),
      O => G_708
    );
  G_709_32 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_accept_arr_out(0),
      O => G_709
    );
  G_711_33 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_out_buf_out_34_Q,
      O => G_711
    );
  G_712 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => cntrlr_fsm_state(0),
      ADR1 => cntrlr_prev_ptr(1),
      ADR2 => cntrlr_prev_ptr(0),
      O => cntrlr_fifo_we_2
    );
  G_715_34 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_out_state_2_Q,
      ADR1 => cntrlr_out_buf_out_32_Q,
      O => G_715
    );
  G_716_35 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_rddone_buf,
      ADR1 => cntrlr_match_fifo_tail(0),
      ADR2 => cntrlr_match_fifo_rddone_buf,
      O => G_716
    );
  G_717_36 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_rddone_buf,
      ADR1 => cntrlr_match_fifo_tail(1),
      ADR2 => cntrlr_match_fifo_rddone_buf,
      ADR3 => cntrlr_match_fifo_tail(0),
      O => G_717
    );
  G_718_37 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_rddone_buf,
      ADR1 => cntrlr_match_fifo_un1_tail_19_c2,
      ADR2 => cntrlr_match_fifo_tail(2),
      O => G_718
    );
  G_719_38 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_rddone_buf,
      ADR1 => cntrlr_match_fifo_tail(3),
      ADR2 => cntrlr_match_fifo_un1_tail_19_c2,
      ADR3 => cntrlr_match_fifo_tail(2),
      O => G_719
    );
  G_727_39 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2085,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      ADR2 => reset_l_1,
      ADR3 => regex_en_2,
      O => G_727
    );
  G_730_40 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine2_N_639,
      ADR3 => regular_expression_machine2_state_h_state(1),
      O => G_730
    );
  G_731_41 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine2_N_668,
      ADR3 => regular_expression_machine2_state_h_state(2),
      O => G_731
    );
  G_732_42 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine2_N_696,
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => G_732
    );
  G_733_43 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine2_N_709,
      ADR3 => regular_expression_machine2_state_h_state(4),
      O => G_733
    );
  G_734_44 : X_LUT4
    generic map(
      INIT => X"1504"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine2_N_596,
      ADR3 => regular_expression_machine2_state_h_state(0),
      O => G_734
    );
  G_736_45 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine0_N_688,
      ADR3 => regular_expression_machine0_state_h_state(1),
      O => G_736
    );
  G_737_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine0_N_717,
      ADR3 => regular_expression_machine0_state_h_state(2),
      O => G_737
    );
  G_738_47 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine0_N_746,
      ADR3 => regular_expression_machine0_state_h_state(3),
      O => G_738
    );
  G_739_48 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine0_N_772,
      ADR3 => regular_expression_machine0_state_h_state(4),
      O => G_739
    );
  G_740_49 : X_LUT4
    generic map(
      INIT => X"1504"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => regex_en_2,
      ADR2 => regular_expression_machine0_N_638,
      ADR3 => regular_expression_machine0_state_h_state(0),
      O => G_740
    );
  N_816_i_50 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => cntrlr_N_811_1_i,
      ADR1 => cntrlr_out_state_0_Q,
      ADR2 => cntrlr_un20_dataen_out_6,
      O => N_816_i
    );
  G_724_2 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2098,
      ADR1 => state_ns_246_0_and2_2_514,
      ADR2 => regular_expression_machine5_N_2215,
      O => N_826_2
    );
  G_724_51 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_826_2,
      ADR1 => regular_expression_machine5_N_2094,
      ADR2 => state_ns_246_0_and2_1_679,
      ADR3 => regular_expression_machine5_N_1470,
      O => G_724
    );
  G_725_1 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2092,
      ADR1 => regular_expression_machine5_N_2215,
      ADR2 => regular_expression_machine5_N_2140,
      ADR3 => regular_expression_machine5_N_2126,
      O => N_827_1
    );
  G_725_52 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => N_827_1,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => reset_l_1,
      ADR3 => regex_en_2,
      O => G_725
    );
  G_726_53 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2086,
      ADR1 => regular_expression_machine5_N_2087,
      ADR2 => state_ns_322_0_and2_1_678,
      ADR3 => regular_expression_machine5_N_2044,
      O => G_726
    );
  G_710_1 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => cntrlr_out_state_11_Q,
      ADR1 => cntrlr_fifo_empty,
      O => N_812_1
    );
  G_710_54 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => N_812_1,
      ADR1 => cntrlr_mfifo_avail,
      O => G_710
    );
  G_713_55 : X_LUT4
    generic map(
      INIT => X"3332"
    )
    port map (
      ADR0 => regex_en_0_0_and2_1_226,
      ADR1 => cntrlr_N_1066,
      ADR2 => regex_en_0_0_and2_0_208,
      ADR3 => regex_en_0_0_and2_2_206,
      O => G_713
    );
  regular_expression_machine0_G_88_s_56 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(4),
      ADR1 => regex_in_0(5),
      ADR2 => regular_expression_machine0_state_h_state(2),
      O => regular_expression_machine0_G_88_s
    );
  regular_expression_machine0_G_109 : X_LUT4
    generic map(
      INIT => X"0004"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regex_in(6),
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine0_G_109_sx,
      O => regular_expression_machine0_N_965
    );
  regular_expression_machine0_G_109_sx_57 : X_LUT4
    generic map(
      INIT => X"FFF7"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(2),
      ADR1 => regular_expression_machine0_state_h_state(4),
      ADR2 => regex_in_0(4),
      ADR3 => regex_in(7),
      O => regular_expression_machine0_G_109_sx
    );
  regular_expression_machine0_G_97 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regex_in_1(1),
      ADR2 => regular_expression_machine0_G_97_sx,
      O => regular_expression_machine0_N_953
    );
  regular_expression_machine0_G_97_sx_58 : X_LUT4
    generic map(
      INIT => X"FFFD"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(4),
      ADR1 => regular_expression_machine0_state_h_state(2),
      ADR2 => regex_in_0(4),
      ADR3 => regex_in(7),
      O => regular_expression_machine0_G_97_sx
    );
  regular_expression_machine0_G_90 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      ADR2 => regex_in_2_4_Q,
      ADR3 => regex_in_2_1_Q,
      O => regular_expression_machine0_N_946
    );
  regular_expression_machine0_G_127_bm_59 : X_LUT4
    generic map(
      INIT => X"A0A8"
    )
    port map (
      ADR0 => regular_expression_machine0_G_127_bm_1,
      ADR1 => regular_expression_machine0_N_962,
      ADR2 => regular_expression_machine0_state_h_state(0),
      ADR3 => regex_in_2_5_Q,
      O => regular_expression_machine0_G_127_bm
    );
  regular_expression_machine0_G_127_bm_1_60 : X_LUT4
    generic map(
      INIT => X"4C44"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine6_N_308_1,
      ADR3 => regular_expression_machine0_N_947,
      O => regular_expression_machine0_G_127_bm_1
    );
  regular_expression_machine0_G_129 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine0_N_884,
      O => regular_expression_machine0_N_897
    );
  regular_expression_machine0_G_127 : X_MUX2
    port map (
      IA => regular_expression_machine0_G_127_am,
      IB => regular_expression_machine0_G_127_bm,
      O => regular_expression_machine0_N_895,
      SEL => regular_expression_machine0_state_h_state(3)
    );
  regular_expression_machine0_G_127_am_61 : X_LUT4
    generic map(
      INIT => X"8580"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_N_953,
      ADR2 => regular_expression_machine0_state_h_state(1),
      ADR3 => regular_expression_machine0_N_708,
      O => regular_expression_machine0_G_127_am
    );
  regular_expression_machine0_G_116 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(2),
      ADR1 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_N_884
    );
  regular_expression_machine0_G_114 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine0_N_965,
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_N_946,
      ADR3 => regular_expression_machine0_N_958,
      O => regular_expression_machine0_N_882
    );
  regular_expression_machine0_G_108 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308_1,
      ADR1 => regular_expression_machine0_G_88_s,
      ADR2 => regular_expression_machine0_state_h_state(0),
      ADR3 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_N_964
    );
  regular_expression_machine0_G_106 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine6_N_307,
      ADR1 => regex_in_2_1_Q,
      ADR2 => regular_expression_machine0_N_947,
      O => regular_expression_machine0_N_962
    );
  regular_expression_machine0_G_102 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(2),
      ADR1 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_N_958
    );
  regular_expression_machine0_G_96 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine0_state_h_state(0),
      O => regular_expression_machine0_N_952
    );
  regular_expression_machine0_G_91 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(2),
      ADR1 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_N_947
    );
  regular_expression_machine0_G_89 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => G_1_fast,
      ADR1 => regular_expression_machine0_state_h_state(4),
      ADR2 => regular_expression_machine0_state_h_state(2),
      O => regular_expression_machine0_N_945
    );
  regular_expression_machine0_G_9 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_state_h_state(3),
      ADR2 => regular_expression_machine0_state_h_state(1),
      ADR3 => regular_expression_machine0_state_ns_30_s,
      O => regular_expression_machine0_state_d(29)
    );
  regular_expression_machine0_G_87_s_62 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_G_87_s
    );
  regular_expression_machine0_G_94_s_63 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(2),
      ADR1 => regular_expression_machine0_G_87_s,
      O => regular_expression_machine0_G_94_s
    );
  regular_expression_machine0_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => regular_expression_machine0_state_d(29),
      O => accepted(0),
      SRST => cntrlr_N_882_1_i_2,
      SSET => accepted(0),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine0_state_h_state_ns_180 : X_LUT4
    generic map(
      INIT => X"00FD"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_state(3),
      ADR2 => regular_expression_machine0_state_h_N_710,
      ADR3 => regular_expression_machine0_state_h_state_ns_180_sx,
      O => regular_expression_machine0_state_h_N_744
    );
  regular_expression_machine0_state_h_state_ns_180_sx_64 : X_LUT4
    generic map(
      INIT => X"11B1"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_922,
      ADR2 => regular_expression_machine0_state_h_state(3),
      ADR3 => regular_expression_machine0_state_h_N_634,
      O => regular_expression_machine0_state_h_state_ns_180_sx
    );
  regular_expression_machine0_state_h_state_ns_224_i_55_65 : X_LUT4
    generic map(
      INIT => X"A002"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_224_i_55_1,
      ADR1 => regular_expression_machine0_N_884,
      ADR2 => regex_in_2_5_Q,
      ADR3 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_224_i_55
    );
  regular_expression_machine0_state_h_state_ns_224_i_55_1_66 : X_LUT4
    generic map(
      INIT => X"6040"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_state(1),
      ADR3 => regular_expression_machine0_N_958,
      O => regular_expression_machine0_state_h_state_ns_224_i_55_1
    );
  regular_expression_machine0_state_h_state_ns_57_bm_67 : X_LUT4
    generic map(
      INIT => X"80BE"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_57_bm_1,
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_state(3),
      ADR3 => regular_expression_machine6_N_308_1,
      O => regular_expression_machine0_state_h_state_ns_57_bm
    );
  regular_expression_machine0_state_h_state_ns_57_bm_1_68 : X_LUT4
    generic map(
      INIT => X"FE32"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine0_state_h_state(3),
      ADR2 => regular_expression_machine0_N_897,
      ADR3 => regular_expression_machine0_state_h_N_624,
      O => regular_expression_machine0_state_h_state_ns_57_bm_1
    );
  regular_expression_machine0_state_h_state_ns_296 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_920,
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_state(3),
      ADR3 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_state_h_N_722
    );
  regular_expression_machine0_state_h_state_ns_68 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_N_610,
      IB => regular_expression_machine0_state_h_N_637,
      O => regular_expression_machine0_N_638,
      SEL => regex_in_2_2_Q
    );
  regular_expression_machine0_state_h_state_ns_240_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine0_N_920_1,
      ADR1 => regular_expression_machine0_N_947,
      ADR2 => regular_expression_machine7_N_288,
      O => regular_expression_machine0_state_h_N_920
    );
  regular_expression_machine0_state_h_state_ns_240_0_and2_1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_2_4_Q,
      O => regular_expression_machine0_N_920_1
    );
  regular_expression_machine0_state_h_state_ns_115_0_and2_0 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_N_952,
      ADR2 => regular_expression_machine6_N_308_1,
      ADR3 => regular_expression_machine0_G_88_s,
      O => regular_expression_machine0_state_h_N_922
    );
  regular_expression_machine0_state_h_state_ns_115_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_679,
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_N_921
    );
  regular_expression_machine0_state_h_state_ns_105_0_and2_0 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_N_671,
      ADR3 => regular_expression_machine0_state_h_N_666,
      O => regular_expression_machine0_state_h_N_919
    );
  regular_expression_machine0_state_h_state_ns_127_0 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_827,
      ADR1 => regular_expression_machine0_N_945,
      ADR2 => regular_expression_machine0_state_h_state_ns_127_0_and2_0_619,
      ADR3 => regular_expression_machine0_N_953,
      O => regular_expression_machine0_state_h_N_693
    );
  regular_expression_machine0_state_h_state_ns_316 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_316_am,
      IB => regular_expression_machine0_state_h_state_ns_316_bm,
      O => regular_expression_machine0_state_h_N_757,
      SEL => regular_expression_machine0_state_h_N_827
    );
  regular_expression_machine0_state_h_state_ns_316_bm_69 : X_LUT4
    generic map(
      INIT => X"7350"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308_1,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine0_N_884,
      ADR3 => regular_expression_machine0_N_946,
      O => regular_expression_machine0_state_h_state_ns_316_bm
    );
  regular_expression_machine0_state_h_state_ns_316_am_70 : X_LUT3
    generic map(
      INIT => X"57"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308_1,
      ADR1 => regular_expression_machine6_N_307,
      ADR2 => regex_in_2_5_Q,
      O => regular_expression_machine0_state_h_state_ns_316_am
    );
  regular_expression_machine0_state_h_state_ns_216 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_216_am,
      IB => regular_expression_machine0_state_h_state_ns_216_bm,
      O => regular_expression_machine0_state_h_N_624,
      SEL => regex_in_2_5_Q
    );
  regular_expression_machine0_state_h_state_ns_216_bm_71 : X_LUT4
    generic map(
      INIT => X"3533"
    )
    port map (
      ADR0 => regular_expression_machine6_N_307,
      ADR1 => G_1_fast,
      ADR2 => regular_expression_machine0_state_h_state(1),
      ADR3 => regular_expression_machine0_N_947,
      O => regular_expression_machine0_state_h_state_ns_216_bm
    );
  regular_expression_machine0_state_h_state_ns_216_am_72 : X_LUT4
    generic map(
      INIT => X"5333"
    )
    port map (
      ADR0 => regular_expression_machine6_N_307,
      ADR1 => G_1_fast,
      ADR2 => regular_expression_machine0_N_958,
      ADR3 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_state_h_state_ns_216_am
    );
  regular_expression_machine0_state_h_state_ns_210 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_N_761,
      IB => regular_expression_machine0_state_h_N_771,
      O => regular_expression_machine0_N_772,
      SEL => regex_in_2_2_Q
    );
  regular_expression_machine0_state_h_state_ns_209 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_209_am,
      IB => regular_expression_machine0_state_h_state_ns_209_bm,
      O => regular_expression_machine0_state_h_N_771,
      SEL => regex_in_1(0)
    );
  regular_expression_machine0_state_h_state_ns_209_bm_73 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_635,
      ADR2 => regular_expression_machine0_state_h_N_707,
      O => regular_expression_machine0_state_h_state_ns_209_bm
    );
  regular_expression_machine0_state_h_state_ns_209_am_74 : X_LUT4
    generic map(
      INIT => X"444E"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_737,
      ADR2 => regular_expression_machine0_state_h_state_ns_224_i_55,
      ADR3 => regular_expression_machine6_N_308_1,
      O => regular_expression_machine0_state_h_state_ns_209_am
    );
  regular_expression_machine0_state_h_state_ns_199 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_199_am,
      IB => regular_expression_machine0_state_h_state_ns_199_bm,
      O => regular_expression_machine0_state_h_N_761,
      SEL => regex_in_1(0)
    );
  regular_expression_machine0_state_h_state_ns_199_bm_75 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_759,
      ADR2 => regular_expression_machine0_state_h_N_757,
      O => regular_expression_machine0_state_h_state_ns_199_bm
    );
  regular_expression_machine0_state_h_state_ns_199_am_76 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_750_1,
      ADR1 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_199_am
    );
  regular_expression_machine0_state_h_state_ns_182 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_731,
      ADR1 => regular_expression_machine0_state_h_N_745,
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine0_N_746
    );
  regular_expression_machine0_state_h_state_ns_181 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_741,
      ADR1 => regular_expression_machine0_state_h_N_744,
      ADR2 => regex_in_1(0),
      O => regular_expression_machine0_state_h_N_745
    );
  regular_expression_machine0_state_h_state_ns_177 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_177_am,
      IB => regular_expression_machine0_state_h_state_ns_177_bm,
      O => regular_expression_machine0_state_h_N_741,
      SEL => regex_in_1(3)
    );
  regular_expression_machine0_state_h_state_ns_177_bm_77 : X_LUT4
    generic map(
      INIT => X"C480"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_N_671,
      ADR3 => regular_expression_machine0_state_h_N_701,
      O => regular_expression_machine0_state_h_state_ns_177_bm
    );
  regular_expression_machine0_state_h_state_ns_177_am_78 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_736,
      ADR1 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_177_am
    );
  regular_expression_machine0_state_h_state_ns_173 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_N_736,
      O => regular_expression_machine0_state_h_N_737
    );
  regular_expression_machine0_state_h_state_ns_172 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_172_am,
      IB => regular_expression_machine0_state_h_state_ns_172_bm,
      O => regular_expression_machine0_state_h_N_736,
      SEL => regular_expression_machine0_state_h_state(0)
    );
  regular_expression_machine0_state_h_state_ns_172_bm_79 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_280_278,
      ADR1 => regular_expression_machine7_N_288,
      ADR2 => regex_in_2_5_Q,
      O => regular_expression_machine0_state_h_state_ns_172_bm
    );
  regular_expression_machine0_state_h_state_ns_172_am_80 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_246_263,
      ADR1 => regular_expression_machine7_N_288,
      ADR2 => regex_in_2_4_Q,
      O => regular_expression_machine0_state_h_state_ns_172_am
    );
  regular_expression_machine0_state_h_state_ns_167 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_167_am,
      IB => regular_expression_machine0_state_h_state_ns_167_bm,
      O => regular_expression_machine0_state_h_N_731,
      SEL => regex_in_1(0)
    );
  regular_expression_machine0_state_h_state_ns_167_bm_81 : X_LUT4
    generic map(
      INIT => X"D888"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_729,
      ADR2 => regular_expression_machine0_state_h_N_827,
      ADR3 => regular_expression_machine0_N_945,
      O => regular_expression_machine0_state_h_state_ns_167_bm
    );
  regular_expression_machine0_state_h_state_ns_167_am_82 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_722,
      ADR2 => regular_expression_machine0_state_h_N_645,
      O => regular_expression_machine0_state_h_state_ns_167_am
    );
  regular_expression_machine0_state_h_state_ns_165 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_603,
      ADR1 => regular_expression_machine0_state_h_state(3),
      ADR2 => regular_expression_machine0_state_h_state_ns_298_605,
      ADR3 => regular_expression_machine0_state_h_N_725,
      O => regular_expression_machine0_state_h_N_729
    );
  regular_expression_machine0_state_h_state_ns_161 : X_LUT3
    generic map(
      INIT => X"12"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(4),
      ADR1 => regular_expression_machine6_N_308_1,
      ADR2 => regular_expression_machine0_state_h_state(2),
      O => regular_expression_machine0_state_h_N_725
    );
  regular_expression_machine0_state_h_state_ns_151 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_151_am,
      IB => regular_expression_machine0_state_h_state_ns_151_bm,
      O => regular_expression_machine0_N_717,
      SEL => regex_in_2_2_Q
    );
  regular_expression_machine0_state_h_state_ns_151_bm_83 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine0_state_h_N_715,
      ADR2 => regular_expression_machine0_state_h_N_706,
      O => regular_expression_machine0_state_h_state_ns_151_bm
    );
  regular_expression_machine0_state_h_state_ns_151_am_84 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine0_state_h_N_697,
      ADR2 => regular_expression_machine0_state_h_N_750_1,
      O => regular_expression_machine0_state_h_state_ns_151_am
    );
  regular_expression_machine0_state_h_state_ns_149 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_707,
      ADR1 => regular_expression_machine0_N_895,
      ADR2 => regex_in_1(3),
      O => regular_expression_machine0_state_h_N_715
    );
  regular_expression_machine0_state_h_state_ns_144 : X_LUT4
    generic map(
      INIT => X"A404"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_N_708,
      ADR2 => regular_expression_machine0_state_h_state(1),
      ADR3 => regular_expression_machine0_N_953,
      O => regular_expression_machine0_state_h_N_710
    );
  regular_expression_machine0_state_h_state_ns_142 : X_LUT4
    generic map(
      INIT => X"40E0"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(4),
      ADR1 => regular_expression_machine0_N_946,
      ADR2 => regular_expression_machine0_state_h_state(2),
      ADR3 => G_1_fast,
      O => regular_expression_machine0_N_708
    );
  regular_expression_machine0_state_h_state_ns_141 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_141_am,
      IB => regular_expression_machine0_state_h_state_ns_141_bm,
      O => regular_expression_machine0_state_h_N_707,
      SEL => regular_expression_machine0_state_h_state(3)
    );
  regular_expression_machine0_state_h_state_ns_141_bm_85 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_N_952,
      ADR1 => regular_expression_machine6_N_308_1,
      ADR2 => regular_expression_machine0_G_88_s,
      O => regular_expression_machine0_state_h_state_ns_141_bm
    );
  regular_expression_machine0_state_h_state_ns_141_am_86 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine6_N_308_1,
      ADR3 => regular_expression_machine0_G_88_s,
      O => regular_expression_machine0_state_h_state_ns_141_am
    );
  regular_expression_machine0_state_h_state_ns_140 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_140_am,
      IB => regular_expression_machine0_state_h_state_ns_140_bm,
      O => regular_expression_machine0_state_h_N_706,
      SEL => regex_in_1(3)
    );
  regular_expression_machine0_state_h_state_ns_140_bm_87 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_139_0_683,
      ADR1 => regular_expression_machine0_state_h_N_918,
      O => regular_expression_machine0_state_h_state_ns_140_bm
    );
  regular_expression_machine0_state_h_state_ns_140_am_88 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_314_671,
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine6_N_308,
      ADR3 => regular_expression_machine0_G_94_s,
      O => regular_expression_machine0_state_h_state_ns_140_am
    );
  regular_expression_machine0_state_h_state_ns_138 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_138_am,
      IB => regular_expression_machine0_state_h_state_ns_138_bm,
      O => regular_expression_machine0_state_h_N_704,
      SEL => regular_expression_machine0_state_h_state(0)
    );
  regular_expression_machine0_state_h_state_ns_138_bm_89 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine0_N_946,
      ADR2 => regex_in_2_5_Q,
      ADR3 => regular_expression_machine0_N_958,
      O => regular_expression_machine0_state_h_state_ns_138_bm
    );
  regular_expression_machine0_state_h_state_ns_138_am_90 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308_fast,
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_ns_30_s,
      ADR3 => regex_in_2_5_Q,
      O => regular_expression_machine0_state_h_state_ns_138_am
    );
  regular_expression_machine0_state_h_state_ns_135 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine0_N_965,
      O => regular_expression_machine0_state_h_N_701
    );
  regular_expression_machine0_state_h_state_ns_131 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_693,
      ADR1 => regex_in_1(3),
      ADR2 => regular_expression_machine0_N_964,
      ADR3 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_N_697
    );
  regular_expression_machine0_state_h_state_ns_120 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_659,
      ADR1 => regular_expression_machine0_state_h_N_687,
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine0_N_688
    );
  regular_expression_machine0_state_h_state_ns_119 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_119_am,
      IB => regular_expression_machine0_state_h_state_ns_119_bm,
      O => regular_expression_machine0_state_h_N_687,
      SEL => regex_in_1(0)
    );
  regular_expression_machine0_state_h_state_ns_119_bm_91 : X_LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_685,
      ADR2 => regular_expression_machine0_state_h_N_921,
      ADR3 => regular_expression_machine0_state_h_N_922,
      O => regular_expression_machine0_state_h_state_ns_119_bm
    );
  regular_expression_machine0_state_h_state_ns_119_am_92 : X_LUT4
    generic map(
      INIT => X"EEE4"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine0_state_h_N_43,
      ADR2 => regular_expression_machine0_state_h_N_919,
      ADR3 => regular_expression_machine0_state_h_N_918,
      O => regular_expression_machine0_state_h_state_ns_119_am
    );
  regular_expression_machine0_state_h_state_ns_111 : X_LUT4
    generic map(
      INIT => X"88B8"
    )
    port map (
      ADR0 => regular_expression_machine0_N_962,
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_h_N_920,
      ADR3 => regex_in_2_5_Q,
      O => regular_expression_machine0_state_h_N_679
    );
  regular_expression_machine0_state_h_state_ns_103 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_103_am,
      IB => regular_expression_machine0_state_h_state_ns_103_bm,
      O => regular_expression_machine0_state_h_N_671,
      SEL => regular_expression_machine0_state_h_state(1)
    );
  regular_expression_machine0_state_h_state_ns_103_bm_93 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine6_N_307,
      ADR2 => regex_in_2_1_Q,
      ADR3 => regular_expression_machine0_N_958,
      O => regular_expression_machine0_state_h_state_ns_103_bm
    );
  regular_expression_machine0_state_h_state_ns_103_am_94 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine6_N_307,
      ADR2 => regex_in_2_1_Q,
      ADR3 => regular_expression_machine0_N_947,
      O => regular_expression_machine0_state_h_state_ns_103_am
    );
  regular_expression_machine0_state_h_state_ns_98 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308,
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_ns_30_s,
      ADR3 => regex_in_1(5),
      O => regular_expression_machine0_state_h_N_666
    );
  regular_expression_machine0_state_h_state_ns_91 : X_LUT4
    generic map(
      INIT => X"88B8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_658,
      ADR1 => regex_in_1(0),
      ADR2 => regular_expression_machine0_state_h_N_645,
      ADR3 => regex_in_1(3),
      O => regular_expression_machine0_state_h_N_659
    );
  regular_expression_machine0_state_h_state_ns_90 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_90_am,
      IB => regular_expression_machine0_state_h_state_ns_90_bm,
      O => regular_expression_machine0_state_h_N_658,
      SEL => regex_in_1(3)
    );
  regular_expression_machine0_state_h_state_ns_90_bm_95 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_914,
      ADR1 => regular_expression_machine0_state_h_N_656,
      ADR2 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_90_bm
    );
  regular_expression_machine0_state_h_state_ns_90_am_96 : X_LUT4
    generic map(
      INIT => X"5551"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308,
      ADR1 => regular_expression_machine0_state_h_state_ns_309_234,
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine0_state_h_state(2),
      O => regular_expression_machine0_state_h_state_ns_90_am
    );
  regular_expression_machine0_state_h_state_ns_88 : X_LUT4
    generic map(
      INIT => X"8B88"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_606,
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine6_N_308,
      ADR3 => regular_expression_machine0_G_88_s,
      O => regular_expression_machine0_state_h_N_656
    );
  regular_expression_machine0_state_h_state_ns_77 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_N_644,
      O => regular_expression_machine0_state_h_N_645
    );
  regular_expression_machine0_state_h_state_ns_76 : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_state_h_state_ns_266_308,
      ADR2 => regular_expression_machine0_state_h_N_907,
      ADR3 => regular_expression_machine0_state_h_state_ns_262_317,
      O => regular_expression_machine0_state_h_N_644
    );
  regular_expression_machine0_state_h_state_ns_67 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_627,
      ADR1 => regex_in_1(0),
      ADR2 => regular_expression_machine0_state_h_N_635,
      ADR3 => regex_in_1(3),
      O => regular_expression_machine0_state_h_N_637
    );
  regular_expression_machine0_state_h_state_ns_65 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_630,
      ADR1 => regular_expression_machine0_state_h_N_634,
      ADR2 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_N_635
    );
  regular_expression_machine0_state_h_state_ns_64 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_64_am,
      IB => regular_expression_machine0_state_h_state_ns_64_bm,
      O => regular_expression_machine0_state_h_N_634,
      SEL => regular_expression_machine0_state_h_state(0)
    );
  regular_expression_machine0_state_h_state_ns_64_bm_97 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_rep1,
      ADR2 => regular_expression_machine0_N_947,
      O => regular_expression_machine0_state_h_state_ns_64_bm
    );
  regular_expression_machine0_state_h_state_ns_64_am_98 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_fast,
      ADR2 => regular_expression_machine0_state_ns_30_s,
      ADR3 => regex_in_1(5),
      O => regular_expression_machine0_state_h_state_ns_64_am
    );
  regular_expression_machine0_state_h_state_ns_60 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_60_am,
      IB => regular_expression_machine0_state_h_state_ns_60_bm,
      O => regular_expression_machine0_state_h_N_630,
      SEL => regular_expression_machine0_state_h_state(0)
    );
  regular_expression_machine0_state_h_state_ns_60_bm_99 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine0_N_953,
      O => regular_expression_machine0_state_h_state_ns_60_bm
    );
  regular_expression_machine0_state_h_state_ns_60_am_100 : X_LUT4
    generic map(
      INIT => X"4E44"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine0_N_945,
      ADR2 => regular_expression_machine6_N_308,
      ADR3 => regular_expression_machine0_G_94_s,
      O => regular_expression_machine0_state_h_state_ns_60_am
    );
  regular_expression_machine0_state_h_state_ns_57 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_57_am,
      IB => regular_expression_machine0_state_h_state_ns_57_bm,
      O => regular_expression_machine0_state_h_N_627,
      SEL => regex_in_1(3)
    );
  regular_expression_machine0_state_h_state_ns_57_am_101 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_302_643,
      ADR1 => regular_expression_machine0_state_h_state_ns_246_263,
      ADR2 => regular_expression_machine7_N_288,
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine0_state_h_state_ns_57_am
    );
  regular_expression_machine0_state_h_state_ns_35 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_750_1,
      ADR1 => regular_expression_machine0_state_h_N_609,
      ADR2 => regex_in_1(0),
      O => regular_expression_machine0_state_h_N_610
    );
  regular_expression_machine0_state_h_state_ns_34 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_34_am,
      IB => regular_expression_machine0_state_h_state_ns_34_bm,
      O => regular_expression_machine0_state_h_N_609,
      SEL => regex_in_1(3)
    );
  regular_expression_machine0_state_h_state_ns_34_bm_102 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_N_607,
      ADR2 => regular_expression_machine0_state_h_N_603,
      O => regular_expression_machine0_state_h_state_ns_34_bm
    );
  regular_expression_machine0_state_h_state_ns_34_am_103 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_127_0_and2_0_619,
      ADR1 => regular_expression_machine0_N_953,
      O => regular_expression_machine0_state_h_state_ns_34_am
    );
  regular_expression_machine0_state_h_state_ns_32 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_32_am,
      IB => regular_expression_machine0_state_h_state_ns_32_bm,
      O => regular_expression_machine0_state_h_N_607,
      SEL => regular_expression_machine0_state_h_state(0)
    );
  regular_expression_machine0_state_h_state_ns_32_bm_104 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_rep1,
      ADR2 => regular_expression_machine0_state_ns_30_s,
      O => regular_expression_machine0_state_h_state_ns_32_bm
    );
  regular_expression_machine0_state_h_state_ns_32_am_105 : X_LUT4
    generic map(
      INIT => X"3120"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_rep1,
      ADR2 => regular_expression_machine0_G_88_s,
      ADR3 => regular_expression_machine0_state_h_state_ns_23_s,
      O => regular_expression_machine0_state_h_state_ns_32_am
    );
  regular_expression_machine0_state_h_state_ns_31 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_rep1,
      ADR2 => regular_expression_machine0_state_ns_30_s,
      O => regular_expression_machine0_state_h_N_606
    );
  regular_expression_machine0_state_h_state_ns_28 : X_MUX2
    port map (
      IA => regular_expression_machine0_state_h_state_ns_28_am,
      IB => regular_expression_machine0_state_h_state_ns_28_bm,
      O => regular_expression_machine0_state_h_N_603,
      SEL => regular_expression_machine0_state_h_state(0)
    );
  regular_expression_machine0_state_h_state_ns_28_bm_106 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_rep1,
      ADR2 => regular_expression_machine0_G_94_s,
      O => regular_expression_machine0_state_h_state_ns_28_bm
    );
  regular_expression_machine0_state_h_state_ns_28_am_107 : X_LUT4
    generic map(
      INIT => X"3120"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(1),
      ADR1 => regular_expression_machine6_N_308_rep1,
      ADR2 => regular_expression_machine0_state_h_state_ns_23_s,
      ADR3 => regular_expression_machine0_G_88_s,
      O => regular_expression_machine0_state_h_state_ns_28_am
    );
  regular_expression_machine0_state_h_state_ns_318_1 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_262_317,
      ADR1 => regular_expression_machine0_state_h_N_907,
      ADR2 => regex_in_0(3),
      ADR3 => regular_expression_machine0_state_h_state(0),
      O => regular_expression_machine0_state_h_N_750_1
    );
  regular_expression_machine0_state_h_state_ns_312 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_312_642,
      ADR1 => regular_expression_machine6_N_308,
      ADR2 => regular_expression_machine0_G_94_s,
      O => regular_expression_machine0_state_h_N_685
    );
  regular_expression_machine0_state_h_state_ns_302 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_302_643,
      ADR1 => regular_expression_machine6_N_308,
      ADR2 => regular_expression_machine0_G_88_s,
      O => regular_expression_machine0_state_h_N_759
    );
  regular_expression_machine0_state_h_state_ns_286 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_302_643,
      ADR1 => regular_expression_machine0_state_h_state_ns_246_263,
      ADR2 => regular_expression_machine7_N_288,
      ADR3 => regex_in_1(4),
      O => regular_expression_machine0_state_h_N_43
    );
  regular_expression_machine0_state_h_state_ns_89_0_and2_0 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state_ns_89_0_and2_0_300,
      ADR1 => regular_expression_machine0_N_947,
      ADR2 => regular_expression_machine7_N_288,
      O => regular_expression_machine0_state_h_N_914
    );
  regular_expression_machine0_state_h_state_ns_230_0_and2 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine0_N_907_2,
      ADR1 => regular_expression_machine0_state_h_state(2),
      ADR2 => regex_in(7),
      ADR3 => regex_in(6),
      O => regular_expression_machine0_state_h_N_907
    );
  regular_expression_machine0_state_h_state_ns_105_0_and2 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine0_N_882,
      ADR1 => regular_expression_machine0_state_h_state(3),
      ADR2 => regular_expression_machine0_state_h_state(0),
      O => regular_expression_machine0_state_h_N_918
    );
  regular_expression_machine0_state_h_state_ns_309_234_108 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_state(4),
      ADR2 => regular_expression_machine0_state_h_state(0),
      ADR3 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_state_h_state_ns_309_234
    );
  regular_expression_machine0_state_h_state_ns_246_263_109 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_h_state(2),
      ADR3 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_state_h_state_ns_246_263
    );
  regular_expression_machine0_state_h_state_ns_280_275_110 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(4),
      ADR1 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_state_h_state_ns_280_275
    );
  regular_expression_machine0_state_h_state_ns_280_278_111 : X_LUT4
    generic map(
      INIT => X"0440"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regular_expression_machine0_state_h_state_ns_280_275,
      ADR2 => regular_expression_machine0_state_h_state(2),
      ADR3 => regex_in_1(4),
      O => regular_expression_machine0_state_h_state_ns_280_278
    );
  regular_expression_machine0_state_h_state_ns_89_0_and2_0_300_112 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_0(5),
      ADR3 => regular_expression_machine0_state_h_state_ns_312_642,
      O => regular_expression_machine0_state_h_state_ns_89_0_and2_0_300
    );
  regular_expression_machine0_state_h_state_ns_266_308_113 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_state_h_state_ns_266_308
    );
  regular_expression_machine0_state_h_state_ns_262_317_114 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_h_state(4),
      O => regular_expression_machine0_state_h_state_ns_262_317
    );
  regular_expression_machine0_state_h_state_ns_298_605_115 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_h_state(0),
      O => regular_expression_machine0_state_h_state_ns_298_605
    );
  regular_expression_machine0_state_h_state_ns_127_0_and2_0_619_116 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine0_state_h_state(1),
      ADR2 => regular_expression_machine0_state_h_state(0),
      ADR3 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_127_0_and2_0_619
    );
  regular_expression_machine0_state_h_state_ns_127_0_and2_621 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_state_h_N_827
    );
  regular_expression_machine0_state_h_state_ns_312_642_117 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(3),
      ADR1 => regular_expression_machine0_state_h_state(0),
      ADR2 => regular_expression_machine0_state_h_state(1),
      O => regular_expression_machine0_state_h_state_ns_312_642
    );
  regular_expression_machine0_state_h_state_ns_302_643_118 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_302_643
    );
  regular_expression_machine0_state_h_state_ns_314_671_119 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(0),
      ADR1 => regular_expression_machine0_state_h_state(3),
      O => regular_expression_machine0_state_h_state_ns_314_671
    );
  regular_expression_machine0_state_h_state_ns_139_0_683_120 : X_LUT4
    generic map(
      INIT => X"CAC0"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_N_701,
      ADR1 => regular_expression_machine0_state_h_N_704,
      ADR2 => regular_expression_machine0_state_h_state(3),
      ADR3 => regular_expression_machine0_state_h_state(0),
      O => regular_expression_machine0_state_h_state_ns_139_0_683
    );
  regular_expression_machine0_state_h_state_ns_30_s : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine0_state_h_state(4),
      ADR1 => regular_expression_machine0_state_h_state(2),
      O => regular_expression_machine0_state_ns_30_s
    );
  regular_expression_machine0_state_h_state_ns_23_s_121 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine0_N_947,
      O => regular_expression_machine0_state_h_state_ns_23_s
    );
  regular_expression_machine0_state_h_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_736,
      O => regular_expression_machine0_state_h_state(1),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine0_state_h_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_737,
      O => regular_expression_machine0_state_h_state(2),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine0_state_h_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_738,
      O => regular_expression_machine0_state_h_state(3),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine0_state_h_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_739,
      O => regular_expression_machine0_state_h_state(4),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine0_state_h_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_740,
      O => regular_expression_machine0_state_h_state(0),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_nxt_state_47_0_4_Q : X_LUT4
    generic map(
      INIT => X"00E0"
    )
    port map (
      ADR0 => regular_expression_machine1_state(2),
      ADR1 => regular_expression_machine1_state(16),
      ADR2 => regular_expression_machine1_N_560,
      ADR3 => regex_in_2_1_Q,
      O => regular_expression_machine1_nxt_state_47_4_Q
    );
  regular_expression_machine1_G_275 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine1_N_433_i,
      ADR1 => regular_expression_machine1_N_547,
      O => regular_expression_machine1_N_560
    );
  regular_expression_machine1_G_78_0_and2 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine1_state(0),
      ADR1 => regular_expression_machine7_N_104_1,
      O => regular_expression_machine1_nxt_state_47_2_Q
    );
  regular_expression_machine1_nxt_state_47_0_and2_16_Q : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine1_state(14),
      ADR1 => regular_expression_machine7_N_104_1,
      O => regular_expression_machine1_nxt_state_47_16_Q
    );
  regular_expression_machine1_un1_state_61_0_and2 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regular_expression_machine1_state(9),
      ADR1 => regular_expression_machine6_N_311,
      ADR2 => regular_expression_machine6_N_310,
      ADR3 => regex_in_1(0),
      O => regular_expression_machine1_N_303
    );
  regular_expression_machine1_nxt_state_47_97_i_1 : X_LUT3
    generic map(
      INIT => X"DF"
    )
    port map (
      ADR0 => regular_expression_machine1_N_433_i,
      ADR1 => regular_expression_machine1_N_431,
      ADR2 => regex_in_2_1_Q,
      O => regular_expression_machine1_N_398_1
    );
  regular_expression_machine1_un1_state_30_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine1_state(13),
      ADR1 => regular_expression_machine1_N_491_3,
      ADR2 => regular_expression_machine3_N_418,
      O => regular_expression_machine1_N_468
    );
  regular_expression_machine1_nxt_state_47_0_and2_12_Q : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine1_state(10),
      ADR1 => regular_expression_machine7_N_322_1,
      O => regular_expression_machine1_nxt_state_47_12_Q
    );
  regular_expression_machine1_nxt_state_47_0_and2_14_Q : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine1_state(12),
      ADR1 => regular_expression_machine1_N_398_1,
      O => regular_expression_machine1_nxt_state_47_14_Q
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_2_3_20_Q : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine1_N_521,
      ADR1 => regular_expression_machine1_state(22),
      ADR2 => regular_expression_machine1_state(21),
      O => regular_expression_machine1_N_482_4
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_12_3_20_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regular_expression_machine6_N_342_2,
      O => regular_expression_machine1_N_491_3
    );
  regular_expression_machine1_G_202_i_or2 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine6_N_307,
      O => regular_expression_machine1_N_547
    );
  regular_expression_machine1_nxt_state_47_99_i_or2 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regex_in_2_2_Q,
      O => regular_expression_machine1_N_443
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_5_20_Q : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine1_state(18),
      ADR1 => regular_expression_machine1_N_431,
      ADR2 => regular_expression_machine1_N_433_i,
      O => regular_expression_machine1_N_484
    );
  regular_expression_machine1_nxt_state_47_0_and2_6_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine1_state(4),
      ADR1 => regular_expression_machine1_N_560,
      ADR2 => regex_in_2_1_Q,
      O => regular_expression_machine1_nxt_state_47_6_Q
    );
  regular_expression_machine1_G_243 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine1_state(0),
      ADR1 => regular_expression_machine1_N_438,
      O => regular_expression_machine1_N_442
    );
  regular_expression_machine1_G_232 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine6_N_307,
      O => regular_expression_machine1_N_431
    );
  regular_expression_machine1_G_231 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine1_N_502,
      ADR1 => regular_expression_machine1_N_561,
      ADR2 => regex_in_2_1_Q,
      ADR3 => regular_expression_machine1_G_200_280,
      O => regular_expression_machine1_N_430
    );
  regular_expression_machine1_G_230 : X_LUT4
    generic map(
      INIT => X"3A30"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine1_state(17),
      ADR2 => regex_in_1(0),
      ADR3 => regular_expression_machine1_G_198_235,
      O => regular_expression_machine1_N_429
    );
  regular_expression_machine1_G_229 : X_LUT4
    generic map(
      INIT => X"0353"
    )
    port map (
      ADR0 => regular_expression_machine1_state(15),
      ADR1 => regular_expression_machine1_state(11),
      ADR2 => regex_in_1(3),
      ADR3 => regex_in_2_1_Q,
      O => regular_expression_machine1_N_428
    );
  regular_expression_machine1_nxt_state_47_0_21_Q : X_LUT4
    generic map(
      INIT => X"3222"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_and2_11_20_498,
      ADR1 => regular_expression_machine1_N_431,
      ADR2 => regular_expression_machine1_nxt_state_47_0_and2_21_570,
      ADR3 => regular_expression_machine1_N_433_i,
      O => regular_expression_machine1_nxt_state_47_21_Q
    );
  regular_expression_machine1_G_225 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine1_state(8),
      ADR1 => regular_expression_machine1_state(17),
      ADR2 => regular_expression_machine1_state(14),
      O => regular_expression_machine1_N_525
    );
  regular_expression_machine1_G_224 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine1_state(11),
      ADR1 => regular_expression_machine1_state(15),
      O => regular_expression_machine1_N_524
    );
  regular_expression_machine1_G_220 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regular_expression_machine7_N_328,
      O => regular_expression_machine1_N_520
    );
  regular_expression_machine1_G_209 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regular_expression_machine3_N_361,
      O => regular_expression_machine1_N_509
    );
  regular_expression_machine1_G_139 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine1_state(1),
      ADR1 => regular_expression_machine1_state(7),
      O => regular_expression_machine1_N_285
    );
  regular_expression_machine1_G_221 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine1_G_221_119,
      ADR1 => regular_expression_machine1_G_221_117,
      ADR2 => regular_expression_machine1_state(16),
      ADR3 => regular_expression_machine1_state(10),
      O => regular_expression_machine1_N_521
    );
  regular_expression_machine1_G_239 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine1_G_239_135,
      ADR1 => regular_expression_machine1_state(3),
      ADR2 => regular_expression_machine1_state(6),
      ADR3 => regular_expression_machine1_state(5),
      O => regular_expression_machine1_N_438
    );
  regular_expression_machine1_nxt_state_47_0_and2_10_Q : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine1_N_561,
      ADR1 => regular_expression_machine7_N_344,
      ADR2 => regular_expression_machine1_nxt_state_47_0_and2_10_301,
      ADR3 => regular_expression_machine7_N_288,
      O => regular_expression_machine1_nxt_state_47_10_Q
    );
  regular_expression_machine1_un1_state_108_0_and2 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine1_N_547,
      ADR1 => regular_expression_machine1_state(1),
      ADR2 => regular_expression_machine7_N_328,
      ADR3 => regular_expression_machine6_N_340_2,
      O => regular_expression_machine1_N_555
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_12_20_Q : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine1_N_491_3,
      ADR1 => regular_expression_machine1_N_561,
      ADR2 => regex_in_0(3),
      ADR3 => regular_expression_machine1_nxt_state_47_i_0_and2_12_20_420,
      O => regular_expression_machine1_N_491
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_9_20_Q : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine1_N_547,
      ADR1 => regular_expression_machine1_N_285,
      ADR2 => regular_expression_machine7_N_328,
      ADR3 => regular_expression_machine6_N_340_2,
      O => regular_expression_machine1_N_488
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_6_20_Q : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine3_N_361,
      ADR1 => regular_expression_machine6_N_340_2,
      ADR2 => regular_expression_machine1_state(5),
      ADR3 => regular_expression_machine1_N_443,
      O => regular_expression_machine1_N_485
    );
  regular_expression_machine1_un1_state_77_0_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine1_N_509,
      ADR1 => regular_expression_machine6_N_340_2,
      ADR2 => regular_expression_machine1_state(5),
      ADR3 => regular_expression_machine1_N_443,
      O => regular_expression_machine1_N_470
    );
  regular_expression_machine1_un1_state_50_0_and2 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine1_N_547,
      ADR1 => regular_expression_machine1_state(11),
      ADR2 => regular_expression_machine1_N_443,
      ADR3 => regular_expression_machine6_N_342_2,
      O => regular_expression_machine1_N_469
    );
  regular_expression_machine1_un1_state_24_0_and2 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine1_N_431,
      ADR1 => regular_expression_machine1_state(15),
      ADR2 => regular_expression_machine1_N_443,
      ADR3 => regular_expression_machine6_N_342_2,
      O => regular_expression_machine1_N_467
    );
  regular_expression_machine1_un1_state_11_0_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine1_N_509,
      ADR1 => regular_expression_machine1_N_433_i,
      ADR2 => regular_expression_machine6_N_342_2,
      ADR3 => regular_expression_machine1_state(17),
      O => regular_expression_machine1_N_466
    );
  regular_expression_machine1_G_201 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine1_N_429,
      ADR1 => regex_in_1(1),
      ADR2 => regex_in_1(2),
      ADR3 => regular_expression_machine1_state(8),
      O => regular_expression_machine1_N_502
    );
  regular_expression_machine1_nxt_state_47_0_and2_18_Q : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine1_N_560,
      ADR1 => regex_in_1(1),
      ADR2 => regular_expression_machine1_state(16),
      O => regular_expression_machine1_nxt_state_47_18_Q
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_20_Q : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_and2_20_578,
      ADR1 => regular_expression_machine1_N_431,
      ADR2 => regex_in_1(1),
      O => regular_expression_machine1_N_478
    );
  regular_expression_machine1_un1_state_83_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine1_N_560,
      ADR1 => regular_expression_machine1_un1_state_83_0_and2_581,
      O => regular_expression_machine1_N_553
    );
  regular_expression_machine1_un1_state_103_0_and2 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine1_N_547,
      ADR1 => regular_expression_machine1_state(7),
      ADR2 => regular_expression_machine7_N_328,
      ADR3 => regular_expression_machine6_N_340_2,
      O => regular_expression_machine1_N_554
    );
  regular_expression_machine1_nxt_state_47_i_0_20_64_122 : X_LUT4
    generic map(
      INIT => X"FCF8"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_and2_1_s(20),
      ADR1 => regular_expression_machine1_N_560,
      ADR2 => regular_expression_machine1_N_484,
      ADR3 => regular_expression_machine1_state(16),
      O => regular_expression_machine1_nxt_state_47_i_0_20_64
    );
  regular_expression_machine1_nxt_state_47_i_0_20_65_123 : X_LUT4
    generic map(
      INIT => X"BAAA"
    )
    port map (
      ADR0 => regular_expression_machine1_N_485,
      ADR1 => regular_expression_machine6_N_307,
      ADR2 => regular_expression_machine1_un1_state_83_0_and2_581,
      ADR3 => regular_expression_machine1_N_433_i,
      O => regular_expression_machine1_nxt_state_47_i_0_20_65
    );
  regular_expression_machine1_nxt_state_47_i_0_20_66_124 : X_LUT4
    generic map(
      INIT => X"EEFE"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_20_64,
      ADR1 => regular_expression_machine1_N_488,
      ADR2 => regular_expression_machine1_nxt_state_47_i_0_and2_11_20_498,
      ADR3 => regular_expression_machine1_N_431,
      O => regular_expression_machine1_nxt_state_47_i_0_20_66
    );
  regular_expression_machine1_nxt_state_47_i_0_20_69_125 : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_and2_2_20_527,
      ADR1 => regular_expression_machine1_N_509,
      ADR2 => regular_expression_machine1_nxt_state_47_i_0_and2_3_20_438,
      ADR3 => regular_expression_machine6_N_307,
      O => regular_expression_machine1_nxt_state_47_i_0_20_69
    );
  regular_expression_machine1_nxt_state_47_i_0_20_70_126 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine1_N_478,
      ADR1 => regular_expression_machine1_N_491,
      ADR2 => regular_expression_machine1_nxt_state_47_i_0_and2_0_20_366,
      ADR3 => regular_expression_machine1_N_520,
      O => regular_expression_machine1_nxt_state_47_i_0_20_70
    );
  regular_expression_machine1_nxt_state_47_i_0_20_72_127 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_20_69,
      ADR1 => regular_expression_machine1_nxt_state_47_i_0_20_70,
      ADR2 => regular_expression_machine1_nxt_state_47_i_0_20_65,
      ADR3 => regular_expression_machine1_nxt_state_47_i_0_20_66,
      O => regular_expression_machine1_nxt_state_47_i_0_20_72
    );
  regular_expression_machine1_G_221_117_128 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine1_state(18),
      ADR1 => regular_expression_machine1_state(13),
      O => regular_expression_machine1_G_221_117
    );
  regular_expression_machine1_G_221_119_129 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine1_state(9),
      ADR1 => regular_expression_machine1_state(19),
      ADR2 => regular_expression_machine1_state(23),
      ADR3 => regular_expression_machine1_state(20),
      O => regular_expression_machine1_G_221_119
    );
  regular_expression_machine1_G_239_135_130 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine1_state(7),
      ADR1 => regular_expression_machine1_state(1),
      ADR2 => regular_expression_machine1_state(4),
      ADR3 => regular_expression_machine1_state(2),
      O => regular_expression_machine1_G_239_135
    );
  regular_expression_machine1_nxt_state_47_97_i_and2_218_131 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine1_N_525,
      ADR1 => regular_expression_machine1_N_524,
      ADR2 => regular_expression_machine1_state(21),
      O => regular_expression_machine1_nxt_state_47_97_i_and2_218
    );
  regular_expression_machine1_nxt_state_47_99_i_and2_222_132 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine1_N_525,
      ADR1 => regular_expression_machine1_N_524,
      ADR2 => regular_expression_machine1_state(12),
      ADR3 => regular_expression_machine1_state(21),
      O => regular_expression_machine1_nxt_state_47_99_i_and2_222
    );
  regular_expression_machine1_G_198_235_133 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine1_state(14),
      ADR1 => regular_expression_machine1_state(0),
      O => regular_expression_machine1_G_198_235
    );
  regular_expression_machine1_G_200_280_134 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine1_state(0),
      ADR1 => regular_expression_machine1_state(17),
      ADR2 => regular_expression_machine1_state(14),
      O => regular_expression_machine1_G_200_280
    );
  regular_expression_machine1_nxt_state_47_0_and2_10_301_135 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine1_state(8),
      ADR1 => regex_in_0(1),
      O => regular_expression_machine1_nxt_state_47_0_and2_10_301
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_0_20_366_136 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regular_expression_machine3_N_361,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine1_state(0),
      ADR3 => regular_expression_machine1_state(10),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_0_20_366
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_12_20_420_137 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine1_state(6),
      ADR1 => regex_in(7),
      ADR2 => regex_in(6),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_12_20_420
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_3_20_435_138 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine1_N_442,
      ADR1 => regular_expression_machine1_N_482_4,
      ADR2 => regular_expression_machine1_N_525,
      ADR3 => regular_expression_machine1_state(12),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_3_20_435
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_3_20_438_139 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine1_N_428,
      ADR1 => regular_expression_machine1_N_443,
      ADR2 => regex_in_0(5),
      ADR3 => regular_expression_machine1_nxt_state_47_i_0_and2_3_20_435,
      O => regular_expression_machine1_nxt_state_47_i_0_and2_3_20_438
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_11_20_498_140 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine7_N_328,
      ADR1 => regular_expression_machine6_N_342_2,
      ADR2 => regular_expression_machine1_state(19),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_11_20_498
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_2_20_524_141 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine1_state(12),
      ADR1 => regular_expression_machine1_state(15),
      ADR2 => regular_expression_machine1_state(11),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_2_20_524
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_2_20_527_142 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine1_N_430,
      ADR1 => regular_expression_machine1_N_482_4,
      ADR2 => regular_expression_machine1_N_438,
      ADR3 => regular_expression_machine1_nxt_state_47_i_0_and2_2_20_524,
      O => regular_expression_machine1_nxt_state_47_i_0_and2_2_20_527
    );
  regular_expression_machine1_nxt_state_47_0_and2_21_570_143 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine1_state(18),
      ADR1 => regex_in_0(1),
      O => regular_expression_machine1_nxt_state_47_0_and2_21_570
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_20_578_144 : X_LUT4
    generic map(
      INIT => X"0DD0"
    )
    port map (
      ADR0 => regular_expression_machine1_state(22),
      ADR1 => regular_expression_machine1_N_442,
      ADR2 => regex_in_0(2),
      ADR3 => regex_in_0(0),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_20_578
    );
  regular_expression_machine1_nxt_state_47_99_i_579_145 : X_LUT4
    generic map(
      INIT => X"BAAA"
    )
    port map (
      ADR0 => regular_expression_machine1_N_443,
      ADR1 => regular_expression_machine1_N_442,
      ADR2 => regular_expression_machine1_nxt_state_47_99_i_and2_222,
      ADR3 => regular_expression_machine1_N_521,
      O => regular_expression_machine1_nxt_state_47_99_i_579
    );
  regular_expression_machine1_un1_state_83_0_and2_581_146 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine1_state(3),
      ADR1 => regular_expression_machine6_N_340_2,
      O => regular_expression_machine1_un1_state_83_0_and2_581
    );
  regular_expression_machine1_nxt_state_47_i_0_and2_1_s_20_Q : X_LUT3
    generic map(
      INIT => X"54"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regular_expression_machine1_state(4),
      ADR2 => regular_expression_machine1_state(2),
      O => regular_expression_machine1_nxt_state_47_i_0_and2_1_s(20)
    );
  regular_expression_machine1_N_59_i_147 : X_LUT4
    generic map(
      INIT => X"0111"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_i_0_20_72,
      ADR1 => regular_expression_machine1_N_303,
      ADR2 => regular_expression_machine3_N_394_1,
      ADR3 => regular_expression_machine1_state(13),
      O => regular_expression_machine1_N_59_i
    );
  regular_expression_machine1_N_401_i_148 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regular_expression_machine1_nxt_state_47_99_i_579,
      ADR1 => regular_expression_machine1_N_431,
      ADR2 => regex_in_0(1),
      O => regular_expression_machine1_N_401_i
    );
  regular_expression_machine1_N_398_i_149 : X_LUT4
    generic map(
      INIT => X"4555"
    )
    port map (
      ADR0 => regular_expression_machine1_N_398_1,
      ADR1 => regular_expression_machine1_N_442,
      ADR2 => regular_expression_machine1_nxt_state_47_97_i_and2_218,
      ADR3 => regular_expression_machine1_N_521,
      O => regular_expression_machine1_N_398_i
    );
  regular_expression_machine1_N_513_i_150 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine1_state(22),
      ADR1 => regular_expression_machine1_state(21),
      O => regular_expression_machine1_N_513_i
    );
  regular_expression_machine1_state_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_14_Q,
      O => regular_expression_machine1_state(14),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_468,
      O => regular_expression_machine1_state(15),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_16_Q,
      O => regular_expression_machine1_state(16),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_467,
      O => regular_expression_machine1_state(17),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_18_Q,
      O => regular_expression_machine1_state(18),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_466,
      O => regular_expression_machine1_state(19),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_59_i,
      O => regular_expression_machine1_state(20),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_21_Q,
      O => regular_expression_machine1_state(21),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_GND,
      O => regular_expression_machine1_state(22),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_GND,
      O => regular_expression_machine1_state(23),
      SSET => cntrlr_N_882_1_i_2,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  regular_expression_machine1_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_398_i,
      O => regular_expression_machine1_state(0),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_401_i,
      O => regular_expression_machine1_state(1),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_2_Q,
      O => regular_expression_machine1_state(2),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_555,
      O => regular_expression_machine1_state(3),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_4_Q,
      O => regular_expression_machine1_state(4),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_553,
      O => regular_expression_machine1_state(5),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_6_Q,
      O => regular_expression_machine1_state(6),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_470,
      O => regular_expression_machine1_state(7),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_491,
      O => regular_expression_machine1_state(8),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_554,
      O => regular_expression_machine1_state(9),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_10_Q,
      O => regular_expression_machine1_state(10),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_303,
      O => regular_expression_machine1_state(11),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_nxt_state_47_12_Q,
      O => regular_expression_machine1_state(12),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_state_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine1_N_469,
      O => regular_expression_machine1_state(13),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine1_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => regular_expression_machine1_N_513_i,
      O => accepted(1),
      SRST => cntrlr_N_882_1_i_2,
      SSET => accepted(1),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine1_GND_151 : X_ZERO
    port map (
      O => regular_expression_machine1_GND
    );
  regular_expression_machine2_G_83 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine2_G_67_sx,
      ADR1 => regular_expression_machine2_G_83_sx,
      O => regular_expression_machine2_N_847
    );
  regular_expression_machine2_G_83_sx_152 : X_LUT4
    generic map(
      INIT => X"FFBF"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regular_expression_machine2_G_82_243,
      ADR2 => regular_expression_machine2_state_h_state(3),
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine2_G_83_sx
    );
  regular_expression_machine2_G_81 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in(6),
      ADR2 => regular_expression_machine2_G_81_sx_0,
      O => regular_expression_machine2_N_845
    );
  regular_expression_machine2_G_81_sx_0_153 : X_LUT4
    generic map(
      INIT => X"EFFF"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regex_in(7),
      ADR2 => regular_expression_machine2_state_h_state(0),
      ADR3 => regular_expression_machine2_state_h_state(4),
      O => regular_expression_machine2_G_81_sx_0
    );
  regular_expression_machine2_G_67 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine2_G_67_sx,
      O => regular_expression_machine2_N_831
    );
  regular_expression_machine2_G_67_sx_154 : X_LUT4
    generic map(
      INIT => X"FF7F"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in_1(5),
      ADR2 => regex_in(6),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_G_67_sx
    );
  regular_expression_machine2_G_65 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regex_in(7),
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine2_N_829
    );
  regular_expression_machine2_G_76 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine2_G_76_sx,
      O => regular_expression_machine2_N_840
    );
  regular_expression_machine2_G_76_sx_155 : X_LUT4
    generic map(
      INIT => X"FEFF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in_1(5),
      ADR2 => regex_in(7),
      ADR3 => regex_in(6),
      O => regular_expression_machine2_G_76_sx
    );
  regular_expression_machine2_G_76_fast_156 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine2_G_76_fast_sx,
      O => regular_expression_machine2_G_76_fast
    );
  regular_expression_machine2_G_76_fast_sx_157 : X_LUT4
    generic map(
      INIT => X"FEFF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in_1(5),
      ADR2 => regex_in(7),
      ADR3 => regex_in(6),
      O => regular_expression_machine2_G_76_fast_sx
    );
  regular_expression_machine2_G_63 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      ADR2 => regex_in_2_2_Q,
      ADR3 => regex_in_1(5),
      O => regular_expression_machine2_N_827
    );
  regular_expression_machine2_G_81_sx_158 : X_LUT4
    generic map(
      INIT => X"F7FF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(4),
      ADR1 => regular_expression_machine2_state_h_state(0),
      ADR2 => regex_in(7),
      ADR3 => regex_in(6),
      O => regular_expression_machine2_G_81_sx
    );
  regular_expression_machine2_G_92 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine2_N_600,
      ADR1 => regular_expression_machine2_N_557,
      ADR2 => regex_in_1(0),
      O => regular_expression_machine2_N_796
    );
  regular_expression_machine2_G_90 : X_MUX2
    port map (
      IA => regular_expression_machine2_G_90_am,
      IB => regular_expression_machine2_G_90_bm,
      O => regular_expression_machine2_N_794,
      SEL => regex_in_1(0)
    );
  regular_expression_machine2_G_90_bm_159 : X_LUT4
    generic map(
      INIT => X"8580"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_N_840,
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regular_expression_machine2_N_579,
      O => regular_expression_machine2_G_90_bm
    );
  regular_expression_machine2_G_90_am_160 : X_LUT4
    generic map(
      INIT => X"0840"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_N_545,
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regular_expression_machine2_state_h_state(0),
      O => regular_expression_machine2_G_90_am
    );
  regular_expression_machine2_G_80 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(1),
      ADR1 => regular_expression_machine2_state_h_state(2),
      O => regular_expression_machine2_N_844
    );
  regular_expression_machine2_G_77 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine2_N_831,
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regex_in_2_1_Q,
      O => regular_expression_machine2_N_841
    );
  regular_expression_machine2_G_68 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine2_G_2_fast,
      ADR1 => regex_in_1(5),
      ADR2 => regular_expression_machine2_state_h_state(0),
      O => regular_expression_machine2_N_832
    );
  regular_expression_machine2_G_9_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine2_N_844,
      ADR1 => regular_expression_machine2_state_ns_224_282,
      ADR2 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_d(27)
    );
  regular_expression_machine2_G_82_243_161 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(4),
      ADR1 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_G_82_243
    );
  regular_expression_machine2_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => regular_expression_machine2_state_d(27),
      O => accepted(2),
      SRST => cntrlr_N_882_1_i_2,
      SSET => accepted(2),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine2_state_h_state_ns_133_bm_162 : X_LUT4
    generic map(
      INIT => X"888B"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_133_bm_1,
      ADR1 => regex_in_1(1),
      ADR2 => regular_expression_machine2_state_h_state_ns_198_sx,
      ADR3 => regular_expression_machine2_state_h_G_3_sx,
      O => regular_expression_machine2_state_h_state_ns_133_bm
    );
  regular_expression_machine2_state_h_state_ns_133_bm_1_163 : X_LUT4
    generic map(
      INIT => X"F808"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_230_475,
      ADR1 => regular_expression_machine2_N_579,
      ADR2 => regular_expression_machine2_state_h_state(1),
      ADR3 => regular_expression_machine2_state_h_state_ns_61_1,
      O => regular_expression_machine2_state_h_state_ns_133_bm_1
    );
  regular_expression_machine2_state_h_state_ns_61_1_164 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in_1(5),
      ADR2 => regular_expression_machine2_state_h_state_ns_60_sx_sx,
      ADR3 => regex_in(6),
      O => regular_expression_machine2_state_h_state_ns_61_1
    );
  regular_expression_machine2_state_h_state_ns_198_sx_165 : X_LUT4
    generic map(
      INIT => X"EBFF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(4),
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regular_expression_machine2_state_h_state(1),
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine2_state_h_state_ns_198_sx
    );
  regular_expression_machine2_state_h_state_ns_52 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine2_state_h_state_ns_52_sx_0,
      O => regular_expression_machine2_N_579
    );
  regular_expression_machine2_state_h_state_ns_52_sx_0_166 : X_LUT4
    generic map(
      INIT => X"DFFF"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regex_in(7),
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine2_state_h_state(0),
      O => regular_expression_machine2_state_h_state_ns_52_sx_0
    );
  regular_expression_machine2_state_h_state_ns_220 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_220_sx_sx,
      ADR1 => regex_in(6),
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine2_state_h_N_571
    );
  regular_expression_machine2_state_h_state_ns_92_sx_167 : X_LUT3
    generic map(
      INIT => X"F2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in(6),
      ADR2 => regular_expression_machine2_state_h_state_ns_92_sx_sx,
      O => regular_expression_machine2_state_h_state_ns_92_sx
    );
  regular_expression_machine2_state_h_state_ns_92_sx_sx_168 : X_LUT4
    generic map(
      INIT => X"BF3F"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regular_expression_machine2_state_h_state(4),
      ADR2 => regex_in_1(1),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_state_h_state_ns_92_sx_sx
    );
  regular_expression_machine2_state_h_state_ns_62_bm_169 : X_LUT3
    generic map(
      INIT => X"0B"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_587,
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_state_h_state_ns_62_bm_sx,
      O => regular_expression_machine2_state_h_state_ns_62_bm
    );
  regular_expression_machine2_state_h_state_ns_62_bm_sx_170 : X_LUT4
    generic map(
      INIT => X"3133"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_230_475,
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_state_h_state_ns_52_sx,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine2_state_h_state_ns_62_bm_sx
    );
  regular_expression_machine2_state_h_state_ns_195_bm_171 : X_LUT4
    generic map(
      INIT => X"0013"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regular_expression_machine2_state_h_state_ns_90_0_sx,
      ADR2 => regular_expression_machine7_N_288,
      ADR3 => regular_expression_machine2_state_h_state_ns_195_bm_sx,
      O => regular_expression_machine2_state_h_state_ns_195_bm
    );
  regular_expression_machine2_state_h_state_ns_195_bm_sx_172 : X_LUT4
    generic map(
      INIT => X"FBBB"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(1),
      ADR1 => regular_expression_machine2_state_h_state(4),
      ADR2 => regular_expression_machine2_state_h_state(0),
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine2_state_h_state_ns_195_bm_sx
    );
  regular_expression_machine2_state_h_state_ns_234 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_G_3_sx,
      ADR1 => regex_in_2_2_Q,
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_h_N_643
    );
  regular_expression_machine2_state_h_state_ns_48 : X_LUT4
    generic map(
      INIT => X"008B"
    )
    port map (
      ADR0 => regular_expression_machine2_N_829,
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regular_expression_machine2_G_81_sx,
      ADR3 => regular_expression_machine2_state_h_state_ns_48_sx,
      O => regular_expression_machine2_state_h_N_575
    );
  regular_expression_machine2_state_h_state_ns_48_sx_173 : X_LUT4
    generic map(
      INIT => X"7747"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_47_0_and2_s,
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regex_in_2_2_Q,
      ADR3 => regex_in_1(5),
      O => regular_expression_machine2_state_h_state_ns_48_sx
    );
  regular_expression_machine2_state_h_state_ns_90_0_sx_174 : X_LUT3
    generic map(
      INIT => X"F4"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in_1(5),
      ADR2 => regular_expression_machine2_state_h_state_ns_90_0_sx_sx,
      O => regular_expression_machine2_state_h_state_ns_90_0_sx
    );
  regular_expression_machine2_state_h_state_ns_90_0_sx_sx_175 : X_LUT4
    generic map(
      INIT => X"DD9D"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in_1(5),
      ADR2 => regex_in(6),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_state_h_state_ns_90_0_sx_sx
    );
  regular_expression_machine2_state_h_state_ns_90_0_and2_G_3 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine2_state_h_G_3_sx,
      O => regular_expression_machine2_state_h_N_818
    );
  regular_expression_machine2_state_h_state_ns_90_0_and2_G_3_sx : X_LUT4
    generic map(
      INIT => X"FFBF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in_1(5),
      ADR2 => regex_in(6),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_state_h_G_3_sx
    );
  regular_expression_machine2_state_h_state_ns_220_sx_sx_176 : X_LUT4
    generic map(
      INIT => X"FFF7"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(4),
      ADR1 => regular_expression_machine2_state_h_state(0),
      ADR2 => regex_in_1(5),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_state_h_state_ns_220_sx_sx
    );
  regular_expression_machine2_state_h_state_ns_60 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_60_sx_sx,
      ADR1 => regex_in(6),
      ADR2 => regex_in_1(5),
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine2_state_h_N_587
    );
  regular_expression_machine2_state_h_state_ns_60_sx_sx_177 : X_LUT4
    generic map(
      INIT => X"FFEF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regular_expression_machine2_state_h_state(4),
      ADR2 => regular_expression_machine2_state_h_state(3),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_state_h_state_ns_60_sx_sx
    );
  regular_expression_machine2_state_h_state_ns_52_sx_178 : X_LUT4
    generic map(
      INIT => X"F7FF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regex_in_1(5),
      ADR2 => regex_in(7),
      ADR3 => regex_in(6),
      O => regular_expression_machine2_state_h_state_ns_52_sx
    );
  regular_expression_machine2_state_h_state_ns_92 : X_LUT4
    generic map(
      INIT => X"0013"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regular_expression_machine2_state_h_state_ns_90_0_sx,
      ADR2 => regex_in_2_2_Q,
      ADR3 => regular_expression_machine2_state_h_state_ns_92_sx,
      O => regular_expression_machine2_state_h_N_617
    );
  regular_expression_machine2_state_h_state_ns_8 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine2_G_2_fast,
      ADR1 => regular_expression_machine2_state_h_state_ns_8_sx,
      O => regular_expression_machine2_state_h_N_540
    );
  regular_expression_machine2_state_h_state_ns_8_sx_179 : X_LUT4
    generic map(
      INIT => X"FFBF"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(4),
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regular_expression_machine2_state_h_state(0),
      ADR3 => regex_in_1(5),
      O => regular_expression_machine2_state_h_state_ns_8_sx
    );
  regular_expression_machine2_state_h_state_ns_4_G_2_fast : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in(6),
      ADR2 => regex_in(7),
      O => regular_expression_machine2_G_2_fast
    );
  regular_expression_machine2_state_h_state_ns_4_G_2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in(6),
      ADR2 => regex_in(7),
      O => regular_expression_machine2_state_h_N_536
    );
  regular_expression_machine2_state_h_state_ns_208 : X_LUT4
    generic map(
      INIT => X"0A80"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_208_1,
      ADR1 => regular_expression_machine2_state_h_N_660,
      ADR2 => regular_expression_machine2_state_h_state(2),
      ADR3 => regex_in_1(0),
      O => regular_expression_machine2_state_h_N_666
    );
  regular_expression_machine2_state_h_state_ns_208_1_180 : X_LUT4
    generic map(
      INIT => X"9111"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regex_in_2_1_Q,
      ADR3 => regular_expression_machine2_state_h_N_633,
      O => regular_expression_machine2_state_h_state_ns_208_1
    );
  regular_expression_machine2_state_h_state_ns_105_0_and2 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine2_N_832,
      ADR1 => regex_in_2_1_Q,
      ADR2 => regular_expression_machine2_G_82_243,
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_h_N_824
    );
  regular_expression_machine2_state_h_state_ns_205_bm_181 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_562,
      ADR1 => regex_in_1(0),
      ADR2 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_state_ns_205_bm
    );
  regular_expression_machine2_state_h_state_ns_114 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_N_760,
      IB => regular_expression_machine2_state_h_N_638,
      O => regular_expression_machine2_N_639,
      SEL => regex_in_2_4_Q
    );
  regular_expression_machine2_state_h_state_ns_197_0_and2_0 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regular_expression_machine2_N_827,
      O => regular_expression_machine2_state_h_N_815
    );
  regular_expression_machine2_state_h_state_ns_197_0_and2 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_state_h_N_575,
      ADR3 => regular_expression_machine2_state_h_N_571,
      O => regular_expression_machine2_state_h_N_814
    );
  regular_expression_machine2_state_h_state_ns_105_0 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_824,
      ADR1 => regular_expression_machine2_N_841,
      ADR2 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_N_630
    );
  regular_expression_machine2_state_h_state_ns_88_0 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => regular_expression_machine2_N_796,
      ADR1 => regular_expression_machine2_N_844,
      ADR2 => regular_expression_machine2_state_h_state_ns_88_0_and2_0_602,
      ADR3 => regular_expression_machine2_N_794,
      O => regular_expression_machine2_state_h_N_613
    );
  regular_expression_machine2_state_h_state_ns_222_1 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine2_state_h_N_536,
      ADR2 => regex_in_2_1_Q,
      O => regular_expression_machine2_N_595_1
    );
  regular_expression_machine2_state_h_state_ns_236 : X_LUT4
    generic map(
      INIT => X"CAAA"
    )
    port map (
      ADR0 => regular_expression_machine2_N_827,
      ADR1 => regular_expression_machine2_state_h_N_536,
      ADR2 => regular_expression_machine2_state_h_state_ns_218_273,
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_h_N_685
    );
  regular_expression_machine2_state_h_state_ns_231 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_state_h_state(4),
      O => regular_expression_machine2_state_h_N_732
    );
  regular_expression_machine2_state_h_state_ns_205 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_205_am,
      IB => regular_expression_machine2_state_h_state_ns_205_bm,
      O => regular_expression_machine2_state_h_N_649,
      SEL => regular_expression_machine2_state_h_state(2)
    );
  regular_expression_machine2_state_h_state_ns_205_am_182 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine2_state_h_N_644,
      ADR2 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_state_ns_205_am
    );
  regular_expression_machine2_state_h_state_ns_195 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_195_am,
      IB => regular_expression_machine2_state_h_state_ns_195_bm,
      O => regular_expression_machine2_state_h_N_682,
      SEL => regex_in_2_1_Q
    );
  regular_expression_machine2_state_h_state_ns_195_am_183 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_536,
      ADR1 => regex_in_1(5),
      O => regular_expression_machine2_state_h_state_ns_195_am
    );
  regular_expression_machine2_state_h_state_ns_190 : X_LUT4
    generic map(
      INIT => X"22E2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_707,
      ADR1 => regex_in_2_4_Q,
      ADR2 => regular_expression_machine2_state_h_N_694,
      ADR3 => regex_in_1(3),
      O => regular_expression_machine2_N_709
    );
  regular_expression_machine2_state_h_state_ns_188 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_N_700,
      IB => regular_expression_machine2_state_h_N_706,
      O => regular_expression_machine2_state_h_N_707,
      SEL => regex_in_0(3)
    );
  regular_expression_machine2_state_h_state_ns_187 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_187_am,
      IB => regular_expression_machine2_state_h_state_ns_187_bm,
      O => regular_expression_machine2_state_h_N_706,
      SEL => regex_in_1(0)
    );
  regular_expression_machine2_state_h_state_ns_187_bm_184 : X_LUT4
    generic map(
      INIT => X"E444"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_N_651,
      ADR2 => regular_expression_machine2_state_h_state_ns_274_0_and2_552,
      ADR3 => regular_expression_machine2_N_845,
      O => regular_expression_machine2_state_h_state_ns_187_bm
    );
  regular_expression_machine2_state_h_state_ns_187_am_185 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_state_ns_266_0_and2_496,
      ADR2 => regular_expression_machine2_N_840,
      O => regular_expression_machine2_state_h_state_ns_187_am
    );
  regular_expression_machine2_state_h_state_ns_181 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_181_am,
      IB => regular_expression_machine2_state_h_state_ns_181_bm,
      O => regular_expression_machine2_state_h_N_700,
      SEL => regex_in_1(0)
    );
  regular_expression_machine2_state_h_state_ns_181_bm_186 : X_LUT4
    generic map(
      INIT => X"E444"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_N_676,
      ADR2 => regular_expression_machine2_state_h_state(1),
      ADR3 => regular_expression_machine2_state_h_N_562,
      O => regular_expression_machine2_state_h_state_ns_181_bm
    );
  regular_expression_machine2_state_h_state_ns_181_am_187 : X_LUT4
    generic map(
      INIT => X"D888"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_N_550,
      ADR2 => regular_expression_machine2_state_h_N_644,
      ADR3 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_state_ns_181_am
    );
  regular_expression_machine2_state_h_state_ns_175 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_175_am,
      IB => regular_expression_machine2_state_h_state_ns_175_bm,
      O => regular_expression_machine2_N_696,
      SEL => regex_in_2_4_Q
    );
  regular_expression_machine2_state_h_state_ns_175_bm_188 : X_LUT4
    generic map(
      INIT => X"E444"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine2_state_h_N_694,
      ADR2 => regular_expression_machine2_state_h_state_ns_286_504,
      ADR3 => regular_expression_machine2_state_h_N_633,
      O => regular_expression_machine2_state_h_state_ns_175_bm
    );
  regular_expression_machine2_state_h_state_ns_175_am_189 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine2_state_h_N_690,
      ADR2 => regular_expression_machine2_state_h_N_679,
      O => regular_expression_machine2_state_h_state_ns_175_am
    );
  regular_expression_machine2_state_h_state_ns_173 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_693,
      ADR1 => regex_in_1(0),
      ADR2 => regular_expression_machine2_state_h_N_536,
      ADR3 => regex_in_1(1),
      O => regular_expression_machine2_state_h_N_694
    );
  regular_expression_machine2_state_h_state_ns_172 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_N_841,
      ADR3 => regular_expression_machine2_state_h_N_660,
      O => regular_expression_machine2_state_h_N_693
    );
  regular_expression_machine2_state_h_state_ns_169 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_569,
      ADR1 => regular_expression_machine2_state_h_N_689,
      ADR2 => regex_in_1(0),
      O => regular_expression_machine2_state_h_N_690
    );
  regular_expression_machine2_state_h_state_ns_168 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_N_682,
      IB => regular_expression_machine2_state_h_N_688,
      O => regular_expression_machine2_state_h_N_689,
      SEL => regular_expression_machine2_state_h_state(2)
    );
  regular_expression_machine2_state_h_state_ns_167 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_167_am_0,
      IB => regular_expression_machine2_state_h_state_ns_167_bm_0,
      O => regular_expression_machine2_state_h_N_688,
      SEL => regular_expression_machine2_state_h_state(1)
    );
  regular_expression_machine2_state_h_state_ns_167_bm : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regular_expression_machine2_state_h_N_732,
      ADR2 => regular_expression_machine2_N_840,
      ADR3 => regular_expression_machine2_N_827,
      O => regular_expression_machine2_state_h_state_ns_167_bm_0
    );
  regular_expression_machine2_state_h_state_ns_167_am : X_LUT4
    generic map(
      INIT => X"E444"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regular_expression_machine2_state_h_N_685,
      ADR2 => regular_expression_machine2_state_h_state_ns_230_475,
      ADR3 => regular_expression_machine2_N_579,
      O => regular_expression_machine2_state_h_state_ns_167_am_0
    );
  regular_expression_machine2_state_h_state_ns_158 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_673,
      ADR1 => regular_expression_machine2_state_h_N_678,
      ADR2 => regex_in_1(0),
      O => regular_expression_machine2_state_h_N_679
    );
  regular_expression_machine2_state_h_state_ns_157 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_676,
      ADR1 => regular_expression_machine2_state_h_state(2),
      ADR2 => regular_expression_machine2_state_h_N_562,
      ADR3 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_N_678
    );
  regular_expression_machine2_state_h_state_ns_155 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_N_557,
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_state_h_state_ns_256_505,
      ADR3 => regular_expression_machine2_state_h_N_571,
      O => regular_expression_machine2_state_h_N_676
    );
  regular_expression_machine2_state_h_state_ns_152 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_152_am,
      IB => regular_expression_machine2_state_h_state_ns_152_bm,
      O => regular_expression_machine2_state_h_N_673,
      SEL => regular_expression_machine2_state_h_state(2)
    );
  regular_expression_machine2_state_h_state_ns_152_bm_190 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regular_expression_machine2_state_ns_224_282,
      ADR3 => regular_expression_machine2_N_545,
      O => regular_expression_machine2_state_h_state_ns_152_bm
    );
  regular_expression_machine2_state_h_state_ns_152_am_191 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_540,
      ADR1 => regex_in_1(1),
      ADR2 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_state_ns_152_am
    );
  regular_expression_machine2_state_h_state_ns_145 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_145_am,
      IB => regular_expression_machine2_state_h_state_ns_145_bm,
      O => regular_expression_machine2_N_668,
      SEL => regex_in_2_4_Q
    );
  regular_expression_machine2_state_h_state_ns_145_bm_192 : X_LUT4
    generic map(
      INIT => X"E444"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine2_state_h_N_666,
      ADR2 => regular_expression_machine2_state_h_state_ns_286_504,
      ADR3 => regular_expression_machine2_state_h_N_633,
      O => regular_expression_machine2_state_h_state_ns_145_bm
    );
  regular_expression_machine2_state_h_state_ns_145_am_193 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine2_state_h_N_657,
      ADR2 => regular_expression_machine2_state_h_N_649,
      O => regular_expression_machine2_state_h_state_ns_145_am
    );
  regular_expression_machine2_state_h_state_ns_134 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_569,
      ADR1 => regular_expression_machine2_state_h_N_656,
      ADR2 => regex_in_1(0),
      O => regular_expression_machine2_state_h_N_657
    );
  regular_expression_machine2_state_h_state_ns_133 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_133_am,
      IB => regular_expression_machine2_state_h_state_ns_133_bm,
      O => regular_expression_machine2_state_h_N_656,
      SEL => regular_expression_machine2_state_h_state(2)
    );
  regular_expression_machine2_state_h_state_ns_133_am_194 : X_LUT4
    generic map(
      INIT => X"E444"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(1),
      ADR1 => regular_expression_machine2_state_h_N_617,
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine2_state_h_N_575,
      O => regular_expression_machine2_state_h_state_ns_133_am
    );
  regular_expression_machine2_state_h_state_ns_128 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_617,
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_state_h_N_575,
      ADR3 => regex_in_1(1),
      O => regular_expression_machine2_state_h_N_651
    );
  regular_expression_machine2_state_h_state_ns_121 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_599,
      ADR1 => regular_expression_machine2_state_h_N_643,
      ADR2 => regex_in_1(1),
      O => regular_expression_machine2_state_h_N_644
    );
  regular_expression_machine2_state_h_state_ns_113 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_632,
      ADR1 => regex_in_0(3),
      ADR2 => regular_expression_machine2_state_h_state_ns_286_504,
      ADR3 => regular_expression_machine2_state_h_N_633,
      O => regular_expression_machine2_state_h_N_638
    );
  regular_expression_machine2_state_h_state_ns_108 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_state_h_state_ns_218_274,
      ADR2 => regular_expression_machine2_N_829,
      O => regular_expression_machine2_state_h_N_633
    );
  regular_expression_machine2_state_h_state_ns_102 : X_LUT4
    generic map(
      INIT => X"EEE2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_613,
      ADR1 => regex_in_0(3),
      ADR2 => regular_expression_machine2_state_h_state_ns_101_0_623,
      ADR3 => regular_expression_machine2_state_h_N_820,
      O => regular_expression_machine2_state_h_N_760
    );
  regular_expression_machine2_state_h_state_ns_97 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_state_h_state(4),
      ADR2 => regular_expression_machine2_N_832,
      ADR3 => regular_expression_machine2_state_h_N_818,
      O => regular_expression_machine2_state_h_N_622
    );
  regular_expression_machine2_state_h_state_ns_75 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_599,
      ADR1 => regular_expression_machine2_state_h_N_540,
      ADR2 => regex_in_1(1),
      O => regular_expression_machine2_N_600
    );
  regular_expression_machine2_state_h_state_ns_74 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine2_N_545,
      ADR1 => regular_expression_machine2_state_h_state(3),
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regular_expression_machine2_state_h_state(0),
      O => regular_expression_machine2_state_h_N_599
    );
  regular_expression_machine2_state_h_state_ns_69 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_592,
      ADR1 => regex_in_2_4_Q,
      ADR2 => regular_expression_machine2_N_595_1,
      ADR3 => regex_in_1(0),
      O => regular_expression_machine2_N_596
    );
  regular_expression_machine2_state_h_state_ns_65 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_65_am,
      IB => regular_expression_machine2_state_h_state_ns_65_bm,
      O => regular_expression_machine2_state_h_N_592,
      SEL => regex_in_0(3)
    );
  regular_expression_machine2_state_h_state_ns_65_bm_195 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine2_state_h_N_590,
      ADR2 => regular_expression_machine2_state_h_N_569,
      O => regular_expression_machine2_state_h_state_ns_65_bm
    );
  regular_expression_machine2_state_h_state_ns_65_am_196 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine2_state_h_N_563,
      ADR2 => regular_expression_machine2_state_h_N_551,
      O => regular_expression_machine2_state_h_state_ns_65_am
    );
  regular_expression_machine2_state_h_state_ns_63 : X_LUT4
    generic map(
      INIT => X"BBB8"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_589,
      ADR1 => regular_expression_machine2_state_h_state(2),
      ADR2 => regular_expression_machine2_state_h_N_815,
      ADR3 => regular_expression_machine2_state_h_N_814,
      O => regular_expression_machine2_state_h_N_590
    );
  regular_expression_machine2_state_h_state_ns_62 : X_MUX2
    port map (
      IA => regular_expression_machine2_state_h_state_ns_62_am,
      IB => regular_expression_machine2_state_h_state_ns_62_bm,
      O => regular_expression_machine2_state_h_N_589,
      SEL => regex_in_1(1)
    );
  regular_expression_machine2_state_h_state_ns_62_am_197 : X_LUT4
    generic map(
      INIT => X"EC4C"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(1),
      ADR1 => regular_expression_machine2_N_827,
      ADR2 => regular_expression_machine2_state_h_N_732,
      ADR3 => regular_expression_machine2_G_76_fast,
      O => regular_expression_machine2_state_h_state_ns_62_am
    );
  regular_expression_machine2_state_h_state_ns_42 : X_LUT4
    generic map(
      INIT => X"E222"
    )
    port map (
      ADR0 => regular_expression_machine2_N_847,
      ADR1 => regular_expression_machine2_state_h_state(2),
      ADR2 => regular_expression_machine2_state_h_state_ns_266_0_and2_496,
      ADR3 => regular_expression_machine2_N_840,
      O => regular_expression_machine2_state_h_N_569
    );
  regular_expression_machine2_state_h_state_ns_31 : X_LUT4
    generic map(
      INIT => X"B888"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_562,
      ADR1 => regular_expression_machine2_state_h_state(2),
      ADR2 => regular_expression_machine2_N_557,
      ADR3 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_N_563
    );
  regular_expression_machine2_state_h_state_ns_19 : X_LUT4
    generic map(
      INIT => X"B888"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_550,
      ADR1 => regular_expression_machine2_state_h_state(2),
      ADR2 => regular_expression_machine2_state_h_state_ns_260_572,
      ADR3 => regular_expression_machine2_state_h_N_540,
      O => regular_expression_machine2_state_h_N_551
    );
  regular_expression_machine2_state_h_state_ns_212 : X_LUT4
    generic map(
      INIT => X"0004"
    )
    port map (
      ADR0 => regex_in_1(2),
      ADR1 => regex_in_0(5),
      ADR2 => regex_in(6),
      ADR3 => regex_in(7),
      O => regular_expression_machine2_N_545
    );
  regular_expression_machine2_state_h_state_ns_262 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_274_0_and2_552,
      ADR1 => regular_expression_machine2_N_545,
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regular_expression_machine2_state_h_state(0),
      O => regular_expression_machine2_state_h_N_550
    );
  regular_expression_machine2_state_h_state_ns_252 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine2_N_829,
      ADR1 => regular_expression_machine2_state_h_state_ns_47_0_and2_s,
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_h_N_660
    );
  regular_expression_machine2_state_h_state_ns_242 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine2_N_840,
      ADR1 => regular_expression_machine2_state_h_state(4),
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_h_N_562
    );
  regular_expression_machine2_state_h_state_ns_240 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_218_274,
      ADR1 => regular_expression_machine2_N_829,
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_N_557
    );
  regular_expression_machine2_state_h_state_ns_284 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_630,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine2_state_h_state(2),
      O => regular_expression_machine2_state_h_N_632
    );
  regular_expression_machine2_state_h_state_ns_101_0_and2 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_101_0_and2_601,
      ADR1 => regex_in_1(1),
      ADR2 => regular_expression_machine2_state_h_N_587,
      ADR3 => regular_expression_machine2_state_h_N_622,
      O => regular_expression_machine2_state_h_N_820
    );
  regular_expression_machine2_state_h_state_ns_101_0_and2_2 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine2_N_847,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine2_state_h_state(2),
      O => regular_expression_machine2_state_h_N_823
    );
  regular_expression_machine2_state_h_state_ns_218_273_198 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regular_expression_machine2_state_h_state(4),
      O => regular_expression_machine2_state_h_state_ns_218_273
    );
  regular_expression_machine2_state_h_state_ns_218_274_199 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_218_273,
      ADR1 => regex_in_0(5),
      O => regular_expression_machine2_state_h_state_ns_218_274
    );
  regular_expression_machine2_state_h_state_ns_224_282 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(0),
      ADR1 => regular_expression_machine2_state_h_state(4),
      O => regular_expression_machine2_state_ns_224_282
    );
  regular_expression_machine2_state_h_state_ns_230_475_200 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(4),
      ADR1 => regular_expression_machine2_state_h_state(3),
      O => regular_expression_machine2_state_h_state_ns_230_475
    );
  regular_expression_machine2_state_h_state_ns_266_0_and2_496_201 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regular_expression_machine2_state_h_state(4),
      ADR3 => regex_in_0(1),
      O => regular_expression_machine2_state_h_state_ns_266_0_and2_496
    );
  regular_expression_machine2_state_h_state_ns_286_502_202 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_state_ns_286_502
    );
  regular_expression_machine2_state_h_state_ns_286_504_203 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_0(1),
      ADR2 => regular_expression_machine2_state_h_state_ns_286_502,
      O => regular_expression_machine2_state_h_state_ns_286_504
    );
  regular_expression_machine2_state_h_state_ns_256_505_204 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regex_in_0(1),
      O => regular_expression_machine2_state_h_state_ns_256_505
    );
  regular_expression_machine2_state_h_state_ns_274_0_and2_552_205 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(3),
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regex_in_0(1),
      O => regular_expression_machine2_state_h_state_ns_274_0_and2_552
    );
  regular_expression_machine2_state_h_state_ns_260_572_206 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(1),
      ADR1 => regex_in_0(1),
      O => regular_expression_machine2_state_h_state_ns_260_572
    );
  regular_expression_machine2_state_h_state_ns_101_0_and2_0_599_207 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_state(1),
      O => regular_expression_machine2_state_h_state_ns_101_0_and2_0_599
    );
  regular_expression_machine2_state_h_state_ns_101_0_and2_601_208 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regex_in_0(0),
      O => regular_expression_machine2_state_h_state_ns_101_0_and2_601
    );
  regular_expression_machine2_state_h_state_ns_88_0_and2_0_602_209 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state(2),
      ADR1 => regular_expression_machine2_state_h_state(1),
      ADR2 => regex_in_0(1),
      O => regular_expression_machine2_state_h_state_ns_88_0_and2_0_602
    );
  regular_expression_machine2_state_h_state_ns_101_0_622_210 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_N_823,
      ADR1 => regular_expression_machine2_N_841,
      ADR2 => regex_in_0(0),
      ADR3 => regular_expression_machine2_N_844,
      O => regular_expression_machine2_state_h_state_ns_101_0_622
    );
  regular_expression_machine2_state_h_state_ns_101_0_623_211 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine2_state_h_state_ns_101_0_622,
      ADR1 => regular_expression_machine2_state_h_N_617,
      ADR2 => regex_in_0(0),
      ADR3 => regular_expression_machine2_state_h_state_ns_101_0_and2_0_599,
      O => regular_expression_machine2_state_h_state_ns_101_0_623
    );
  regular_expression_machine2_state_h_state_ns_47_0_and2_s_212 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine2_state_h_state(0),
      ADR2 => regular_expression_machine2_state_h_state(4),
      O => regular_expression_machine2_state_h_state_ns_47_0_and2_s
    );
  regular_expression_machine2_state_h_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_730,
      O => regular_expression_machine2_state_h_state(1),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine2_state_h_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_731,
      O => regular_expression_machine2_state_h_state(2),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine2_state_h_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_732,
      O => regular_expression_machine2_state_h_state(3),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine2_state_h_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_733,
      O => regular_expression_machine2_state_h_state(4),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine2_state_h_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_734,
      O => regular_expression_machine2_state_h_state(0),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_Q : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_1(12),
      ADR1 => regular_expression_machine3_N_360,
      ADR2 => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_428,
      ADR3 => regex_in_2_1_Q,
      O => regular_expression_machine3_N_390
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_2_1_12_Q : X_LUT4
    generic map(
      INIT => X"8900"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regex_in_2_2_Q,
      ADR2 => regular_expression_machine3_N_366,
      ADR3 => regular_expression_machine3_G_238_1_0,
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_1(12)
    );
  regular_expression_machine3_G_238_1_0_213 : X_LUT4
    generic map(
      INIT => X"1B11"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regular_expression_machine3_state(4),
      ADR2 => regular_expression_machine3_state(3),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine3_G_238_1_0
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_0_12_346_214 : X_LUT3
    generic map(
      INIT => X"51"
    )
    port map (
      ADR0 => regular_expression_machine3_N_362,
      ADR1 => regular_expression_machine3_state(14),
      ADR2 => regular_expression_machine3_state(0),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_0_12_346
    );
  regular_expression_machine3_G_249 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine3_state(1),
      ADR1 => regular_expression_machine3_state(0),
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine3_N_375
    );
  regular_expression_machine3_G_221 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regex_in(6),
      O => regular_expression_machine3_N_423
    );
  regular_expression_machine3_G_234 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regex_in(7),
      O => regular_expression_machine3_N_360
    );
  regular_expression_machine3_G_235 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regular_expression_machine3_N_360,
      O => regular_expression_machine3_N_361
    );
  regular_expression_machine3_un1_state_33_0_and2_0_and2_1 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regular_expression_machine1_N_491_3,
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine3_N_401_1
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_3_12_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regular_expression_machine3_N_391_1,
      O => regular_expression_machine3_N_391
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_3_1_12_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regular_expression_machine3_N_418,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine3_state(10),
      ADR3 => regular_expression_machine3_state(11),
      O => regular_expression_machine3_N_391_1
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_6_1_12_Q : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine3_N_418,
      ADR1 => regular_expression_machine3_N_366,
      O => regular_expression_machine3_N_394_1
    );
  regular_expression_machine3_un1_state_62_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine3_state(2),
      ADR1 => regular_expression_machine1_N_491_3,
      ADR2 => regular_expression_machine3_N_418,
      O => regular_expression_machine3_N_403
    );
  regular_expression_machine3_G_230_5 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine3_state(9),
      ADR1 => regular_expression_machine3_state(5),
      ADR2 => regular_expression_machine3_state(15),
      ADR3 => regular_expression_machine3_state(12),
      O => regular_expression_machine3_N_390_6
    );
  regular_expression_machine3_nxt_state_31_i_0_0_or2_0_Q : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_426,
      ADR2 => regular_expression_machine3_G_230_158,
      ADR3 => regular_expression_machine3_G_230_157,
      O => regular_expression_machine3_N_385
    );
  regular_expression_machine3_G_49_i_0_or2 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regex_in_2_4_Q,
      O => regular_expression_machine3_N_366
    );
  regular_expression_machine3_G_236 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in_2_4_Q,
      O => regular_expression_machine3_N_362
    );
  regular_expression_machine3_G_233 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => regular_expression_machine3_state(7),
      ADR1 => regular_expression_machine3_state(8),
      ADR2 => regex_in_1(5),
      O => regular_expression_machine3_N_359
    );
  regular_expression_machine3_nxt_state_31_0_0_13_Q : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => regular_expression_machine3_N_391_1,
      ADR1 => regular_expression_machine0_N_907_2,
      ADR2 => regular_expression_machine3_N_393_3,
      ADR3 => regular_expression_machine3_N_420,
      O => regular_expression_machine3_nxt_state_31_13_Q
    );
  regular_expression_machine3_G_227 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine3_state(5),
      O => regular_expression_machine3_N_429
    );
  regular_expression_machine3_G_225 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine3_state(6),
      O => regular_expression_machine3_N_427
    );
  regular_expression_machine3_G_224 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine3_state(6),
      ADR1 => regular_expression_machine3_state(10),
      O => regular_expression_machine3_N_426
    );
  regular_expression_machine3_G_222 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine3_state(0),
      ADR1 => regular_expression_machine3_state(2),
      O => regular_expression_machine3_N_424
    );
  regular_expression_machine3_G_218 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine0_N_920_1,
      O => regular_expression_machine3_N_420
    );
  regular_expression_machine3_G_217_215 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine3_state(13),
      ADR1 => regular_expression_machine3_state(14),
      O => regular_expression_machine3_G_217
    );
  regular_expression_machine3_G_216 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine3_N_414,
      O => regular_expression_machine3_N_418
    );
  regular_expression_machine3_G_212 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine3_N_361,
      O => regular_expression_machine3_N_414
    );
  regular_expression_machine3_nxt_state_31_0_and2_0_and2_5_Q : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine3_N_418,
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine3_state(4),
      O => regular_expression_machine3_nxt_state_31_5_Q
    );
  regular_expression_machine3_un1_state_70_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine6_N_339_1,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine3_state(0),
      O => regular_expression_machine3_N_405
    );
  regular_expression_machine3_un1_state_63_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine6_N_341_1,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine3_state(1),
      O => regular_expression_machine3_N_404
    );
  regular_expression_machine3_un1_state_49_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine1_N_491_3,
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine3_N_360,
      ADR3 => regular_expression_machine3_un1_state_49_0_and2_0_and2_500,
      O => regular_expression_machine3_N_402
    );
  regular_expression_machine3_un1_state_38_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine3_N_401_1,
      ADR1 => regular_expression_machine3_N_423,
      ADR2 => regular_expression_machine3_N_429,
      O => regular_expression_machine3_N_401
    );
  regular_expression_machine3_un1_state_33_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine3_N_401_1,
      ADR1 => regular_expression_machine3_N_423,
      ADR2 => regular_expression_machine3_N_427,
      O => regular_expression_machine3_N_400
    );
  regular_expression_machine3_un1_state_30_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine3_N_420,
      ADR1 => regular_expression_machine3_N_414,
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine3_state(7),
      O => regular_expression_machine3_N_399
    );
  regular_expression_machine3_un1_state_26_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine3_N_420,
      ADR1 => regular_expression_machine3_N_414,
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine3_state(8),
      O => regular_expression_machine3_N_398
    );
  regular_expression_machine3_nxt_state_31_0_0_and2_0_3_13_Q : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regular_expression_machine3_N_361,
      ADR1 => regex_in_1(2),
      ADR2 => regex_in_0(5),
      ADR3 => regular_expression_machine3_state(9),
      O => regular_expression_machine3_N_393_3
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_12_Q : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine3_N_361,
      ADR1 => regular_expression_machine1_N_491_3,
      ADR2 => regular_expression_machine3_N_375,
      ADR3 => regex_in_0(0),
      O => regular_expression_machine3_N_387
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_1_12_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine3_nxt_state_31_i_0_0_and2_1_12_450,
      ADR1 => regular_expression_machine1_N_491_3,
      ADR2 => regex_in_1(2),
      O => regular_expression_machine3_N_389
    );
  regular_expression_machine3_G_230_157_216 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine3_state(7),
      ADR1 => regular_expression_machine3_state(3),
      ADR2 => regular_expression_machine3_state(4),
      O => regular_expression_machine3_G_230_157
    );
  regular_expression_machine3_G_230_158_217 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine3_state(8),
      ADR1 => regular_expression_machine3_state(13),
      ADR2 => regular_expression_machine3_state(2),
      ADR3 => regular_expression_machine3_state(0),
      O => regular_expression_machine3_G_230_158
    );
  regular_expression_machine3_G_47_i_0_415_218 : X_LUT4
    generic map(
      INIT => X"FFF7"
    )
    port map (
      ADR0 => regex_in_0(2),
      ADR1 => regex_in_0(1),
      ADR2 => regex_in_0(5),
      ADR3 => regex_in_1(4),
      O => regular_expression_machine3_G_47_i_0_415
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_424_219 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine3_state(8),
      ADR1 => regular_expression_machine3_state(7),
      ADR2 => regular_expression_machine3_state(14),
      ADR3 => regular_expression_machine3_state(13),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_424
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_426_220 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine3_N_390_6,
      ADR1 => regular_expression_machine3_N_426,
      ADR2 => regular_expression_machine3_state(11),
      ADR3 => regular_expression_machine3_state(1),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_426
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_428_221 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_426,
      ADR2 => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_424,
      ADR3 => regular_expression_machine3_N_424,
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_2_12_428
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_1_12_450_222 : X_LUT4
    generic map(
      INIT => X"00E0"
    )
    port map (
      ADR0 => regular_expression_machine3_N_429,
      ADR1 => regular_expression_machine3_N_427,
      ADR2 => regular_expression_machine3_N_423,
      ADR3 => regex_in(7),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_1_12_450
    );
  regular_expression_machine3_un1_state_49_0_and2_0_and2_500_223 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in(6),
      ADR2 => regular_expression_machine3_state(3),
      O => regular_expression_machine3_un1_state_49_0_and2_0_and2_500
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_516_224 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine3_state(3),
      ADR1 => regular_expression_machine3_state(4),
      ADR2 => regular_expression_machine3_state(9),
      ADR3 => regular_expression_machine3_state(5),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_516
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_519_225 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine3_N_424,
      ADR1 => regular_expression_machine3_N_426,
      ADR2 => regular_expression_machine3_state(15),
      ADR3 => regular_expression_machine3_state(12),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_519
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_520_226 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_516,
      ADR1 => regular_expression_machine3_G_217,
      ADR2 => regular_expression_machine3_state(11),
      ADR3 => regular_expression_machine3_state(1),
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_520
    );
  regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_523_227 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine3_N_420,
      ADR1 => regular_expression_machine3_N_359,
      ADR2 => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_520,
      ADR3 => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_519,
      O => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_523
    );
  regular_expression_machine3_nxt_state_31_i_0_0_12_624_228 : X_LUT4
    generic map(
      INIT => X"BAAA"
    )
    port map (
      ADR0 => regular_expression_machine3_N_390,
      ADR1 => regular_expression_machine3_N_361,
      ADR2 => regular_expression_machine3_N_388_1,
      ADR3 => regular_expression_machine3_nxt_state_31_i_0_0_and2_0_12_346,
      O => regular_expression_machine3_nxt_state_31_i_0_0_12_624
    );
  regular_expression_machine3_nxt_state_31_i_0_0_12_626_229 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => regular_expression_machine3_nxt_state_31_i_0_0_and2_4_12_523,
      ADR1 => regular_expression_machine3_N_414,
      ADR2 => regular_expression_machine3_nxt_state_31_i_0_0_12_624,
      ADR3 => regular_expression_machine3_N_387,
      O => regular_expression_machine3_nxt_state_31_i_0_0_12_626
    );
  regular_expression_machine3_nxt_state_31_i_0_0_12_627_230 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine3_nxt_state_31_i_0_0_12_626,
      ADR1 => regular_expression_machine3_N_389,
      ADR2 => regular_expression_machine3_N_393_3,
      ADR3 => regular_expression_machine0_N_920_1,
      O => regular_expression_machine3_nxt_state_31_i_0_0_12_627
    );
  regular_expression_machine3_N_43_i_231 : X_LUT4
    generic map(
      INIT => X"0111"
    )
    port map (
      ADR0 => regular_expression_machine3_N_391,
      ADR1 => regular_expression_machine3_nxt_state_31_i_0_0_12_627,
      ADR2 => regular_expression_machine3_N_394_1,
      ADR3 => regular_expression_machine3_state(2),
      O => regular_expression_machine3_N_43_i
    );
  regular_expression_machine3_N_251_i_232 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine3_N_361,
      ADR1 => regular_expression_machine3_G_47_i_0_415,
      ADR2 => regular_expression_machine3_N_385,
      O => regular_expression_machine3_N_251_i
    );
  regular_expression_machine3_N_253_i_233 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine2_N_595_1,
      ADR1 => regular_expression_machine3_N_366,
      ADR2 => regular_expression_machine3_N_385,
      O => regular_expression_machine3_N_253_i
    );
  regular_expression_machine3_N_131_i_234 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine7_N_374_1,
      ADR1 => regular_expression_machine3_N_385,
      ADR2 => regex_in_0(2),
      O => regular_expression_machine3_N_131_i
    );
  regular_expression_machine3_N_419_i_235 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine3_state(14),
      ADR1 => regular_expression_machine3_state(13),
      O => regular_expression_machine3_N_419_i
    );
  regular_expression_machine3_state_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine3_GND,
      O => regular_expression_machine3_state(14),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine3_GND,
      O => regular_expression_machine3_state(15),
      SSET => cntrlr_N_882_1_i_1,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  regular_expression_machine3_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_131_i,
      O => regular_expression_machine3_state(0),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_405,
      O => regular_expression_machine3_state(1),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_404,
      O => regular_expression_machine3_state(2),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_403,
      O => regular_expression_machine3_state(3),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_402,
      O => regular_expression_machine3_state(4),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_nxt_state_31_5_Q,
      O => regular_expression_machine3_state(5),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_401,
      O => regular_expression_machine3_state(6),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_253_i,
      O => regular_expression_machine3_state(7),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_251_i,
      O => regular_expression_machine3_state(8),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_400,
      O => regular_expression_machine3_state(9),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_399,
      O => regular_expression_machine3_state(10),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_398,
      O => regular_expression_machine3_state(11),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_N_43_i,
      O => regular_expression_machine3_state(12),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_state_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en,
      CLK => clk,
      I => regular_expression_machine3_nxt_state_31_13_Q,
      O => regular_expression_machine3_state(13),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regular_expression_machine3_N_419_i,
      CLK => clk,
      I => regular_expression_machine3_VCC,
      O => accepted(3),
      SRST => cntrlr_N_882_1_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine3_GND_236 : X_ZERO
    port map (
      O => regular_expression_machine3_GND
    );
  regular_expression_machine3_VCC_237 : X_ONE
    port map (
      O => regular_expression_machine3_VCC
    );
  regular_expression_machine4_G_295 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regex_in(6),
      O => regular_expression_machine4_N_514
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_12_16_Q : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine4_state(0),
      ADR1 => regular_expression_machine4_N_503,
      ADR2 => regular_expression_machine4_N_502,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine4_N_482
    );
  regular_expression_machine4_un1_state_21_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine4_state(11),
      ADR1 => regular_expression_machine6_N_340_2,
      ADR2 => regular_expression_machine6_N_340_1,
      O => regular_expression_machine4_N_486
    );
  regular_expression_machine4_un1_state_26_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine4_state(8),
      ADR1 => regular_expression_machine6_N_340_2,
      ADR2 => regular_expression_machine6_N_340_1,
      O => regular_expression_machine4_N_487
    );
  regular_expression_machine4_un1_state_56_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine4_state(13),
      ADR1 => regular_expression_machine6_N_329_1,
      ADR2 => regular_expression_machine4_N_502,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine4_N_493
    );
  regular_expression_machine4_un1_state_58_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine4_state(2),
      ADR1 => regular_expression_machine6_N_329_1,
      ADR2 => regular_expression_machine4_N_502,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine4_N_494
    );
  regular_expression_machine4_un1_state_68_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine4_state(12),
      ADR1 => regular_expression_machine4_N_503,
      ADR2 => regular_expression_machine4_N_502,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine4_N_495
    );
  regular_expression_machine4_G_299_3 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine4_N_513,
      ADR1 => regular_expression_machine4_G_284,
      O => regular_expression_machine4_N_473_4
    );
  regular_expression_machine4_nxt_state_39_i_0_0_1_11_Q : X_LUT3
    generic map(
      INIT => X"F7"
    )
    port map (
      ADR0 => regular_expression_machine6_N_329_1,
      ADR1 => regular_expression_machine1_N_561,
      ADR2 => regex_in_2_4_Q,
      O => regular_expression_machine4_N_131_1
    );
  regular_expression_machine4_un1_state_43_0_and2_0_and2_2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine4_N_503,
      ADR1 => regular_expression_machine1_N_561,
      ADR2 => regex_in_2_4_Q,
      O => regular_expression_machine4_N_492_2
    );
  regular_expression_machine4_G_319 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regular_expression_machine4_state(18),
      ADR1 => regular_expression_machine4_N_449,
      O => regular_expression_machine4_N_453
    );
  regular_expression_machine4_G_315 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine4_state(1),
      ADR1 => regular_expression_machine4_state(0),
      ADR2 => regular_expression_machine4_state(4),
      ADR3 => regular_expression_machine4_state(2),
      O => regular_expression_machine4_N_449
    );
  regular_expression_machine4_G_312 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine4_state(0),
      ADR1 => regular_expression_machine4_state(1),
      O => regular_expression_machine4_N_446
    );
  regular_expression_machine4_G_308 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine4_state(8),
      ADR1 => regular_expression_machine4_state(11),
      O => regular_expression_machine4_N_442
    );
  regular_expression_machine4_G_306 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine7_N_288_rep1,
      O => regular_expression_machine4_N_440
    );
  regular_expression_machine4_G_304 : X_LUT4
    generic map(
      INIT => X"111D"
    )
    port map (
      ADR0 => regular_expression_machine4_state(15),
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine4_state(12),
      ADR3 => regular_expression_machine4_state(0),
      O => regular_expression_machine4_N_438
    );
  regular_expression_machine4_G_302 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine4_N_496,
      ADR1 => regex_in_0(3),
      ADR2 => regular_expression_machine1_N_561,
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine4_N_436
    );
  regular_expression_machine4_nxt_state_39_0_0_17_Q : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => regular_expression_machine4_N_479,
      ADR1 => regular_expression_machine7_N_375_1,
      ADR2 => regular_expression_machine4_state(15),
      O => regular_expression_machine4_nxt_state_39(17)
    );
  regular_expression_machine4_G_297 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine4_state(5),
      ADR1 => regular_expression_machine4_state(13),
      O => regular_expression_machine4_N_516
    );
  regular_expression_machine4_G_284_238 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine4_state(17),
      ADR1 => regular_expression_machine4_state(18),
      O => regular_expression_machine4_G_284
    );
  regular_expression_machine4_G_283 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regex_in_0(3),
      O => regular_expression_machine4_N_503
    );
  regular_expression_machine4_G_282 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine4_N_501,
      O => regular_expression_machine4_N_502
    );
  regular_expression_machine4_G_281 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regular_expression_machine4_N_440,
      O => regular_expression_machine4_N_501
    );
  regular_expression_machine4_G_293 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine4_G_293_131,
      ADR1 => regular_expression_machine4_N_442,
      ADR2 => regular_expression_machine4_G_293_128,
      ADR3 => regular_expression_machine4_state(10),
      O => regular_expression_machine4_N_513
    );
  regular_expression_machine4_un1_state_46_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine4_N_492_2,
      ADR1 => regular_expression_machine4_N_514,
      ADR2 => regex_in(7),
      ADR3 => regular_expression_machine4_state(4),
      O => regular_expression_machine4_N_492
    );
  regular_expression_machine4_un1_state_43_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine4_N_492_2,
      ADR1 => regular_expression_machine4_N_514,
      ADR2 => regex_in(7),
      ADR3 => regular_expression_machine4_state(9),
      O => regular_expression_machine4_N_491
    );
  regular_expression_machine4_un1_state_40_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine4_N_502,
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine4_un1_state_40_0_and2_0_and2_556,
      ADR3 => regex_in_1(1),
      O => regular_expression_machine4_N_489
    );
  regular_expression_machine4_un1_state_33_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine4_N_501,
      ADR1 => regular_expression_machine1_N_433_i,
      ADR2 => regular_expression_machine6_N_329_1,
      ADR3 => regular_expression_machine4_state(6),
      O => regular_expression_machine4_N_488
    );
  regular_expression_machine4_un1_state_17_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine4_N_501,
      ADR1 => regular_expression_machine1_N_561,
      ADR2 => regular_expression_machine4_un1_state_17_0_and2_0_and2_401,
      ADR3 => regex_in_1(1),
      O => regular_expression_machine4_N_485
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_11_Q : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine4_N_513,
      ADR1 => regular_expression_machine4_N_449,
      ADR2 => regular_expression_machine4_nxt_state_39_i_0_0_and2_11_192,
      ADR3 => regular_expression_machine4_N_516,
      O => regular_expression_machine4_N_484
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_11_16_Q : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine6_N_311,
      ADR1 => regular_expression_machine1_N_433_i,
      ADR2 => regex_in_0(3),
      ADR3 => regular_expression_machine4_state(1),
      O => regular_expression_machine4_N_481
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_10_16_Q : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine4_N_503,
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_and2_10_16_351,
      ADR2 => regular_expression_machine1_N_433_i,
      ADR3 => regular_expression_machine4_N_440,
      O => regular_expression_machine4_N_480
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_9_16_Q : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine4_N_440,
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_and2_9_16_334,
      ADR2 => regular_expression_machine0_N_920_1,
      ADR3 => regular_expression_machine1_N_561,
      O => regular_expression_machine4_N_479
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_5_16_Q : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine4_N_501,
      ADR1 => regular_expression_machine6_N_329_1,
      ADR2 => regex_in_0(0),
      ADR3 => regular_expression_machine4_state(6),
      O => regular_expression_machine4_N_475
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_Q : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine4_N_502,
      ADR1 => regular_expression_machine4_N_438,
      ADR2 => regular_expression_machine4_N_503,
      ADR3 => regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_509,
      O => regular_expression_machine4_N_473
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_0_16_Q : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine4_N_436,
      ADR1 => regular_expression_machine7_N_288,
      ADR2 => regex_in_1(1),
      ADR3 => regular_expression_machine4_N_453,
      O => regular_expression_machine4_N_470
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_16_Q : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine1_N_561,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine4_nxt_state_39_i_0_0_and2_16_418,
      ADR3 => regular_expression_machine4_N_514,
      O => regular_expression_machine4_N_469
    );
  regular_expression_machine4_G_299 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine4_N_473_4,
      ADR1 => regular_expression_machine4_G_299_211,
      ADR2 => regular_expression_machine4_N_516,
      ADR3 => regular_expression_machine4_N_446,
      O => regular_expression_machine4_N_518
    );
  regular_expression_machine4_G_279 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_1(1),
      ADR2 => regular_expression_machine4_state(2),
      ADR3 => regular_expression_machine4_state(13),
      O => regular_expression_machine4_N_499
    );
  regular_expression_machine4_G_276 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine7_N_328,
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_1(5),
      ADR3 => regex_in_0(3),
      O => regular_expression_machine4_N_496
    );
  regular_expression_machine4_G_301 : X_LUT3
    generic map(
      INIT => X"FB"
    )
    port map (
      ADR0 => regular_expression_machine4_N_440,
      ADR1 => regex_in_0(0),
      ADR2 => regex_in_0(3),
      O => regular_expression_machine4_N_519
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_86_239 : X_LUT4
    generic map(
      INIT => X"AEAA"
    )
    port map (
      ADR0 => regular_expression_machine4_N_475,
      ADR1 => regular_expression_machine0_N_920_1,
      ADR2 => regular_expression_machine4_N_519,
      ADR3 => regular_expression_machine4_state(3),
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_86
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_87_240 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine4_N_482,
      ADR1 => regular_expression_machine4_N_502,
      ADR2 => regular_expression_machine6_N_329_1,
      ADR3 => regular_expression_machine4_nxt_state_39_i_0_0_and2_1_16_470,
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_87
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_88_241 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine4_N_481,
      ADR1 => regular_expression_machine4_N_479,
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_88
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_89_242 : X_LUT4
    generic map(
      INIT => X"ABAA"
    )
    port map (
      ADR0 => regular_expression_machine4_nxt_state_39_i_0_0_16_86,
      ADR1 => regular_expression_machine4_N_131_1,
      ADR2 => regular_expression_machine7_N_288,
      ADR3 => regular_expression_machine4_state(3),
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_89
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_90_243 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine4_N_480,
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_and2_6_16_445,
      ADR2 => regular_expression_machine4_N_501,
      ADR3 => regular_expression_machine6_N_329_1,
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_90
    );
  regular_expression_machine4_G_293_128_244 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine4_state(16),
      ADR1 => regular_expression_machine4_state(19),
      O => regular_expression_machine4_G_293_128
    );
  regular_expression_machine4_G_293_131_245 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine4_state(14),
      ADR1 => regular_expression_machine4_state(7),
      ADR2 => regular_expression_machine4_state(6),
      ADR3 => regular_expression_machine4_state(3),
      O => regular_expression_machine4_G_293_131
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_11_192_246 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine4_state(9),
      ADR1 => regular_expression_machine4_state(17),
      ADR2 => regular_expression_machine4_state(15),
      ADR3 => regular_expression_machine4_state(12),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_11_192
    );
  regular_expression_machine4_G_299_211_247 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine4_state(2),
      ADR1 => regular_expression_machine4_state(15),
      ADR2 => regular_expression_machine4_state(12),
      O => regular_expression_machine4_G_299_211
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_9_16_334_248 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine4_state(14),
      ADR1 => regex_in_0(3),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_9_16_334
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_7_16_342_249 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine1_N_561,
      ADR1 => regex_in_0(1),
      ADR2 => regular_expression_machine4_state(10),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_7_16_342
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_10_16_351_250 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine4_state(7),
      ADR1 => regex_in_1(4),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_10_16_351
    );
  regular_expression_machine4_un1_state_17_0_and2_0_and2_401_251 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine4_state(10),
      ADR1 => regex_in_0(3),
      O => regular_expression_machine4_un1_state_17_0_and2_0_and2_401
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_405_252 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine4_state(9),
      ADR1 => regular_expression_machine4_state(4),
      ADR2 => regular_expression_machine4_state(12),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_405
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_408_253 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine4_N_513,
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_405,
      ADR2 => regular_expression_machine4_N_446,
      ADR3 => regular_expression_machine4_G_284,
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_408
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_410_254 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_408,
      ADR2 => regular_expression_machine4_state(15),
      ADR3 => regex_in_0(2),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_410
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_411_255 : X_LUT4
    generic map(
      INIT => X"8A88"
    )
    port map (
      ADR0 => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_410,
      ADR1 => regular_expression_machine4_N_499,
      ADR2 => regular_expression_machine4_state(5),
      ADR3 => regex_in_0(1),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_411
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_16_418_256 : X_LUT4
    generic map(
      INIT => X"2220"
    )
    port map (
      ADR0 => regular_expression_machine4_N_503,
      ADR1 => regex_in(7),
      ADR2 => regular_expression_machine4_N_518,
      ADR3 => regular_expression_machine4_state(4),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_16_418
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_6_16_445_257 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine4_state(2),
      ADR1 => regex_in_0(2),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_6_16_445
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_1_16_470_258 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine4_N_442,
      ADR1 => regex_in_0(2),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_1_16_470
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_507_259 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine4_state(9),
      ADR1 => regular_expression_machine4_state(1),
      ADR2 => regular_expression_machine4_state(13),
      ADR3 => regular_expression_machine4_state(5),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_507
    );
  regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_509_260 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine4_N_473_4,
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_507,
      ADR2 => regular_expression_machine4_state(4),
      ADR3 => regular_expression_machine4_state(2),
      O => regular_expression_machine4_nxt_state_39_i_0_0_and2_3_16_509
    );
  regular_expression_machine4_un1_state_40_0_and2_0_and2_556_261 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine4_state(5),
      ADR1 => regex_in_0(3),
      O => regular_expression_machine4_un1_state_40_0_and2_0_and2_556
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_645_262 : X_LUT4
    generic map(
      INIT => X"FCF8"
    )
    port map (
      ADR0 => regular_expression_machine4_nxt_state_39_i_0_0_and2_2_16_411,
      ADR1 => regular_expression_machine4_N_501,
      ADR2 => regular_expression_machine4_N_469,
      ADR3 => regular_expression_machine4_nxt_state_39_i_0_0_and2_7_16_342,
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_645
    );
  regular_expression_machine4_nxt_state_39_i_0_0_16_648_263 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine4_nxt_state_39_i_0_0_16_645,
      ADR1 => regular_expression_machine4_N_473,
      ADR2 => regular_expression_machine4_nxt_state_39_i_0_0_16_90,
      ADR3 => regular_expression_machine4_N_470,
      O => regular_expression_machine4_nxt_state_39_i_0_0_16_648
    );
  regular_expression_machine4_N_51_i_264 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine4_nxt_state_39_i_0_0_16_88,
      ADR1 => regular_expression_machine4_nxt_state_39_i_0_0_16_87,
      ADR2 => regular_expression_machine4_nxt_state_39_i_0_0_16_648,
      ADR3 => regular_expression_machine4_nxt_state_39_i_0_0_16_89,
      O => regular_expression_machine4_N_51_i
    );
  regular_expression_machine4_N_131_i_265 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine4_N_131_1,
      ADR1 => regular_expression_machine7_N_288,
      ADR2 => regular_expression_machine4_N_484,
      O => regular_expression_machine4_N_131_i
    );
  regular_expression_machine4_N_423_i_266 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine0_N_920_1,
      ADR1 => regex_in_0(2),
      ADR2 => regular_expression_machine4_N_519,
      ADR3 => regular_expression_machine4_state(3),
      O => regular_expression_machine4_N_423_i
    );
  regular_expression_machine4_N_135_i_267 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine4_N_519,
      ADR1 => regular_expression_machine0_N_920_1,
      ADR2 => regex_in_0(2),
      ADR3 => regular_expression_machine4_N_484,
      O => regular_expression_machine4_N_135_i
    );
  regular_expression_machine4_N_504_i_268 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine4_state(18),
      ADR1 => regular_expression_machine4_state(17),
      O => regular_expression_machine4_N_504_i
    );
  regular_expression_machine4_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_488,
      O => regular_expression_machine4_state(7),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_480,
      O => regular_expression_machine4_state(8),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_487,
      O => regular_expression_machine4_state(9),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_491,
      O => regular_expression_machine4_state(10),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_131_i,
      O => regular_expression_machine4_state(11),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_485,
      O => regular_expression_machine4_state(12),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_486,
      O => regular_expression_machine4_state(13),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_495,
      O => regular_expression_machine4_state(14),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_493,
      O => regular_expression_machine4_state(15),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_51_i,
      O => regular_expression_machine4_state(16),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_nxt_state_39(17),
      O => regular_expression_machine4_state(17),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_GND,
      O => regular_expression_machine4_state(18),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_GND,
      O => regular_expression_machine4_state(19),
      SSET => cntrlr_N_882_1_i_1,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  regular_expression_machine4_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_135_i,
      O => regular_expression_machine4_state(0),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_482,
      O => regular_expression_machine4_state(1),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_481,
      O => regular_expression_machine4_state(2),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_494,
      O => regular_expression_machine4_state(3),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_423_i,
      O => regular_expression_machine4_state(4),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_492,
      O => regular_expression_machine4_state(5),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine4_N_489,
      O => regular_expression_machine4_state(6),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regular_expression_machine4_N_504_i,
      CLK => clk,
      I => regular_expression_machine4_VCC,
      O => accepted(4),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine4_GND_269 : X_ZERO
    port map (
      O => regular_expression_machine4_GND
    );
  regular_expression_machine4_VCC_270 : X_ONE
    port map (
      O => regular_expression_machine4_VCC
    );
  regular_expression_machine5_G_230 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_1(1),
      ADR2 => regex_in_1(2),
      O => regular_expression_machine5_N_1898
    );
  regular_expression_machine5_G_229_i : X_LUT3
    generic map(
      INIT => X"FB"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_N_1989
    );
  regular_expression_machine5_G_388 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      ADR3 => regular_expression_machine5_un10_state_1,
      O => regular_expression_machine5_N_2127
    );
  regular_expression_machine5_G_223 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_1(1),
      ADR2 => regex_in_1(2),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine5_N_1891
    );
  regular_expression_machine5_G_489 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_N_2243
    );
  regular_expression_machine5_G_209 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regex_in_2_1_Q,
      ADR2 => regex_in_1(2),
      O => regular_expression_machine5_N_1877
    );
  regular_expression_machine5_G_235 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regex_in_2_1_Q,
      ADR2 => regex_in_1(2),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine5_N_1903
    );
  regular_expression_machine5_G_223_fast_271 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_1(1),
      ADR2 => regex_in_1(2),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine5_G_223_fast
    );
  regular_expression_machine5_G_443_bm_272 : X_LUT4
    generic map(
      INIT => X"FFBA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_ns_184_0_653,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine5_N_1722,
      ADR3 => regular_expression_machine5_G_443_bm_sx,
      O => regular_expression_machine5_G_443_bm
    );
  regular_expression_machine5_G_443_bm_sx_273 : X_LUT3
    generic map(
      INIT => X"F8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1393,
      ADR1 => regular_expression_machine5_state_ns_184_0_and2_0_607,
      ADR2 => regular_expression_machine5_N_1805,
      O => regular_expression_machine5_G_443_bm_sx
    );
  regular_expression_machine5_G_439_bm_274 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_G_439_bm_1,
      ADR1 => regular_expression_machine5_state_ns_350_0_608,
      ADR2 => regular_expression_machine5_state_ns_184_0_and2_0_607,
      ADR3 => regular_expression_machine5_N_1564,
      O => regular_expression_machine5_G_439_bm
    );
  regular_expression_machine5_G_439_bm_1_275 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_ns_350_0_609,
      ADR1 => regular_expression_machine5_N_1298_3,
      ADR2 => regular_expression_machine5_N_2215,
      ADR3 => regular_expression_machine5_state_ns_350_0_and2_1_562,
      O => regular_expression_machine5_G_439_bm_1
    );
  regular_expression_machine5_G_249 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      O => regular_expression_machine5_N_1704
    );
  regular_expression_machine5_G_297 : X_LUT4
    generic map(
      INIT => X"8AAA"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine5_N_1718,
      ADR2 => regular_expression_machine5_state_ns_216_0_and2_136,
      ADR3 => regular_expression_machine5_N_2124,
      O => regular_expression_machine5_N_1752
    );
  regular_expression_machine5_G_377 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      O => regular_expression_machine5_N_1298_3
    );
  regular_expression_machine5_G_373 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regex_in(6),
      O => regular_expression_machine5_N_2113
    );
  regular_expression_machine5_G_379 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in(6),
      ADR1 => regular_expression_machine5_N_2114,
      O => regular_expression_machine5_N_2119
    );
  regular_expression_machine5_G_389 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_en_2,
      ADR1 => regex_in(7),
      O => regular_expression_machine5_N_2128
    );
  regular_expression_machine5_G_240 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      ADR2 => regex_in_2_5_Q,
      O => regular_expression_machine5_N_1908
    );
  regular_expression_machine5_G_376 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_N_2116
    );
  regular_expression_machine5_G_483 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      O => regular_expression_machine5_N_2237
    );
  regular_expression_machine5_G_493 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine5_G_485_s,
      O => regular_expression_machine5_N_1717_i
    );
  regular_expression_machine5_G_498 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_3_Q,
      ADR1 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_N_2196
    );
  regular_expression_machine5_next_state_un10_state_0_and2_1 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_un10_state_1
    );
  regular_expression_machine5_G_492 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine5_G_485_s,
      ADR2 => regular_expression_machine5_state_2_Q,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_N_2246
    );
  regular_expression_machine5_G_490 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      O => regular_expression_machine5_N_2244
    );
  regular_expression_machine5_G_488 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      O => regular_expression_machine5_N_2242
    );
  regular_expression_machine5_G_486 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_N_2240
    );
  regular_expression_machine5_G_482 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine5_state_4_Q,
      ADR2 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_N_2236
    );
  regular_expression_machine5_G_446 : X_LUT3
    generic map(
      INIT => X"35"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2127,
      ADR1 => regular_expression_machine5_N_2040_i,
      ADR2 => regular_expression_machine5_state_1_Q,
      O => regular_expression_machine5_N_2050
    );
  regular_expression_machine5_G_443 : X_MUX2
    port map (
      IA => regular_expression_machine5_G_443_am,
      IB => regular_expression_machine5_G_443_bm,
      O => regular_expression_machine5_N_2047,
      SEL => regex_in_0(3)
    );
  regular_expression_machine5_G_443_am_276 : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_ns_160_0_96,
      ADR1 => regular_expression_machine5_N_1733,
      ADR2 => regex_in_2_4_Q,
      O => regular_expression_machine5_G_443_am
    );
  regular_expression_machine5_G_440 : X_MUX2
    port map (
      IA => regular_expression_machine5_G_440_am,
      IB => regular_expression_machine5_G_440_bm,
      O => regular_expression_machine5_N_2044,
      SEL => regex_in_2_4_Q
    );
  regular_expression_machine5_G_440_bm_277 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1832_1,
      ADR1 => regular_expression_machine5_N_1854_1,
      ADR2 => regular_expression_machine5_N_1848,
      ADR3 => regular_expression_machine5_N_1847,
      O => regular_expression_machine5_G_440_bm
    );
  regular_expression_machine5_G_440_am_278 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine5_state_ns_296_0_641,
      ADR1 => regular_expression_machine5_N_1733,
      O => regular_expression_machine5_G_440_am
    );
  regular_expression_machine5_G_439 : X_MUX2
    port map (
      IA => regular_expression_machine5_G_439_am,
      IB => regular_expression_machine5_G_439_bm,
      O => regular_expression_machine5_N_2043,
      SEL => regex_in_0(3)
    );
  regular_expression_machine5_G_439_am_279 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_ns_337_0_666,
      ADR1 => regular_expression_machine5_N_1830,
      ADR2 => regular_expression_machine5_state_ns_337_0_663,
      ADR3 => regular_expression_machine5_N_1856,
      O => regular_expression_machine5_G_439_am
    );
  regular_expression_machine5_G_401 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine5_N_2242,
      ADR3 => regular_expression_machine7_N_365_1,
      O => regular_expression_machine5_N_2140
    );
  regular_expression_machine5_G_387 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2113,
      ADR1 => regular_expression_machine5_N_2111,
      O => regular_expression_machine5_N_2126
    );
  regular_expression_machine5_G_385 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_N_2124
    );
  regular_expression_machine5_G_374 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_en_2,
      ADR1 => regular_expression_machine5_N_2111,
      O => regular_expression_machine5_N_2114
    );
  regular_expression_machine5_G_371 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => regex_in(7),
      O => regular_expression_machine5_N_2111
    );
  regular_expression_machine5_G_286 : X_LUT4
    generic map(
      INIT => X"BFFF"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine5_state_ns_397_3_0_and2_267,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regex_in_1(5),
      O => regular_expression_machine5_N_1741
    );
  regular_expression_machine5_G_283 : X_LUT4
    generic map(
      INIT => X"2AAA"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine5_N_1298_3,
      ADR2 => regular_expression_machine5_state_ns_216_0_and2_136,
      ADR3 => regular_expression_machine5_N_2124,
      O => regular_expression_machine5_N_1738
    );
  regular_expression_machine5_G_277 : X_LUT4
    generic map(
      INIT => X"BBBA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2074,
      ADR1 => regular_expression_machine5_state_0_Q,
      ADR2 => regular_expression_machine5_state_ns_236_i_546,
      ADR3 => regular_expression_machine5_N_2225,
      O => regular_expression_machine5_N_1732
    );
  regular_expression_machine5_G_263 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => regular_expression_machine5_state_1_Q,
      ADR1 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_N_1718
    );
  regular_expression_machine5_G_255 : X_LUT4
    generic map(
      INIT => X"AEAA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1868,
      ADR1 => regular_expression_machine5_N_1908,
      ADR2 => regular_expression_machine5_N_1707,
      ADR3 => regular_expression_machine5_state_ns_265_0_and2_1_373,
      O => regular_expression_machine5_N_1710
    );
  regular_expression_machine5_G_252 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regex_in_0(0),
      O => regular_expression_machine5_N_1707
    );
  regular_expression_machine5_G_244 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1704,
      ADR1 => regex_in_2_4_Q,
      ADR2 => regex_in_1(2),
      O => regular_expression_machine5_N_1912
    );
  regular_expression_machine5_G_227 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regex_in_1(2),
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine5_state_ns_435_0_and2_255,
      O => regular_expression_machine5_N_1895
    );
  regular_expression_machine5_next_state_un10_state_0_and2 : X_LUT4
    generic map(
      INIT => X"9000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_3_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      ADR2 => regular_expression_machine5_N_2242,
      ADR3 => regular_expression_machine5_un10_state_1,
      O => regular_expression_machine5_un10_state
    );
  regular_expression_machine5_G_216 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2215,
      ADR1 => regular_expression_machine5_N_1704,
      ADR2 => regex_in_1(4),
      ADR3 => regex_in_1(2),
      O => regular_expression_machine5_N_1884
    );
  regular_expression_machine5_G_215 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2208,
      ADR1 => regular_expression_machine5_state_0_Q,
      ADR2 => regex_in_1(4),
      ADR3 => regex_in_1(2),
      O => regular_expression_machine5_N_1883
    );
  regular_expression_machine5_G_211 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2127,
      ADR1 => regular_expression_machine5_N_1877,
      ADR2 => regular_expression_machine5_N_2242,
      O => regular_expression_machine5_N_1879
    );
  regular_expression_machine5_G_200 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2240,
      ADR1 => regular_expression_machine5_N_2196,
      ADR2 => regular_expression_machine6_N_271_2,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_N_1868
    );
  regular_expression_machine5_G_236_i : X_LUT3
    generic map(
      INIT => X"DF"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2237,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_N_1993
    );
  regular_expression_machine5_G_226_455_280 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regex_in_0(2),
      ADR2 => regular_expression_machine5_N_2242,
      O => regular_expression_machine5_G_226_455
    );
  regular_expression_machine5_G_484_s_281 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regular_expression_machine5_state_2_Q,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_G_484_s
    );
  regular_expression_machine5_G_485_s_282 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      O => regular_expression_machine5_G_485_s
    );
  regular_expression_machine5_G_487_s_283 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      ADR2 => regular_expression_machine5_state_2_Q,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_G_487_s
    );
  regular_expression_machine5_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => regular_expression_machine5_un10_state,
      O => accepted(5),
      SRST => cntrlr_N_882_1_i_2,
      SSET => accepted(5),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine5_state_h_state_ns_184_0_653 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_184_0_653_1_0,
      ADR1 => regular_expression_machine5_N_1993,
      ADR2 => regular_expression_machine5_N_1912,
      ADR3 => regular_expression_machine6_N_271_2,
      O => regular_expression_machine5_state_ns_184_0_653
    );
  regular_expression_machine5_state_h_state_ns_184_0_653_1_0_284 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_184_0_653_1,
      ADR1 => regular_expression_machine5_N_2244,
      ADR2 => regular_expression_machine5_N_1891,
      ADR3 => regular_expression_machine5_N_2040_i,
      O => regular_expression_machine5_state_h_state_ns_184_0_653_1_0
    );
  regular_expression_machine5_state_h_state_ns_279_0_and2 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine5_state_h_state_ns_279_0_and2_sx,
      O => regular_expression_machine5_N_2074
    );
  regular_expression_machine5_state_h_state_ns_279_0_and2_sx_285 : X_LUT4
    generic map(
      INIT => X"BFFF"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1704,
      ADR1 => regular_expression_machine5_N_2196,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_state_h_state_ns_279_0_and2_sx
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx_286 : X_LUT4
    generic map(
      INIT => X"FF5D"
    )
    port map (
      ADR0 => regex_in_1(4),
      ADR1 => regex_in_1(2),
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx_sx,
      O => regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx_sx_287 : X_LUT4
    generic map(
      INIT => X"1DDD"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_157_0_and2_252,
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine5_state_h_state_ns_157_0_and2_0_359,
      ADR3 => regular_expression_machine5_G_484_s,
      O => regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx_sx
    );
  regular_expression_machine5_state_h_state_ns_84_i_and2 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_1(5),
      ADR1 => regular_expression_machine5_state_h_state_ns_84_i_and2_sx,
      O => regular_expression_machine5_N_2040_i
    );
  regular_expression_machine5_state_h_state_ns_84_i_and2_sx_288 : X_LUT4
    generic map(
      INIT => X"7FFF"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_3_Q,
      ADR1 => regular_expression_machine5_state_2_Q,
      ADR2 => regular_expression_machine5_state_h_state_5_Q,
      ADR3 => regular_expression_machine5_state_4_Q,
      O => regular_expression_machine5_state_h_state_ns_84_i_and2_sx
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_5 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1912,
      ADR1 => regular_expression_machine6_N_271_2,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      ADR3 => regular_expression_machine5_N_1717_i,
      O => regular_expression_machine5_state_h_N_1841
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_3 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regular_expression_machine5_state_h_state_ns_160_0_and2_3_sx,
      O => regular_expression_machine5_state_h_N_1798
    );
  regular_expression_machine5_state_h_state_ns_77_0_and2 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine5_N_2116,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_N_2215
    );
  regular_expression_machine5_state_h_state_ns_97_i_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_4_Q,
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_state_h_N_2219
    );
  regular_expression_machine5_state_h_state_ns_283_0 : X_LUT4
    generic map(
      INIT => X"FFEC"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_ns_283_0_80,
      ADR2 => regular_expression_machine5_state_h_state_ns_283_0_83_1,
      ADR3 => regular_expression_machine5_state_h_state_ns_283_0_sx,
      O => regular_expression_machine5_state_h_N_1511
    );
  regular_expression_machine5_state_h_state_ns_283_0_sx_289 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1840,
      ADR1 => regular_expression_machine5_state_h_N_1838,
      ADR2 => regular_expression_machine5_state_h_N_1841,
      ADR3 => regular_expression_machine5_state_h_N_1837,
      O => regular_expression_machine5_state_h_state_ns_283_0_sx
    );
  regular_expression_machine5_state_h_state_ns_265_0_674_290 : X_LUT4
    generic map(
      INIT => X"FEFC"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_265_0_674_1,
      ADR1 => regular_expression_machine5_state_h_N_1831,
      ADR2 => regular_expression_machine5_state_h_N_1798,
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine5_state_h_state_ns_265_0_674
    );
  regular_expression_machine5_state_h_state_ns_265_0_674_1_291 : X_LUT4
    generic map(
      INIT => X"F444"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1738,
      ADR1 => regular_expression_machine5_N_1877,
      ADR2 => regular_expression_machine7_N_367_1,
      ADR3 => regular_expression_machine5_state_h_N_1303,
      O => regular_expression_machine5_state_h_state_ns_265_0_674_1
    );
  regular_expression_machine5_state_h_state_ns_184_0_653_1_292 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1807,
      ADR1 => regular_expression_machine5_state_h_N_2102_1,
      ADR2 => regular_expression_machine5_N_1898,
      ADR3 => regular_expression_machine5_state_h_N_2057_2,
      O => regular_expression_machine5_state_h_state_ns_184_0_653_1
    );
  regular_expression_machine5_state_h_state_ns_102_i_633_293 : X_LUT4
    generic map(
      INIT => X"FCFE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_102_i_633_1_0,
      ADR1 => regular_expression_machine5_state_h_state_ns_102_i_76,
      ADR2 => regular_expression_machine5_state_h_state_ns_102_i_633_1,
      ADR3 => regular_expression_machine6_N_271_2,
      O => regular_expression_machine5_state_h_state_ns_102_i_633
    );
  regular_expression_machine5_state_h_state_ns_102_i_633_1_0_294 : X_LUT4
    generic map(
      INIT => X"222F"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2242,
      ADR1 => regular_expression_machine5_N_2127,
      ADR2 => regular_expression_machine5_N_1704,
      ADR3 => regular_expression_machine5_state_h_N_2219,
      O => regular_expression_machine5_state_h_state_ns_102_i_633_1_0
    );
  regular_expression_machine5_state_h_state_ns_102_i_633_1_295 : X_LUT4
    generic map(
      INIT => X"5D08"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_ns_102_i_and2_7_391,
      ADR2 => regular_expression_machine5_N_1989,
      ADR3 => regular_expression_machine5_N_1718,
      O => regular_expression_machine5_state_h_state_ns_102_i_633_1
    );
  regular_expression_machine5_state_h_state_ns_283_0_83_1_296 : X_LUT4
    generic map(
      INIT => X"5444"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regular_expression_machine5_state_h_state_ns_283_0_and2_3_279,
      ADR2 => regex_in_1(0),
      ADR3 => regular_expression_machine5_state_h_N_1507,
      O => regular_expression_machine5_state_h_state_ns_283_0_83_1
    );
  regular_expression_machine5_state_h_state_ns_102_i : X_LUT4
    generic map(
      INIT => X"EFEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_102_i_1,
      ADR1 => regular_expression_machine5_state_h_state_ns_102_i_634,
      ADR2 => regular_expression_machine5_state_h_N_2063,
      ADR3 => regular_expression_machine3_N_388_1,
      O => regular_expression_machine5_state_h_N_1671
    );
  regular_expression_machine5_state_h_state_ns_102_i_1_297 : X_LUT4
    generic map(
      INIT => X"0415"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine5_state_0_Q,
      ADR2 => regular_expression_machine5_state_h_N_2156,
      ADR3 => regular_expression_machine5_N_2215,
      O => regular_expression_machine5_state_h_state_ns_102_i_1
    );
  regular_expression_machine5_state_h_state_ns_222_0_and2_0 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regular_expression_machine5_state_h_N_2222,
      ADR2 => regular_expression_machine5_state_h_N_2229,
      O => regular_expression_machine5_state_h_N_1816
    );
  regular_expression_machine5_state_h_state_ns_212_0_and2 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_2_Q,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2070
    );
  regular_expression_machine5_state_h_state_ns_206_0 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2225,
      ADR1 => regular_expression_machine5_N_2240,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      ADR3 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_state_h_N_1436
    );
  regular_expression_machine5_state_h_state_ns_62_0 : X_LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine5_state_h_N_2070,
      ADR2 => regular_expression_machine5_state_h_N_2212,
      ADR3 => regular_expression_machine5_state_h_N_2213,
      O => regular_expression_machine5_state_h_N_1303
    );
  regular_expression_machine5_state_h_state_ns_70_i_and2_1 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regular_expression_machine5_state_h_N_2222,
      ADR2 => regular_expression_machine5_state_h_N_2229,
      O => regular_expression_machine5_state_h_N_1774
    );
  regular_expression_machine5_state_h_state_ns_162_0 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2063,
      ADR1 => regular_expression_machine5_N_1704,
      ADR2 => regular_expression_machine5_N_2236,
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_N_1393
    );
  regular_expression_machine5_state_h_state_ns_50_0 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2210,
      ADR1 => regular_expression_machine5_state_h_N_2209_2,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      ADR3 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_state_h_N_1291
    );
  regular_expression_machine5_state_h_state_ns_50_0_and2_2 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine5_N_2240,
      ADR2 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_N_2209_2
    );
  regular_expression_machine5_state_h_state_ns_232_0_and2_1 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1704,
      ADR1 => regex_in_2_5_Q,
      ADR2 => regular_expression_machine5_G_485_s,
      O => regular_expression_machine5_state_h_N_1821_1
    );
  regular_expression_machine5_state_h_state_ns_265_0_and2_2_1 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => regular_expression_machine3_N_388_1,
      ADR1 => regular_expression_machine5_state_h_N_2210,
      ADR2 => regular_expression_machine5_state_h_N_2209_2,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_N_1832_1
    );
  regular_expression_machine5_state_h_state_ns_316_0_and2_2_1 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1704,
      ADR1 => regular_expression_machine5_N_1707,
      O => regular_expression_machine5_state_h_N_1852_1
    );
  regular_expression_machine5_state_h_state_ns_337_0_and2_0_1 : X_LUT4
    generic map(
      INIT => X"88A8"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regular_expression_machine5_state_h_N_2229,
      ADR2 => regular_expression_machine5_state_h_state_ns_157_0_and2_252,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine5_N_1854_1
    );
  regular_expression_machine5_state_h_state_ns_279_0_and2_0 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2244,
      ADR1 => regular_expression_machine5_N_2124,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regex_in_2_5_Q,
      O => regular_expression_machine5_state_h_N_2075
    );
  regular_expression_machine5_state_h_state_ns_421_1_0_and2 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_state_1_Q,
      ADR1 => regular_expression_machine5_N_2243,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_1495_1
    );
  regular_expression_machine5_state_h_state_ns_236_i_and2 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine5_un10_state_1,
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_N_2237,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_N_2225
    );
  regular_expression_machine5_state_h_state_ns_184_0_and2_4_1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regular_expression_machine5_N_1298_3,
      O => regular_expression_machine5_state_h_N_2102_1
    );
  regular_expression_machine5_state_h_state_ns_337_0_and2_2 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2213,
      ADR1 => regular_expression_machine5_state_0_Q,
      ADR2 => regular_expression_machine7_N_367_1,
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine5_N_1856
    );
  regular_expression_machine5_state_h_state_ns_433_0_and2_2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2124,
      ADR1 => regular_expression_machine5_N_2237,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2057_2
    );
  regular_expression_machine5_state_h_state_ns_322_0_and2 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2243,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_N_2140,
      ADR3 => regular_expression_machine5_N_2126,
      O => regular_expression_machine5_N_2086
    );
  regular_expression_machine5_state_h_state_ns_236_i_and2_0 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2240,
      ADR1 => regular_expression_machine5_state_2_Q,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2226
    );
  regular_expression_machine5_state_h_state_ns_59_0_and2_0 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_state_1_Q,
      ADR1 => regex_in_1(5),
      ADR2 => regular_expression_machine5_G_487_s,
      O => regular_expression_machine5_state_h_N_2213
    );
  regular_expression_machine5_state_h_state_ns_48_0_and2 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_state_1_Q,
      ADR1 => regex_in_1(5),
      ADR2 => regular_expression_machine5_G_487_s,
      O => regular_expression_machine5_N_2208
    );
  regular_expression_machine5_state_h_state_ns_84_i : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2040_i,
      ADR1 => regular_expression_machine5_N_2243,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2156
    );
  regular_expression_machine5_state_h_state_ns_189_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_state_1_Q,
      ADR1 => reset_l_2,
      ADR2 => regex_en_2,
      O => regular_expression_machine5_N_2099
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => reset_l_2,
      ADR2 => regex_en_2,
      O => regular_expression_machine5_N_2094
    );
  regular_expression_machine5_state_h_state_ns_288_0_and2_1 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2119,
      ADR1 => regex_in_0(3),
      ADR2 => regular_expression_machine5_state_h_N_1511,
      ADR3 => regular_expression_machine5_state_h_N_1493,
      O => regular_expression_machine5_N_2092
    );
  regular_expression_machine5_state_h_state_ns_322_0_and2_0 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => reset_l_2,
      ADR2 => regex_en_2,
      O => regular_expression_machine5_N_2087
    );
  regular_expression_machine5_state_h_state_ns_355_0_and2_1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2119,
      ADR1 => regular_expression_machine5_N_2043,
      O => regular_expression_machine5_N_2085
    );
  regular_expression_machine5_state_h_state_ns_79_0_and2 : X_LUT4
    generic map(
      INIT => X"88A8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2244,
      ADR1 => regular_expression_machine5_N_2215,
      ADR2 => regular_expression_machine5_N_1717_i,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2063
    );
  regular_expression_machine5_state_h_state_ns_308_0 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2080,
      ADR1 => regular_expression_machine5_N_1704,
      ADR2 => regular_expression_machine5_N_2236,
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_state_h_N_1534
    );
  regular_expression_machine5_state_h_state_ns_136_0 : X_LUT3
    generic map(
      INIT => X"28"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2237,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      ADR2 => regular_expression_machine5_state_2_Q,
      O => regular_expression_machine5_state_h_N_1367
    );
  regular_expression_machine5_state_h_state_ns_296_0_or2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1710,
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine5_G_226_455,
      ADR3 => regular_expression_machine5_N_2246,
      O => regular_expression_machine5_N_1733
    );
  regular_expression_machine5_state_h_state_ns_240_0_or2 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1879,
      ADR1 => regular_expression_machine5_state_h_N_1821_1,
      ADR2 => regular_expression_machine5_N_1898,
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_N_1722
    );
  regular_expression_machine5_state_h_state_ns_350_0_and2 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regex_in_2_4_Q,
      ADR2 => regex_in_1(2),
      O => regular_expression_machine5_state_h_N_1858
    );
  regular_expression_machine5_state_h_state_ns_305_0_and2_2 : X_LUT4
    generic map(
      INIT => X"88A8"
    )
    port map (
      ADR0 => regular_expression_machine7_N_367_1,
      ADR1 => regular_expression_machine5_state_h_N_2079,
      ADR2 => regular_expression_machine5_state_h_N_2213,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_N_1848
    );
  regular_expression_machine5_state_h_state_ns_305_0_and2_1 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1877,
      ADR1 => regular_expression_machine5_N_1718,
      ADR2 => regular_expression_machine5_N_2246,
      O => regular_expression_machine5_N_1847
    );
  regular_expression_machine5_state_h_state_ns_265_0_and2_0 : X_LUT4
    generic map(
      INIT => X"5554"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1707,
      ADR1 => regular_expression_machine5_N_1895,
      ADR2 => regular_expression_machine5_N_1884,
      ADR3 => regular_expression_machine5_N_1883,
      O => regular_expression_machine5_N_1830
    );
  regular_expression_machine5_state_h_state_ns_70_i_and2 : X_LUT4
    generic map(
      INIT => X"5155"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1707,
      ADR1 => regex_in_1(2),
      ADR2 => regex_in_1(5),
      ADR3 => regular_expression_machine5_state_ns_435_0_and2_255,
      O => regular_expression_machine5_state_h_N_1772
    );
  regular_expression_machine5_state_h_state_ns_232_0 : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2215,
      ADR1 => regular_expression_machine5_N_1298_3,
      ADR2 => regular_expression_machine5_state_h_N_1821_1,
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_state_h_N_1462
    );
  regular_expression_machine5_state_h_state_ns_71 : X_MUX2
    port map (
      IA => regular_expression_machine5_state_h_state_ns_71_am,
      IB => regular_expression_machine5_state_h_state_ns_71_bm,
      O => regular_expression_machine5_state_h_N_1306,
      SEL => regex_in_1(4)
    );
  regular_expression_machine5_state_h_state_ns_71_bm_298 : X_LUT3
    generic map(
      INIT => X"45"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_70_i_660,
      ADR1 => regular_expression_machine5_state_h_N_1291,
      ADR2 => regular_expression_machine3_N_388_1,
      O => regular_expression_machine5_state_h_state_ns_71_bm
    );
  regular_expression_machine5_state_h_state_ns_71_am_299 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1766,
      ADR1 => regular_expression_machine5_state_h_state_ns_37_0_75,
      O => regular_expression_machine5_state_h_state_ns_71_am
    );
  regular_expression_machine5_state_h_state_ns_340_0 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_340_0_56,
      ADR1 => regular_expression_machine5_N_1704,
      ADR2 => regular_expression_machine5_N_2236,
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_N_1564
    );
  regular_expression_machine5_state_h_state_ns_157_0_and2_0 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_G_484_s,
      ADR1 => regex_in_1(5),
      ADR2 => regex_in_1(2),
      ADR3 => regular_expression_machine5_state_h_state_ns_157_0_and2_0_359,
      O => regular_expression_machine5_state_h_N_2222
    );
  regular_expression_machine5_state_h_state_ns_108_i_and2_2_1 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2057_2,
      ADR1 => regular_expression_machine1_N_520,
      ADR2 => regex_in_1(4),
      ADR3 => regular_expression_machine5_N_2244,
      O => regular_expression_machine5_state_h_N_2106_1
    );
  regular_expression_machine5_state_h_state_ns_189_0_and2_2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2127,
      ADR1 => regular_expression_machine7_N_367_1,
      ADR2 => regular_expression_machine5_N_2126,
      ADR3 => regular_expression_machine5_state_h_N_2102_1,
      O => regular_expression_machine5_N_2102
    );
  regular_expression_machine5_state_h_state_ns_189_0_and2_1 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine1_N_433_i,
      ADR1 => regular_expression_machine0_N_920_1,
      ADR2 => regular_expression_machine5_N_2126,
      ADR3 => regular_expression_machine5_state_h_state_ns_189_0_and2_1_394,
      O => regular_expression_machine5_N_2101
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2_3 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine7_N_367_1,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine5_N_2127,
      ADR3 => regular_expression_machine5_state_h_state_ns_246_0_and2_3_531,
      O => regular_expression_machine5_N_2098
    );
  regular_expression_machine5_state_h_state_ns_175_i_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_175_i_and2_312,
      ADR1 => regular_expression_machine5_N_2124,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regex_in_1(5),
      O => regular_expression_machine5_state_h_N_2069
    );
  regular_expression_machine5_state_h_state_ns_296_0_and2_1 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine1_N_443,
      ADR3 => regular_expression_machine5_N_1704,
      O => regular_expression_machine5_state_h_N_1844
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_4 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2242,
      ADR1 => regular_expression_machine7_N_365_1,
      ADR2 => regex_in_1(4),
      ADR3 => regular_expression_machine5_state_h_state_ns_283_0_and2_4_375,
      O => regular_expression_machine5_state_h_N_1840
    );
  regular_expression_machine5_state_h_state_ns_265_0_and2_1 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1891,
      ADR1 => regular_expression_machine5_N_1908,
      ADR2 => regular_expression_machine5_state_ns_265_0_and2_1_373,
      O => regular_expression_machine5_state_h_N_1831
    );
  regular_expression_machine5_state_h_state_ns_184_0_and2_3 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine5_G_223_fast,
      ADR1 => regular_expression_machine5_N_1989,
      ADR2 => regular_expression_machine5_state_h_state_ns_102_i_and2_7_390,
      O => regular_expression_machine5_state_h_N_1807
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_4 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1367,
      ADR1 => regular_expression_machine5_N_1891,
      ADR2 => regular_expression_machine5_N_1704,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_1799
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_1 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_state_h_state_ns_160_0_and2_1_547,
      ADR3 => regular_expression_machine5_N_1707,
      O => regular_expression_machine5_state_h_N_1796
    );
  regular_expression_machine5_state_h_state_ns_265_0 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1832_1,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine5_state_h_state_ns_265_0_674,
      ADR3 => regular_expression_machine5_N_1830,
      O => regular_expression_machine5_state_h_N_1493
    );
  regular_expression_machine5_state_h_state_ns_240_0 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_240_0_670,
      ADR1 => regular_expression_machine5_state_h_N_1825,
      ADR2 => regular_expression_machine5_N_1732,
      ADR3 => regular_expression_machine5_N_1877,
      O => regular_expression_machine5_N_1470
    );
  regular_expression_machine5_state_h_state_ns_222_0 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1816,
      ADR1 => regular_expression_machine5_state_h_state_ns_222_0_78,
      ADR2 => regular_expression_machine5_state_h_state_ns_222_0_and2_3_443,
      ADR3 => regular_expression_machine7_N_367_1,
      O => regular_expression_machine5_state_h_N_1452
    );
  regular_expression_machine5_state_h_state_ns_50_0_and2_0 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine5_G_487_s,
      ADR2 => regex_in_1(2),
      ADR3 => regular_expression_machine5_N_2244,
      O => regular_expression_machine5_state_h_N_2210
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2_0 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => state_ns_322_0_and2_1_678,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine5_state_h_N_1452,
      ADR3 => regular_expression_machine5_state_h_N_1435,
      O => regular_expression_machine5_state_h_N_2095
    );
  regular_expression_machine5_state_h_state_ns_288_0_and2_2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2106_1,
      ADR1 => regular_expression_machine5_N_2113,
      ADR2 => regular_expression_machine5_N_2114,
      O => regular_expression_machine5_state_h_N_2093
    );
  regular_expression_machine5_state_h_state_ns_322_0_and2_2 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => state_ns_246_0_and2_1_679,
      ADR1 => regular_expression_machine5_state_h_state_ns_316_0_639,
      ADR2 => regular_expression_machine5_state_h_state_ns_316_0_and2_620,
      ADR3 => regular_expression_machine5_N_1732,
      O => regular_expression_machine5_state_h_N_2089
    );
  regular_expression_machine5_state_h_state_ns_302_0_and2_0 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_N_1704,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2079
    );
  regular_expression_machine5_state_h_state_ns_279_0 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2074,
      ADR1 => regular_expression_machine5_state_h_N_2075,
      ADR2 => regular_expression_machine5_N_2040_i,
      ADR3 => regular_expression_machine5_N_1298_3,
      O => regular_expression_machine5_state_h_N_1507
    );
  regular_expression_machine5_state_h_state_ns_350_0_and2_3 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2236,
      ADR1 => regular_expression_machine5_N_2196,
      ADR2 => regular_expression_machine5_N_1903,
      ADR3 => regular_expression_machine5_N_2244,
      O => regular_expression_machine5_state_h_N_1862
    );
  regular_expression_machine5_state_h_state_ns_337_0_and2_3 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2243,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_N_1891,
      ADR3 => regular_expression_machine5_N_1298_3,
      O => regular_expression_machine5_state_h_N_1857
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_2 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine3_N_388_1,
      ADR1 => regular_expression_machine5_state_h_state_ns_283_0_and2_2_331,
      ADR2 => regex_in_1(4),
      ADR3 => regex_in_1(2),
      O => regular_expression_machine5_state_h_N_1838
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_1 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1462,
      ADR1 => regular_expression_machine5_N_1707,
      ADR2 => regex_in_1(4),
      O => regular_expression_machine5_state_h_N_1837
    );
  regular_expression_machine5_state_h_state_ns_240_0_and2_2 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine7_N_367_1,
      ADR3 => regular_expression_machine5_N_1704,
      O => regular_expression_machine5_state_h_N_1825
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1741,
      ADR1 => regular_expression_machine6_N_271_2,
      ADR2 => regex_in_1(4),
      ADR3 => regex_in_1(2),
      O => regular_expression_machine5_state_h_N_1794
    );
  regular_expression_machine5_state_h_state_ns_37_0_and2_2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_37_0_and2_2_571,
      ADR1 => regular_expression_machine5_N_1717_i,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_1766
    );
  regular_expression_machine5_state_h_state_ns_37_0_and2_1 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_N_1707,
      ADR3 => regular_expression_machine5_N_1298_3,
      O => regular_expression_machine5_state_h_N_1765
    );
  regular_expression_machine5_state_h_state_ns_37_0_and2_0 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_N_1898,
      ADR3 => regular_expression_machine5_N_1704,
      O => regular_expression_machine5_state_h_N_1764
    );
  regular_expression_machine5_state_h_state_ns_308_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1717_i,
      ADR1 => regular_expression_machine5_N_2244,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_N_2080
    );
  regular_expression_machine5_state_h_state_ns_59_0_and2 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_state_1_Q,
      ADR3 => regular_expression_machine5_state_4_Q,
      O => regular_expression_machine5_state_h_N_2212
    );
  regular_expression_machine5_state_h_state_ns_298_0_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2240,
      ADR1 => regular_expression_machine5_state_0_Q,
      ADR2 => regex_in_1(2),
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_state_h_N_2229
    );
  regular_expression_machine5_state_h_state_ns_355_0_and2 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2140,
      ADR1 => regular_expression_machine5_N_2126,
      ADR2 => regex_in_0(5),
      ADR3 => regular_expression_machine5_state_h_state_ns_355_0_and2_563,
      O => regular_expression_machine5_N_2083
    );
  regular_expression_machine5_state_h_state_ns_108_i_and2_0 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1306,
      ADR1 => regex_in_0(3),
      ADR2 => regular_expression_machine5_N_2128,
      ADR3 => regex_in(6),
      O => regular_expression_machine5_state_h_N_2104
    );
  regular_expression_machine5_state_h_state_ns_108_i_and2_1 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1671,
      ADR1 => regular_expression_machine7_N_394,
      ADR2 => regular_expression_machine5_N_2128,
      ADR3 => regex_in(6),
      O => regular_expression_machine5_state_h_N_2105
    );
  regular_expression_machine5_state_h_state_ns_108_i_and2_2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2106_1,
      ADR1 => regular_expression_machine5_N_2113,
      ADR2 => regular_expression_machine5_N_2128,
      O => regular_expression_machine5_state_h_N_2106
    );
  regular_expression_machine5_state_h_state_ns_108_i_and2_3 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2140,
      ADR1 => regular_expression_machine5_N_2243,
      ADR2 => regular_expression_machine5_state_h_state_ns_108_i_and2_3_540,
      O => regular_expression_machine5_state_h_N_2107
    );
  regular_expression_machine5_state_h_state_ns_184_0_and2_1 : X_LUT4
    generic map(
      INIT => X"00B0"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2069,
      ADR1 => regular_expression_machine5_N_2050,
      ADR2 => regular_expression_machine5_N_1903,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_N_1805
    );
  regular_expression_machine5_state_h_state_ns_222_0_and2_1 : X_LUT4
    generic map(
      INIT => X"88A8"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_222_0_and2_1_566,
      ADR1 => regular_expression_machine5_state_h_N_2070,
      ADR2 => regular_expression_machine5_N_1717_i,
      ADR3 => regular_expression_machine5_state_1_Q,
      O => regular_expression_machine5_state_h_N_1817
    );
  regular_expression_machine5_state_h_state_ns_337_0_and2 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2240,
      ADR1 => regular_expression_machine5_N_2196,
      ADR2 => regular_expression_machine5_N_1903,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_N_1853
    );
  regular_expression_machine5_state_h_state_ns_205_0 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1710,
      ADR1 => regex_in_0(2),
      ADR2 => regular_expression_machine5_state_h_N_1813,
      ADR3 => regular_expression_machine5_state_h_state_ns_205_0_60,
      O => regular_expression_machine5_state_h_N_1435
    );
  regular_expression_machine5_state_h_state_ns_205_0_and2_1 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2246,
      ADR1 => regular_expression_machine3_N_388_1,
      ADR2 => regex_in_0(2),
      ADR3 => regular_expression_machine5_N_2242,
      O => regular_expression_machine5_state_h_N_1813
    );
  regular_expression_machine5_state_h_state_ns_222_0_and2_2 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1436,
      ADR1 => regular_expression_machine3_N_388_1,
      ADR2 => regex_in_0(2),
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_N_1818
    );
  regular_expression_machine5_state_h_state_ns_240_0_and2_1 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regex_in_0(2),
      ADR2 => regular_expression_machine5_N_1993,
      ADR3 => regular_expression_machine5_N_2244,
      O => regular_expression_machine5_state_h_N_1824
    );
  regular_expression_machine5_state_h_state_ns_340_0_56_300 : X_LUT4
    generic map(
      INIT => X"C0E0"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1908,
      ADR1 => regular_expression_machine5_N_2215,
      ADR2 => regular_expression_machine5_N_2244,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_state_ns_340_0_56
    );
  regular_expression_machine5_state_h_state_ns_205_0_60_301 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1766,
      ADR1 => regular_expression_machine5_N_2208,
      ADR2 => regular_expression_machine5_N_1898,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_state_ns_205_0_60
    );
  regular_expression_machine5_state_h_state_ns_37_0_75_302 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1765,
      ADR1 => regular_expression_machine5_state_h_N_1764,
      ADR2 => regular_expression_machine5_state_h_state_ns_37_0_and2_357,
      ADR3 => regular_expression_machine5_state_h_N_1852_1,
      O => regular_expression_machine5_state_h_state_ns_37_0_75
    );
  regular_expression_machine5_state_h_state_ns_102_i_76_303 : X_LUT4
    generic map(
      INIT => X"550D"
    )
    port map (
      ADR0 => regex_in_0(2),
      ADR1 => regex_in_0(5),
      ADR2 => regex_in_0(0),
      ADR3 => regex_in_0(1),
      O => regular_expression_machine5_state_h_state_ns_102_i_76
    );
  regular_expression_machine5_state_h_state_ns_222_0_78_304 : X_LUT4
    generic map(
      INIT => X"EFEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1818,
      ADR1 => regular_expression_machine5_state_h_N_1817,
      ADR2 => regular_expression_machine5_N_1752,
      ADR3 => regular_expression_machine5_N_1877,
      O => regular_expression_machine5_state_h_state_ns_222_0_78
    );
  regular_expression_machine5_state_h_state_ns_283_0_80_305 : X_LUT4
    generic map(
      INIT => X"EEAE"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1891,
      ADR1 => regular_expression_machine5_state_h_state_ns_283_0_and2_595,
      ADR2 => regular_expression_machine5_state_h_N_1495_1,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_state_ns_283_0_80
    );
  regular_expression_machine5_state_h_state_ns_160_0_91_306 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1798,
      ADR1 => regular_expression_machine5_state_h_N_1291,
      ADR2 => regular_expression_machine3_N_388_1,
      ADR3 => regex_in_1(4),
      O => regular_expression_machine5_state_h_state_ns_160_0_91
    );
  regular_expression_machine5_state_h_state_ns_160_0_92_307 : X_LUT4
    generic map(
      INIT => X"BAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1794,
      ADR1 => regular_expression_machine5_N_1993,
      ADR2 => regular_expression_machine5_state_h_state_ns_160_0_and2_6_343,
      ADR3 => regular_expression_machine7_N_365_1,
      O => regular_expression_machine5_state_h_state_ns_160_0_92
    );
  regular_expression_machine5_state_h_state_ns_160_0_95_308 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1799,
      ADR1 => regular_expression_machine5_state_h_N_1796,
      ADR2 => regular_expression_machine5_state_h_state_ns_160_0_and2_5_356,
      ADR3 => regular_expression_machine5_N_1912,
      O => regular_expression_machine5_state_h_state_ns_160_0_95
    );
  regular_expression_machine5_state_h_state_ns_160_0_96 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_160_0_91,
      ADR1 => regular_expression_machine5_state_h_state_ns_160_0_92,
      ADR2 => regular_expression_machine5_state_h_state_ns_160_0_95,
      O => regular_expression_machine5_state_ns_160_0_96
    );
  regular_expression_machine5_state_h_state_ns_316_0_98_309 : X_LUT3
    generic map(
      INIT => X"21"
    )
    port map (
      ADR0 => regex_in_0(2),
      ADR1 => regex_in_0(1),
      ADR2 => regex_in_0(0),
      O => regular_expression_machine5_state_h_state_ns_316_0_98
    );
  regular_expression_machine5_state_h_state_ns_316_0_99_310 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_316_0_98,
      ADR1 => regular_expression_machine5_state_h_N_1534,
      ADR2 => regular_expression_machine3_N_388_1,
      ADR3 => regex_in_0(2),
      O => regular_expression_machine5_state_h_state_ns_316_0_99
    );
  regular_expression_machine5_state_h_state_ns_216_0_and2_136 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_ns_216_0_and2_136
    );
  regular_expression_machine5_state_h_state_ns_157_0_and2_250_311 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_state_h_state_ns_157_0_and2_250
    );
  regular_expression_machine5_state_h_state_ns_157_0_and2_252_312 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_2_Q,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      ADR2 => regular_expression_machine5_N_2242,
      ADR3 => regular_expression_machine5_state_h_state_ns_157_0_and2_250,
      O => regular_expression_machine5_state_h_state_ns_157_0_and2_252
    );
  regular_expression_machine5_state_h_state_ns_435_0_and2_255 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1298_3,
      ADR1 => regular_expression_machine5_N_2116,
      ADR2 => regular_expression_machine5_state_4_Q,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_ns_435_0_and2_255
    );
  regular_expression_machine5_state_h_state_ns_397_3_0_and2_267 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_3_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_state_h_state_5_Q,
      O => regular_expression_machine5_state_ns_397_3_0_and2_267
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_3_279_313 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regex_in_0(5),
      O => regular_expression_machine5_state_h_state_ns_283_0_and2_3_279
    );
  regular_expression_machine5_state_h_state_ns_175_i_and2_312_314 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine5_state_1_Q,
      ADR1 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_state_ns_175_i_and2_312
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_2_331_315 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine5_state_h_state_ns_355_0_and2_563,
      ADR2 => regular_expression_machine5_N_2244,
      O => regular_expression_machine5_state_h_state_ns_283_0_and2_2_331
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_6_343_316 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1298_3,
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_0(2),
      O => regular_expression_machine5_state_h_state_ns_160_0_and2_6_343
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_5_356_317 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      ADR2 => regular_expression_machine5_G_484_s,
      ADR3 => regex_in_0(5),
      O => regular_expression_machine5_state_h_state_ns_160_0_and2_5_356
    );
  regular_expression_machine5_state_h_state_ns_37_0_and2_357_318 : X_LUT4
    generic map(
      INIT => X"6000"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regex_in_0(2),
      ADR2 => regular_expression_machine5_G_484_s,
      ADR3 => regex_in_0(5),
      O => regular_expression_machine5_state_h_state_ns_37_0_and2_357
    );
  regular_expression_machine5_state_h_state_ns_157_0_and2_0_359_319 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_state_ns_157_0_and2_0_359
    );
  regular_expression_machine5_state_h_state_ns_265_0_and2_1_373 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_3_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_ns_265_0_and2_1_373
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_4_375_320 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine5_state_4_Q,
      ADR1 => regular_expression_machine5_state_h_state_5_Q,
      ADR2 => regular_expression_machine5_state_2_Q,
      ADR3 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_state_ns_283_0_and2_4_375
    );
  regular_expression_machine5_state_h_state_ns_240_0_and2_4_378_321 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regex_in_0(2),
      ADR1 => regular_expression_machine5_N_2196,
      ADR2 => regex_in_0(5),
      ADR3 => regular_expression_machine5_G_485_s,
      O => regular_expression_machine5_state_h_state_ns_240_0_and2_4_378
    );
  regular_expression_machine5_state_h_state_ns_102_i_and2_7_390_322 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_3_Q,
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_state_ns_102_i_and2_7_390
    );
  regular_expression_machine5_state_h_state_ns_102_i_and2_7_391_323 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_102_i_and2_7_390,
      ADR1 => regex_in_0(1),
      O => regular_expression_machine5_state_h_state_ns_102_i_and2_7_391
    );
  regular_expression_machine5_state_h_state_ns_189_0_and2_1_394_324 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2237,
      ADR1 => regular_expression_machine5_N_2196,
      ADR2 => regular_expression_machine5_N_2242,
      O => regular_expression_machine5_state_h_state_ns_189_0_and2_1_394
    );
  regular_expression_machine5_state_h_state_ns_337_0_and2_1_400_325 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_1(4),
      ADR1 => regex_in_0(5),
      O => regular_expression_machine5_state_h_state_ns_337_0_and2_1_400
    );
  regular_expression_machine5_state_h_state_ns_222_0_and2_3_443_326 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2196,
      ADR1 => regular_expression_machine5_N_2244,
      ADR2 => regular_expression_machine5_state_4_Q,
      O => regular_expression_machine5_state_h_state_ns_222_0_and2_3_443
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2_2_513_327 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regex_in_1(4),
      ADR1 => regex_in_0(2),
      ADR2 => regular_expression_machine5_N_2114,
      ADR3 => regular_expression_machine5_N_2113,
      O => regular_expression_machine5_state_h_state_ns_246_0_and2_2_513
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2_2_514 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_246_0_and2_2_513,
      ADR1 => regular_expression_machine5_N_2242,
      ADR2 => regular_expression_machine7_N_365_1,
      O => state_ns_246_0_and2_2_514
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2_3_531_328 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1298_3,
      ADR1 => regular_expression_machine5_N_2114,
      ADR2 => regular_expression_machine5_N_2113,
      O => regular_expression_machine5_state_h_state_ns_246_0_and2_3_531
    );
  regular_expression_machine5_state_h_state_ns_108_i_and2_3_540_329 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2113,
      ADR1 => regular_expression_machine5_N_2128,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      O => regular_expression_machine5_state_h_state_ns_108_i_and2_3_540
    );
  regular_expression_machine5_state_h_state_ns_236_i_546 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2226,
      ADR1 => regular_expression_machine5_state_1_Q,
      ADR2 => regular_expression_machine5_N_2236,
      ADR3 => regular_expression_machine5_N_2196,
      O => regular_expression_machine5_state_ns_236_i_546
    );
  regular_expression_machine5_state_h_state_ns_160_0_and2_1_547_330 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1704,
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_0(2),
      O => regular_expression_machine5_state_h_state_ns_160_0_and2_1_547
    );
  regular_expression_machine5_state_h_state_ns_350_0_and2_1_562 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_0(2),
      O => regular_expression_machine5_state_ns_350_0_and2_1_562
    );
  regular_expression_machine5_state_h_state_ns_355_0_and2_563_331 : X_LUT4
    generic map(
      INIT => X"0220"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_5_Q,
      ADR1 => regular_expression_machine5_state_2_Q,
      ADR2 => regular_expression_machine5_state_h_state_3_Q,
      ADR3 => regular_expression_machine5_state_4_Q,
      O => regular_expression_machine5_state_h_state_ns_355_0_and2_563
    );
  regular_expression_machine5_state_h_state_ns_222_0_and2_1_566_332 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_state_0_Q,
      ADR1 => regular_expression_machine7_N_367_1,
      O => regular_expression_machine5_state_h_state_ns_222_0_and2_1_566
    );
  regular_expression_machine5_state_h_state_ns_37_0_and2_2_571_333 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1298_3,
      ADR1 => regular_expression_machine7_N_367_1,
      O => regular_expression_machine5_state_h_state_ns_37_0_and2_2_571
    );
  regular_expression_machine5_state_h_state_ns_283_0_and2_595_334 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine7_N_365_1,
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_0(2),
      O => regular_expression_machine5_state_h_state_ns_283_0_and2_595
    );
  regular_expression_machine5_state_h_state_ns_184_0_and2_0_607 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine3_N_388_1,
      ADR1 => regex_in_1(4),
      ADR2 => regex_in_0(2),
      O => regular_expression_machine5_state_ns_184_0_and2_0_607
    );
  regular_expression_machine5_state_h_state_ns_350_0_608 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1858,
      ADR1 => regular_expression_machine5_N_2040_i,
      ADR2 => regular_expression_machine5_N_1912,
      ADR3 => regex_in_0(1),
      O => regular_expression_machine5_state_ns_350_0_608
    );
  regular_expression_machine5_state_h_state_ns_350_0_609 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1862,
      ADR1 => regular_expression_machine5_state_h_N_2219,
      ADR2 => regular_expression_machine5_N_1903,
      ADR3 => regular_expression_machine5_N_1704,
      O => regular_expression_machine5_state_ns_350_0_609
    );
  regular_expression_machine5_state_h_state_ns_316_0_and2_620_335 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_0(2),
      O => regular_expression_machine5_state_h_state_ns_316_0_and2_620
    );
  regular_expression_machine5_state_h_state_ns_102_i_634_336 : X_LUT4
    generic map(
      INIT => X"AAAB"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_102_i_633,
      ADR1 => regular_expression_machine5_N_2225,
      ADR2 => regular_expression_machine6_N_271_2,
      ADR3 => regular_expression_machine5_state_0_Q,
      O => regular_expression_machine5_state_h_state_ns_102_i_634
    );
  regular_expression_machine5_state_h_state_ns_316_0_639_337 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_316_0_99,
      ADR1 => regular_expression_machine5_state_h_N_1825,
      ADR2 => regular_expression_machine5_state_h_N_1852_1,
      ADR3 => regular_expression_machine5_state_h_N_2156,
      O => regular_expression_machine5_state_h_state_ns_316_0_639
    );
  regular_expression_machine5_state_h_state_ns_296_0_641 : X_LUT4
    generic map(
      INIT => X"BAFA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1844,
      ADR1 => regular_expression_machine5_N_1717_i,
      ADR2 => regular_expression_machine7_N_367_1,
      ADR3 => regular_expression_machine5_N_1298_3,
      O => regular_expression_machine5_state_ns_296_0_641
    );
  regular_expression_machine5_state_h_state_ns_70_i_658_338 : X_LUT4
    generic map(
      INIT => X"EAEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1772,
      ADR1 => regular_expression_machine5_N_1877,
      ADR2 => regular_expression_machine5_N_1718,
      ADR3 => regular_expression_machine5_N_2246,
      O => regular_expression_machine5_state_h_state_ns_70_i_658
    );
  regular_expression_machine5_state_h_state_ns_70_i_660_339 : X_LUT4
    generic map(
      INIT => X"FFF4"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1303,
      ADR1 => regular_expression_machine7_N_367_1,
      ADR2 => regular_expression_machine5_state_h_N_1774,
      ADR3 => regular_expression_machine5_state_h_state_ns_70_i_658,
      O => regular_expression_machine5_state_h_state_ns_70_i_660
    );
  regular_expression_machine5_state_h_state_ns_337_0_663 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1853,
      ADR1 => regular_expression_machine5_state_h_N_1857,
      ADR2 => regular_expression_machine5_state_h_state_ns_337_0_and2_1_400,
      ADR3 => regular_expression_machine5_N_1877,
      O => regular_expression_machine5_state_ns_337_0_663
    );
  regular_expression_machine5_state_h_state_ns_337_0_666 : X_LUT4
    generic map(
      INIT => X"C888"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1854_1,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine5_state_h_N_1291,
      ADR3 => regular_expression_machine3_N_388_1,
      O => regular_expression_machine5_state_ns_337_0_666
    );
  regular_expression_machine5_state_h_state_ns_240_0_667_340 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_1824,
      ADR1 => regular_expression_machine5_state_h_state_ns_240_0_and2_4_378,
      ADR2 => regular_expression_machine5_N_2242,
      ADR3 => regular_expression_machine7_N_365_1,
      O => regular_expression_machine5_state_h_state_ns_240_0_667
    );
  regular_expression_machine5_state_h_state_ns_240_0_669_341 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine5_N_1722,
      ADR1 => regular_expression_machine5_N_1898,
      ADR2 => regular_expression_machine5_N_2215,
      ADR3 => regular_expression_machine5_N_1298_3,
      O => regular_expression_machine5_state_h_state_ns_240_0_669
    );
  regular_expression_machine5_state_h_state_ns_240_0_670_342 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_state_ns_240_0_669,
      ADR1 => regular_expression_machine5_state_h_state_ns_240_0_667,
      ADR2 => regular_expression_machine7_N_368_1,
      ADR3 => regular_expression_machine5_state_h_N_2080,
      O => regular_expression_machine5_state_h_state_ns_240_0_670
    );
  regular_expression_machine5_state_h_state_ns_322_0_and2_1_678 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine5_N_2119,
      O => state_ns_322_0_and2_1_678
    );
  regular_expression_machine5_state_h_state_ns_246_0_and2_1_679 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine5_N_2119,
      ADR1 => regular_expression_machine7_N_394,
      O => state_ns_246_0_and2_1_679
    );
  regular_expression_machine5_state_h_state_ns_108_i_690_343 : X_LUT4
    generic map(
      INIT => X"BBBF"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2107,
      ADR1 => reset_l_2,
      ADR2 => regular_expression_machine5_state_0_Q,
      ADR3 => regex_en_2,
      O => regular_expression_machine5_state_h_state_ns_108_i_690
    );
  regular_expression_machine5_state_h_N_1951_i_344 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine5_state_h_N_2105,
      ADR1 => regular_expression_machine5_state_h_state_ns_108_i_690,
      ADR2 => regular_expression_machine5_state_h_N_2106,
      ADR3 => regular_expression_machine5_state_h_N_2104,
      O => regular_expression_machine5_state_h_N_1951_i
    );
  regular_expression_machine5_state_h_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => regular_expression_machine5_state_h_N_1951_i,
      O => regular_expression_machine5_state_0_Q,
      SRST => regex_restart,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine5_state_h_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_723,
      O => regular_expression_machine5_state_1_Q,
      SRST => regex_restart,
      SSET => regular_expression_machine5_state_h_N_2093,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine5_state_h_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_724,
      O => regular_expression_machine5_state_2_Q,
      SRST => regex_restart,
      SSET => regular_expression_machine5_state_h_N_2095,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine5_state_h_state_3_Q_345 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_725,
      O => regular_expression_machine5_state_h_state_3_Q,
      SRST => regex_restart,
      SSET => regular_expression_machine5_state_h_N_2093,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine5_state_h_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_726,
      O => regular_expression_machine5_state_4_Q,
      SRST => regex_restart,
      SSET => regular_expression_machine5_state_h_N_2089,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine5_state_h_state_5_Q_346 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_727,
      O => regular_expression_machine5_state_h_state_5_Q,
      SRST => regex_restart,
      SSET => regular_expression_machine5_N_2083,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  regular_expression_machine6_nxt_state_35_0_and2_i_or2_1_5_G_1_fast : X_LUT4
    generic map(
      INIT => X"FFFB"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regex_in(6),
      ADR2 => regex_in(7),
      ADR3 => regex_in_0(4),
      O => G_1_fast
    );
  regular_expression_machine6_nxt_state_35_0_and2_i_or2_5_rep1 : X_LUT4
    generic map(
      INIT => X"FFFB"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      ADR2 => regex_in_1(1),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine6_N_308_rep1
    );
  regular_expression_machine6_nxt_state_35_0_and2_i_or2_fast_5_Q : X_LUT4
    generic map(
      INIT => X"FFFB"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      ADR2 => regex_in_1(1),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine6_N_308_fast
    );
  regular_expression_machine6_nxt_state_35_and2_0_and2_i_or2_s_13_G_2_G_2_G_2_rep1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      O => regular_expression_machine7_N_288_rep1
    );
  regular_expression_machine6_nxt_state_35_0_and2_i_or2_5_Q : X_LUT4
    generic map(
      INIT => X"FFFB"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      ADR2 => regex_in_1(1),
      ADR3 => regex_in_2_4_Q,
      O => regular_expression_machine6_N_308
    );
  regular_expression_machine6_nxt_state_35_and2_0_and2_i_or2_s_13_G_2_G_2_G_2 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_in(7),
      ADR1 => regex_in(6),
      O => regular_expression_machine7_N_288
    );
  regular_expression_machine6_nxt_state_35_and2_0_and2_i_or2_13_G_1 : X_LUT3
    generic map(
      INIT => X"FB"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regex_in(6),
      ADR2 => regex_in(7),
      O => regular_expression_machine6_N_307
    );
  regular_expression_machine6_nxt_state_35_0_and2_i_or2_1_5_G_1 : X_LUT4
    generic map(
      INIT => X"FFFB"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regex_in(6),
      ADR2 => regex_in(7),
      ADR3 => regex_in_0(4),
      O => regular_expression_machine6_N_308_1
    );
  regular_expression_machine6_N_269_i_347 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine6_N_269_i_1,
      ADR1 => regular_expression_machine6_N_312,
      ADR2 => regular_expression_machine6_N_306,
      ADR3 => regex_in(6),
      O => regular_expression_machine6_N_269_i
    );
  regular_expression_machine6_N_269_i_1_348 : X_LUT4
    generic map(
      INIT => X"0007"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(12),
      ADR1 => regex_in_2_5_Q,
      ADR2 => regex_in_2_1_Q,
      ADR3 => regex_in_1(0),
      O => regular_expression_machine6_N_269_i_1
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179_349 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179_1_0,
      ADR1 => regular_expression_machine6_state(16),
      ADR2 => regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_175,
      ADR3 => regular_expression_machine6_state_0(0),
      O => regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179_1_0_350 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(3),
      ADR1 => regular_expression_machine6_state_0(14),
      ADR2 => regular_expression_machine6_state_0(8),
      ADR3 => regular_expression_machine6_state_0(4),
      O => regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179_1_0
    );
  regular_expression_machine6_nxt_state_35_i_i_or2_14_Q : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_2_4_Q,
      ADR1 => regex_in(7),
      O => regular_expression_machine6_N_258
    );
  regular_expression_machine6_nxt_state_35_and2_0_and2_i_or2_0_13_Q : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine6_N_310,
      O => regular_expression_machine6_N_314
    );
  regular_expression_machine6_nxt_state_35_0_and2_i_or2_0_5_Q : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine6_state_0(4),
      O => regular_expression_machine6_N_316
    );
  regular_expression_machine6_nxt_state_35_i_and2_15_0_and2_0_and2_2_14_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_2_5_Q,
      O => regular_expression_machine6_N_342_2
    );
  regular_expression_machine6_nxt_state_35_i_i_and2_i_2_0_Q : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_1(0),
      O => regular_expression_machine6_N_271_2
    );
  regular_expression_machine6_nxt_state_35_i_i_and2_i_or2_7_Q : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => regular_expression_machine6_N_258,
      ADR1 => regular_expression_machine6_N_347_7,
      ADR2 => regular_expression_machine6_G_176_171,
      ADR3 => regular_expression_machine6_G_176_170,
      O => regular_expression_machine6_N_306
    );
  regular_expression_machine6_un1_state_99_0_and2_0_and2_1 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_N_311,
      ADR1 => regular_expression_machine6_N_309,
      O => regular_expression_machine6_N_341_1
    );
  regular_expression_machine6_G_183 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(1),
      ADR1 => regular_expression_machine6_state_0(2),
      O => regular_expression_machine6_N_354
    );
  regular_expression_machine6_G_182 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(13),
      ADR1 => regular_expression_machine6_state_0(6),
      O => regular_expression_machine6_N_353
    );
  regular_expression_machine6_G_191 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine6_N_309,
      O => regular_expression_machine6_N_313
    );
  regular_expression_machine6_un1_state_24_0_and3_i_1 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine6_N_311,
      ADR1 => regular_expression_machine6_N_314,
      O => regular_expression_machine6_N_298_1
    );
  regular_expression_machine6_nxt_state_35_and2_0_and2_i_or2_12_Q : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine6_N_308_1,
      O => regular_expression_machine6_N_311
    );
  regular_expression_machine6_G_199 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine6_N_353,
      O => regular_expression_machine6_N_321
    );
  regular_expression_machine6_un1_state_23_0_and2_0_and2_1 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_N_311,
      ADR1 => regular_expression_machine6_N_312,
      O => regular_expression_machine6_N_339_1
    );
  regular_expression_machine6_un1_state_63_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(5),
      ADR1 => regular_expression_machine6_N_340_2,
      ADR2 => regular_expression_machine6_N_340_1,
      O => regular_expression_machine6_N_340
    );
  regular_expression_machine6_un1_state_63_0_and2_0_and2_2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_2_5_Q,
      O => regular_expression_machine6_N_340_2
    );
  regular_expression_machine6_un1_state_63_0_and2_0_and2_1 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_N_314,
      ADR1 => regular_expression_machine6_N_307,
      O => regular_expression_machine6_N_340_1
    );
  regular_expression_machine6_G_177 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(10),
      ADR1 => regular_expression_machine6_state_0(7),
      O => regular_expression_machine6_N_348
    );
  regular_expression_machine6_nxt_state_35_i_i_and2_i_or2_0_7_Q : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regex_in_1(3),
      O => regular_expression_machine6_N_312
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_2_1_14_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_1(3),
      O => regular_expression_machine6_N_329_1
    );
  regular_expression_machine6_nxt_state_35_i_i_and2_i_or2_0_Q : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_1(2),
      ADR1 => regex_in_0(3),
      O => regular_expression_machine6_N_309
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_1_14_Q : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regex_in_0(0),
      O => regular_expression_machine3_N_388_1
    );
  regular_expression_machine6_G_188 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regex_in_1(2),
      ADR1 => regex_in_0(3),
      O => regular_expression_machine6_N_310
    );
  regular_expression_machine6_G_181 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(11),
      ADR1 => regular_expression_machine6_state_0(15),
      ADR2 => regular_expression_machine6_state_0(9),
      O => regular_expression_machine6_N_352
    );
  regular_expression_machine6_un1_state_23_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine6_N_339_1,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine6_state_0(12),
      O => regular_expression_machine6_N_339
    );
  regular_expression_machine6_un1_state_1_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine6_N_339_1,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine6_state_0(11),
      O => regular_expression_machine6_N_338
    );
  regular_expression_machine6_nxt_state_35_i_i_and2_0_and2_9_Q : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308,
      ADR1 => regular_expression_machine6_N_314,
      ADR2 => regular_expression_machine6_N_321,
      ADR3 => regular_expression_machine6_state(16),
      O => regular_expression_machine6_N_343
    );
  regular_expression_machine6_un1_state_99_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine6_N_341_1,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine6_state_0(0),
      O => regular_expression_machine6_N_341
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_Q : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_14_54,
      ADR1 => regular_expression_machine6_nxt_state_35_i_i_0_14_53,
      ADR2 => regular_expression_machine6_nxt_state_35_i_i_0_14_575,
      ADR3 => regular_expression_machine6_nxt_state_35_i_i_0_14_52,
      O => regular_expression_machine6_N_121
    );
  regular_expression_machine6_G_176_7 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => regular_expression_machine6_N_352,
      ADR1 => regular_expression_machine6_N_348,
      ADR2 => regular_expression_machine6_N_353,
      ADR3 => regular_expression_machine6_N_354,
      O => regular_expression_machine6_N_347_7
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_14_Q : X_LUT4
    generic map(
      INIT => X"0444"
    )
    port map (
      ADR0 => regular_expression_machine6_N_312,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine6_state_0(11),
      ADR3 => regex_in_0(5),
      O => regular_expression_machine6_N_326
    );
  regular_expression_machine6_nxt_state_35_i_and2_15_0_and2_0_and2_14_Q : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => regular_expression_machine6_N_313,
      ADR1 => regular_expression_machine6_N_258,
      ADR2 => regular_expression_machine6_N_342_2,
      ADR3 => regular_expression_machine6_nxt_state_35_i_and2_15_0_and2_0_and2_14_383,
      O => regular_expression_machine6_N_342
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_48_351 : X_LUT4
    generic map(
      INIT => X"3101"
    )
    port map (
      ADR0 => regular_expression_machine6_N_309,
      ADR1 => regex_in_0(5),
      ADR2 => regex_in_0(1),
      ADR3 => regex_in_0(3),
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_48
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_50_352 : X_LUT4
    generic map(
      INIT => X"AAAB"
    )
    port map (
      ADR0 => regular_expression_machine6_N_326,
      ADR1 => regex_in_0(5),
      ADR2 => regular_expression_machine6_N_310,
      ADR3 => regex_in_0(0),
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_50
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_51_353 : X_LUT4
    generic map(
      INIT => X"8FF8"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_and2_0_14_260,
      ADR1 => regular_expression_machine6_N_316,
      ADR2 => regex_in(6),
      ADR3 => regular_expression_machine6_N_313,
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_51
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_52_354 : X_LUT3
    generic map(
      INIT => X"64"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_0(1),
      ADR2 => regular_expression_machine6_nxt_state_35_i_i_0_and2_9_14_248,
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_52
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_53_355 : X_LUT4
    generic map(
      INIT => X"EFEE"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_14_50,
      ADR1 => regular_expression_machine6_nxt_state_35_i_i_0_14_48,
      ADR2 => regular_expression_machine6_N_312,
      ADR3 => regex_in_0(1),
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_53
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_54_356 : X_LUT4
    generic map(
      INIT => X"AAAE"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_14_51,
      ADR1 => regular_expression_machine6_N_354,
      ADR2 => regular_expression_machine6_N_310,
      ADR3 => regex_in_0(0),
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_54
    );
  regular_expression_machine6_G_176_170_357 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(14),
      ADR1 => regular_expression_machine6_state(17),
      ADR2 => regular_expression_machine6_state_0(4),
      ADR3 => regular_expression_machine6_state_0(8),
      O => regular_expression_machine6_G_176_170
    );
  regular_expression_machine6_G_176_171_358 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(5),
      ADR1 => regular_expression_machine6_state_0(0),
      ADR2 => regular_expression_machine6_state_0(3),
      ADR3 => regular_expression_machine6_state_0(12),
      O => regular_expression_machine6_G_176_171
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_175_359 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(12),
      ADR1 => regular_expression_machine6_state_0(5),
      O => regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_175
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_8_14_238_360 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regular_expression_machine6_N_352,
      ADR2 => regular_expression_machine6_state_0(5),
      O => regular_expression_machine6_nxt_state_35_i_i_0_and2_8_14_238
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_9_14_248_361 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => regex_in_0(2),
      ADR1 => regular_expression_machine6_N_348,
      ADR2 => regular_expression_machine6_state_0(0),
      O => regular_expression_machine6_nxt_state_35_i_i_0_and2_9_14_248
    );
  regular_expression_machine6_nxt_state_35_i_i_0_and2_0_14_260_362 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regex_in_0(2),
      O => regular_expression_machine6_nxt_state_35_i_i_0_and2_0_14_260
    );
  regular_expression_machine6_nxt_state_35_i_and2_15_0_and2_0_and2_14_383_363 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(3),
      ADR1 => regex_in(6),
      O => regular_expression_machine6_nxt_state_35_i_and2_15_0_and2_0_and2_14_383
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_573_364 : X_LUT4
    generic map(
      INIT => X"888F"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_and2_10_14_179,
      ADR1 => regular_expression_machine6_N_347_7,
      ADR2 => regular_expression_machine6_state_0(3),
      ADR3 => regex_in(6),
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_573
    );
  regular_expression_machine6_nxt_state_35_i_i_0_14_575_365 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => regular_expression_machine6_nxt_state_35_i_i_0_and2_8_14_238,
      ADR1 => regex_in_0(1),
      ADR2 => regular_expression_machine6_N_258,
      ADR3 => regular_expression_machine6_nxt_state_35_i_i_0_14_573,
      O => regular_expression_machine6_nxt_state_35_i_i_0_14_575
    );
  regular_expression_machine6_N_296_i_366 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine6_N_298_1,
      ADR1 => regular_expression_machine6_state_0(6),
      O => regular_expression_machine6_N_296_i
    );
  regular_expression_machine6_N_277_i_367 : X_LUT4
    generic map(
      INIT => X"0100"
    )
    port map (
      ADR0 => regular_expression_machine6_N_308,
      ADR1 => regular_expression_machine6_N_316,
      ADR2 => regex_in_0(2),
      ADR3 => regex_in_0(3),
      O => regular_expression_machine6_N_277_i
    );
  regular_expression_machine6_N_273_i_368 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine6_N_341_1,
      ADR1 => regex_in_0(0),
      ADR2 => regular_expression_machine6_N_348,
      O => regular_expression_machine6_N_273_i
    );
  regular_expression_machine6_N_298_i_369 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine6_N_298_1,
      ADR1 => regular_expression_machine6_state_0(13),
      O => regular_expression_machine6_N_298_i
    );
  regular_expression_machine6_N_275_i_370 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine6_N_340_1,
      ADR1 => regex_in_0(5),
      ADR2 => regex_in_0(1),
      ADR3 => regular_expression_machine6_N_352,
      O => regular_expression_machine6_N_275_i
    );
  regular_expression_machine6_N_302_i_371 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(1),
      ADR1 => regular_expression_machine6_N_311,
      ADR2 => regular_expression_machine6_N_310,
      ADR3 => regex_in_0(0),
      O => regular_expression_machine6_N_302_i
    );
  regular_expression_machine6_N_271_i_372 : X_LUT4
    generic map(
      INIT => X"0100"
    )
    port map (
      ADR0 => regular_expression_machine6_N_306,
      ADR1 => regular_expression_machine6_N_271_2,
      ADR2 => regular_expression_machine6_N_309,
      ADR3 => regex_in(6),
      O => regular_expression_machine6_N_271_i
    );
  regular_expression_machine6_N_300_i_373 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => regular_expression_machine6_state_0(2),
      ADR1 => regular_expression_machine6_N_311,
      ADR2 => regular_expression_machine6_N_310,
      ADR3 => regex_in_0(0),
      O => regular_expression_machine6_N_300_i
    );
  regular_expression_machine6_next_state_N_345_i : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine6_state(16),
      ADR1 => regular_expression_machine6_state_0(8),
      ADR2 => regular_expression_machine6_state_0(15),
      ADR3 => regular_expression_machine6_state_0(10),
      O => regular_expression_machine6_N_345_i
    );
  regular_expression_machine6_state_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine6_N_296_i,
      O => regular_expression_machine6_state_0(11),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_273_i,
      O => regular_expression_machine6_state_0(12),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_275_i,
      O => regular_expression_machine6_state_0(13),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_121,
      O => regular_expression_machine6_state_0(14),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_298_i,
      O => regular_expression_machine6_state_0(15),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_271_i,
      O => regular_expression_machine6_state_0(0),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_341,
      O => regular_expression_machine6_state_0(1),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_302_i,
      O => regular_expression_machine6_state_0(2),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_300_i,
      O => regular_expression_machine6_state_0(3),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_342,
      O => regular_expression_machine6_state_0(4),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_277_i,
      O => regular_expression_machine6_state_0(5),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_340,
      O => regular_expression_machine6_state_0(6),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_269_i,
      O => regular_expression_machine6_state_0(7),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_338,
      O => regular_expression_machine6_state_0(8),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_343,
      O => regular_expression_machine6_state_0(9),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_state_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_1,
      CLK => clk,
      I => regular_expression_machine6_N_339,
      O => regular_expression_machine6_state_0(10),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regular_expression_machine6_N_345_i,
      CLK => clk,
      I => regular_expression_machine6_VCC,
      O => accepted(6),
      SRST => cntrlr_N_882_1_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine6_VCC_374 : X_ONE
    port map (
      O => regular_expression_machine6_VCC
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_40_375 : X_LUT4
    generic map(
      INIT => X"FFF4"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine7_N_368_1,
      ADR2 => regular_expression_machine7_nxt_state_35_i_i_0_14_37,
      ADR3 => regular_expression_machine7_nxt_state_35_i_i_0_14_40_sx,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_40
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_40_sx_376 : X_LUT4
    generic map(
      INIT => X"AAAE"
    )
    port map (
      ADR0 => regular_expression_machine7_N_361,
      ADR1 => regular_expression_machine7_N_338,
      ADR2 => regex_in_2_5_Q,
      ADR3 => regex_in_2_2_Q,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_40_sx
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_46_377 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => regular_expression_machine7_nxt_state_35_i_i_0_14_41,
      ADR1 => regular_expression_machine7_nxt_state_35_i_i_0_14_43,
      ADR2 => regular_expression_machine7_nxt_state_35_i_i_0_14_40,
      ADR3 => regular_expression_machine7_nxt_state_35_i_i_0_14_46_sx,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_46
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_46_sx_378 : X_LUT4
    generic map(
      INIT => X"FBAA"
    )
    port map (
      ADR0 => regular_expression_machine7_N_371,
      ADR1 => regex_in_1(4),
      ADR2 => regular_expression_machine7_N_389,
      ADR3 => regular_expression_machine1_N_561,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_46_sx
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_9_1_14_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regex_in_2_1_Q,
      ADR2 => regex_in_2_2_Q,
      O => regular_expression_machine7_N_367_1
    );
  regular_expression_machine7_G_220_G_1 : X_LUT3
    generic map(
      INIT => X"FB"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regex_in(6),
      ADR2 => regex_in(7),
      O => regular_expression_machine7_N_331
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_37_379 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine7_nxt_state_35_i_i_0_14_37_1,
      ADR1 => regular_expression_machine7_N_363,
      ADR2 => regular_expression_machine0_N_907_2,
      ADR3 => regular_expression_machine7_N_328,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_37
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_37_1_380 : X_LUT4
    generic map(
      INIT => X"ABAA"
    )
    port map (
      ADR0 => regular_expression_machine7_N_358,
      ADR1 => regex_in_2_1_Q,
      ADR2 => regex_in_2_2_Q,
      ADR3 => regular_expression_machine7_N_339,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_37_1
    );
  regular_expression_machine7_G_206 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine7_N_329,
      O => regular_expression_machine7_N_388
    );
  regular_expression_machine7_G_209 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine7_state(2),
      ADR1 => regular_expression_machine7_state(6),
      O => regular_expression_machine7_N_391
    );
  regular_expression_machine7_G_222 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regex_in_2_5_Q,
      ADR1 => regular_expression_machine7_state(8),
      O => regular_expression_machine7_N_333
    );
  regular_expression_machine7_G_228 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regular_expression_machine7_state(12),
      O => regular_expression_machine7_N_339
    );
  regular_expression_machine7_un1_state_31_0_and2_0_and2_2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine1_N_433_i,
      ADR1 => regular_expression_machine7_N_394,
      O => regular_expression_machine7_N_382_2
    );
  regular_expression_machine7_un1_state_24_0_and2_0_and2_2 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_2_2_Q,
      ADR1 => regular_expression_machine7_N_386,
      O => regular_expression_machine7_N_381_2
    );
  regular_expression_machine7_un1_state_51_0_and2_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine7_N_375_1,
      ADR1 => regular_expression_machine7_state(6),
      O => regular_expression_machine7_N_375
    );
  regular_expression_machine7_un1_state_50_0_and2_i_1 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine7_N_329,
      ADR1 => regular_expression_machine7_N_335,
      O => regular_expression_machine7_N_322_1
    );
  regular_expression_machine7_nxt_state_35_i_0_0_1_5_Q : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine7_N_335,
      ADR1 => regular_expression_machine7_N_344,
      O => regular_expression_machine7_N_104_1
    );
  regular_expression_machine7_un1_state_47_0_and2_0_and2_1 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine7_N_386,
      ADR1 => regular_expression_machine7_N_344,
      O => regular_expression_machine7_N_374_1
    );
  regular_expression_machine7_un1_state_59_0_and2_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine7_N_375_1,
      ADR1 => regular_expression_machine7_state(2),
      O => regular_expression_machine7_N_377
    );
  regular_expression_machine7_un1_state_59_0_and2_0_and2_1 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine7_N_335,
      ADR1 => regular_expression_machine7_N_388,
      O => regular_expression_machine7_N_375_1
    );
  regular_expression_machine7_nxt_state_35_i_0_0_or2_0_5_Q : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regex_in_2_4_Q,
      O => regular_expression_machine7_N_344
    );
  regular_expression_machine7_G_227 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regular_expression_machine7_state(5),
      O => regular_expression_machine7_N_338
    );
  regular_expression_machine7_G_207 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine7_state(3),
      ADR1 => regular_expression_machine7_state(5),
      O => regular_expression_machine7_N_389
    );
  regular_expression_machine7_G_208 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine7_state(7),
      ADR1 => regular_expression_machine7_state(4),
      O => regular_expression_machine7_N_390
    );
  regular_expression_machine7_G_215 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regular_expression_machine7_state(10),
      ADR1 => regular_expression_machine7_state(14),
      O => regular_expression_machine7_N_397
    );
  regular_expression_machine7_nxt_state_35_0_0_15_Q : X_LUT4
    generic map(
      INIT => X"AAAE"
    )
    port map (
      ADR0 => regular_expression_machine7_N_353,
      ADR1 => regular_expression_machine7_nxt_state_35_0_0_and2_0_15_305,
      ADR2 => regular_expression_machine7_N_331,
      ADR3 => regular_expression_machine7_N_336,
      O => regular_expression_machine7_nxt_state_35_15_Q
    );
  regular_expression_machine7_G_225 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regex_in_2_5_Q,
      O => regular_expression_machine7_N_336
    );
  regular_expression_machine7_nxt_state_35_i_0_0_or2_5_Q : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine7_N_328,
      ADR1 => regular_expression_machine7_N_331,
      O => regular_expression_machine7_N_335
    );
  regular_expression_machine7_un1_state_55_0_and2_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regular_expression_machine7_state(9),
      ADR1 => regular_expression_machine7_N_375_1,
      O => regular_expression_machine7_N_376
    );
  regular_expression_machine7_G_219 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine7_state(11),
      ADR1 => regular_expression_machine7_state(1),
      O => regular_expression_machine7_N_330
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_12_2_14_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_1(3),
      O => regular_expression_machine7_N_370_2
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_5_14_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine6_N_271_2,
      ADR1 => regular_expression_machine7_N_329,
      O => regular_expression_machine7_N_363
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_0_14_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => regex_in_1(3),
      ADR1 => regex_in_2_2_Q,
      ADR2 => regex_in_2_4_Q,
      ADR3 => regex_in_2_1_Q,
      O => regular_expression_machine7_N_358
    );
  regular_expression_machine7_G_217 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => regex_in_1(0),
      ADR1 => regex_in_2_2_Q,
      O => regular_expression_machine7_N_328
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_10_1_14_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regular_expression_machine1_N_433_i,
      O => regular_expression_machine7_N_368_1
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_7_1_14_Q : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_2_1_Q,
      ADR1 => regex_in_1(0),
      O => regular_expression_machine7_N_365_1
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_7_14_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regular_expression_machine7_state(13),
      ADR1 => regular_expression_machine7_N_365_1,
      O => regular_expression_machine7_N_365
    );
  regular_expression_machine7_nxt_state_35_i_0_0_or2_0_Q : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regex_in_1(4),
      O => regular_expression_machine7_N_329
    );
  regular_expression_machine7_G_212 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_0(3),
      ADR1 => regex_in_1(4),
      O => regular_expression_machine7_N_394
    );
  regular_expression_machine7_G_205 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_1(2),
      O => regular_expression_machine1_N_433_i
    );
  regular_expression_machine7_G_204 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_1(1),
      ADR1 => regular_expression_machine7_N_288,
      O => regular_expression_machine7_N_386
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_3_14_Q : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => regular_expression_machine7_N_336,
      ADR1 => regex_in_1(1),
      ADR2 => regex_in_0(3),
      O => regular_expression_machine7_N_361
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_12_14_Q : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => regular_expression_machine7_N_370_2,
      ADR1 => regex_in_1(2),
      ADR2 => regular_expression_machine7_state(11),
      ADR3 => regular_expression_machine7_state(0),
      O => regular_expression_machine7_N_370
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_11_14_Q : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine7_N_328,
      ADR1 => regex_in_0(1),
      ADR2 => regular_expression_machine7_N_390,
      O => regular_expression_machine7_N_369
    );
  regular_expression_machine7_nxt_state_35_and2_0_and2_0_and2_13_Q : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => regular_expression_machine7_N_382_2,
      ADR1 => regular_expression_machine7_N_386,
      ADR2 => regular_expression_machine7_N_330,
      O => regular_expression_machine7_nxt_state_35_13_Q
    );
  regular_expression_machine7_nxt_state_35_0_0_and2_15_Q : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => regular_expression_machine7_N_344,
      ADR1 => regular_expression_machine7_state(13),
      ADR2 => regular_expression_machine1_N_433_i,
      ADR3 => regular_expression_machine7_N_331,
      O => regular_expression_machine7_N_353
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_13_14_Q : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => regular_expression_machine7_N_388,
      ADR1 => regex_in_0(1),
      ADR2 => regular_expression_machine7_N_391,
      ADR3 => regular_expression_machine7_state(9),
      O => regular_expression_machine7_N_371
    );
  regular_expression_machine7_nxt_state_35_0_and2_0_and2_9_Q : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => regular_expression_machine7_N_329,
      ADR1 => regular_expression_machine7_state(7),
      ADR2 => regular_expression_machine7_N_328,
      ADR3 => regular_expression_machine7_N_386,
      O => regular_expression_machine7_nxt_state_35_9_Q
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_Q : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => regular_expression_machine7_N_288,
      ADR1 => regular_expression_machine7_nxt_state_35_i_i_0_14_46,
      ADR2 => regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_165,
      ADR3 => regular_expression_machine7_N_355_6,
      O => regular_expression_machine7_N_119
    );
  regular_expression_machine7_un1_state_47_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine7_N_374_1,
      ADR1 => regular_expression_machine7_un1_state_47_0_and2_0_and2_388,
      ADR2 => regex_in_1(2),
      ADR3 => regular_expression_machine7_state(3),
      O => regular_expression_machine7_N_374
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_14_3_14_Q : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => regular_expression_machine7_state(12),
      ADR1 => regular_expression_machine7_state(15),
      ADR2 => regular_expression_machine7_state(13),
      ADR3 => regular_expression_machine7_state(8),
      O => regular_expression_machine7_N_372_3
    );
  regular_expression_machine7_nxt_state_35_i_0_0_and2_6_5_Q : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => regular_expression_machine7_N_389,
      ADR1 => regular_expression_machine7_N_391,
      ADR2 => regular_expression_machine7_N_330,
      ADR3 => regular_expression_machine7_N_390,
      O => regular_expression_machine7_N_355_6
    );
  regular_expression_machine7_nxt_state_35_i_0_0_and2_8_5_Q : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine7_N_355_6,
      ADR1 => regular_expression_machine7_N_372_3,
      ADR2 => regular_expression_machine7_N_397,
      ADR3 => regular_expression_machine7_state(0),
      O => regular_expression_machine7_N_355_8
    );
  regular_expression_machine7_un1_state_42_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => regular_expression_machine7_N_388,
      ADR1 => regular_expression_machine7_N_328,
      ADR2 => regular_expression_machine7_N_386,
      ADR3 => regular_expression_machine7_state(4),
      O => regular_expression_machine7_N_373
    );
  regular_expression_machine7_nxt_state_35_0_and2_0_and2_7_Q : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => regular_expression_machine7_N_381_2,
      ADR1 => regular_expression_machine7_N_344,
      ADR2 => regular_expression_machine7_N_338,
      O => regular_expression_machine7_nxt_state_35_7_Q
    );
  regular_expression_machine7_un1_state_24_0_and2_0_and2 : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => regular_expression_machine7_N_381_2,
      ADR1 => regular_expression_machine7_N_329,
      ADR2 => regular_expression_machine7_N_336,
      ADR3 => regular_expression_machine7_state(10),
      O => regular_expression_machine7_N_381
    );
  regular_expression_machine7_un1_state_31_0_and2_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => regular_expression_machine7_N_382_2,
      ADR1 => regular_expression_machine7_N_386,
      ADR2 => regular_expression_machine7_N_333,
      O => regular_expression_machine7_N_382
    );
  regular_expression_machine7_nxt_state_35_0_and2_0_and2_2_Q : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => regular_expression_machine7_N_335,
      ADR1 => regular_expression_machine7_N_394,
      ADR2 => regular_expression_machine7_nxt_state_35_0_and2_0_and2_2_364,
      O => regular_expression_machine7_nxt_state_35_2_Q
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_39_381 : X_LUT4
    generic map(
      INIT => X"AAAB"
    )
    port map (
      ADR0 => regular_expression_machine7_N_369,
      ADR1 => regular_expression_machine6_N_271_2,
      ADR2 => regex_in_0(5),
      ADR3 => regular_expression_machine7_state(7),
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_39
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_41_382 : X_LUT4
    generic map(
      INIT => X"EEFE"
    )
    port map (
      ADR0 => regular_expression_machine7_nxt_state_35_i_i_0_14_39,
      ADR1 => regular_expression_machine7_N_365,
      ADR2 => regular_expression_machine7_N_367_1,
      ADR3 => regular_expression_machine7_state(10),
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_41
    );
  regular_expression_machine7_nxt_state_35_i_i_0_14_43_383 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => regular_expression_machine7_N_370,
      ADR1 => regular_expression_machine7_N_368_1,
      ADR2 => regular_expression_machine7_N_333,
      ADR3 => regular_expression_machine7_N_330,
      O => regular_expression_machine7_nxt_state_35_i_i_0_14_43
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_162_384 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regular_expression_machine6_state(16),
      ADR1 => regular_expression_machine7_state(0),
      O => regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_162
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_165_385 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => regular_expression_machine7_N_372_3,
      ADR1 => regular_expression_machine7_N_397,
      ADR2 => regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_162,
      ADR3 => regular_expression_machine7_state(9),
      O => regular_expression_machine7_nxt_state_35_i_i_0_and2_14_14_165
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_14_246 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_0(0),
      ADR1 => regex_in_0(2),
      O => regular_expression_machine1_N_561
    );
  regular_expression_machine7_nxt_state_35_i_i_0_and2_6_14_289 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => regex_in_0(1),
      ADR1 => regex_in_1(4),
      O => regular_expression_machine0_N_907_2
    );
  regular_expression_machine7_nxt_state_35_0_0_and2_0_15_305_386 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regular_expression_machine7_N_339,
      ADR1 => regex_in_0(2),
      ADR2 => regex_in_1(4),
      O => regular_expression_machine7_nxt_state_35_0_0_and2_0_15_305
    );
  regular_expression_machine7_nxt_state_35_0_and2_0_and2_2_364_387 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regular_expression_machine7_state(11),
      ADR2 => regular_expression_machine7_state(0),
      O => regular_expression_machine7_nxt_state_35_0_and2_0_and2_2_364
    );
  regular_expression_machine7_un1_state_47_0_and2_0_and2_388_388 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => regex_in_0(5),
      ADR1 => regex_in_0(0),
      O => regular_expression_machine7_un1_state_47_0_and2_0_and2_388
    );
  regular_expression_machine7_N_108_i_389 : X_LUT4
    generic map(
      INIT => X"1101"
    )
    port map (
      ADR0 => regular_expression_machine7_N_322_1,
      ADR1 => regex_in_0(5),
      ADR2 => regular_expression_machine7_N_355_8,
      ADR3 => regular_expression_machine6_state(17),
      O => regular_expression_machine7_N_108_i
    );
  regular_expression_machine7_N_104_i_390 : X_LUT4
    generic map(
      INIT => X"5551"
    )
    port map (
      ADR0 => regular_expression_machine7_N_104_1,
      ADR1 => regular_expression_machine7_N_355_8,
      ADR2 => regular_expression_machine7_state(9),
      ADR3 => regular_expression_machine6_state(17),
      O => regular_expression_machine7_N_104_i
    );
  regular_expression_machine7_N_322_i_391 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => regular_expression_machine7_N_322_1,
      ADR1 => regex_in_0(5),
      ADR2 => regular_expression_machine7_state(9),
      O => regular_expression_machine7_N_322_i
    );
  regular_expression_machine7_next_state_N_380_i : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => regular_expression_machine7_state(15),
      ADR1 => regular_expression_machine6_state(16),
      O => regular_expression_machine7_N_380_i
    );
  regular_expression_machine7_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_373,
      O => regular_expression_machine7_state(6),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_nxt_state_35_7_Q,
      O => regular_expression_machine7_state(7),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_375,
      O => regular_expression_machine7_state(8),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_nxt_state_35_9_Q,
      O => regular_expression_machine7_state(9),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_382,
      O => regular_expression_machine7_state(10),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_322_i,
      O => regular_expression_machine7_state(11),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_381,
      O => regular_expression_machine7_state(12),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_nxt_state_35_13_Q,
      O => regular_expression_machine7_state(13),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_119,
      O => regular_expression_machine7_state(14),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_nxt_state_35_15_Q,
      O => regular_expression_machine7_state(15),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_GND,
      O => regular_expression_machine6_state(16),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_GND,
      O => regular_expression_machine6_state(17),
      SSET => cntrlr_N_882_1_i,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  regular_expression_machine7_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_108_i,
      O => regular_expression_machine7_state(0),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_376,
      O => regular_expression_machine7_state(1),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_nxt_state_35_2_Q,
      O => regular_expression_machine7_state(2),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_377,
      O => regular_expression_machine7_state(3),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_374,
      O => regular_expression_machine7_state(4),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_state_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regex_en_2,
      CLK => clk,
      I => regular_expression_machine7_N_104_i,
      O => regular_expression_machine7_state(5),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_accepted : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => regular_expression_machine7_N_380_i,
      CLK => clk,
      I => regular_expression_machine7_VCC,
      O => accepted(7),
      SRST => cntrlr_N_882_1_i,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  regular_expression_machine7_GND_392 : X_ZERO
    port map (
      O => regular_expression_machine7_GND
    );
  regular_expression_machine7_VCC_393 : X_ONE
    port map (
      O => regular_expression_machine7_VCC
    );
  cntrlr_un14_input_ptr_s_0_0_394 : X_INV
    port map (
      I => cntrlr_un14_input_ptr_cry_0,
      O => cntrlr_un14_input_ptr_s_0_0
    );
  cntrlr_un14_input_ptr_axb_1_395 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(3),
      O => cntrlr_un14_input_ptr_axb_1,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_2_396 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(4),
      O => cntrlr_un14_input_ptr_axb_2,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_3_397 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(5),
      O => cntrlr_un14_input_ptr_axb_3,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_4_398 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(6),
      O => cntrlr_un14_input_ptr_axb_4,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_5_399 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(7),
      O => cntrlr_un14_input_ptr_axb_5,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_6_400 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(8),
      O => cntrlr_un14_input_ptr_axb_6,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_7_401 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(9),
      O => cntrlr_un14_input_ptr_axb_7,
      ADR1 => GND
    );
  cntrlr_N_372_i_402 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => cntrlr_input_ptr(1),
      O => cntrlr_N_372_i,
      ADR1 => GND
    );
  cntrlr_N_373_i_403 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => cntrlr_input_ptr(2),
      O => cntrlr_N_373_i,
      ADR1 => GND
    );
  cntrlr_N_374_i_404 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => cntrlr_input_ptr(3),
      O => cntrlr_N_374_i,
      ADR1 => GND
    );
  cntrlr_un1_input_ptr_2_axb_3_405 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_input_ptr(4),
      O => cntrlr_un1_input_ptr_2_axb_3,
      ADR1 => GND
    );
  cntrlr_un1_input_ptr_2_axb_4_406 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_input_ptr(5),
      O => cntrlr_un1_input_ptr_2_axb_4,
      ADR1 => GND
    );
  cntrlr_N_375_i_407 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => cntrlr_input_ptr(6),
      O => cntrlr_N_375_i,
      ADR1 => GND
    );
  cntrlr_un1_input_ptr_2_axb_6_408 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_input_ptr(7),
      O => cntrlr_un1_input_ptr_2_axb_6,
      ADR1 => GND
    );
  cntrlr_regex_ptr_qxu_0_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(0),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(0)
    );
  cntrlr_regex_ptr_qxu_1_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(1),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(1)
    );
  cntrlr_regex_ptr_qxu_2_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(2),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(2)
    );
  cntrlr_regex_ptr_qxu_3_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(3),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(3)
    );
  cntrlr_regex_ptr_qxu_4_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(4),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(4)
    );
  cntrlr_regex_ptr_qxu_5_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(5),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(5)
    );
  cntrlr_regex_ptr_qxu_6_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(6),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(6)
    );
  cntrlr_regex_ptr_qxu_7_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(7),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(7)
    );
  cntrlr_regex_ptr_qxu_8_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(8),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(8)
    );
  cntrlr_regex_ptr_qxu_9_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(9),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(9)
    );
  cntrlr_out_ptr_qxu_0_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(0),
      ADR2 => cntrlr_out_ptr(0),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(0)
    );
  cntrlr_out_ptr_qxu_1_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(1),
      ADR2 => cntrlr_out_ptr(1),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(1)
    );
  cntrlr_out_ptr_qxu_2_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(2),
      ADR2 => cntrlr_out_ptr(2),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(2)
    );
  cntrlr_out_ptr_qxu_3_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(3),
      ADR2 => cntrlr_out_ptr(3),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(3)
    );
  cntrlr_out_ptr_qxu_4_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(4),
      ADR2 => cntrlr_out_ptr(4),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(4)
    );
  cntrlr_out_ptr_qxu_5_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(5),
      ADR2 => cntrlr_out_ptr(5),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(5)
    );
  cntrlr_out_ptr_qxu_6_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(6),
      ADR2 => cntrlr_out_ptr(6),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(6)
    );
  cntrlr_out_ptr_qxu_7_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(7),
      ADR2 => cntrlr_out_ptr(7),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(7)
    );
  cntrlr_input_ptr_qxu_0_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(0),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(0)
    );
  cntrlr_input_ptr_qxu_1_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(1),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(1)
    );
  cntrlr_input_ptr_qxu_2_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(2),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(2)
    );
  cntrlr_input_ptr_qxu_3_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(3),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(3)
    );
  cntrlr_input_ptr_qxu_4_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(4),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(4)
    );
  cntrlr_input_ptr_qxu_5_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(5),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(5)
    );
  cntrlr_input_ptr_qxu_6_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(6),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(6)
    );
  cntrlr_input_ptr_qxu_7_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(7),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(7)
    );
  cntrlr_fsm_state_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_N_838_i,
      O => cntrlr_fsm_state_1(8),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_N_836_i,
      O => cntrlr_fsm_state_1(7),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_N_834_i,
      O => cntrlr_fsm_state_1(6),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_5_Q,
      O => cntrlr_fsm_state_1(5),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_4_Q,
      O => cntrlr_fsm_state_1(4),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_3_Q,
      O => cntrlr_fsm_state_1(3),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_2_Q,
      O => cntrlr_fsm_state_1(2),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_N_845,
      O => cntrlr_fsm_state_1(1),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_N_828_i,
      O => cntrlr_fsm_state(0),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_12_Q,
      O => cntrlr_fsm_state_1(12),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_11_Q,
      O => cntrlr_fsm_state_1(11),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_fsm_state_34_10_Q,
      O => cntrlr_fsm_state_1(10),
      SET => GND,
      RST => GSR
    );
  cntrlr_fsm_state_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_reset_l_29_i,
      CLK => clk,
      I => cntrlr_N_840_i,
      O => cntrlr_fsm_state_1(9),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(0),
      O => cntrlr_regex_ptr(0),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(1),
      O => cntrlr_regex_ptr(1),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(2),
      O => cntrlr_regex_ptr(2),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(3),
      O => cntrlr_regex_ptr(3),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(4),
      O => cntrlr_regex_ptr(4),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(5),
      O => cntrlr_regex_ptr(5),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(6),
      O => cntrlr_regex_ptr(6),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(7),
      O => cntrlr_regex_ptr(7),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(8),
      O => cntrlr_regex_ptr(8),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(9),
      O => cntrlr_regex_ptr(9),
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_ptr_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1105_i,
      CLK => clk,
      I => cntrlr_regex_ptr_s(10),
      O => cntrlr_regex_ptr(10),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(0),
      O => cntrlr_out_ptr(0),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(1),
      O => cntrlr_out_ptr(1),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(2),
      O => cntrlr_out_ptr(2),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(3),
      O => cntrlr_out_ptr(3),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(4),
      O => cntrlr_out_ptr(4),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(5),
      O => cntrlr_out_ptr(5),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(6),
      O => cntrlr_out_ptr(6),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(7),
      O => cntrlr_out_ptr(7),
      SET => GND,
      RST => GSR
    );
  cntrlr_out_ptr_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1217_i,
      CLK => clk,
      I => cntrlr_out_ptr_s(8),
      O => cntrlr_out_ptr(8),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(0),
      O => cntrlr_input_ptr(0),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(1),
      O => cntrlr_input_ptr(1),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(2),
      O => cntrlr_input_ptr(2),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(3),
      O => cntrlr_input_ptr(3),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(4),
      O => cntrlr_input_ptr(4),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(5),
      O => cntrlr_input_ptr(5),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(6),
      O => cntrlr_input_ptr(6),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(7),
      O => cntrlr_input_ptr(7),
      SET => GND,
      RST => GSR
    );
  cntrlr_input_ptr_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_1194_i,
      CLK => clk,
      I => cntrlr_input_ptr_s(8),
      O => cntrlr_input_ptr(8),
      SET => GND,
      RST => GSR
    );
  cntrlr_un8_ready_l_NE_i_i_409 : X_INV
    port map (
      I => cntrlr_un8_ready_l_NE_i,
      O => cntrlr_un8_ready_l_NE_i_i
    );
  cntrlr_count_address_in_buf_full6_NE_i : X_INV
    port map (
      I => cntrlr_buf_full6_NE,
      O => cntrlr_buf_full6_NE_i
    );
  cntrlr_prev_ptr_fast_fast_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(0),
      O => cntrlr_prev_ptr_fast_fast(0),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_1_rep1_410 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(1),
      O => cntrlr_prev_ptr_1_rep1,
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_fast_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(1),
      O => cntrlr_prev_ptr_fast(1),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_fast_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(0),
      O => cntrlr_prev_ptr_fast(0),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_regex_input_machine_N_882_1_i_2 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => reset_l_0,
      O => cntrlr_N_882_1_i_2
    );
  cntrlr_regex_input_machine_N_882_1_i_1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => reset_l_0,
      O => cntrlr_N_882_1_i_1
    );
  cntrlr_regex_en_2 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_713,
      O => regex_en_2,
      SSET => cntrlr_N_868,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  cntrlr_regex_en_1 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_713,
      O => regex_en_1,
      SSET => cntrlr_N_868,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  cntrlr_un14_input_ptr_axb_0 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(2),
      O => cntrlr_un14_input_ptr_cry_0,
      ADR1 => GND
    );
  cntrlr_un14_input_ptr_axb_8_411 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(10),
      O => cntrlr_un14_input_ptr_axb_8,
      ADR1 => GND
    );
  cntrlr_un1_input_ptr_2_axb_7_412 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => cntrlr_input_ptr(8),
      O => cntrlr_un1_input_ptr_2_axb_7,
      ADR1 => GND
    );
  cntrlr_regex_in_3_7_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(7),
      IB => cntrlr_regex_in_3_bm(7),
      O => regex_in(7),
      SEL => cntrlr_prev_ptr(1)
    );
  cntrlr_regex_in_3_bm_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast_fast(0),
      ADR1 => cntrlr_char_buf_out(7),
      ADR2 => cntrlr_char_buf_out(15),
      O => cntrlr_regex_in_3_bm(7)
    );
  cntrlr_regex_in_3_am_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast_fast(0),
      ADR1 => cntrlr_char_buf_out(23),
      ADR2 => cntrlr_char_buf_out(31),
      O => cntrlr_regex_in_3_am(7)
    );
  cntrlr_regex_in_3_6_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(6),
      IB => cntrlr_regex_in_3_bm(6),
      O => regex_in(6),
      SEL => cntrlr_prev_ptr(1)
    );
  cntrlr_regex_in_3_bm_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast_fast(0),
      ADR1 => cntrlr_char_buf_out(6),
      ADR2 => cntrlr_char_buf_out(14),
      O => cntrlr_regex_in_3_bm(6)
    );
  cntrlr_regex_in_3_am_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast_fast(0),
      ADR1 => cntrlr_char_buf_out(22),
      ADR2 => cntrlr_char_buf_out(30),
      O => cntrlr_regex_in_3_am(6)
    );
  cntrlr_regex_in_3_3_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(3),
      IB => cntrlr_regex_in_3_bm(3),
      O => regex_in(3),
      SEL => cntrlr_prev_ptr(1)
    );
  cntrlr_regex_in_3_bm_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(0),
      ADR1 => cntrlr_char_buf_out(3),
      ADR2 => cntrlr_char_buf_out(11),
      O => cntrlr_regex_in_3_bm(3)
    );
  cntrlr_regex_in_3_am_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(0),
      ADR1 => cntrlr_char_buf_out(19),
      ADR2 => cntrlr_char_buf_out(27),
      O => cntrlr_regex_in_3_am(3)
    );
  cntrlr_G_400 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => cntrlr_N_852,
      ADR1 => cntrlr_N_890,
      O => cntrlr_N_891
    );
  cntrlr_regex_input_machine_fsm_state_34_0_2_Q : X_LUT4
    generic map(
      INIT => X"F222"
    )
    port map (
      ADR0 => cntrlr_fsm_state_34_0_and2_2_214,
      ADR1 => cntrlr_N_856,
      ADR2 => cntrlr_fsm_state_1(3),
      ADR3 => cntrlr_N_891,
      O => cntrlr_fsm_state_34_2_Q
    );
  cntrlr_regex_input_machine_fsm_state_34_0_10_Q : X_LUT4
    generic map(
      INIT => X"22F2"
    )
    port map (
      ADR0 => cntrlr_fsm_state_34_0_and2_0_10_189,
      ADR1 => cntrlr_un8_ready_l_NE_i,
      ADR2 => cntrlr_fsm_state_1(10),
      ADR3 => cntrlr_N_856,
      O => cntrlr_fsm_state_34_10_Q
    );
  cntrlr_regex_input_machine_fsm_state_34_0_12_Q : X_LUT4
    generic map(
      INIT => X"5575"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_N_852,
      ADR2 => cntrlr_fsm_state(0),
      ADR3 => regex_restart,
      O => cntrlr_fsm_state_34_12_Q
    );
  cntrlr_N_811_1_i_0 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => cntrlr_out_state_2_Q,
      ADR1 => cntrlr_out_state_3_Q,
      O => cntrlr_N_811_1_i
    );
  cntrlr_regex_in_3_2_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(2),
      IB => cntrlr_regex_in_3_bm(2),
      O => regex_in(2),
      SEL => cntrlr_prev_ptr(1)
    );
  cntrlr_regex_in_3_bm_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(0),
      ADR1 => cntrlr_char_buf_out(2),
      ADR2 => cntrlr_char_buf_out(10),
      O => cntrlr_regex_in_3_bm(2)
    );
  cntrlr_regex_in_3_am_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(0),
      ADR1 => cntrlr_char_buf_out(18),
      ADR2 => cntrlr_char_buf_out(26),
      O => cntrlr_regex_in_3_am(2)
    );
  cntrlr_count_address_in_un16_input_ptr_NE_7 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => cntrlr_un16_input_ptr_NE_2,
      ADR1 => cntrlr_un16_input_ptr_NE_1,
      ADR2 => cntrlr_un16_input_ptr_NE_4,
      ADR3 => cntrlr_un16_input_ptr_NE_3,
      O => cntrlr_un16_input_ptr_NE_7
    );
  cntrlr_count_address_in_un16_input_ptr_NE_4 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_input_ptr(6),
      ADR1 => cntrlr_un14_input_ptr_s_6,
      ADR2 => cntrlr_input_ptr(7),
      ADR3 => cntrlr_un14_input_ptr_s_7,
      O => cntrlr_un16_input_ptr_NE_4
    );
  cntrlr_count_address_in_un16_input_ptr_NE_3 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_input_ptr(4),
      ADR1 => cntrlr_un14_input_ptr_s_4,
      ADR2 => cntrlr_input_ptr(5),
      ADR3 => cntrlr_un14_input_ptr_s_5,
      O => cntrlr_un16_input_ptr_NE_3
    );
  cntrlr_count_address_in_un16_input_ptr_NE_2 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_input_ptr(2),
      ADR1 => cntrlr_un14_input_ptr_s_2,
      ADR2 => cntrlr_input_ptr(3),
      ADR3 => cntrlr_un14_input_ptr_s_3,
      O => cntrlr_un16_input_ptr_NE_2
    );
  cntrlr_count_address_in_un16_input_ptr_NE_1 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_input_ptr(0),
      ADR1 => cntrlr_un14_input_ptr_s_0_0,
      ADR2 => cntrlr_input_ptr(1),
      ADR3 => cntrlr_un14_input_ptr_s_1,
      O => cntrlr_un16_input_ptr_NE_1
    );
  cntrlr_count_address_in_buf_full6_NE : X_LUT3
    generic map(
      INIT => X"BE"
    )
    port map (
      ADR0 => cntrlr_buf_full6_NE_7,
      ADR1 => cntrlr_un1_input_ptr_2_s_7,
      ADR2 => cntrlr_regex_ptr(10),
      O => cntrlr_buf_full6_NE
    );
  cntrlr_count_address_in_buf_full6_NE_7 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => cntrlr_buf_full6_NE_2,
      ADR1 => cntrlr_buf_full6_NE_1,
      ADR2 => cntrlr_buf_full6_NE_4,
      ADR3 => cntrlr_buf_full6_NE_3,
      O => cntrlr_buf_full6_NE_7
    );
  cntrlr_count_address_in_buf_full6_NE_4 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_un1_input_ptr_2_s_5,
      ADR1 => cntrlr_regex_ptr(8),
      ADR2 => cntrlr_un1_input_ptr_2_s_6,
      ADR3 => cntrlr_regex_ptr(9),
      O => cntrlr_buf_full6_NE_4
    );
  cntrlr_count_address_in_buf_full6_NE_3 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_un1_input_ptr_2_s_3,
      ADR1 => cntrlr_regex_ptr(6),
      ADR2 => cntrlr_un1_input_ptr_2_s_4,
      ADR3 => cntrlr_regex_ptr(7),
      O => cntrlr_buf_full6_NE_3
    );
  cntrlr_count_address_in_buf_full6_NE_2 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_un1_input_ptr_2_s_1,
      ADR1 => cntrlr_regex_ptr(4),
      ADR2 => cntrlr_un1_input_ptr_2_s_2,
      ADR3 => cntrlr_regex_ptr(5),
      O => cntrlr_buf_full6_NE_2
    );
  cntrlr_count_address_in_buf_full6_NE_1 : X_LUT4
    generic map(
      INIT => X"9FF9"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(3),
      ADR1 => cntrlr_input_ptr(1),
      ADR2 => cntrlr_regex_ptr(2),
      ADR3 => cntrlr_input_ptr(0),
      O => cntrlr_buf_full6_NE_1
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_0_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(0),
      O => cntrlr_out_ptr_4(0)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_1_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(1),
      O => cntrlr_out_ptr_4(1)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_2_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(2),
      O => cntrlr_out_ptr_4(2)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_3_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(3),
      O => cntrlr_out_ptr_4(3)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_4_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(4),
      O => cntrlr_out_ptr_4(4)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_5_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(5),
      O => cntrlr_out_ptr_4(5)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_6_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(6),
      O => cntrlr_out_ptr_4(6)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_7_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(7),
      O => cntrlr_out_ptr_4(7)
    );
  cntrlr_output_fsm_out_ptr_4_0_and2_0_and3_8_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_fifo_dout(8),
      O => cntrlr_out_ptr_4(8)
    );
  cntrlr_G_623 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => cntrlr_input_ptr(4),
      ADR1 => cntrlr_regex_ptr(6),
      O => cntrlr_N_1074
    );
  cntrlr_G_401_i : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => reset_l_i_1,
      ADR1 => cntrlr_un8_ready_l_NE_i,
      O => cntrlr_N_1066
    );
  cntrlr_G_617 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_out_state_10_Q,
      O => cntrlr_out_ptr_lcry
    );
  cntrlr_G_309_i_or2 : X_LUT3
    generic map(
      INIT => X"D5"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_prev_ptr(1),
      ADR2 => cntrlr_prev_ptr(0),
      O => cntrlr_N_856
    );
  cntrlr_regex_input_machine_fsm_state_34_i_or2_0_Q : X_LUT4
    generic map(
      INIT => X"D555"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => regex_restart,
      ADR2 => cntrlr_prev_ptr(1),
      ADR3 => cntrlr_prev_ptr(0),
      O => cntrlr_N_853
    );
  cntrlr_G_421 : X_LUT4
    generic map(
      INIT => X"ACCC"
    )
    port map (
      ADR0 => cntrlr_char_buf_out(32),
      ADR1 => cntrlr_fsm_state(0),
      ADR2 => cntrlr_prev_ptr(1),
      ADR3 => cntrlr_prev_ptr(0),
      O => cntrlr_N_861
    );
  cntrlr_G_417 : X_LUT3
    generic map(
      INIT => X"7F"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => cntrlr_prev_ptr(1),
      ADR2 => cntrlr_prev_ptr(0),
      O => cntrlr_N_857
    );
  cntrlr_G_412 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => cntrlr_prev_ptr(0),
      ADR1 => cntrlr_prev_ptr(1),
      O => cntrlr_N_852
    );
  cntrlr_regex_input_machine_fsm_state_34_0_5_Q : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(6),
      ADR1 => cntrlr_N_891,
      ADR2 => cntrlr_fsm_state_1(5),
      ADR3 => cntrlr_N_856,
      O => cntrlr_fsm_state_34_5_Q
    );
  cntrlr_regex_input_machine_fsm_state_34_0_4_Q : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(5),
      ADR1 => cntrlr_N_891,
      ADR2 => cntrlr_fsm_state_1(4),
      ADR3 => cntrlr_N_856,
      O => cntrlr_fsm_state_34_4_Q
    );
  cntrlr_regex_input_machine_fsm_state_34_0_3_Q : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(4),
      ADR1 => cntrlr_N_891,
      ADR2 => cntrlr_fsm_state_1(3),
      ADR3 => cntrlr_N_856,
      O => cntrlr_fsm_state_34_3_Q
    );
  cntrlr_G_399 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_char_buf_out(32),
      ADR2 => regex_restart,
      O => cntrlr_N_890
    );
  cntrlr_regex_input_machine_fsm_state_34_0_11_Q : X_LUT4
    generic map(
      INIT => X"C444"
    )
    port map (
      ADR0 => cntrlr_N_857,
      ADR1 => reset_l_2,
      ADR2 => cntrlr_fsm_state_1(11),
      ADR3 => cntrlr_N_852,
      O => cntrlr_fsm_state_34_11_Q
    );
  cntrlr_regex_in_3_5_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(5),
      IB => cntrlr_regex_in_3_bm(5),
      O => regex_in(5),
      SEL => cntrlr_prev_ptr_fast(0)
    );
  cntrlr_regex_in_3_bm_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(1),
      ADR1 => cntrlr_char_buf_out(5),
      ADR2 => cntrlr_char_buf_out(21),
      O => cntrlr_regex_in_3_bm(5)
    );
  cntrlr_regex_in_3_am_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(1),
      ADR1 => cntrlr_char_buf_out(13),
      ADR2 => cntrlr_char_buf_out(29),
      O => cntrlr_regex_in_3_am(5)
    );
  cntrlr_regex_in_3_4_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(4),
      IB => cntrlr_regex_in_3_bm(4),
      O => regex_in(4),
      SEL => cntrlr_prev_ptr_fast(0)
    );
  cntrlr_regex_in_3_bm_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_1_rep1,
      ADR1 => cntrlr_char_buf_out(4),
      ADR2 => cntrlr_char_buf_out(20),
      O => cntrlr_regex_in_3_bm(4)
    );
  cntrlr_regex_in_3_am_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_1_rep1,
      ADR1 => cntrlr_char_buf_out(12),
      ADR2 => cntrlr_char_buf_out(28),
      O => cntrlr_regex_in_3_am(4)
    );
  cntrlr_regex_in_3_1_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(1),
      IB => cntrlr_regex_in_3_bm(1),
      O => regex_in(1),
      SEL => cntrlr_prev_ptr_fast(0)
    );
  cntrlr_regex_in_3_bm_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_1_rep1,
      ADR1 => cntrlr_char_buf_out(1),
      ADR2 => cntrlr_char_buf_out(17),
      O => cntrlr_regex_in_3_bm(1)
    );
  cntrlr_regex_in_3_am_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_1_rep1,
      ADR1 => cntrlr_char_buf_out(9),
      ADR2 => cntrlr_char_buf_out(25),
      O => cntrlr_regex_in_3_am(1)
    );
  cntrlr_regex_in_3_0_Q : X_MUX2
    port map (
      IA => cntrlr_regex_in_3_am(0),
      IB => cntrlr_regex_in_3_bm(0),
      O => regex_in(0),
      SEL => cntrlr_prev_ptr_fast(0)
    );
  cntrlr_regex_in_3_bm_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(1),
      ADR1 => cntrlr_char_buf_out(0),
      ADR2 => cntrlr_char_buf_out(16),
      O => cntrlr_regex_in_3_bm(0)
    );
  cntrlr_regex_in_3_am_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_prev_ptr_fast(1),
      ADR1 => cntrlr_char_buf_out(8),
      ADR2 => cntrlr_char_buf_out(24),
      O => cntrlr_regex_in_3_am(0)
    );
  cntrlr_count_address_in_un9_sof_in : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => cntrlr_dataen_in,
      ADR1 => cntrlr_sof_in,
      O => cntrlr_un9_sof_in
    );
  cntrlr_regex_input_machine_fsm_state_34_i_and2_0_Q : X_LUT4
    generic map(
      INIT => X"0004"
    )
    port map (
      ADR0 => cntrlr_N_852,
      ADR1 => cntrlr_fsm_state_34_i_and2_0_203,
      ADR2 => cntrlr_fsm_state_1(1),
      ADR3 => cntrlr_fsm_state_1(2),
      O => cntrlr_N_872
    );
  cntrlr_regex_en_0_0_and2 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => cntrlr_N_1066,
      ADR1 => cntrlr_N_857,
      ADR2 => cntrlr_fsm_state_1(1),
      ADR3 => cntrlr_char_buf_out(32),
      O => cntrlr_N_868
    );
  cntrlr_G_619 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => cntrlr_G_619_146,
      ADR1 => cntrlr_G_619_144,
      ADR2 => cntrlr_G_619_141,
      ADR3 => cntrlr_G_619_140,
      O => cntrlr_un8_ready_l_NE_i
    );
  cntrlr_un5_tca_out_appl_i_0_and2_0_and3 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => cntrlr_buf_full,
      ADR1 => enable_l,
      ADR2 => tca_appl_in,
      O => tca_out_appl
    );
  cntrlr_fifo_writes_un67_char_buf_out_0_and2 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => cntrlr_prev_ptr(0),
      ADR1 => cntrlr_prev_ptr(1),
      ADR2 => regex_restart,
      O => cntrlr_un67_char_buf_out
    );
  cntrlr_un20_dataen_out_6_413 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => cntrlr_out_state_6_Q,
      ADR1 => cntrlr_out_state_7_Q,
      ADR2 => cntrlr_out_state_4_Q,
      ADR3 => cntrlr_out_state_5_Q,
      O => cntrlr_un20_dataen_out_6
    );
  cntrlr_I_122_i : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => cntrlr_I_122_i_228,
      ADR1 => cntrlr_fsm_state_34_0_and2_2_214,
      ADR2 => cntrlr_N_891,
      O => cntrlr_N_845
    );
  cntrlr_G_619_140_414 : X_LUT4
    generic map(
      INIT => X"1001"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(0),
      ADR1 => cntrlr_regex_ptr(1),
      ADR2 => cntrlr_regex_ptr(10),
      ADR3 => cntrlr_input_ptr(8),
      O => cntrlr_G_619_140
    );
  cntrlr_G_619_141_415 : X_LUT4
    generic map(
      INIT => X"9009"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(9),
      ADR1 => cntrlr_input_ptr(7),
      ADR2 => cntrlr_regex_ptr(7),
      ADR3 => cntrlr_input_ptr(5),
      O => cntrlr_G_619_141
    );
  cntrlr_G_619_143_416 : X_LUT4
    generic map(
      INIT => X"9009"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(5),
      ADR1 => cntrlr_input_ptr(3),
      ADR2 => cntrlr_regex_ptr(4),
      ADR3 => cntrlr_input_ptr(2),
      O => cntrlr_G_619_143
    );
  cntrlr_G_619_144_417 : X_LUT4
    generic map(
      INIT => X"9009"
    )
    port map (
      ADR0 => cntrlr_regex_ptr(2),
      ADR1 => cntrlr_input_ptr(0),
      ADR2 => cntrlr_regex_ptr(3),
      ADR3 => cntrlr_input_ptr(1),
      O => cntrlr_G_619_144
    );
  cntrlr_G_619_146_418 : X_LUT4
    generic map(
      INIT => X"8008"
    )
    port map (
      ADR0 => cntrlr_G_619_143,
      ADR1 => cntrlr_N_1074,
      ADR2 => cntrlr_regex_ptr(8),
      ADR3 => cntrlr_input_ptr(6),
      O => cntrlr_G_619_146
    );
  cntrlr_regex_input_machine_fsm_state_34_0_and2_0_10_189 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => cntrlr_N_852,
      ADR1 => cntrlr_fsm_state_1(11),
      ADR2 => regex_restart,
      ADR3 => reset_l_2,
      O => cntrlr_fsm_state_34_0_and2_0_10_189
    );
  cntrlr_regex_input_machine_fsm_state_34_i_and2_0_203 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(3),
      ADR1 => cntrlr_fsm_state_1(4),
      ADR2 => cntrlr_fsm_state_1(5),
      ADR3 => cntrlr_fsm_state_1(6),
      O => cntrlr_fsm_state_34_i_and2_0_203
    );
  cntrlr_regex_en_0_0_and2_2_206 : X_LUT4
    generic map(
      INIT => X"0004"
    )
    port map (
      ADR0 => cntrlr_N_852,
      ADR1 => cntrlr_fsm_state_1(2),
      ADR2 => cntrlr_char_buf_out(32),
      ADR3 => regex_restart,
      O => regex_en_0_0_and2_2_206
    );
  cntrlr_regex_en_0_0_and2_0_207_419 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(1),
      ADR1 => cntrlr_prev_ptr(1),
      O => cntrlr_regex_en_0_0_and2_0_207
    );
  cntrlr_regex_en_0_0_and2_0_208 : X_LUT4
    generic map(
      INIT => X"80A2"
    )
    port map (
      ADR0 => cntrlr_regex_en_0_0_and2_0_207,
      ADR1 => cntrlr_length(0),
      ADR2 => cntrlr_length(1),
      ADR3 => cntrlr_prev_ptr(0),
      O => regex_en_0_0_and2_0_208
    );
  cntrlr_regex_input_machine_fsm_state_34_0_and2_2_214 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(2),
      ADR1 => cntrlr_un8_ready_l_NE_i,
      O => cntrlr_fsm_state_34_0_and2_2_214
    );
  cntrlr_regex_en_0_0_and2_1_226 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => cntrlr_N_852,
      ADR1 => cntrlr_fsm_state_1(1),
      ADR2 => cntrlr_length(0),
      ADR3 => cntrlr_length(1),
      O => regex_en_0_0_and2_1_226
    );
  cntrlr_I_122_i_228_420 : X_LUT4
    generic map(
      INIT => X"22A2"
    )
    port map (
      ADR0 => cntrlr_fsm_state_1(1),
      ADR1 => cntrlr_N_856,
      ADR2 => cntrlr_N_890,
      ADR3 => cntrlr_fsm_state_1(2),
      O => cntrlr_I_122_i_228
    );
  cntrlr_N_1208_i : X_LUT3
    generic map(
      INIT => X"7F"
    )
    port map (
      ADR0 => cntrlr_un8_ready_l_NE_i,
      ADR1 => cntrlr_fifo_empty,
      ADR2 => enable_l,
      O => ready_l
    );
  cntrlr_regex_input_machine_N_882_1_i : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => regex_restart,
      ADR1 => reset_l_2,
      O => cntrlr_N_882_1_i
    );
  cntrlr_regex_input_machine_N_840_i : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => cntrlr_N_853,
      ADR1 => cntrlr_N_852,
      ADR2 => cntrlr_fsm_state_1(9),
      ADR3 => cntrlr_fsm_state_1(10),
      O => cntrlr_N_840_i
    );
  cntrlr_un1_reset_l_29_i_421 : X_LUT4
    generic map(
      INIT => X"1F3F"
    )
    port map (
      ADR0 => cntrlr_N_857,
      ADR1 => cntrlr_un8_ready_l_NE_i,
      ADR2 => reset_l_2,
      ADR3 => cntrlr_fsm_state_1(12),
      O => cntrlr_un1_reset_l_29_i
    );
  cntrlr_regex_input_machine_N_828_i : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => cntrlr_N_853,
      ADR1 => cntrlr_N_861,
      ADR2 => cntrlr_N_872,
      O => cntrlr_N_828_i
    );
  cntrlr_regex_input_machine_N_834_i : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => cntrlr_N_853,
      ADR1 => cntrlr_N_852,
      ADR2 => cntrlr_fsm_state_1(6),
      ADR3 => cntrlr_fsm_state_1(7),
      O => cntrlr_N_834_i
    );
  cntrlr_regex_input_machine_N_836_i : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => cntrlr_N_853,
      ADR1 => cntrlr_N_852,
      ADR2 => cntrlr_fsm_state_1(7),
      ADR3 => cntrlr_fsm_state_1(8),
      O => cntrlr_N_836_i
    );
  cntrlr_regex_input_machine_N_838_i : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => cntrlr_N_853,
      ADR1 => cntrlr_N_852,
      ADR2 => cntrlr_fsm_state_1(8),
      ADR3 => cntrlr_fsm_state_1(9),
      O => cntrlr_N_838_i
    );
  cntrlr_N_1194_i_422 : X_LUT3
    generic map(
      INIT => X"FD"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_sof_in,
      ADR2 => cntrlr_dataen_in,
      O => cntrlr_N_1194_i
    );
  cntrlr_N_1217_i_423 : X_LUT3
    generic map(
      INIT => X"DF"
    )
    port map (
      ADR0 => cntrlr_out_state_11_Q,
      ADR1 => cntrlr_out_state_10_Q,
      ADR2 => reset_l_2,
      O => cntrlr_N_1217_i
    );
  cntrlr_N_1105_i_424 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => cntrlr_un8_ready_l_NE_i,
      ADR1 => reset_l_1,
      O => cntrlr_N_1105_i
    );
  cntrlr_un1_un1_buf_full6_i_425 : X_LUT4
    generic map(
      INIT => X"7557"
    )
    port map (
      ADR0 => cntrlr_buf_full6_NE,
      ADR1 => cntrlr_un16_input_ptr_NE_7,
      ADR2 => cntrlr_input_ptr(8),
      ADR3 => cntrlr_un14_input_ptr_s_8,
      O => cntrlr_un1_un1_buf_full6_i
    );
  cntrlr_out_ptr_lcry_i_426 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => cntrlr_out_state_10_Q,
      ADR1 => reset_l_1,
      O => cntrlr_out_ptr_lcry_i
    );
  cntrlr_N_412_i_427 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => cntrlr_un8_ready_l_NE_i,
      ADR1 => cntrlr_N_852,
      ADR2 => cntrlr_fsm_state_1(11),
      ADR3 => regex_restart,
      O => cntrlr_N_412_i
    );
  cntrlr_passed_ptr_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(9),
      O => cntrlr_passed_ptr(7),
      SRST => reset_l_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(8),
      O => cntrlr_passed_ptr(6),
      SRST => reset_l_i_1,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(7),
      O => cntrlr_passed_ptr(5),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(6),
      O => cntrlr_passed_ptr(4),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(5),
      O => cntrlr_passed_ptr(3),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(4),
      O => cntrlr_passed_ptr(2),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(3),
      O => cntrlr_passed_ptr(1),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(2),
      O => cntrlr_passed_ptr(0),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_passed_ptr_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un67_char_buf_out,
      CLK => clk,
      I => cntrlr_prev_ptr_2(10),
      O => cntrlr_passed_ptr(8),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(10),
      O => cntrlr_prev_ptr_2(10),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(9),
      O => cntrlr_prev_ptr_2(9),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(8),
      O => cntrlr_prev_ptr_2(8),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(7),
      O => cntrlr_prev_ptr_2(7),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(6),
      O => cntrlr_prev_ptr_2(6),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(5),
      O => cntrlr_prev_ptr_2(5),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(4),
      O => cntrlr_prev_ptr_2(4),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(3),
      O => cntrlr_prev_ptr_2(3),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(2),
      O => cntrlr_prev_ptr_2(2),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(1),
      O => cntrlr_prev_ptr(1),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_prev_ptr_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un8_ready_l_NE_i_i,
      CLK => clk,
      I => cntrlr_regex_ptr(0),
      O => cntrlr_prev_ptr(0),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_length_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_412_i,
      CLK => clk,
      I => cntrlr_char_buf_out(1),
      O => cntrlr_length(1),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_length_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_412_i,
      CLK => clk,
      I => cntrlr_char_buf_out(0),
      O => cntrlr_length(0),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(1),
      O => cntrlr_fifo_din(1),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(0),
      O => cntrlr_fifo_din(0),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(8),
      O => cntrlr_fifo_din(8),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(7),
      O => cntrlr_fifo_din(7),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(6),
      O => cntrlr_fifo_din(6),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(5),
      O => cntrlr_fifo_din(5),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(4),
      O => cntrlr_fifo_din(4),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(3),
      O => cntrlr_fifo_din(3),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_fifo_din_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_fifo_we_2,
      CLK => clk,
      I => cntrlr_passed_ptr(2),
      O => cntrlr_fifo_din(2),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(7),
      O => cntrlr_accept_arr_out(7),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(6),
      O => cntrlr_accept_arr_out(6),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(5),
      O => cntrlr_accept_arr_out(5),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(4),
      O => cntrlr_accept_arr_out(4),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(3),
      O => cntrlr_accept_arr_out(3),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(2),
      O => cntrlr_accept_arr_out(2),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(1),
      O => cntrlr_accept_arr_out(1),
      SRST => reset_l_i_2,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_accept_arr_out_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_ptr_lcry_i,
      CLK => clk,
      I => cntrlr_mfifo_out(0),
      O => cntrlr_accept_arr_out(0),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_sod_out_428 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_N_811_1_i,
      CLK => clk,
      I => cntrlr_out_state_i(2),
      O => cntrlr_sod_out,
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_buf_full_429 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_un1_un1_buf_full6_i,
      CLK => clk,
      I => cntrlr_buf_full6_NE_i,
      O => cntrlr_buf_full,
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_eof_appl_in : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_715,
      O => eof_out,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_sof_appl_in : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_8_Q,
      O => sof_out,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_dataen_appl_in : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => N_816_i,
      O => dataen_out,
      SRST => reset_l_i_6,
      SSET => eof_out,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  cntrlr_regex_en : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_713,
      O => regex_en,
      SSET => cntrlr_N_868,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  cntrlr_fifo_we_430 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_fifo_we_2,
      O => cntrlr_fifo_we,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_dataen_in_431 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => dataen_out_appl,
      O => cntrlr_dataen_in,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_eof_in_432 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => eof_out_appl,
      O => cntrlr_eof_in,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_sod_appl_in : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_sod_out,
      O => sod_out,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_sod_in_433 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => sod_out_appl,
      O => cntrlr_sod_in,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_sof_in_434 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => sof_out_appl,
      O => cntrlr_sof_in,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_702,
      O => matched_flop(1),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_703,
      O => matched_flop(2),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_704,
      O => matched_flop(3),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_705,
      O => matched_flop(4),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_706,
      O => matched_flop(5),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_707,
      O => matched_flop(6),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_708,
      O => matched_flop(7),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_matched_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_709,
      O => matched_flop(0),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(23),
      O => cntrlr_data_in(23),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(24),
      O => cntrlr_data_in(24),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(25),
      O => cntrlr_data_in(25),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(26),
      O => cntrlr_data_in(26),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(27),
      O => cntrlr_data_in(27),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(28),
      O => cntrlr_data_in(28),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(29),
      O => cntrlr_data_in(29),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(30),
      O => cntrlr_data_in(30),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(31),
      O => cntrlr_data_in(31),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(8),
      O => cntrlr_data_in(8),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(9),
      O => cntrlr_data_in(9),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(10),
      O => cntrlr_data_in(10),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(11),
      O => cntrlr_data_in(11),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(12),
      O => cntrlr_data_in(12),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(13),
      O => cntrlr_data_in(13),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(14),
      O => cntrlr_data_in(14),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(15),
      O => cntrlr_data_in(15),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(16),
      O => cntrlr_data_in(16),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(17),
      O => cntrlr_data_in(17),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(18),
      O => cntrlr_data_in(18),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(19),
      O => cntrlr_data_in(19),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(20),
      O => cntrlr_data_in(20),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(21),
      O => cntrlr_data_in(21),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(22),
      O => cntrlr_data_in(22),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(0),
      O => cntrlr_data_in(0),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(1),
      O => cntrlr_data_in(1),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(2),
      O => cntrlr_data_in(2),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(3),
      O => cntrlr_data_in(3),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(4),
      O => cntrlr_data_in(4),
      SRST => reset_l_i_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(5),
      O => cntrlr_data_in(5),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(6),
      O => cntrlr_data_in(6),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_data_in_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => d_out_appl(7),
      O => cntrlr_data_in(7),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(21),
      O => data_out(21),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(22),
      O => data_out(22),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(23),
      O => data_out(23),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(24),
      O => data_out(24),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(25),
      O => data_out(25),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(26),
      O => data_out(26),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(27),
      O => data_out(27),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(28),
      O => data_out(28),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(29),
      O => data_out(29),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(30),
      O => data_out(30),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(31),
      O => data_out(31),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(6),
      O => data_out(6),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(7),
      O => data_out(7),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(8),
      O => data_out(8),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(9),
      O => data_out(9),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(10),
      O => data_out(10),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(11),
      O => data_out(11),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(12),
      O => data_out(12),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(13),
      O => data_out(13),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(14),
      O => data_out(14),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(15),
      O => data_out(15),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(16),
      O => data_out(16),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(17),
      O => data_out(17),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(18),
      O => data_out(18),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(19),
      O => data_out(19),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(20),
      O => data_out(20),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(0),
      O => data_out(0),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(1),
      O => data_out(1),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(2),
      O => data_out(2),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(3),
      O => data_out(3),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(4),
      O => data_out(4),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_d_appl_in_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_buf_out(5),
      O => data_out(5),
      SRST => reset_l_i_8,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_input_ptr_s_8_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(7),
      I1 => cntrlr_input_ptr_qxu(8),
      O => cntrlr_input_ptr_s(8)
    );
  cntrlr_input_ptr_qxu_8_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_input_ptr(8),
      ADR3 => cntrlr_GND,
      O => cntrlr_input_ptr_qxu(8)
    );
  cntrlr_input_ptr_s_7_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(6),
      I1 => cntrlr_input_ptr_qxu(7),
      O => cntrlr_input_ptr_s(7)
    );
  cntrlr_input_ptr_s_6_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(5),
      I1 => cntrlr_input_ptr_qxu(6),
      O => cntrlr_input_ptr_s(6)
    );
  cntrlr_input_ptr_s_5_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(4),
      I1 => cntrlr_input_ptr_qxu(5),
      O => cntrlr_input_ptr_s(5)
    );
  cntrlr_input_ptr_s_4_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(3),
      I1 => cntrlr_input_ptr_qxu(4),
      O => cntrlr_input_ptr_s(4)
    );
  cntrlr_input_ptr_s_3_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(2),
      I1 => cntrlr_input_ptr_qxu(3),
      O => cntrlr_input_ptr_s(3)
    );
  cntrlr_input_ptr_s_2_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(1),
      I1 => cntrlr_input_ptr_qxu(2),
      O => cntrlr_input_ptr_s(2)
    );
  cntrlr_input_ptr_s_1_Q : X_XOR2
    port map (
      I0 => cntrlr_input_ptr_cry(0),
      I1 => cntrlr_input_ptr_qxu(1),
      O => cntrlr_input_ptr_s(1)
    );
  cntrlr_input_ptr_s_0_Q : X_XOR2
    port map (
      I0 => reset_l_1,
      I1 => cntrlr_input_ptr_qxu(0),
      O => cntrlr_input_ptr_s(0)
    );
  cntrlr_out_ptr_s_8_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(7),
      I1 => cntrlr_out_ptr_qxu(8),
      O => cntrlr_out_ptr_s(8)
    );
  cntrlr_out_ptr_qxu_8_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => cntrlr_out_ptr_lcry,
      ADR1 => cntrlr_out_ptr_4(8),
      ADR2 => cntrlr_out_ptr(8),
      ADR3 => cntrlr_GND,
      O => cntrlr_out_ptr_qxu(8)
    );
  cntrlr_out_ptr_s_7_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(6),
      I1 => cntrlr_out_ptr_qxu(7),
      O => cntrlr_out_ptr_s(7)
    );
  cntrlr_out_ptr_s_6_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(5),
      I1 => cntrlr_out_ptr_qxu(6),
      O => cntrlr_out_ptr_s(6)
    );
  cntrlr_out_ptr_s_5_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(4),
      I1 => cntrlr_out_ptr_qxu(5),
      O => cntrlr_out_ptr_s(5)
    );
  cntrlr_out_ptr_s_4_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(3),
      I1 => cntrlr_out_ptr_qxu(4),
      O => cntrlr_out_ptr_s(4)
    );
  cntrlr_out_ptr_s_3_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(2),
      I1 => cntrlr_out_ptr_qxu(3),
      O => cntrlr_out_ptr_s(3)
    );
  cntrlr_out_ptr_s_2_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(1),
      I1 => cntrlr_out_ptr_qxu(2),
      O => cntrlr_out_ptr_s(2)
    );
  cntrlr_out_ptr_s_1_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_cry(0),
      I1 => cntrlr_out_ptr_qxu(1),
      O => cntrlr_out_ptr_s(1)
    );
  cntrlr_out_ptr_s_0_Q : X_XOR2
    port map (
      I0 => cntrlr_out_ptr_lcry,
      I1 => cntrlr_out_ptr_qxu(0),
      O => cntrlr_out_ptr_s(0)
    );
  cntrlr_regex_ptr_s_10_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(9),
      I1 => cntrlr_regex_ptr_qxu(10),
      O => cntrlr_regex_ptr_s(10)
    );
  cntrlr_regex_ptr_qxu_10_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => reset_l_1,
      ADR1 => cntrlr_GND,
      ADR2 => cntrlr_regex_ptr(10),
      ADR3 => cntrlr_GND,
      O => cntrlr_regex_ptr_qxu(10)
    );
  cntrlr_regex_ptr_s_9_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(8),
      I1 => cntrlr_regex_ptr_qxu(9),
      O => cntrlr_regex_ptr_s(9)
    );
  cntrlr_regex_ptr_s_8_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(7),
      I1 => cntrlr_regex_ptr_qxu(8),
      O => cntrlr_regex_ptr_s(8)
    );
  cntrlr_regex_ptr_s_7_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(6),
      I1 => cntrlr_regex_ptr_qxu(7),
      O => cntrlr_regex_ptr_s(7)
    );
  cntrlr_regex_ptr_s_6_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(5),
      I1 => cntrlr_regex_ptr_qxu(6),
      O => cntrlr_regex_ptr_s(6)
    );
  cntrlr_regex_ptr_s_5_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(4),
      I1 => cntrlr_regex_ptr_qxu(5),
      O => cntrlr_regex_ptr_s(5)
    );
  cntrlr_regex_ptr_s_4_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(3),
      I1 => cntrlr_regex_ptr_qxu(4),
      O => cntrlr_regex_ptr_s(4)
    );
  cntrlr_regex_ptr_s_3_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(2),
      I1 => cntrlr_regex_ptr_qxu(3),
      O => cntrlr_regex_ptr_s(3)
    );
  cntrlr_regex_ptr_s_2_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(1),
      I1 => cntrlr_regex_ptr_qxu(2),
      O => cntrlr_regex_ptr_s(2)
    );
  cntrlr_regex_ptr_s_1_Q : X_XOR2
    port map (
      I0 => cntrlr_regex_ptr_cry(0),
      I1 => cntrlr_regex_ptr_qxu(1),
      O => cntrlr_regex_ptr_s(1)
    );
  cntrlr_regex_ptr_s_0_Q : X_XOR2
    port map (
      I0 => reset_l_1,
      I1 => cntrlr_regex_ptr_qxu(0),
      O => cntrlr_regex_ptr_s(0)
    );
  cntrlr_un1_input_ptr_2_s_7_435 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_6,
      I1 => cntrlr_un1_input_ptr_2_axb_7,
      O => cntrlr_un1_input_ptr_2_s_7
    );
  cntrlr_un1_input_ptr_2_s_6_436 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_5,
      I1 => cntrlr_un1_input_ptr_2_axb_6,
      O => cntrlr_un1_input_ptr_2_s_6
    );
  cntrlr_un1_input_ptr_2_s_5_437 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_4,
      I1 => cntrlr_N_375_i,
      O => cntrlr_un1_input_ptr_2_s_5
    );
  cntrlr_un1_input_ptr_2_s_4_438 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_3,
      I1 => cntrlr_un1_input_ptr_2_axb_4,
      O => cntrlr_un1_input_ptr_2_s_4
    );
  cntrlr_un1_input_ptr_2_s_3_439 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_2,
      I1 => cntrlr_un1_input_ptr_2_axb_3,
      O => cntrlr_un1_input_ptr_2_s_3
    );
  cntrlr_un1_input_ptr_2_s_2_440 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_1,
      I1 => cntrlr_N_374_i,
      O => cntrlr_un1_input_ptr_2_s_2
    );
  cntrlr_un1_input_ptr_2_s_1_441 : X_XOR2
    port map (
      I0 => cntrlr_un1_input_ptr_2_cry_0,
      I1 => cntrlr_N_373_i,
      O => cntrlr_un1_input_ptr_2_s_1
    );
  cntrlr_un14_input_ptr_s_8_442 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_7,
      I1 => cntrlr_un14_input_ptr_axb_8,
      O => cntrlr_un14_input_ptr_s_8
    );
  cntrlr_un14_input_ptr_s_7_443 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_6,
      I1 => cntrlr_un14_input_ptr_axb_7,
      O => cntrlr_un14_input_ptr_s_7
    );
  cntrlr_un14_input_ptr_s_6_444 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_5,
      I1 => cntrlr_un14_input_ptr_axb_6,
      O => cntrlr_un14_input_ptr_s_6
    );
  cntrlr_un14_input_ptr_s_5_445 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_4,
      I1 => cntrlr_un14_input_ptr_axb_5,
      O => cntrlr_un14_input_ptr_s_5
    );
  cntrlr_un14_input_ptr_s_4_446 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_3,
      I1 => cntrlr_un14_input_ptr_axb_4,
      O => cntrlr_un14_input_ptr_s_4
    );
  cntrlr_un14_input_ptr_s_3_447 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_2,
      I1 => cntrlr_un14_input_ptr_axb_3,
      O => cntrlr_un14_input_ptr_s_3
    );
  cntrlr_un14_input_ptr_s_2_448 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_1,
      I1 => cntrlr_un14_input_ptr_axb_2,
      O => cntrlr_un14_input_ptr_s_2
    );
  cntrlr_un14_input_ptr_s_1_449 : X_XOR2
    port map (
      I0 => cntrlr_un14_input_ptr_cry_0,
      I1 => cntrlr_un14_input_ptr_axb_1,
      O => cntrlr_un14_input_ptr_s_1
    );
  cntrlr_GND_450 : X_ZERO
    port map (
      O => cntrlr_GND
    );
  cntrlr_VCC_451 : X_ONE
    port map (
      O => cntrlr_VCC
    );
  cntrlr_input_ptr_cry_7_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(6),
      SEL => cntrlr_input_ptr_qxu(7),
      O => cntrlr_input_ptr_cry_7_O
    );
  cntrlr_input_ptr_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_7_O,
      O => cntrlr_input_ptr_cry(7)
    );
  cntrlr_input_ptr_cry_6_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(5),
      SEL => cntrlr_input_ptr_qxu(6),
      O => cntrlr_input_ptr_cry_6_O
    );
  cntrlr_input_ptr_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_6_O,
      O => cntrlr_input_ptr_cry(6)
    );
  cntrlr_input_ptr_cry_5_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(4),
      SEL => cntrlr_input_ptr_qxu(5),
      O => cntrlr_input_ptr_cry_5_O
    );
  cntrlr_input_ptr_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_5_O,
      O => cntrlr_input_ptr_cry(5)
    );
  cntrlr_input_ptr_cry_4_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(3),
      SEL => cntrlr_input_ptr_qxu(4),
      O => cntrlr_input_ptr_cry_4_O
    );
  cntrlr_input_ptr_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_4_O,
      O => cntrlr_input_ptr_cry(4)
    );
  cntrlr_input_ptr_cry_3_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(2),
      SEL => cntrlr_input_ptr_qxu(3),
      O => cntrlr_input_ptr_cry_3_O
    );
  cntrlr_input_ptr_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_3_O,
      O => cntrlr_input_ptr_cry(3)
    );
  cntrlr_input_ptr_cry_2_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(1),
      SEL => cntrlr_input_ptr_qxu(2),
      O => cntrlr_input_ptr_cry_2_O
    );
  cntrlr_input_ptr_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_2_O,
      O => cntrlr_input_ptr_cry(2)
    );
  cntrlr_input_ptr_cry_1_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_input_ptr_cry(0),
      SEL => cntrlr_input_ptr_qxu(1),
      O => cntrlr_input_ptr_cry_1_O
    );
  cntrlr_input_ptr_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_1_O,
      O => cntrlr_input_ptr_cry(1)
    );
  cntrlr_input_ptr_cry_0_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => reset_l_1,
      SEL => cntrlr_input_ptr_qxu(0),
      O => cntrlr_input_ptr_cry_0_O
    );
  cntrlr_input_ptr_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_input_ptr_cry_0_O,
      O => cntrlr_input_ptr_cry(0)
    );
  cntrlr_out_ptr_cry_7_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(6),
      SEL => cntrlr_out_ptr_qxu(7),
      O => cntrlr_out_ptr_cry_7_O
    );
  cntrlr_out_ptr_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_7_O,
      O => cntrlr_out_ptr_cry(7)
    );
  cntrlr_out_ptr_cry_6_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(5),
      SEL => cntrlr_out_ptr_qxu(6),
      O => cntrlr_out_ptr_cry_6_O
    );
  cntrlr_out_ptr_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_6_O,
      O => cntrlr_out_ptr_cry(6)
    );
  cntrlr_out_ptr_cry_5_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(4),
      SEL => cntrlr_out_ptr_qxu(5),
      O => cntrlr_out_ptr_cry_5_O
    );
  cntrlr_out_ptr_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_5_O,
      O => cntrlr_out_ptr_cry(5)
    );
  cntrlr_out_ptr_cry_4_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(3),
      SEL => cntrlr_out_ptr_qxu(4),
      O => cntrlr_out_ptr_cry_4_O
    );
  cntrlr_out_ptr_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_4_O,
      O => cntrlr_out_ptr_cry(4)
    );
  cntrlr_out_ptr_cry_3_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(2),
      SEL => cntrlr_out_ptr_qxu(3),
      O => cntrlr_out_ptr_cry_3_O
    );
  cntrlr_out_ptr_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_3_O,
      O => cntrlr_out_ptr_cry(3)
    );
  cntrlr_out_ptr_cry_2_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(1),
      SEL => cntrlr_out_ptr_qxu(2),
      O => cntrlr_out_ptr_cry_2_O
    );
  cntrlr_out_ptr_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_2_O,
      O => cntrlr_out_ptr_cry(2)
    );
  cntrlr_out_ptr_cry_1_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_cry(0),
      SEL => cntrlr_out_ptr_qxu(1),
      O => cntrlr_out_ptr_cry_1_O
    );
  cntrlr_out_ptr_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_1_O,
      O => cntrlr_out_ptr_cry(1)
    );
  cntrlr_out_ptr_cry_0_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_out_ptr_lcry,
      SEL => cntrlr_out_ptr_qxu(0),
      O => cntrlr_out_ptr_cry_0_O
    );
  cntrlr_out_ptr_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_out_ptr_cry_0_O,
      O => cntrlr_out_ptr_cry(0)
    );
  cntrlr_regex_ptr_cry_9_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(8),
      SEL => cntrlr_regex_ptr_qxu(9),
      O => cntrlr_regex_ptr_cry_9_O
    );
  cntrlr_regex_ptr_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_9_O,
      O => cntrlr_regex_ptr_cry(9)
    );
  cntrlr_regex_ptr_cry_8_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(7),
      SEL => cntrlr_regex_ptr_qxu(8),
      O => cntrlr_regex_ptr_cry_8_O
    );
  cntrlr_regex_ptr_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_8_O,
      O => cntrlr_regex_ptr_cry(8)
    );
  cntrlr_regex_ptr_cry_7_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(6),
      SEL => cntrlr_regex_ptr_qxu(7),
      O => cntrlr_regex_ptr_cry_7_O
    );
  cntrlr_regex_ptr_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_7_O,
      O => cntrlr_regex_ptr_cry(7)
    );
  cntrlr_regex_ptr_cry_6_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(5),
      SEL => cntrlr_regex_ptr_qxu(6),
      O => cntrlr_regex_ptr_cry_6_O
    );
  cntrlr_regex_ptr_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_6_O,
      O => cntrlr_regex_ptr_cry(6)
    );
  cntrlr_regex_ptr_cry_5_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(4),
      SEL => cntrlr_regex_ptr_qxu(5),
      O => cntrlr_regex_ptr_cry_5_O
    );
  cntrlr_regex_ptr_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_5_O,
      O => cntrlr_regex_ptr_cry(5)
    );
  cntrlr_regex_ptr_cry_4_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(3),
      SEL => cntrlr_regex_ptr_qxu(4),
      O => cntrlr_regex_ptr_cry_4_O
    );
  cntrlr_regex_ptr_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_4_O,
      O => cntrlr_regex_ptr_cry(4)
    );
  cntrlr_regex_ptr_cry_3_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(2),
      SEL => cntrlr_regex_ptr_qxu(3),
      O => cntrlr_regex_ptr_cry_3_O
    );
  cntrlr_regex_ptr_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_3_O,
      O => cntrlr_regex_ptr_cry(3)
    );
  cntrlr_regex_ptr_cry_2_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(1),
      SEL => cntrlr_regex_ptr_qxu(2),
      O => cntrlr_regex_ptr_cry_2_O
    );
  cntrlr_regex_ptr_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_2_O,
      O => cntrlr_regex_ptr_cry(2)
    );
  cntrlr_regex_ptr_cry_1_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_regex_ptr_cry(0),
      SEL => cntrlr_regex_ptr_qxu(1),
      O => cntrlr_regex_ptr_cry_1_O
    );
  cntrlr_regex_ptr_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_1_O,
      O => cntrlr_regex_ptr_cry(1)
    );
  cntrlr_regex_ptr_cry_0_Q : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => reset_l_1,
      SEL => cntrlr_regex_ptr_qxu(0),
      O => cntrlr_regex_ptr_cry_0_O
    );
  cntrlr_regex_ptr_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_regex_ptr_cry_0_O,
      O => cntrlr_regex_ptr_cry(0)
    );
  cntrlr_un1_input_ptr_2_cry_6_452 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un1_input_ptr_2_cry_5,
      SEL => cntrlr_un1_input_ptr_2_axb_6,
      O => cntrlr_un1_input_ptr_2_cry_6_O
    );
  cntrlr_un1_input_ptr_2_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_6_O,
      O => cntrlr_un1_input_ptr_2_cry_6
    );
  cntrlr_un1_input_ptr_2_cry_5_453 : X_MUX2
    port map (
      IA => cntrlr_VCC,
      IB => cntrlr_un1_input_ptr_2_cry_4,
      SEL => cntrlr_N_375_i,
      O => cntrlr_un1_input_ptr_2_cry_5_O
    );
  cntrlr_un1_input_ptr_2_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_5_O,
      O => cntrlr_un1_input_ptr_2_cry_5
    );
  cntrlr_un1_input_ptr_2_cry_4_454 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un1_input_ptr_2_cry_3,
      SEL => cntrlr_un1_input_ptr_2_axb_4,
      O => cntrlr_un1_input_ptr_2_cry_4_O
    );
  cntrlr_un1_input_ptr_2_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_4_O,
      O => cntrlr_un1_input_ptr_2_cry_4
    );
  cntrlr_un1_input_ptr_2_cry_3_455 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un1_input_ptr_2_cry_2,
      SEL => cntrlr_un1_input_ptr_2_axb_3,
      O => cntrlr_un1_input_ptr_2_cry_3_O
    );
  cntrlr_un1_input_ptr_2_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_3_O,
      O => cntrlr_un1_input_ptr_2_cry_3
    );
  cntrlr_un1_input_ptr_2_cry_2_456 : X_MUX2
    port map (
      IA => cntrlr_VCC,
      IB => cntrlr_un1_input_ptr_2_cry_1,
      SEL => cntrlr_N_374_i,
      O => cntrlr_un1_input_ptr_2_cry_2_O
    );
  cntrlr_un1_input_ptr_2_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_2_O,
      O => cntrlr_un1_input_ptr_2_cry_2
    );
  cntrlr_un1_input_ptr_2_cry_1_457 : X_MUX2
    port map (
      IA => cntrlr_VCC,
      IB => cntrlr_un1_input_ptr_2_cry_0,
      SEL => cntrlr_N_373_i,
      O => cntrlr_un1_input_ptr_2_cry_1_O
    );
  cntrlr_un1_input_ptr_2_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_1_O,
      O => cntrlr_un1_input_ptr_2_cry_1
    );
  cntrlr_un1_input_ptr_2_cry_0_458 : X_MUX2
    port map (
      IA => cntrlr_VCC,
      IB => cntrlr_GND,
      SEL => cntrlr_N_372_i,
      O => cntrlr_un1_input_ptr_2_cry_0_O
    );
  cntrlr_un1_input_ptr_2_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un1_input_ptr_2_cry_0_O,
      O => cntrlr_un1_input_ptr_2_cry_0
    );
  cntrlr_un14_input_ptr_cry_7_459 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_6,
      SEL => cntrlr_un14_input_ptr_axb_7,
      O => cntrlr_un14_input_ptr_cry_7_O
    );
  cntrlr_un14_input_ptr_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_7_O,
      O => cntrlr_un14_input_ptr_cry_7
    );
  cntrlr_un14_input_ptr_cry_6_460 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_5,
      SEL => cntrlr_un14_input_ptr_axb_6,
      O => cntrlr_un14_input_ptr_cry_6_O
    );
  cntrlr_un14_input_ptr_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_6_O,
      O => cntrlr_un14_input_ptr_cry_6
    );
  cntrlr_un14_input_ptr_cry_5_461 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_4,
      SEL => cntrlr_un14_input_ptr_axb_5,
      O => cntrlr_un14_input_ptr_cry_5_O
    );
  cntrlr_un14_input_ptr_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_5_O,
      O => cntrlr_un14_input_ptr_cry_5
    );
  cntrlr_un14_input_ptr_cry_4_462 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_3,
      SEL => cntrlr_un14_input_ptr_axb_4,
      O => cntrlr_un14_input_ptr_cry_4_O
    );
  cntrlr_un14_input_ptr_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_4_O,
      O => cntrlr_un14_input_ptr_cry_4
    );
  cntrlr_un14_input_ptr_cry_3_463 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_2,
      SEL => cntrlr_un14_input_ptr_axb_3,
      O => cntrlr_un14_input_ptr_cry_3_O
    );
  cntrlr_un14_input_ptr_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_3_O,
      O => cntrlr_un14_input_ptr_cry_3
    );
  cntrlr_un14_input_ptr_cry_2_464 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_1,
      SEL => cntrlr_un14_input_ptr_axb_2,
      O => cntrlr_un14_input_ptr_cry_2_O
    );
  cntrlr_un14_input_ptr_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_2_O,
      O => cntrlr_un14_input_ptr_cry_2
    );
  cntrlr_un14_input_ptr_cry_1_465 : X_MUX2
    port map (
      IA => cntrlr_GND,
      IB => cntrlr_un14_input_ptr_cry_0,
      SEL => cntrlr_un14_input_ptr_axb_1,
      O => cntrlr_un14_input_ptr_cry_1_O
    );
  cntrlr_un14_input_ptr_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_un14_input_ptr_cry_1_O,
      O => cntrlr_un14_input_ptr_cry_1
    );
  cntrlr_output_fifo_VCC : X_ONE
    port map (
      O => cntrlr_output_fifo_N2147483644
    );
  cntrlr_output_fifo_GND : X_ZERO
    port map (
      O => cntrlr_output_fifo_N2147483641
    );
  cntrlr_output_fifo_BU0 : X_RAMB4_S16_S16
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_output_fifo_N2147483644,
      ENB => cntrlr_output_fifo_N116,
      WEA => cntrlr_output_fifo_N118,
      WEB => cntrlr_output_fifo_N2147483641,
      RSTA => cntrlr_output_fifo_N2147483641,
      RSTB => cntrlr_output_fifo_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DIA(15) => cntrlr_output_fifo_N2147483641,
      DIA(14) => cntrlr_output_fifo_N2147483641,
      DIA(13) => cntrlr_output_fifo_N2147483641,
      DIA(12) => cntrlr_output_fifo_N2147483641,
      DIA(11) => cntrlr_output_fifo_N2147483641,
      DIA(10) => cntrlr_output_fifo_N2147483641,
      DIA(9) => cntrlr_output_fifo_N2147483641,
      DIA(8) => cntrlr_fifo_din(8),
      DIA(7) => cntrlr_fifo_din(7),
      DIA(6) => cntrlr_fifo_din(6),
      DIA(5) => cntrlr_fifo_din(5),
      DIA(4) => cntrlr_fifo_din(4),
      DIA(3) => cntrlr_fifo_din(3),
      DIA(2) => cntrlr_fifo_din(2),
      DIA(1) => cntrlr_fifo_din(1),
      DIA(0) => cntrlr_fifo_din(0),
      DOB(15) => NLW_cntrlr_output_fifo_BU0_DOB_15_UNCONNECTED,
      DOB(14) => NLW_cntrlr_output_fifo_BU0_DOB_14_UNCONNECTED,
      DOB(13) => NLW_cntrlr_output_fifo_BU0_DOB_13_UNCONNECTED,
      DOB(12) => NLW_cntrlr_output_fifo_BU0_DOB_12_UNCONNECTED,
      DOB(11) => NLW_cntrlr_output_fifo_BU0_DOB_11_UNCONNECTED,
      DOB(10) => NLW_cntrlr_output_fifo_BU0_DOB_10_UNCONNECTED,
      DOB(9) => NLW_cntrlr_output_fifo_BU0_DOB_9_UNCONNECTED,
      DOB(8) => cntrlr_fifo_dout(8),
      DOB(7) => cntrlr_fifo_dout(7),
      DOB(6) => cntrlr_fifo_dout(6),
      DOB(5) => cntrlr_fifo_dout(5),
      DOB(4) => cntrlr_fifo_dout(4),
      DOB(3) => cntrlr_fifo_dout(3),
      DOB(2) => cntrlr_fifo_dout(2),
      DOB(1) => cntrlr_fifo_dout(1),
      DOB(0) => cntrlr_fifo_dout(0),
      DOA(15) => NLW_cntrlr_output_fifo_BU0_DOA_15_UNCONNECTED,
      DOA(14) => NLW_cntrlr_output_fifo_BU0_DOA_14_UNCONNECTED,
      DOA(13) => NLW_cntrlr_output_fifo_BU0_DOA_13_UNCONNECTED,
      DOA(12) => NLW_cntrlr_output_fifo_BU0_DOA_12_UNCONNECTED,
      DOA(11) => NLW_cntrlr_output_fifo_BU0_DOA_11_UNCONNECTED,
      DOA(10) => NLW_cntrlr_output_fifo_BU0_DOA_10_UNCONNECTED,
      DOA(9) => NLW_cntrlr_output_fifo_BU0_DOA_9_UNCONNECTED,
      DOA(8) => NLW_cntrlr_output_fifo_BU0_DOA_8_UNCONNECTED,
      DOA(7) => NLW_cntrlr_output_fifo_BU0_DOA_7_UNCONNECTED,
      DOA(6) => NLW_cntrlr_output_fifo_BU0_DOA_6_UNCONNECTED,
      DOA(5) => NLW_cntrlr_output_fifo_BU0_DOA_5_UNCONNECTED,
      DOA(4) => NLW_cntrlr_output_fifo_BU0_DOA_4_UNCONNECTED,
      DOA(3) => NLW_cntrlr_output_fifo_BU0_DOA_3_UNCONNECTED,
      DOA(2) => NLW_cntrlr_output_fifo_BU0_DOA_2_UNCONNECTED,
      DOA(1) => NLW_cntrlr_output_fifo_BU0_DOA_1_UNCONNECTED,
      DOA(0) => NLW_cntrlr_output_fifo_BU0_DOA_0_UNCONNECTED,
      DIB(15) => cntrlr_output_fifo_N2147483641,
      DIB(14) => cntrlr_output_fifo_N2147483641,
      DIB(13) => cntrlr_output_fifo_N2147483641,
      DIB(12) => cntrlr_output_fifo_N2147483641,
      DIB(11) => cntrlr_output_fifo_N2147483641,
      DIB(10) => cntrlr_output_fifo_N2147483641,
      DIB(9) => cntrlr_output_fifo_N2147483641,
      DIB(8) => cntrlr_output_fifo_N2147483641,
      DIB(7) => cntrlr_output_fifo_N2147483641,
      DIB(6) => cntrlr_output_fifo_N2147483641,
      DIB(5) => cntrlr_output_fifo_N2147483641,
      DIB(4) => cntrlr_output_fifo_N2147483641,
      DIB(3) => cntrlr_output_fifo_N2147483641,
      DIB(2) => cntrlr_output_fifo_N2147483641,
      DIB(1) => cntrlr_output_fifo_N2147483641,
      DIB(0) => cntrlr_output_fifo_N2147483641,
      ADDRB(7) => cntrlr_output_fifo_N2147483641,
      ADDRB(6) => cntrlr_output_fifo_N2147483641,
      ADDRB(5) => cntrlr_output_fifo_N2147483641,
      ADDRB(4) => cntrlr_output_fifo_N2147483641,
      ADDRB(3) => cntrlr_output_fifo_N111,
      ADDRB(2) => cntrlr_output_fifo_N112,
      ADDRB(1) => cntrlr_output_fifo_N113,
      ADDRB(0) => cntrlr_output_fifo_N114,
      ADDRA(7) => cntrlr_output_fifo_N2147483641,
      ADDRA(6) => cntrlr_output_fifo_N2147483641,
      ADDRA(5) => cntrlr_output_fifo_N2147483641,
      ADDRA(4) => cntrlr_output_fifo_N2147483641,
      ADDRA(3) => cntrlr_output_fifo_N106,
      ADDRA(2) => cntrlr_output_fifo_N107,
      ADDRA(1) => cntrlr_output_fifo_N108,
      ADDRA(0) => cntrlr_output_fifo_N109
    );
  cntrlr_output_fifo_BU1 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => N_812_1,
      ADR1 => cntrlr_fifo_empty,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N760
    );
  cntrlr_output_fifo_BU2 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => N_812_1,
      ADR1 => cntrlr_fifo_empty,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N116
    );
  cntrlr_output_fifo_BU3 : X_LUT4
    generic map(
      INIT => X"5555"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N114,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1078
    );
  cntrlr_output_fifo_BU4 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N2147483641,
      IA => cntrlr_output_fifo_N114,
      O => cntrlr_output_fifo_N1092,
      SEL => cntrlr_output_fifo_N1078
    );
  cntrlr_output_fifo_BU5 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N2147483641,
      I1 => cntrlr_output_fifo_N1078,
      O => cntrlr_output_fifo_N1073
    );
  cntrlr_output_fifo_BU6 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1073,
      O => cntrlr_output_fifo_N114,
      RST => cntrlr_output_fifo_BU6_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU7 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N113,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1108
    );
  cntrlr_output_fifo_BU8 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N1092,
      IA => cntrlr_output_fifo_N113,
      O => cntrlr_output_fifo_N1122,
      SEL => cntrlr_output_fifo_N1108
    );
  cntrlr_output_fifo_BU9 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1092,
      I1 => cntrlr_output_fifo_N1108,
      O => cntrlr_output_fifo_N1074
    );
  cntrlr_output_fifo_BU10 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1074,
      O => cntrlr_output_fifo_N113,
      RST => cntrlr_output_fifo_BU10_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU11 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N112,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1138
    );
  cntrlr_output_fifo_BU12 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N1122,
      IA => cntrlr_output_fifo_N112,
      O => cntrlr_output_fifo_N1152,
      SEL => cntrlr_output_fifo_N1138
    );
  cntrlr_output_fifo_BU13 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1122,
      I1 => cntrlr_output_fifo_N1138,
      O => cntrlr_output_fifo_N1075
    );
  cntrlr_output_fifo_BU14 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1075,
      O => cntrlr_output_fifo_N112,
      RST => cntrlr_output_fifo_BU14_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU15 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N111,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1168
    );
  cntrlr_output_fifo_BU16 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1152,
      I1 => cntrlr_output_fifo_N1168,
      O => cntrlr_output_fifo_N1076
    );
  cntrlr_output_fifo_BU17 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1076,
      O => cntrlr_output_fifo_N111,
      RST => cntrlr_output_fifo_BU17_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU18 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N114,
      ADR1 => cntrlr_output_fifo_N113,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1339
    );
  cntrlr_output_fifo_BU19 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1339,
      O => cntrlr_output_fifo_N805,
      RST => cntrlr_output_fifo_BU19_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU20 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N113,
      ADR1 => cntrlr_output_fifo_N112,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1415
    );
  cntrlr_output_fifo_BU21 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1415,
      O => cntrlr_output_fifo_N804,
      RST => cntrlr_output_fifo_BU21_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU22 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N112,
      ADR1 => cntrlr_output_fifo_N111,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1491
    );
  cntrlr_output_fifo_BU23 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1491,
      O => cntrlr_output_fifo_N803,
      RST => cntrlr_output_fifo_BU23_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU24 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N111,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1567
    );
  cntrlr_output_fifo_BU25 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU25_GSR_OR,
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N1567,
      O => cntrlr_output_fifo_N802,
      RST => GND
    );
  cntrlr_output_fifo_BU26 : X_LUT4
    generic map(
      INIT => X"fffe"
    )
    port map (
      ADR0 => N_812_1,
      ADR1 => cntrlr_fifo_empty,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1636
    );
  cntrlr_output_fifo_BU28 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU28_GSR_OR,
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N845,
      O => cntrlr_output_fifo_N855,
      RST => GND
    );
  cntrlr_output_fifo_BU29 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N2147483641,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1640
    );
  cntrlr_output_fifo_BU31 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N844,
      O => cntrlr_output_fifo_N854,
      RST => cntrlr_output_fifo_BU31_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU32 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N805,
      ADR1 => cntrlr_output_fifo_N845,
      ADR2 => cntrlr_output_fifo_N855,
      ADR3 => cntrlr_fifo_empty,
      O => cntrlr_output_fifo_N1628
    );
  cntrlr_output_fifo_BU33 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N2147483644,
      IA => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1633,
      SEL => cntrlr_output_fifo_N1628
    );
  cntrlr_output_fifo_BU34 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N2147483641,
      CLK => cntrlr_output_fifo_N2147483641,
      I => cntrlr_output_fifo_N2147483641,
      O => NLW_cntrlr_output_fifo_BU34_O_UNCONNECTED,
      RST => GSR,
      SET => GND
    );
  cntrlr_output_fifo_BU35 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N804,
      ADR1 => cntrlr_output_fifo_N844,
      ADR2 => cntrlr_output_fifo_N854,
      ADR3 => cntrlr_fifo_empty,
      O => cntrlr_output_fifo_N1627
    );
  cntrlr_output_fifo_BU36 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N1633,
      IA => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1632,
      SEL => cntrlr_output_fifo_N1627
    );
  cntrlr_output_fifo_BU37 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N843,
      O => cntrlr_output_fifo_N853,
      RST => cntrlr_output_fifo_BU37_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU38 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N803,
      ADR1 => cntrlr_output_fifo_N843,
      ADR2 => cntrlr_output_fifo_N853,
      ADR3 => cntrlr_fifo_empty,
      O => cntrlr_output_fifo_N1626
    );
  cntrlr_output_fifo_BU39 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N1632,
      IA => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1631,
      SEL => cntrlr_output_fifo_N1626
    );
  cntrlr_output_fifo_BU40 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU40_GSR_OR,
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N842,
      O => cntrlr_output_fifo_N852,
      RST => GND
    );
  cntrlr_output_fifo_BU41 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N802,
      ADR1 => cntrlr_output_fifo_N842,
      ADR2 => cntrlr_output_fifo_N852,
      ADR3 => cntrlr_fifo_empty,
      O => cntrlr_output_fifo_N1625
    );
  cntrlr_output_fifo_BU43 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N2147483641,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => NLW_cntrlr_output_fifo_BU43_O_UNCONNECTED
    );
  cntrlr_output_fifo_BU44 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1630,
      I1 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1638
    );
  cntrlr_output_fifo_BU45 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU45_GSR_OR,
      CE => cntrlr_output_fifo_N1636,
      CLK => clk,
      I => cntrlr_output_fifo_N1638,
      O => cntrlr_fifo_empty,
      RST => GND
    );
  cntrlr_output_fifo_BU46 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => cntrlr_fifo_we,
      ADR1 => cntrlr_output_fifo_full,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N764
    );
  cntrlr_output_fifo_BU47 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => cntrlr_fifo_we,
      ADR1 => cntrlr_output_fifo_full,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N118
    );
  cntrlr_output_fifo_BU48 : X_LUT4
    generic map(
      INIT => X"5555"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N109,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1907
    );
  cntrlr_output_fifo_BU49 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N2147483641,
      IA => cntrlr_output_fifo_N109,
      O => cntrlr_output_fifo_N1921,
      SEL => cntrlr_output_fifo_N1907
    );
  cntrlr_output_fifo_BU50 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N2147483641,
      I1 => cntrlr_output_fifo_N1907,
      O => cntrlr_output_fifo_N1902
    );
  cntrlr_output_fifo_BU51 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N1902,
      O => cntrlr_output_fifo_N109,
      RST => cntrlr_output_fifo_BU51_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU52 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N108,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1937
    );
  cntrlr_output_fifo_BU53 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N1921,
      IA => cntrlr_output_fifo_N108,
      O => cntrlr_output_fifo_N1951,
      SEL => cntrlr_output_fifo_N1937
    );
  cntrlr_output_fifo_BU54 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1921,
      I1 => cntrlr_output_fifo_N1937,
      O => cntrlr_output_fifo_N1903
    );
  cntrlr_output_fifo_BU55 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N1903,
      O => cntrlr_output_fifo_N108,
      RST => cntrlr_output_fifo_BU55_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU56 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N107,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1967
    );
  cntrlr_output_fifo_BU57 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N1951,
      IA => cntrlr_output_fifo_N107,
      O => cntrlr_output_fifo_N1981,
      SEL => cntrlr_output_fifo_N1967
    );
  cntrlr_output_fifo_BU58 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1951,
      I1 => cntrlr_output_fifo_N1967,
      O => cntrlr_output_fifo_N1904
    );
  cntrlr_output_fifo_BU59 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N1904,
      O => cntrlr_output_fifo_N107,
      RST => cntrlr_output_fifo_BU59_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU60 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N106,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N1997
    );
  cntrlr_output_fifo_BU61 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N1981,
      I1 => cntrlr_output_fifo_N1997,
      O => cntrlr_output_fifo_N1905
    );
  cntrlr_output_fifo_BU62 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N1905,
      O => cntrlr_output_fifo_N106,
      RST => cntrlr_output_fifo_BU62_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU63 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N109,
      ADR1 => cntrlr_output_fifo_N108,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2168
    );
  cntrlr_output_fifo_BU64 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N2168,
      O => cntrlr_output_fifo_N845,
      RST => cntrlr_output_fifo_BU64_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU65 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N108,
      ADR1 => cntrlr_output_fifo_N107,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2244
    );
  cntrlr_output_fifo_BU66 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N2244,
      O => cntrlr_output_fifo_N844,
      RST => cntrlr_output_fifo_BU66_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU67 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N107,
      ADR1 => cntrlr_output_fifo_N106,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2320
    );
  cntrlr_output_fifo_BU68 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N2320,
      O => cntrlr_output_fifo_N843,
      RST => cntrlr_output_fifo_BU68_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU69 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N106,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2396
    );
  cntrlr_output_fifo_BU70 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU70_GSR_OR,
      CE => cntrlr_output_fifo_N764,
      CLK => clk,
      I => cntrlr_output_fifo_N2396,
      O => cntrlr_output_fifo_N842,
      RST => GND
    );
  cntrlr_output_fifo_BU71 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU71_GSR_OR,
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N805,
      O => cntrlr_output_fifo_N815,
      RST => GND
    );
  cntrlr_output_fifo_BU72 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N804,
      O => cntrlr_output_fifo_N814,
      RST => cntrlr_output_fifo_BU72_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU73 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N803,
      O => cntrlr_output_fifo_N813,
      RST => cntrlr_output_fifo_BU73_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU74 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU74_GSR_OR,
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N802,
      O => cntrlr_output_fifo_N812,
      RST => GND
    );
  cntrlr_output_fifo_BU75 : X_LUT4
    generic map(
      INIT => X"fffe"
    )
    port map (
      ADR0 => cntrlr_fifo_we,
      ADR1 => cntrlr_output_fifo_full,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2563
    );
  cntrlr_output_fifo_BU77 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU77_GSR_OR,
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N815,
      O => cntrlr_output_fifo_N820,
      RST => GND
    );
  cntrlr_output_fifo_BU78 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N2147483641,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2567
    );
  cntrlr_output_fifo_BU80 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU80_GSR_OR,
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N814,
      O => cntrlr_output_fifo_N819,
      RST => GND
    );
  cntrlr_output_fifo_BU81 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N845,
      ADR1 => cntrlr_output_fifo_N815,
      ADR2 => cntrlr_output_fifo_N820,
      ADR3 => cntrlr_output_fifo_full,
      O => cntrlr_output_fifo_N2555
    );
  cntrlr_output_fifo_BU82 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N2147483644,
      IA => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2560,
      SEL => cntrlr_output_fifo_N2555
    );
  cntrlr_output_fifo_BU83 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N2147483641,
      CLK => cntrlr_output_fifo_N2147483641,
      I => cntrlr_output_fifo_N2147483641,
      O => NLW_cntrlr_output_fifo_BU83_O_UNCONNECTED,
      RST => GSR,
      SET => GND
    );
  cntrlr_output_fifo_BU84 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N844,
      ADR1 => cntrlr_output_fifo_N814,
      ADR2 => cntrlr_output_fifo_N819,
      ADR3 => cntrlr_output_fifo_full,
      O => cntrlr_output_fifo_N2554
    );
  cntrlr_output_fifo_BU85 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N2560,
      IA => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2559,
      SEL => cntrlr_output_fifo_N2554
    );
  cntrlr_output_fifo_BU86 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N813,
      O => cntrlr_output_fifo_N818,
      RST => cntrlr_output_fifo_BU86_GSR_OR,
      SET => GND
    );
  cntrlr_output_fifo_BU87 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N843,
      ADR1 => cntrlr_output_fifo_N813,
      ADR2 => cntrlr_output_fifo_N818,
      ADR3 => cntrlr_output_fifo_full,
      O => cntrlr_output_fifo_N2553
    );
  cntrlr_output_fifo_BU88 : X_MUX2
    port map (
      IB => cntrlr_output_fifo_N2559,
      IA => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2558,
      SEL => cntrlr_output_fifo_N2553
    );
  cntrlr_output_fifo_BU89 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU89_GSR_OR,
      CE => cntrlr_output_fifo_N760,
      CLK => clk,
      I => cntrlr_output_fifo_N812,
      O => cntrlr_output_fifo_N817,
      RST => GND
    );
  cntrlr_output_fifo_BU90 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N842,
      ADR1 => cntrlr_output_fifo_N812,
      ADR2 => cntrlr_output_fifo_N817,
      ADR3 => cntrlr_output_fifo_full,
      O => cntrlr_output_fifo_N2552
    );
  cntrlr_output_fifo_BU92 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => cntrlr_output_fifo_N2147483641,
      ADR1 => cntrlr_output_fifo_N2147483641,
      ADR2 => cntrlr_output_fifo_N2147483641,
      ADR3 => cntrlr_output_fifo_N2147483641,
      O => NLW_cntrlr_output_fifo_BU92_O_UNCONNECTED
    );
  cntrlr_output_fifo_BU93 : X_XOR2
    port map (
      I0 => cntrlr_output_fifo_N2557,
      I1 => cntrlr_output_fifo_N2147483641,
      O => cntrlr_output_fifo_N2565
    );
  cntrlr_output_fifo_BU94 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => cntrlr_output_fifo_BU94_GSR_OR,
      CE => cntrlr_output_fifo_N2563,
      CLK => clk,
      I => cntrlr_output_fifo_N2565,
      O => cntrlr_output_fifo_full,
      RST => GND
    );
  cntrlr_output_fifo_BU27 : X_MUX2
    port map (
      IA => cntrlr_output_fifo_N2147483641,
      IB => cntrlr_output_fifo_N2147483644,
      SEL => NLW_cntrlr_output_fifo_BU27_SEL_UNCONNECTED,
      O => cntrlr_output_fifo_BU27_O
    );
  cntrlr_output_fifo_BU27_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_output_fifo_BU27_O,
      O => cntrlr_output_fifo_BU27_LO
    );
  cntrlr_output_fifo_BU30 : X_MUX2
    port map (
      IA => cntrlr_output_fifo_N2147483641,
      IB => cntrlr_output_fifo_N2147483644,
      SEL => cntrlr_output_fifo_N1640,
      O => cntrlr_output_fifo_BU30_O
    );
  cntrlr_output_fifo_BU30_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_output_fifo_BU30_O,
      O => cntrlr_output_fifo_BU30_LO
    );
  cntrlr_output_fifo_BU42 : X_MUX2
    port map (
      IA => cntrlr_output_fifo_N2147483641,
      IB => cntrlr_output_fifo_N1631,
      SEL => cntrlr_output_fifo_N1625,
      O => cntrlr_output_fifo_BU42_O
    );
  cntrlr_output_fifo_BU42_MUXCY_D_BUF : X_BUF
    port map (
      I => cntrlr_output_fifo_BU42_O,
      O => cntrlr_output_fifo_N1630
    );
  cntrlr_output_fifo_BU76 : X_MUX2
    port map (
      IA => cntrlr_output_fifo_N2147483641,
      IB => cntrlr_output_fifo_N2147483644,
      SEL => NLW_cntrlr_output_fifo_BU76_SEL_UNCONNECTED,
      O => cntrlr_output_fifo_BU76_O
    );
  cntrlr_output_fifo_BU76_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_output_fifo_BU76_O,
      O => cntrlr_output_fifo_BU76_LO
    );
  cntrlr_output_fifo_BU79 : X_MUX2
    port map (
      IA => cntrlr_output_fifo_N2147483641,
      IB => cntrlr_output_fifo_N2147483644,
      SEL => cntrlr_output_fifo_N2567,
      O => cntrlr_output_fifo_BU79_O
    );
  cntrlr_output_fifo_BU79_MUXCY_L_BUF : X_BUF
    port map (
      I => cntrlr_output_fifo_BU79_O,
      O => cntrlr_output_fifo_BU79_LO
    );
  cntrlr_output_fifo_BU91 : X_MUX2
    port map (
      IA => cntrlr_output_fifo_N2147483641,
      IB => cntrlr_output_fifo_N2558,
      SEL => cntrlr_output_fifo_N2552,
      O => cntrlr_output_fifo_BU91_O
    );
  cntrlr_output_fifo_BU91_MUXCY_D_BUF : X_BUF
    port map (
      I => cntrlr_output_fifo_BU91_O,
      O => cntrlr_output_fifo_N2557
    );
  cntrlr_output_buffer_VCC : X_ONE
    port map (
      O => cntrlr_output_buffer_N2147483644
    );
  cntrlr_output_buffer_GND : X_ZERO
    port map (
      O => cntrlr_output_buffer_N2147483641
    );
  cntrlr_output_buffer_BU0 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_output_buffer_N2147483644,
      ENB => cntrlr_output_buffer_N2147483644,
      WEA => cntrlr_output_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_output_buffer_N2147483641,
      RSTB => cntrlr_output_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_out_buf_out(7),
      DOA(6) => cntrlr_out_buf_out(6),
      DOA(5) => cntrlr_out_buf_out(5),
      DOA(4) => cntrlr_out_buf_out(4),
      DOA(3) => cntrlr_out_buf_out(3),
      DOA(2) => cntrlr_out_buf_out(2),
      DOA(1) => cntrlr_out_buf_out(1),
      DOA(0) => cntrlr_out_buf_out(0),
      DIB(7) => cntrlr_data_in(7),
      DIB(6) => cntrlr_data_in(6),
      DIB(5) => cntrlr_data_in(5),
      DIB(4) => cntrlr_data_in(4),
      DIB(3) => cntrlr_data_in(3),
      DIB(2) => cntrlr_data_in(2),
      DIB(1) => cntrlr_data_in(1),
      DIB(0) => cntrlr_data_in(0),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_output_buffer_N2147483641,
      DIA(6) => cntrlr_output_buffer_N2147483641,
      DIA(5) => cntrlr_output_buffer_N2147483641,
      DIA(4) => cntrlr_output_buffer_N2147483641,
      DIA(3) => cntrlr_output_buffer_N2147483641,
      DIA(2) => cntrlr_output_buffer_N2147483641,
      DIA(1) => cntrlr_output_buffer_N2147483641,
      DIA(0) => cntrlr_output_buffer_N2147483641,
      ADDRA(8) => cntrlr_out_ptr(8),
      ADDRA(7) => cntrlr_out_ptr(7),
      ADDRA(6) => cntrlr_out_ptr(6),
      ADDRA(5) => cntrlr_out_ptr(5),
      ADDRA(4) => cntrlr_out_ptr(4),
      ADDRA(3) => cntrlr_out_ptr(3),
      ADDRA(2) => cntrlr_out_ptr(2),
      ADDRA(1) => cntrlr_out_ptr(1),
      ADDRA(0) => cntrlr_out_ptr(0),
      DOB(7) => NLW_cntrlr_output_buffer_BU0_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_output_buffer_BU0_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_output_buffer_BU0_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_output_buffer_BU0_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_output_buffer_BU0_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_output_buffer_BU0_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_output_buffer_BU0_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_output_buffer_BU0_DOB_0_UNCONNECTED
    );
  cntrlr_output_buffer_BU1 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_output_buffer_N2147483644,
      ENB => cntrlr_output_buffer_N2147483644,
      WEA => cntrlr_output_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_output_buffer_N2147483641,
      RSTB => cntrlr_output_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_out_buf_out(15),
      DOA(6) => cntrlr_out_buf_out(14),
      DOA(5) => cntrlr_out_buf_out(13),
      DOA(4) => cntrlr_out_buf_out(12),
      DOA(3) => cntrlr_out_buf_out(11),
      DOA(2) => cntrlr_out_buf_out(10),
      DOA(1) => cntrlr_out_buf_out(9),
      DOA(0) => cntrlr_out_buf_out(8),
      DIB(7) => cntrlr_data_in(15),
      DIB(6) => cntrlr_data_in(14),
      DIB(5) => cntrlr_data_in(13),
      DIB(4) => cntrlr_data_in(12),
      DIB(3) => cntrlr_data_in(11),
      DIB(2) => cntrlr_data_in(10),
      DIB(1) => cntrlr_data_in(9),
      DIB(0) => cntrlr_data_in(8),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_output_buffer_N2147483641,
      DIA(6) => cntrlr_output_buffer_N2147483641,
      DIA(5) => cntrlr_output_buffer_N2147483641,
      DIA(4) => cntrlr_output_buffer_N2147483641,
      DIA(3) => cntrlr_output_buffer_N2147483641,
      DIA(2) => cntrlr_output_buffer_N2147483641,
      DIA(1) => cntrlr_output_buffer_N2147483641,
      DIA(0) => cntrlr_output_buffer_N2147483641,
      ADDRA(8) => cntrlr_out_ptr(8),
      ADDRA(7) => cntrlr_out_ptr(7),
      ADDRA(6) => cntrlr_out_ptr(6),
      ADDRA(5) => cntrlr_out_ptr(5),
      ADDRA(4) => cntrlr_out_ptr(4),
      ADDRA(3) => cntrlr_out_ptr(3),
      ADDRA(2) => cntrlr_out_ptr(2),
      ADDRA(1) => cntrlr_out_ptr(1),
      ADDRA(0) => cntrlr_out_ptr(0),
      DOB(7) => NLW_cntrlr_output_buffer_BU1_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_output_buffer_BU1_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_output_buffer_BU1_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_output_buffer_BU1_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_output_buffer_BU1_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_output_buffer_BU1_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_output_buffer_BU1_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_output_buffer_BU1_DOB_0_UNCONNECTED
    );
  cntrlr_output_buffer_BU2 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_output_buffer_N2147483644,
      ENB => cntrlr_output_buffer_N2147483644,
      WEA => cntrlr_output_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_output_buffer_N2147483641,
      RSTB => cntrlr_output_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_out_buf_out(23),
      DOA(6) => cntrlr_out_buf_out(22),
      DOA(5) => cntrlr_out_buf_out(21),
      DOA(4) => cntrlr_out_buf_out(20),
      DOA(3) => cntrlr_out_buf_out(19),
      DOA(2) => cntrlr_out_buf_out(18),
      DOA(1) => cntrlr_out_buf_out(17),
      DOA(0) => cntrlr_out_buf_out(16),
      DIB(7) => cntrlr_data_in(23),
      DIB(6) => cntrlr_data_in(22),
      DIB(5) => cntrlr_data_in(21),
      DIB(4) => cntrlr_data_in(20),
      DIB(3) => cntrlr_data_in(19),
      DIB(2) => cntrlr_data_in(18),
      DIB(1) => cntrlr_data_in(17),
      DIB(0) => cntrlr_data_in(16),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_output_buffer_N2147483641,
      DIA(6) => cntrlr_output_buffer_N2147483641,
      DIA(5) => cntrlr_output_buffer_N2147483641,
      DIA(4) => cntrlr_output_buffer_N2147483641,
      DIA(3) => cntrlr_output_buffer_N2147483641,
      DIA(2) => cntrlr_output_buffer_N2147483641,
      DIA(1) => cntrlr_output_buffer_N2147483641,
      DIA(0) => cntrlr_output_buffer_N2147483641,
      ADDRA(8) => cntrlr_out_ptr(8),
      ADDRA(7) => cntrlr_out_ptr(7),
      ADDRA(6) => cntrlr_out_ptr(6),
      ADDRA(5) => cntrlr_out_ptr(5),
      ADDRA(4) => cntrlr_out_ptr(4),
      ADDRA(3) => cntrlr_out_ptr(3),
      ADDRA(2) => cntrlr_out_ptr(2),
      ADDRA(1) => cntrlr_out_ptr(1),
      ADDRA(0) => cntrlr_out_ptr(0),
      DOB(7) => NLW_cntrlr_output_buffer_BU2_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_output_buffer_BU2_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_output_buffer_BU2_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_output_buffer_BU2_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_output_buffer_BU2_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_output_buffer_BU2_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_output_buffer_BU2_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_output_buffer_BU2_DOB_0_UNCONNECTED
    );
  cntrlr_output_buffer_BU3 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_output_buffer_N2147483644,
      ENB => cntrlr_output_buffer_N2147483644,
      WEA => cntrlr_output_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_output_buffer_N2147483641,
      RSTB => cntrlr_output_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_out_buf_out(31),
      DOA(6) => cntrlr_out_buf_out(30),
      DOA(5) => cntrlr_out_buf_out(29),
      DOA(4) => cntrlr_out_buf_out(28),
      DOA(3) => cntrlr_out_buf_out(27),
      DOA(2) => cntrlr_out_buf_out(26),
      DOA(1) => cntrlr_out_buf_out(25),
      DOA(0) => cntrlr_out_buf_out(24),
      DIB(7) => cntrlr_data_in(31),
      DIB(6) => cntrlr_data_in(30),
      DIB(5) => cntrlr_data_in(29),
      DIB(4) => cntrlr_data_in(28),
      DIB(3) => cntrlr_data_in(27),
      DIB(2) => cntrlr_data_in(26),
      DIB(1) => cntrlr_data_in(25),
      DIB(0) => cntrlr_data_in(24),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_output_buffer_N2147483641,
      DIA(6) => cntrlr_output_buffer_N2147483641,
      DIA(5) => cntrlr_output_buffer_N2147483641,
      DIA(4) => cntrlr_output_buffer_N2147483641,
      DIA(3) => cntrlr_output_buffer_N2147483641,
      DIA(2) => cntrlr_output_buffer_N2147483641,
      DIA(1) => cntrlr_output_buffer_N2147483641,
      DIA(0) => cntrlr_output_buffer_N2147483641,
      ADDRA(8) => cntrlr_out_ptr(8),
      ADDRA(7) => cntrlr_out_ptr(7),
      ADDRA(6) => cntrlr_out_ptr(6),
      ADDRA(5) => cntrlr_out_ptr(5),
      ADDRA(4) => cntrlr_out_ptr(4),
      ADDRA(3) => cntrlr_out_ptr(3),
      ADDRA(2) => cntrlr_out_ptr(2),
      ADDRA(1) => cntrlr_out_ptr(1),
      ADDRA(0) => cntrlr_out_ptr(0),
      DOB(7) => NLW_cntrlr_output_buffer_BU3_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_output_buffer_BU3_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_output_buffer_BU3_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_output_buffer_BU3_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_output_buffer_BU3_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_output_buffer_BU3_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_output_buffer_BU3_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_output_buffer_BU3_DOB_0_UNCONNECTED
    );
  cntrlr_output_buffer_BU4 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_output_buffer_N2147483644,
      ENB => cntrlr_output_buffer_N2147483644,
      WEA => cntrlr_output_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_output_buffer_N2147483641,
      RSTB => cntrlr_output_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => NLW_cntrlr_output_buffer_BU4_DOA_7_UNCONNECTED,
      DOA(6) => NLW_cntrlr_output_buffer_BU4_DOA_6_UNCONNECTED,
      DOA(5) => NLW_cntrlr_output_buffer_BU4_DOA_5_UNCONNECTED,
      DOA(4) => NLW_cntrlr_output_buffer_BU4_DOA_4_UNCONNECTED,
      DOA(3) => NLW_cntrlr_output_buffer_BU4_DOA_3_UNCONNECTED,
      DOA(2) => cntrlr_out_buf_out_34_Q,
      DOA(1) => cntrlr_output_buffer_doa(33),
      DOA(0) => cntrlr_out_buf_out_32_Q,
      DIB(7) => cntrlr_output_buffer_N2147483641,
      DIB(6) => cntrlr_output_buffer_N2147483641,
      DIB(5) => cntrlr_output_buffer_N2147483641,
      DIB(4) => cntrlr_output_buffer_N2147483641,
      DIB(3) => cntrlr_output_buffer_N2147483641,
      DIB(2) => cntrlr_sof_in,
      DIB(1) => cntrlr_sod_in,
      DIB(0) => cntrlr_eof_in,
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_output_buffer_N2147483641,
      DIA(6) => cntrlr_output_buffer_N2147483641,
      DIA(5) => cntrlr_output_buffer_N2147483641,
      DIA(4) => cntrlr_output_buffer_N2147483641,
      DIA(3) => cntrlr_output_buffer_N2147483641,
      DIA(2) => cntrlr_output_buffer_N2147483641,
      DIA(1) => cntrlr_output_buffer_N2147483641,
      DIA(0) => cntrlr_output_buffer_N2147483641,
      ADDRA(8) => cntrlr_out_ptr(8),
      ADDRA(7) => cntrlr_out_ptr(7),
      ADDRA(6) => cntrlr_out_ptr(6),
      ADDRA(5) => cntrlr_out_ptr(5),
      ADDRA(4) => cntrlr_out_ptr(4),
      ADDRA(3) => cntrlr_out_ptr(3),
      ADDRA(2) => cntrlr_out_ptr(2),
      ADDRA(1) => cntrlr_out_ptr(1),
      ADDRA(0) => cntrlr_out_ptr(0),
      DOB(7) => NLW_cntrlr_output_buffer_BU4_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_output_buffer_BU4_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_output_buffer_BU4_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_output_buffer_BU4_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_output_buffer_BU4_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_output_buffer_BU4_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_output_buffer_BU4_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_output_buffer_BU4_DOB_0_UNCONNECTED
    );
  cntrlr_regex_buffer_VCC : X_ONE
    port map (
      O => cntrlr_regex_buffer_N2147483644
    );
  cntrlr_regex_buffer_GND : X_ZERO
    port map (
      O => cntrlr_regex_buffer_N2147483641
    );
  cntrlr_regex_buffer_BU0 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_regex_buffer_N2147483644,
      ENB => cntrlr_regex_buffer_N2147483644,
      WEA => cntrlr_regex_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_regex_buffer_N2147483641,
      RSTB => cntrlr_regex_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_char_buf_out(7),
      DOA(6) => cntrlr_char_buf_out(6),
      DOA(5) => cntrlr_char_buf_out(5),
      DOA(4) => cntrlr_char_buf_out(4),
      DOA(3) => cntrlr_char_buf_out(3),
      DOA(2) => cntrlr_char_buf_out(2),
      DOA(1) => cntrlr_char_buf_out(1),
      DOA(0) => cntrlr_char_buf_out(0),
      DIB(7) => cntrlr_data_in(7),
      DIB(6) => cntrlr_data_in(6),
      DIB(5) => cntrlr_data_in(5),
      DIB(4) => cntrlr_data_in(4),
      DIB(3) => cntrlr_data_in(3),
      DIB(2) => cntrlr_data_in(2),
      DIB(1) => cntrlr_data_in(1),
      DIB(0) => cntrlr_data_in(0),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_regex_buffer_N2147483641,
      DIA(6) => cntrlr_regex_buffer_N2147483641,
      DIA(5) => cntrlr_regex_buffer_N2147483641,
      DIA(4) => cntrlr_regex_buffer_N2147483641,
      DIA(3) => cntrlr_regex_buffer_N2147483641,
      DIA(2) => cntrlr_regex_buffer_N2147483641,
      DIA(1) => cntrlr_regex_buffer_N2147483641,
      DIA(0) => cntrlr_regex_buffer_N2147483641,
      ADDRA(8) => cntrlr_regex_ptr(10),
      ADDRA(7) => cntrlr_regex_ptr(9),
      ADDRA(6) => cntrlr_regex_ptr(8),
      ADDRA(5) => cntrlr_regex_ptr(7),
      ADDRA(4) => cntrlr_regex_ptr(6),
      ADDRA(3) => cntrlr_regex_ptr(5),
      ADDRA(2) => cntrlr_regex_ptr(4),
      ADDRA(1) => cntrlr_regex_ptr(3),
      ADDRA(0) => cntrlr_regex_ptr(2),
      DOB(7) => NLW_cntrlr_regex_buffer_BU0_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_regex_buffer_BU0_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_regex_buffer_BU0_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_regex_buffer_BU0_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_regex_buffer_BU0_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_regex_buffer_BU0_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_regex_buffer_BU0_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_regex_buffer_BU0_DOB_0_UNCONNECTED
    );
  cntrlr_regex_buffer_BU1 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_regex_buffer_N2147483644,
      ENB => cntrlr_regex_buffer_N2147483644,
      WEA => cntrlr_regex_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_regex_buffer_N2147483641,
      RSTB => cntrlr_regex_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_char_buf_out(15),
      DOA(6) => cntrlr_char_buf_out(14),
      DOA(5) => cntrlr_char_buf_out(13),
      DOA(4) => cntrlr_char_buf_out(12),
      DOA(3) => cntrlr_char_buf_out(11),
      DOA(2) => cntrlr_char_buf_out(10),
      DOA(1) => cntrlr_char_buf_out(9),
      DOA(0) => cntrlr_char_buf_out(8),
      DIB(7) => cntrlr_data_in(15),
      DIB(6) => cntrlr_data_in(14),
      DIB(5) => cntrlr_data_in(13),
      DIB(4) => cntrlr_data_in(12),
      DIB(3) => cntrlr_data_in(11),
      DIB(2) => cntrlr_data_in(10),
      DIB(1) => cntrlr_data_in(9),
      DIB(0) => cntrlr_data_in(8),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_regex_buffer_N2147483641,
      DIA(6) => cntrlr_regex_buffer_N2147483641,
      DIA(5) => cntrlr_regex_buffer_N2147483641,
      DIA(4) => cntrlr_regex_buffer_N2147483641,
      DIA(3) => cntrlr_regex_buffer_N2147483641,
      DIA(2) => cntrlr_regex_buffer_N2147483641,
      DIA(1) => cntrlr_regex_buffer_N2147483641,
      DIA(0) => cntrlr_regex_buffer_N2147483641,
      ADDRA(8) => cntrlr_regex_ptr(10),
      ADDRA(7) => cntrlr_regex_ptr(9),
      ADDRA(6) => cntrlr_regex_ptr(8),
      ADDRA(5) => cntrlr_regex_ptr(7),
      ADDRA(4) => cntrlr_regex_ptr(6),
      ADDRA(3) => cntrlr_regex_ptr(5),
      ADDRA(2) => cntrlr_regex_ptr(4),
      ADDRA(1) => cntrlr_regex_ptr(3),
      ADDRA(0) => cntrlr_regex_ptr(2),
      DOB(7) => NLW_cntrlr_regex_buffer_BU1_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_regex_buffer_BU1_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_regex_buffer_BU1_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_regex_buffer_BU1_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_regex_buffer_BU1_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_regex_buffer_BU1_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_regex_buffer_BU1_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_regex_buffer_BU1_DOB_0_UNCONNECTED
    );
  cntrlr_regex_buffer_BU2 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_regex_buffer_N2147483644,
      ENB => cntrlr_regex_buffer_N2147483644,
      WEA => cntrlr_regex_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_regex_buffer_N2147483641,
      RSTB => cntrlr_regex_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_char_buf_out(23),
      DOA(6) => cntrlr_char_buf_out(22),
      DOA(5) => cntrlr_char_buf_out(21),
      DOA(4) => cntrlr_char_buf_out(20),
      DOA(3) => cntrlr_char_buf_out(19),
      DOA(2) => cntrlr_char_buf_out(18),
      DOA(1) => cntrlr_char_buf_out(17),
      DOA(0) => cntrlr_char_buf_out(16),
      DIB(7) => cntrlr_data_in(23),
      DIB(6) => cntrlr_data_in(22),
      DIB(5) => cntrlr_data_in(21),
      DIB(4) => cntrlr_data_in(20),
      DIB(3) => cntrlr_data_in(19),
      DIB(2) => cntrlr_data_in(18),
      DIB(1) => cntrlr_data_in(17),
      DIB(0) => cntrlr_data_in(16),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_regex_buffer_N2147483641,
      DIA(6) => cntrlr_regex_buffer_N2147483641,
      DIA(5) => cntrlr_regex_buffer_N2147483641,
      DIA(4) => cntrlr_regex_buffer_N2147483641,
      DIA(3) => cntrlr_regex_buffer_N2147483641,
      DIA(2) => cntrlr_regex_buffer_N2147483641,
      DIA(1) => cntrlr_regex_buffer_N2147483641,
      DIA(0) => cntrlr_regex_buffer_N2147483641,
      ADDRA(8) => cntrlr_regex_ptr(10),
      ADDRA(7) => cntrlr_regex_ptr(9),
      ADDRA(6) => cntrlr_regex_ptr(8),
      ADDRA(5) => cntrlr_regex_ptr(7),
      ADDRA(4) => cntrlr_regex_ptr(6),
      ADDRA(3) => cntrlr_regex_ptr(5),
      ADDRA(2) => cntrlr_regex_ptr(4),
      ADDRA(1) => cntrlr_regex_ptr(3),
      ADDRA(0) => cntrlr_regex_ptr(2),
      DOB(7) => NLW_cntrlr_regex_buffer_BU2_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_regex_buffer_BU2_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_regex_buffer_BU2_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_regex_buffer_BU2_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_regex_buffer_BU2_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_regex_buffer_BU2_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_regex_buffer_BU2_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_regex_buffer_BU2_DOB_0_UNCONNECTED
    );
  cntrlr_regex_buffer_BU3 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_regex_buffer_N2147483644,
      ENB => cntrlr_regex_buffer_N2147483644,
      WEA => cntrlr_regex_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_regex_buffer_N2147483641,
      RSTB => cntrlr_regex_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => cntrlr_char_buf_out(31),
      DOA(6) => cntrlr_char_buf_out(30),
      DOA(5) => cntrlr_char_buf_out(29),
      DOA(4) => cntrlr_char_buf_out(28),
      DOA(3) => cntrlr_char_buf_out(27),
      DOA(2) => cntrlr_char_buf_out(26),
      DOA(1) => cntrlr_char_buf_out(25),
      DOA(0) => cntrlr_char_buf_out(24),
      DIB(7) => cntrlr_data_in(31),
      DIB(6) => cntrlr_data_in(30),
      DIB(5) => cntrlr_data_in(29),
      DIB(4) => cntrlr_data_in(28),
      DIB(3) => cntrlr_data_in(27),
      DIB(2) => cntrlr_data_in(26),
      DIB(1) => cntrlr_data_in(25),
      DIB(0) => cntrlr_data_in(24),
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_regex_buffer_N2147483641,
      DIA(6) => cntrlr_regex_buffer_N2147483641,
      DIA(5) => cntrlr_regex_buffer_N2147483641,
      DIA(4) => cntrlr_regex_buffer_N2147483641,
      DIA(3) => cntrlr_regex_buffer_N2147483641,
      DIA(2) => cntrlr_regex_buffer_N2147483641,
      DIA(1) => cntrlr_regex_buffer_N2147483641,
      DIA(0) => cntrlr_regex_buffer_N2147483641,
      ADDRA(8) => cntrlr_regex_ptr(10),
      ADDRA(7) => cntrlr_regex_ptr(9),
      ADDRA(6) => cntrlr_regex_ptr(8),
      ADDRA(5) => cntrlr_regex_ptr(7),
      ADDRA(4) => cntrlr_regex_ptr(6),
      ADDRA(3) => cntrlr_regex_ptr(5),
      ADDRA(2) => cntrlr_regex_ptr(4),
      ADDRA(1) => cntrlr_regex_ptr(3),
      ADDRA(0) => cntrlr_regex_ptr(2),
      DOB(7) => NLW_cntrlr_regex_buffer_BU3_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_regex_buffer_BU3_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_regex_buffer_BU3_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_regex_buffer_BU3_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_regex_buffer_BU3_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_regex_buffer_BU3_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_regex_buffer_BU3_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_regex_buffer_BU3_DOB_0_UNCONNECTED
    );
  cntrlr_regex_buffer_BU4 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => cntrlr_regex_buffer_N2147483644,
      ENB => cntrlr_regex_buffer_N2147483644,
      WEA => cntrlr_regex_buffer_N2147483641,
      WEB => cntrlr_un9_sof_in,
      RSTA => cntrlr_regex_buffer_N2147483641,
      RSTB => cntrlr_regex_buffer_N2147483641,
      CLKA => clk,
      CLKB => clk,
      GSR => GSR,
      DOA(7) => NLW_cntrlr_regex_buffer_BU4_DOA_7_UNCONNECTED,
      DOA(6) => NLW_cntrlr_regex_buffer_BU4_DOA_6_UNCONNECTED,
      DOA(5) => NLW_cntrlr_regex_buffer_BU4_DOA_5_UNCONNECTED,
      DOA(4) => NLW_cntrlr_regex_buffer_BU4_DOA_4_UNCONNECTED,
      DOA(3) => NLW_cntrlr_regex_buffer_BU4_DOA_3_UNCONNECTED,
      DOA(2) => regex_restart,
      DOA(1) => cntrlr_regex_buffer_doa(33),
      DOA(0) => cntrlr_char_buf_out(32),
      DIB(7) => cntrlr_regex_buffer_N2147483641,
      DIB(6) => cntrlr_regex_buffer_N2147483641,
      DIB(5) => cntrlr_regex_buffer_N2147483641,
      DIB(4) => cntrlr_regex_buffer_N2147483641,
      DIB(3) => cntrlr_regex_buffer_N2147483641,
      DIB(2) => cntrlr_sof_in,
      DIB(1) => cntrlr_sod_in,
      DIB(0) => cntrlr_eof_in,
      ADDRB(8) => cntrlr_input_ptr(8),
      ADDRB(7) => cntrlr_input_ptr(7),
      ADDRB(6) => cntrlr_input_ptr(6),
      ADDRB(5) => cntrlr_input_ptr(5),
      ADDRB(4) => cntrlr_input_ptr(4),
      ADDRB(3) => cntrlr_input_ptr(3),
      ADDRB(2) => cntrlr_input_ptr(2),
      ADDRB(1) => cntrlr_input_ptr(1),
      ADDRB(0) => cntrlr_input_ptr(0),
      DIA(7) => cntrlr_regex_buffer_N2147483641,
      DIA(6) => cntrlr_regex_buffer_N2147483641,
      DIA(5) => cntrlr_regex_buffer_N2147483641,
      DIA(4) => cntrlr_regex_buffer_N2147483641,
      DIA(3) => cntrlr_regex_buffer_N2147483641,
      DIA(2) => cntrlr_regex_buffer_N2147483641,
      DIA(1) => cntrlr_regex_buffer_N2147483641,
      DIA(0) => cntrlr_regex_buffer_N2147483641,
      ADDRA(8) => cntrlr_regex_ptr(10),
      ADDRA(7) => cntrlr_regex_ptr(9),
      ADDRA(6) => cntrlr_regex_ptr(8),
      ADDRA(5) => cntrlr_regex_ptr(7),
      ADDRA(4) => cntrlr_regex_ptr(6),
      ADDRA(3) => cntrlr_regex_ptr(5),
      ADDRA(2) => cntrlr_regex_ptr(4),
      ADDRA(1) => cntrlr_regex_ptr(3),
      ADDRA(0) => cntrlr_regex_ptr(2),
      DOB(7) => NLW_cntrlr_regex_buffer_BU4_DOB_7_UNCONNECTED,
      DOB(6) => NLW_cntrlr_regex_buffer_BU4_DOB_6_UNCONNECTED,
      DOB(5) => NLW_cntrlr_regex_buffer_BU4_DOB_5_UNCONNECTED,
      DOB(4) => NLW_cntrlr_regex_buffer_BU4_DOB_4_UNCONNECTED,
      DOB(3) => NLW_cntrlr_regex_buffer_BU4_DOB_3_UNCONNECTED,
      DOB(2) => NLW_cntrlr_regex_buffer_BU4_DOB_2_UNCONNECTED,
      DOB(1) => NLW_cntrlr_regex_buffer_BU4_DOB_1_UNCONNECTED,
      DOB(0) => NLW_cntrlr_regex_buffer_BU4_DOB_0_UNCONNECTED
    );
  cntrlr_match_fifo_tail_1_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_718,
      O => cntrlr_match_fifo_tail_1(2),
      SRST => reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_out_5_0_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(0),
      ADR1 => cntrlr_match_fifo_fifo_7(0),
      ADR2 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_322
    );
  cntrlr_match_fifo_data_out_5_5_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(5),
      ADR1 => cntrlr_match_fifo_fifo_7(5),
      ADR2 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_327
    );
  cntrlr_match_fifo_data_out_7_0_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(0),
      IB => cntrlr_match_fifo_data_out_7_bm(0),
      O => cntrlr_match_fifo_N_338,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_7_bm_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(0),
      ADR2 => cntrlr_match_fifo_fifo_4(0),
      O => cntrlr_match_fifo_data_out_7_bm(0)
    );
  cntrlr_match_fifo_data_out_7_am_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(0),
      ADR2 => cntrlr_match_fifo_fifo_0(0),
      O => cntrlr_match_fifo_data_out_7_am(0)
    );
  cntrlr_match_fifo_data_out_7_5_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(5),
      IB => cntrlr_match_fifo_data_out_7_bm(5),
      O => cntrlr_match_fifo_N_343,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_7_bm_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(5),
      ADR2 => cntrlr_match_fifo_fifo_4(5),
      O => cntrlr_match_fifo_data_out_7_bm(5)
    );
  cntrlr_match_fifo_data_out_7_am_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(5),
      ADR2 => cntrlr_match_fifo_fifo_0(5),
      O => cntrlr_match_fifo_data_out_7_am(5)
    );
  cntrlr_match_fifo_data_out_8_0_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_322,
      ADR1 => cntrlr_match_fifo_fifo_3(0),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_347
    );
  cntrlr_match_fifo_data_out_8_5_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_327,
      ADR1 => cntrlr_match_fifo_fifo_3(5),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_352
    );
  cntrlr_match_fifo_data_out_9_0_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(0),
      IB => cntrlr_match_fifo_data_out_9_bm(0),
      O => cntrlr_match_fifo_N_357,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_9_bm_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(3),
      ADR1 => cntrlr_match_fifo_fifo_12(0),
      ADR2 => cntrlr_match_fifo_fifo_5(0),
      O => cntrlr_match_fifo_data_out_9_bm(0)
    );
  cntrlr_match_fifo_data_out_9_am_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(3),
      ADR1 => cntrlr_match_fifo_fifo_8(0),
      ADR2 => cntrlr_match_fifo_fifo_1(0),
      O => cntrlr_match_fifo_data_out_9_am(0)
    );
  cntrlr_match_fifo_data_out_9_5_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(5),
      IB => cntrlr_match_fifo_data_out_9_bm(5),
      O => cntrlr_match_fifo_N_362,
      SEL => cntrlr_match_fifo_tail(0)
    );
  cntrlr_match_fifo_data_out_9_bm_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail_1(2),
      ADR1 => cntrlr_match_fifo_fifo_5(5),
      ADR2 => cntrlr_match_fifo_fifo_1(5),
      O => cntrlr_match_fifo_data_out_9_bm(5)
    );
  cntrlr_match_fifo_data_out_9_am_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail_1(2),
      ADR1 => cntrlr_match_fifo_fifo_12(5),
      ADR2 => cntrlr_match_fifo_fifo_8(5),
      O => cntrlr_match_fifo_data_out_9_am(5)
    );
  cntrlr_match_fifo_data_out_10_0_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(0),
      IB => cntrlr_match_fifo_data_out_10_bm(0),
      O => cntrlr_match_fifo_N_365,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_10_bm_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_14(0),
      ADR2 => cntrlr_match_fifo_fifo_13(0),
      O => cntrlr_match_fifo_data_out_10_bm(0)
    );
  cntrlr_match_fifo_data_out_10_am_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_10(0),
      ADR2 => cntrlr_match_fifo_fifo_9(0),
      O => cntrlr_match_fifo_data_out_10_am(0)
    );
  cntrlr_match_fifo_data_out_10_5_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(5),
      IB => cntrlr_match_fifo_data_out_10_bm(5),
      O => cntrlr_match_fifo_N_370,
      SEL => cntrlr_match_fifo_tail(0)
    );
  cntrlr_match_fifo_data_out_10_bm_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail_1(2),
      ADR1 => cntrlr_match_fifo_fifo_13(5),
      ADR2 => cntrlr_match_fifo_fifo_9(5),
      O => cntrlr_match_fifo_data_out_10_bm(5)
    );
  cntrlr_match_fifo_data_out_10_am_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail_1(2),
      ADR1 => cntrlr_match_fifo_fifo_14(5),
      ADR2 => cntrlr_match_fifo_fifo_10(5),
      O => cntrlr_match_fifo_data_out_10_am(5)
    );
  cntrlr_match_fifo_data_out_0_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(0),
      IB => cntrlr_match_fifo_data_out_bm(0),
      O => cntrlr_mfifo_out(0),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_347,
      ADR2 => cntrlr_match_fifo_N_338,
      O => cntrlr_match_fifo_data_out_bm(0)
    );
  cntrlr_match_fifo_data_out_am_0_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_365,
      ADR2 => cntrlr_match_fifo_N_357,
      O => cntrlr_match_fifo_data_out_am(0)
    );
  cntrlr_match_fifo_data_out_5_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(5),
      IB => cntrlr_match_fifo_data_out_bm(5),
      O => cntrlr_mfifo_out(5),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_352,
      ADR2 => cntrlr_match_fifo_N_343,
      O => cntrlr_match_fifo_data_out_bm(5)
    );
  cntrlr_match_fifo_data_out_am_5_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_370,
      ADR2 => cntrlr_match_fifo_N_362,
      O => cntrlr_match_fifo_data_out_am(5)
    );
  cntrlr_match_fifo_data_out_sn_G_16_i : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_tail(3),
      ADR2 => cntrlr_match_fifo_tail(0),
      O => cntrlr_match_fifo_N_16
    );
  cntrlr_match_fifo_data_out_sn_G_22 : X_LUT3
    generic map(
      INIT => X"C5"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(3),
      ADR1 => cntrlr_match_fifo_tail(1),
      ADR2 => cntrlr_match_fifo_tail(0),
      O => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_G_82 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(2),
      ADR1 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_463
    );
  cntrlr_match_fifo_un2_data_avail_NE_1 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_head(0),
      ADR2 => cntrlr_match_fifo_tail(1),
      ADR3 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_mfifo_avail_1
    );
  cntrlr_match_fifo_un2_data_avail_NE : X_LUT4
    generic map(
      INIT => X"BFFB"
    )
    port map (
      ADR0 => cntrlr_match_fifo_mfifo_avail_1,
      ADR1 => cntrlr_match_fifo_N_463,
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_head(3),
      O => cntrlr_mfifo_avail
    );
  cntrlr_match_fifo_data_out_5_2_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(2),
      ADR1 => cntrlr_match_fifo_fifo_7(2),
      ADR2 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_324
    );
  cntrlr_match_fifo_data_out_7_2_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(2),
      IB => cntrlr_match_fifo_data_out_7_bm(2),
      O => cntrlr_match_fifo_N_340,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_7_bm_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(2),
      ADR2 => cntrlr_match_fifo_fifo_4(2),
      O => cntrlr_match_fifo_data_out_7_bm(2)
    );
  cntrlr_match_fifo_data_out_7_am_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(2),
      ADR2 => cntrlr_match_fifo_fifo_0(2),
      O => cntrlr_match_fifo_data_out_7_am(2)
    );
  cntrlr_match_fifo_data_out_7_7_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(7),
      IB => cntrlr_match_fifo_data_out_7_bm(7),
      O => cntrlr_match_fifo_N_345,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_7_bm_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(7),
      ADR2 => cntrlr_match_fifo_fifo_4(7),
      O => cntrlr_match_fifo_data_out_7_bm(7)
    );
  cntrlr_match_fifo_data_out_7_am_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(7),
      ADR2 => cntrlr_match_fifo_fifo_0(7),
      O => cntrlr_match_fifo_data_out_7_am(7)
    );
  cntrlr_match_fifo_data_out_8_2_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_324,
      ADR1 => cntrlr_match_fifo_fifo_3(2),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail_1(2),
      O => cntrlr_match_fifo_N_349
    );
  cntrlr_match_fifo_data_out_9_2_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(2),
      IB => cntrlr_match_fifo_data_out_9_bm(2),
      O => cntrlr_match_fifo_N_359,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_9_bm_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_5(2),
      ADR2 => cntrlr_match_fifo_fifo_12(2),
      O => cntrlr_match_fifo_data_out_9_bm(2)
    );
  cntrlr_match_fifo_data_out_9_am_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_1(2),
      ADR2 => cntrlr_match_fifo_fifo_8(2),
      O => cntrlr_match_fifo_data_out_9_am(2)
    );
  cntrlr_match_fifo_data_out_9_7_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(7),
      IB => cntrlr_match_fifo_data_out_9_bm(7),
      O => cntrlr_match_fifo_N_364,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_9_bm_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_5(7),
      ADR2 => cntrlr_match_fifo_fifo_12(7),
      O => cntrlr_match_fifo_data_out_9_bm(7)
    );
  cntrlr_match_fifo_data_out_9_am_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_1(7),
      ADR2 => cntrlr_match_fifo_fifo_8(7),
      O => cntrlr_match_fifo_data_out_9_am(7)
    );
  cntrlr_match_fifo_data_out_10_2_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(2),
      IB => cntrlr_match_fifo_data_out_10_bm(2),
      O => cntrlr_match_fifo_N_367,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_10_bm_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_13(2),
      ADR2 => cntrlr_match_fifo_fifo_14(2),
      O => cntrlr_match_fifo_data_out_10_bm(2)
    );
  cntrlr_match_fifo_data_out_10_am_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_9(2),
      ADR2 => cntrlr_match_fifo_fifo_10(2),
      O => cntrlr_match_fifo_data_out_10_am(2)
    );
  cntrlr_match_fifo_data_out_10_7_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(7),
      IB => cntrlr_match_fifo_data_out_10_bm(7),
      O => cntrlr_match_fifo_N_372,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_10_bm_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_13(7),
      ADR2 => cntrlr_match_fifo_fifo_14(7),
      O => cntrlr_match_fifo_data_out_10_bm(7)
    );
  cntrlr_match_fifo_data_out_10_am_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_9(7),
      ADR2 => cntrlr_match_fifo_fifo_10(7),
      O => cntrlr_match_fifo_data_out_10_am(7)
    );
  cntrlr_match_fifo_data_out_2_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(2),
      IB => cntrlr_match_fifo_data_out_bm(2),
      O => cntrlr_mfifo_out(2),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_349,
      ADR2 => cntrlr_match_fifo_N_340,
      O => cntrlr_match_fifo_data_out_bm(2)
    );
  cntrlr_match_fifo_data_out_am_2_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_367,
      ADR2 => cntrlr_match_fifo_N_359,
      O => cntrlr_match_fifo_data_out_am(2)
    );
  cntrlr_match_fifo_data_out_7_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(7),
      IB => cntrlr_match_fifo_data_out_bm(7),
      O => cntrlr_mfifo_out(7),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_354,
      ADR2 => cntrlr_match_fifo_N_345,
      O => cntrlr_match_fifo_data_out_bm(7)
    );
  cntrlr_match_fifo_data_out_am_7_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_372,
      ADR2 => cntrlr_match_fifo_N_364,
      O => cntrlr_match_fifo_data_out_am(7)
    );
  cntrlr_match_fifo_un1_wren_buf_5_0_and2 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(3),
      ADR1 => cntrlr_match_fifo_N_490,
      ADR2 => cntrlr_match_fifo_N_487,
      O => cntrlr_match_fifo_N_472
    );
  cntrlr_match_fifo_un1_wren_buf_8_0_and2 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(1),
      ADR1 => cntrlr_match_fifo_head(2),
      ADR2 => cntrlr_match_fifo_un1_head_1_c1,
      ADR3 => cntrlr_match_fifo_head(3),
      O => cntrlr_match_fifo_N_475
    );
  cntrlr_match_fifo_un1_wren_buf_1_4_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_489,
      ADR1 => cntrlr_match_fifo_head(1),
      ADR2 => cntrlr_match_fifo_head(2),
      O => cntrlr_match_fifo_N_468
    );
  cntrlr_match_fifo_un1_reset_l_4_i : X_LUT3
    generic map(
      INIT => X"D5"
    )
    port map (
      ADR0 => reset_l_2,
      ADR1 => cntrlr_match_fifo_N_490,
      ADR2 => cntrlr_match_fifo_N_489,
      O => cntrlr_match_fifo_N_442
    );
  cntrlr_match_fifo_G_57 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(2),
      ADR1 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_490
    );
  cntrlr_match_fifo_G_56 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(3),
      ADR1 => cntrlr_match_fifo_wren_buf,
      ADR2 => cntrlr_match_fifo_head(0),
      O => cntrlr_match_fifo_N_489
    );
  cntrlr_match_fifo_G_55 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(0),
      ADR1 => cntrlr_match_fifo_wren_buf,
      O => cntrlr_match_fifo_un1_head_1_c1
    );
  cntrlr_match_fifo_G_54 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(0),
      ADR1 => cntrlr_match_fifo_wren_buf,
      O => cntrlr_match_fifo_N_487
    );
  cntrlr_match_fifo_un1_wren_buf_6_0_and2 : X_LUT4
    generic map(
      INIT => X"0004"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(2),
      ADR1 => cntrlr_match_fifo_N_487,
      ADR2 => cntrlr_match_fifo_head(3),
      ADR3 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_473
    );
  cntrlr_match_fifo_un1_wren_buf_12_0_and2 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(2),
      ADR1 => cntrlr_match_fifo_N_487,
      ADR2 => cntrlr_match_fifo_head(3),
      ADR3 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_479
    );
  cntrlr_match_fifo_un1_head_1_m_i_xor2_0_Q : X_LUT4
    generic map(
      INIT => X"9555"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(3),
      ADR1 => cntrlr_match_fifo_head(2),
      ADR2 => cntrlr_match_fifo_un1_head_1_c1,
      ADR3 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_460
    );
  cntrlr_match_fifo_un1_wren_buf_10_0_and2 : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(1),
      ADR1 => cntrlr_match_fifo_N_489,
      ADR2 => cntrlr_match_fifo_head(2),
      O => cntrlr_match_fifo_N_477
    );
  cntrlr_match_fifo_G_25 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_rddone_buf,
      ADR2 => cntrlr_match_fifo_tail(0),
      O => cntrlr_match_fifo_un1_tail_19_c2
    );
  cntrlr_match_fifo_data_out_6_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(6),
      IB => cntrlr_match_fifo_data_out_bm(6),
      O => cntrlr_mfifo_out(6),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_353,
      ADR2 => cntrlr_match_fifo_N_344,
      O => cntrlr_match_fifo_data_out_bm(6)
    );
  cntrlr_match_fifo_data_out_am_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_371,
      ADR2 => cntrlr_match_fifo_N_363,
      O => cntrlr_match_fifo_data_out_am(6)
    );
  cntrlr_match_fifo_data_out_4_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(4),
      IB => cntrlr_match_fifo_data_out_bm(4),
      O => cntrlr_mfifo_out(4),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_351,
      ADR2 => cntrlr_match_fifo_N_342,
      O => cntrlr_match_fifo_data_out_bm(4)
    );
  cntrlr_match_fifo_data_out_am_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_369,
      ADR2 => cntrlr_match_fifo_N_361,
      O => cntrlr_match_fifo_data_out_am(4)
    );
  cntrlr_match_fifo_data_out_3_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(3),
      IB => cntrlr_match_fifo_data_out_bm(3),
      O => cntrlr_mfifo_out(3),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_350,
      ADR2 => cntrlr_match_fifo_N_341,
      O => cntrlr_match_fifo_data_out_bm(3)
    );
  cntrlr_match_fifo_data_out_am_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_368,
      ADR2 => cntrlr_match_fifo_N_360,
      O => cntrlr_match_fifo_data_out_am(3)
    );
  cntrlr_match_fifo_data_out_1_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_am(1),
      IB => cntrlr_match_fifo_data_out_bm(1),
      O => cntrlr_mfifo_out(1),
      SEL => cntrlr_match_fifo_N_18
    );
  cntrlr_match_fifo_data_out_bm_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_N_348,
      ADR2 => cntrlr_match_fifo_N_339,
      O => cntrlr_match_fifo_data_out_bm(1)
    );
  cntrlr_match_fifo_data_out_am_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_16,
      ADR1 => cntrlr_match_fifo_N_366,
      ADR2 => cntrlr_match_fifo_N_358,
      O => cntrlr_match_fifo_data_out_am(1)
    );
  cntrlr_match_fifo_data_out_10_6_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(6),
      IB => cntrlr_match_fifo_data_out_10_bm(6),
      O => cntrlr_match_fifo_N_371,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_10_bm_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_13(6),
      ADR2 => cntrlr_match_fifo_fifo_14(6),
      O => cntrlr_match_fifo_data_out_10_bm(6)
    );
  cntrlr_match_fifo_data_out_10_am_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_9(6),
      ADR2 => cntrlr_match_fifo_fifo_10(6),
      O => cntrlr_match_fifo_data_out_10_am(6)
    );
  cntrlr_match_fifo_data_out_10_4_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(4),
      IB => cntrlr_match_fifo_data_out_10_bm(4),
      O => cntrlr_match_fifo_N_369,
      SEL => cntrlr_match_fifo_tail_1(2)
    );
  cntrlr_match_fifo_data_out_10_bm_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_13(4),
      ADR2 => cntrlr_match_fifo_fifo_14(4),
      O => cntrlr_match_fifo_data_out_10_bm(4)
    );
  cntrlr_match_fifo_data_out_10_am_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_9(4),
      ADR2 => cntrlr_match_fifo_fifo_10(4),
      O => cntrlr_match_fifo_data_out_10_am(4)
    );
  cntrlr_match_fifo_data_out_10_3_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(3),
      IB => cntrlr_match_fifo_data_out_10_bm(3),
      O => cntrlr_match_fifo_N_368,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_10_bm_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_13(3),
      ADR2 => cntrlr_match_fifo_fifo_14(3),
      O => cntrlr_match_fifo_data_out_10_bm(3)
    );
  cntrlr_match_fifo_data_out_10_am_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_9(3),
      ADR2 => cntrlr_match_fifo_fifo_10(3),
      O => cntrlr_match_fifo_data_out_10_am(3)
    );
  cntrlr_match_fifo_data_out_10_1_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_10_am(1),
      IB => cntrlr_match_fifo_data_out_10_bm(1),
      O => cntrlr_match_fifo_N_366,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_10_bm_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_13(1),
      ADR2 => cntrlr_match_fifo_fifo_14(1),
      O => cntrlr_match_fifo_data_out_10_bm(1)
    );
  cntrlr_match_fifo_data_out_10_am_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_9(1),
      ADR2 => cntrlr_match_fifo_fifo_10(1),
      O => cntrlr_match_fifo_data_out_10_am(1)
    );
  cntrlr_match_fifo_data_out_9_6_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(6),
      IB => cntrlr_match_fifo_data_out_9_bm(6),
      O => cntrlr_match_fifo_N_363,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_9_bm_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_5(6),
      ADR2 => cntrlr_match_fifo_fifo_12(6),
      O => cntrlr_match_fifo_data_out_9_bm(6)
    );
  cntrlr_match_fifo_data_out_9_am_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_1(6),
      ADR2 => cntrlr_match_fifo_fifo_8(6),
      O => cntrlr_match_fifo_data_out_9_am(6)
    );
  cntrlr_match_fifo_data_out_9_4_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(4),
      IB => cntrlr_match_fifo_data_out_9_bm(4),
      O => cntrlr_match_fifo_N_361,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_9_bm_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_5(4),
      ADR2 => cntrlr_match_fifo_fifo_12(4),
      O => cntrlr_match_fifo_data_out_9_bm(4)
    );
  cntrlr_match_fifo_data_out_9_am_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_1(4),
      ADR2 => cntrlr_match_fifo_fifo_8(4),
      O => cntrlr_match_fifo_data_out_9_am(4)
    );
  cntrlr_match_fifo_data_out_9_3_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(3),
      IB => cntrlr_match_fifo_data_out_9_bm(3),
      O => cntrlr_match_fifo_N_360,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_9_bm_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_5(3),
      ADR2 => cntrlr_match_fifo_fifo_12(3),
      O => cntrlr_match_fifo_data_out_9_bm(3)
    );
  cntrlr_match_fifo_data_out_9_am_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_1(3),
      ADR2 => cntrlr_match_fifo_fifo_8(3),
      O => cntrlr_match_fifo_data_out_9_am(3)
    );
  cntrlr_match_fifo_data_out_9_1_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_9_am(1),
      IB => cntrlr_match_fifo_data_out_9_bm(1),
      O => cntrlr_match_fifo_N_358,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_9_bm_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_5(1),
      ADR2 => cntrlr_match_fifo_fifo_12(1),
      O => cntrlr_match_fifo_data_out_9_bm(1)
    );
  cntrlr_match_fifo_data_out_9_am_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(0),
      ADR1 => cntrlr_match_fifo_fifo_1(1),
      ADR2 => cntrlr_match_fifo_fifo_8(1),
      O => cntrlr_match_fifo_data_out_9_am(1)
    );
  cntrlr_match_fifo_data_out_8_7_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_329,
      ADR1 => cntrlr_match_fifo_fifo_3(7),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_354
    );
  cntrlr_match_fifo_data_out_8_6_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_328,
      ADR1 => cntrlr_match_fifo_fifo_3(6),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_353
    );
  cntrlr_match_fifo_data_out_8_4_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_326,
      ADR1 => cntrlr_match_fifo_fifo_3(4),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_351
    );
  cntrlr_match_fifo_data_out_8_3_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_325,
      ADR1 => cntrlr_match_fifo_fifo_3(3),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_350
    );
  cntrlr_match_fifo_data_out_8_1_Q : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_323,
      ADR1 => cntrlr_match_fifo_fifo_3(1),
      ADR2 => cntrlr_match_fifo_tail(3),
      ADR3 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_348
    );
  cntrlr_match_fifo_data_out_7_6_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(6),
      IB => cntrlr_match_fifo_data_out_7_bm(6),
      O => cntrlr_match_fifo_N_344,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_7_bm_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(6),
      ADR2 => cntrlr_match_fifo_fifo_4(6),
      O => cntrlr_match_fifo_data_out_7_bm(6)
    );
  cntrlr_match_fifo_data_out_7_am_6_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(6),
      ADR2 => cntrlr_match_fifo_fifo_0(6),
      O => cntrlr_match_fifo_data_out_7_am(6)
    );
  cntrlr_match_fifo_data_out_7_4_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(4),
      IB => cntrlr_match_fifo_data_out_7_bm(4),
      O => cntrlr_match_fifo_N_342,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_7_bm_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(4),
      ADR2 => cntrlr_match_fifo_fifo_4(4),
      O => cntrlr_match_fifo_data_out_7_bm(4)
    );
  cntrlr_match_fifo_data_out_7_am_4_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(4),
      ADR2 => cntrlr_match_fifo_fifo_0(4),
      O => cntrlr_match_fifo_data_out_7_am(4)
    );
  cntrlr_match_fifo_data_out_7_3_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(3),
      IB => cntrlr_match_fifo_data_out_7_bm(3),
      O => cntrlr_match_fifo_N_341,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_7_bm_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(3),
      ADR2 => cntrlr_match_fifo_fifo_4(3),
      O => cntrlr_match_fifo_data_out_7_bm(3)
    );
  cntrlr_match_fifo_data_out_7_am_3_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(3),
      ADR2 => cntrlr_match_fifo_fifo_0(3),
      O => cntrlr_match_fifo_data_out_7_am(3)
    );
  cntrlr_match_fifo_data_out_7_1_Q : X_MUX2
    port map (
      IA => cntrlr_match_fifo_data_out_7_am(1),
      IB => cntrlr_match_fifo_data_out_7_bm(1),
      O => cntrlr_match_fifo_N_339,
      SEL => cntrlr_match_fifo_tail(2)
    );
  cntrlr_match_fifo_data_out_7_bm_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_6(1),
      ADR2 => cntrlr_match_fifo_fifo_4(1),
      O => cntrlr_match_fifo_data_out_7_bm(1)
    );
  cntrlr_match_fifo_data_out_7_am_1_Q : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(1),
      ADR1 => cntrlr_match_fifo_fifo_2(1),
      ADR2 => cntrlr_match_fifo_fifo_0(1),
      O => cntrlr_match_fifo_data_out_7_am(1)
    );
  cntrlr_match_fifo_data_out_5_7_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(7),
      ADR1 => cntrlr_match_fifo_fifo_7(7),
      ADR2 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_329
    );
  cntrlr_match_fifo_data_out_5_6_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(6),
      ADR1 => cntrlr_match_fifo_fifo_7(6),
      ADR2 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_328
    );
  cntrlr_match_fifo_data_out_5_4_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(4),
      ADR1 => cntrlr_match_fifo_fifo_7(4),
      ADR2 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_326
    );
  cntrlr_match_fifo_data_out_5_3_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(3),
      ADR1 => cntrlr_match_fifo_fifo_7(3),
      ADR2 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_325
    );
  cntrlr_match_fifo_data_out_5_1_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => cntrlr_match_fifo_fifo_11(1),
      ADR1 => cntrlr_match_fifo_fifo_7(1),
      ADR2 => cntrlr_match_fifo_tail(2),
      O => cntrlr_match_fifo_N_323
    );
  cntrlr_match_fifo_un1_rddone_buf_466 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => cntrlr_match_fifo_tail(2),
      ADR1 => cntrlr_match_fifo_tail(0),
      ADR2 => cntrlr_match_fifo_tail(1),
      ADR3 => cntrlr_match_fifo_un1_rddone_buf_197,
      O => cntrlr_match_fifo_un1_rddone_buf
    );
  cntrlr_match_fifo_un1_wren_buf_13_0_and2 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_head_1_c1,
      ADR1 => cntrlr_match_fifo_head(3),
      ADR2 => cntrlr_match_fifo_head(2),
      ADR3 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_480
    );
  cntrlr_match_fifo_un1_wren_buf_0_and2 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(3),
      ADR1 => cntrlr_match_fifo_head(1),
      ADR2 => cntrlr_match_fifo_un1_head_1_c1,
      ADR3 => cntrlr_match_fifo_head(2),
      O => cntrlr_match_fifo_N_467
    );
  cntrlr_match_fifo_un1_wren_buf_4_0_and2 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_489,
      ADR1 => cntrlr_match_fifo_head(2),
      ADR2 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_471
    );
  cntrlr_match_fifo_un1_wren_buf_11_0_and2 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(1),
      ADR1 => cntrlr_match_fifo_head(2),
      ADR2 => cntrlr_match_fifo_un1_head_1_c1,
      ADR3 => cntrlr_match_fifo_head(3),
      O => cntrlr_match_fifo_N_478
    );
  cntrlr_match_fifo_un1_wren_buf_9_0_and2 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(1),
      ADR1 => cntrlr_match_fifo_head(2),
      ADR2 => cntrlr_match_fifo_N_487,
      ADR3 => cntrlr_match_fifo_head(3),
      O => cntrlr_match_fifo_N_476
    );
  cntrlr_match_fifo_un1_wren_buf_7_0_and2 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(3),
      ADR1 => cntrlr_match_fifo_head(1),
      ADR2 => cntrlr_match_fifo_un1_head_1_c1,
      ADR3 => cntrlr_match_fifo_head(2),
      O => cntrlr_match_fifo_N_474
    );
  cntrlr_match_fifo_un1_wren_buf_3_1_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_head_1_c1,
      ADR1 => cntrlr_match_fifo_head(3),
      ADR2 => cntrlr_match_fifo_head(2),
      ADR3 => cntrlr_match_fifo_head(1),
      O => cntrlr_match_fifo_N_470
    );
  cntrlr_match_fifo_un1_wren_buf_2_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_490,
      ADR1 => cntrlr_match_fifo_un1_head_1_c1,
      ADR2 => cntrlr_match_fifo_head(3),
      O => cntrlr_match_fifo_N_469
    );
  cntrlr_match_fifo_un1_rddone_buf_197_467 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => cntrlr_match_fifo_rddone_buf,
      ADR1 => cntrlr_match_fifo_tail(3),
      O => cntrlr_match_fifo_un1_rddone_buf_197
    );
  cntrlr_match_fifo_N_450_i_468 : X_LUT3
    generic map(
      INIT => X"15"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_460,
      ADR1 => cntrlr_match_fifo_N_490,
      ADR2 => cntrlr_match_fifo_N_487,
      O => cntrlr_match_fifo_N_450_i
    );
  cntrlr_match_fifo_N_448_i_469 : X_LUT4
    generic map(
      INIT => X"1A2A"
    )
    port map (
      ADR0 => cntrlr_match_fifo_head(2),
      ADR1 => cntrlr_match_fifo_N_489,
      ADR2 => cntrlr_match_fifo_head(1),
      ADR3 => cntrlr_match_fifo_un1_head_1_c1,
      O => cntrlr_match_fifo_N_448_i
    );
  cntrlr_match_fifo_N_446_i_470 : X_LUT4
    generic map(
      INIT => X"0666"
    )
    port map (
      ADR0 => cntrlr_match_fifo_un1_head_1_c1,
      ADR1 => cntrlr_match_fifo_head(1),
      ADR2 => cntrlr_match_fifo_N_489,
      ADR3 => cntrlr_match_fifo_head(2),
      O => cntrlr_match_fifo_N_446_i
    );
  cntrlr_match_fifo_N_444_i_471 : X_LUT4
    generic map(
      INIT => X"0770"
    )
    port map (
      ADR0 => cntrlr_match_fifo_N_490,
      ADR1 => cntrlr_match_fifo_N_489,
      ADR2 => cntrlr_match_fifo_wren_buf,
      ADR3 => cntrlr_match_fifo_head(0),
      O => cntrlr_match_fifo_N_444_i
    );
  cntrlr_match_fifo_fifo_9_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_9(4),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_9(3),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_9(2),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_9(1),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_9(0),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_9(7),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_9(6),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_9_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_480,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_9(5),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_7(5),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_7(4),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_7(3),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_7(2),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_7(1),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_7(0),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_7(7),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_7_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_469,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_7(6),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_8(7),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_8(6),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_8(5),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_8(4),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_8(3),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_8(2),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_8(1),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_8_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_471,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_8(0),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_5(6),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_5(5),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_5(4),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_5(3),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_5(2),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_5(1),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_5(0),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_5_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_474,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_5(7),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_6(7),
      SRST => reset_l_i_3,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_6(6),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_6(5),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_6(4),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_6(3),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_6(2),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_6(1),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_6_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_472,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_6(0),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_4(7),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_4(6),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_4(5),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_4(4),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_4(3),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_4(2),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_4(1),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_4_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_479,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_4(0),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_2(0),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_2(7),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_2(6),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_2(5),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_2(4),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_2(3),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_2(2),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_2_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_476,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_2(1),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_3(7),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_3(6),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_3(5),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_3(4),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_3(3),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_3(2),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_3(1),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_3_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_478,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_3(0),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_0(1),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_0(0),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_0(7),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_0(6),
      SRST => reset_l_i_4,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_0(5),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_0(4),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_0(3),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_0_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_473,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_0(2),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_1(7),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_1(6),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_1(5),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_1(4),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_1(3),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_1(2),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_1(1),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_1_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_467,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_1(0),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_13(5),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_13(4),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_13(3),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_13(2),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_13(1),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_13(0),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_13(7),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_13_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_470,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_13(6),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_14(7),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_14(6),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_14(5),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_14(4),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_14(3),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_14(2),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_14(1),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_14_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_442,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_14(0),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_11(6),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_11(5),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_11(4),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_11(3),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_11(2),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_11(1),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_11(0),
      SRST => reset_l_i_5,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_11_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_475,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_11(7),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_12(7),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_12(6),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_12(5),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_12(4),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_12(3),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_12(2),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_12(1),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_12_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_477,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_12(0),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(7),
      O => cntrlr_match_fifo_fifo_10(7),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(6),
      O => cntrlr_match_fifo_fifo_10(6),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(5),
      O => cntrlr_match_fifo_fifo_10(5),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(4),
      O => cntrlr_match_fifo_fifo_10(4),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(3),
      O => cntrlr_match_fifo_fifo_10(3),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(2),
      O => cntrlr_match_fifo_fifo_10(2),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(1),
      O => cntrlr_match_fifo_fifo_10(1),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_fifo_10_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_match_fifo_N_468,
      CLK => clk,
      I => cntrlr_match_fifo_data_buf(0),
      O => cntrlr_match_fifo_fifo_10(0),
      SRST => reset_l_i_6,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_rddone_buf_472 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => N_812_1,
      O => cntrlr_match_fifo_rddone_buf,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_wren_buf_473 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_fifo_we,
      O => cntrlr_match_fifo_wren_buf,
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(5),
      O => cntrlr_match_fifo_data_buf(5),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(6),
      O => cntrlr_match_fifo_data_buf(6),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(7),
      O => cntrlr_match_fifo_data_buf(7),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(0),
      O => cntrlr_match_fifo_data_buf(0),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(1),
      O => cntrlr_match_fifo_data_buf(1),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(2),
      O => cntrlr_match_fifo_data_buf(2),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(3),
      O => cntrlr_match_fifo_data_buf(3),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_data_buf_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => accepted(4),
      O => cntrlr_match_fifo_data_buf(4),
      SRST => reset_l_i_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_tail_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_716,
      O => cntrlr_match_fifo_tail(0),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_tail_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_717,
      O => cntrlr_match_fifo_tail(1),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_tail_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_718,
      O => cntrlr_match_fifo_tail(2),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_tail_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_719,
      O => cntrlr_match_fifo_tail(3),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_head_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_match_fifo_N_444_i,
      O => cntrlr_match_fifo_head(0),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_head_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_match_fifo_N_446_i,
      O => cntrlr_match_fifo_head(1),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_head_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_match_fifo_N_448_i,
      O => cntrlr_match_fifo_head(2),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_match_fifo_head_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_match_fifo_N_450_i,
      O => cntrlr_match_fifo_head(3),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_i_2_Q : X_INV
    port map (
      I => cntrlr_out_state_2_Q,
      O => cntrlr_out_state_i(2)
    );
  cntrlr_out_state_h_out_state_ns_0_iv_0_0_and3_3_Q : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => cntrlr_out_state_8_Q,
      ADR1 => cntrlr_out_buf_out_34_Q,
      O => cntrlr_out_state_h_N_1103
    );
  cntrlr_out_state_h_N_790_i_474 : X_LUT4
    generic map(
      INIT => X"EECE"
    )
    port map (
      ADR0 => cntrlr_out_state_11_Q,
      ADR1 => cntrlr_out_state_0_Q,
      ADR2 => cntrlr_mfifo_avail,
      ADR3 => cntrlr_fifo_empty,
      O => cntrlr_out_state_h_N_790_i
    );
  cntrlr_out_state_h_out_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => cntrlr_out_buf_out_32_Q,
      CLK => clk,
      I => cntrlr_out_state_h_GND,
      O => cntrlr_out_state_2_Q,
      SRST => reset_l_i_1,
      SSET => cntrlr_out_state_3_Q,
      SET => GND,
      RST => GSR
    );
  cntrlr_out_state_h_out_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_5_Q,
      O => cntrlr_out_state_4_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_4_Q,
      O => cntrlr_out_state_3_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => eof_out,
      O => cntrlr_out_state_0_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_h_N_790_i,
      O => cntrlr_out_state_11_Q,
      SSET => reset_l_i_1,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  cntrlr_out_state_h_out_state_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_710,
      O => cntrlr_out_state_10_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_10_Q,
      O => cntrlr_out_state_h_out_state(9),
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_h_out_state(9),
      O => cntrlr_out_state_8_Q,
      SRST => reset_l_i_1,
      SSET => cntrlr_out_state_h_N_1103,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  cntrlr_out_state_h_out_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => G_711,
      O => cntrlr_out_state_7_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_7_Q,
      O => cntrlr_out_state_6_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_out_state_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => clk,
      I => cntrlr_out_state_6_Q,
      O => cntrlr_out_state_5_Q,
      SRST => reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  cntrlr_out_state_h_GND_475 : X_ZERO
    port map (
      O => cntrlr_out_state_h_GND
    );
  cntrlr_output_fifo_BU6_GSR_OR_476 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU6_GSR_OR
    );
  cntrlr_output_fifo_BU10_GSR_OR_477 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU10_GSR_OR
    );
  cntrlr_output_fifo_BU14_GSR_OR_478 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU14_GSR_OR
    );
  cntrlr_output_fifo_BU17_GSR_OR_479 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU17_GSR_OR
    );
  cntrlr_output_fifo_BU19_GSR_OR_480 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU19_GSR_OR
    );
  cntrlr_output_fifo_BU21_GSR_OR_481 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU21_GSR_OR
    );
  cntrlr_output_fifo_BU23_GSR_OR_482 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU23_GSR_OR
    );
  cntrlr_output_fifo_BU25_GSR_OR_483 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU25_GSR_OR
    );
  cntrlr_output_fifo_BU28_GSR_OR_484 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU28_GSR_OR
    );
  cntrlr_output_fifo_BU31_GSR_OR_485 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU31_GSR_OR
    );
  cntrlr_output_fifo_BU37_GSR_OR_486 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU37_GSR_OR
    );
  cntrlr_output_fifo_BU40_GSR_OR_487 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU40_GSR_OR
    );
  cntrlr_output_fifo_BU45_GSR_OR_488 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU45_GSR_OR
    );
  cntrlr_output_fifo_BU51_GSR_OR_489 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU51_GSR_OR
    );
  cntrlr_output_fifo_BU55_GSR_OR_490 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU55_GSR_OR
    );
  cntrlr_output_fifo_BU59_GSR_OR_491 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU59_GSR_OR
    );
  cntrlr_output_fifo_BU62_GSR_OR_492 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU62_GSR_OR
    );
  cntrlr_output_fifo_BU64_GSR_OR_493 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU64_GSR_OR
    );
  cntrlr_output_fifo_BU66_GSR_OR_494 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU66_GSR_OR
    );
  cntrlr_output_fifo_BU68_GSR_OR_495 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU68_GSR_OR
    );
  cntrlr_output_fifo_BU70_GSR_OR_496 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU70_GSR_OR
    );
  cntrlr_output_fifo_BU71_GSR_OR_497 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU71_GSR_OR
    );
  cntrlr_output_fifo_BU72_GSR_OR_498 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU72_GSR_OR
    );
  cntrlr_output_fifo_BU73_GSR_OR_499 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU73_GSR_OR
    );
  cntrlr_output_fifo_BU74_GSR_OR_500 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU74_GSR_OR
    );
  cntrlr_output_fifo_BU77_GSR_OR_501 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU77_GSR_OR
    );
  cntrlr_output_fifo_BU80_GSR_OR_502 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU80_GSR_OR
    );
  cntrlr_output_fifo_BU86_GSR_OR_503 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU86_GSR_OR
    );
  cntrlr_output_fifo_BU89_GSR_OR_504 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU89_GSR_OR
    );
  cntrlr_output_fifo_BU94_GSR_OR_505 : X_OR2
    port map (
      I0 => reset_l_i_1,
      I1 => GSR,
      O => cntrlr_output_fifo_BU94_GSR_OR
    );
  NlwTieBlock_regex_app_VCC : X_ONE
    port map (
      O => VCC
    );
  NlwTieBlock_regex_app_GND : X_ZERO
    port map (
      O => GND
    );
  NlwBlockROC : ROC     port map (O => GSR);
end STRUCTURE;

