-- Xilinx Vhdl produced by program ngd2vhdl E.35
-- Command: -w frameproc.ngd frameproc_sim.vhd 
-- Input file: frameproc.ngd
-- Output file: frameproc_sim.vhd
-- Design name: FrameProc
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: v2000efg680-7

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity FrameProc is
  port (
    DataEn_OUT_APPL : out STD_LOGIC; 
    Reset_l : in STD_LOGIC := 'X'; 
    TCA_MOD_IN : out STD_LOGIC; 
    DataEn_APPL_IN : in STD_LOGIC := 'X'; 
    TCA_OUT_APPL : in STD_LOGIC := 'X'; 
    TCA_OUT_MOD : in STD_LOGIC := 'X'; 
    TCA_APPL_IN : out STD_LOGIC; 
    SOC_OUT_MOD : out STD_LOGIC; 
    SOC_MOD_IN : in STD_LOGIC := 'X'; 
    EOF_OUT_APPL : out STD_LOGIC; 
    CLK : in STD_LOGIC := 'X'; 
    SOF_OUT_APPL : out STD_LOGIC; 
    Ready_l : out STD_LOGIC; 
    EOF_APPL_IN : in STD_LOGIC := 'X'; 
    SOF_APPL_IN : in STD_LOGIC := 'X'; 
    Enable_l : in STD_LOGIC := 'X'; 
    D_OUT_APPL : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_MOD_IN : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_OUT_MOD : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_APPL_IN : in STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end FrameProc;

architecture STRUCTURE of FrameProc is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal NlwRenamedSignal_TCA_OUT_APPL : STD_LOGIC; 
  signal NlwRenamedSignal_TCA_OUT_MOD : STD_LOGIC; 
  signal Reset_l_0 : STD_LOGIC; 
  signal Reset_l_1 : STD_LOGIC; 
  signal enable_in : STD_LOGIC; 
  signal Reset_l_i_6_fast : STD_LOGIC; 
  signal Reset_l_i_5 : STD_LOGIC; 
  signal Reset_l_i_30 : STD_LOGIC; 
  signal Reset_l_i_31 : STD_LOGIC; 
  signal Reset_l_i_29 : STD_LOGIC; 
  signal Reset_l_i_28 : STD_LOGIC; 
  signal Reset_l_i_27 : STD_LOGIC; 
  signal Reset_l_i_26 : STD_LOGIC; 
  signal Reset_l_i_25 : STD_LOGIC; 
  signal Reset_l_i_24 : STD_LOGIC; 
  signal Reset_l_i_23 : STD_LOGIC; 
  signal Reset_l_i_22 : STD_LOGIC; 
  signal Reset_l_i_21 : STD_LOGIC; 
  signal Reset_l_i_20 : STD_LOGIC; 
  signal Reset_l_i_19 : STD_LOGIC; 
  signal Reset_l_i_18 : STD_LOGIC; 
  signal Reset_l_i_17 : STD_LOGIC; 
  signal Reset_l_i_16 : STD_LOGIC; 
  signal Reset_l_i_15 : STD_LOGIC; 
  signal Reset_l_i_14 : STD_LOGIC; 
  signal Reset_l_i_13 : STD_LOGIC; 
  signal Reset_l_i_12 : STD_LOGIC; 
  signal Reset_l_i_11 : STD_LOGIC; 
  signal Reset_l_i_10 : STD_LOGIC; 
  signal Reset_l_i_9 : STD_LOGIC; 
  signal Reset_l_i_8 : STD_LOGIC; 
  signal Reset_l_i_7 : STD_LOGIC; 
  signal Reset_l_i_6 : STD_LOGIC; 
  signal Reset_l_i_4 : STD_LOGIC; 
  signal Reset_l_i_3 : STD_LOGIC; 
  signal Reset_l_i_2 : STD_LOGIC; 
  signal Reset_l_i_1 : STD_LOGIC; 
  signal Reset_l_i : STD_LOGIC; 
  signal crc_out_crc_gen_d_soc_in : STD_LOGIC; 
  signal G_842 : STD_LOGIC; 
  signal G_843 : STD_LOGIC; 
  signal G_844 : STD_LOGIC; 
  signal crc_out_crc_gen_un5_count_c2 : STD_LOGIC; 
  signal G_845 : STD_LOGIC; 
  signal segment_out_state_6_Q : STD_LOGIC; 
  signal segment_un1_cur_len_1_c2 : STD_LOGIC; 
  signal G_847 : STD_LOGIC; 
  signal G_848 : STD_LOGIC; 
  signal segment_un1_cur_len_1_c1 : STD_LOGIC; 
  signal G_849 : STD_LOGIC; 
  signal segment_lfifo_out_0_Q : STD_LOGIC; 
  signal segment_N_1668 : STD_LOGIC; 
  signal segment_dfifo_out_0_Q : STD_LOGIC; 
  signal segment_N_1673 : STD_LOGIC; 
  signal G_858 : STD_LOGIC; 
  signal segment_lfifo_mt : STD_LOGIC; 
  signal segment_N_1391 : STD_LOGIC; 
  signal segment_N_1556_1 : STD_LOGIC; 
  signal segment_lfifo_out_6_Q : STD_LOGIC; 
  signal G_865 : STD_LOGIC; 
  signal segment_sof_in : STD_LOGIC; 
  signal segment_N_283 : STD_LOGIC; 
  signal G_866 : STD_LOGIC; 
  signal segment_out_state_1_Q : STD_LOGIC; 
  signal segment_out_state_7_Q : STD_LOGIC; 
  signal G_867 : STD_LOGIC; 
  signal data_enable_soc_in : STD_LOGIC; 
  signal data_enable_un2_cwcount_in_3_c2 : STD_LOGIC; 
  signal G_869 : STD_LOGIC; 
  signal data_enable_state_in_5_Q : STD_LOGIC; 
  signal G_870 : STD_LOGIC; 
  signal G_871 : STD_LOGIC; 
  signal G_872 : STD_LOGIC; 
  signal data_enable_N_7750 : STD_LOGIC; 
  signal data_enable_lc_flag : STD_LOGIC; 
  signal data_enable_state_out_4_Q : STD_LOGIC; 
  signal data_enable_buf_flag : STD_LOGIC; 
  signal G_907 : STD_LOGIC; 
  signal data_enable_N_8502 : STD_LOGIC; 
  signal data_enable_N_7315 : STD_LOGIC; 
  signal data_enable_out_sm_proc_un57_state_in : STD_LOGIC; 
  signal data_enable_N_7997 : STD_LOGIC; 
  signal G_908 : STD_LOGIC; 
  signal data_enable_N_7744 : STD_LOGIC; 
  signal data_enable_N_7745 : STD_LOGIC; 
  signal G_909 : STD_LOGIC; 
  signal data_enable_state_in_3_Q : STD_LOGIC; 
  signal data_enable_state_in_7_Q : STD_LOGIC; 
  signal G_910 : STD_LOGIC; 
  signal EOF_OUT_MOD_0_0_0_0_and2_0_287 : STD_LOGIC; 
  signal data_enable_out_sm_proc_un6_lc_copy_NE : STD_LOGIC; 
  signal EOF_OUT_MOD_0_0_0_0_and2_1_551 : STD_LOGIC; 
  signal G_911 : STD_LOGIC; 
  signal data_enable_N_7757 : STD_LOGIC; 
  signal data_enable_state_out_8_Q : STD_LOGIC; 
  signal G_913 : STD_LOGIC; 
  signal data_enable_state_in_4_Q : STD_LOGIC; 
  signal G_914 : STD_LOGIC; 
  signal crc_in_crc_gen_d_soc_in : STD_LOGIC; 
  signal G_916 : STD_LOGIC; 
  signal G_917 : STD_LOGIC; 
  signal G_918 : STD_LOGIC; 
  signal crc_in_crc_gen_un5_count_c2 : STD_LOGIC; 
  signal G_919 : STD_LOGIC; 
  signal G_62_0 : STD_LOGIC; 
  signal crc_out_crc_gen_soc_delay : STD_LOGIC; 
  signal crc_out_crc_gen_dataen_buf : STD_LOGIC; 
  signal G_63_0 : STD_LOGIC; 
  signal N_955_i : STD_LOGIC; 
  signal data_enable_N_7764 : STD_LOGIC; 
  signal data_enable_N_7748 : STD_LOGIC; 
  signal data_enable_N_7353 : STD_LOGIC; 
  signal data_enable_N_7976 : STD_LOGIC; 
  signal N_1021_i : STD_LOGIC; 
  signal G_6_0_0_0_or2 : STD_LOGIC; 
  signal data_enable_buf_copy : STD_LOGIC; 
  signal N_1024_i : STD_LOGIC; 
  signal G_62 : STD_LOGIC; 
  signal crc_in_crc_gen_soc_delay : STD_LOGIC; 
  signal crc_in_crc_gen_dataen_buf : STD_LOGIC; 
  signal G_63 : STD_LOGIC; 
  signal N_1029_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_21_Q : STD_LOGIC; 
  signal data_enable_N_7296_rep1 : STD_LOGIC; 
  signal data_enable_N_7978 : STD_LOGIC; 
  signal N_1006_1 : STD_LOGIC; 
  signal data_enable_N_7555 : STD_LOGIC; 
  signal data_enable_N_7971 : STD_LOGIC; 
  signal data_enable_N_7572 : STD_LOGIC; 
  signal data_enable_N_7972_1 : STD_LOGIC; 
  signal N_1006_2 : STD_LOGIC; 
  signal data_enable_N_7979 : STD_LOGIC; 
  signal data_enable_N_7980 : STD_LOGIC; 
  signal N_1006_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_19 : STD_LOGIC; 
  signal data_enable_N_7982 : STD_LOGIC; 
  signal data_enable_N_7439 : STD_LOGIC; 
  signal data_enable_N_7981 : STD_LOGIC; 
  signal N_1006_4 : STD_LOGIC; 
  signal G_897 : STD_LOGIC; 
  signal data_enable_N_7562 : STD_LOGIC; 
  signal data_enable_N_7971_fast : STD_LOGIC; 
  signal data_enable_N_7979_rep1 : STD_LOGIC; 
  signal N_1007_2 : STD_LOGIC; 
  signal data_enable_N_7579 : STD_LOGIC; 
  signal N_1007_3 : STD_LOGIC; 
  signal data_enable_N_7773 : STD_LOGIC; 
  signal N_1007_5 : STD_LOGIC; 
  signal data_enable_N_7771 : STD_LOGIC; 
  signal data_enable_N_7774 : STD_LOGIC; 
  signal G_898 : STD_LOGIC; 
  signal data_enable_N_7793 : STD_LOGIC; 
  signal data_enable_N_7324 : STD_LOGIC; 
  signal data_enable_N_8496 : STD_LOGIC; 
  signal N_1008_1 : STD_LOGIC; 
  signal data_enable_N_7792 : STD_LOGIC; 
  signal D_OUT_MOD_0_i_i_0_and2_2_1_541 : STD_LOGIC; 
  signal data_enable_N_7974 : STD_LOGIC; 
  signal N_1008_3 : STD_LOGIC; 
  signal data_enable_N_7795 : STD_LOGIC; 
  signal N_1008_6 : STD_LOGIC; 
  signal data_enable_N_7790 : STD_LOGIC; 
  signal data_enable_N_7789 : STD_LOGIC; 
  signal G_899 : STD_LOGIC; 
  signal data_enable_cell_buf_10_2_Q : STD_LOGIC; 
  signal N_1009_1 : STD_LOGIC; 
  signal data_enable_N_7561 : STD_LOGIC; 
  signal data_enable_N_7578 : STD_LOGIC; 
  signal N_1009_2 : STD_LOGIC; 
  signal N_1009_3 : STD_LOGIC; 
  signal data_enable_N_7420 : STD_LOGIC; 
  signal N_1009_4 : STD_LOGIC; 
  signal G_900 : STD_LOGIC; 
  signal data_enable_cell_buf_10_3_Q : STD_LOGIC; 
  signal N_1010_1 : STD_LOGIC; 
  signal data_enable_N_7560 : STD_LOGIC; 
  signal data_enable_N_7577 : STD_LOGIC; 
  signal N_1010_2 : STD_LOGIC; 
  signal N_1010_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_1 : STD_LOGIC; 
  signal data_enable_N_7421 : STD_LOGIC; 
  signal N_1010_4 : STD_LOGIC; 
  signal G_901 : STD_LOGIC; 
  signal data_enable_cell_buf_10_4_Q : STD_LOGIC; 
  signal data_enable_N_7296 : STD_LOGIC; 
  signal N_1011_1 : STD_LOGIC; 
  signal data_enable_N_7559 : STD_LOGIC; 
  signal data_enable_N_7576 : STD_LOGIC; 
  signal N_1011_2 : STD_LOGIC; 
  signal N_1011_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_2 : STD_LOGIC; 
  signal data_enable_N_7422 : STD_LOGIC; 
  signal N_1011_4 : STD_LOGIC; 
  signal G_902 : STD_LOGIC; 
  signal data_enable_cell_buf_10_5_Q : STD_LOGIC; 
  signal N_1012_1 : STD_LOGIC; 
  signal data_enable_N_7558 : STD_LOGIC; 
  signal data_enable_N_7575 : STD_LOGIC; 
  signal N_1012_2 : STD_LOGIC; 
  signal N_1012_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_3 : STD_LOGIC; 
  signal data_enable_N_7423 : STD_LOGIC; 
  signal N_1012_4 : STD_LOGIC; 
  signal G_903 : STD_LOGIC; 
  signal data_enable_cell_buf_10_6_Q : STD_LOGIC; 
  signal N_1013_1 : STD_LOGIC; 
  signal data_enable_N_7557 : STD_LOGIC; 
  signal data_enable_N_7574 : STD_LOGIC; 
  signal N_1013_2 : STD_LOGIC; 
  signal N_1013_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_4 : STD_LOGIC; 
  signal data_enable_N_7424 : STD_LOGIC; 
  signal N_1013_4 : STD_LOGIC; 
  signal G_904 : STD_LOGIC; 
  signal N_1014_3 : STD_LOGIC; 
  signal N_1014_2 : STD_LOGIC; 
  signal G_905 : STD_LOGIC; 
  signal G_906 : STD_LOGIC; 
  signal data_enable_cell_buf_10_31_Q : STD_LOGIC; 
  signal data_enable_N_7296_fast : STD_LOGIC; 
  signal N_991_1 : STD_LOGIC; 
  signal data_enable_N_7546 : STD_LOGIC; 
  signal data_enable_N_7563 : STD_LOGIC; 
  signal data_enable_N_7972 : STD_LOGIC; 
  signal N_991_2 : STD_LOGIC; 
  signal data_enable_N_7979_rep2 : STD_LOGIC; 
  signal N_991_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_29 : STD_LOGIC; 
  signal data_enable_N_7982_rep1 : STD_LOGIC; 
  signal data_enable_N_7449 : STD_LOGIC; 
  signal N_991_4 : STD_LOGIC; 
  signal G_882 : STD_LOGIC; 
  signal data_enable_N_7534 : STD_LOGIC; 
  signal data_enable_N_7983 : STD_LOGIC; 
  signal data_enable_N_7979_fast : STD_LOGIC; 
  signal N_992_2 : STD_LOGIC; 
  signal data_enable_N_7980_fast : STD_LOGIC; 
  signal data_enable_N_7978_fast : STD_LOGIC; 
  signal N_992_3 : STD_LOGIC; 
  signal data_enable_N_7800 : STD_LOGIC; 
  signal un32_d_out_mod_s_5 : STD_LOGIC; 
  signal data_enable_N_7982_fast : STD_LOGIC; 
  signal N_992_7 : STD_LOGIC; 
  signal data_enable_N_7805 : STD_LOGIC; 
  signal data_enable_N_7803 : STD_LOGIC; 
  signal N_992_8 : STD_LOGIC; 
  signal data_enable_N_7797 : STD_LOGIC; 
  signal data_enable_cell_buf_11_7_Q : STD_LOGIC; 
  signal data_enable_N_7291 : STD_LOGIC; 
  signal G_883 : STD_LOGIC; 
  signal data_enable_N_7426 : STD_LOGIC; 
  signal data_enable_N_7981_fast : STD_LOGIC; 
  signal data_enable_N_7488 : STD_LOGIC; 
  signal data_enable_N_7986 : STD_LOGIC; 
  signal N_993_1 : STD_LOGIC; 
  signal N_993_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_6 : STD_LOGIC; 
  signal data_enable_N_7394 : STD_LOGIC; 
  signal data_enable_N_7984 : STD_LOGIC; 
  signal N_993_4 : STD_LOGIC; 
  signal data_enable_cell_buf_10_8_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_8_Q : STD_LOGIC; 
  signal G_6027_1_fast : STD_LOGIC; 
  signal N_993_5 : STD_LOGIC; 
  signal data_enable_N_7815 : STD_LOGIC; 
  signal N_993_6 : STD_LOGIC; 
  signal G_884 : STD_LOGIC; 
  signal data_enable_N_7427 : STD_LOGIC; 
  signal data_enable_N_7489 : STD_LOGIC; 
  signal N_994_1 : STD_LOGIC; 
  signal N_994_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_7 : STD_LOGIC; 
  signal data_enable_N_7395 : STD_LOGIC; 
  signal N_994_4 : STD_LOGIC; 
  signal data_enable_cell_buf_10_9_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_9_Q : STD_LOGIC; 
  signal N_994_5 : STD_LOGIC; 
  signal data_enable_N_7826 : STD_LOGIC; 
  signal N_994_6 : STD_LOGIC; 
  signal G_885 : STD_LOGIC; 
  signal data_enable_N_7531 : STD_LOGIC; 
  signal N_995_2 : STD_LOGIC; 
  signal N_995_3 : STD_LOGIC; 
  signal data_enable_N_7833 : STD_LOGIC; 
  signal un32_d_out_mod_s_8 : STD_LOGIC; 
  signal N_995_7 : STD_LOGIC; 
  signal data_enable_N_7838 : STD_LOGIC; 
  signal data_enable_N_7836 : STD_LOGIC; 
  signal N_995_8 : STD_LOGIC; 
  signal data_enable_N_7830 : STD_LOGIC; 
  signal data_enable_cell_buf_11_10_Q : STD_LOGIC; 
  signal G_886 : STD_LOGIC; 
  signal data_enable_N_7429 : STD_LOGIC; 
  signal data_enable_N_7491 : STD_LOGIC; 
  signal N_996_1 : STD_LOGIC; 
  signal N_996_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_9 : STD_LOGIC; 
  signal data_enable_N_7397 : STD_LOGIC; 
  signal N_996_4 : STD_LOGIC; 
  signal data_enable_cell_buf_10_11_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_11_Q : STD_LOGIC; 
  signal N_996_5 : STD_LOGIC; 
  signal data_enable_N_7848 : STD_LOGIC; 
  signal N_996_6 : STD_LOGIC; 
  signal G_887 : STD_LOGIC; 
  signal data_enable_N_7430 : STD_LOGIC; 
  signal data_enable_N_7492 : STD_LOGIC; 
  signal N_997_1 : STD_LOGIC; 
  signal N_997_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_10 : STD_LOGIC; 
  signal data_enable_N_7398 : STD_LOGIC; 
  signal N_997_4 : STD_LOGIC; 
  signal data_enable_cell_buf_10_12_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_12_Q : STD_LOGIC; 
  signal N_997_5 : STD_LOGIC; 
  signal data_enable_N_7859 : STD_LOGIC; 
  signal N_997_6 : STD_LOGIC; 
  signal G_888 : STD_LOGIC; 
  signal data_enable_N_7528 : STD_LOGIC; 
  signal N_998_2 : STD_LOGIC; 
  signal N_998_3 : STD_LOGIC; 
  signal data_enable_N_7866 : STD_LOGIC; 
  signal un32_d_out_mod_s_11 : STD_LOGIC; 
  signal N_998_7 : STD_LOGIC; 
  signal data_enable_N_7871 : STD_LOGIC; 
  signal data_enable_N_7869 : STD_LOGIC; 
  signal N_998_8 : STD_LOGIC; 
  signal data_enable_N_7863 : STD_LOGIC; 
  signal data_enable_cell_buf_11_13_Q : STD_LOGIC; 
  signal G_889 : STD_LOGIC; 
  signal data_enable_N_7527 : STD_LOGIC; 
  signal N_999_2 : STD_LOGIC; 
  signal N_999_3 : STD_LOGIC; 
  signal data_enable_N_7877 : STD_LOGIC; 
  signal un32_d_out_mod_s_12 : STD_LOGIC; 
  signal N_999_7 : STD_LOGIC; 
  signal data_enable_N_7882 : STD_LOGIC; 
  signal data_enable_N_7880 : STD_LOGIC; 
  signal N_999_8 : STD_LOGIC; 
  signal data_enable_N_7874 : STD_LOGIC; 
  signal data_enable_cell_buf_11_14_Q : STD_LOGIC; 
  signal G_890 : STD_LOGIC; 
  signal data_enable_N_7510 : STD_LOGIC; 
  signal N_1000_2 : STD_LOGIC; 
  signal N_1000_3 : STD_LOGIC; 
  signal data_enable_N_7888 : STD_LOGIC; 
  signal un32_d_out_mod_s_13 : STD_LOGIC; 
  signal N_1000_7 : STD_LOGIC; 
  signal data_enable_N_7893 : STD_LOGIC; 
  signal data_enable_N_7891 : STD_LOGIC; 
  signal N_1000_8 : STD_LOGIC; 
  signal data_enable_N_7885 : STD_LOGIC; 
  signal data_enable_cell_buf_11_15_Q : STD_LOGIC; 
  signal G_891 : STD_LOGIC; 
  signal data_enable_N_7511 : STD_LOGIC; 
  signal N_1001_2 : STD_LOGIC; 
  signal data_enable_N_7980_rep1 : STD_LOGIC; 
  signal data_enable_N_7978_rep1 : STD_LOGIC; 
  signal N_1001_3 : STD_LOGIC; 
  signal data_enable_N_7899 : STD_LOGIC; 
  signal un32_d_out_mod_s_14 : STD_LOGIC; 
  signal N_1001_7 : STD_LOGIC; 
  signal data_enable_N_7904 : STD_LOGIC; 
  signal data_enable_N_7902 : STD_LOGIC; 
  signal N_1001_8 : STD_LOGIC; 
  signal data_enable_N_7896 : STD_LOGIC; 
  signal data_enable_cell_buf_11_16_Q : STD_LOGIC; 
  signal G_892 : STD_LOGIC; 
  signal data_enable_N_7497 : STD_LOGIC; 
  signal N_1002_1 : STD_LOGIC; 
  signal data_enable_N_7512 : STD_LOGIC; 
  signal N_1002_2 : STD_LOGIC; 
  signal N_1002_3 : STD_LOGIC; 
  signal data_enable_cell_buf_10_17_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_17_Q : STD_LOGIC; 
  signal N_1002_5 : STD_LOGIC; 
  signal data_enable_N_7910 : STD_LOGIC; 
  signal un32_d_out_mod_s_15 : STD_LOGIC; 
  signal N_1002_7 : STD_LOGIC; 
  signal G_893 : STD_LOGIC; 
  signal data_enable_N_7498 : STD_LOGIC; 
  signal N_1003_1 : STD_LOGIC; 
  signal data_enable_N_7513 : STD_LOGIC; 
  signal N_1003_2 : STD_LOGIC; 
  signal N_1003_3 : STD_LOGIC; 
  signal data_enable_cell_buf_10_18_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_18_Q : STD_LOGIC; 
  signal N_1003_5 : STD_LOGIC; 
  signal data_enable_N_7921 : STD_LOGIC; 
  signal un32_d_out_mod_s_16 : STD_LOGIC; 
  signal N_1003_7 : STD_LOGIC; 
  signal G_894 : STD_LOGIC; 
  signal data_enable_N_7499 : STD_LOGIC; 
  signal N_1004_1 : STD_LOGIC; 
  signal data_enable_N_7514 : STD_LOGIC; 
  signal N_1004_2 : STD_LOGIC; 
  signal N_1004_3 : STD_LOGIC; 
  signal data_enable_cell_buf_10_19_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_19_Q : STD_LOGIC; 
  signal N_1004_5 : STD_LOGIC; 
  signal data_enable_N_7932 : STD_LOGIC; 
  signal un32_d_out_mod_s_17 : STD_LOGIC; 
  signal N_1004_7 : STD_LOGIC; 
  signal G_895 : STD_LOGIC; 
  signal data_enable_cell_buf_10_20_Q : STD_LOGIC; 
  signal N_1005_1 : STD_LOGIC; 
  signal data_enable_N_7556 : STD_LOGIC; 
  signal data_enable_N_7573 : STD_LOGIC; 
  signal N_1005_2 : STD_LOGIC; 
  signal N_1005_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_18 : STD_LOGIC; 
  signal data_enable_N_7438 : STD_LOGIC; 
  signal N_1005_4 : STD_LOGIC; 
  signal G_896 : STD_LOGIC; 
  signal segment_out_state_3_Q : STD_LOGIC; 
  signal segment_N_1408 : STD_LOGIC; 
  signal N_977_1 : STD_LOGIC; 
  signal segment_soc_out : STD_LOGIC; 
  signal segment_N_650 : STD_LOGIC; 
  signal G_868 : STD_LOGIC; 
  signal data_enable_cell_buf_10_22_Q : STD_LOGIC; 
  signal N_982_1 : STD_LOGIC; 
  signal data_enable_N_7554 : STD_LOGIC; 
  signal data_enable_N_7971_rep1 : STD_LOGIC; 
  signal data_enable_N_7571 : STD_LOGIC; 
  signal N_982_2 : STD_LOGIC; 
  signal N_982_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_20 : STD_LOGIC; 
  signal data_enable_N_7440 : STD_LOGIC; 
  signal data_enable_N_7981_rep1 : STD_LOGIC; 
  signal N_982_4 : STD_LOGIC; 
  signal G_873 : STD_LOGIC; 
  signal data_enable_cell_buf_10_23_Q : STD_LOGIC; 
  signal N_983_1 : STD_LOGIC; 
  signal data_enable_N_7553 : STD_LOGIC; 
  signal data_enable_N_7570 : STD_LOGIC; 
  signal N_983_2 : STD_LOGIC; 
  signal N_983_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_21 : STD_LOGIC; 
  signal data_enable_N_7441 : STD_LOGIC; 
  signal N_983_4 : STD_LOGIC; 
  signal G_874 : STD_LOGIC; 
  signal data_enable_cell_buf_10_24_Q : STD_LOGIC; 
  signal N_984_1 : STD_LOGIC; 
  signal data_enable_N_7552 : STD_LOGIC; 
  signal data_enable_N_7569 : STD_LOGIC; 
  signal N_984_2 : STD_LOGIC; 
  signal N_984_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_22 : STD_LOGIC; 
  signal data_enable_N_7442 : STD_LOGIC; 
  signal N_984_4 : STD_LOGIC; 
  signal G_875 : STD_LOGIC; 
  signal data_enable_cell_buf_10_25_Q : STD_LOGIC; 
  signal N_985_1 : STD_LOGIC; 
  signal data_enable_N_7551 : STD_LOGIC; 
  signal data_enable_N_7568 : STD_LOGIC; 
  signal N_985_2 : STD_LOGIC; 
  signal N_985_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_23 : STD_LOGIC; 
  signal data_enable_N_7443 : STD_LOGIC; 
  signal N_985_4 : STD_LOGIC; 
  signal G_876 : STD_LOGIC; 
  signal data_enable_cell_buf_10_26_Q : STD_LOGIC; 
  signal N_986_1 : STD_LOGIC; 
  signal data_enable_N_7550 : STD_LOGIC; 
  signal data_enable_N_7567 : STD_LOGIC; 
  signal N_986_2 : STD_LOGIC; 
  signal N_986_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_24 : STD_LOGIC; 
  signal data_enable_N_7444 : STD_LOGIC; 
  signal N_986_4 : STD_LOGIC; 
  signal G_877 : STD_LOGIC; 
  signal data_enable_cell_buf_10_27_Q : STD_LOGIC; 
  signal N_987_1 : STD_LOGIC; 
  signal data_enable_N_7549 : STD_LOGIC; 
  signal data_enable_N_7566 : STD_LOGIC; 
  signal N_987_2 : STD_LOGIC; 
  signal N_987_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_25 : STD_LOGIC; 
  signal data_enable_N_7445 : STD_LOGIC; 
  signal N_987_4 : STD_LOGIC; 
  signal G_878 : STD_LOGIC; 
  signal data_enable_cell_buf_10_28_Q : STD_LOGIC; 
  signal N_988_1 : STD_LOGIC; 
  signal data_enable_N_7548 : STD_LOGIC; 
  signal data_enable_N_7565 : STD_LOGIC; 
  signal N_988_2 : STD_LOGIC; 
  signal N_988_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_26 : STD_LOGIC; 
  signal data_enable_N_7446 : STD_LOGIC; 
  signal N_988_4 : STD_LOGIC; 
  signal G_879 : STD_LOGIC; 
  signal data_enable_cell_buf_10_29_Q : STD_LOGIC; 
  signal N_989_1 : STD_LOGIC; 
  signal data_enable_N_7547 : STD_LOGIC; 
  signal data_enable_N_7564 : STD_LOGIC; 
  signal N_989_2 : STD_LOGIC; 
  signal N_989_3 : STD_LOGIC; 
  signal un32_d_out_mod_s_27 : STD_LOGIC; 
  signal data_enable_N_7447 : STD_LOGIC; 
  signal N_989_4 : STD_LOGIC; 
  signal G_880 : STD_LOGIC; 
  signal data_enable_N_7524 : STD_LOGIC; 
  signal N_990_2 : STD_LOGIC; 
  signal N_990_3 : STD_LOGIC; 
  signal data_enable_N_7943 : STD_LOGIC; 
  signal un32_d_out_mod_s_28 : STD_LOGIC; 
  signal N_990_7 : STD_LOGIC; 
  signal data_enable_N_7948 : STD_LOGIC; 
  signal data_enable_N_7946 : STD_LOGIC; 
  signal N_990_8 : STD_LOGIC; 
  signal data_enable_N_7940 : STD_LOGIC; 
  signal data_enable_cell_buf_11_30_Q : STD_LOGIC; 
  signal G_881 : STD_LOGIC; 
  signal segment_N_1671 : STD_LOGIC; 
  signal un27_data_out_s_8 : STD_LOGIC; 
  signal segment_N_1672 : STD_LOGIC; 
  signal N_961_1 : STD_LOGIC; 
  signal segment_dfifo_out_10_Q : STD_LOGIC; 
  signal G_852 : STD_LOGIC; 
  signal un27_data_out_s_9 : STD_LOGIC; 
  signal N_962_1 : STD_LOGIC; 
  signal segment_dfifo_out_11_Q : STD_LOGIC; 
  signal G_853 : STD_LOGIC; 
  signal un27_data_out_s_10 : STD_LOGIC; 
  signal N_963_1 : STD_LOGIC; 
  signal segment_dfifo_out_12_Q : STD_LOGIC; 
  signal G_854 : STD_LOGIC; 
  signal un27_data_out_s_11 : STD_LOGIC; 
  signal N_964_1 : STD_LOGIC; 
  signal segment_dfifo_out_13_Q : STD_LOGIC; 
  signal G_855 : STD_LOGIC; 
  signal un27_data_out_s_12 : STD_LOGIC; 
  signal N_965_1 : STD_LOGIC; 
  signal segment_dfifo_out_14_Q : STD_LOGIC; 
  signal G_856 : STD_LOGIC; 
  signal un27_data_out_s_13 : STD_LOGIC; 
  signal N_966_1 : STD_LOGIC; 
  signal segment_dfifo_out_15_Q : STD_LOGIC; 
  signal G_857 : STD_LOGIC; 
  signal N_968_1 : STD_LOGIC; 
  signal segment_dfifo_out_2_Q : STD_LOGIC; 
  signal G_859 : STD_LOGIC; 
  signal un27_data_out_s_1 : STD_LOGIC; 
  signal N_969_1 : STD_LOGIC; 
  signal segment_dfifo_out_3_Q : STD_LOGIC; 
  signal G_860 : STD_LOGIC; 
  signal un27_data_out_s_2 : STD_LOGIC; 
  signal N_970_1 : STD_LOGIC; 
  signal segment_dfifo_out_4_Q : STD_LOGIC; 
  signal G_861 : STD_LOGIC; 
  signal un27_data_out_s_3 : STD_LOGIC; 
  signal N_971_1 : STD_LOGIC; 
  signal segment_dfifo_out_5_Q : STD_LOGIC; 
  signal G_862 : STD_LOGIC; 
  signal un27_data_out_s_4 : STD_LOGIC; 
  signal N_972_1 : STD_LOGIC; 
  signal segment_dfifo_out_6_Q : STD_LOGIC; 
  signal G_863 : STD_LOGIC; 
  signal un27_data_out_s_5 : STD_LOGIC; 
  signal N_973_1 : STD_LOGIC; 
  signal segment_dfifo_out_7_Q : STD_LOGIC; 
  signal G_864 : STD_LOGIC; 
  signal un27_data_out_s_6 : STD_LOGIC; 
  signal N_959_1 : STD_LOGIC; 
  signal segment_dfifo_out_8_Q : STD_LOGIC; 
  signal G_850 : STD_LOGIC; 
  signal un27_data_out_s_7 : STD_LOGIC; 
  signal N_960_1 : STD_LOGIC; 
  signal segment_dfifo_out_9_Q : STD_LOGIC; 
  signal G_851 : STD_LOGIC; 
  signal soc2 : STD_LOGIC; 
  signal soc8 : STD_LOGIC; 
  signal crc_in_crc_pos_wire : STD_LOGIC; 
  signal crc_in_soc_wire : STD_LOGIC; 
  signal crc_in_crc_gen_is_lastcell : STD_LOGIC; 
  signal crc_in_crc_gen_sof_buf : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q111 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q11 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q_369 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q000 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q101 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q000_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q000_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q011_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q011 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q011_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q101_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q111_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q00 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_3 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q101_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_4 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q101_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q00_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110_3 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_3 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q_537 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q11_0 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_4 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100_3 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_5 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_5 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_6 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q001_6 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q000_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100_4 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q100_5 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q010_7 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110_4 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q110_5 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q11_1 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_q11_2 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row0_xorq_q_371 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row0_xorq_q_372 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row1_xorq_q_194 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row1_xorq_q_192 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row2_xorq_q_317 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row2_xorq_q_312 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row3_xorq_q_129 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row3_xorq_q_128 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row3_xorq_q_123 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row4_xorq_q_253 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row4_xorq_q_252 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row4_xorq_q_247 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row5_xorq_q_510 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row5_xorq_q_507 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row6_xorq_q_202 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row6_xorq_q_197 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row7_xorq_q_429 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row7_xorq_q_426 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row8_xorq_q_502 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row8_xorq_q_501 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row9_xorq_q_49 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row9_xorq_q_47 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row10_xorq_q_538 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row11_xorq_q_309 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row11_xorq_q_307 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row11_xorq_q_305 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row12_xorq_q_108 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row12_xorq_q_107 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row12_xorq_q_104 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row13_xorq_q_261 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row13_xorq_q_259 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row13_xorq_q_257 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row14_xorq_q_209 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row14_xorq_q_207 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row14_xorq_q_205 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row15_xorq_q_229 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row15_xorq_q_224 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row16_xorq_q_138 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row16_xorq_q_136 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row16_xorq_q_131 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row17_xorq_q_80 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row17_xorq_q_78 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row17_xorq_q_73 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row18_xorq_q_416 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row18_xorq_q_413 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row19_xorq_q_144 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row19_xorq_q_142 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row20_xorq_q_114 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row20_xorq_q_112 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row21_xorq_q_471 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row22_xorq_q_444 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row22_xorq_q_441 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row23_xorq_q_466 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row23_xorq_q_463 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row24_xorq_q_344 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row25_xorq_q_459 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row26_xorq_q_410 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row26_xorq_q_406 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row27_xorq_q_285 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row27_xorq_q_283 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row27_xorq_q_279 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row28_xorq_q_360 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row28_xorq_q_357 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row29_xorq_q_492 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row29_xorq_q_489 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row30_xorq_q_217 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row30_xorq_q_215 : STD_LOGIC; 
  signal crc_in_crc_gen_crccalc_matrix_row31_xorq_q_378 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_1 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_2 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_3 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_4 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_5 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_6 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_7 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_8 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_9 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_10 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_11 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_12 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_13 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_14 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_15 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_16 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_17 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_18 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_19 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_20 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_21 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_22 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_23 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_24 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_25 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_26 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_27 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_28 : STD_LOGIC; 
  signal data_enable_N_1805_i : STD_LOGIC; 
  signal data_enable_N_1806_i : STD_LOGIC; 
  signal data_enable_N_1807_i : STD_LOGIC; 
  signal data_enable_N_1808_i : STD_LOGIC; 
  signal data_enable_N_1809_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_7_Q : STD_LOGIC; 
  signal data_enable_N_1810_i : STD_LOGIC; 
  signal data_enable_N_1811_i : STD_LOGIC; 
  signal data_enable_N_1812_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_10_Q : STD_LOGIC; 
  signal data_enable_N_1813_i : STD_LOGIC; 
  signal data_enable_N_1814_i : STD_LOGIC; 
  signal data_enable_N_1815_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_13_Q : STD_LOGIC; 
  signal data_enable_N_1816_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_14_Q : STD_LOGIC; 
  signal data_enable_N_1817_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_15_Q : STD_LOGIC; 
  signal data_enable_N_1818_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_16_Q : STD_LOGIC; 
  signal data_enable_N_1819_i : STD_LOGIC; 
  signal data_enable_N_1820_i : STD_LOGIC; 
  signal data_enable_N_1821_i : STD_LOGIC; 
  signal data_enable_N_1822_i : STD_LOGIC; 
  signal data_enable_N_1823_i : STD_LOGIC; 
  signal data_enable_N_1824_i : STD_LOGIC; 
  signal data_enable_N_1825_i : STD_LOGIC; 
  signal data_enable_N_1826_i : STD_LOGIC; 
  signal data_enable_N_1827_i : STD_LOGIC; 
  signal data_enable_N_1828_i : STD_LOGIC; 
  signal data_enable_N_1829_i : STD_LOGIC; 
  signal data_enable_N_1830_i : STD_LOGIC; 
  signal data_enable_N_1831_i : STD_LOGIC; 
  signal data_enable_N_1832_i : STD_LOGIC; 
  signal data_enable_cell_buf_10_30_Q : STD_LOGIC; 
  signal data_enable_N_1833_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_2_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_3_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_4_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_5_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_6_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_7_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_8_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_9_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_10_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_11_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_12_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_13_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_14_i : STD_LOGIC; 
  signal data_enable_un73_state_in_axb_15_i : STD_LOGIC; 
  signal data_enable_N_4674_i : STD_LOGIC; 
  signal data_enable_VCC : STD_LOGIC; 
  signal data_enable_GND : STD_LOGIC; 
  signal data_enable_cell_buf_11_20_Q : STD_LOGIC; 
  signal data_enable_un1_un1_un2_cell_buf_11_i_0_0_0 : STD_LOGIC; 
  signal data_enable_cell_buf_11_21_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_22_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_23_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_24_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_25_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_26_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_27_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_28_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_29_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_31_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_5_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_6_Q : STD_LOGIC; 
  signal data_enable_N_7376 : STD_LOGIC; 
  signal data_enable_un1_un1_un5_cell_buf_10_i_0_0_0 : STD_LOGIC; 
  signal data_enable_G_6113 : STD_LOGIC; 
  signal data_enable_G_6114 : STD_LOGIC; 
  signal data_enable_G_6115 : STD_LOGIC; 
  signal data_enable_G_6116 : STD_LOGIC; 
  signal data_enable_G_6117 : STD_LOGIC; 
  signal data_enable_G_6118 : STD_LOGIC; 
  signal data_enable_G_6119 : STD_LOGIC; 
  signal data_enable_G_6120 : STD_LOGIC; 
  signal data_enable_G_6121 : STD_LOGIC; 
  signal data_enable_cell_buf_11_0_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_1_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_2_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_3_Q : STD_LOGIC; 
  signal data_enable_cell_buf_11_4_Q : STD_LOGIC; 
  signal data_enable_G_6097 : STD_LOGIC; 
  signal data_enable_G_6098 : STD_LOGIC; 
  signal data_enable_G_6099 : STD_LOGIC; 
  signal data_enable_G_6100 : STD_LOGIC; 
  signal data_enable_G_6101 : STD_LOGIC; 
  signal data_enable_G_6102 : STD_LOGIC; 
  signal data_enable_G_6103 : STD_LOGIC; 
  signal data_enable_G_6104 : STD_LOGIC; 
  signal data_enable_G_6105 : STD_LOGIC; 
  signal data_enable_G_6106 : STD_LOGIC; 
  signal data_enable_G_6107 : STD_LOGIC; 
  signal data_enable_G_6108 : STD_LOGIC; 
  signal data_enable_G_6109 : STD_LOGIC; 
  signal data_enable_G_6110 : STD_LOGIC; 
  signal data_enable_G_6111 : STD_LOGIC; 
  signal data_enable_cell_buf_10_0_Q : STD_LOGIC; 
  signal data_enable_cell_buf_10_1_Q : STD_LOGIC; 
  signal data_enable_N_7345_i : STD_LOGIC; 
  signal data_enable_G_6093 : STD_LOGIC; 
  signal data_enable_G_6094 : STD_LOGIC; 
  signal data_enable_G_6095 : STD_LOGIC; 
  signal data_enable_G_6096 : STD_LOGIC; 
  signal data_enable_un1_state_in_9_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_7_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_6_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_3_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_4_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_5_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_10_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_2_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_8_0_and2_0_and2_0_and2 : STD_LOGIC; 
  signal data_enable_un1_state_in_11_0_0_0 : STD_LOGIC; 
  signal data_enable_G_5564 : STD_LOGIC; 
  signal data_enable_G_6_0_0_0 : STD_LOGIC; 
  signal data_enable_N_1834_i : STD_LOGIC; 
  signal data_enable_state_out_5_rep1 : STD_LOGIC; 
  signal data_enable_lc_copy : STD_LOGIC; 
  signal data_enable_N_7963 : STD_LOGIC; 
  signal data_enable_state_out_5_Q : STD_LOGIC; 
  signal data_enable_state_out_0_Q : STD_LOGIC; 
  signal data_enable_G_6027_fast : STD_LOGIC; 
  signal data_enable_N_7977 : STD_LOGIC; 
  signal data_enable_N_7969 : STD_LOGIC; 
  signal data_enable_N_8046 : STD_LOGIC; 
  signal data_enable_N_7967 : STD_LOGIC; 
  signal data_enable_cwcount_out_0_Q : STD_LOGIC; 
  signal data_enable_cwcount_out_3_Q : STD_LOGIC; 
  signal data_enable_state_out_2_Q : STD_LOGIC; 
  signal data_enable_G_4_11 : STD_LOGIC; 
  signal data_enable_state_out_1_Q : STD_LOGIC; 
  signal data_enable_G_5499_fast : STD_LOGIC; 
  signal data_enable_state_out_3_Q : STD_LOGIC; 
  signal data_enable_state_out_6_Q : STD_LOGIC; 
  signal data_enable_G_2_7 : STD_LOGIC; 
  signal data_enable_N_7973 : STD_LOGIC; 
  signal data_enable_G_4_4 : STD_LOGIC; 
  signal data_enable_N_7291_1 : STD_LOGIC; 
  signal data_enable_N_4687_i : STD_LOGIC; 
  signal data_enable_N_4689_i : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_0 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_axb_29 : STD_LOGIC; 
  signal data_enable_G_6056_am : STD_LOGIC; 
  signal data_enable_G_6056_bm : STD_LOGIC; 
  signal data_enable_N_7320 : STD_LOGIC; 
  signal data_enable_G_6060_am : STD_LOGIC; 
  signal data_enable_G_6060_bm : STD_LOGIC; 
  signal data_enable_N_7796 : STD_LOGIC; 
  signal data_enable_N_7319 : STD_LOGIC; 
  signal data_enable_N_8049 : STD_LOGIC; 
  signal data_enable_N_7760 : STD_LOGIC; 
  signal data_enable_N_7762 : STD_LOGIC; 
  signal data_enable_N_7586 : STD_LOGIC; 
  signal data_enable_N_8044 : STD_LOGIC; 
  signal data_enable_N_7985 : STD_LOGIC; 
  signal data_enable_G_6298_am : STD_LOGIC; 
  signal data_enable_G_6298_bm : STD_LOGIC; 
  signal data_enable_G_6315_am : STD_LOGIC; 
  signal data_enable_G_6315_bm : STD_LOGIC; 
  signal data_enable_N_7766 : STD_LOGIC; 
  signal data_enable_N_4702 : STD_LOGIC; 
  signal data_enable_N_6888 : STD_LOGIC; 
  signal data_enable_N_4682 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_20 : STD_LOGIC; 
  signal data_enable_N_7290 : STD_LOGIC; 
  signal data_enable_N_7734 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_11 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_7 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_6 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_5 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_2 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_1 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_4 : STD_LOGIC; 
  signal data_enable_un6_lc_copy_NE_3 : STD_LOGIC; 
  signal data_enable_N_7942 : STD_LOGIC; 
  signal data_enable_N_7931 : STD_LOGIC; 
  signal data_enable_N_7920 : STD_LOGIC; 
  signal data_enable_N_7909 : STD_LOGIC; 
  signal data_enable_N_7898 : STD_LOGIC; 
  signal data_enable_N_7887 : STD_LOGIC; 
  signal data_enable_N_7876 : STD_LOGIC; 
  signal data_enable_N_7865 : STD_LOGIC; 
  signal data_enable_N_7854 : STD_LOGIC; 
  signal data_enable_N_7843 : STD_LOGIC; 
  signal data_enable_N_7832 : STD_LOGIC; 
  signal data_enable_N_7821 : STD_LOGIC; 
  signal data_enable_N_7810 : STD_LOGIC; 
  signal data_enable_N_7799 : STD_LOGIC; 
  signal data_enable_N_7723 : STD_LOGIC; 
  signal data_enable_N_7714 : STD_LOGIC; 
  signal data_enable_N_7705 : STD_LOGIC; 
  signal data_enable_N_7696 : STD_LOGIC; 
  signal data_enable_N_7687 : STD_LOGIC; 
  signal data_enable_N_7678 : STD_LOGIC; 
  signal data_enable_N_7669 : STD_LOGIC; 
  signal data_enable_N_7660 : STD_LOGIC; 
  signal data_enable_N_7651 : STD_LOGIC; 
  signal data_enable_N_7642 : STD_LOGIC; 
  signal data_enable_N_7633 : STD_LOGIC; 
  signal data_enable_N_7624 : STD_LOGIC; 
  signal data_enable_N_7615 : STD_LOGIC; 
  signal data_enable_N_7606 : STD_LOGIC; 
  signal data_enable_N_7597 : STD_LOGIC; 
  signal data_enable_N_7588 : STD_LOGIC; 
  signal data_enable_G_6314_am : STD_LOGIC; 
  signal data_enable_G_6314_bm : STD_LOGIC; 
  signal data_enable_G_6313_am : STD_LOGIC; 
  signal data_enable_G_6313_bm : STD_LOGIC; 
  signal data_enable_G_6312_am : STD_LOGIC; 
  signal data_enable_G_6312_bm : STD_LOGIC; 
  signal data_enable_G_6311_am : STD_LOGIC; 
  signal data_enable_G_6311_bm : STD_LOGIC; 
  signal data_enable_G_6310_am : STD_LOGIC; 
  signal data_enable_G_6310_bm : STD_LOGIC; 
  signal data_enable_G_6309_am : STD_LOGIC; 
  signal data_enable_G_6309_bm : STD_LOGIC; 
  signal data_enable_G_6308_am : STD_LOGIC; 
  signal data_enable_G_6308_bm : STD_LOGIC; 
  signal data_enable_G_6307_am : STD_LOGIC; 
  signal data_enable_G_6307_bm : STD_LOGIC; 
  signal data_enable_G_6306_am : STD_LOGIC; 
  signal data_enable_G_6306_bm : STD_LOGIC; 
  signal data_enable_G_6305_am : STD_LOGIC; 
  signal data_enable_G_6305_bm : STD_LOGIC; 
  signal data_enable_G_6304_am : STD_LOGIC; 
  signal data_enable_G_6304_bm : STD_LOGIC; 
  signal data_enable_G_6303_am : STD_LOGIC; 
  signal data_enable_G_6303_bm : STD_LOGIC; 
  signal data_enable_G_6302_am : STD_LOGIC; 
  signal data_enable_G_6302_bm : STD_LOGIC; 
  signal data_enable_G_6301_am : STD_LOGIC; 
  signal data_enable_G_6301_bm : STD_LOGIC; 
  signal data_enable_G_6300_am : STD_LOGIC; 
  signal data_enable_G_6300_bm : STD_LOGIC; 
  signal data_enable_G_6299_am : STD_LOGIC; 
  signal data_enable_G_6299_bm : STD_LOGIC; 
  signal data_enable_cwcount_out_1_Q : STD_LOGIC; 
  signal data_enable_G_6297_am : STD_LOGIC; 
  signal data_enable_G_6297_bm : STD_LOGIC; 
  signal data_enable_G_6296_am : STD_LOGIC; 
  signal data_enable_G_6296_bm : STD_LOGIC; 
  signal data_enable_G_6295_am : STD_LOGIC; 
  signal data_enable_G_6295_bm : STD_LOGIC; 
  signal data_enable_G_6294_am : STD_LOGIC; 
  signal data_enable_G_6294_bm : STD_LOGIC; 
  signal data_enable_G_6293_am : STD_LOGIC; 
  signal data_enable_G_6293_bm : STD_LOGIC; 
  signal data_enable_G_6292_am : STD_LOGIC; 
  signal data_enable_G_6292_bm : STD_LOGIC; 
  signal data_enable_G_6291_am : STD_LOGIC; 
  signal data_enable_G_6291_bm : STD_LOGIC; 
  signal data_enable_G_6290_am : STD_LOGIC; 
  signal data_enable_G_6290_bm : STD_LOGIC; 
  signal data_enable_G_6289_am : STD_LOGIC; 
  signal data_enable_G_6289_bm : STD_LOGIC; 
  signal data_enable_G_6288_am : STD_LOGIC; 
  signal data_enable_G_6288_bm : STD_LOGIC; 
  signal data_enable_G_6287_am : STD_LOGIC; 
  signal data_enable_G_6287_bm : STD_LOGIC; 
  signal data_enable_G_6286_am : STD_LOGIC; 
  signal data_enable_G_6286_bm : STD_LOGIC; 
  signal data_enable_G_6285_am : STD_LOGIC; 
  signal data_enable_G_6285_bm : STD_LOGIC; 
  signal data_enable_G_6284_am : STD_LOGIC; 
  signal data_enable_G_6284_bm : STD_LOGIC; 
  signal data_enable_G_6283_am : STD_LOGIC; 
  signal data_enable_G_6283_bm : STD_LOGIC; 
  signal data_enable_G_6282_am : STD_LOGIC; 
  signal data_enable_G_6282_bm : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_29 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_28 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_27 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_26 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_25 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_24 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_23 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_22 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_21 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_19 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_18 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_17 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_16 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_15 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_14 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_13 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_12 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_11 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_10 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_9 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_8 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_7 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_6 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_5 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_4 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_3 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_2 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_s_1 : STD_LOGIC; 
  signal data_enable_N_7316 : STD_LOGIC; 
  signal data_enable_un1_cwcount_out_16_c2 : STD_LOGIC; 
  signal data_enable_G_6_0_0_0_327 : STD_LOGIC; 
  signal data_enable_EOF_OUT_MOD_0_0_0_0_and2_588 : STD_LOGIC; 
  signal data_enable_N_7731 : STD_LOGIC; 
  signal data_enable_N_4685_i : STD_LOGIC; 
  signal data_enable_N_4676_i : STD_LOGIC; 
  signal data_enable_N_6792_i : STD_LOGIC; 
  signal data_enable_N_4709_i : STD_LOGIC; 
  signal data_enable_N_4678_i : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_14 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_13 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_12 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_11 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_10 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_9 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_8 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_7 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_6 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_5 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_4 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_3 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_2 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_1 : STD_LOGIC; 
  signal data_enable_un73_state_in_cry_0 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_28 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_27 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_26 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_25 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_24 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_23 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_22 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_21 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_20 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_19 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_18 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_17 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_16 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_15 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_14 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_13 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_12 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_11 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_10 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_9 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_8 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_7 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_6 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_5 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_4 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_3 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_2 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_1 : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_0 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_28 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_27 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_26 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_25 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_24 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_23 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_22 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_21 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_20 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_19 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_18 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_17 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_16 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_15 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_14 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_13 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_12 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_11 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_10 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_9 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_8 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_7 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_6 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_5 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_4 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_3 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_2 : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_1 : STD_LOGIC; 
  signal data_enable_fwcount_cry_12_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_11_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_10_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_9_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_8_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_7_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_6_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_5_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_4_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_3_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_2_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_1_O : STD_LOGIC; 
  signal data_enable_fwcount_cry_0_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_14_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_13_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_12_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_11_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_10_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_9_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_8_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_7_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_6_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_5_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_4_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_3_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_2_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_1_O : STD_LOGIC; 
  signal data_enable_output_proc_un73_state_in_cry_0_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_28_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_27_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_26_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_25_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_24_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_23_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_22_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_21_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_20_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_19_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_18_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_17_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_16_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_15_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_14_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_13_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_12_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_11_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_10_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_9_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_8_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_7_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_6_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_5_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_4_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_3_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_2_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_1_O : STD_LOGIC; 
  signal data_enable_un32_d_out_mod_cry_0_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_28_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_27_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_26_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_25_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_24_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_23_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_22_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_21_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_20_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_19_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_18_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_17_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_16_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_15_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_14_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_13_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_12_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_11_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_10_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_9_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_8_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_7_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_6_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_5_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_4_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_3_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_2_O : STD_LOGIC; 
  signal data_enable_un38_cell_buf_cry_1_O : STD_LOGIC; 
  signal data_enable_state_out_h_N_1155_i : STD_LOGIC; 
  signal data_enable_state_out_h_N_7751 : STD_LOGIC; 
  signal data_enable_state_out_h_N_7753 : STD_LOGIC; 
  signal data_enable_state_out_h_N_7740 : STD_LOGIC; 
  signal data_enable_state_out_h_N_7756 : STD_LOGIC; 
  signal data_enable_state_out_h_N_7752 : STD_LOGIC; 
  signal data_enable_state_out_h_state_out_ns_i_0_0_0_3_554 : STD_LOGIC; 
  signal data_enable_state_in_h_state_in_0_Q : STD_LOGIC; 
  signal data_enable_state_in_h_N_7738 : STD_LOGIC; 
  signal data_enable_state_in_h_N_7763 : STD_LOGIC; 
  signal data_enable_state_in_h_state_in_6_Q : STD_LOGIC; 
  signal data_enable_state_in_h_state_in_ns_i_0_0_0_and2_0_2_28 : STD_LOGIC; 
  signal data_enable_state_in_h_N_1121_i : STD_LOGIC; 
  signal segment_N_541_i : STD_LOGIC; 
  signal segment_N_542_i : STD_LOGIC; 
  signal segment_N_543_i : STD_LOGIC; 
  signal segment_N_544_i : STD_LOGIC; 
  signal segment_N_545_i : STD_LOGIC; 
  signal segment_N_546_i : STD_LOGIC; 
  signal segment_N_547_i : STD_LOGIC; 
  signal segment_N_548_i : STD_LOGIC; 
  signal segment_N_549_i : STD_LOGIC; 
  signal segment_N_550_i : STD_LOGIC; 
  signal segment_N_551_i : STD_LOGIC; 
  signal segment_N_552_i : STD_LOGIC; 
  signal segment_N_553_i : STD_LOGIC; 
  signal segment_out_state_4_Q : STD_LOGIC; 
  signal segment_un1_out_count_1_axb_0 : STD_LOGIC; 
  signal segment_un1_out_count_1_axb_1 : STD_LOGIC; 
  signal segment_un1_out_count_1_axb_2 : STD_LOGIC; 
  signal segment_total_len_lcry : STD_LOGIC; 
  signal segment_GND : STD_LOGIC; 
  signal segment_fifo_rst : STD_LOGIC; 
  signal segment_G_9_0_0 : STD_LOGIC; 
  signal segment_N_554_i : STD_LOGIC; 
  signal segment_out_state_2_Q : STD_LOGIC; 
  signal segment_N_1386 : STD_LOGIC; 
  signal segment_first_cell : STD_LOGIC; 
  signal segment_G_848_fast : STD_LOGIC; 
  signal segment_N_1666 : STD_LOGIC; 
  signal segment_G_846_fast : STD_LOGIC; 
  signal segment_N_8 : STD_LOGIC; 
  signal segment_eof_in : STD_LOGIC; 
  signal segment_un22_dataen_in : STD_LOGIC; 
  signal segment_un27_dataen_in : STD_LOGIC; 
  signal segment_un1_in_state : STD_LOGIC; 
  signal segment_dataen_in : STD_LOGIC; 
  signal segment_un8_lfifo_we_5 : STD_LOGIC; 
  signal segment_un17_lfifo_we : STD_LOGIC; 
  signal segment_un9_dataen_in : STD_LOGIC; 
  signal segment_N_264 : STD_LOGIC; 
  signal segment_un1_out_count_1_s_1 : STD_LOGIC; 
  signal segment_N_265 : STD_LOGIC; 
  signal segment_un1_out_count_1_axb_3 : STD_LOGIC; 
  signal segment_N_1381 : STD_LOGIC; 
  signal segment_out_state_0_Q : STD_LOGIC; 
  signal segment_N_1399 : STD_LOGIC; 
  signal segment_N_1752 : STD_LOGIC; 
  signal segment_N_1394 : STD_LOGIC; 
  signal segment_N_1446 : STD_LOGIC; 
  signal segment_header_3_Q : STD_LOGIC; 
  signal segment_N_1468 : STD_LOGIC; 
  signal segment_dfifo_out_16_Q : STD_LOGIC; 
  signal segment_N_1517 : STD_LOGIC; 
  signal segment_N_1667 : STD_LOGIC; 
  signal segment_header_16_Q : STD_LOGIC; 
  signal segment_N_1518 : STD_LOGIC; 
  signal segment_dfifo_out_31_Q : STD_LOGIC; 
  signal segment_N_1565 : STD_LOGIC; 
  signal segment_header_31_Q : STD_LOGIC; 
  signal segment_N_1566 : STD_LOGIC; 
  signal segment_N_1556 : STD_LOGIC; 
  signal segment_un1_out_count_1_s_3 : STD_LOGIC; 
  signal segment_N_267 : STD_LOGIC; 
  signal segment_un1_out_count_1_s_2 : STD_LOGIC; 
  signal segment_N_266 : STD_LOGIC; 
  signal segment_header_24_Q : STD_LOGIC; 
  signal segment_N_1564 : STD_LOGIC; 
  signal segment_dfifo_out_24_Q : STD_LOGIC; 
  signal segment_N_1563 : STD_LOGIC; 
  signal segment_header_30_Q : STD_LOGIC; 
  signal segment_N_1544 : STD_LOGIC; 
  signal segment_dfifo_out_30_Q : STD_LOGIC; 
  signal segment_N_1543 : STD_LOGIC; 
  signal segment_header_29_Q : STD_LOGIC; 
  signal segment_N_1542 : STD_LOGIC; 
  signal segment_dfifo_out_29_Q : STD_LOGIC; 
  signal segment_N_1541 : STD_LOGIC; 
  signal segment_header_28_Q : STD_LOGIC; 
  signal segment_N_1540 : STD_LOGIC; 
  signal segment_dfifo_out_28_Q : STD_LOGIC; 
  signal segment_N_1539 : STD_LOGIC; 
  signal segment_header_27_Q : STD_LOGIC; 
  signal segment_N_1538 : STD_LOGIC; 
  signal segment_dfifo_out_27_Q : STD_LOGIC; 
  signal segment_N_1537 : STD_LOGIC; 
  signal segment_header_26_Q : STD_LOGIC; 
  signal segment_N_1536 : STD_LOGIC; 
  signal segment_dfifo_out_26_Q : STD_LOGIC; 
  signal segment_N_1535 : STD_LOGIC; 
  signal segment_header_25_Q : STD_LOGIC; 
  signal segment_N_1534 : STD_LOGIC; 
  signal segment_dfifo_out_25_Q : STD_LOGIC; 
  signal segment_N_1533 : STD_LOGIC; 
  signal segment_header_23_Q : STD_LOGIC; 
  signal segment_N_1532 : STD_LOGIC; 
  signal segment_dfifo_out_23_Q : STD_LOGIC; 
  signal segment_N_1531 : STD_LOGIC; 
  signal segment_header_22_Q : STD_LOGIC; 
  signal segment_N_1530 : STD_LOGIC; 
  signal segment_dfifo_out_22_Q : STD_LOGIC; 
  signal segment_N_1529 : STD_LOGIC; 
  signal segment_header_21_Q : STD_LOGIC; 
  signal segment_N_1528 : STD_LOGIC; 
  signal segment_dfifo_out_21_Q : STD_LOGIC; 
  signal segment_N_1527 : STD_LOGIC; 
  signal segment_header_20_Q : STD_LOGIC; 
  signal segment_N_1526 : STD_LOGIC; 
  signal segment_dfifo_out_20_Q : STD_LOGIC; 
  signal segment_N_1525 : STD_LOGIC; 
  signal segment_header_19_Q : STD_LOGIC; 
  signal segment_N_1524 : STD_LOGIC; 
  signal segment_dfifo_out_19_Q : STD_LOGIC; 
  signal segment_N_1523 : STD_LOGIC; 
  signal segment_header_18_Q : STD_LOGIC; 
  signal segment_N_1522 : STD_LOGIC; 
  signal segment_dfifo_out_18_Q : STD_LOGIC; 
  signal segment_N_1521 : STD_LOGIC; 
  signal segment_header_17_Q : STD_LOGIC; 
  signal segment_N_1520 : STD_LOGIC; 
  signal segment_dfifo_out_17_Q : STD_LOGIC; 
  signal segment_N_1519 : STD_LOGIC; 
  signal segment_header_15_Q : STD_LOGIC; 
  signal segment_N_1516 : STD_LOGIC; 
  signal segment_header_14_Q : STD_LOGIC; 
  signal segment_N_1512 : STD_LOGIC; 
  signal segment_header_13_Q : STD_LOGIC; 
  signal segment_N_1508 : STD_LOGIC; 
  signal segment_header_12_Q : STD_LOGIC; 
  signal segment_N_1504 : STD_LOGIC; 
  signal segment_header_11_Q : STD_LOGIC; 
  signal segment_N_1500 : STD_LOGIC; 
  signal segment_header_10_Q : STD_LOGIC; 
  signal segment_N_1496 : STD_LOGIC; 
  signal segment_header_9_Q : STD_LOGIC; 
  signal segment_N_1492 : STD_LOGIC; 
  signal segment_header_8_Q : STD_LOGIC; 
  signal segment_N_1488 : STD_LOGIC; 
  signal segment_header_7_Q : STD_LOGIC; 
  signal segment_N_1484 : STD_LOGIC; 
  signal segment_header_6_Q : STD_LOGIC; 
  signal segment_N_1480 : STD_LOGIC; 
  signal segment_header_5_Q : STD_LOGIC; 
  signal segment_N_1476 : STD_LOGIC; 
  signal segment_header_4_Q : STD_LOGIC; 
  signal segment_N_1472 : STD_LOGIC; 
  signal segment_header_2_Q : STD_LOGIC; 
  signal segment_N_1464 : STD_LOGIC; 
  signal segment_N_1460 : STD_LOGIC; 
  signal segment_dfifo_out_1_Q : STD_LOGIC; 
  signal segment_N_1459 : STD_LOGIC; 
  signal segment_header_0_Q : STD_LOGIC; 
  signal segment_N_1458 : STD_LOGIC; 
  signal segment_un52_dfifo_re_0_0_547 : STD_LOGIC; 
  signal segment_un52_dfifo_re_0_0_and2_0_40 : STD_LOGIC; 
  signal segment_un52_dfifo_re_0_0 : STD_LOGIC; 
  signal segment_N_1447 : STD_LOGIC; 
  signal segment_N_1444 : STD_LOGIC; 
  signal segment_un5_lfifo_re_0_0 : STD_LOGIC; 
  signal segment_un5_lfifo_re_0_0_and2_60 : STD_LOGIC; 
  signal segment_N_1450 : STD_LOGIC; 
  signal segment_un52_dfifo_re_0_0_545 : STD_LOGIC; 
  signal segment_N_1381_i : STD_LOGIC; 
  signal segment_N_1281_i : STD_LOGIC; 
  signal segment_N_1407_i : STD_LOGIC; 
  signal segment_N_1557_i : STD_LOGIC; 
  signal segment_N_289 : STD_LOGIC; 
  signal segment_un1_un1_un9_dataen_in_i : STD_LOGIC; 
  signal segment_un1_out_count_1_cry_2 : STD_LOGIC; 
  signal segment_un1_out_count_1_cry_1 : STD_LOGIC; 
  signal segment_un1_out_count_1_cry_0 : STD_LOGIC; 
  signal segment_un27_data_out_cry_12 : STD_LOGIC; 
  signal segment_un27_data_out_cry_11 : STD_LOGIC; 
  signal segment_VCC : STD_LOGIC; 
  signal segment_un27_data_out_cry_10 : STD_LOGIC; 
  signal segment_un27_data_out_cry_9 : STD_LOGIC; 
  signal segment_un27_data_out_cry_8 : STD_LOGIC; 
  signal segment_un27_data_out_cry_7 : STD_LOGIC; 
  signal segment_un27_data_out_cry_6 : STD_LOGIC; 
  signal segment_un27_data_out_cry_5 : STD_LOGIC; 
  signal segment_un27_data_out_cry_4 : STD_LOGIC; 
  signal segment_un27_data_out_cry_3 : STD_LOGIC; 
  signal segment_un27_data_out_cry_2 : STD_LOGIC; 
  signal segment_un27_data_out_cry_1 : STD_LOGIC; 
  signal segment_un27_data_out_cry_0 : STD_LOGIC; 
  signal segment_total_len_cry_12_O : STD_LOGIC; 
  signal segment_total_len_cry_11_O : STD_LOGIC; 
  signal segment_total_len_cry_10_O : STD_LOGIC; 
  signal segment_total_len_cry_9_O : STD_LOGIC; 
  signal segment_total_len_cry_8_O : STD_LOGIC; 
  signal segment_total_len_cry_7_O : STD_LOGIC; 
  signal segment_total_len_cry_6_O : STD_LOGIC; 
  signal segment_total_len_cry_5_O : STD_LOGIC; 
  signal segment_total_len_cry_4_O : STD_LOGIC; 
  signal segment_total_len_cry_3_O : STD_LOGIC; 
  signal segment_total_len_cry_2_O : STD_LOGIC; 
  signal segment_total_len_cry_1_O : STD_LOGIC; 
  signal segment_total_len_cry_0_O : STD_LOGIC; 
  signal segment_un1_out_count_1_cry_2_O : STD_LOGIC; 
  signal segment_un1_out_count_1_cry_1_O : STD_LOGIC; 
  signal segment_un1_out_count_1_cry_0_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_12_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_11_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_10_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_9_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_8_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_7_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_6_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_5_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_4_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_3_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_2_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_1_O : STD_LOGIC; 
  signal segment_un27_data_out_cry_0_O : STD_LOGIC; 
  signal segment_dfifo_N2147483644 : STD_LOGIC; 
  signal segment_dfifo_N2147483641 : STD_LOGIC; 
  signal segment_dfifo_N212 : STD_LOGIC; 
  signal segment_dfifo_N211 : STD_LOGIC; 
  signal segment_dfifo_N214 : STD_LOGIC; 
  signal segment_dfifo_N210 : STD_LOGIC; 
  signal segment_dfifo_N209 : STD_LOGIC; 
  signal segment_dfifo_N208 : STD_LOGIC; 
  signal segment_dfifo_N207 : STD_LOGIC; 
  signal segment_dfifo_N206 : STD_LOGIC; 
  signal segment_dfifo_N204 : STD_LOGIC; 
  signal segment_dfifo_N203 : STD_LOGIC; 
  signal segment_dfifo_N202 : STD_LOGIC; 
  signal segment_dfifo_N216 : STD_LOGIC; 
  signal segment_dfifo_N201 : STD_LOGIC; 
  signal segment_dfifo_N200 : STD_LOGIC; 
  signal segment_dfifo_N199 : STD_LOGIC; 
  signal segment_dfifo_N198 : STD_LOGIC; 
  signal segment_dfifo_empty : STD_LOGIC; 
  signal segment_dfifo_N1710 : STD_LOGIC; 
  signal segment_dfifo_N2124 : STD_LOGIC; 
  signal segment_dfifo_N2138 : STD_LOGIC; 
  signal segment_dfifo_N2116 : STD_LOGIC; 
  signal segment_dfifo_N2154 : STD_LOGIC; 
  signal segment_dfifo_N2168 : STD_LOGIC; 
  signal segment_dfifo_N2117 : STD_LOGIC; 
  signal segment_dfifo_N2184 : STD_LOGIC; 
  signal segment_dfifo_N2198 : STD_LOGIC; 
  signal segment_dfifo_N2118 : STD_LOGIC; 
  signal segment_dfifo_N2214 : STD_LOGIC; 
  signal segment_dfifo_N2228 : STD_LOGIC; 
  signal segment_dfifo_N2119 : STD_LOGIC; 
  signal segment_dfifo_N2244 : STD_LOGIC; 
  signal segment_dfifo_N2258 : STD_LOGIC; 
  signal segment_dfifo_N2120 : STD_LOGIC; 
  signal segment_dfifo_N2274 : STD_LOGIC; 
  signal segment_dfifo_N2288 : STD_LOGIC; 
  signal segment_dfifo_N2121 : STD_LOGIC; 
  signal segment_dfifo_N2304 : STD_LOGIC; 
  signal segment_dfifo_N2122 : STD_LOGIC; 
  signal segment_dfifo_N2514 : STD_LOGIC; 
  signal segment_dfifo_N1764 : STD_LOGIC; 
  signal segment_dfifo_N2590 : STD_LOGIC; 
  signal segment_dfifo_N1763 : STD_LOGIC; 
  signal segment_dfifo_N2666 : STD_LOGIC; 
  signal segment_dfifo_N1762 : STD_LOGIC; 
  signal segment_dfifo_N2742 : STD_LOGIC; 
  signal segment_dfifo_N1761 : STD_LOGIC; 
  signal segment_dfifo_N2818 : STD_LOGIC; 
  signal segment_dfifo_N1760 : STD_LOGIC; 
  signal segment_dfifo_N2894 : STD_LOGIC; 
  signal segment_dfifo_N1759 : STD_LOGIC; 
  signal segment_dfifo_N2970 : STD_LOGIC; 
  signal segment_dfifo_N1758 : STD_LOGIC; 
  signal segment_dfifo_N3057 : STD_LOGIC; 
  signal segment_dfifo_N1714 : STD_LOGIC; 
  signal segment_dfifo_N1828 : STD_LOGIC; 
  signal segment_dfifo_N1844 : STD_LOGIC; 
  signal segment_dfifo_N3061 : STD_LOGIC; 
  signal segment_dfifo_N1827 : STD_LOGIC; 
  signal segment_dfifo_N1843 : STD_LOGIC; 
  signal segment_dfifo_N3046 : STD_LOGIC; 
  signal segment_dfifo_N3054 : STD_LOGIC; 
  signal segment_dfifo_N3045 : STD_LOGIC; 
  signal segment_dfifo_N3053 : STD_LOGIC; 
  signal segment_dfifo_N1826 : STD_LOGIC; 
  signal segment_dfifo_N1842 : STD_LOGIC; 
  signal segment_dfifo_N3044 : STD_LOGIC; 
  signal segment_dfifo_N3052 : STD_LOGIC; 
  signal segment_dfifo_N1825 : STD_LOGIC; 
  signal segment_dfifo_N1841 : STD_LOGIC; 
  signal segment_dfifo_N3043 : STD_LOGIC; 
  signal segment_dfifo_N3051 : STD_LOGIC; 
  signal segment_dfifo_N1824 : STD_LOGIC; 
  signal segment_dfifo_N1840 : STD_LOGIC; 
  signal segment_dfifo_N3042 : STD_LOGIC; 
  signal segment_dfifo_N3050 : STD_LOGIC; 
  signal segment_dfifo_N1823 : STD_LOGIC; 
  signal segment_dfifo_N1839 : STD_LOGIC; 
  signal segment_dfifo_N3041 : STD_LOGIC; 
  signal segment_dfifo_N3049 : STD_LOGIC; 
  signal segment_dfifo_N1822 : STD_LOGIC; 
  signal segment_dfifo_N1838 : STD_LOGIC; 
  signal segment_dfifo_N3040 : STD_LOGIC; 
  signal segment_dfifo_N3048 : STD_LOGIC; 
  signal segment_dfifo_N3059 : STD_LOGIC; 
  signal segment_dfifo_full : STD_LOGIC; 
  signal segment_dfifo_N3409 : STD_LOGIC; 
  signal segment_dfifo_N3423 : STD_LOGIC; 
  signal segment_dfifo_N3401 : STD_LOGIC; 
  signal segment_dfifo_N3439 : STD_LOGIC; 
  signal segment_dfifo_N3453 : STD_LOGIC; 
  signal segment_dfifo_N3402 : STD_LOGIC; 
  signal segment_dfifo_N3469 : STD_LOGIC; 
  signal segment_dfifo_N3483 : STD_LOGIC; 
  signal segment_dfifo_N3403 : STD_LOGIC; 
  signal segment_dfifo_N3499 : STD_LOGIC; 
  signal segment_dfifo_N3513 : STD_LOGIC; 
  signal segment_dfifo_N3404 : STD_LOGIC; 
  signal segment_dfifo_N3529 : STD_LOGIC; 
  signal segment_dfifo_N3543 : STD_LOGIC; 
  signal segment_dfifo_N3405 : STD_LOGIC; 
  signal segment_dfifo_N3559 : STD_LOGIC; 
  signal segment_dfifo_N3573 : STD_LOGIC; 
  signal segment_dfifo_N3406 : STD_LOGIC; 
  signal segment_dfifo_N3589 : STD_LOGIC; 
  signal segment_dfifo_N3407 : STD_LOGIC; 
  signal segment_dfifo_N3799 : STD_LOGIC; 
  signal segment_dfifo_N3875 : STD_LOGIC; 
  signal segment_dfifo_N3951 : STD_LOGIC; 
  signal segment_dfifo_N4027 : STD_LOGIC; 
  signal segment_dfifo_N4103 : STD_LOGIC; 
  signal segment_dfifo_N4179 : STD_LOGIC; 
  signal segment_dfifo_N4255 : STD_LOGIC; 
  signal segment_dfifo_N1780 : STD_LOGIC; 
  signal segment_dfifo_N1779 : STD_LOGIC; 
  signal segment_dfifo_N1778 : STD_LOGIC; 
  signal segment_dfifo_N1777 : STD_LOGIC; 
  signal segment_dfifo_N1776 : STD_LOGIC; 
  signal segment_dfifo_N1775 : STD_LOGIC; 
  signal segment_dfifo_N1774 : STD_LOGIC; 
  signal segment_dfifo_N4500 : STD_LOGIC; 
  signal segment_dfifo_N1788 : STD_LOGIC; 
  signal segment_dfifo_N4504 : STD_LOGIC; 
  signal segment_dfifo_N1787 : STD_LOGIC; 
  signal segment_dfifo_N4489 : STD_LOGIC; 
  signal segment_dfifo_N4497 : STD_LOGIC; 
  signal segment_dfifo_N4488 : STD_LOGIC; 
  signal segment_dfifo_N4496 : STD_LOGIC; 
  signal segment_dfifo_N1786 : STD_LOGIC; 
  signal segment_dfifo_N4487 : STD_LOGIC; 
  signal segment_dfifo_N4495 : STD_LOGIC; 
  signal segment_dfifo_N1785 : STD_LOGIC; 
  signal segment_dfifo_N4486 : STD_LOGIC; 
  signal segment_dfifo_N4494 : STD_LOGIC; 
  signal segment_dfifo_N1784 : STD_LOGIC; 
  signal segment_dfifo_N4485 : STD_LOGIC; 
  signal segment_dfifo_N4493 : STD_LOGIC; 
  signal segment_dfifo_N1783 : STD_LOGIC; 
  signal segment_dfifo_N4484 : STD_LOGIC; 
  signal segment_dfifo_N4492 : STD_LOGIC; 
  signal segment_dfifo_N1782 : STD_LOGIC; 
  signal segment_dfifo_N4483 : STD_LOGIC; 
  signal segment_dfifo_N4491 : STD_LOGIC; 
  signal segment_dfifo_N4502 : STD_LOGIC; 
  signal segment_dfifo_BU46_O : STD_LOGIC; 
  signal segment_dfifo_BU46_LO : STD_LOGIC; 
  signal segment_dfifo_BU49_O : STD_LOGIC; 
  signal segment_dfifo_BU49_LO : STD_LOGIC; 
  signal segment_dfifo_BU70_O : STD_LOGIC; 
  signal segment_dfifo_BU125_O : STD_LOGIC; 
  signal segment_dfifo_BU125_LO : STD_LOGIC; 
  signal segment_dfifo_BU128_O : STD_LOGIC; 
  signal segment_dfifo_BU128_LO : STD_LOGIC; 
  signal segment_dfifo_BU149_O : STD_LOGIC; 
  signal segment_lfifo_N1 : STD_LOGIC; 
  signal segment_lfifo_N0 : STD_LOGIC; 
  signal segment_lfifo_N9 : STD_LOGIC; 
  signal segment_lfifo_N8 : STD_LOGIC; 
  signal segment_lfifo_N10 : STD_LOGIC; 
  signal segment_lfifo_N7 : STD_LOGIC; 
  signal segment_lfifo_N6 : STD_LOGIC; 
  signal segment_lfifo_N5 : STD_LOGIC; 
  signal segment_lfifo_N4 : STD_LOGIC; 
  signal segment_lfifo_N3 : STD_LOGIC; 
  signal segment_lfifo_N11 : STD_LOGIC; 
  signal segment_lfifo_N2 : STD_LOGIC; 
  signal segment_lfifo_N837 : STD_LOGIC; 
  signal segment_lfifo_N1051 : STD_LOGIC; 
  signal segment_lfifo_N1053 : STD_LOGIC; 
  signal segment_lfifo_N1047 : STD_LOGIC; 
  signal segment_lfifo_N1056 : STD_LOGIC; 
  signal segment_lfifo_N1058 : STD_LOGIC; 
  signal segment_lfifo_N1048 : STD_LOGIC; 
  signal segment_lfifo_N1061 : STD_LOGIC; 
  signal segment_lfifo_N1063 : STD_LOGIC; 
  signal segment_lfifo_N1049 : STD_LOGIC; 
  signal segment_lfifo_N1066 : STD_LOGIC; 
  signal segment_lfifo_N1050 : STD_LOGIC; 
  signal segment_lfifo_N1234 : STD_LOGIC; 
  signal segment_lfifo_N863 : STD_LOGIC; 
  signal segment_lfifo_N1266 : STD_LOGIC; 
  signal segment_lfifo_N862 : STD_LOGIC; 
  signal segment_lfifo_N1298 : STD_LOGIC; 
  signal segment_lfifo_N861 : STD_LOGIC; 
  signal segment_lfifo_N1330 : STD_LOGIC; 
  signal segment_lfifo_N860 : STD_LOGIC; 
  signal segment_lfifo_N1358 : STD_LOGIC; 
  signal segment_lfifo_N839 : STD_LOGIC; 
  signal segment_lfifo_N895 : STD_LOGIC; 
  signal segment_lfifo_N903 : STD_LOGIC; 
  signal segment_lfifo_N1360 : STD_LOGIC; 
  signal segment_lfifo_N894 : STD_LOGIC; 
  signal segment_lfifo_N902 : STD_LOGIC; 
  signal segment_lfifo_N1352 : STD_LOGIC; 
  signal segment_lfifo_N1356 : STD_LOGIC; 
  signal segment_lfifo_N1351 : STD_LOGIC; 
  signal segment_lfifo_N1355 : STD_LOGIC; 
  signal segment_lfifo_N893 : STD_LOGIC; 
  signal segment_lfifo_N901 : STD_LOGIC; 
  signal segment_lfifo_N1350 : STD_LOGIC; 
  signal segment_lfifo_N1354 : STD_LOGIC; 
  signal segment_lfifo_N892 : STD_LOGIC; 
  signal segment_lfifo_N900 : STD_LOGIC; 
  signal segment_lfifo_N1349 : STD_LOGIC; 
  signal segment_lfifo_N1353 : STD_LOGIC; 
  signal segment_lfifo_N1359 : STD_LOGIC; 
  signal segment_lfifo_full : STD_LOGIC; 
  signal segment_lfifo_N1521 : STD_LOGIC; 
  signal segment_lfifo_N1523 : STD_LOGIC; 
  signal segment_lfifo_N1517 : STD_LOGIC; 
  signal segment_lfifo_N1526 : STD_LOGIC; 
  signal segment_lfifo_N1528 : STD_LOGIC; 
  signal segment_lfifo_N1518 : STD_LOGIC; 
  signal segment_lfifo_N1531 : STD_LOGIC; 
  signal segment_lfifo_N1533 : STD_LOGIC; 
  signal segment_lfifo_N1519 : STD_LOGIC; 
  signal segment_lfifo_N1536 : STD_LOGIC; 
  signal segment_lfifo_N1520 : STD_LOGIC; 
  signal segment_lfifo_N1704 : STD_LOGIC; 
  signal segment_lfifo_N1736 : STD_LOGIC; 
  signal segment_lfifo_N1768 : STD_LOGIC; 
  signal segment_lfifo_N1800 : STD_LOGIC; 
  signal segment_lfifo_N871 : STD_LOGIC; 
  signal segment_lfifo_N870 : STD_LOGIC; 
  signal segment_lfifo_N869 : STD_LOGIC; 
  signal segment_lfifo_N868 : STD_LOGIC; 
  signal segment_lfifo_N1886 : STD_LOGIC; 
  signal segment_lfifo_N875 : STD_LOGIC; 
  signal segment_lfifo_N1888 : STD_LOGIC; 
  signal segment_lfifo_N874 : STD_LOGIC; 
  signal segment_lfifo_N1880 : STD_LOGIC; 
  signal segment_lfifo_N1884 : STD_LOGIC; 
  signal segment_lfifo_N1879 : STD_LOGIC; 
  signal segment_lfifo_N1883 : STD_LOGIC; 
  signal segment_lfifo_N873 : STD_LOGIC; 
  signal segment_lfifo_N1878 : STD_LOGIC; 
  signal segment_lfifo_N1882 : STD_LOGIC; 
  signal segment_lfifo_N872 : STD_LOGIC; 
  signal segment_lfifo_N1877 : STD_LOGIC; 
  signal segment_lfifo_N1881 : STD_LOGIC; 
  signal segment_lfifo_N1887 : STD_LOGIC; 
  signal segment_lfifo_BU26_O : STD_LOGIC; 
  signal segment_lfifo_BU26_LO : STD_LOGIC; 
  signal segment_lfifo_BU29_O : STD_LOGIC; 
  signal segment_lfifo_BU29_LO : STD_LOGIC; 
  signal segment_lfifo_BU41_O : STD_LOGIC; 
  signal segment_lfifo_BU75_O : STD_LOGIC; 
  signal segment_lfifo_BU75_LO : STD_LOGIC; 
  signal segment_lfifo_BU78_O : STD_LOGIC; 
  signal segment_lfifo_BU78_LO : STD_LOGIC; 
  signal segment_lfifo_BU90_O : STD_LOGIC; 
  signal segment_out_state_h_N_1554 : STD_LOGIC; 
  signal segment_out_state_h_out_state_ns_0_0_and2_1_4_332 : STD_LOGIC; 
  signal segment_out_state_h_N_1552 : STD_LOGIC; 
  signal segment_out_state_h_N_304_i : STD_LOGIC; 
  signal segment_in_state_h_N_286 : STD_LOGIC; 
  signal segment_in_state_h_N_281_i : STD_LOGIC; 
  signal crc_out_crc_pos_wire : STD_LOGIC; 
  signal crc_out_soc_wire : STD_LOGIC; 
  signal crc_out_crc_gen_is_lastcell : STD_LOGIC; 
  signal crc_out_crc_gen_sof_buf : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q111 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q11 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q000 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q100 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q100_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q101 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q000_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q100_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q100_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q000_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q011_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q011 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q011_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q101_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q111_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q00 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_3 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q101_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_4 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q101_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q00_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110_3 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_3 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q_531 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q11_0 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_4 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q100_3 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_5 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_5 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_6 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q001_6 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q000_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q100_4 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q010_7 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q11_1 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110_4 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q110_5 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q11_2 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_q11_3 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row0_xorq_q_350 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row0_xorq_q_351 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row1_xorq_q_188 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row1_xorq_q_186 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row2_xorq_q_324 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row2_xorq_q_319 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row3_xorq_q_89 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row3_xorq_q_88 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row3_xorq_q_83 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row4_xorq_q_237 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row4_xorq_q_236 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row4_xorq_q_231 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row5_xorq_q_517 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row5_xorq_q_514 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row6_xorq_q_183 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row6_xorq_q_178 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row7_xorq_q_423 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row7_xorq_q_419 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row8_xorq_q_523 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row8_xorq_q_522 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row9_xorq_q_58 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row9_xorq_q_56 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row10_xorq_q_532 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row11_xorq_q_298 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row11_xorq_q_296 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row11_xorq_q_294 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row12_xorq_q_71 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row12_xorq_q_70 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row12_xorq_q_67 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row13_xorq_q_269 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row13_xorq_q_267 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row13_xorq_q_265 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row14_xorq_q_175 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row14_xorq_q_173 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row14_xorq_q_171 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row15_xorq_q_245 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row15_xorq_q_240 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row16_xorq_q_154 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row16_xorq_q_150 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row16_xorq_q_151 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row17_xorq_q_98 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row17_xorq_q_96 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row17_xorq_q_91 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row18_xorq_q_402 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row18_xorq_q_398 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row19_xorq_q_159 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row19_xorq_q_157 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row20_xorq_q_120 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row20_xorq_q_118 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row21_xorq_q_454 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row22_xorq_q_476 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row22_xorq_q_477 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row23_xorq_q_437 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row23_xorq_q_435 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row24_xorq_q_339 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row25_xorq_q_449 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row26_xorq_q_397 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row26_xorq_q_393 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row27_xorq_q_277 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row27_xorq_q_275 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row27_xorq_q_271 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row28_xorq_q_387 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row28_xorq_q_384 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row28_xorq_q_383 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row29_xorq_q_483 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row29_xorq_q_484 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row30_xorq_q_167 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row30_xorq_q_165 : STD_LOGIC; 
  signal crc_out_crc_gen_crccalc_matrix_row31_xorq_q_365 : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal segment_dfifo_BU7_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU11_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU15_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU19_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU23_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU27_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU30_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU32_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU34_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU36_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU38_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU40_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU42_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU44_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU47_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU50_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU56_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU59_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU62_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU65_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU68_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU73_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU79_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU83_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU87_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU91_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU95_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU99_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU102_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU104_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU106_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU108_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU110_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU112_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU114_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU116_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU117_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU118_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU119_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU120_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU121_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU122_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU123_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU126_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU129_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU135_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU138_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU141_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU144_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU147_GSR_OR : STD_LOGIC; 
  signal segment_dfifo_BU152_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU5_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU9_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU13_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU16_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU18_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU20_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU22_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU24_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU27_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU30_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU36_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU39_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU44_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU50_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU54_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU58_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU61_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU63_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU65_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU67_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU69_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU70_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU71_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU72_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU73_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU76_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU79_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU85_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU88_GSR_OR : STD_LOGIC; 
  signal segment_lfifo_BU93_GSR_OR : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_8_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_9_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_10_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_11_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_12_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_13_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_14_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_15_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU0_DOA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_8_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_9_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_10_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_11_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_12_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_13_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_14_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_15_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU1_DOA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU53_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU71_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU132_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU150_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU46_SEL_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_dfifo_BU125_SEL_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOB_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_B7_DOA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_BU33_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_BU42_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_BU82_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_BU91_O_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_BU26_SEL_UNCONNECTED : STD_LOGIC; 
  signal NLW_segment_lfifo_BU75_SEL_UNCONNECTED : STD_LOGIC; 
  signal crc_out_crc_gen_count : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal segment_cur_len : STD_LOGIC_VECTOR ( 3 downto 1 ); 
  signal segment_in_state_h_in_state : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal data_enable_cwcount_in : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal data_enable_data_in : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_state_out_h_state_out : STD_LOGIC_VECTOR ( 7 downto 7 ); 
  signal crc_in_crc_gen_count : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal data_enable_delay_word0 : STD_LOGIC_VECTOR ( 31 downto 2 ); 
  signal data_enable_delay_word1 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_byte_count : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal data_enable_cwcount_out : STD_LOGIC_VECTOR ( 2 downto 2 ); 
  signal D_OUT_MOD_0_i_i_0_and2_5_s : STD_LOGIC_VECTOR ( 19 downto 17 ); 
  signal segment_out_count : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal segment_total_len : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal data2 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data8 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_in_data_wire : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_in_crc_out : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_in_crc_gen_crc_calc : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_in_crc_gen_d_data_in : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_in_crc_gen_crccalc_prexored : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_in_crc_set_data_buf_3 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_data_in_i : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal data_enable_fwcount : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal data_enable_fwcount_qxu : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal data_enable_cell_buf_10_4 : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal data_enable_state_in : STD_LOGIC_VECTOR ( 2 downto 1 ); 
  signal data_enable_byte_count_0 : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal data_enable_cell_buf_0 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_1 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_2 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_3 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_4 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_5 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_6 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_7 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_8 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_cell_buf_9 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal data_enable_delay_word0_1 : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal data_enable_fwcount_s : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal data_enable_cwcount_out_1 : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal data_enable_state_out_fast : STD_LOGIC_VECTOR ( 5 downto 5 ); 
  signal data_enable_cwcount_out_4 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal data_enable_cwcount_out_3 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal data_enable_cwcount_out_2 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal data_enable_fwcount_cry : STD_LOGIC_VECTOR ( 12 downto 0 ); 
  signal data_enable_state_out_h_state_out_ns : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal segment_out_count_2 : STD_LOGIC_VECTOR ( 3 downto 1 ); 
  signal segment_total_len_qxu : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal segment_total_len_s : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal segment_in_count : STD_LOGIC_VECTOR ( 6 downto 0 ); 
  signal segment_in_count_6 : STD_LOGIC_VECTOR ( 5 downto 4 ); 
  signal segment_in_count_13 : STD_LOGIC_VECTOR ( 6 downto 0 ); 
  signal segment_data_in : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal segment_lfifo_out : STD_LOGIC_VECTOR ( 5 downto 1 ); 
  signal segment_cur_len_3 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal segment_data_out : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal segment_total_len_cry : STD_LOGIC_VECTOR ( 12 downto 0 ); 
  signal crc_out_data_wire : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_out_crc_out : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_out_crc_gen_crc_calc : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_out_crc_gen_d_data_in : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_out_crc_gen_crccalc_prexored : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal crc_out_crc_set_data_buf_3 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
begin
  TCA_MOD_IN <= NlwRenamedSignal_TCA_OUT_APPL;
  NlwRenamedSignal_TCA_OUT_APPL <= TCA_OUT_APPL;
  NlwRenamedSignal_TCA_OUT_MOD <= TCA_OUT_MOD;
  TCA_APPL_IN <= NlwRenamedSignal_TCA_OUT_MOD;
  Reset_l_1_4 : X_BUF
    port map (
      I => Reset_l,
      O => Reset_l_1
    );
  Reset_l_0_5 : X_BUF
    port map (
      I => Reset_l,
      O => Reset_l_0
    );
  enable_in_6 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => Enable_l,
      O => enable_in,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  Reset_l_i_6_fast_7 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_6_fast
    );
  I_928 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_5
    );
  Reset_l_1_i : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_30
    );
  Reset_l_i_31_8 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_31
    );
  Reset_l_i_29_9 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_29
    );
  Reset_l_i_28_10 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_28
    );
  Reset_l_i_27_11 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_27
    );
  Reset_l_i_26_12 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_26
    );
  Reset_l_i_25_13 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_25
    );
  Reset_l_i_24_14 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_24
    );
  Reset_l_i_23_15 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_23
    );
  Reset_l_i_22_16 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_22
    );
  Reset_l_i_21_17 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_21
    );
  Reset_l_i_20_18 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_20
    );
  Reset_l_i_19_19 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_19
    );
  Reset_l_i_18_20 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_18
    );
  Reset_l_i_17_21 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_17
    );
  Reset_l_i_16_22 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_16
    );
  Reset_l_i_15_23 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_15
    );
  Reset_l_i_14_24 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_14
    );
  Reset_l_i_13_25 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_13
    );
  Reset_l_i_12_26 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_12
    );
  Reset_l_i_11_27 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_11
    );
  Reset_l_i_10_28 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_10
    );
  Reset_l_i_9_29 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_9
    );
  Reset_l_i_8_30 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_8
    );
  Reset_l_i_7_31 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_7
    );
  Reset_l_i_6_32 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_6
    );
  Reset_l_i_4_33 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_4
    );
  Reset_l_i_3_34 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_3
    );
  Reset_l_i_2_35 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_2
    );
  Reset_l_i_1_36 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i_1
    );
  enable_in_i : X_INV
    port map (
      I => enable_in,
      O => Ready_l
    );
  Reset_l_i_37 : X_INV
    port map (
      I => Reset_l_1,
      O => Reset_l_i
    );
  G_842_38 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => crc_out_crc_gen_d_soc_in,
      ADR1 => crc_out_crc_gen_count(0),
      O => G_842
    );
  G_843_39 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => crc_out_crc_gen_d_soc_in,
      ADR1 => crc_out_crc_gen_count(1),
      ADR2 => crc_out_crc_gen_count(0),
      O => G_843
    );
  G_844_40 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => crc_out_crc_gen_d_soc_in,
      ADR1 => crc_out_crc_gen_count(2),
      ADR2 => crc_out_crc_gen_count(1),
      ADR3 => crc_out_crc_gen_count(0),
      O => G_844
    );
  G_845_41 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => crc_out_crc_gen_d_soc_in,
      ADR1 => crc_out_crc_gen_count(3),
      ADR2 => crc_out_crc_gen_un5_count_c2,
      ADR3 => crc_out_crc_gen_count(2),
      O => G_845
    );
  G_847_42 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => segment_out_state_6_Q,
      ADR1 => segment_un1_cur_len_1_c2,
      ADR2 => segment_cur_len(2),
      O => G_847
    );
  G_848_43 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => segment_out_state_6_Q,
      ADR1 => segment_cur_len(3),
      ADR2 => segment_un1_cur_len_1_c2,
      ADR3 => segment_cur_len(2),
      O => G_848
    );
  G_849_44 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => segment_out_state_6_Q,
      ADR1 => segment_un1_cur_len_1_c1,
      ADR2 => segment_cur_len(1),
      O => G_849
    );
  G_858_45 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_lfifo_out_0_Q,
      ADR1 => segment_N_1668,
      ADR2 => segment_dfifo_out_0_Q,
      ADR3 => segment_N_1673,
      O => G_858
    );
  G_865_46 : X_LUT4
    generic map(
      INIT => X"88A8"
    )
    port map (
      ADR0 => segment_lfifo_mt,
      ADR1 => segment_N_1391,
      ADR2 => segment_N_1556_1,
      ADR3 => segment_lfifo_out_6_Q,
      O => G_865
    );
  G_866_47 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => segment_sof_in,
      ADR1 => segment_in_state_h_in_state(0),
      ADR2 => segment_N_283,
      ADR3 => segment_in_state_h_in_state(1),
      O => G_866
    );
  G_867_48 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => segment_out_state_1_Q,
      ADR1 => segment_out_state_7_Q,
      ADR2 => segment_lfifo_mt,
      O => G_867
    );
  G_869_49 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_cwcount_in(3),
      ADR2 => data_enable_un2_cwcount_in_3_c2,
      ADR3 => data_enable_cwcount_in(2),
      O => G_869
    );
  G_870_50 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_state_in_5_Q,
      ADR2 => data_enable_cwcount_in(0),
      O => G_870
    );
  G_871_51 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_cwcount_in(1),
      ADR2 => data_enable_cwcount_in(0),
      ADR3 => data_enable_state_in_5_Q,
      O => G_871
    );
  G_872_52 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_un2_cwcount_in_3_c2,
      ADR2 => data_enable_cwcount_in(2),
      O => G_872
    );
  G_907_53 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => data_enable_N_7750,
      ADR1 => data_enable_lc_flag,
      ADR2 => data_enable_state_out_4_Q,
      ADR3 => data_enable_buf_flag,
      O => G_907
    );
  G_908_54 : X_LUT4
    generic map(
      INIT => X"F222"
    )
    port map (
      ADR0 => data_enable_N_8502,
      ADR1 => data_enable_N_7315,
      ADR2 => data_enable_out_sm_proc_un57_state_in,
      ADR3 => data_enable_N_7997,
      O => G_908
    );
  G_909_55 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => data_enable_N_7744,
      ADR1 => data_enable_N_7745,
      O => G_909
    );
  G_910_56 : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => data_enable_state_in_3_Q,
      ADR1 => data_enable_state_in_7_Q,
      ADR2 => data_enable_soc_in,
      O => G_910
    );
  G_911_57 : X_LUT4
    generic map(
      INIT => X"22F2"
    )
    port map (
      ADR0 => EOF_OUT_MOD_0_0_0_0_and2_0_287,
      ADR1 => data_enable_out_sm_proc_un6_lc_copy_NE,
      ADR2 => EOF_OUT_MOD_0_0_0_0_and2_1_551,
      ADR3 => data_enable_out_sm_proc_un57_state_in,
      O => G_911
    );
  G_913_58 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => data_enable_N_7757,
      ADR1 => data_enable_data_in(1),
      ADR2 => data_enable_soc_in,
      ADR3 => data_enable_state_out_8_Q,
      O => G_913
    );
  G_914_59 : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => data_enable_state_out_h_state_out(7),
      ADR1 => data_enable_state_in_4_Q,
      ADR2 => data_enable_state_out_8_Q,
      ADR3 => data_enable_N_7315,
      O => G_914
    );
  G_916_60 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => crc_in_crc_gen_d_soc_in,
      ADR1 => crc_in_crc_gen_count(0),
      O => G_916
    );
  G_917_61 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => crc_in_crc_gen_d_soc_in,
      ADR1 => crc_in_crc_gen_count(1),
      ADR2 => crc_in_crc_gen_count(0),
      O => G_917
    );
  G_918_62 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => crc_in_crc_gen_d_soc_in,
      ADR1 => crc_in_crc_gen_count(2),
      ADR2 => crc_in_crc_gen_count(1),
      ADR3 => crc_in_crc_gen_count(0),
      O => G_918
    );
  G_919_63 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => crc_in_crc_gen_d_soc_in,
      ADR1 => crc_in_crc_gen_count(3),
      ADR2 => crc_in_crc_gen_un5_count_c2,
      ADR3 => crc_in_crc_gen_count(2),
      O => G_919
    );
  N_955_i_64 : X_LUT4
    generic map(
      INIT => X"DCFC"
    )
    port map (
      ADR0 => G_62_0,
      ADR1 => crc_out_crc_gen_soc_delay,
      ADR2 => crc_out_crc_gen_dataen_buf,
      ADR3 => G_63_0,
      O => N_955_i
    );
  N_1021_i_65 : X_LUT4
    generic map(
      INIT => X"1011"
    )
    port map (
      ADR0 => data_enable_N_7764,
      ADR1 => data_enable_N_7748,
      ADR2 => data_enable_N_7353,
      ADR3 => data_enable_N_7976,
      O => N_1021_i
    );
  N_1024_i_66 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => G_6_0_0_0_or2,
      ADR2 => data_enable_buf_flag,
      ADR3 => data_enable_buf_copy,
      O => N_1024_i
    );
  N_1029_i_67 : X_LUT4
    generic map(
      INIT => X"DCFC"
    )
    port map (
      ADR0 => G_62,
      ADR1 => crc_in_crc_gen_soc_delay,
      ADR2 => crc_in_crc_gen_dataen_buf,
      ADR3 => G_63,
      O => N_1029_i
    );
  G_897_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_21_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_delay_word0(21),
      ADR3 => data_enable_N_7978,
      O => N_1006_1
    );
  G_897_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7555,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7572,
      ADR3 => data_enable_N_7972_1,
      O => N_1006_2
    );
  G_897_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(21),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(21),
      ADR3 => data_enable_N_7980,
      O => N_1006_3
    );
  G_897_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_19,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7439,
      ADR3 => data_enable_N_7981,
      O => N_1006_4
    );
  G_897_68 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1006_2,
      ADR1 => N_1006_1,
      ADR2 => N_1006_4,
      ADR3 => N_1006_3,
      O => G_897
    );
  G_898_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7562,
      ADR1 => data_enable_N_7971_fast,
      ADR2 => data_enable_delay_word1(0),
      ADR3 => data_enable_N_7979_rep1,
      O => N_1007_2
    );
  G_898_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(0),
      ADR1 => data_enable_N_7980,
      ADR2 => data_enable_N_7579,
      ADR3 => data_enable_N_7972_1,
      O => N_1007_3
    );
  G_898_5 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1007_2,
      ADR1 => data_enable_N_7773,
      ADR2 => data_enable_byte_count(0),
      ADR3 => data_enable_N_7982,
      O => N_1007_5
    );
  G_898_69 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1007_5,
      ADR1 => N_1007_3,
      ADR2 => data_enable_N_7771,
      ADR3 => data_enable_N_7774,
      O => G_898
    );
  G_899_1 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => data_enable_N_7793,
      ADR1 => data_enable_N_7324,
      ADR2 => data_enable_N_8496,
      ADR3 => data_enable_cwcount_out(2),
      O => N_1008_1
    );
  G_899_3 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => data_enable_N_7792,
      ADR1 => D_OUT_MOD_0_i_i_0_and2_2_1_541,
      ADR2 => data_enable_N_7974,
      ADR3 => data_enable_cwcount_out(2),
      O => N_1008_3
    );
  G_899_6 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1008_3,
      ADR1 => data_enable_N_7795,
      ADR2 => data_enable_delay_word1(1),
      ADR3 => data_enable_N_7979,
      O => N_1008_6
    );
  G_899_70 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1008_6,
      ADR1 => N_1008_1,
      ADR2 => data_enable_N_7790,
      ADR3 => data_enable_N_7789,
      O => G_899
    );
  G_900_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_2_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_delay_word0(2),
      ADR3 => data_enable_N_7978,
      O => N_1009_1
    );
  G_900_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7561,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7578,
      ADR3 => data_enable_N_7972_1,
      O => N_1009_2
    );
  G_900_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(2),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(2),
      ADR3 => data_enable_N_7980,
      O => N_1009_3
    );
  G_900_4 : X_LUT4
    generic map(
      INIT => X"F444"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_2_Q,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7420,
      ADR3 => data_enable_N_7981,
      O => N_1009_4
    );
  G_900_71 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1009_2,
      ADR1 => N_1009_1,
      ADR2 => N_1009_4,
      ADR3 => N_1009_3,
      O => G_900
    );
  G_901_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_3_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_delay_word0(3),
      ADR3 => data_enable_N_7978,
      O => N_1010_1
    );
  G_901_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7560,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7577,
      ADR3 => data_enable_N_7972_1,
      O => N_1010_2
    );
  G_901_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(3),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(3),
      ADR3 => data_enable_N_7980,
      O => N_1010_3
    );
  G_901_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_1,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7421,
      ADR3 => data_enable_N_7981,
      O => N_1010_4
    );
  G_901_72 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1010_2,
      ADR1 => N_1010_1,
      ADR2 => N_1010_4,
      ADR3 => N_1010_3,
      O => G_901
    );
  G_902_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_4_Q,
      ADR1 => data_enable_N_7296,
      ADR2 => data_enable_delay_word0(4),
      ADR3 => data_enable_N_7978,
      O => N_1011_1
    );
  G_902_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7559,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7576,
      ADR3 => data_enable_N_7972_1,
      O => N_1011_2
    );
  G_902_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(4),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(4),
      ADR3 => data_enable_N_7980,
      O => N_1011_3
    );
  G_902_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_2,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7422,
      ADR3 => data_enable_N_7981,
      O => N_1011_4
    );
  G_902_73 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1011_2,
      ADR1 => N_1011_1,
      ADR2 => N_1011_4,
      ADR3 => N_1011_3,
      O => G_902
    );
  G_903_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_5_Q,
      ADR1 => data_enable_N_7296,
      ADR2 => data_enable_delay_word0(5),
      ADR3 => data_enable_N_7978,
      O => N_1012_1
    );
  G_903_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7558,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7575,
      ADR3 => data_enable_N_7972_1,
      O => N_1012_2
    );
  G_903_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(5),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(5),
      ADR3 => data_enable_N_7980,
      O => N_1012_3
    );
  G_903_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_3,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7423,
      ADR3 => data_enable_N_7981,
      O => N_1012_4
    );
  G_903_74 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1012_2,
      ADR1 => N_1012_1,
      ADR2 => N_1012_4,
      ADR3 => N_1012_3,
      O => G_903
    );
  G_904_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_6_Q,
      ADR1 => data_enable_N_7296,
      ADR2 => data_enable_delay_word0(6),
      ADR3 => data_enable_N_7978,
      O => N_1013_1
    );
  G_904_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7557,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7574,
      ADR3 => data_enable_N_7972_1,
      O => N_1013_2
    );
  G_904_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(6),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(6),
      ADR3 => data_enable_N_7980,
      O => N_1013_3
    );
  G_904_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_4,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7424,
      ADR3 => data_enable_N_7981,
      O => N_1013_4
    );
  G_904_75 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1013_2,
      ADR1 => N_1013_1,
      ADR2 => N_1013_4,
      ADR3 => N_1013_3,
      O => G_904
    );
  G_905_76 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => N_1014_3,
      ADR1 => N_1014_2,
      ADR2 => data_enable_cwcount_in(3),
      ADR3 => data_enable_lc_flag,
      O => G_905
    );
  G_906_2 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => data_enable_state_in_5_Q,
      ADR1 => data_enable_cwcount_in(2),
      O => N_1014_2
    );
  G_906_3 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => data_enable_cwcount_in(0),
      ADR1 => data_enable_cwcount_in(1),
      O => N_1014_3
    );
  G_906_77 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => N_1014_3,
      ADR1 => N_1014_2,
      ADR2 => data_enable_cwcount_in(3),
      ADR3 => data_enable_lc_flag,
      O => G_906
    );
  G_882_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_31_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(31),
      ADR3 => data_enable_N_7978,
      O => N_991_1
    );
  G_882_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7546,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7563,
      ADR3 => data_enable_N_7972,
      O => N_991_2
    );
  G_882_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(31),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(31),
      ADR3 => data_enable_N_7980,
      O => N_991_3
    );
  G_882_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_29,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7449,
      ADR3 => data_enable_N_7981,
      O => N_991_4
    );
  G_882_78 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_991_2,
      ADR1 => N_991_1,
      ADR2 => N_991_4,
      ADR3 => N_991_3,
      O => G_882
    );
  G_883_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7534,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(7),
      ADR3 => data_enable_N_7979_fast,
      O => N_992_2
    );
  G_883_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(7),
      ADR1 => data_enable_N_7980_fast,
      ADR2 => data_enable_delay_word0(7),
      ADR3 => data_enable_N_7978_fast,
      O => N_992_3
    );
  G_883_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_992_3,
      ADR1 => data_enable_N_7800,
      ADR2 => un32_d_out_mod_s_5,
      ADR3 => data_enable_N_7982_fast,
      O => N_992_7
    );
  G_883_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_992_7,
      ADR1 => N_992_2,
      ADR2 => data_enable_N_7805,
      ADR3 => data_enable_N_7803,
      O => N_992_8
    );
  G_883_79 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_992_8,
      ADR1 => data_enable_N_7797,
      ADR2 => data_enable_cell_buf_11_7_Q,
      ADR3 => data_enable_N_7291,
      O => G_883
    );
  G_884_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7426,
      ADR1 => data_enable_N_7981_fast,
      ADR2 => data_enable_N_7488,
      ADR3 => data_enable_N_7986,
      O => N_993_1
    );
  G_884_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(8),
      ADR1 => data_enable_N_7980,
      ADR2 => data_enable_delay_word0(8),
      ADR3 => data_enable_N_7978,
      O => N_993_3
    );
  G_884_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_6,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7394,
      ADR3 => data_enable_N_7984,
      O => N_993_4
    );
  G_884_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_8_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_cell_buf_11_8_Q,
      ADR3 => G_6027_1_fast,
      O => N_993_5
    );
  G_884_6 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_993_1,
      ADR1 => data_enable_N_7815,
      ADR2 => data_enable_delay_word1(8),
      ADR3 => data_enable_N_7979_rep2,
      O => N_993_6
    );
  G_884_80 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_993_5,
      ADR1 => N_993_6,
      ADR2 => N_993_4,
      ADR3 => N_993_3,
      O => G_884
    );
  G_885_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7427,
      ADR1 => data_enable_N_7981_fast,
      ADR2 => data_enable_N_7489,
      ADR3 => data_enable_N_7986,
      O => N_994_1
    );
  G_885_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(9),
      ADR1 => data_enable_N_7980,
      ADR2 => data_enable_delay_word0(9),
      ADR3 => data_enable_N_7978,
      O => N_994_3
    );
  G_885_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_7,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7395,
      ADR3 => data_enable_N_7984,
      O => N_994_4
    );
  G_885_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_9_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_cell_buf_11_9_Q,
      ADR3 => G_6027_1_fast,
      O => N_994_5
    );
  G_885_6 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_994_1,
      ADR1 => data_enable_N_7826,
      ADR2 => data_enable_delay_word1(9),
      ADR3 => data_enable_N_7979_rep2,
      O => N_994_6
    );
  G_885_81 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_994_5,
      ADR1 => N_994_6,
      ADR2 => N_994_4,
      ADR3 => N_994_3,
      O => G_885
    );
  G_886_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7531,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(10),
      ADR3 => data_enable_N_7979_fast,
      O => N_995_2
    );
  G_886_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(10),
      ADR1 => data_enable_N_7980_fast,
      ADR2 => data_enable_delay_word0(10),
      ADR3 => data_enable_N_7978_fast,
      O => N_995_3
    );
  G_886_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_995_3,
      ADR1 => data_enable_N_7833,
      ADR2 => un32_d_out_mod_s_8,
      ADR3 => data_enable_N_7982_fast,
      O => N_995_7
    );
  G_886_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_995_7,
      ADR1 => N_995_2,
      ADR2 => data_enable_N_7838,
      ADR3 => data_enable_N_7836,
      O => N_995_8
    );
  G_886_82 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_995_8,
      ADR1 => data_enable_N_7830,
      ADR2 => data_enable_cell_buf_11_10_Q,
      ADR3 => data_enable_N_7291,
      O => G_886
    );
  G_887_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7429,
      ADR1 => data_enable_N_7981_fast,
      ADR2 => data_enable_N_7491,
      ADR3 => data_enable_N_7986,
      O => N_996_1
    );
  G_887_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(11),
      ADR1 => data_enable_N_7980,
      ADR2 => data_enable_delay_word0(11),
      ADR3 => data_enable_N_7978,
      O => N_996_3
    );
  G_887_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_9,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7397,
      ADR3 => data_enable_N_7984,
      O => N_996_4
    );
  G_887_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_11_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_cell_buf_11_11_Q,
      ADR3 => G_6027_1_fast,
      O => N_996_5
    );
  G_887_6 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_996_1,
      ADR1 => data_enable_N_7848,
      ADR2 => data_enable_delay_word1(11),
      ADR3 => data_enable_N_7979_rep2,
      O => N_996_6
    );
  G_887_83 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_996_5,
      ADR1 => N_996_6,
      ADR2 => N_996_4,
      ADR3 => N_996_3,
      O => G_887
    );
  G_888_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7430,
      ADR1 => data_enable_N_7981_fast,
      ADR2 => data_enable_N_7492,
      ADR3 => data_enable_N_7986,
      O => N_997_1
    );
  G_888_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(12),
      ADR1 => data_enable_N_7980,
      ADR2 => data_enable_delay_word0(12),
      ADR3 => data_enable_N_7978,
      O => N_997_3
    );
  G_888_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_10,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7398,
      ADR3 => data_enable_N_7984,
      O => N_997_4
    );
  G_888_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_12_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_cell_buf_11_12_Q,
      ADR3 => G_6027_1_fast,
      O => N_997_5
    );
  G_888_6 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_997_1,
      ADR1 => data_enable_N_7859,
      ADR2 => data_enable_delay_word1(12),
      ADR3 => data_enable_N_7979,
      O => N_997_6
    );
  G_888_84 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_997_5,
      ADR1 => N_997_6,
      ADR2 => N_997_4,
      ADR3 => N_997_3,
      O => G_888
    );
  G_889_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7528,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(13),
      ADR3 => data_enable_N_7979_fast,
      O => N_998_2
    );
  G_889_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(13),
      ADR1 => data_enable_N_7980_fast,
      ADR2 => data_enable_delay_word0(13),
      ADR3 => data_enable_N_7978_fast,
      O => N_998_3
    );
  G_889_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_998_3,
      ADR1 => data_enable_N_7866,
      ADR2 => un32_d_out_mod_s_11,
      ADR3 => data_enable_N_7982_fast,
      O => N_998_7
    );
  G_889_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_998_7,
      ADR1 => N_998_2,
      ADR2 => data_enable_N_7871,
      ADR3 => data_enable_N_7869,
      O => N_998_8
    );
  G_889_85 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_998_8,
      ADR1 => data_enable_N_7863,
      ADR2 => data_enable_cell_buf_11_13_Q,
      ADR3 => data_enable_N_7291,
      O => G_889
    );
  G_890_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7527,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(14),
      ADR3 => data_enable_N_7979_rep1,
      O => N_999_2
    );
  G_890_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(14),
      ADR1 => data_enable_N_7980_fast,
      ADR2 => data_enable_delay_word0(14),
      ADR3 => data_enable_N_7978_fast,
      O => N_999_3
    );
  G_890_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_999_3,
      ADR1 => data_enable_N_7877,
      ADR2 => un32_d_out_mod_s_12,
      ADR3 => data_enable_N_7982_fast,
      O => N_999_7
    );
  G_890_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_999_7,
      ADR1 => N_999_2,
      ADR2 => data_enable_N_7882,
      ADR3 => data_enable_N_7880,
      O => N_999_8
    );
  G_890_86 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_999_8,
      ADR1 => data_enable_N_7874,
      ADR2 => data_enable_cell_buf_11_14_Q,
      ADR3 => data_enable_N_7291,
      O => G_890
    );
  G_891_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7510,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(15),
      ADR3 => data_enable_N_7979_rep1,
      O => N_1000_2
    );
  G_891_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(15),
      ADR1 => data_enable_N_7980_fast,
      ADR2 => data_enable_delay_word0(15),
      ADR3 => data_enable_N_7978_fast,
      O => N_1000_3
    );
  G_891_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1000_3,
      ADR1 => data_enable_N_7888,
      ADR2 => un32_d_out_mod_s_13,
      ADR3 => data_enable_N_7982_fast,
      O => N_1000_7
    );
  G_891_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1000_7,
      ADR1 => N_1000_2,
      ADR2 => data_enable_N_7893,
      ADR3 => data_enable_N_7891,
      O => N_1000_8
    );
  G_891_87 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1000_8,
      ADR1 => data_enable_N_7885,
      ADR2 => data_enable_cell_buf_11_15_Q,
      ADR3 => data_enable_N_7291,
      O => G_891
    );
  G_892_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7511,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(16),
      ADR3 => data_enable_N_7979_rep1,
      O => N_1001_2
    );
  G_892_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(16),
      ADR1 => data_enable_N_7980_rep1,
      ADR2 => data_enable_delay_word0(16),
      ADR3 => data_enable_N_7978_rep1,
      O => N_1001_3
    );
  G_892_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1001_3,
      ADR1 => data_enable_N_7899,
      ADR2 => un32_d_out_mod_s_14,
      ADR3 => data_enable_N_7982_fast,
      O => N_1001_7
    );
  G_892_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1001_7,
      ADR1 => N_1001_2,
      ADR2 => data_enable_N_7904,
      ADR3 => data_enable_N_7902,
      O => N_1001_8
    );
  G_892_88 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1001_8,
      ADR1 => data_enable_N_7896,
      ADR2 => data_enable_cell_buf_11_16_Q,
      ADR3 => data_enable_N_7291,
      O => G_892
    );
  G_893_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => D_OUT_MOD_0_i_i_0_and2_5_s(17),
      ADR1 => data_enable_N_7974,
      ADR2 => data_enable_N_7497,
      ADR3 => data_enable_N_7986,
      O => N_1002_1
    );
  G_893_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7512,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(17),
      ADR3 => data_enable_N_7979,
      O => N_1002_2
    );
  G_893_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(17),
      ADR1 => data_enable_N_7980_rep1,
      ADR2 => data_enable_delay_word0(17),
      ADR3 => data_enable_N_7978_rep1,
      O => N_1002_3
    );
  G_893_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_17_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_cell_buf_11_17_Q,
      ADR3 => G_6027_1_fast,
      O => N_1002_5
    );
  G_893_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1002_3,
      ADR1 => data_enable_N_7910,
      ADR2 => un32_d_out_mod_s_15,
      ADR3 => data_enable_N_7982,
      O => N_1002_7
    );
  G_893_89 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1002_5,
      ADR1 => N_1002_7,
      ADR2 => N_1002_2,
      ADR3 => N_1002_1,
      O => G_893
    );
  G_894_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => D_OUT_MOD_0_i_i_0_and2_5_s(18),
      ADR1 => data_enable_N_7974,
      ADR2 => data_enable_N_7498,
      ADR3 => data_enable_N_7986,
      O => N_1003_1
    );
  G_894_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7513,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(18),
      ADR3 => data_enable_N_7979,
      O => N_1003_2
    );
  G_894_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(18),
      ADR1 => data_enable_N_7980_rep1,
      ADR2 => data_enable_delay_word0(18),
      ADR3 => data_enable_N_7978_rep1,
      O => N_1003_3
    );
  G_894_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_18_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_cell_buf_11_18_Q,
      ADR3 => G_6027_1_fast,
      O => N_1003_5
    );
  G_894_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1003_3,
      ADR1 => data_enable_N_7921,
      ADR2 => un32_d_out_mod_s_16,
      ADR3 => data_enable_N_7982,
      O => N_1003_7
    );
  G_894_90 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1003_5,
      ADR1 => N_1003_7,
      ADR2 => N_1003_2,
      ADR3 => N_1003_1,
      O => G_894
    );
  G_895_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => D_OUT_MOD_0_i_i_0_and2_5_s(19),
      ADR1 => data_enable_N_7974,
      ADR2 => data_enable_N_7499,
      ADR3 => data_enable_N_7986,
      O => N_1004_1
    );
  G_895_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7514,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(19),
      ADR3 => data_enable_N_7979,
      O => N_1004_2
    );
  G_895_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(19),
      ADR1 => data_enable_N_7980_rep1,
      ADR2 => data_enable_delay_word0(19),
      ADR3 => data_enable_N_7978_rep1,
      O => N_1004_3
    );
  G_895_5 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_19_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_cell_buf_11_19_Q,
      ADR3 => G_6027_1_fast,
      O => N_1004_5
    );
  G_895_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_1004_3,
      ADR1 => data_enable_N_7932,
      ADR2 => un32_d_out_mod_s_17,
      ADR3 => data_enable_N_7982,
      O => N_1004_7
    );
  G_895_91 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1004_5,
      ADR1 => N_1004_7,
      ADR2 => N_1004_2,
      ADR3 => N_1004_1,
      O => G_895
    );
  G_896_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_20_Q,
      ADR1 => data_enable_N_7296_rep1,
      ADR2 => data_enable_delay_word0(20),
      ADR3 => data_enable_N_7978,
      O => N_1005_1
    );
  G_896_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7556,
      ADR1 => data_enable_N_7971,
      ADR2 => data_enable_N_7573,
      ADR3 => data_enable_N_7972,
      O => N_1005_2
    );
  G_896_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(20),
      ADR1 => data_enable_N_7979,
      ADR2 => data_enable_data_in(20),
      ADR3 => data_enable_N_7980,
      O => N_1005_3
    );
  G_896_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_18,
      ADR1 => data_enable_N_7982,
      ADR2 => data_enable_N_7438,
      ADR3 => data_enable_N_7981,
      O => N_1005_4
    );
  G_896_92 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_1005_2,
      ADR1 => N_1005_1,
      ADR2 => N_1005_4,
      ADR3 => N_1005_3,
      O => G_896
    );
  G_868_1 : X_LUT4
    generic map(
      INIT => X"A88A"
    )
    port map (
      ADR0 => segment_out_state_3_Q,
      ADR1 => segment_N_1408,
      ADR2 => segment_cur_len(2),
      ADR3 => segment_cur_len(1),
      O => N_977_1
    );
  G_868_93 : X_LUT4
    generic map(
      INIT => X"AAAE"
    )
    port map (
      ADR0 => N_977_1,
      ADR1 => segment_soc_out,
      ADR2 => segment_out_count(0),
      ADR3 => segment_N_650,
      O => G_868
    );
  G_873_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_22_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(22),
      ADR3 => data_enable_N_7978,
      O => N_982_1
    );
  G_873_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7554,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7571,
      ADR3 => data_enable_N_7972,
      O => N_982_2
    );
  G_873_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(22),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(22),
      ADR3 => data_enable_N_7980,
      O => N_982_3
    );
  G_873_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_20,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7440,
      ADR3 => data_enable_N_7981_rep1,
      O => N_982_4
    );
  G_873_94 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_982_2,
      ADR1 => N_982_1,
      ADR2 => N_982_4,
      ADR3 => N_982_3,
      O => G_873
    );
  G_874_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_23_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(23),
      ADR3 => data_enable_N_7978,
      O => N_983_1
    );
  G_874_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7553,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7570,
      ADR3 => data_enable_N_7972,
      O => N_983_2
    );
  G_874_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(23),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(23),
      ADR3 => data_enable_N_7980,
      O => N_983_3
    );
  G_874_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_21,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7441,
      ADR3 => data_enable_N_7981_rep1,
      O => N_983_4
    );
  G_874_95 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_983_2,
      ADR1 => N_983_1,
      ADR2 => N_983_4,
      ADR3 => N_983_3,
      O => G_874
    );
  G_875_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_24_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(24),
      ADR3 => data_enable_N_7978,
      O => N_984_1
    );
  G_875_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7552,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7569,
      ADR3 => data_enable_N_7972,
      O => N_984_2
    );
  G_875_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(24),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(24),
      ADR3 => data_enable_N_7980,
      O => N_984_3
    );
  G_875_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_22,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7442,
      ADR3 => data_enable_N_7981,
      O => N_984_4
    );
  G_875_96 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_984_2,
      ADR1 => N_984_1,
      ADR2 => N_984_4,
      ADR3 => N_984_3,
      O => G_875
    );
  G_876_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_25_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(25),
      ADR3 => data_enable_N_7978,
      O => N_985_1
    );
  G_876_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7551,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7568,
      ADR3 => data_enable_N_7972,
      O => N_985_2
    );
  G_876_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(25),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(25),
      ADR3 => data_enable_N_7980,
      O => N_985_3
    );
  G_876_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_23,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7443,
      ADR3 => data_enable_N_7981,
      O => N_985_4
    );
  G_876_97 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_985_2,
      ADR1 => N_985_1,
      ADR2 => N_985_4,
      ADR3 => N_985_3,
      O => G_876
    );
  G_877_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_26_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(26),
      ADR3 => data_enable_N_7978,
      O => N_986_1
    );
  G_877_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7550,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7567,
      ADR3 => data_enable_N_7972,
      O => N_986_2
    );
  G_877_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(26),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(26),
      ADR3 => data_enable_N_7980,
      O => N_986_3
    );
  G_877_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_24,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7444,
      ADR3 => data_enable_N_7981,
      O => N_986_4
    );
  G_877_98 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_986_2,
      ADR1 => N_986_1,
      ADR2 => N_986_4,
      ADR3 => N_986_3,
      O => G_877
    );
  G_878_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_27_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(27),
      ADR3 => data_enable_N_7978,
      O => N_987_1
    );
  G_878_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7549,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7566,
      ADR3 => data_enable_N_7972,
      O => N_987_2
    );
  G_878_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(27),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(27),
      ADR3 => data_enable_N_7980,
      O => N_987_3
    );
  G_878_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_25,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7445,
      ADR3 => data_enable_N_7981,
      O => N_987_4
    );
  G_878_99 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_987_2,
      ADR1 => N_987_1,
      ADR2 => N_987_4,
      ADR3 => N_987_3,
      O => G_878
    );
  G_879_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_28_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(28),
      ADR3 => data_enable_N_7978,
      O => N_988_1
    );
  G_879_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7548,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7565,
      ADR3 => data_enable_N_7972,
      O => N_988_2
    );
  G_879_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(28),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(28),
      ADR3 => data_enable_N_7980,
      O => N_988_3
    );
  G_879_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_26,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7446,
      ADR3 => data_enable_N_7981,
      O => N_988_4
    );
  G_879_100 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_988_2,
      ADR1 => N_988_1,
      ADR2 => N_988_4,
      ADR3 => N_988_3,
      O => G_879
    );
  G_880_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_29_Q,
      ADR1 => data_enable_N_7296_fast,
      ADR2 => data_enable_delay_word0(29),
      ADR3 => data_enable_N_7978,
      O => N_989_1
    );
  G_880_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7547,
      ADR1 => data_enable_N_7971_rep1,
      ADR2 => data_enable_N_7564,
      ADR3 => data_enable_N_7972,
      O => N_989_2
    );
  G_880_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_delay_word1(29),
      ADR1 => data_enable_N_7979_rep2,
      ADR2 => data_enable_data_in(29),
      ADR3 => data_enable_N_7980,
      O => N_989_3
    );
  G_880_4 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => un32_d_out_mod_s_27,
      ADR1 => data_enable_N_7982_rep1,
      ADR2 => data_enable_N_7447,
      ADR3 => data_enable_N_7981,
      O => N_989_4
    );
  G_880_101 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_989_2,
      ADR1 => N_989_1,
      ADR2 => N_989_4,
      ADR3 => N_989_3,
      O => G_880
    );
  G_881_2 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_N_7524,
      ADR1 => data_enable_N_7983,
      ADR2 => data_enable_delay_word1(30),
      ADR3 => data_enable_N_7979_fast,
      O => N_990_2
    );
  G_881_3 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => data_enable_data_in(30),
      ADR1 => data_enable_N_7980_fast,
      ADR2 => data_enable_delay_word0(30),
      ADR3 => data_enable_N_7978_fast,
      O => N_990_3
    );
  G_881_7 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_990_3,
      ADR1 => data_enable_N_7943,
      ADR2 => un32_d_out_mod_s_28,
      ADR3 => data_enable_N_7982_fast,
      O => N_990_7
    );
  G_881_8 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => N_990_7,
      ADR1 => N_990_2,
      ADR2 => data_enable_N_7948,
      ADR3 => data_enable_N_7946,
      O => N_990_8
    );
  G_881_102 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_990_8,
      ADR1 => data_enable_N_7940,
      ADR2 => data_enable_cell_buf_11_30_Q,
      ADR3 => data_enable_N_7291,
      O => G_881
    );
  G_852_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(8),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_8,
      ADR3 => segment_N_1672,
      O => N_961_1
    );
  G_852_103 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_961_1,
      ADR1 => segment_dfifo_out_10_Q,
      ADR2 => segment_N_1673,
      O => G_852
    );
  G_853_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(9),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_9,
      ADR3 => segment_N_1672,
      O => N_962_1
    );
  G_853_104 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_962_1,
      ADR1 => segment_dfifo_out_11_Q,
      ADR2 => segment_N_1673,
      O => G_853
    );
  G_854_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(10),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_10,
      ADR3 => segment_N_1672,
      O => N_963_1
    );
  G_854_105 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_963_1,
      ADR1 => segment_dfifo_out_12_Q,
      ADR2 => segment_N_1673,
      O => G_854
    );
  G_855_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(11),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_11,
      ADR3 => segment_N_1672,
      O => N_964_1
    );
  G_855_106 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_964_1,
      ADR1 => segment_dfifo_out_13_Q,
      ADR2 => segment_N_1673,
      O => G_855
    );
  G_856_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(12),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_12,
      ADR3 => segment_N_1672,
      O => N_965_1
    );
  G_856_107 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_965_1,
      ADR1 => segment_dfifo_out_14_Q,
      ADR2 => segment_N_1673,
      O => G_856
    );
  G_857_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(13),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_13,
      ADR3 => segment_N_1672,
      O => N_966_1
    );
  G_857_108 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_966_1,
      ADR1 => segment_dfifo_out_15_Q,
      ADR2 => segment_N_1673,
      O => G_857
    );
  G_859_1 : X_LUT4
    generic map(
      INIT => X"8F88"
    )
    port map (
      ADR0 => segment_total_len(0),
      ADR1 => segment_N_1671,
      ADR2 => segment_total_len(0),
      ADR3 => segment_N_1672,
      O => N_968_1
    );
  G_859_109 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_968_1,
      ADR1 => segment_dfifo_out_2_Q,
      ADR2 => segment_N_1673,
      O => G_859
    );
  G_860_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(1),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_1,
      ADR3 => segment_N_1672,
      O => N_969_1
    );
  G_860_110 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_969_1,
      ADR1 => segment_dfifo_out_3_Q,
      ADR2 => segment_N_1673,
      O => G_860
    );
  G_861_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(2),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_2,
      ADR3 => segment_N_1672,
      O => N_970_1
    );
  G_861_111 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_970_1,
      ADR1 => segment_dfifo_out_4_Q,
      ADR2 => segment_N_1673,
      O => G_861
    );
  G_862_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(3),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_3,
      ADR3 => segment_N_1672,
      O => N_971_1
    );
  G_862_112 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_971_1,
      ADR1 => segment_dfifo_out_5_Q,
      ADR2 => segment_N_1673,
      O => G_862
    );
  G_863_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(4),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_4,
      ADR3 => segment_N_1672,
      O => N_972_1
    );
  G_863_113 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_972_1,
      ADR1 => segment_dfifo_out_6_Q,
      ADR2 => segment_N_1673,
      O => G_863
    );
  G_864_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(5),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_5,
      ADR3 => segment_N_1672,
      O => N_973_1
    );
  G_864_114 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_973_1,
      ADR1 => segment_dfifo_out_7_Q,
      ADR2 => segment_N_1673,
      O => G_864
    );
  G_850_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(6),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_6,
      ADR3 => segment_N_1672,
      O => N_959_1
    );
  G_850_115 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_959_1,
      ADR1 => segment_dfifo_out_8_Q,
      ADR2 => segment_N_1673,
      O => G_850
    );
  G_851_1 : X_LUT4
    generic map(
      INIT => X"F888"
    )
    port map (
      ADR0 => segment_total_len(7),
      ADR1 => segment_N_1671,
      ADR2 => un27_data_out_s_7,
      ADR3 => segment_N_1672,
      O => N_960_1
    );
  G_851_116 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => N_960_1,
      ADR1 => segment_dfifo_out_9_Q,
      ADR2 => segment_N_1673,
      O => G_851
    );
  crc_in_crc_gen_G_63 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => crc_in_crc_gen_count(1),
      ADR1 => crc_in_crc_gen_count(3),
      O => G_63
    );
  crc_in_crc_gen_G_62 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => crc_in_crc_gen_count(0),
      ADR1 => crc_in_crc_gen_count(2),
      O => G_62
    );
  crc_in_crc_gen_G_4 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => crc_in_crc_gen_count(0),
      ADR1 => crc_in_crc_gen_count(1),
      O => crc_in_crc_gen_un5_count_c2
    );
  crc_in_crc_gen_sof_buf_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => crc_in_soc_wire,
      ADR1 => crc_in_crc_gen_is_lastcell,
      O => crc_in_crc_gen_sof_buf
    );
  crc_in_crc_gen_un2_crc_pos_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => G_62,
      ADR1 => G_63,
      ADR2 => crc_in_crc_gen_is_lastcell,
      O => crc_in_crc_pos_wire
    );
  crc_in_crc_gen_crc_out_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(13),
      O => crc_in_crc_out(13),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(12),
      O => crc_in_crc_out(12),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(11),
      O => crc_in_crc_out(11),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(10),
      O => crc_in_crc_out(10),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(9),
      O => crc_in_crc_out(9),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(8),
      O => crc_in_crc_out(8),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(7),
      O => crc_in_crc_out(7),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(6),
      O => crc_in_crc_out(6),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(5),
      O => crc_in_crc_out(5),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(4),
      O => crc_in_crc_out(4),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(3),
      O => crc_in_crc_out(3),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(2),
      O => crc_in_crc_out(2),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(1),
      O => crc_in_crc_out(1),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(0),
      O => crc_in_crc_out(0),
      SRST => Reset_l_i_11,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(28),
      O => crc_in_crc_out(28),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(27),
      O => crc_in_crc_out(27),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(26),
      O => crc_in_crc_out(26),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(25),
      O => crc_in_crc_out(25),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(24),
      O => crc_in_crc_out(24),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(23),
      O => crc_in_crc_out(23),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(22),
      O => crc_in_crc_out(22),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(21),
      O => crc_in_crc_out(21),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(20),
      O => crc_in_crc_out(20),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(19),
      O => crc_in_crc_out(19),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(18),
      O => crc_in_crc_out(18),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(17),
      O => crc_in_crc_out(17),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(16),
      O => crc_in_crc_out(16),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(15),
      O => crc_in_crc_out(15),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(14),
      O => crc_in_crc_out(14),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(31),
      O => crc_in_crc_out(31),
      SRST => Reset_l_i_12,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(30),
      O => crc_in_crc_out(30),
      SRST => Reset_l_i_13,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_crc_out_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_in_crc_gen_crc_calc(29),
      O => crc_in_crc_out(29),
      SRST => Reset_l_i_13,
      SSET => crc_in_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_in_crc_gen_is_lastcell_117 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_in_soc_wire,
      CLK => CLK,
      I => crc_in_data_wire(1),
      O => crc_in_crc_gen_is_lastcell,
      SSET => Reset_l_i_13,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  crc_in_crc_gen_soc_delay_118 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_soc_wire,
      O => crc_in_crc_gen_soc_delay,
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_SOC_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_soc_in,
      O => crc_in_soc_wire,
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_soc_in_119 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => SOC_MOD_IN,
      O => crc_in_crc_gen_d_soc_in,
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_dataen_buf_120 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => N_1029_i,
      O => crc_in_crc_gen_dataen_buf,
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_count_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_916,
      O => crc_in_crc_gen_count(0),
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_count_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_917,
      O => crc_in_crc_gen_count(1),
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_count_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_918,
      O => crc_in_crc_gen_count(2),
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_count_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_919,
      O => crc_in_crc_gen_count(3),
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(27),
      O => crc_in_data_wire(27),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(28),
      O => crc_in_data_wire(28),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(29),
      O => crc_in_data_wire(29),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(30),
      O => crc_in_data_wire(30),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(31),
      O => crc_in_data_wire(31),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(12),
      O => crc_in_data_wire(12),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(13),
      O => crc_in_data_wire(13),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(14),
      O => crc_in_data_wire(14),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(15),
      O => crc_in_data_wire(15),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(16),
      O => crc_in_data_wire(16),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(17),
      O => crc_in_data_wire(17),
      SRST => Reset_l_i_13,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(18),
      O => crc_in_data_wire(18),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(19),
      O => crc_in_data_wire(19),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(20),
      O => crc_in_data_wire(20),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(21),
      O => crc_in_data_wire(21),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(22),
      O => crc_in_data_wire(22),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(23),
      O => crc_in_data_wire(23),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(24),
      O => crc_in_data_wire(24),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(25),
      O => crc_in_data_wire(25),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(26),
      O => crc_in_data_wire(26),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(0),
      O => crc_in_data_wire(0),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(1),
      O => crc_in_data_wire(1),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(2),
      O => crc_in_data_wire(2),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(3),
      O => crc_in_data_wire(3),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(4),
      O => crc_in_data_wire(4),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(5),
      O => crc_in_data_wire(5),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(6),
      O => crc_in_data_wire(6),
      SRST => Reset_l_i_14,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(7),
      O => crc_in_data_wire(7),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(8),
      O => crc_in_data_wire(8),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(9),
      O => crc_in_data_wire(9),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(10),
      O => crc_in_data_wire(10),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_D_OUT_MOD_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_gen_d_data_in(11),
      O => crc_in_data_wire(11),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(25),
      O => crc_in_crc_gen_d_data_in(25),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(26),
      O => crc_in_crc_gen_d_data_in(26),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(27),
      O => crc_in_crc_gen_d_data_in(27),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(28),
      O => crc_in_crc_gen_d_data_in(28),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(29),
      O => crc_in_crc_gen_d_data_in(29),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(30),
      O => crc_in_crc_gen_d_data_in(30),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(31),
      O => crc_in_crc_gen_d_data_in(31),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(10),
      O => crc_in_crc_gen_d_data_in(10),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(11),
      O => crc_in_crc_gen_d_data_in(11),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(12),
      O => crc_in_crc_gen_d_data_in(12),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(13),
      O => crc_in_crc_gen_d_data_in(13),
      SRST => Reset_l_i_15,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(14),
      O => crc_in_crc_gen_d_data_in(14),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(15),
      O => crc_in_crc_gen_d_data_in(15),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(16),
      O => crc_in_crc_gen_d_data_in(16),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(17),
      O => crc_in_crc_gen_d_data_in(17),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(18),
      O => crc_in_crc_gen_d_data_in(18),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(19),
      O => crc_in_crc_gen_d_data_in(19),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(20),
      O => crc_in_crc_gen_d_data_in(20),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(21),
      O => crc_in_crc_gen_d_data_in(21),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(22),
      O => crc_in_crc_gen_d_data_in(22),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(23),
      O => crc_in_crc_gen_d_data_in(23),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(24),
      O => crc_in_crc_gen_d_data_in(24),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(0),
      O => crc_in_crc_gen_d_data_in(0),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(1),
      O => crc_in_crc_gen_d_data_in(1),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(2),
      O => crc_in_crc_gen_d_data_in(2),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(3),
      O => crc_in_crc_gen_d_data_in(3),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(4),
      O => crc_in_crc_gen_d_data_in(4),
      SRST => Reset_l_i_16,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(5),
      O => crc_in_crc_gen_d_data_in(5),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(6),
      O => crc_in_crc_gen_d_data_in(6),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(7),
      O => crc_in_crc_gen_d_data_in(7),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(8),
      O => crc_in_crc_gen_d_data_in(8),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_d_data_in_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_MOD_IN(9),
      O => crc_in_crc_gen_d_data_in(9),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_gen_crccalc_prexor_thexor0_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(0),
      ADR1 => crc_in_crc_out(0),
      O => crc_in_crc_gen_crccalc_prexored(0)
    );
  crc_in_crc_gen_crccalc_prexor_thexor1_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(1),
      ADR1 => crc_in_crc_out(1),
      O => crc_in_crc_gen_crccalc_prexored(1)
    );
  crc_in_crc_gen_crccalc_prexor_thexor2_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(2),
      ADR1 => crc_in_crc_out(2),
      O => crc_in_crc_gen_crccalc_prexored(2)
    );
  crc_in_crc_gen_crccalc_prexor_thexor3_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(3),
      ADR1 => crc_in_crc_out(3),
      O => crc_in_crc_gen_crccalc_prexored(3)
    );
  crc_in_crc_gen_crccalc_prexor_thexor4_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(4),
      ADR1 => crc_in_crc_out(4),
      O => crc_in_crc_gen_crccalc_prexored(4)
    );
  crc_in_crc_gen_crccalc_prexor_thexor5_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(5),
      ADR1 => crc_in_crc_out(5),
      O => crc_in_crc_gen_crccalc_prexored(5)
    );
  crc_in_crc_gen_crccalc_prexor_thexor6_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(6),
      ADR1 => crc_in_crc_out(6),
      O => crc_in_crc_gen_crccalc_prexored(6)
    );
  crc_in_crc_gen_crccalc_prexor_thexor7_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(7),
      ADR1 => crc_in_crc_out(7),
      O => crc_in_crc_gen_crccalc_prexored(7)
    );
  crc_in_crc_gen_crccalc_prexor_thexor8_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(8),
      ADR1 => crc_in_crc_out(8),
      O => crc_in_crc_gen_crccalc_prexored(8)
    );
  crc_in_crc_gen_crccalc_prexor_thexor9_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(9),
      ADR1 => crc_in_crc_out(9),
      O => crc_in_crc_gen_crccalc_prexored(9)
    );
  crc_in_crc_gen_crccalc_prexor_thexor10_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(10),
      ADR1 => crc_in_crc_out(10),
      O => crc_in_crc_gen_crccalc_prexored(10)
    );
  crc_in_crc_gen_crccalc_prexor_thexor11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(11),
      ADR1 => crc_in_crc_out(11),
      O => crc_in_crc_gen_crccalc_prexored(11)
    );
  crc_in_crc_gen_crccalc_prexor_thexor12_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(12),
      ADR1 => crc_in_crc_out(12),
      O => crc_in_crc_gen_crccalc_prexored(12)
    );
  crc_in_crc_gen_crccalc_prexor_thexor13_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(13),
      ADR1 => crc_in_crc_out(13),
      O => crc_in_crc_gen_crccalc_prexored(13)
    );
  crc_in_crc_gen_crccalc_prexor_thexor14_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(14),
      ADR1 => crc_in_crc_out(14),
      O => crc_in_crc_gen_crccalc_prexored(14)
    );
  crc_in_crc_gen_crccalc_prexor_thexor15_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(15),
      ADR1 => crc_in_crc_out(15),
      O => crc_in_crc_gen_crccalc_prexored(15)
    );
  crc_in_crc_gen_crccalc_prexor_thexor16_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(16),
      ADR1 => crc_in_crc_out(16),
      O => crc_in_crc_gen_crccalc_prexored(16)
    );
  crc_in_crc_gen_crccalc_prexor_thexor17_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(17),
      ADR1 => crc_in_crc_out(17),
      O => crc_in_crc_gen_crccalc_prexored(17)
    );
  crc_in_crc_gen_crccalc_prexor_thexor18_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(18),
      ADR1 => crc_in_crc_out(18),
      O => crc_in_crc_gen_crccalc_prexored(18)
    );
  crc_in_crc_gen_crccalc_prexor_thexor19_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(19),
      ADR1 => crc_in_crc_out(19),
      O => crc_in_crc_gen_crccalc_prexored(19)
    );
  crc_in_crc_gen_crccalc_prexor_thexor20_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(20),
      ADR1 => crc_in_crc_out(20),
      O => crc_in_crc_gen_crccalc_prexored(20)
    );
  crc_in_crc_gen_crccalc_prexor_thexor21_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(21),
      ADR1 => crc_in_crc_out(21),
      O => crc_in_crc_gen_crccalc_prexored(21)
    );
  crc_in_crc_gen_crccalc_prexor_thexor22_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(22),
      ADR1 => crc_in_crc_out(22),
      O => crc_in_crc_gen_crccalc_prexored(22)
    );
  crc_in_crc_gen_crccalc_prexor_thexor23_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(23),
      ADR1 => crc_in_crc_out(23),
      O => crc_in_crc_gen_crccalc_prexored(23)
    );
  crc_in_crc_gen_crccalc_prexor_thexor24_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(24),
      ADR1 => crc_in_crc_out(24),
      O => crc_in_crc_gen_crccalc_prexored(24)
    );
  crc_in_crc_gen_crccalc_prexor_thexor25_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(25),
      ADR1 => crc_in_crc_out(25),
      O => crc_in_crc_gen_crccalc_prexored(25)
    );
  crc_in_crc_gen_crccalc_prexor_thexor26_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(26),
      ADR1 => crc_in_crc_out(26),
      O => crc_in_crc_gen_crccalc_prexored(26)
    );
  crc_in_crc_gen_crccalc_prexor_thexor27_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(27),
      ADR1 => crc_in_crc_out(27),
      O => crc_in_crc_gen_crccalc_prexored(27)
    );
  crc_in_crc_gen_crccalc_prexor_thexor28_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(28),
      ADR1 => crc_in_crc_out(28),
      O => crc_in_crc_gen_crccalc_prexored(28)
    );
  crc_in_crc_gen_crccalc_prexor_thexor29_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(29),
      ADR1 => crc_in_crc_out(29),
      O => crc_in_crc_gen_crccalc_prexored(29)
    );
  crc_in_crc_gen_crccalc_prexor_thexor30_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(30),
      ADR1 => crc_in_crc_out(30),
      O => crc_in_crc_gen_crccalc_prexored(30)
    );
  crc_in_crc_gen_crccalc_prexor_thexor31_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_data_wire(31),
      ADR1 => crc_in_crc_out(31),
      O => crc_in_crc_gen_crccalc_prexored(31)
    );
  crc_in_crc_gen_crccalc_matrix_row0_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row0_xorq_q_371,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q001,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q11,
      ADR3 => crc_in_crc_gen_crccalc_matrix_row0_xorq_q_372,
      O => crc_in_crc_gen_crc_calc(0)
    );
  crc_in_crc_gen_crccalc_matrix_row0_xorq_q_369 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(25),
      ADR1 => crc_in_data_wire(25),
      ADR2 => crc_in_crc_out(12),
      ADR3 => crc_in_data_wire(12),
      O => crc_in_crc_gen_crccalc_matrix_q_369
    );
  crc_in_crc_gen_crccalc_matrix_row0_xorq_q_371_121 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(16),
      ADR1 => crc_in_crc_gen_crccalc_prexored(28),
      ADR2 => crc_in_crc_gen_crccalc_prexored(0),
      ADR3 => crc_in_crc_gen_crccalc_prexored(6),
      O => crc_in_crc_gen_crccalc_matrix_row0_xorq_q_371
    );
  crc_in_crc_gen_crccalc_matrix_row0_xorq_q_372_122 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q_369,
      ADR1 => crc_in_crc_gen_crccalc_prexored(24),
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      O => crc_in_crc_gen_crccalc_matrix_row0_xorq_q_372
    );
  crc_in_crc_gen_crccalc_matrix_row0_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(9),
      ADR1 => crc_in_data_wire(9),
      ADR2 => crc_in_crc_out(10),
      ADR3 => crc_in_data_wire(10),
      O => crc_in_crc_gen_crccalc_matrix_q001
    );
  crc_in_crc_gen_crccalc_matrix_row0_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(30),
      ADR1 => crc_in_data_wire(30),
      ADR2 => crc_in_crc_out(31),
      ADR3 => crc_in_data_wire(31),
      O => crc_in_crc_gen_crccalc_matrix_q111
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row1_xorq_q_194,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row1_xorq_q_192,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q010_0,
      O => crc_in_crc_gen_crc_calc(1)
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq_q_192_123 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q110,
      O => crc_in_crc_gen_crccalc_matrix_row1_xorq_q_192
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq_q_194_124 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q000,
      ADR1 => crc_in_crc_gen_crccalc_prexored(13),
      ADR2 => crc_in_crc_gen_crccalc_prexored(24),
      ADR3 => crc_in_crc_gen_crccalc_prexored(9),
      O => crc_in_crc_gen_crccalc_matrix_row1_xorq_q_194
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq000_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(0),
      ADR1 => crc_in_data_wire(0),
      ADR2 => crc_in_crc_out(1),
      ADR3 => crc_in_data_wire(1),
      O => crc_in_crc_gen_crccalc_matrix_q000
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(6),
      ADR1 => crc_in_data_wire(6),
      ADR2 => crc_in_crc_out(7),
      ADR3 => crc_in_data_wire(7),
      O => crc_in_crc_gen_crccalc_matrix_q010_0
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(11),
      ADR1 => crc_in_data_wire(11),
      ADR2 => crc_in_crc_out(12),
      ADR3 => crc_in_data_wire(12),
      O => crc_in_crc_gen_crccalc_matrix_q010
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(16),
      ADR1 => crc_in_data_wire(16),
      ADR2 => crc_in_crc_out(17),
      ADR3 => crc_in_data_wire(17),
      O => crc_in_crc_gen_crccalc_matrix_q100
    );
  crc_in_crc_gen_crccalc_matrix_row1_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(27),
      ADR1 => crc_in_data_wire(27),
      ADR2 => crc_in_crc_out(28),
      ADR3 => crc_in_data_wire(28),
      O => crc_in_crc_gen_crccalc_matrix_q110
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row2_xorq_q_317,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row2_xorq_q_312,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q001_0,
      O => crc_in_crc_gen_crc_calc(2)
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq_q_312_125 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_in_crc_gen_crccalc_prexored(13),
      ADR2 => crc_in_crc_gen_crccalc_prexored(9),
      O => crc_in_crc_gen_crccalc_matrix_row2_xorq_q_312
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq_q_317_126 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q000,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q101,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q110_0,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q100_0,
      O => crc_in_crc_gen_crccalc_matrix_row2_xorq_q_317
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(2),
      ADR1 => crc_in_data_wire(2),
      ADR2 => crc_in_crc_out(6),
      ADR3 => crc_in_data_wire(6),
      O => crc_in_crc_gen_crccalc_matrix_q001_0
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(7),
      ADR1 => crc_in_data_wire(7),
      ADR2 => crc_in_crc_out(8),
      ADR3 => crc_in_data_wire(8),
      O => crc_in_crc_gen_crccalc_matrix_q010_1
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(14),
      ADR1 => crc_in_data_wire(14),
      ADR2 => crc_in_crc_out(16),
      ADR3 => crc_in_data_wire(16),
      O => crc_in_crc_gen_crccalc_matrix_q100_0
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(17),
      ADR1 => crc_in_data_wire(17),
      ADR2 => crc_in_crc_out(18),
      ADR3 => crc_in_data_wire(18),
      O => crc_in_crc_gen_crccalc_matrix_q101
    );
  crc_in_crc_gen_crccalc_matrix_row2_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(24),
      ADR1 => crc_in_data_wire(24),
      ADR2 => crc_in_crc_out(26),
      ADR3 => crc_in_data_wire(26),
      O => crc_in_crc_gen_crccalc_matrix_q110_0
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row3_xorq_q_129,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row3_xorq_q_128,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q100_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q000_0,
      O => crc_in_crc_gen_crc_calc(3)
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq_q_123_127 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(10),
      ADR1 => crc_in_data_wire(10),
      ADR2 => crc_in_crc_out(3),
      ADR3 => crc_in_data_wire(3),
      O => crc_in_crc_gen_crccalc_matrix_row3_xorq_q_123
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq_q_128_128 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100_2,
      ADR1 => crc_in_crc_gen_crccalc_prexored(14),
      ADR2 => crc_in_crc_gen_crccalc_prexored(7),
      ADR3 => crc_in_crc_gen_crccalc_prexored(31),
      O => crc_in_crc_gen_crccalc_matrix_row3_xorq_q_128
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq_q_129_129 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q010_2,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row3_xorq_q_123,
      ADR2 => crc_in_crc_gen_crccalc_prexored(25),
      ADR3 => crc_in_crc_gen_crccalc_prexored(27),
      O => crc_in_crc_gen_crccalc_matrix_row3_xorq_q_129
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(8),
      ADR1 => crc_in_data_wire(8),
      ADR2 => crc_in_crc_out(9),
      ADR3 => crc_in_data_wire(9),
      O => crc_in_crc_gen_crccalc_matrix_q010_2
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(15),
      ADR1 => crc_in_data_wire(15),
      ADR2 => crc_in_crc_out(17),
      ADR3 => crc_in_data_wire(17),
      O => crc_in_crc_gen_crccalc_matrix_q100_1
    );
  crc_in_crc_gen_crccalc_matrix_row3_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(18),
      ADR1 => crc_in_data_wire(18),
      ADR2 => crc_in_crc_out(19),
      ADR3 => crc_in_data_wire(19),
      O => crc_in_crc_gen_crccalc_matrix_q100_2
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row4_xorq_q_253,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row4_xorq_q_252,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q100_2,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q011,
      O => crc_in_crc_gen_crc_calc(4)
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq_q_247_130 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(0),
      ADR1 => crc_in_data_wire(0),
      ADR2 => crc_in_crc_out(25),
      ADR3 => crc_in_data_wire(25),
      O => crc_in_crc_gen_crccalc_matrix_row4_xorq_q_247
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq_q_252_131 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q001_1,
      ADR1 => crc_in_crc_gen_crccalc_prexored(24),
      ADR2 => crc_in_crc_gen_crccalc_prexored(20),
      ADR3 => crc_in_crc_gen_crccalc_prexored(29),
      O => crc_in_crc_gen_crccalc_matrix_row4_xorq_q_252
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq_q_253_132 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row4_xorq_q_247,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q000_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q011_0,
      O => crc_in_crc_gen_crccalc_matrix_row4_xorq_q_253
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq0000_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(2),
      ADR1 => crc_in_data_wire(2),
      ADR2 => crc_in_crc_out(3),
      ADR3 => crc_in_data_wire(3),
      O => crc_in_crc_gen_crccalc_matrix_q000_1
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(4),
      ADR1 => crc_in_data_wire(4),
      ADR2 => crc_in_crc_out(6),
      ADR3 => crc_in_data_wire(6),
      O => crc_in_crc_gen_crccalc_matrix_q001_1
    );
  crc_in_crc_gen_crccalc_matrix_row4_xorq011_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(12),
      ADR1 => crc_in_data_wire(12),
      ADR2 => crc_in_crc_out(15),
      ADR3 => crc_in_data_wire(15),
      O => crc_in_crc_gen_crccalc_matrix_q011
    );
  crc_in_crc_gen_crccalc_matrix_row5_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row5_xorq_q_510,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q00,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q011_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q101_0,
      O => crc_in_crc_gen_crc_calc(5)
    );
  crc_in_crc_gen_crccalc_matrix_row5_xorq_q_507_133 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(13),
      ADR1 => crc_in_crc_gen_crccalc_prexored(19),
      ADR2 => crc_in_crc_gen_crccalc_prexored(6),
      O => crc_in_crc_gen_crccalc_matrix_row5_xorq_q_507
    );
  crc_in_crc_gen_crccalc_matrix_row5_xorq_q_510_134 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row5_xorq_q_507,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q111_0,
      ADR2 => crc_in_crc_gen_crccalc_prexored(24),
      ADR3 => crc_in_crc_gen_crccalc_prexored(5),
      O => crc_in_crc_gen_crccalc_matrix_row5_xorq_q_510
    );
  crc_in_crc_gen_crccalc_matrix_row5_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(3),
      ADR1 => crc_in_data_wire(3),
      ADR2 => crc_in_crc_out(4),
      ADR3 => crc_in_data_wire(4),
      O => crc_in_crc_gen_crccalc_matrix_q001_2
    );
  crc_in_crc_gen_crccalc_matrix_row5_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(20),
      ADR1 => crc_in_data_wire(20),
      ADR2 => crc_in_crc_out(21),
      ADR3 => crc_in_data_wire(21),
      O => crc_in_crc_gen_crccalc_matrix_q101_0
    );
  crc_in_crc_gen_crccalc_matrix_row5_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(28),
      ADR1 => crc_in_data_wire(28),
      ADR2 => crc_in_crc_out(29),
      ADR3 => crc_in_data_wire(29),
      O => crc_in_crc_gen_crccalc_matrix_q111_0
    );
  crc_in_crc_gen_crccalc_matrix_row6_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row6_xorq_q_202,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row6_xorq_q_197,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q011_0,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q000_0,
      O => crc_in_crc_gen_crc_calc(6)
    );
  crc_in_crc_gen_crccalc_matrix_row6_xorq_q_197_135 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(14),
      ADR1 => crc_in_crc_gen_crccalc_prexored(25),
      ADR2 => crc_in_crc_gen_crccalc_prexored(20),
      O => crc_in_crc_gen_crccalc_matrix_row6_xorq_q_197
    );
  crc_in_crc_gen_crccalc_matrix_row6_xorq_q_202_136 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q010_0,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q101_1,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q110_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q001_3,
      O => crc_in_crc_gen_crccalc_matrix_row6_xorq_q_202
    );
  crc_in_crc_gen_crccalc_matrix_row6_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(4),
      ADR1 => crc_in_data_wire(4),
      ADR2 => crc_in_crc_out(5),
      ADR3 => crc_in_data_wire(5),
      O => crc_in_crc_gen_crccalc_matrix_q001_3
    );
  crc_in_crc_gen_crccalc_matrix_row6_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(21),
      ADR1 => crc_in_data_wire(21),
      ADR2 => crc_in_crc_out(22),
      ADR3 => crc_in_data_wire(22),
      O => crc_in_crc_gen_crccalc_matrix_q101_1
    );
  crc_in_crc_gen_crccalc_matrix_row6_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(29),
      ADR1 => crc_in_data_wire(29),
      ADR2 => crc_in_crc_out(30),
      ADR3 => crc_in_data_wire(30),
      O => crc_in_crc_gen_crccalc_matrix_q110_1
    );
  crc_in_crc_gen_crccalc_matrix_row7_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row7_xorq_q_429,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q00_0,
      ADR2 => crc_in_crc_gen_crccalc_matrix_row7_xorq_q_426,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q101_2,
      O => crc_in_crc_gen_crc_calc(7)
    );
  crc_in_crc_gen_crccalc_matrix_row7_xorq_q_426_137 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(15),
      ADR1 => crc_in_crc_gen_crccalc_prexored(16),
      ADR2 => crc_in_crc_gen_crccalc_prexored(10),
      ADR3 => crc_in_crc_gen_crccalc_prexored(21),
      O => crc_in_crc_gen_crccalc_matrix_row7_xorq_q_426
    );
  crc_in_crc_gen_crccalc_matrix_row7_xorq_q_429_138 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_2,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q010_1,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q111_0,
      O => crc_in_crc_gen_crccalc_matrix_row7_xorq_q_429
    );
  crc_in_crc_gen_crccalc_matrix_row7_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(3),
      ADR1 => crc_in_data_wire(3),
      ADR2 => crc_in_crc_out(5),
      ADR3 => crc_in_data_wire(5),
      O => crc_in_crc_gen_crccalc_matrix_q001_4
    );
  crc_in_crc_gen_crccalc_matrix_row7_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(22),
      ADR1 => crc_in_data_wire(22),
      ADR2 => crc_in_crc_out(23),
      ADR3 => crc_in_data_wire(23),
      O => crc_in_crc_gen_crccalc_matrix_q101_2
    );
  crc_in_crc_gen_crccalc_matrix_row7_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(24),
      ADR1 => crc_in_data_wire(24),
      ADR2 => crc_in_crc_out(25),
      ADR3 => crc_in_data_wire(25),
      O => crc_in_crc_gen_crccalc_matrix_q110_2
    );
  crc_in_crc_gen_crccalc_matrix_row8_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q00,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row8_xorq_q_502,
      ADR2 => crc_in_crc_gen_crccalc_matrix_row8_xorq_q_501,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q110_3,
      O => crc_in_crc_gen_crc_calc(8)
    );
  crc_in_crc_gen_crccalc_matrix_row8_xorq_q_499 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(8),
      ADR1 => crc_in_data_wire(8),
      ADR2 => crc_in_crc_out(11),
      ADR3 => crc_in_data_wire(11),
      O => crc_in_crc_gen_crccalc_matrix_q011_0
    );
  crc_in_crc_gen_crccalc_matrix_row8_xorq_q_501_139 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(12),
      ADR1 => crc_in_crc_gen_crccalc_matrix_q011_0,
      O => crc_in_crc_gen_crccalc_matrix_row8_xorq_q_501
    );
  crc_in_crc_gen_crccalc_matrix_row8_xorq_q_502_140 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(17),
      ADR1 => crc_in_crc_gen_crccalc_prexored(22),
      ADR2 => crc_in_crc_gen_crccalc_prexored(10),
      ADR3 => crc_in_crc_gen_crccalc_prexored(23),
      O => crc_in_crc_gen_crccalc_matrix_row8_xorq_q_502
    );
  crc_in_crc_gen_crccalc_matrix_row8_xorq00_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q000,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q001_2,
      O => crc_in_crc_gen_crccalc_matrix_q00
    );
  crc_in_crc_gen_crccalc_matrix_row8_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(28),
      ADR1 => crc_in_data_wire(28),
      ADR2 => crc_in_crc_out(31),
      ADR3 => crc_in_data_wire(31),
      O => crc_in_crc_gen_crccalc_matrix_q110_3
    );
  crc_in_crc_gen_crccalc_matrix_row9_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row9_xorq_q_49,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q010_3,
      ADR2 => crc_in_crc_gen_crccalc_prexored(13),
      ADR3 => crc_in_crc_gen_crccalc_prexored(24),
      O => crc_in_crc_gen_crc_calc(9)
    );
  crc_in_crc_gen_crccalc_matrix_row9_xorq_q_41 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(1),
      ADR1 => crc_in_data_wire(1),
      ADR2 => crc_in_crc_out(2),
      ADR3 => crc_in_data_wire(2),
      O => crc_in_crc_gen_crccalc_matrix_q000_0
    );
  crc_in_crc_gen_crccalc_matrix_row9_xorq_q_47_141 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(5),
      ADR1 => crc_in_crc_gen_crccalc_prexored(18),
      ADR2 => crc_in_crc_gen_crccalc_prexored(12),
      ADR3 => crc_in_crc_gen_crccalc_prexored(4),
      O => crc_in_crc_gen_crccalc_matrix_row9_xorq_q_47
    );
  crc_in_crc_gen_crccalc_matrix_row9_xorq_q_49_142 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row9_xorq_q_47,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q000_0,
      ADR2 => crc_in_crc_gen_crccalc_prexored(29),
      ADR3 => crc_in_crc_gen_crccalc_prexored(23),
      O => crc_in_crc_gen_crccalc_matrix_row9_xorq_q_49
    );
  crc_in_crc_gen_crccalc_matrix_row9_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(9),
      ADR1 => crc_in_data_wire(9),
      ADR2 => crc_in_crc_out(11),
      ADR3 => crc_in_data_wire(11),
      O => crc_in_crc_gen_crccalc_matrix_q010_3
    );
  crc_in_crc_gen_crccalc_matrix_row10_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row10_xorq_q_538,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q_537,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q11_0,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q00_0,
      O => crc_in_crc_gen_crc_calc(10)
    );
  crc_in_crc_gen_crccalc_matrix_row10_xorq_q_537 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(14),
      ADR1 => crc_in_data_wire(14),
      ADR2 => crc_in_crc_out(13),
      ADR3 => crc_in_data_wire(13),
      O => crc_in_crc_gen_crccalc_matrix_q_537
    );
  crc_in_crc_gen_crccalc_matrix_row10_xorq_q_538_143 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(19),
      ADR1 => crc_in_crc_gen_crccalc_prexored(16),
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      ADR3 => crc_in_crc_gen_crccalc_prexored(9),
      O => crc_in_crc_gen_crccalc_matrix_row10_xorq_q_538
    );
  crc_in_crc_gen_crccalc_matrix_row10_xorq00_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q001_4,
      ADR1 => crc_in_crc_gen_crccalc_prexored(0),
      ADR2 => crc_in_crc_gen_crccalc_prexored(2),
      O => crc_in_crc_gen_crccalc_matrix_q00_0
    );
  crc_in_crc_gen_crccalc_matrix_row11_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row11_xorq_q_309,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row11_xorq_q_307,
      ADR2 => crc_in_crc_gen_crccalc_matrix_row11_xorq_q_305,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q100_3,
      O => crc_in_crc_gen_crc_calc(11)
    );
  crc_in_crc_gen_crccalc_matrix_row11_xorq_q_305_144 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(3),
      ADR1 => crc_in_crc_gen_crccalc_prexored(20),
      ADR2 => crc_in_crc_gen_crccalc_prexored(0),
      ADR3 => crc_in_crc_gen_crccalc_prexored(4),
      O => crc_in_crc_gen_crccalc_matrix_row11_xorq_q_305
    );
  crc_in_crc_gen_crccalc_matrix_row11_xorq_q_307_145 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q010_4,
      ADR1 => crc_in_crc_gen_crccalc_prexored(14),
      ADR2 => crc_in_crc_gen_crccalc_prexored(17),
      ADR3 => crc_in_crc_gen_crccalc_prexored(1),
      O => crc_in_crc_gen_crccalc_matrix_row11_xorq_q_307
    );
  crc_in_crc_gen_crccalc_matrix_row11_xorq_q_309_146 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_2,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q110_3,
      ADR2 => crc_in_crc_gen_crccalc_prexored(9),
      ADR3 => crc_in_crc_gen_crccalc_prexored(12),
      O => crc_in_crc_gen_crccalc_matrix_row11_xorq_q_309
    );
  crc_in_crc_gen_crccalc_matrix_row11_xorq011_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(15),
      ADR1 => crc_in_data_wire(15),
      ADR2 => crc_in_crc_out(16),
      ADR3 => crc_in_data_wire(16),
      O => crc_in_crc_gen_crccalc_matrix_q010_4
    );
  crc_in_crc_gen_crccalc_matrix_row11_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(26),
      ADR1 => crc_in_data_wire(26),
      ADR2 => crc_in_crc_out(27),
      ADR3 => crc_in_data_wire(27),
      O => crc_in_crc_gen_crccalc_matrix_q100_3
    );
  crc_in_crc_gen_crccalc_matrix_row12_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row12_xorq_q_108,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row12_xorq_q_107,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q001_3,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q100_1,
      O => crc_in_crc_gen_crc_calc(12)
    );
  crc_in_crc_gen_crccalc_matrix_row12_xorq_q_104_147 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_in_crc_gen_crccalc_prexored(0),
      ADR2 => crc_in_crc_gen_crccalc_prexored(27),
      O => crc_in_crc_gen_crccalc_matrix_row12_xorq_q_104
    );
  crc_in_crc_gen_crccalc_matrix_row12_xorq_q_107_148 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q001_5,
      ADR1 => crc_in_crc_gen_crccalc_prexored(13),
      ADR2 => crc_in_crc_gen_crccalc_prexored(18),
      ADR3 => crc_in_crc_gen_crccalc_prexored(21),
      O => crc_in_crc_gen_crccalc_matrix_row12_xorq_q_107
    );
  crc_in_crc_gen_crccalc_matrix_row12_xorq_q_108_149 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row12_xorq_q_104,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q000_0,
      ADR2 => crc_in_crc_gen_crccalc_prexored(24),
      ADR3 => crc_in_crc_gen_crccalc_prexored(12),
      O => crc_in_crc_gen_crccalc_matrix_row12_xorq_q_108
    );
  crc_in_crc_gen_crccalc_matrix_row12_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(6),
      ADR1 => crc_in_data_wire(6),
      ADR2 => crc_in_crc_out(9),
      ADR3 => crc_in_data_wire(9),
      O => crc_in_crc_gen_crccalc_matrix_q001_5
    );
  crc_in_crc_gen_crccalc_matrix_row13_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row13_xorq_q_261,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row13_xorq_q_259,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q100_0,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q100_2,
      O => crc_in_crc_gen_crc_calc(13)
    );
  crc_in_crc_gen_crccalc_matrix_row13_xorq_q_257_150 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q000_0,
      ADR1 => crc_in_crc_gen_crccalc_prexored(10),
      ADR2 => crc_in_crc_gen_crccalc_prexored(22),
      O => crc_in_crc_gen_crccalc_matrix_row13_xorq_q_257
    );
  crc_in_crc_gen_crccalc_matrix_row13_xorq_q_259_151 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q001_4,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q010_0,
      O => crc_in_crc_gen_crccalc_matrix_row13_xorq_q_259
    );
  crc_in_crc_gen_crccalc_matrix_row13_xorq_q_261_152 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row13_xorq_q_257,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q110_3,
      ADR2 => crc_in_crc_gen_crccalc_prexored(13),
      ADR3 => crc_in_crc_gen_crccalc_prexored(25),
      O => crc_in_crc_gen_crccalc_matrix_row13_xorq_q_261
    );
  crc_in_crc_gen_crccalc_matrix_row14_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row14_xorq_q_209,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row14_xorq_q_207,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q001_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q010_5,
      O => crc_in_crc_gen_crc_calc(14)
    );
  crc_in_crc_gen_crccalc_matrix_row14_xorq_q_205_153 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(14),
      ADR1 => crc_in_crc_gen_crccalc_prexored(23),
      ADR2 => crc_in_crc_gen_crccalc_prexored(11),
      O => crc_in_crc_gen_crccalc_matrix_row14_xorq_q_205
    );
  crc_in_crc_gen_crccalc_matrix_row14_xorq_q_207_154 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q010_1,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q000_1,
      O => crc_in_crc_gen_crccalc_matrix_row14_xorq_q_207
    );
  crc_in_crc_gen_crccalc_matrix_row14_xorq_q_209_155 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row14_xorq_q_205,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q100_1,
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      ADR3 => crc_in_crc_gen_crccalc_prexored(29),
      O => crc_in_crc_gen_crccalc_matrix_row14_xorq_q_209
    );
  crc_in_crc_gen_crccalc_matrix_row14_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(19),
      ADR1 => crc_in_data_wire(19),
      ADR2 => crc_in_crc_out(20),
      ADR3 => crc_in_data_wire(20),
      O => crc_in_crc_gen_crccalc_matrix_q010_5
    );
  crc_in_crc_gen_crccalc_matrix_row15_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row15_xorq_q_229,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row15_xorq_q_224,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q001_6,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q010_6,
      O => crc_in_crc_gen_crc_calc(15)
    );
  crc_in_crc_gen_crccalc_matrix_row15_xorq_q_224_156 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(24),
      ADR1 => crc_in_crc_gen_crccalc_prexored(27),
      ADR2 => crc_in_crc_gen_crccalc_prexored(30),
      O => crc_in_crc_gen_crccalc_matrix_row15_xorq_q_224
    );
  crc_in_crc_gen_crccalc_matrix_row15_xorq_q_229_157 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q101_0,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q001_2,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_2,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q011,
      O => crc_in_crc_gen_crccalc_matrix_row15_xorq_q_229
    );
  crc_in_crc_gen_crccalc_matrix_row15_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(5),
      ADR1 => crc_in_data_wire(5),
      ADR2 => crc_in_crc_out(7),
      ADR3 => crc_in_data_wire(7),
      O => crc_in_crc_gen_crccalc_matrix_q001_6
    );
  crc_in_crc_gen_crccalc_matrix_row15_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(16),
      ADR1 => crc_in_data_wire(16),
      ADR2 => crc_in_crc_out(18),
      ADR3 => crc_in_data_wire(18),
      O => crc_in_crc_gen_crccalc_matrix_q010_6
    );
  crc_in_crc_gen_crccalc_matrix_row16_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row16_xorq_q_138,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row16_xorq_q_136,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q110_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q000_2,
      O => crc_in_crc_gen_crc_calc(16)
    );
  crc_in_crc_gen_crccalc_matrix_row16_xorq_q_131_158 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(17),
      ADR1 => crc_in_data_wire(17),
      ADR2 => crc_in_crc_out(21),
      ADR3 => crc_in_data_wire(21),
      O => crc_in_crc_gen_crccalc_matrix_row16_xorq_q_131
    );
  crc_in_crc_gen_crccalc_matrix_row16_xorq_q_136_159 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(12),
      ADR1 => crc_in_crc_gen_crccalc_prexored(0),
      ADR2 => crc_in_crc_gen_crccalc_prexored(13),
      ADR3 => crc_in_crc_gen_crccalc_prexored(26),
      O => crc_in_crc_gen_crccalc_matrix_row16_xorq_q_136
    );
  crc_in_crc_gen_crccalc_matrix_row16_xorq_q_138_160 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100_4,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row16_xorq_q_131,
      ADR2 => crc_in_crc_gen_crccalc_prexored(4),
      ADR3 => crc_in_crc_gen_crccalc_prexored(19),
      O => crc_in_crc_gen_crccalc_matrix_row16_xorq_q_138
    );
  crc_in_crc_gen_crccalc_matrix_row16_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(5),
      ADR1 => crc_in_data_wire(5),
      ADR2 => crc_in_crc_out(8),
      ADR3 => crc_in_data_wire(8),
      O => crc_in_crc_gen_crccalc_matrix_q000_2
    );
  crc_in_crc_gen_crccalc_matrix_row16_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(22),
      ADR1 => crc_in_data_wire(22),
      ADR2 => crc_in_crc_out(24),
      ADR3 => crc_in_data_wire(24),
      O => crc_in_crc_gen_crccalc_matrix_q100_4
    );
  crc_in_crc_gen_crccalc_matrix_row17_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row17_xorq_q_80,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row17_xorq_q_78,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q100_5,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q_537,
      O => crc_in_crc_gen_crc_calc(17)
    );
  crc_in_crc_gen_crccalc_matrix_row17_xorq_q_73_161 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(1),
      ADR1 => crc_in_data_wire(1),
      ADR2 => crc_in_crc_out(22),
      ADR3 => crc_in_data_wire(22),
      O => crc_in_crc_gen_crccalc_matrix_row17_xorq_q_73
    );
  crc_in_crc_gen_crccalc_matrix_row17_xorq_q_78_162 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_in_crc_gen_crccalc_prexored(5),
      ADR2 => crc_in_crc_gen_crccalc_prexored(27),
      O => crc_in_crc_gen_crccalc_matrix_row17_xorq_q_78
    );
  crc_in_crc_gen_crccalc_matrix_row17_xorq_q_80_163 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q001_5,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row17_xorq_q_73,
      ADR2 => crc_in_crc_gen_crccalc_prexored(18),
      ADR3 => crc_in_crc_gen_crccalc_prexored(20),
      O => crc_in_crc_gen_crccalc_matrix_row17_xorq_q_80
    );
  crc_in_crc_gen_crccalc_matrix_row17_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(23),
      ADR1 => crc_in_data_wire(23),
      ADR2 => crc_in_crc_out(25),
      ADR3 => crc_in_data_wire(25),
      O => crc_in_crc_gen_crccalc_matrix_q100_5
    );
  crc_in_crc_gen_crccalc_matrix_row18_xorq_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row18_xorq_q_416,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row18_xorq_q_413,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_7,
      O => crc_in_crc_gen_crc_calc(18)
    );
  crc_in_crc_gen_crccalc_matrix_row18_xorq_q_413_164 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(21),
      ADR1 => crc_in_crc_gen_crccalc_prexored(15),
      ADR2 => crc_in_crc_gen_crccalc_prexored(14),
      ADR3 => crc_in_crc_gen_crccalc_prexored(19),
      O => crc_in_crc_gen_crccalc_matrix_row18_xorq_q_413
    );
  crc_in_crc_gen_crccalc_matrix_row18_xorq_q_416_165 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q011_1,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q001_0,
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      ADR3 => crc_in_crc_gen_crccalc_matrix_q110_3,
      O => crc_in_crc_gen_crccalc_matrix_row18_xorq_q_416
    );
  crc_in_crc_gen_crccalc_matrix_row18_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(23),
      ADR1 => crc_in_data_wire(23),
      ADR2 => crc_in_crc_out(24),
      ADR3 => crc_in_data_wire(24),
      O => crc_in_crc_gen_crccalc_matrix_q010_7
    );
  crc_in_crc_gen_crccalc_matrix_row19_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row19_xorq_q_144,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row19_xorq_q_142,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_1,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q010_4,
      O => crc_in_crc_gen_crc_calc(19)
    );
  crc_in_crc_gen_crccalc_matrix_row19_xorq_q_142_166 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(20),
      ADR1 => crc_in_crc_gen_crccalc_prexored(11),
      ADR2 => crc_in_crc_gen_crccalc_prexored(25),
      ADR3 => crc_in_crc_gen_crccalc_prexored(3),
      O => crc_in_crc_gen_crccalc_matrix_row19_xorq_q_142
    );
  crc_in_crc_gen_crccalc_matrix_row19_xorq_q_144_167 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_4,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q100_4,
      O => crc_in_crc_gen_crccalc_matrix_row19_xorq_q_144
    );
  crc_in_crc_gen_crccalc_matrix_row19_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(27),
      ADR1 => crc_in_data_wire(27),
      ADR2 => crc_in_crc_out(29),
      ADR3 => crc_in_data_wire(29),
      O => crc_in_crc_gen_crccalc_matrix_q110_4
    );
  crc_in_crc_gen_crccalc_matrix_row20_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row20_xorq_q_114,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row20_xorq_q_112,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q100,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q110_5,
      O => crc_in_crc_gen_crc_calc(20)
    );
  crc_in_crc_gen_crccalc_matrix_row20_xorq_q_112_168 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(4),
      ADR1 => crc_in_crc_gen_crccalc_prexored(21),
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      ADR3 => crc_in_crc_gen_crccalc_prexored(12),
      O => crc_in_crc_gen_crccalc_matrix_row20_xorq_q_112
    );
  crc_in_crc_gen_crccalc_matrix_row20_xorq_q_114_169 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100_5,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q010_2,
      O => crc_in_crc_gen_crccalc_matrix_row20_xorq_q_114
    );
  crc_in_crc_gen_crccalc_matrix_row20_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(28),
      ADR1 => crc_in_data_wire(28),
      ADR2 => crc_in_crc_out(30),
      ADR3 => crc_in_data_wire(30),
      O => crc_in_crc_gen_crccalc_matrix_q110_5
    );
  crc_in_crc_gen_crccalc_matrix_row21_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q11_1,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row21_xorq_q_471,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q001,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q101,
      O => crc_in_crc_gen_crc_calc(21)
    );
  crc_in_crc_gen_crccalc_matrix_row21_xorq_q_471_170 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_0,
      ADR1 => crc_in_crc_gen_crccalc_prexored(13),
      ADR2 => crc_in_crc_gen_crccalc_prexored(5),
      ADR3 => crc_in_crc_gen_crccalc_prexored(22),
      O => crc_in_crc_gen_crccalc_matrix_row21_xorq_q_471
    );
  crc_in_crc_gen_crccalc_matrix_row22_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row22_xorq_q_444,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11_1,
      ADR2 => crc_in_crc_gen_crccalc_matrix_row22_xorq_q_441,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q010,
      O => crc_in_crc_gen_crc_calc(22)
    );
  crc_in_crc_gen_crccalc_matrix_row22_xorq_q_441_171 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(14),
      ADR1 => crc_in_crc_gen_crccalc_prexored(19),
      ADR2 => crc_in_crc_gen_crccalc_prexored(23),
      O => crc_in_crc_gen_crccalc_matrix_row22_xorq_q_441
    );
  crc_in_crc_gen_crccalc_matrix_row22_xorq_q_444_172 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_0,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q010_6,
      ADR2 => crc_in_crc_gen_crccalc_prexored(9),
      ADR3 => crc_in_crc_gen_crccalc_prexored(0),
      O => crc_in_crc_gen_crccalc_matrix_row22_xorq_q_444
    );
  crc_in_crc_gen_crccalc_matrix_row23_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row23_xorq_q_466,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11_1,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q001_5,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q000,
      O => crc_in_crc_gen_crc_calc(23)
    );
  crc_in_crc_gen_crccalc_matrix_row23_xorq_q_463_173 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(13),
      ADR1 => crc_in_crc_gen_crccalc_prexored(20),
      ADR2 => crc_in_crc_gen_crccalc_prexored(17),
      O => crc_in_crc_gen_crccalc_matrix_row23_xorq_q_463
    );
  crc_in_crc_gen_crccalc_matrix_row23_xorq_q_466_174 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row23_xorq_q_463,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q010_4,
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      ADR3 => crc_in_crc_gen_crccalc_prexored(19),
      O => crc_in_crc_gen_crccalc_matrix_row23_xorq_q_466
    );
  crc_in_crc_gen_crccalc_matrix_row23_xorq11_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(27),
      ADR1 => crc_in_crc_gen_crccalc_prexored(31),
      ADR2 => crc_in_crc_gen_crccalc_prexored(29),
      O => crc_in_crc_gen_crccalc_matrix_q11_1
    );
  crc_in_crc_gen_crccalc_matrix_row24_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row24_xorq_q_344,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11_2,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q101_0,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q100,
      O => crc_in_crc_gen_crc_calc(24)
    );
  crc_in_crc_gen_crccalc_matrix_row24_xorq_q_344_175 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q011_1,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q000_0,
      ADR2 => crc_in_crc_gen_crccalc_prexored(14),
      ADR3 => crc_in_crc_gen_crccalc_prexored(18),
      O => crc_in_crc_gen_crccalc_matrix_row24_xorq_q_344
    );
  crc_in_crc_gen_crccalc_matrix_row25_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row25_xorq_q_459,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11_0,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q101,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q101_1,
      O => crc_in_crc_gen_crc_calc(25)
    );
  crc_in_crc_gen_crccalc_matrix_row25_xorq_q_459_176 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q000_1,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q011_0,
      ADR2 => crc_in_crc_gen_crccalc_prexored(19),
      ADR3 => crc_in_crc_gen_crccalc_prexored(15),
      O => crc_in_crc_gen_crccalc_matrix_row25_xorq_q_459
    );
  crc_in_crc_gen_crccalc_matrix_row26_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row26_xorq_q_410,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q110_2,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_5,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q101_2,
      O => crc_in_crc_gen_crc_calc(26)
    );
  crc_in_crc_gen_crccalc_matrix_row26_xorq_q_406_177 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(10),
      ADR1 => crc_in_crc_gen_crccalc_prexored(18),
      ADR2 => crc_in_crc_gen_crccalc_prexored(0),
      ADR3 => crc_in_crc_gen_crccalc_prexored(3),
      O => crc_in_crc_gen_crccalc_matrix_row26_xorq_q_406
    );
  crc_in_crc_gen_crccalc_matrix_row26_xorq_q_410_178 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row26_xorq_q_406,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q001_1,
      ADR2 => crc_in_crc_gen_crccalc_prexored(26),
      ADR3 => crc_in_crc_gen_crccalc_matrix_q110_3,
      O => crc_in_crc_gen_crccalc_matrix_row26_xorq_q_410
    );
  crc_in_crc_gen_crccalc_matrix_row27_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row27_xorq_q_285,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row27_xorq_q_283,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_5,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q001_6,
      O => crc_in_crc_gen_crc_calc(27)
    );
  crc_in_crc_gen_crccalc_matrix_row27_xorq_q_279_179 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(1),
      ADR1 => crc_in_data_wire(1),
      ADR2 => crc_in_crc_out(11),
      ADR3 => crc_in_data_wire(11),
      O => crc_in_crc_gen_crccalc_matrix_row27_xorq_q_279
    );
  crc_in_crc_gen_crccalc_matrix_row27_xorq_q_283_180 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_4,
      ADR1 => crc_in_crc_gen_crccalc_prexored(26),
      ADR2 => crc_in_crc_gen_crccalc_prexored(4),
      O => crc_in_crc_gen_crccalc_matrix_row27_xorq_q_283
    );
  crc_in_crc_gen_crccalc_matrix_row27_xorq_q_285_181 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_2,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row27_xorq_q_279,
      ADR2 => crc_in_crc_gen_crccalc_prexored(21),
      ADR3 => crc_in_crc_gen_crccalc_prexored(23),
      O => crc_in_crc_gen_crccalc_matrix_row27_xorq_q_285
    );
  crc_in_crc_gen_crccalc_matrix_row28_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row28_xorq_q_360,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11_2,
      ADR2 => crc_in_crc_gen_crccalc_matrix_row28_xorq_q_357,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q101_0,
      O => crc_in_crc_gen_crc_calc(28)
    );
  crc_in_crc_gen_crccalc_matrix_row28_xorq_q_357_182 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(26),
      ADR1 => crc_in_crc_gen_crccalc_prexored(8),
      ADR2 => crc_in_crc_gen_crccalc_prexored(2),
      O => crc_in_crc_gen_crccalc_matrix_row28_xorq_q_357
    );
  crc_in_crc_gen_crccalc_matrix_row28_xorq_q_360_183 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100_4,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q_369,
      ADR2 => crc_in_crc_gen_crccalc_prexored(5),
      ADR3 => crc_in_crc_gen_crccalc_prexored(6),
      O => crc_in_crc_gen_crccalc_matrix_row28_xorq_q_360
    );
  crc_in_crc_gen_crccalc_matrix_row28_xorq11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q110_5,
      ADR1 => crc_in_crc_gen_crccalc_prexored(27),
      O => crc_in_crc_gen_crccalc_matrix_q11_2
    );
  crc_in_crc_gen_crccalc_matrix_row29_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row29_xorq_q_492,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11_0,
      ADR2 => crc_in_crc_gen_crccalc_matrix_row29_xorq_q_489,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q100_5,
      O => crc_in_crc_gen_crc_calc(29)
    );
  crc_in_crc_gen_crccalc_matrix_row29_xorq_q_489_184 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(13),
      ADR1 => crc_in_crc_gen_crccalc_prexored(6),
      ADR2 => crc_in_crc_gen_crccalc_prexored(7),
      O => crc_in_crc_gen_crccalc_matrix_row29_xorq_q_489
    );
  crc_in_crc_gen_crccalc_matrix_row29_xorq_q_492_185 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100_3,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q101_1,
      ADR2 => crc_in_crc_gen_crccalc_prexored(9),
      ADR3 => crc_in_crc_gen_crccalc_prexored(3),
      O => crc_in_crc_gen_crccalc_matrix_row29_xorq_q_492
    );
  crc_in_crc_gen_crccalc_matrix_row29_xorq11_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_prexored(28),
      ADR1 => crc_in_crc_gen_crccalc_prexored(31),
      ADR2 => crc_in_crc_gen_crccalc_prexored(29),
      O => crc_in_crc_gen_crccalc_matrix_q11_0
    );
  crc_in_crc_gen_crccalc_matrix_row30_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row30_xorq_q_217,
      ADR1 => crc_in_crc_gen_crccalc_matrix_row30_xorq_q_215,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q101_2,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q110_1,
      O => crc_in_crc_gen_crc_calc(30)
    );
  crc_in_crc_gen_crccalc_matrix_row30_xorq_q_212 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_out(7),
      ADR1 => crc_in_data_wire(7),
      ADR2 => crc_in_crc_out(10),
      ADR3 => crc_in_data_wire(10),
      O => crc_in_crc_gen_crccalc_matrix_q011_1
    );
  crc_in_crc_gen_crccalc_matrix_row30_xorq_q_215_186 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q011_1,
      ADR1 => crc_in_crc_gen_crccalc_prexored(14),
      ADR2 => crc_in_crc_gen_crccalc_prexored(4),
      O => crc_in_crc_gen_crccalc_matrix_row30_xorq_q_215
    );
  crc_in_crc_gen_crccalc_matrix_row30_xorq_q_217_187 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q100_3,
      ADR1 => crc_in_crc_gen_crccalc_prexored(24),
      ADR2 => crc_in_crc_gen_crccalc_prexored(8),
      ADR3 => crc_in_crc_gen_crccalc_prexored(28),
      O => crc_in_crc_gen_crccalc_matrix_row30_xorq_q_217
    );
  crc_in_crc_gen_crccalc_matrix_row31_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_row31_xorq_q_378,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q11,
      ADR2 => crc_in_crc_gen_crccalc_matrix_q010_3,
      ADR3 => crc_in_crc_gen_crccalc_matrix_q000_2,
      O => crc_in_crc_gen_crc_calc(31)
    );
  crc_in_crc_gen_crccalc_matrix_row31_xorq_q_378_188 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q010_7,
      ADR1 => crc_in_crc_gen_crccalc_matrix_q110,
      ADR2 => crc_in_crc_gen_crccalc_prexored(25),
      ADR3 => crc_in_crc_gen_crccalc_prexored(15),
      O => crc_in_crc_gen_crccalc_matrix_row31_xorq_q_378
    );
  crc_in_crc_gen_crccalc_matrix_row31_xorq11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_in_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_in_crc_gen_crccalc_prexored(29),
      O => crc_in_crc_gen_crccalc_matrix_q11
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_0_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(0),
      ADR1 => crc_in_crc_out(0),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(0)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_1_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(1),
      ADR1 => crc_in_crc_out(1),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(1)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_2_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(2),
      ADR1 => crc_in_crc_out(2),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(2)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_3_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(3),
      ADR1 => crc_in_crc_out(3),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(3)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_4_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(4),
      ADR1 => crc_in_crc_out(4),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(4)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_5_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(5),
      ADR1 => crc_in_crc_out(5),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(5)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_6_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(6),
      ADR1 => crc_in_crc_out(6),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(6)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_7_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(7),
      ADR1 => crc_in_crc_out(7),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(7)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_8_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(8),
      ADR1 => crc_in_crc_out(8),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(8)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_9_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(9),
      ADR1 => crc_in_crc_out(9),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(9)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_10_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(10),
      ADR1 => crc_in_crc_out(10),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(10)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_11_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(11),
      ADR1 => crc_in_crc_out(11),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(11)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_12_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(12),
      ADR1 => crc_in_crc_out(12),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(12)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_13_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(13),
      ADR1 => crc_in_crc_out(13),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(13)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_14_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(14),
      ADR1 => crc_in_crc_out(14),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(14)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_15_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(15),
      ADR1 => crc_in_crc_out(15),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(15)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_16_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(16),
      ADR1 => crc_in_crc_out(16),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(16)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_17_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(17),
      ADR1 => crc_in_crc_out(17),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(17)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_18_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(18),
      ADR1 => crc_in_crc_out(18),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(18)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_19_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(19),
      ADR1 => crc_in_crc_out(19),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(19)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_20_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(20),
      ADR1 => crc_in_crc_out(20),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(20)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_21_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(21),
      ADR1 => crc_in_crc_out(21),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(21)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_22_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(22),
      ADR1 => crc_in_crc_out(22),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(22)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_23_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(23),
      ADR1 => crc_in_crc_out(23),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(23)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_24_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(24),
      ADR1 => crc_in_crc_out(24),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(24)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_25_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(25),
      ADR1 => crc_in_crc_out(25),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(25)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_26_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(26),
      ADR1 => crc_in_crc_out(26),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(26)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_27_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(27),
      ADR1 => crc_in_crc_out(27),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(27)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_28_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(28),
      ADR1 => crc_in_crc_out(28),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(28)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_29_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(29),
      ADR1 => crc_in_crc_out(29),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(29)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_30_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(30),
      ADR1 => crc_in_crc_out(30),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(30)
    );
  crc_in_crc_set_clk_copy_data_buf_3_0_xor2_31_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_in_data_wire(31),
      ADR1 => crc_in_crc_out(31),
      ADR2 => crc_in_crc_pos_wire,
      O => crc_in_crc_set_data_buf_3(31)
    );
  crc_in_crc_set_SOC_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_soc_wire,
      O => soc2,
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(18),
      O => data2(18),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(19),
      O => data2(19),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(20),
      O => data2(20),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(21),
      O => data2(21),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(22),
      O => data2(22),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(23),
      O => data2(23),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(24),
      O => data2(24),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(25),
      O => data2(25),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(26),
      O => data2(26),
      SRST => Reset_l_i_17,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(27),
      O => data2(27),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(28),
      O => data2(28),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(29),
      O => data2(29),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(30),
      O => data2(30),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(31),
      O => data2(31),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(3),
      O => data2(3),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(4),
      O => data2(4),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(5),
      O => data2(5),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(6),
      O => data2(6),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(7),
      O => data2(7),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(8),
      O => data2(8),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(9),
      O => data2(9),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(10),
      O => data2(10),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(11),
      O => data2(11),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(12),
      O => data2(12),
      SRST => Reset_l_i_18,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(13),
      O => data2(13),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(14),
      O => data2(14),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(15),
      O => data2(15),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(16),
      O => data2(16),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(17),
      O => data2(17),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(0),
      O => data2(0),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(1),
      O => data2(1),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_in_crc_set_D_OUT_MOD_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_in_crc_set_data_buf_3(2),
      O => data2(2),
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_un38_cell_buf_axb_1_189 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(3),
      O => data_enable_un38_cell_buf_axb_1,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_2_190 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(4),
      O => data_enable_un38_cell_buf_axb_2,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_3_191 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(5),
      O => data_enable_un38_cell_buf_axb_3,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_4_192 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(6),
      O => data_enable_un38_cell_buf_axb_4,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_5_193 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(7),
      O => data_enable_un38_cell_buf_axb_5,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_6_194 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(8),
      O => data_enable_un38_cell_buf_axb_6,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_7_195 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(9),
      O => data_enable_un38_cell_buf_axb_7,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_8_196 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(10),
      O => data_enable_un38_cell_buf_axb_8,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_9_197 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(11),
      O => data_enable_un38_cell_buf_axb_9,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_10_198 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(12),
      O => data_enable_un38_cell_buf_axb_10,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_11_199 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(13),
      O => data_enable_un38_cell_buf_axb_11,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_12_200 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(14),
      O => data_enable_un38_cell_buf_axb_12,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_13_201 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(15),
      O => data_enable_un38_cell_buf_axb_13,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_14_202 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(16),
      O => data_enable_un38_cell_buf_axb_14,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_15_203 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(17),
      O => data_enable_un38_cell_buf_axb_15,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_16_204 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(18),
      O => data_enable_un38_cell_buf_axb_16,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_17_205 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(19),
      O => data_enable_un38_cell_buf_axb_17,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_18_206 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(20),
      O => data_enable_un38_cell_buf_axb_18,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_19_207 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(21),
      O => data_enable_un38_cell_buf_axb_19,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_20_208 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(22),
      O => data_enable_un38_cell_buf_axb_20,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_21_209 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(23),
      O => data_enable_un38_cell_buf_axb_21,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_22_210 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(24),
      O => data_enable_un38_cell_buf_axb_22,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_23_211 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(25),
      O => data_enable_un38_cell_buf_axb_23,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_24_212 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(26),
      O => data_enable_un38_cell_buf_axb_24,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_25_213 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(27),
      O => data_enable_un38_cell_buf_axb_25,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_26_214 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(28),
      O => data_enable_un38_cell_buf_axb_26,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_27_215 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(29),
      O => data_enable_un38_cell_buf_axb_27,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_28_216 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(30),
      O => data_enable_un38_cell_buf_axb_28,
      ADR1 => GND
    );
  data_enable_N_1805_i_217 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_2_Q,
      O => data_enable_N_1805_i,
      ADR1 => GND
    );
  data_enable_N_1806_i_218 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_3_Q,
      O => data_enable_N_1806_i,
      ADR1 => GND
    );
  data_enable_N_1807_i_219 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_4_Q,
      O => data_enable_N_1807_i,
      ADR1 => GND
    );
  data_enable_N_1808_i_220 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_5_Q,
      O => data_enable_N_1808_i,
      ADR1 => GND
    );
  data_enable_N_1809_i_221 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_6_Q,
      O => data_enable_N_1809_i,
      ADR1 => GND
    );
  data_enable_N_1810_i_222 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_7_Q,
      O => data_enable_N_1810_i,
      ADR1 => GND
    );
  data_enable_N_1811_i_223 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_8_Q,
      O => data_enable_N_1811_i,
      ADR1 => GND
    );
  data_enable_N_1812_i_224 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_9_Q,
      O => data_enable_N_1812_i,
      ADR1 => GND
    );
  data_enable_N_1813_i_225 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_10_Q,
      O => data_enable_N_1813_i,
      ADR1 => GND
    );
  data_enable_N_1814_i_226 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_11_Q,
      O => data_enable_N_1814_i,
      ADR1 => GND
    );
  data_enable_N_1815_i_227 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_12_Q,
      O => data_enable_N_1815_i,
      ADR1 => GND
    );
  data_enable_N_1816_i_228 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_13_Q,
      O => data_enable_N_1816_i,
      ADR1 => GND
    );
  data_enable_N_1817_i_229 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_14_Q,
      O => data_enable_N_1817_i,
      ADR1 => GND
    );
  data_enable_N_1818_i_230 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_15_Q,
      O => data_enable_N_1818_i,
      ADR1 => GND
    );
  data_enable_N_1819_i_231 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_16_Q,
      O => data_enable_N_1819_i,
      ADR1 => GND
    );
  data_enable_N_1820_i_232 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_17_Q,
      O => data_enable_N_1820_i,
      ADR1 => GND
    );
  data_enable_N_1821_i_233 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_18_Q,
      O => data_enable_N_1821_i,
      ADR1 => GND
    );
  data_enable_N_1822_i_234 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_19_Q,
      O => data_enable_N_1822_i,
      ADR1 => GND
    );
  data_enable_N_1823_i_235 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_20_Q,
      O => data_enable_N_1823_i,
      ADR1 => GND
    );
  data_enable_N_1824_i_236 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_21_Q,
      O => data_enable_N_1824_i,
      ADR1 => GND
    );
  data_enable_N_1825_i_237 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_22_Q,
      O => data_enable_N_1825_i,
      ADR1 => GND
    );
  data_enable_N_1826_i_238 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_23_Q,
      O => data_enable_N_1826_i,
      ADR1 => GND
    );
  data_enable_N_1827_i_239 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_24_Q,
      O => data_enable_N_1827_i,
      ADR1 => GND
    );
  data_enable_N_1828_i_240 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_25_Q,
      O => data_enable_N_1828_i,
      ADR1 => GND
    );
  data_enable_N_1829_i_241 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_26_Q,
      O => data_enable_N_1829_i,
      ADR1 => GND
    );
  data_enable_N_1830_i_242 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_27_Q,
      O => data_enable_N_1830_i,
      ADR1 => GND
    );
  data_enable_N_1831_i_243 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_28_Q,
      O => data_enable_N_1831_i,
      ADR1 => GND
    );
  data_enable_N_1832_i_244 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_29_Q,
      O => data_enable_N_1832_i,
      ADR1 => GND
    );
  data_enable_N_1833_i_245 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_30_Q,
      O => data_enable_N_1833_i,
      ADR1 => GND
    );
  data_enable_data_in_i_0_Q : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_data_in(0),
      O => data_enable_data_in_i(0),
      ADR1 => GND
    );
  data_enable_data_in_i_1_Q : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => data_enable_data_in(1),
      O => data_enable_data_in_i(1),
      ADR1 => GND
    );
  data_enable_output_proc_un73_state_in_axb_2_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(2),
      ADR1 => data_enable_fwcount(0),
      O => data_enable_un73_state_in_axb_2_i
    );
  data_enable_output_proc_un73_state_in_axb_3_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(3),
      ADR1 => data_enable_fwcount(1),
      O => data_enable_un73_state_in_axb_3_i
    );
  data_enable_output_proc_un73_state_in_axb_4_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(4),
      ADR1 => data_enable_fwcount(2),
      O => data_enable_un73_state_in_axb_4_i
    );
  data_enable_output_proc_un73_state_in_axb_5_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(5),
      ADR1 => data_enable_fwcount(3),
      O => data_enable_un73_state_in_axb_5_i
    );
  data_enable_output_proc_un73_state_in_axb_6_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(6),
      ADR1 => data_enable_fwcount(4),
      O => data_enable_un73_state_in_axb_6_i
    );
  data_enable_output_proc_un73_state_in_axb_7_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(7),
      ADR1 => data_enable_fwcount(5),
      O => data_enable_un73_state_in_axb_7_i
    );
  data_enable_output_proc_un73_state_in_axb_8_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(8),
      ADR1 => data_enable_fwcount(6),
      O => data_enable_un73_state_in_axb_8_i
    );
  data_enable_output_proc_un73_state_in_axb_9_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(9),
      ADR1 => data_enable_fwcount(7),
      O => data_enable_un73_state_in_axb_9_i
    );
  data_enable_output_proc_un73_state_in_axb_10_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(10),
      ADR1 => data_enable_fwcount(8),
      O => data_enable_un73_state_in_axb_10_i
    );
  data_enable_output_proc_un73_state_in_axb_11_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(11),
      ADR1 => data_enable_fwcount(9),
      O => data_enable_un73_state_in_axb_11_i
    );
  data_enable_output_proc_un73_state_in_axb_12_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(12),
      ADR1 => data_enable_fwcount(10),
      O => data_enable_un73_state_in_axb_12_i
    );
  data_enable_output_proc_un73_state_in_axb_13_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(13),
      ADR1 => data_enable_fwcount(11),
      O => data_enable_un73_state_in_axb_13_i
    );
  data_enable_output_proc_un73_state_in_axb_14_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(14),
      ADR1 => data_enable_fwcount(12),
      O => data_enable_un73_state_in_axb_14_i
    );
  data_enable_output_proc_un73_state_in_axb_15_i : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => data_enable_data_in(15),
      ADR1 => data_enable_fwcount(13),
      O => data_enable_un73_state_in_axb_15_i
    );
  data_enable_fwcount_qxu_0_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_VCC,
      ADR2 => data_enable_fwcount(0),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(0)
    );
  data_enable_fwcount_qxu_1_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(1),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(1)
    );
  data_enable_fwcount_qxu_2_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(2),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(2)
    );
  data_enable_fwcount_qxu_3_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(3),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(3)
    );
  data_enable_fwcount_qxu_4_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(4),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(4)
    );
  data_enable_fwcount_qxu_5_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(5),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(5)
    );
  data_enable_fwcount_qxu_6_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(6),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(6)
    );
  data_enable_fwcount_qxu_7_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(7),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(7)
    );
  data_enable_fwcount_qxu_8_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(8),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(8)
    );
  data_enable_fwcount_qxu_9_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(9),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(9)
    );
  data_enable_fwcount_qxu_10_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(10),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(10)
    );
  data_enable_fwcount_qxu_11_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(11),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(11)
    );
  data_enable_fwcount_qxu_12_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(12),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(12)
    );
  data_enable_cell_buf_11_20_Q_246 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_11_20_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_21_Q_247 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_11_21_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_22_Q_248 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_11_22_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_23_Q_249 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_11_23_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_24_Q_250 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_11_24_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_25_Q_251 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_11_25_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_26_Q_252 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_11_26_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_27_Q_253 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_11_27_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_28_Q_254 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_11_28_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_29_Q_255 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_11_29_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_30_Q_256 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_11_30_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_31_Q_257 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_11_31_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_5_Q_258 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_11_5_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_6_Q_259 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_11_6_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_7_Q_260 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_11_7_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_8_Q_261 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_11_8_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_9_Q_262 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_11_9_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_10_Q_263 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_11_10_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_11_Q_264 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_11_11_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_12_Q_265 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_11_12_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_13_Q_266 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_11_13_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_14_Q_267 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_11_14_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_15_Q_268 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_11_15_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_16_Q_269 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_11_16_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_17_Q_270 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_11_17_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_18_Q_271 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_11_18_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_19_Q_272 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_11_19_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_22_Q_273 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_N_7376,
      O => data_enable_cell_buf_10_22_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_23_Q_274 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6113,
      O => data_enable_cell_buf_10_23_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_24_Q_275 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6114,
      O => data_enable_cell_buf_10_24_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_25_Q_276 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6115,
      O => data_enable_cell_buf_10_25_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_26_Q_277 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6116,
      O => data_enable_cell_buf_10_26_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_27_Q_278 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6117,
      O => data_enable_cell_buf_10_27_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_28_Q_279 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6118,
      O => data_enable_cell_buf_10_28_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_29_Q_280 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6119,
      O => data_enable_cell_buf_10_29_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_30_Q_281 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6120,
      O => data_enable_cell_buf_10_30_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_31_Q_282 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6121,
      O => data_enable_cell_buf_10_31_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_0_Q_283 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_11_0_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_1_Q_284 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_11_1_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_2_Q_285 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_11_2_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_3_Q_286 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_11_3_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_11_4_Q_287 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_11_4_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_7_Q_288 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6097,
      O => data_enable_cell_buf_10_7_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_8_Q_289 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6098,
      O => data_enable_cell_buf_10_8_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_9_Q_290 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6099,
      O => data_enable_cell_buf_10_9_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_10_Q_291 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6100,
      O => data_enable_cell_buf_10_10_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_11_Q_292 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6101,
      O => data_enable_cell_buf_10_11_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_12_Q_293 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6102,
      O => data_enable_cell_buf_10_12_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_13_Q_294 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6103,
      O => data_enable_cell_buf_10_13_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_14_Q_295 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6104,
      O => data_enable_cell_buf_10_14_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_15_Q_296 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6105,
      O => data_enable_cell_buf_10_15_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_16_Q_297 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6106,
      O => data_enable_cell_buf_10_16_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_17_Q_298 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6107,
      O => data_enable_cell_buf_10_17_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_18_Q_299 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6108,
      O => data_enable_cell_buf_10_18_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_19_Q_300 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6109,
      O => data_enable_cell_buf_10_19_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_20_Q_301 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6110,
      O => data_enable_cell_buf_10_20_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_21_Q_302 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6111,
      O => data_enable_cell_buf_10_21_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(24),
      O => data_enable_data_in(24),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(25),
      O => data_enable_data_in(25),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(26),
      O => data_enable_data_in(26),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(27),
      O => data_enable_data_in(27),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(28),
      O => data_enable_data_in(28),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(29),
      O => data_enable_data_in(29),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(30),
      O => data_enable_data_in(30),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(31),
      O => data_enable_data_in(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_0_Q_303 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_cell_buf_10_4(0),
      O => data_enable_cell_buf_10_0_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_1_Q_304 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_cell_buf_10_4(1),
      O => data_enable_cell_buf_10_1_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_2_Q_305 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_N_7345_i,
      O => data_enable_cell_buf_10_2_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_3_Q_306 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6093,
      O => data_enable_cell_buf_10_3_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_4_Q_307 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6094,
      O => data_enable_cell_buf_10_4_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_5_Q_308 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6095,
      O => data_enable_cell_buf_10_5_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_10_6_Q_309 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0,
      CLK => CLK,
      I => data_enable_G_6096,
      O => data_enable_cell_buf_10_6_Q,
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(9),
      O => data_enable_data_in(9),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(10),
      O => data_enable_data_in(10),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(11),
      O => data_enable_data_in(11),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(12),
      O => data_enable_data_in(12),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(13),
      O => data_enable_data_in(13),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(14),
      O => data_enable_data_in(14),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(15),
      O => data_enable_data_in(15),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(16),
      O => data_enable_data_in(16),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(17),
      O => data_enable_data_in(17),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(18),
      O => data_enable_data_in(18),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(19),
      O => data_enable_data_in(19),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(20),
      O => data_enable_data_in(20),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(21),
      O => data_enable_data_in(21),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_0,
      CLK => CLK,
      I => data2(22),
      O => data_enable_data_in(22),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(23),
      O => data_enable_data_in(23),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_delay_word1(28),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_delay_word1(29),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_delay_word1(30),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_delay_word1(31),
      SET => GND,
      RST => GSR
    );
  data_enable_byte_count_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in_4_Q,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_byte_count(0),
      SET => GND,
      RST => GSR
    );
  data_enable_byte_count_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in_4_Q,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_byte_count_0(1),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(0),
      O => data_enable_data_in(0),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(1),
      O => data_enable_data_in(1),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(2),
      O => data_enable_data_in(2),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(3),
      O => data_enable_data_in(3),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(4),
      O => data_enable_data_in(4),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(5),
      O => data_enable_data_in(5),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(6),
      O => data_enable_data_in(6),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(7),
      O => data_enable_data_in(7),
      SET => GND,
      RST => GSR
    );
  data_enable_data_in_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => Reset_l_1,
      CLK => CLK,
      I => data2(8),
      O => data_enable_data_in(8),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_delay_word1(13),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_delay_word1(14),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_delay_word1(15),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_delay_word1(16),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_delay_word1(17),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_delay_word1(18),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_delay_word1(19),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_delay_word1(20),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_delay_word1(21),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_delay_word1(22),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_delay_word1(23),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_delay_word1(24),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_delay_word1(25),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_delay_word1(26),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_delay_word1(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_0(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_0(31),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_delay_word1(0),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_delay_word1(1),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_delay_word1(2),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_delay_word1(3),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_delay_word1(4),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_delay_word1(5),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_delay_word1(6),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_delay_word1(7),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_delay_word1(8),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_delay_word1(9),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_delay_word1(10),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_delay_word1(11),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word1_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_state_in(1),
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_delay_word1(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_0(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_0(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_0(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_0(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_0(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_0(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_0(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_0(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_0(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_0(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_0(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_0(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_0(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_0(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_0(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_0(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_0(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_0(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_0(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_0(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_0(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_0(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_0(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_0(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_0(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_0(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_0(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_0(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_0(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_0_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_9_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_0(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_1(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_1(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_1(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_1(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_1(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_1(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_1(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_1(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_1(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_1(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_1(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_1(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_1(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_1(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_1(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_1(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_1(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_1(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_1(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_1(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_1(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_1(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_1(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_1(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_1(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_1(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_1(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_1(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_1(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_1(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_2(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_2(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_2(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_2(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_2(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_2(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_2(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_2(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_2(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_2(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_2(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_2(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_2(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_1(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_1_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_7_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_1(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_2(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_2(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_2(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_2(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_2(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_2(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_2(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_2(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_2(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_2(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_2(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_2(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_2(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_2(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_2(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_3(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_3(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_3(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_3(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_3(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_3(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_3(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_3(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_3(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_3(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_3(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_2(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_2(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_2(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_2_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_6_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_2(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_3(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_3(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_3(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_3(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_3(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_3(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_3(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_3(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_3(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_3(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_3(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_3(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_3(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_3(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_3(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_4(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_4(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_4(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_4(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_4(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_4(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_4(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_4(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_4(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_3(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_3(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_3(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_3(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_3(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_3_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_3_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_3(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_4(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_4(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_4(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_4(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_4(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_4(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_4(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_4(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_4(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_4(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_4(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_4(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_4(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_4(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_4(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_5(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_5(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_5(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_5(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_5(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_5(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_5(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_4(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_4(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_4(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_4(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_4(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_4(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_4(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_4_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_4_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_4(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_5(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_5(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_5(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_5(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_5(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_5(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_5(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_5(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_5(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_5(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_5(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_5(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_5(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_5(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_5(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_6(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_6(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_6(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_6(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_6(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_5(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_5(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_5(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_5(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_5(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_5(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_5(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_5(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_5(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_5_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_5_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_5(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_6(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_6(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_6(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_6(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_6(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_6(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_6(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_6(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_6(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_6(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_6(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_6(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_6(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_6(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_6(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_7(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_7(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_7(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_6(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_6(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_6(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_6(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_6(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_6(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_6(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_6(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_6(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_6(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_6(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_6_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_10_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_6(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_7(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_7(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_7(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_7(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_7(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_7(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_7(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_7(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_7(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_7(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_7(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_7(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_7(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_7(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_7(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_8(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_7(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_7(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_7(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_7(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_7(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_7(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_7(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_7(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_7(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_7(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_7(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_7(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_7(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_7_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_2_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_7(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_8(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_8(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_8(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_8(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_8(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_8(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_8(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_8(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_8(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_8(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_8(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_8(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_8(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_8(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_8(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_8(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_8(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_8(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_8(4),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_8(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_8(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_8(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_8(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_8(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_8(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_8(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_8(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_8(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_8(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_8(15),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_delay_word0(18),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_delay_word0(19),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_delay_word0(20),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_delay_word0(21),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_delay_word0(22),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_delay_word0(23),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_delay_word0(24),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_delay_word0(25),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_delay_word0(26),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_delay_word0(27),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_delay_word0(28),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_delay_word0(29),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_delay_word0(30),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_delay_word0(31),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_8_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_8_0_and2_0_and2_0_and2,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_8(0),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_delay_word0(3),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_delay_word0(4),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_delay_word0(5),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_delay_word0(6),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_delay_word0(7),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_delay_word0(8),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_delay_word0(9),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_delay_word0(10),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_delay_word0(11),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_delay_word0(12),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_delay_word0(13),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_delay_word0(14),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_delay_word0(15),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_delay_word0(16),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_delay_word0(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_20_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(20),
      O => data_enable_cell_buf_9(20),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_21_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(21),
      O => data_enable_cell_buf_9(21),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_22_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(22),
      O => data_enable_cell_buf_9(22),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_23_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(23),
      O => data_enable_cell_buf_9(23),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_24_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(24),
      O => data_enable_cell_buf_9(24),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_25_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(25),
      O => data_enable_cell_buf_9(25),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_26_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(26),
      O => data_enable_cell_buf_9(26),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_27_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(27),
      O => data_enable_cell_buf_9(27),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_28_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(28),
      O => data_enable_cell_buf_9(28),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_29_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(29),
      O => data_enable_cell_buf_9(29),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_30_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(30),
      O => data_enable_cell_buf_9(30),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_31_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(31),
      O => data_enable_cell_buf_9(31),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_delay_word0_1(0),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_delay_word0_1(1),
      SET => GND,
      RST => GSR
    );
  data_enable_delay_word0_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_un1_state_in_11_0_0_0,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_delay_word0(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(5),
      O => data_enable_cell_buf_9(5),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(6),
      O => data_enable_cell_buf_9(6),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(7),
      O => data_enable_cell_buf_9(7),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(8),
      O => data_enable_cell_buf_9(8),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(9),
      O => data_enable_cell_buf_9(9),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(10),
      O => data_enable_cell_buf_9(10),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(11),
      O => data_enable_cell_buf_9(11),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(12),
      O => data_enable_cell_buf_9(12),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(13),
      O => data_enable_cell_buf_9(13),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_14_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(14),
      O => data_enable_cell_buf_9(14),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_15_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(15),
      O => data_enable_cell_buf_9(15),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_16_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(16),
      O => data_enable_cell_buf_9(16),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_17_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(17),
      O => data_enable_cell_buf_9(17),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_18_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(18),
      O => data_enable_cell_buf_9(18),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_19_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(19),
      O => data_enable_cell_buf_9(19),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(0),
      O => data_enable_cell_buf_9(0),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(1),
      O => data_enable_cell_buf_9(1),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(2),
      O => data_enable_cell_buf_9(2),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(3),
      O => data_enable_cell_buf_9(3),
      SET => GND,
      RST => GSR
    );
  data_enable_cell_buf_9_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_5564,
      CLK => CLK,
      I => data_enable_data_in(4),
      O => data_enable_cell_buf_9(4),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(0),
      O => data_enable_fwcount(0),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(1),
      O => data_enable_fwcount(1),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(2),
      O => data_enable_fwcount(2),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(3),
      O => data_enable_fwcount(3),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(4),
      O => data_enable_fwcount(4),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(5),
      O => data_enable_fwcount(5),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(6),
      O => data_enable_fwcount(6),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(7),
      O => data_enable_fwcount(7),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(8),
      O => data_enable_fwcount(8),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(9),
      O => data_enable_fwcount(9),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(10),
      O => data_enable_fwcount(10),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(11),
      O => data_enable_fwcount(11),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(12),
      O => data_enable_fwcount(12),
      SET => GND,
      RST => GSR
    );
  data_enable_fwcount_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_G_6_0_0_0,
      CLK => CLK,
      I => data_enable_fwcount_s(13),
      O => data_enable_fwcount(13),
      SET => GND,
      RST => GSR
    );
  data_enable_N_1834_i_310 : X_INV
    port map (
      I => data_enable_cell_buf_10_31_Q,
      O => data_enable_N_1834_i
    );
  data_enable_G_5494_G_6_rep1 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => data_enable_state_out_5_rep1,
      ADR1 => Reset_l_1,
      ADR2 => data_enable_lc_copy,
      ADR3 => data_enable_buf_copy,
      O => data_enable_N_7980_rep1
    );
  data_enable_G_5494_G_6_fast : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => data_enable_state_out_5_rep1,
      ADR1 => Reset_l_1,
      ADR2 => data_enable_lc_copy,
      ADR3 => data_enable_buf_copy,
      O => data_enable_N_7980_fast
    );
  data_enable_G_6027_fast_311 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => data_enable_N_7963,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => Reset_l_i_5,
      O => data_enable_G_6027_fast
    );
  data_enable_G_5497_rep1 : X_LUT4
    generic map(
      INIT => X"2220"
    )
    port map (
      ADR0 => data_enable_N_7977,
      ADR1 => Reset_l_i_6,
      ADR2 => data_enable_byte_count_0(1),
      ADR3 => data_enable_byte_count(0),
      O => data_enable_N_7982_rep1
    );
  data_enable_G_5497_fast : X_LUT4
    generic map(
      INIT => X"2220"
    )
    port map (
      ADR0 => data_enable_N_7977,
      ADR1 => Reset_l_i_6,
      ADR2 => data_enable_byte_count_0(1),
      ADR3 => data_enable_byte_count(0),
      O => data_enable_N_7982_fast
    );
  data_enable_G_6032_rep1 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => data_enable_N_7969,
      ADR1 => data_enable_N_8046,
      ADR2 => data_enable_N_7967,
      ADR3 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7296_rep1
    );
  data_enable_G_6032_fast : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => data_enable_N_7969,
      ADR1 => data_enable_N_8046,
      ADR2 => data_enable_N_7967,
      ADR3 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7296_fast
    );
  data_enable_G_5485_rep1 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_3_Q,
      O => data_enable_N_7971_rep1
    );
  data_enable_G_5485_fast : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_3_Q,
      O => data_enable_N_7971_fast
    );
  data_enable_G_6027_1_fast : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => data_enable_N_7963,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => Reset_l_i_31,
      O => G_6027_1_fast
    );
  data_enable_G_5493_rep2 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => data_enable_state_out_0_Q,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_2_Q,
      ADR3 => Reset_l_i_5,
      O => data_enable_N_7979_rep2
    );
  data_enable_G_5493_rep1 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => data_enable_state_out_0_Q,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_2_Q,
      ADR3 => Reset_l_i_5,
      O => data_enable_N_7979_rep1
    );
  data_enable_G_5493_fast : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => data_enable_state_out_0_Q,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_2_Q,
      ADR3 => Reset_l_i_5,
      O => data_enable_N_7979_fast
    );
  data_enable_G_5492_G_4_rep1 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => data_enable_G_4_11,
      ADR1 => data_enable_state_out_5_rep1,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => data_enable_state_out_1_Q,
      O => data_enable_N_7978_rep1
    );
  data_enable_G_5492_G_4_fast : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => data_enable_G_4_11,
      ADR1 => data_enable_state_out_5_rep1,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => data_enable_state_out_1_Q,
      O => data_enable_N_7978_fast
    );
  data_enable_G_5496_rep1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_N_7974,
      O => data_enable_N_7981_rep1
    );
  data_enable_G_5496_fast : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_N_7974,
      O => data_enable_N_7981_fast
    );
  data_enable_G_5499_fast_312 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(1),
      ADR1 => data_enable_N_7972_1,
      O => data_enable_G_5499_fast
    );
  data_enable_G_5494_G_6 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => data_enable_state_out_5_rep1,
      ADR1 => Reset_l_1,
      ADR2 => data_enable_lc_copy,
      ADR3 => data_enable_buf_copy,
      O => data_enable_N_7980
    );
  data_enable_G_6089_G_1 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => data_enable_state_out_3_Q,
      ADR1 => data_enable_state_out_4_Q,
      O => data_enable_N_7353
    );
  data_enable_G_5490_G_7 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => data_enable_state_out_5_Q,
      ADR1 => data_enable_state_out_2_Q,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => data_enable_state_out_1_Q,
      O => data_enable_N_7976
    );
  data_enable_G_5492_G_4 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => data_enable_G_4_11,
      ADR1 => data_enable_state_out_5_rep1,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => data_enable_state_out_1_Q,
      O => data_enable_N_7978
    );
  data_enable_G_5492_G_2_7 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => data_enable_state_out_6_Q,
      ADR1 => data_enable_state_out_3_Q,
      O => data_enable_G_2_7
    );
  data_enable_G_5492_G_4_11 : X_LUT4
    generic map(
      INIT => X"00E0"
    )
    port map (
      ADR0 => data_enable_G_2_7,
      ADR1 => data_enable_state_out_4_Q,
      ADR2 => Reset_l_1,
      ADR3 => data_enable_state_out_2_Q,
      O => data_enable_G_4_11
    );
  data_enable_G_5487_G_2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => data_enable_state_out_fast(5),
      O => data_enable_N_7973
    );
  data_enable_G_5480_G_4 : X_LUT4
    generic map(
      INIT => X"8880"
    )
    port map (
      ADR0 => data_enable_G_4_4,
      ADR1 => data_enable_state_out_5_rep1,
      ADR2 => data_enable_lc_copy,
      ADR3 => data_enable_buf_copy,
      O => data_enable_N_7967
    );
  data_enable_G_5480_G_4_4 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_cwcount_out(2),
      ADR1 => Reset_l_1,
      O => data_enable_G_4_4
    );
  data_enable_G_5486_1 : X_LUT4
    generic map(
      INIT => X"8880"
    )
    port map (
      ADR0 => data_enable_N_7973,
      ADR1 => data_enable_cwcount_out(2),
      ADR2 => data_enable_buf_copy,
      ADR3 => data_enable_lc_copy,
      O => data_enable_N_7972_1
    );
  data_enable_G_6027_1 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => data_enable_N_7963,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => Reset_l_i_31,
      O => data_enable_N_7291_1
    );
  data_enable_cwcount_out_1_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4687_i,
      O => data_enable_cwcount_out_1(1),
      SRST => Reset_l_i_31,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_4_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4689_i,
      O => data_enable_cwcount_out_4(0),
      SRST => Reset_l_i_31,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_3_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4689_i,
      O => data_enable_cwcount_out_3(0),
      SRST => Reset_l_i_31,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_2_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4689_i,
      O => data_enable_cwcount_out_2(0),
      SRST => Reset_l_i_31,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_1_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4689_i,
      O => data_enable_cwcount_out_1(0),
      SRST => Reset_l_i_31,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_un38_cell_buf_axb_0 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(2),
      O => data_enable_un38_cell_buf_cry_0,
      ADR1 => GND
    );
  data_enable_un38_cell_buf_axb_29_313 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => data_enable_data_in(31),
      O => data_enable_un38_cell_buf_axb_29,
      ADR1 => GND
    );
  data_enable_G_5486 : X_LUT4
    generic map(
      INIT => X"8880"
    )
    port map (
      ADR0 => data_enable_N_7973,
      ADR1 => data_enable_cwcount_out(2),
      ADR2 => data_enable_buf_copy,
      ADR3 => data_enable_lc_copy,
      O => data_enable_N_7972
    );
  data_enable_G_6056 : X_MUX2
    port map (
      IA => data_enable_G_6056_am,
      IB => data_enable_G_6056_bm,
      O => data_enable_N_7320,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6056_bm_314 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_3(1),
      ADR2 => data_enable_cell_buf_2(1),
      O => data_enable_G_6056_bm
    );
  data_enable_G_6056_am_315 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_1(1),
      ADR2 => data_enable_cell_buf_0(1),
      O => data_enable_G_6056_am
    );
  data_enable_G_6060 : X_MUX2
    port map (
      IA => data_enable_G_6060_am,
      IB => data_enable_G_6060_bm,
      O => data_enable_N_7324,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6060_bm_316 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_7(1),
      ADR2 => data_enable_cell_buf_6(1),
      O => data_enable_G_6060_bm
    );
  data_enable_G_6060_am_317 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_5(1),
      ADR2 => data_enable_cell_buf_4(1),
      O => data_enable_G_6060_am
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_4_1_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7980_rep1,
      ADR1 => data_enable_data_in(1),
      O => data_enable_N_7793
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_1_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7978,
      ADR1 => data_enable_delay_word0_1(1),
      O => data_enable_N_7796
    );
  data_enable_G_6_0_0_0_or2 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => data_enable_state_out_2_Q,
      ADR1 => data_enable_state_out_6_Q,
      O => G_6_0_0_0_or2
    );
  data_enable_G_5512 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_state_in_4_Q,
      ADR1 => data_enable_state_out_3_Q,
      O => data_enable_N_7997
    );
  data_enable_G_6055 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_10_1_Q,
      ADR1 => data_enable_cell_buf_11_1_Q,
      ADR2 => data_enable_cwcount_out_4(0),
      O => data_enable_N_7319
    );
  data_enable_G_5565 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cwcount_out(2),
      ADR2 => data_enable_cwcount_out_3_Q,
      ADR3 => data_enable_cwcount_out_1(1),
      O => data_enable_N_8049
    );
  data_enable_G_5491 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => data_enable_state_out_1_Q,
      ADR1 => data_enable_state_out_5_rep1,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => data_enable_state_out_2_Q,
      O => data_enable_N_7977
    );
  data_enable_G_5564_318 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => N_1014_3,
      ADR1 => N_1014_2,
      ADR2 => data_enable_cwcount_in(3),
      O => data_enable_G_5564
    );
  data_enable_un1_state_in_11_0_0_0_319 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => data_enable_state_in(2),
      ADR1 => data_enable_state_in_7_Q,
      ADR2 => data_enable_soc_in,
      O => data_enable_un1_state_in_11_0_0_0
    );
  data_enable_un1_un1_un2_cell_buf_11_i_0_0_0_320 : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => data_enable_N_7760,
      ADR1 => data_enable_state_in_3_Q,
      ADR2 => data_enable_state_in_5_Q,
      O => data_enable_un1_un1_un2_cell_buf_11_i_0_0_0
    );
  data_enable_un1_un1_un5_cell_buf_10_i_0_0_0_321 : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => data_enable_N_7762,
      ADR1 => data_enable_state_in_4_Q,
      ADR2 => data_enable_state_in_5_Q,
      O => data_enable_un1_un1_un5_cell_buf_10_i_0_0_0
    );
  data_enable_un1_state_in_11_0_0_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_state_in_7_Q,
      O => data_enable_N_7586
    );
  data_enable_un1_state_in_8_0_and2_0_and2_0_and2_322 : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => N_1014_2,
      ADR1 => data_enable_cwcount_in(3),
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(0),
      O => data_enable_un1_state_in_8_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_10_0_and2_0_and2_0_and2_323 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => data_enable_cwcount_in(0),
      ADR1 => data_enable_N_8044,
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(3),
      O => data_enable_un1_state_in_10_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_6_0_and2_0_and2_0_and2_324 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => data_enable_cwcount_in(0),
      ADR1 => N_1014_2,
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(3),
      O => data_enable_un1_state_in_6_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_3_0_and2_0_and2_0_and2_325 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => data_enable_cwcount_in(0),
      ADR1 => N_1014_2,
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(3),
      O => data_enable_un1_state_in_3_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_2_0_and2_0_and2_0_and2_326 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => data_enable_cwcount_in(0),
      ADR1 => data_enable_N_8044,
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(3),
      O => data_enable_un1_state_in_2_0_and2_0_and2_0_and2
    );
  data_enable_G_5499 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(1),
      ADR1 => data_enable_N_7972_1,
      O => data_enable_N_7984
    );
  data_enable_G_5500 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(1),
      ADR1 => data_enable_N_7972_1,
      O => data_enable_N_7985
    );
  data_enable_G_6298 : X_MUX2
    port map (
      IA => data_enable_G_6298_am,
      IB => data_enable_G_6298_bm,
      O => data_enable_N_7562,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6298_bm_327 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_3(0),
      ADR2 => data_enable_cell_buf_2(0),
      O => data_enable_G_6298_bm
    );
  data_enable_G_6298_am_328 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_1(0),
      ADR2 => data_enable_cell_buf_0(0),
      O => data_enable_G_6298_am
    );
  data_enable_G_6315 : X_MUX2
    port map (
      IA => data_enable_G_6315_am,
      IB => data_enable_G_6315_bm,
      O => data_enable_N_7579,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6315_bm_329 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_7(0),
      ADR2 => data_enable_cell_buf_6(0),
      O => data_enable_G_6315_bm
    );
  data_enable_G_6315_am_330 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_4(0),
      ADR1 => data_enable_cell_buf_5(0),
      ADR2 => data_enable_cell_buf_4(0),
      O => data_enable_G_6315_am
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_0_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_0_Q,
      O => data_enable_N_7766
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_4_0_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_9(0),
      ADR3 => data_enable_cell_buf_8(0),
      O => data_enable_N_7771
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_6_0_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7978_rep1,
      ADR1 => data_enable_delay_word0_1(0),
      O => data_enable_N_7773
    );
  data_enable_G_6018 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_buf_flag,
      ADR1 => data_enable_state_out_4_Q,
      O => data_enable_N_8502
    );
  data_enable_un1_un1_un1_un79_state_out_0_and2_i_0 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_N_7745,
      ADR2 => G_6_0_0_0_or2,
      O => data_enable_N_4702
    );
  data_enable_un1_reset_l_3_0_and2_0_and2_i : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => data_enable_soc_in,
      O => data_enable_N_6888
    );
  data_enable_G_6051 : X_LUT2
    generic map(
      INIT => X"D"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_data_in(1),
      O => data_enable_N_7315
    );
  data_enable_G_5560 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_state_in_5_Q,
      ADR1 => data_enable_cwcount_in(2),
      O => data_enable_N_8044
    );
  data_enable_un1_reset_l_6_0_and2_i_0 : X_LUT3
    generic map(
      INIT => X"FD"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => data_enable_state_out_6_Q,
      ADR2 => data_enable_state_out_2_Q,
      O => data_enable_N_4682
    );
  data_enable_G_6112 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(22),
      ADR1 => data_enable_un38_cell_buf_s_20,
      ADR2 => data_enable_N_7290,
      O => data_enable_N_7376
    );
  data_enable_save_data_proc_cell_buf_10_4_0_and2_0_and2_0_and2_1_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_state_in_5_Q,
      ADR1 => data_enable_data_in(1),
      O => data_enable_cell_buf_10_4(1)
    );
  data_enable_G_5493 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => data_enable_state_out_0_Q,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_2_Q,
      ADR3 => Reset_l_i_5,
      O => data_enable_N_7979
    );
  data_enable_G_6012 : X_LUT4
    generic map(
      INIT => X"2220"
    )
    port map (
      ADR0 => data_enable_state_out_5_Q,
      ADR1 => Reset_l_i_5,
      ADR2 => data_enable_buf_copy,
      ADR3 => data_enable_lc_copy,
      O => data_enable_N_8496
    );
  data_enable_G_6_0_0_0_and2 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => data_enable_state_out_4_Q,
      ADR1 => data_enable_buf_flag,
      ADR2 => data_enable_lc_flag,
      O => data_enable_N_7734
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_331 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => data_enable_un6_lc_copy_NE_11,
      ADR1 => data_enable_un6_lc_copy_NE_7,
      ADR2 => data_enable_un6_lc_copy_NE_6,
      ADR3 => data_enable_un6_lc_copy_NE_5,
      O => data_enable_out_sm_proc_un6_lc_copy_NE
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_11 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => data_enable_un6_lc_copy_NE_2,
      ADR1 => data_enable_un6_lc_copy_NE_1,
      ADR2 => data_enable_un6_lc_copy_NE_4,
      ADR3 => data_enable_un6_lc_copy_NE_3,
      O => data_enable_un6_lc_copy_NE_11
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_7 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(12),
      ADR1 => data_enable_cell_buf_10_14_Q,
      ADR2 => data_enable_fwcount(13),
      ADR3 => data_enable_cell_buf_10_15_Q,
      O => data_enable_un6_lc_copy_NE_7
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_6 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(10),
      ADR1 => data_enable_cell_buf_10_12_Q,
      ADR2 => data_enable_fwcount(11),
      ADR3 => data_enable_cell_buf_10_13_Q,
      O => data_enable_un6_lc_copy_NE_6
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_5 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(8),
      ADR1 => data_enable_cell_buf_10_10_Q,
      ADR2 => data_enable_fwcount(9),
      ADR3 => data_enable_cell_buf_10_11_Q,
      O => data_enable_un6_lc_copy_NE_5
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_4 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(5),
      ADR1 => data_enable_cell_buf_10_7_Q,
      ADR2 => data_enable_fwcount(6),
      ADR3 => data_enable_cell_buf_10_8_Q,
      O => data_enable_un6_lc_copy_NE_4
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_3 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(4),
      ADR1 => data_enable_cell_buf_10_6_Q,
      ADR2 => data_enable_fwcount(7),
      ADR3 => data_enable_cell_buf_10_9_Q,
      O => data_enable_un6_lc_copy_NE_3
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_2 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(2),
      ADR1 => data_enable_cell_buf_10_4_Q,
      ADR2 => data_enable_fwcount(3),
      ADR3 => data_enable_cell_buf_10_5_Q,
      O => data_enable_un6_lc_copy_NE_2
    );
  data_enable_out_sm_proc_un6_lc_copy_NE_1 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => data_enable_fwcount(0),
      ADR1 => data_enable_cell_buf_10_2_Q,
      ADR2 => data_enable_fwcount(1),
      ADR3 => data_enable_cell_buf_10_3_Q,
      O => data_enable_un6_lc_copy_NE_1
    );
  data_enable_G_5476 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => data_enable_N_8046,
      ADR1 => data_enable_N_7967,
      ADR2 => data_enable_cwcount_out_4(0),
      O => data_enable_N_7963
    );
  data_enable_save_data_proc_cell_buf_10_4_0_and2_0_and2_0_and2_0_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_state_in_5_Q,
      ADR1 => data_enable_data_in(0),
      O => data_enable_cell_buf_10_4(0)
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_30_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_1(30),
      ADR3 => data_enable_cell_buf_0(30),
      O => data_enable_N_7948
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_30_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_rep1,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_9(30),
      ADR3 => data_enable_cell_buf_8(30),
      O => data_enable_N_7946
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_30_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(30),
      ADR3 => data_enable_cell_buf_4(30),
      O => data_enable_N_7943
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_30_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_7(30),
      ADR3 => data_enable_cell_buf_6(30),
      O => data_enable_N_7942
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_30_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_30_Q,
      O => data_enable_N_7940
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_19_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7984,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(19),
      ADR3 => data_enable_cell_buf_4(19),
      O => data_enable_N_7932
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_19_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_7(19),
      ADR3 => data_enable_cell_buf_6(19),
      O => data_enable_N_7931
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_18_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7984,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(18),
      ADR3 => data_enable_cell_buf_4(18),
      O => data_enable_N_7921
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_18_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_7(18),
      ADR3 => data_enable_cell_buf_6(18),
      O => data_enable_N_7920
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_17_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7984,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(17),
      ADR3 => data_enable_cell_buf_4(17),
      O => data_enable_N_7910
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_17_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_7(17),
      ADR3 => data_enable_cell_buf_6(17),
      O => data_enable_N_7909
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_16_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_1(16),
      ADR3 => data_enable_cell_buf_0(16),
      O => data_enable_N_7904
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_16_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_rep1,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_9(16),
      ADR3 => data_enable_cell_buf_8(16),
      O => data_enable_N_7902
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_16_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(16),
      ADR3 => data_enable_cell_buf_4(16),
      O => data_enable_N_7899
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_16_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_7(16),
      ADR3 => data_enable_cell_buf_6(16),
      O => data_enable_N_7898
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_16_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_16_Q,
      O => data_enable_N_7896
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_15_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_1(15),
      ADR3 => data_enable_cell_buf_0(15),
      O => data_enable_N_7893
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_15_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_rep1,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_9(15),
      ADR3 => data_enable_cell_buf_8(15),
      O => data_enable_N_7891
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_15_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(15),
      ADR3 => data_enable_cell_buf_4(15),
      O => data_enable_N_7888
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_15_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_7(15),
      ADR3 => data_enable_cell_buf_6(15),
      O => data_enable_N_7887
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_15_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_15_Q,
      O => data_enable_N_7885
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_14_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_1(14),
      ADR3 => data_enable_cell_buf_0(14),
      O => data_enable_N_7882
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_14_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_rep1,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_9(14),
      ADR3 => data_enable_cell_buf_8(14),
      O => data_enable_N_7880
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_14_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_4(0),
      ADR2 => data_enable_cell_buf_5(14),
      ADR3 => data_enable_cell_buf_4(14),
      O => data_enable_N_7877
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_14_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(14),
      ADR3 => data_enable_cell_buf_6(14),
      O => data_enable_N_7876
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_14_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_14_Q,
      O => data_enable_N_7874
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_13_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_1(13),
      ADR3 => data_enable_cell_buf_0(13),
      O => data_enable_N_7871
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_13_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_rep1,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_9(13),
      ADR3 => data_enable_cell_buf_8(13),
      O => data_enable_N_7869
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_13_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_5(13),
      ADR3 => data_enable_cell_buf_4(13),
      O => data_enable_N_7866
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_13_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(13),
      ADR3 => data_enable_cell_buf_6(13),
      O => data_enable_N_7865
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_13_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_13_Q,
      O => data_enable_N_7863
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_6_12_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7983,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_3(12),
      ADR3 => data_enable_cell_buf_2(12),
      O => data_enable_N_7859
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_12_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(12),
      ADR3 => data_enable_cell_buf_6(12),
      O => data_enable_N_7854
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_6_11_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7983,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_3(11),
      ADR3 => data_enable_cell_buf_2(11),
      O => data_enable_N_7848
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_11_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(11),
      ADR3 => data_enable_cell_buf_6(11),
      O => data_enable_N_7843
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_10_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_1(10),
      ADR3 => data_enable_cell_buf_0(10),
      O => data_enable_N_7838
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_10_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_fast,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_9(10),
      ADR3 => data_enable_cell_buf_8(10),
      O => data_enable_N_7836
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_10_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_5(10),
      ADR3 => data_enable_cell_buf_4(10),
      O => data_enable_N_7833
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_10_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(10),
      ADR3 => data_enable_cell_buf_6(10),
      O => data_enable_N_7832
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_10_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_10_Q,
      O => data_enable_N_7830
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_6_9_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7983,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_3(9),
      ADR3 => data_enable_cell_buf_2(9),
      O => data_enable_N_7826
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_9_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(9),
      ADR3 => data_enable_cell_buf_6(9),
      O => data_enable_N_7821
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_6_8_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7983,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_3(8),
      ADR3 => data_enable_cell_buf_2(8),
      O => data_enable_N_7815
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_8_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(8),
      ADR3 => data_enable_cell_buf_6(8),
      O => data_enable_N_7810
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_7_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7986,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_1(7),
      ADR3 => data_enable_cell_buf_0(7),
      O => data_enable_N_7805
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_7_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7981_fast,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_9(7),
      ADR3 => data_enable_cell_buf_8(7),
      O => data_enable_N_7803
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_7_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_G_5499_fast,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_5(7),
      ADR3 => data_enable_cell_buf_4(7),
      O => data_enable_N_7800
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_7_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7985,
      ADR1 => data_enable_cwcount_out_3(0),
      ADR2 => data_enable_cell_buf_7(7),
      ADR3 => data_enable_cell_buf_6(7),
      O => data_enable_N_7799
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7296,
      ADR1 => data_enable_cell_buf_10_7_Q,
      O => data_enable_N_7797
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_31_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_31_Q,
      O => data_enable_N_7723
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_29_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_29_Q,
      O => data_enable_N_7714
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_28_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_28_Q,
      O => data_enable_N_7705
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_27_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_27_Q,
      O => data_enable_N_7696
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_26_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_26_Q,
      O => data_enable_N_7687
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_25_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_25_Q,
      O => data_enable_N_7678
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_24_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291_1,
      ADR1 => data_enable_cell_buf_11_24_Q,
      O => data_enable_N_7669
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_23_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7291,
      ADR1 => data_enable_cell_buf_11_23_Q,
      O => data_enable_N_7660
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_22_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_22_Q,
      O => data_enable_N_7651
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_21_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_21_Q,
      O => data_enable_N_7642
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_20_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_20_Q,
      O => data_enable_N_7633
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_6_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_6_Q,
      O => data_enable_N_7624
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_5_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_5_Q,
      O => data_enable_N_7615
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_4_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_4_Q,
      O => data_enable_N_7606
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_3_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_3_Q,
      O => data_enable_N_7597
    );
  data_enable_D_OUT_MOD_0_0_0_and2_0_2_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_G_6027_fast,
      ADR1 => data_enable_cell_buf_11_2_Q,
      O => data_enable_N_7588
    );
  data_enable_G_6314 : X_MUX2
    port map (
      IA => data_enable_G_6314_am,
      IB => data_enable_G_6314_bm,
      O => data_enable_N_7578,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6314_bm_332 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_7(2),
      ADR2 => data_enable_cell_buf_6(2),
      O => data_enable_G_6314_bm
    );
  data_enable_G_6314_am_333 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_5(2),
      ADR2 => data_enable_cell_buf_4(2),
      O => data_enable_G_6314_am
    );
  data_enable_G_6313 : X_MUX2
    port map (
      IA => data_enable_G_6313_am,
      IB => data_enable_G_6313_bm,
      O => data_enable_N_7577,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6313_bm_334 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_7(3),
      ADR2 => data_enable_cell_buf_6(3),
      O => data_enable_G_6313_bm
    );
  data_enable_G_6313_am_335 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_5(3),
      ADR2 => data_enable_cell_buf_4(3),
      O => data_enable_G_6313_am
    );
  data_enable_G_6312 : X_MUX2
    port map (
      IA => data_enable_G_6312_am,
      IB => data_enable_G_6312_bm,
      O => data_enable_N_7576,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6312_bm_336 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_7(4),
      ADR2 => data_enable_cell_buf_6(4),
      O => data_enable_G_6312_bm
    );
  data_enable_G_6312_am_337 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_5(4),
      ADR2 => data_enable_cell_buf_4(4),
      O => data_enable_G_6312_am
    );
  data_enable_G_6311 : X_MUX2
    port map (
      IA => data_enable_G_6311_am,
      IB => data_enable_G_6311_bm,
      O => data_enable_N_7575,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6311_bm_338 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_7(5),
      ADR2 => data_enable_cell_buf_6(5),
      O => data_enable_G_6311_bm
    );
  data_enable_G_6311_am_339 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_5(5),
      ADR2 => data_enable_cell_buf_4(5),
      O => data_enable_G_6311_am
    );
  data_enable_G_6310 : X_MUX2
    port map (
      IA => data_enable_G_6310_am,
      IB => data_enable_G_6310_bm,
      O => data_enable_N_7574,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6310_bm_340 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_7(6),
      ADR2 => data_enable_cell_buf_6(6),
      O => data_enable_G_6310_bm
    );
  data_enable_G_6310_am_341 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_5(6),
      ADR2 => data_enable_cell_buf_4(6),
      O => data_enable_G_6310_am
    );
  data_enable_G_6309 : X_MUX2
    port map (
      IA => data_enable_G_6309_am,
      IB => data_enable_G_6309_bm,
      O => data_enable_N_7573,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6309_bm_342 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_7(20),
      ADR2 => data_enable_cell_buf_6(20),
      O => data_enable_G_6309_bm
    );
  data_enable_G_6309_am_343 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_3(0),
      ADR1 => data_enable_cell_buf_5(20),
      ADR2 => data_enable_cell_buf_4(20),
      O => data_enable_G_6309_am
    );
  data_enable_G_6308 : X_MUX2
    port map (
      IA => data_enable_G_6308_am,
      IB => data_enable_G_6308_bm,
      O => data_enable_N_7572,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6308_bm_344 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(21),
      ADR2 => data_enable_cell_buf_6(21),
      O => data_enable_G_6308_bm
    );
  data_enable_G_6308_am_345 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(21),
      ADR2 => data_enable_cell_buf_4(21),
      O => data_enable_G_6308_am
    );
  data_enable_G_6307 : X_MUX2
    port map (
      IA => data_enable_G_6307_am,
      IB => data_enable_G_6307_bm,
      O => data_enable_N_7571,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6307_bm_346 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(22),
      ADR2 => data_enable_cell_buf_6(22),
      O => data_enable_G_6307_bm
    );
  data_enable_G_6307_am_347 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(22),
      ADR2 => data_enable_cell_buf_4(22),
      O => data_enable_G_6307_am
    );
  data_enable_G_6306 : X_MUX2
    port map (
      IA => data_enable_G_6306_am,
      IB => data_enable_G_6306_bm,
      O => data_enable_N_7570,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6306_bm_348 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(23),
      ADR2 => data_enable_cell_buf_6(23),
      O => data_enable_G_6306_bm
    );
  data_enable_G_6306_am_349 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(23),
      ADR2 => data_enable_cell_buf_4(23),
      O => data_enable_G_6306_am
    );
  data_enable_G_6305 : X_MUX2
    port map (
      IA => data_enable_G_6305_am,
      IB => data_enable_G_6305_bm,
      O => data_enable_N_7569,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6305_bm_350 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(24),
      ADR2 => data_enable_cell_buf_6(24),
      O => data_enable_G_6305_bm
    );
  data_enable_G_6305_am_351 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(24),
      ADR2 => data_enable_cell_buf_4(24),
      O => data_enable_G_6305_am
    );
  data_enable_G_6304 : X_MUX2
    port map (
      IA => data_enable_G_6304_am,
      IB => data_enable_G_6304_bm,
      O => data_enable_N_7568,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6304_bm_352 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(25),
      ADR2 => data_enable_cell_buf_6(25),
      O => data_enable_G_6304_bm
    );
  data_enable_G_6304_am_353 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(25),
      ADR2 => data_enable_cell_buf_4(25),
      O => data_enable_G_6304_am
    );
  data_enable_G_6303 : X_MUX2
    port map (
      IA => data_enable_G_6303_am,
      IB => data_enable_G_6303_bm,
      O => data_enable_N_7567,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6303_bm_354 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(26),
      ADR2 => data_enable_cell_buf_6(26),
      O => data_enable_G_6303_bm
    );
  data_enable_G_6303_am_355 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(26),
      ADR2 => data_enable_cell_buf_4(26),
      O => data_enable_G_6303_am
    );
  data_enable_G_6302 : X_MUX2
    port map (
      IA => data_enable_G_6302_am,
      IB => data_enable_G_6302_bm,
      O => data_enable_N_7566,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6302_bm_356 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(27),
      ADR2 => data_enable_cell_buf_6(27),
      O => data_enable_G_6302_bm
    );
  data_enable_G_6302_am_357 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(27),
      ADR2 => data_enable_cell_buf_4(27),
      O => data_enable_G_6302_am
    );
  data_enable_G_6301 : X_MUX2
    port map (
      IA => data_enable_G_6301_am,
      IB => data_enable_G_6301_bm,
      O => data_enable_N_7565,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6301_bm_358 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(28),
      ADR2 => data_enable_cell_buf_6(28),
      O => data_enable_G_6301_bm
    );
  data_enable_G_6301_am_359 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(28),
      ADR2 => data_enable_cell_buf_4(28),
      O => data_enable_G_6301_am
    );
  data_enable_G_6300 : X_MUX2
    port map (
      IA => data_enable_G_6300_am,
      IB => data_enable_G_6300_bm,
      O => data_enable_N_7564,
      SEL => data_enable_cwcount_out_1(1)
    );
  data_enable_G_6300_bm_360 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(29),
      ADR2 => data_enable_cell_buf_6(29),
      O => data_enable_G_6300_bm
    );
  data_enable_G_6300_am_361 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(29),
      ADR2 => data_enable_cell_buf_4(29),
      O => data_enable_G_6300_am
    );
  data_enable_G_6299 : X_MUX2
    port map (
      IA => data_enable_G_6299_am,
      IB => data_enable_G_6299_bm,
      O => data_enable_N_7563,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6299_bm_362 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_7(31),
      ADR2 => data_enable_cell_buf_6(31),
      O => data_enable_G_6299_bm
    );
  data_enable_G_6299_am_363 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_5(31),
      ADR2 => data_enable_cell_buf_4(31),
      O => data_enable_G_6299_am
    );
  data_enable_G_6297 : X_MUX2
    port map (
      IA => data_enable_G_6297_am,
      IB => data_enable_G_6297_bm,
      O => data_enable_N_7561,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6297_bm_364 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(2),
      ADR2 => data_enable_cell_buf_2(2),
      O => data_enable_G_6297_bm
    );
  data_enable_G_6297_am_365 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(2),
      ADR2 => data_enable_cell_buf_0(2),
      O => data_enable_G_6297_am
    );
  data_enable_G_6296 : X_MUX2
    port map (
      IA => data_enable_G_6296_am,
      IB => data_enable_G_6296_bm,
      O => data_enable_N_7560,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6296_bm_366 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(3),
      ADR2 => data_enable_cell_buf_2(3),
      O => data_enable_G_6296_bm
    );
  data_enable_G_6296_am_367 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(3),
      ADR2 => data_enable_cell_buf_0(3),
      O => data_enable_G_6296_am
    );
  data_enable_G_6295 : X_MUX2
    port map (
      IA => data_enable_G_6295_am,
      IB => data_enable_G_6295_bm,
      O => data_enable_N_7559,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6295_bm_368 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(4),
      ADR2 => data_enable_cell_buf_2(4),
      O => data_enable_G_6295_bm
    );
  data_enable_G_6295_am_369 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(4),
      ADR2 => data_enable_cell_buf_0(4),
      O => data_enable_G_6295_am
    );
  data_enable_G_6294 : X_MUX2
    port map (
      IA => data_enable_G_6294_am,
      IB => data_enable_G_6294_bm,
      O => data_enable_N_7558,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6294_bm_370 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(5),
      ADR2 => data_enable_cell_buf_2(5),
      O => data_enable_G_6294_bm
    );
  data_enable_G_6294_am_371 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(5),
      ADR2 => data_enable_cell_buf_0(5),
      O => data_enable_G_6294_am
    );
  data_enable_G_6293 : X_MUX2
    port map (
      IA => data_enable_G_6293_am,
      IB => data_enable_G_6293_bm,
      O => data_enable_N_7557,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6293_bm_372 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(6),
      ADR2 => data_enable_cell_buf_2(6),
      O => data_enable_G_6293_bm
    );
  data_enable_G_6293_am_373 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(6),
      ADR2 => data_enable_cell_buf_0(6),
      O => data_enable_G_6293_am
    );
  data_enable_G_6292 : X_MUX2
    port map (
      IA => data_enable_G_6292_am,
      IB => data_enable_G_6292_bm,
      O => data_enable_N_7556,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6292_bm_374 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(20),
      ADR2 => data_enable_cell_buf_2(20),
      O => data_enable_G_6292_bm
    );
  data_enable_G_6292_am_375 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(20),
      ADR2 => data_enable_cell_buf_0(20),
      O => data_enable_G_6292_am
    );
  data_enable_G_6291 : X_MUX2
    port map (
      IA => data_enable_G_6291_am,
      IB => data_enable_G_6291_bm,
      O => data_enable_N_7555,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6291_bm_376 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_3(21),
      ADR2 => data_enable_cell_buf_2(21),
      O => data_enable_G_6291_bm
    );
  data_enable_G_6291_am_377 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_2(0),
      ADR1 => data_enable_cell_buf_1(21),
      ADR2 => data_enable_cell_buf_0(21),
      O => data_enable_G_6291_am
    );
  data_enable_G_6290 : X_MUX2
    port map (
      IA => data_enable_G_6290_am,
      IB => data_enable_G_6290_bm,
      O => data_enable_N_7554,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6290_bm_378 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(22),
      ADR2 => data_enable_cell_buf_2(22),
      O => data_enable_G_6290_bm
    );
  data_enable_G_6290_am_379 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(22),
      ADR2 => data_enable_cell_buf_0(22),
      O => data_enable_G_6290_am
    );
  data_enable_G_6289 : X_MUX2
    port map (
      IA => data_enable_G_6289_am,
      IB => data_enable_G_6289_bm,
      O => data_enable_N_7553,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6289_bm_380 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(23),
      ADR2 => data_enable_cell_buf_2(23),
      O => data_enable_G_6289_bm
    );
  data_enable_G_6289_am_381 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(23),
      ADR2 => data_enable_cell_buf_0(23),
      O => data_enable_G_6289_am
    );
  data_enable_G_6288 : X_MUX2
    port map (
      IA => data_enable_G_6288_am,
      IB => data_enable_G_6288_bm,
      O => data_enable_N_7552,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6288_bm_382 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(24),
      ADR2 => data_enable_cell_buf_2(24),
      O => data_enable_G_6288_bm
    );
  data_enable_G_6288_am_383 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(24),
      ADR2 => data_enable_cell_buf_0(24),
      O => data_enable_G_6288_am
    );
  data_enable_G_6287 : X_MUX2
    port map (
      IA => data_enable_G_6287_am,
      IB => data_enable_G_6287_bm,
      O => data_enable_N_7551,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6287_bm_384 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(25),
      ADR2 => data_enable_cell_buf_2(25),
      O => data_enable_G_6287_bm
    );
  data_enable_G_6287_am_385 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(25),
      ADR2 => data_enable_cell_buf_0(25),
      O => data_enable_G_6287_am
    );
  data_enable_G_6286 : X_MUX2
    port map (
      IA => data_enable_G_6286_am,
      IB => data_enable_G_6286_bm,
      O => data_enable_N_7550,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6286_bm_386 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(26),
      ADR2 => data_enable_cell_buf_2(26),
      O => data_enable_G_6286_bm
    );
  data_enable_G_6286_am_387 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(26),
      ADR2 => data_enable_cell_buf_0(26),
      O => data_enable_G_6286_am
    );
  data_enable_G_6285 : X_MUX2
    port map (
      IA => data_enable_G_6285_am,
      IB => data_enable_G_6285_bm,
      O => data_enable_N_7549,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6285_bm_388 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(27),
      ADR2 => data_enable_cell_buf_2(27),
      O => data_enable_G_6285_bm
    );
  data_enable_G_6285_am_389 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(27),
      ADR2 => data_enable_cell_buf_0(27),
      O => data_enable_G_6285_am
    );
  data_enable_G_6284 : X_MUX2
    port map (
      IA => data_enable_G_6284_am,
      IB => data_enable_G_6284_bm,
      O => data_enable_N_7548,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6284_bm_390 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(28),
      ADR2 => data_enable_cell_buf_2(28),
      O => data_enable_G_6284_bm
    );
  data_enable_G_6284_am_391 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(28),
      ADR2 => data_enable_cell_buf_0(28),
      O => data_enable_G_6284_am
    );
  data_enable_G_6283 : X_MUX2
    port map (
      IA => data_enable_G_6283_am,
      IB => data_enable_G_6283_bm,
      O => data_enable_N_7547,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6283_bm_392 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(29),
      ADR2 => data_enable_cell_buf_2(29),
      O => data_enable_G_6283_bm
    );
  data_enable_G_6283_am_393 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(29),
      ADR2 => data_enable_cell_buf_0(29),
      O => data_enable_G_6283_am
    );
  data_enable_G_6282 : X_MUX2
    port map (
      IA => data_enable_G_6282_am,
      IB => data_enable_G_6282_bm,
      O => data_enable_N_7546,
      SEL => data_enable_cwcount_out_1_Q
    );
  data_enable_G_6282_bm_394 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_3(31),
      ADR2 => data_enable_cell_buf_2(31),
      O => data_enable_G_6282_bm
    );
  data_enable_G_6282_am_395 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1(0),
      ADR1 => data_enable_cell_buf_1(31),
      ADR2 => data_enable_cell_buf_0(31),
      O => data_enable_G_6282_am
    );
  data_enable_G_6270 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(7),
      ADR1 => data_enable_cell_buf_3(7),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7534
    );
  data_enable_G_6267 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(10),
      ADR1 => data_enable_cell_buf_3(10),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7531
    );
  data_enable_G_6264 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(13),
      ADR1 => data_enable_cell_buf_3(13),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7528
    );
  data_enable_G_6263 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(14),
      ADR1 => data_enable_cell_buf_3(14),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7527
    );
  data_enable_G_6260 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(30),
      ADR1 => data_enable_cell_buf_3(30),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7524
    );
  data_enable_G_6250 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(19),
      ADR1 => data_enable_cell_buf_3(19),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7514
    );
  data_enable_G_6249 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(18),
      ADR1 => data_enable_cell_buf_3(18),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7513
    );
  data_enable_G_6248 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(17),
      ADR1 => data_enable_cell_buf_3(17),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7512
    );
  data_enable_G_6247 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(16),
      ADR1 => data_enable_cell_buf_3(16),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7511
    );
  data_enable_G_6246 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_2(15),
      ADR1 => data_enable_cell_buf_3(15),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7510
    );
  data_enable_G_6235 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(19),
      ADR1 => data_enable_cell_buf_1(19),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7499
    );
  data_enable_G_6234 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(18),
      ADR1 => data_enable_cell_buf_1(18),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7498
    );
  data_enable_G_6233 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(17),
      ADR1 => data_enable_cell_buf_1(17),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7497
    );
  data_enable_G_6228 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(12),
      ADR1 => data_enable_cell_buf_1(12),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7492
    );
  data_enable_G_6227 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(11),
      ADR1 => data_enable_cell_buf_1(11),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7491
    );
  data_enable_G_6225 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(9),
      ADR1 => data_enable_cell_buf_1(9),
      ADR2 => data_enable_cwcount_out_1(0),
      O => data_enable_N_7489
    );
  data_enable_G_6224 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_0(8),
      ADR1 => data_enable_cell_buf_1(8),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7488
    );
  data_enable_G_6185 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(31),
      ADR1 => data_enable_cell_buf_9(31),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7449
    );
  data_enable_G_6183 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(29),
      ADR1 => data_enable_cell_buf_9(29),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7447
    );
  data_enable_G_6182 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(28),
      ADR1 => data_enable_cell_buf_9(28),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7446
    );
  data_enable_G_6181 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(27),
      ADR1 => data_enable_cell_buf_9(27),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7445
    );
  data_enable_G_6180 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(26),
      ADR1 => data_enable_cell_buf_9(26),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7444
    );
  data_enable_G_6179 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(25),
      ADR1 => data_enable_cell_buf_9(25),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7443
    );
  data_enable_G_6178 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(24),
      ADR1 => data_enable_cell_buf_9(24),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7442
    );
  data_enable_G_6177 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(23),
      ADR1 => data_enable_cell_buf_9(23),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7441
    );
  data_enable_G_6176 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(22),
      ADR1 => data_enable_cell_buf_9(22),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7440
    );
  data_enable_G_6175 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(21),
      ADR1 => data_enable_cell_buf_9(21),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7439
    );
  data_enable_G_6174 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(20),
      ADR1 => data_enable_cell_buf_9(20),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7438
    );
  data_enable_G_6166 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(12),
      ADR1 => data_enable_cell_buf_9(12),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7430
    );
  data_enable_G_6165 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(11),
      ADR1 => data_enable_cell_buf_9(11),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7429
    );
  data_enable_G_6163 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(9),
      ADR1 => data_enable_cell_buf_9(9),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7427
    );
  data_enable_G_6162 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(8),
      ADR1 => data_enable_cell_buf_9(8),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7426
    );
  data_enable_G_6160 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(6),
      ADR1 => data_enable_cell_buf_9(6),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7424
    );
  data_enable_G_6159 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(5),
      ADR1 => data_enable_cell_buf_9(5),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7423
    );
  data_enable_G_6158 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(4),
      ADR1 => data_enable_cell_buf_9(4),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7422
    );
  data_enable_G_6157 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(3),
      ADR1 => data_enable_cell_buf_9(3),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7421
    );
  data_enable_G_6156 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_8(2),
      ADR1 => data_enable_cell_buf_9(2),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7420
    );
  data_enable_G_6134 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_4(12),
      ADR1 => data_enable_cell_buf_5(12),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7398
    );
  data_enable_G_6133 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_4(11),
      ADR1 => data_enable_cell_buf_5(11),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7397
    );
  data_enable_G_6131 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_4(9),
      ADR1 => data_enable_cell_buf_5(9),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7395
    );
  data_enable_G_6130 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_cell_buf_4(8),
      ADR1 => data_enable_cell_buf_5(8),
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7394
    );
  data_enable_G_6121_396 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(31),
      ADR1 => data_enable_un38_cell_buf_s_29,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6121
    );
  data_enable_G_6120_397 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(30),
      ADR1 => data_enable_un38_cell_buf_s_28,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6120
    );
  data_enable_G_6119_398 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(29),
      ADR1 => data_enable_un38_cell_buf_s_27,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6119
    );
  data_enable_G_6118_399 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(28),
      ADR1 => data_enable_un38_cell_buf_s_26,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6118
    );
  data_enable_G_6117_400 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(27),
      ADR1 => data_enable_un38_cell_buf_s_25,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6117
    );
  data_enable_G_6116_401 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(26),
      ADR1 => data_enable_un38_cell_buf_s_24,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6116
    );
  data_enable_G_6115_402 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(25),
      ADR1 => data_enable_un38_cell_buf_s_23,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6115
    );
  data_enable_G_6114_403 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(24),
      ADR1 => data_enable_un38_cell_buf_s_22,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6114
    );
  data_enable_G_6113_404 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(23),
      ADR1 => data_enable_un38_cell_buf_s_21,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6113
    );
  data_enable_G_6111_405 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(21),
      ADR1 => data_enable_un38_cell_buf_s_19,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6111
    );
  data_enable_G_6110_406 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(20),
      ADR1 => data_enable_un38_cell_buf_s_18,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6110
    );
  data_enable_G_6109_407 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(19),
      ADR1 => data_enable_un38_cell_buf_s_17,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6109
    );
  data_enable_G_6108_408 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(18),
      ADR1 => data_enable_un38_cell_buf_s_16,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6108
    );
  data_enable_G_6107_409 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(17),
      ADR1 => data_enable_un38_cell_buf_s_15,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6107
    );
  data_enable_G_6106_410 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(16),
      ADR1 => data_enable_un38_cell_buf_s_14,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6106
    );
  data_enable_G_6105_411 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(15),
      ADR1 => data_enable_un38_cell_buf_s_13,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6105
    );
  data_enable_G_6104_412 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(14),
      ADR1 => data_enable_un38_cell_buf_s_12,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6104
    );
  data_enable_G_6103_413 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(13),
      ADR1 => data_enable_un38_cell_buf_s_11,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6103
    );
  data_enable_G_6102_414 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(12),
      ADR1 => data_enable_un38_cell_buf_s_10,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6102
    );
  data_enable_G_6101_415 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(11),
      ADR1 => data_enable_un38_cell_buf_s_9,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6101
    );
  data_enable_G_6100_416 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(10),
      ADR1 => data_enable_un38_cell_buf_s_8,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6100
    );
  data_enable_G_6099_417 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(9),
      ADR1 => data_enable_un38_cell_buf_s_7,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6099
    );
  data_enable_G_6098_418 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(8),
      ADR1 => data_enable_un38_cell_buf_s_6,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6098
    );
  data_enable_G_6097_419 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(7),
      ADR1 => data_enable_un38_cell_buf_s_5,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6097
    );
  data_enable_G_6096_420 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(6),
      ADR1 => data_enable_un38_cell_buf_s_4,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6096
    );
  data_enable_G_6095_421 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(5),
      ADR1 => data_enable_un38_cell_buf_s_3,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6095
    );
  data_enable_G_6094_422 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(4),
      ADR1 => data_enable_un38_cell_buf_s_2,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6094
    );
  data_enable_G_6093_423 : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => data_enable_data_in(3),
      ADR1 => data_enable_un38_cell_buf_s_1,
      ADR2 => data_enable_N_7290,
      O => data_enable_G_6093
    );
  data_enable_G_6052 : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => data_enable_state_out_0_Q,
      ADR1 => data_enable_state_out_8_Q,
      ADR2 => data_enable_soc_in,
      O => data_enable_N_7316
    );
  data_enable_G_6032 : X_LUT4
    generic map(
      INIT => X"AAEA"
    )
    port map (
      ADR0 => data_enable_N_7969,
      ADR1 => data_enable_N_8046,
      ADR2 => data_enable_N_7967,
      ADR3 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_7296
    );
  data_enable_G_6027 : X_LUT4
    generic map(
      INIT => X"AABA"
    )
    port map (
      ADR0 => data_enable_N_7963,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_state_out_0_Q,
      ADR3 => Reset_l_i_5,
      O => data_enable_N_7291
    );
  data_enable_G_6026 : X_LUT3
    generic map(
      INIT => X"32"
    )
    port map (
      ADR0 => data_enable_data_in(0),
      ADR1 => data_enable_state_in_5_Q,
      ADR2 => data_enable_data_in(1),
      O => data_enable_N_7290
    );
  data_enable_G_5562 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1_Q,
      ADR1 => data_enable_cwcount_out_3_Q,
      O => data_enable_N_8046
    );
  data_enable_G_5501 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_3_Q,
      ADR2 => data_enable_cwcount_out_1_Q,
      O => data_enable_N_7986
    );
  data_enable_G_5498 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_3_Q,
      ADR2 => data_enable_cwcount_out_1_Q,
      O => data_enable_N_7983
    );
  data_enable_G_5496 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_N_7974,
      O => data_enable_N_7981
    );
  data_enable_G_5488 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1_Q,
      ADR1 => data_enable_cwcount_out_3_Q,
      O => data_enable_N_7974
    );
  data_enable_G_5485 : X_LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_3_Q,
      O => data_enable_N_7971
    );
  data_enable_G_665 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => data_enable_cwcount_in(1),
      ADR1 => data_enable_cwcount_in(0),
      ADR2 => data_enable_state_in_5_Q,
      O => data_enable_un2_cwcount_in_3_c2
    );
  data_enable_G_673 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => data_enable_cwcount_out_1_Q,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_cwcount_out_0_Q,
      O => data_enable_un1_cwcount_out_16_c2
    );
  data_enable_G_5482 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => data_enable_N_7977,
      ADR1 => Reset_l_i_6,
      ADR2 => data_enable_byte_count_0(1),
      ADR3 => data_enable_byte_count(0),
      O => data_enable_N_7969
    );
  data_enable_G_6_0_0_0_424 : X_LUT4
    generic map(
      INIT => X"FFF4"
    )
    port map (
      ADR0 => data_enable_N_7315,
      ADR1 => data_enable_state_out_4_Q,
      ADR2 => data_enable_G_6_0_0_0_327,
      ADR3 => data_enable_N_7734,
      O => data_enable_G_6_0_0_0
    );
  data_enable_DataEn_OUT_MOD_0_i_0_0_and2 : X_LUT4
    generic map(
      INIT => X"8808"
    )
    port map (
      ADR0 => data_enable_N_7315,
      ADR1 => data_enable_state_out_4_Q,
      ADR2 => data_enable_buf_flag,
      ADR3 => data_enable_lc_flag,
      O => data_enable_N_7764
    );
  data_enable_EOF_OUT_MOD_0_0_0_0_and2 : X_LUT4
    generic map(
      INIT => X"B000"
    )
    port map (
      ADR0 => data_enable_N_8049,
      ADR1 => data_enable_out_sm_proc_un6_lc_copy_NE,
      ADR2 => data_enable_N_7973,
      ADR3 => data_enable_EOF_OUT_MOD_0_0_0_0_and2_588,
      O => data_enable_N_7731
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_7_0_Q : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => data_enable_N_8046,
      ADR1 => data_enable_N_7967,
      ADR2 => data_enable_cwcount_out_0_Q,
      ADR3 => data_enable_cell_buf_10_0_Q,
      O => data_enable_N_7774
    );
  data_enable_G_5497 : X_LUT4
    generic map(
      INIT => X"2220"
    )
    port map (
      ADR0 => data_enable_N_7977,
      ADR1 => Reset_l_i_6,
      ADR2 => data_enable_byte_count_0(1),
      ADR3 => data_enable_byte_count(0),
      O => data_enable_N_7982
    );
  data_enable_un1_un1_un2_cell_buf_11_i_0_0_0_and2_0 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => N_1014_2,
      ADR1 => data_enable_cwcount_in(3),
      ADR2 => data_enable_cwcount_in(0),
      ADR3 => data_enable_cwcount_in(1),
      O => data_enable_N_7760
    );
  data_enable_un1_un1_un5_cell_buf_10_i_0_0_0_and2_0 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => N_1014_2,
      ADR1 => data_enable_cwcount_in(3),
      ADR2 => data_enable_cwcount_in(0),
      ADR3 => data_enable_cwcount_in(1),
      O => data_enable_N_7762
    );
  data_enable_un1_state_in_4_0_and2_0_and2_0_and2_425 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => data_enable_N_8044,
      ADR1 => data_enable_cwcount_in(3),
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(0),
      O => data_enable_un1_state_in_4_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_5_0_and2_0_and2_0_and2_426 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => data_enable_N_8044,
      ADR1 => N_1014_3,
      ADR2 => data_enable_cwcount_in(3),
      O => data_enable_un1_state_in_5_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_7_0_and2_0_and2_0_and2_427 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => N_1014_2,
      ADR1 => N_1014_3,
      ADR2 => data_enable_cwcount_in(3),
      O => data_enable_un1_state_in_7_0_and2_0_and2_0_and2
    );
  data_enable_un1_state_in_9_0_and2_0_and2_0_and2_428 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => N_1014_2,
      ADR1 => data_enable_cwcount_in(3),
      ADR2 => data_enable_cwcount_in(1),
      ADR3 => data_enable_cwcount_in(0),
      O => data_enable_un1_state_in_9_0_and2_0_and2_0_and2
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_1_1_Q : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_N_8046,
      ADR2 => data_enable_N_7319,
      O => data_enable_N_7790
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_0_1_Q : X_LUT4
    generic map(
      INIT => X"0008"
    )
    port map (
      ADR0 => data_enable_N_7320,
      ADR1 => data_enable_N_8496,
      ADR2 => data_enable_cwcount_out(2),
      ADR3 => data_enable_cwcount_out_3_Q,
      O => data_enable_N_7789
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_3_1_Q : X_LUT4
    generic map(
      INIT => X"0200"
    )
    port map (
      ADR0 => data_enable_cell_buf_11_1_Q,
      ADR1 => Reset_l_i_6,
      ADR2 => data_enable_state_out_5_Q,
      ADR3 => data_enable_state_out_0_Q,
      O => data_enable_N_7792
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_6_1_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => data_enable_N_7977,
      ADR1 => data_enable_byte_count_0(1),
      ADR2 => Reset_l_i_6,
      O => data_enable_N_7795
    );
  data_enable_EOF_OUT_MOD_0_0_0_0_and2_0_287 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => data_enable_lc_flag,
      ADR1 => data_enable_state_out_2_Q,
      ADR2 => Reset_l_i_6,
      O => EOF_OUT_MOD_0_0_0_0_and2_0_287
    );
  data_enable_G_6_0_0_0_327_429 : X_LUT4
    generic map(
      INIT => X"FEFF"
    )
    port map (
      ADR0 => G_6_0_0_0_or2,
      ADR1 => data_enable_N_7997,
      ADR2 => data_enable_state_out_5_Q,
      ADR3 => Reset_l_1,
      O => data_enable_G_6_0_0_0_327
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_2_1_541 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_8496,
      ADR1 => data_enable_cwcount_out_0_Q,
      ADR2 => data_enable_cell_buf_9(1),
      ADR3 => data_enable_cell_buf_8(1),
      O => D_OUT_MOD_0_i_i_0_and2_2_1_541
    );
  data_enable_EOF_OUT_MOD_0_0_0_0_and2_1_551 : X_LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      ADR0 => data_enable_lc_flag,
      ADR1 => Reset_l_i_6,
      ADR2 => data_enable_state_out_3_Q,
      ADR3 => data_enable_state_in_4_Q,
      O => EOF_OUT_MOD_0_0_0_0_and2_1_551
    );
  data_enable_EOF_OUT_MOD_0_0_0_0_and2_588_430 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => data_enable_lc_copy,
      ADR1 => data_enable_state_out_2_Q,
      ADR2 => data_enable_state_out_3_Q,
      O => data_enable_EOF_OUT_MOD_0_0_0_0_and2_588
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_s_18_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_0_Q,
      ADR2 => data_enable_cell_buf_9(18),
      ADR3 => data_enable_cell_buf_8(18),
      O => D_OUT_MOD_0_i_i_0_and2_5_s(18)
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_s_19_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_0_Q,
      ADR2 => data_enable_cell_buf_9(19),
      ADR3 => data_enable_cell_buf_8(19),
      O => D_OUT_MOD_0_i_i_0_and2_5_s(19)
    );
  data_enable_D_OUT_MOD_0_i_i_0_and2_5_s_17_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => data_enable_N_7967,
      ADR1 => data_enable_cwcount_out_0_Q,
      ADR2 => data_enable_cell_buf_9(17),
      ADR3 => data_enable_cell_buf_8(17),
      O => D_OUT_MOD_0_i_i_0_and2_5_s(17)
    );
  data_enable_N_4687_i_431 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => G_6_0_0_0_or2,
      ADR1 => data_enable_cwcount_out_1_Q,
      ADR2 => data_enable_state_out_5_Q,
      ADR3 => data_enable_cwcount_out_0_Q,
      O => data_enable_N_4687_i
    );
  data_enable_N_4685_i_432 : X_LUT4
    generic map(
      INIT => X"1444"
    )
    port map (
      ADR0 => G_6_0_0_0_or2,
      ADR1 => data_enable_cwcount_out_3_Q,
      ADR2 => data_enable_cwcount_out(2),
      ADR3 => data_enable_un1_cwcount_out_16_c2,
      O => data_enable_N_4685_i
    );
  data_enable_N_4676_i_433 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => G_6_0_0_0_or2,
      ADR1 => data_enable_un1_cwcount_out_16_c2,
      ADR2 => data_enable_cwcount_out(2),
      O => data_enable_N_4676_i
    );
  data_enable_N_4689_i_434 : X_LUT4
    generic map(
      INIT => X"0006"
    )
    port map (
      ADR0 => data_enable_state_out_5_Q,
      ADR1 => data_enable_cwcount_out_0_Q,
      ADR2 => data_enable_state_out_6_Q,
      ADR3 => data_enable_state_out_2_Q,
      O => data_enable_N_4689_i
    );
  data_enable_lc_save_proc_N_6792_i : X_LUT3
    generic map(
      INIT => X"8A"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => data_enable_data_in(1),
      ADR2 => data_enable_soc_in,
      O => data_enable_N_6792_i
    );
  data_enable_buf_flag_proc_N_4709_i : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => data_enable_state_out_4_Q,
      ADR1 => data_enable_state_out_8_Q,
      ADR2 => data_enable_N_7745,
      ADR3 => G_6_0_0_0_or2,
      O => data_enable_N_4709_i
    );
  data_enable_backup_proc_N_4678_i : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_lc_flag,
      ADR1 => Reset_l_1,
      O => data_enable_N_4678_i
    );
  data_enable_N_7345_i_435 : X_LUT4
    generic map(
      INIT => X"A5A6"
    )
    port map (
      ADR0 => data_enable_data_in(2),
      ADR1 => data_enable_data_in(1),
      ADR2 => data_enable_state_in_5_Q,
      ADR3 => data_enable_data_in(0),
      O => data_enable_N_7345_i
    );
  data_enable_N_4674_i_436 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_state_out_6_Q,
      ADR1 => Reset_l_1,
      O => data_enable_N_4674_i
    );
  data_enable_buf_flag_437 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_N_4702,
      CLK => CLK,
      I => data_enable_N_4709_i,
      O => data_enable_buf_flag,
      SRST => Reset_l_i_10,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_lc_flag_438 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_N_6888,
      CLK => CLK,
      I => data_enable_N_6792_i,
      O => data_enable_lc_flag,
      SRST => Reset_l_i_11,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_lc_copy_439 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => data_enable_N_4682,
      CLK => CLK,
      I => data_enable_N_4678_i,
      O => data_enable_lc_copy,
      SRST => Reset_l_i_11,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_SOF_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_6_Q,
      O => SOF_OUT_APPL,
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_buf_copy_440 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => N_1024_i,
      O => data_enable_buf_copy,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_soc_in_441 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => soc2,
      O => data_enable_soc_in,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_DataEn_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => N_1021_i,
      O => DataEn_OUT_APPL,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_EOF_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_911,
      O => EOF_OUT_APPL,
      SSET => data_enable_N_7731,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_873,
      O => D_OUT_APPL(22),
      SSET => data_enable_N_7651,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_874,
      O => D_OUT_APPL(23),
      SSET => data_enable_N_7660,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_875,
      O => D_OUT_APPL(24),
      SSET => data_enable_N_7669,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_876,
      O => D_OUT_APPL(25),
      SSET => data_enable_N_7678,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_877,
      O => D_OUT_APPL(26),
      SSET => data_enable_N_7687,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_878,
      O => D_OUT_APPL(27),
      SSET => data_enable_N_7696,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_879,
      O => D_OUT_APPL(28),
      SSET => data_enable_N_7705,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_880,
      O => D_OUT_APPL(29),
      SSET => data_enable_N_7714,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_881,
      O => D_OUT_APPL(30),
      SSET => data_enable_N_7942,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_882,
      O => D_OUT_APPL(31),
      SSET => data_enable_N_7723,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_883,
      O => D_OUT_APPL(7),
      SSET => data_enable_N_7799,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_884,
      O => D_OUT_APPL(8),
      SSET => data_enable_N_7810,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_885,
      O => D_OUT_APPL(9),
      SSET => data_enable_N_7821,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_886,
      O => D_OUT_APPL(10),
      SSET => data_enable_N_7832,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_887,
      O => D_OUT_APPL(11),
      SSET => data_enable_N_7843,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_888,
      O => D_OUT_APPL(12),
      SSET => data_enable_N_7854,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_889,
      O => D_OUT_APPL(13),
      SSET => data_enable_N_7865,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_890,
      O => D_OUT_APPL(14),
      SSET => data_enable_N_7876,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_891,
      O => D_OUT_APPL(15),
      SSET => data_enable_N_7887,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_892,
      O => D_OUT_APPL(16),
      SSET => data_enable_N_7898,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_893,
      O => D_OUT_APPL(17),
      SSET => data_enable_N_7909,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_894,
      O => D_OUT_APPL(18),
      SSET => data_enable_N_7920,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_895,
      O => D_OUT_APPL(19),
      SSET => data_enable_N_7931,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_896,
      O => D_OUT_APPL(20),
      SSET => data_enable_N_7633,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_897,
      O => D_OUT_APPL(21),
      SSET => data_enable_N_7642,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_898,
      O => D_OUT_APPL(0),
      SSET => data_enable_N_7766,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_899,
      O => D_OUT_APPL(1),
      SSET => data_enable_N_7796,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_900,
      O => D_OUT_APPL(2),
      SSET => data_enable_N_7588,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_901,
      O => D_OUT_APPL(3),
      SSET => data_enable_N_7597,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_902,
      O => D_OUT_APPL(4),
      SSET => data_enable_N_7606,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_903,
      O => D_OUT_APPL(5),
      SSET => data_enable_N_7615,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_D_OUT_MOD_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_904,
      O => D_OUT_APPL(6),
      SSET => data_enable_N_7624,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_cwcount_out_0_Q_442 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4689_i,
      O => data_enable_cwcount_out_0_Q,
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_1_Q_443 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4687_i,
      O => data_enable_cwcount_out_1_Q,
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4676_i,
      O => data_enable_cwcount_out(2),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_out_3_Q_444 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_N_4685_i,
      O => data_enable_cwcount_out_3_Q,
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_869,
      O => data_enable_cwcount_in(3),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_in_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_870,
      O => data_enable_cwcount_in(0),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_871,
      O => data_enable_cwcount_in(1),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_cwcount_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_872,
      O => data_enable_cwcount_in(2),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_fwcount_s_13_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(12),
      I1 => data_enable_fwcount_qxu(13),
      O => data_enable_fwcount_s(13)
    );
  data_enable_fwcount_qxu_13_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => data_enable_N_4674_i,
      ADR1 => data_enable_GND,
      ADR2 => data_enable_fwcount(13),
      ADR3 => data_enable_GND,
      O => data_enable_fwcount_qxu(13)
    );
  data_enable_fwcount_s_12_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(11),
      I1 => data_enable_fwcount_qxu(12),
      O => data_enable_fwcount_s(12)
    );
  data_enable_fwcount_s_11_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(10),
      I1 => data_enable_fwcount_qxu(11),
      O => data_enable_fwcount_s(11)
    );
  data_enable_fwcount_s_10_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(9),
      I1 => data_enable_fwcount_qxu(10),
      O => data_enable_fwcount_s(10)
    );
  data_enable_fwcount_s_9_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(8),
      I1 => data_enable_fwcount_qxu(9),
      O => data_enable_fwcount_s(9)
    );
  data_enable_fwcount_s_8_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(7),
      I1 => data_enable_fwcount_qxu(8),
      O => data_enable_fwcount_s(8)
    );
  data_enable_fwcount_s_7_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(6),
      I1 => data_enable_fwcount_qxu(7),
      O => data_enable_fwcount_s(7)
    );
  data_enable_fwcount_s_6_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(5),
      I1 => data_enable_fwcount_qxu(6),
      O => data_enable_fwcount_s(6)
    );
  data_enable_fwcount_s_5_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(4),
      I1 => data_enable_fwcount_qxu(5),
      O => data_enable_fwcount_s(5)
    );
  data_enable_fwcount_s_4_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(3),
      I1 => data_enable_fwcount_qxu(4),
      O => data_enable_fwcount_s(4)
    );
  data_enable_fwcount_s_3_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(2),
      I1 => data_enable_fwcount_qxu(3),
      O => data_enable_fwcount_s(3)
    );
  data_enable_fwcount_s_2_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(1),
      I1 => data_enable_fwcount_qxu(2),
      O => data_enable_fwcount_s(2)
    );
  data_enable_fwcount_s_1_Q : X_XOR2
    port map (
      I0 => data_enable_fwcount_cry(0),
      I1 => data_enable_fwcount_qxu(1),
      O => data_enable_fwcount_s(1)
    );
  data_enable_fwcount_s_0_Q : X_XOR2
    port map (
      I0 => data_enable_N_4674_i,
      I1 => data_enable_fwcount_qxu(0),
      O => data_enable_fwcount_s(0)
    );
  data_enable_output_proc_un73_state_in_cry_15 : X_MUX2
    port map (
      IB => data_enable_un73_state_in_cry_14,
      IA => data_enable_data_in(15),
      O => data_enable_out_sm_proc_un57_state_in,
      SEL => data_enable_un73_state_in_axb_15_i
    );
  data_enable_un32_d_out_mod_s_29 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_28,
      I1 => data_enable_N_1834_i,
      O => un32_d_out_mod_s_29
    );
  data_enable_un32_d_out_mod_s_28 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_27,
      I1 => data_enable_N_1833_i,
      O => un32_d_out_mod_s_28
    );
  data_enable_un32_d_out_mod_s_27 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_26,
      I1 => data_enable_N_1832_i,
      O => un32_d_out_mod_s_27
    );
  data_enable_un32_d_out_mod_s_26 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_25,
      I1 => data_enable_N_1831_i,
      O => un32_d_out_mod_s_26
    );
  data_enable_un32_d_out_mod_s_25 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_24,
      I1 => data_enable_N_1830_i,
      O => un32_d_out_mod_s_25
    );
  data_enable_un32_d_out_mod_s_24 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_23,
      I1 => data_enable_N_1829_i,
      O => un32_d_out_mod_s_24
    );
  data_enable_un32_d_out_mod_s_23 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_22,
      I1 => data_enable_N_1828_i,
      O => un32_d_out_mod_s_23
    );
  data_enable_un32_d_out_mod_s_22 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_21,
      I1 => data_enable_N_1827_i,
      O => un32_d_out_mod_s_22
    );
  data_enable_un32_d_out_mod_s_21 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_20,
      I1 => data_enable_N_1826_i,
      O => un32_d_out_mod_s_21
    );
  data_enable_un32_d_out_mod_s_20 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_19,
      I1 => data_enable_N_1825_i,
      O => un32_d_out_mod_s_20
    );
  data_enable_un32_d_out_mod_s_19 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_18,
      I1 => data_enable_N_1824_i,
      O => un32_d_out_mod_s_19
    );
  data_enable_un32_d_out_mod_s_18 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_17,
      I1 => data_enable_N_1823_i,
      O => un32_d_out_mod_s_18
    );
  data_enable_un32_d_out_mod_s_17 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_16,
      I1 => data_enable_N_1822_i,
      O => un32_d_out_mod_s_17
    );
  data_enable_un32_d_out_mod_s_16 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_15,
      I1 => data_enable_N_1821_i,
      O => un32_d_out_mod_s_16
    );
  data_enable_un32_d_out_mod_s_15 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_14,
      I1 => data_enable_N_1820_i,
      O => un32_d_out_mod_s_15
    );
  data_enable_un32_d_out_mod_s_14 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_13,
      I1 => data_enable_N_1819_i,
      O => un32_d_out_mod_s_14
    );
  data_enable_un32_d_out_mod_s_13 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_12,
      I1 => data_enable_N_1818_i,
      O => un32_d_out_mod_s_13
    );
  data_enable_un32_d_out_mod_s_12 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_11,
      I1 => data_enable_N_1817_i,
      O => un32_d_out_mod_s_12
    );
  data_enable_un32_d_out_mod_s_11 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_10,
      I1 => data_enable_N_1816_i,
      O => un32_d_out_mod_s_11
    );
  data_enable_un32_d_out_mod_s_10 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_9,
      I1 => data_enable_N_1815_i,
      O => un32_d_out_mod_s_10
    );
  data_enable_un32_d_out_mod_s_9 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_8,
      I1 => data_enable_N_1814_i,
      O => un32_d_out_mod_s_9
    );
  data_enable_un32_d_out_mod_s_8 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_7,
      I1 => data_enable_N_1813_i,
      O => un32_d_out_mod_s_8
    );
  data_enable_un32_d_out_mod_s_7 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_6,
      I1 => data_enable_N_1812_i,
      O => un32_d_out_mod_s_7
    );
  data_enable_un32_d_out_mod_s_6 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_5,
      I1 => data_enable_N_1811_i,
      O => un32_d_out_mod_s_6
    );
  data_enable_un32_d_out_mod_s_5 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_4,
      I1 => data_enable_N_1810_i,
      O => un32_d_out_mod_s_5
    );
  data_enable_un32_d_out_mod_s_4 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_3,
      I1 => data_enable_N_1809_i,
      O => un32_d_out_mod_s_4
    );
  data_enable_un32_d_out_mod_s_3 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_2,
      I1 => data_enable_N_1808_i,
      O => un32_d_out_mod_s_3
    );
  data_enable_un32_d_out_mod_s_2 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_1,
      I1 => data_enable_N_1807_i,
      O => un32_d_out_mod_s_2
    );
  data_enable_un32_d_out_mod_s_1 : X_XOR2
    port map (
      I0 => data_enable_un32_d_out_mod_cry_0,
      I1 => data_enable_N_1806_i,
      O => un32_d_out_mod_s_1
    );
  data_enable_un38_cell_buf_s_29_445 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_28,
      I1 => data_enable_un38_cell_buf_axb_29,
      O => data_enable_un38_cell_buf_s_29
    );
  data_enable_un38_cell_buf_s_28_446 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_27,
      I1 => data_enable_un38_cell_buf_axb_28,
      O => data_enable_un38_cell_buf_s_28
    );
  data_enable_un38_cell_buf_s_27_447 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_26,
      I1 => data_enable_un38_cell_buf_axb_27,
      O => data_enable_un38_cell_buf_s_27
    );
  data_enable_un38_cell_buf_s_26_448 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_25,
      I1 => data_enable_un38_cell_buf_axb_26,
      O => data_enable_un38_cell_buf_s_26
    );
  data_enable_un38_cell_buf_s_25_449 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_24,
      I1 => data_enable_un38_cell_buf_axb_25,
      O => data_enable_un38_cell_buf_s_25
    );
  data_enable_un38_cell_buf_s_24_450 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_23,
      I1 => data_enable_un38_cell_buf_axb_24,
      O => data_enable_un38_cell_buf_s_24
    );
  data_enable_un38_cell_buf_s_23_451 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_22,
      I1 => data_enable_un38_cell_buf_axb_23,
      O => data_enable_un38_cell_buf_s_23
    );
  data_enable_un38_cell_buf_s_22_452 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_21,
      I1 => data_enable_un38_cell_buf_axb_22,
      O => data_enable_un38_cell_buf_s_22
    );
  data_enable_un38_cell_buf_s_21_453 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_20,
      I1 => data_enable_un38_cell_buf_axb_21,
      O => data_enable_un38_cell_buf_s_21
    );
  data_enable_un38_cell_buf_s_20_454 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_19,
      I1 => data_enable_un38_cell_buf_axb_20,
      O => data_enable_un38_cell_buf_s_20
    );
  data_enable_un38_cell_buf_s_19_455 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_18,
      I1 => data_enable_un38_cell_buf_axb_19,
      O => data_enable_un38_cell_buf_s_19
    );
  data_enable_un38_cell_buf_s_18_456 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_17,
      I1 => data_enable_un38_cell_buf_axb_18,
      O => data_enable_un38_cell_buf_s_18
    );
  data_enable_un38_cell_buf_s_17_457 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_16,
      I1 => data_enable_un38_cell_buf_axb_17,
      O => data_enable_un38_cell_buf_s_17
    );
  data_enable_un38_cell_buf_s_16_458 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_15,
      I1 => data_enable_un38_cell_buf_axb_16,
      O => data_enable_un38_cell_buf_s_16
    );
  data_enable_un38_cell_buf_s_15_459 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_14,
      I1 => data_enable_un38_cell_buf_axb_15,
      O => data_enable_un38_cell_buf_s_15
    );
  data_enable_un38_cell_buf_s_14_460 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_13,
      I1 => data_enable_un38_cell_buf_axb_14,
      O => data_enable_un38_cell_buf_s_14
    );
  data_enable_un38_cell_buf_s_13_461 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_12,
      I1 => data_enable_un38_cell_buf_axb_13,
      O => data_enable_un38_cell_buf_s_13
    );
  data_enable_un38_cell_buf_s_12_462 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_11,
      I1 => data_enable_un38_cell_buf_axb_12,
      O => data_enable_un38_cell_buf_s_12
    );
  data_enable_un38_cell_buf_s_11_463 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_10,
      I1 => data_enable_un38_cell_buf_axb_11,
      O => data_enable_un38_cell_buf_s_11
    );
  data_enable_un38_cell_buf_s_10_464 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_9,
      I1 => data_enable_un38_cell_buf_axb_10,
      O => data_enable_un38_cell_buf_s_10
    );
  data_enable_un38_cell_buf_s_9_465 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_8,
      I1 => data_enable_un38_cell_buf_axb_9,
      O => data_enable_un38_cell_buf_s_9
    );
  data_enable_un38_cell_buf_s_8_466 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_7,
      I1 => data_enable_un38_cell_buf_axb_8,
      O => data_enable_un38_cell_buf_s_8
    );
  data_enable_un38_cell_buf_s_7_467 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_6,
      I1 => data_enable_un38_cell_buf_axb_7,
      O => data_enable_un38_cell_buf_s_7
    );
  data_enable_un38_cell_buf_s_6_468 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_5,
      I1 => data_enable_un38_cell_buf_axb_6,
      O => data_enable_un38_cell_buf_s_6
    );
  data_enable_un38_cell_buf_s_5_469 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_4,
      I1 => data_enable_un38_cell_buf_axb_5,
      O => data_enable_un38_cell_buf_s_5
    );
  data_enable_un38_cell_buf_s_4_470 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_3,
      I1 => data_enable_un38_cell_buf_axb_4,
      O => data_enable_un38_cell_buf_s_4
    );
  data_enable_un38_cell_buf_s_3_471 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_2,
      I1 => data_enable_un38_cell_buf_axb_3,
      O => data_enable_un38_cell_buf_s_3
    );
  data_enable_un38_cell_buf_s_2_472 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_1,
      I1 => data_enable_un38_cell_buf_axb_2,
      O => data_enable_un38_cell_buf_s_2
    );
  data_enable_un38_cell_buf_s_1_473 : X_XOR2
    port map (
      I0 => data_enable_un38_cell_buf_cry_0,
      I1 => data_enable_un38_cell_buf_axb_1,
      O => data_enable_un38_cell_buf_s_1
    );
  data_enable_VCC_474 : X_ONE
    port map (
      O => data_enable_VCC
    );
  data_enable_GND_475 : X_ZERO
    port map (
      O => data_enable_GND
    );
  data_enable_fwcount_cry_12_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(11),
      SEL => data_enable_fwcount_qxu(12),
      O => data_enable_fwcount_cry_12_O
    );
  data_enable_fwcount_cry_12_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_12_O,
      O => data_enable_fwcount_cry(12)
    );
  data_enable_fwcount_cry_11_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(10),
      SEL => data_enable_fwcount_qxu(11),
      O => data_enable_fwcount_cry_11_O
    );
  data_enable_fwcount_cry_11_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_11_O,
      O => data_enable_fwcount_cry(11)
    );
  data_enable_fwcount_cry_10_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(9),
      SEL => data_enable_fwcount_qxu(10),
      O => data_enable_fwcount_cry_10_O
    );
  data_enable_fwcount_cry_10_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_10_O,
      O => data_enable_fwcount_cry(10)
    );
  data_enable_fwcount_cry_9_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(8),
      SEL => data_enable_fwcount_qxu(9),
      O => data_enable_fwcount_cry_9_O
    );
  data_enable_fwcount_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_9_O,
      O => data_enable_fwcount_cry(9)
    );
  data_enable_fwcount_cry_8_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(7),
      SEL => data_enable_fwcount_qxu(8),
      O => data_enable_fwcount_cry_8_O
    );
  data_enable_fwcount_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_8_O,
      O => data_enable_fwcount_cry(8)
    );
  data_enable_fwcount_cry_7_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(6),
      SEL => data_enable_fwcount_qxu(7),
      O => data_enable_fwcount_cry_7_O
    );
  data_enable_fwcount_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_7_O,
      O => data_enable_fwcount_cry(7)
    );
  data_enable_fwcount_cry_6_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(5),
      SEL => data_enable_fwcount_qxu(6),
      O => data_enable_fwcount_cry_6_O
    );
  data_enable_fwcount_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_6_O,
      O => data_enable_fwcount_cry(6)
    );
  data_enable_fwcount_cry_5_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(4),
      SEL => data_enable_fwcount_qxu(5),
      O => data_enable_fwcount_cry_5_O
    );
  data_enable_fwcount_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_5_O,
      O => data_enable_fwcount_cry(5)
    );
  data_enable_fwcount_cry_4_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(3),
      SEL => data_enable_fwcount_qxu(4),
      O => data_enable_fwcount_cry_4_O
    );
  data_enable_fwcount_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_4_O,
      O => data_enable_fwcount_cry(4)
    );
  data_enable_fwcount_cry_3_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(2),
      SEL => data_enable_fwcount_qxu(3),
      O => data_enable_fwcount_cry_3_O
    );
  data_enable_fwcount_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_3_O,
      O => data_enable_fwcount_cry(3)
    );
  data_enable_fwcount_cry_2_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(1),
      SEL => data_enable_fwcount_qxu(2),
      O => data_enable_fwcount_cry_2_O
    );
  data_enable_fwcount_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_2_O,
      O => data_enable_fwcount_cry(2)
    );
  data_enable_fwcount_cry_1_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_fwcount_cry(0),
      SEL => data_enable_fwcount_qxu(1),
      O => data_enable_fwcount_cry_1_O
    );
  data_enable_fwcount_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_1_O,
      O => data_enable_fwcount_cry(1)
    );
  data_enable_fwcount_cry_0_Q : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_N_4674_i,
      SEL => data_enable_fwcount_qxu(0),
      O => data_enable_fwcount_cry_0_O
    );
  data_enable_fwcount_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_fwcount_cry_0_O,
      O => data_enable_fwcount_cry(0)
    );
  data_enable_output_proc_un73_state_in_cry_14 : X_MUX2
    port map (
      IA => data_enable_data_in(14),
      IB => data_enable_un73_state_in_cry_13,
      SEL => data_enable_un73_state_in_axb_14_i,
      O => data_enable_output_proc_un73_state_in_cry_14_O
    );
  data_enable_output_proc_un73_state_in_cry_14_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_14_O,
      O => data_enable_un73_state_in_cry_14
    );
  data_enable_output_proc_un73_state_in_cry_13 : X_MUX2
    port map (
      IA => data_enable_data_in(13),
      IB => data_enable_un73_state_in_cry_12,
      SEL => data_enable_un73_state_in_axb_13_i,
      O => data_enable_output_proc_un73_state_in_cry_13_O
    );
  data_enable_output_proc_un73_state_in_cry_13_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_13_O,
      O => data_enable_un73_state_in_cry_13
    );
  data_enable_output_proc_un73_state_in_cry_12 : X_MUX2
    port map (
      IA => data_enable_data_in(12),
      IB => data_enable_un73_state_in_cry_11,
      SEL => data_enable_un73_state_in_axb_12_i,
      O => data_enable_output_proc_un73_state_in_cry_12_O
    );
  data_enable_output_proc_un73_state_in_cry_12_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_12_O,
      O => data_enable_un73_state_in_cry_12
    );
  data_enable_output_proc_un73_state_in_cry_11 : X_MUX2
    port map (
      IA => data_enable_data_in(11),
      IB => data_enable_un73_state_in_cry_10,
      SEL => data_enable_un73_state_in_axb_11_i,
      O => data_enable_output_proc_un73_state_in_cry_11_O
    );
  data_enable_output_proc_un73_state_in_cry_11_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_11_O,
      O => data_enable_un73_state_in_cry_11
    );
  data_enable_output_proc_un73_state_in_cry_10 : X_MUX2
    port map (
      IA => data_enable_data_in(10),
      IB => data_enable_un73_state_in_cry_9,
      SEL => data_enable_un73_state_in_axb_10_i,
      O => data_enable_output_proc_un73_state_in_cry_10_O
    );
  data_enable_output_proc_un73_state_in_cry_10_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_10_O,
      O => data_enable_un73_state_in_cry_10
    );
  data_enable_output_proc_un73_state_in_cry_9 : X_MUX2
    port map (
      IA => data_enable_data_in(9),
      IB => data_enable_un73_state_in_cry_8,
      SEL => data_enable_un73_state_in_axb_9_i,
      O => data_enable_output_proc_un73_state_in_cry_9_O
    );
  data_enable_output_proc_un73_state_in_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_9_O,
      O => data_enable_un73_state_in_cry_9
    );
  data_enable_output_proc_un73_state_in_cry_8 : X_MUX2
    port map (
      IA => data_enable_data_in(8),
      IB => data_enable_un73_state_in_cry_7,
      SEL => data_enable_un73_state_in_axb_8_i,
      O => data_enable_output_proc_un73_state_in_cry_8_O
    );
  data_enable_output_proc_un73_state_in_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_8_O,
      O => data_enable_un73_state_in_cry_8
    );
  data_enable_output_proc_un73_state_in_cry_7 : X_MUX2
    port map (
      IA => data_enable_data_in(7),
      IB => data_enable_un73_state_in_cry_6,
      SEL => data_enable_un73_state_in_axb_7_i,
      O => data_enable_output_proc_un73_state_in_cry_7_O
    );
  data_enable_output_proc_un73_state_in_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_7_O,
      O => data_enable_un73_state_in_cry_7
    );
  data_enable_output_proc_un73_state_in_cry_6 : X_MUX2
    port map (
      IA => data_enable_data_in(6),
      IB => data_enable_un73_state_in_cry_5,
      SEL => data_enable_un73_state_in_axb_6_i,
      O => data_enable_output_proc_un73_state_in_cry_6_O
    );
  data_enable_output_proc_un73_state_in_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_6_O,
      O => data_enable_un73_state_in_cry_6
    );
  data_enable_output_proc_un73_state_in_cry_5 : X_MUX2
    port map (
      IA => data_enable_data_in(5),
      IB => data_enable_un73_state_in_cry_4,
      SEL => data_enable_un73_state_in_axb_5_i,
      O => data_enable_output_proc_un73_state_in_cry_5_O
    );
  data_enable_output_proc_un73_state_in_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_5_O,
      O => data_enable_un73_state_in_cry_5
    );
  data_enable_output_proc_un73_state_in_cry_4 : X_MUX2
    port map (
      IA => data_enable_data_in(4),
      IB => data_enable_un73_state_in_cry_3,
      SEL => data_enable_un73_state_in_axb_4_i,
      O => data_enable_output_proc_un73_state_in_cry_4_O
    );
  data_enable_output_proc_un73_state_in_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_4_O,
      O => data_enable_un73_state_in_cry_4
    );
  data_enable_output_proc_un73_state_in_cry_3 : X_MUX2
    port map (
      IA => data_enable_data_in(3),
      IB => data_enable_un73_state_in_cry_2,
      SEL => data_enable_un73_state_in_axb_3_i,
      O => data_enable_output_proc_un73_state_in_cry_3_O
    );
  data_enable_output_proc_un73_state_in_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_3_O,
      O => data_enable_un73_state_in_cry_3
    );
  data_enable_output_proc_un73_state_in_cry_2 : X_MUX2
    port map (
      IA => data_enable_data_in(2),
      IB => data_enable_un73_state_in_cry_1,
      SEL => data_enable_un73_state_in_axb_2_i,
      O => data_enable_output_proc_un73_state_in_cry_2_O
    );
  data_enable_output_proc_un73_state_in_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_2_O,
      O => data_enable_un73_state_in_cry_2
    );
  data_enable_output_proc_un73_state_in_cry_1 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un73_state_in_cry_0,
      SEL => data_enable_data_in_i(1),
      O => data_enable_output_proc_un73_state_in_cry_1_O
    );
  data_enable_output_proc_un73_state_in_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_1_O,
      O => data_enable_un73_state_in_cry_1
    );
  data_enable_output_proc_un73_state_in_cry_0 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_GND,
      SEL => data_enable_data_in_i(0),
      O => data_enable_output_proc_un73_state_in_cry_0_O
    );
  data_enable_output_proc_un73_state_in_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_output_proc_un73_state_in_cry_0_O,
      O => data_enable_un73_state_in_cry_0
    );
  data_enable_un32_d_out_mod_cry_28_476 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_27,
      SEL => data_enable_N_1833_i,
      O => data_enable_un32_d_out_mod_cry_28_O
    );
  data_enable_un32_d_out_mod_cry_28_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_28_O,
      O => data_enable_un32_d_out_mod_cry_28
    );
  data_enable_un32_d_out_mod_cry_27_477 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_26,
      SEL => data_enable_N_1832_i,
      O => data_enable_un32_d_out_mod_cry_27_O
    );
  data_enable_un32_d_out_mod_cry_27_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_27_O,
      O => data_enable_un32_d_out_mod_cry_27
    );
  data_enable_un32_d_out_mod_cry_26_478 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_25,
      SEL => data_enable_N_1831_i,
      O => data_enable_un32_d_out_mod_cry_26_O
    );
  data_enable_un32_d_out_mod_cry_26_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_26_O,
      O => data_enable_un32_d_out_mod_cry_26
    );
  data_enable_un32_d_out_mod_cry_25_479 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_24,
      SEL => data_enable_N_1830_i,
      O => data_enable_un32_d_out_mod_cry_25_O
    );
  data_enable_un32_d_out_mod_cry_25_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_25_O,
      O => data_enable_un32_d_out_mod_cry_25
    );
  data_enable_un32_d_out_mod_cry_24_480 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_23,
      SEL => data_enable_N_1829_i,
      O => data_enable_un32_d_out_mod_cry_24_O
    );
  data_enable_un32_d_out_mod_cry_24_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_24_O,
      O => data_enable_un32_d_out_mod_cry_24
    );
  data_enable_un32_d_out_mod_cry_23_481 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_22,
      SEL => data_enable_N_1828_i,
      O => data_enable_un32_d_out_mod_cry_23_O
    );
  data_enable_un32_d_out_mod_cry_23_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_23_O,
      O => data_enable_un32_d_out_mod_cry_23
    );
  data_enable_un32_d_out_mod_cry_22_482 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_21,
      SEL => data_enable_N_1827_i,
      O => data_enable_un32_d_out_mod_cry_22_O
    );
  data_enable_un32_d_out_mod_cry_22_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_22_O,
      O => data_enable_un32_d_out_mod_cry_22
    );
  data_enable_un32_d_out_mod_cry_21_483 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_20,
      SEL => data_enable_N_1826_i,
      O => data_enable_un32_d_out_mod_cry_21_O
    );
  data_enable_un32_d_out_mod_cry_21_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_21_O,
      O => data_enable_un32_d_out_mod_cry_21
    );
  data_enable_un32_d_out_mod_cry_20_484 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_19,
      SEL => data_enable_N_1825_i,
      O => data_enable_un32_d_out_mod_cry_20_O
    );
  data_enable_un32_d_out_mod_cry_20_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_20_O,
      O => data_enable_un32_d_out_mod_cry_20
    );
  data_enable_un32_d_out_mod_cry_19_485 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_18,
      SEL => data_enable_N_1824_i,
      O => data_enable_un32_d_out_mod_cry_19_O
    );
  data_enable_un32_d_out_mod_cry_19_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_19_O,
      O => data_enable_un32_d_out_mod_cry_19
    );
  data_enable_un32_d_out_mod_cry_18_486 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_17,
      SEL => data_enable_N_1823_i,
      O => data_enable_un32_d_out_mod_cry_18_O
    );
  data_enable_un32_d_out_mod_cry_18_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_18_O,
      O => data_enable_un32_d_out_mod_cry_18
    );
  data_enable_un32_d_out_mod_cry_17_487 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_16,
      SEL => data_enable_N_1822_i,
      O => data_enable_un32_d_out_mod_cry_17_O
    );
  data_enable_un32_d_out_mod_cry_17_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_17_O,
      O => data_enable_un32_d_out_mod_cry_17
    );
  data_enable_un32_d_out_mod_cry_16_488 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_15,
      SEL => data_enable_N_1821_i,
      O => data_enable_un32_d_out_mod_cry_16_O
    );
  data_enable_un32_d_out_mod_cry_16_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_16_O,
      O => data_enable_un32_d_out_mod_cry_16
    );
  data_enable_un32_d_out_mod_cry_15_489 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_14,
      SEL => data_enable_N_1820_i,
      O => data_enable_un32_d_out_mod_cry_15_O
    );
  data_enable_un32_d_out_mod_cry_15_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_15_O,
      O => data_enable_un32_d_out_mod_cry_15
    );
  data_enable_un32_d_out_mod_cry_14_490 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_13,
      SEL => data_enable_N_1819_i,
      O => data_enable_un32_d_out_mod_cry_14_O
    );
  data_enable_un32_d_out_mod_cry_14_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_14_O,
      O => data_enable_un32_d_out_mod_cry_14
    );
  data_enable_un32_d_out_mod_cry_13_491 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_12,
      SEL => data_enable_N_1818_i,
      O => data_enable_un32_d_out_mod_cry_13_O
    );
  data_enable_un32_d_out_mod_cry_13_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_13_O,
      O => data_enable_un32_d_out_mod_cry_13
    );
  data_enable_un32_d_out_mod_cry_12_492 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_11,
      SEL => data_enable_N_1817_i,
      O => data_enable_un32_d_out_mod_cry_12_O
    );
  data_enable_un32_d_out_mod_cry_12_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_12_O,
      O => data_enable_un32_d_out_mod_cry_12
    );
  data_enable_un32_d_out_mod_cry_11_493 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_10,
      SEL => data_enable_N_1816_i,
      O => data_enable_un32_d_out_mod_cry_11_O
    );
  data_enable_un32_d_out_mod_cry_11_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_11_O,
      O => data_enable_un32_d_out_mod_cry_11
    );
  data_enable_un32_d_out_mod_cry_10_494 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_9,
      SEL => data_enable_N_1815_i,
      O => data_enable_un32_d_out_mod_cry_10_O
    );
  data_enable_un32_d_out_mod_cry_10_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_10_O,
      O => data_enable_un32_d_out_mod_cry_10
    );
  data_enable_un32_d_out_mod_cry_9_495 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_8,
      SEL => data_enable_N_1814_i,
      O => data_enable_un32_d_out_mod_cry_9_O
    );
  data_enable_un32_d_out_mod_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_9_O,
      O => data_enable_un32_d_out_mod_cry_9
    );
  data_enable_un32_d_out_mod_cry_8_496 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_7,
      SEL => data_enable_N_1813_i,
      O => data_enable_un32_d_out_mod_cry_8_O
    );
  data_enable_un32_d_out_mod_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_8_O,
      O => data_enable_un32_d_out_mod_cry_8
    );
  data_enable_un32_d_out_mod_cry_7_497 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_6,
      SEL => data_enable_N_1812_i,
      O => data_enable_un32_d_out_mod_cry_7_O
    );
  data_enable_un32_d_out_mod_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_7_O,
      O => data_enable_un32_d_out_mod_cry_7
    );
  data_enable_un32_d_out_mod_cry_6_498 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_5,
      SEL => data_enable_N_1811_i,
      O => data_enable_un32_d_out_mod_cry_6_O
    );
  data_enable_un32_d_out_mod_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_6_O,
      O => data_enable_un32_d_out_mod_cry_6
    );
  data_enable_un32_d_out_mod_cry_5_499 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_4,
      SEL => data_enable_N_1810_i,
      O => data_enable_un32_d_out_mod_cry_5_O
    );
  data_enable_un32_d_out_mod_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_5_O,
      O => data_enable_un32_d_out_mod_cry_5
    );
  data_enable_un32_d_out_mod_cry_4_500 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_3,
      SEL => data_enable_N_1809_i,
      O => data_enable_un32_d_out_mod_cry_4_O
    );
  data_enable_un32_d_out_mod_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_4_O,
      O => data_enable_un32_d_out_mod_cry_4
    );
  data_enable_un32_d_out_mod_cry_3_501 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_2,
      SEL => data_enable_N_1808_i,
      O => data_enable_un32_d_out_mod_cry_3_O
    );
  data_enable_un32_d_out_mod_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_3_O,
      O => data_enable_un32_d_out_mod_cry_3
    );
  data_enable_un32_d_out_mod_cry_2_502 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_1,
      SEL => data_enable_N_1807_i,
      O => data_enable_un32_d_out_mod_cry_2_O
    );
  data_enable_un32_d_out_mod_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_2_O,
      O => data_enable_un32_d_out_mod_cry_2
    );
  data_enable_un32_d_out_mod_cry_1_503 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_un32_d_out_mod_cry_0,
      SEL => data_enable_N_1806_i,
      O => data_enable_un32_d_out_mod_cry_1_O
    );
  data_enable_un32_d_out_mod_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_1_O,
      O => data_enable_un32_d_out_mod_cry_1
    );
  data_enable_un32_d_out_mod_cry_0_504 : X_MUX2
    port map (
      IA => data_enable_VCC,
      IB => data_enable_GND,
      SEL => data_enable_N_1805_i,
      O => data_enable_un32_d_out_mod_cry_0_O
    );
  data_enable_un32_d_out_mod_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un32_d_out_mod_cry_0_O,
      O => data_enable_un32_d_out_mod_cry_0
    );
  data_enable_un38_cell_buf_cry_28_505 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_27,
      SEL => data_enable_un38_cell_buf_axb_28,
      O => data_enable_un38_cell_buf_cry_28_O
    );
  data_enable_un38_cell_buf_cry_28_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_28_O,
      O => data_enable_un38_cell_buf_cry_28
    );
  data_enable_un38_cell_buf_cry_27_506 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_26,
      SEL => data_enable_un38_cell_buf_axb_27,
      O => data_enable_un38_cell_buf_cry_27_O
    );
  data_enable_un38_cell_buf_cry_27_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_27_O,
      O => data_enable_un38_cell_buf_cry_27
    );
  data_enable_un38_cell_buf_cry_26_507 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_25,
      SEL => data_enable_un38_cell_buf_axb_26,
      O => data_enable_un38_cell_buf_cry_26_O
    );
  data_enable_un38_cell_buf_cry_26_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_26_O,
      O => data_enable_un38_cell_buf_cry_26
    );
  data_enable_un38_cell_buf_cry_25_508 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_24,
      SEL => data_enable_un38_cell_buf_axb_25,
      O => data_enable_un38_cell_buf_cry_25_O
    );
  data_enable_un38_cell_buf_cry_25_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_25_O,
      O => data_enable_un38_cell_buf_cry_25
    );
  data_enable_un38_cell_buf_cry_24_509 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_23,
      SEL => data_enable_un38_cell_buf_axb_24,
      O => data_enable_un38_cell_buf_cry_24_O
    );
  data_enable_un38_cell_buf_cry_24_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_24_O,
      O => data_enable_un38_cell_buf_cry_24
    );
  data_enable_un38_cell_buf_cry_23_510 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_22,
      SEL => data_enable_un38_cell_buf_axb_23,
      O => data_enable_un38_cell_buf_cry_23_O
    );
  data_enable_un38_cell_buf_cry_23_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_23_O,
      O => data_enable_un38_cell_buf_cry_23
    );
  data_enable_un38_cell_buf_cry_22_511 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_21,
      SEL => data_enable_un38_cell_buf_axb_22,
      O => data_enable_un38_cell_buf_cry_22_O
    );
  data_enable_un38_cell_buf_cry_22_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_22_O,
      O => data_enable_un38_cell_buf_cry_22
    );
  data_enable_un38_cell_buf_cry_21_512 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_20,
      SEL => data_enable_un38_cell_buf_axb_21,
      O => data_enable_un38_cell_buf_cry_21_O
    );
  data_enable_un38_cell_buf_cry_21_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_21_O,
      O => data_enable_un38_cell_buf_cry_21
    );
  data_enable_un38_cell_buf_cry_20_513 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_19,
      SEL => data_enable_un38_cell_buf_axb_20,
      O => data_enable_un38_cell_buf_cry_20_O
    );
  data_enable_un38_cell_buf_cry_20_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_20_O,
      O => data_enable_un38_cell_buf_cry_20
    );
  data_enable_un38_cell_buf_cry_19_514 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_18,
      SEL => data_enable_un38_cell_buf_axb_19,
      O => data_enable_un38_cell_buf_cry_19_O
    );
  data_enable_un38_cell_buf_cry_19_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_19_O,
      O => data_enable_un38_cell_buf_cry_19
    );
  data_enable_un38_cell_buf_cry_18_515 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_17,
      SEL => data_enable_un38_cell_buf_axb_18,
      O => data_enable_un38_cell_buf_cry_18_O
    );
  data_enable_un38_cell_buf_cry_18_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_18_O,
      O => data_enable_un38_cell_buf_cry_18
    );
  data_enable_un38_cell_buf_cry_17_516 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_16,
      SEL => data_enable_un38_cell_buf_axb_17,
      O => data_enable_un38_cell_buf_cry_17_O
    );
  data_enable_un38_cell_buf_cry_17_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_17_O,
      O => data_enable_un38_cell_buf_cry_17
    );
  data_enable_un38_cell_buf_cry_16_517 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_15,
      SEL => data_enable_un38_cell_buf_axb_16,
      O => data_enable_un38_cell_buf_cry_16_O
    );
  data_enable_un38_cell_buf_cry_16_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_16_O,
      O => data_enable_un38_cell_buf_cry_16
    );
  data_enable_un38_cell_buf_cry_15_518 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_14,
      SEL => data_enable_un38_cell_buf_axb_15,
      O => data_enable_un38_cell_buf_cry_15_O
    );
  data_enable_un38_cell_buf_cry_15_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_15_O,
      O => data_enable_un38_cell_buf_cry_15
    );
  data_enable_un38_cell_buf_cry_14_519 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_13,
      SEL => data_enable_un38_cell_buf_axb_14,
      O => data_enable_un38_cell_buf_cry_14_O
    );
  data_enable_un38_cell_buf_cry_14_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_14_O,
      O => data_enable_un38_cell_buf_cry_14
    );
  data_enable_un38_cell_buf_cry_13_520 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_12,
      SEL => data_enable_un38_cell_buf_axb_13,
      O => data_enable_un38_cell_buf_cry_13_O
    );
  data_enable_un38_cell_buf_cry_13_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_13_O,
      O => data_enable_un38_cell_buf_cry_13
    );
  data_enable_un38_cell_buf_cry_12_521 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_11,
      SEL => data_enable_un38_cell_buf_axb_12,
      O => data_enable_un38_cell_buf_cry_12_O
    );
  data_enable_un38_cell_buf_cry_12_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_12_O,
      O => data_enable_un38_cell_buf_cry_12
    );
  data_enable_un38_cell_buf_cry_11_522 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_10,
      SEL => data_enable_un38_cell_buf_axb_11,
      O => data_enable_un38_cell_buf_cry_11_O
    );
  data_enable_un38_cell_buf_cry_11_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_11_O,
      O => data_enable_un38_cell_buf_cry_11
    );
  data_enable_un38_cell_buf_cry_10_523 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_9,
      SEL => data_enable_un38_cell_buf_axb_10,
      O => data_enable_un38_cell_buf_cry_10_O
    );
  data_enable_un38_cell_buf_cry_10_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_10_O,
      O => data_enable_un38_cell_buf_cry_10
    );
  data_enable_un38_cell_buf_cry_9_524 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_8,
      SEL => data_enable_un38_cell_buf_axb_9,
      O => data_enable_un38_cell_buf_cry_9_O
    );
  data_enable_un38_cell_buf_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_9_O,
      O => data_enable_un38_cell_buf_cry_9
    );
  data_enable_un38_cell_buf_cry_8_525 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_7,
      SEL => data_enable_un38_cell_buf_axb_8,
      O => data_enable_un38_cell_buf_cry_8_O
    );
  data_enable_un38_cell_buf_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_8_O,
      O => data_enable_un38_cell_buf_cry_8
    );
  data_enable_un38_cell_buf_cry_7_526 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_6,
      SEL => data_enable_un38_cell_buf_axb_7,
      O => data_enable_un38_cell_buf_cry_7_O
    );
  data_enable_un38_cell_buf_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_7_O,
      O => data_enable_un38_cell_buf_cry_7
    );
  data_enable_un38_cell_buf_cry_6_527 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_5,
      SEL => data_enable_un38_cell_buf_axb_6,
      O => data_enable_un38_cell_buf_cry_6_O
    );
  data_enable_un38_cell_buf_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_6_O,
      O => data_enable_un38_cell_buf_cry_6
    );
  data_enable_un38_cell_buf_cry_5_528 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_4,
      SEL => data_enable_un38_cell_buf_axb_5,
      O => data_enable_un38_cell_buf_cry_5_O
    );
  data_enable_un38_cell_buf_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_5_O,
      O => data_enable_un38_cell_buf_cry_5
    );
  data_enable_un38_cell_buf_cry_4_529 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_3,
      SEL => data_enable_un38_cell_buf_axb_4,
      O => data_enable_un38_cell_buf_cry_4_O
    );
  data_enable_un38_cell_buf_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_4_O,
      O => data_enable_un38_cell_buf_cry_4
    );
  data_enable_un38_cell_buf_cry_3_530 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_2,
      SEL => data_enable_un38_cell_buf_axb_3,
      O => data_enable_un38_cell_buf_cry_3_O
    );
  data_enable_un38_cell_buf_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_3_O,
      O => data_enable_un38_cell_buf_cry_3
    );
  data_enable_un38_cell_buf_cry_2_531 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_1,
      SEL => data_enable_un38_cell_buf_axb_2,
      O => data_enable_un38_cell_buf_cry_2_O
    );
  data_enable_un38_cell_buf_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_2_O,
      O => data_enable_un38_cell_buf_cry_2
    );
  data_enable_un38_cell_buf_cry_1_532 : X_MUX2
    port map (
      IA => data_enable_GND,
      IB => data_enable_un38_cell_buf_cry_0,
      SEL => data_enable_un38_cell_buf_axb_1,
      O => data_enable_un38_cell_buf_cry_1_O
    );
  data_enable_un38_cell_buf_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => data_enable_un38_cell_buf_cry_1_O,
      O => data_enable_un38_cell_buf_cry_1
    );
  data_enable_state_out_h_state_out_5_rep1 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_h_N_1155_i,
      O => data_enable_state_out_5_rep1,
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_out_h_state_out_fast_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_h_N_1155_i,
      O => data_enable_state_out_fast(5),
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_5_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_state_in_4_Q,
      ADR1 => data_enable_state_out_3_Q,
      O => data_enable_N_7748
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_4_Q : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_state_out_4_Q,
      ADR2 => data_enable_buf_flag,
      O => data_enable_state_out_h_N_7751
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_0_7_Q : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => data_enable_out_sm_proc_un57_state_in,
      ADR1 => data_enable_state_out_3_Q,
      ADR2 => data_enable_state_in_4_Q,
      O => data_enable_N_7745
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_0_1_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_state_in_4_Q,
      ADR1 => data_enable_state_out_h_state_out(7),
      O => data_enable_N_7757
    );
  data_enable_state_out_h_state_out_ns_and2_0_and2_0_and2_0_and2_0_Q : X_LUT4
    generic map(
      INIT => X"4454"
    )
    port map (
      ADR0 => data_enable_buf_flag,
      ADR1 => data_enable_state_out_0_Q,
      ADR2 => data_enable_state_out_8_Q,
      ADR3 => data_enable_soc_in,
      O => data_enable_state_out_h_state_out_ns(0)
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_2_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => data_enable_N_7316,
      ADR1 => data_enable_buf_flag,
      ADR2 => data_enable_lc_flag,
      O => data_enable_state_out_h_N_7753
    );
  data_enable_state_out_h_state_out_ns_i_0_0_0_and2_3_Q : X_LUT3
    generic map(
      INIT => X"40"
    )
    port map (
      ADR0 => data_enable_out_sm_proc_un6_lc_copy_NE,
      ADR1 => data_enable_lc_flag,
      ADR2 => data_enable_state_out_2_Q,
      O => data_enable_state_out_h_N_7740
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_1_5_Q : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => data_enable_data_in(1),
      ADR1 => data_enable_soc_in,
      ADR2 => data_enable_state_out_4_Q,
      ADR3 => data_enable_buf_flag,
      O => data_enable_N_7750
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_7_Q : X_LUT4
    generic map(
      INIT => X"B000"
    )
    port map (
      ADR0 => data_enable_N_8049,
      ADR1 => data_enable_out_sm_proc_un6_lc_copy_NE,
      ADR2 => data_enable_state_out_5_Q,
      ADR3 => data_enable_lc_copy,
      O => data_enable_N_7744
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_1_Q : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => data_enable_N_7316,
      ADR1 => data_enable_lc_flag,
      ADR2 => data_enable_buf_flag,
      O => data_enable_state_out_h_N_7756
    );
  data_enable_state_out_h_state_out_ns_0_0_0_and2_0_4_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => data_enable_N_8049,
      ADR1 => data_enable_state_out_5_Q,
      ADR2 => data_enable_lc_copy,
      O => data_enable_state_out_h_N_7752
    );
  data_enable_state_out_h_state_out_ns_i_0_0_0_3_554_533 : X_LUT4
    generic map(
      INIT => X"1311"
    )
    port map (
      ADR0 => data_enable_state_out_5_Q,
      ADR1 => G_6_0_0_0_or2,
      ADR2 => data_enable_out_sm_proc_un6_lc_copy_NE,
      ADR3 => data_enable_lc_copy,
      O => data_enable_state_out_h_state_out_ns_i_0_0_0_3_554
    );
  data_enable_state_out_h_N_1155_i_534 : X_LUT4
    generic map(
      INIT => X"1101"
    )
    port map (
      ADR0 => data_enable_state_out_h_state_out_ns_i_0_0_0_3_554,
      ADR1 => data_enable_state_out_h_N_7740,
      ADR2 => data_enable_N_8049,
      ADR3 => G_6_0_0_0_or2,
      O => data_enable_state_out_h_N_1155_i
    );
  data_enable_state_out_h_state_out_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_h_N_1155_i,
      O => data_enable_state_out_5_Q,
      SRST => Reset_l_i_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_out_h_state_out_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_h_N_7751,
      O => data_enable_state_out_4_Q,
      SRST => Reset_l_i_3,
      SSET => data_enable_state_out_h_N_7752,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_out_h_state_out_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_907,
      O => data_enable_state_out_3_Q,
      SRST => Reset_l_i_2,
      SSET => data_enable_N_7748,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_out_h_state_out_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_908,
      O => data_enable_state_out_2_Q,
      SRST => Reset_l_i_2,
      SSET => data_enable_N_7734,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_out_h_state_out_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_909,
      O => data_enable_state_out_1_Q,
      SRST => Reset_l_i_2,
      SSET => data_enable_state_out_h_N_7740,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_out_h_state_out_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_1_Q,
      O => data_enable_state_out_0_Q,
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_out_h_state_out_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_out_h_state_out_ns(0),
      O => data_enable_state_out_8_Q,
      SSET => Reset_l_i_2,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  data_enable_state_out_h_state_out_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_913,
      O => data_enable_state_out_h_state_out(7),
      SRST => Reset_l_i_2,
      SSET => data_enable_state_out_h_N_7756,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_out_h_state_out_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_914,
      O => data_enable_state_out_6_Q,
      SRST => Reset_l_i_2,
      SSET => data_enable_state_out_h_N_7753,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_in_h_state_in_ns_0_0_0_and2_7_Q : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_state_in_h_state_in_0_Q,
      O => data_enable_state_in_h_N_7738
    );
  data_enable_state_in_h_state_in_ns_i_i_0_0_and2_1_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => data_enable_soc_in,
      ADR1 => data_enable_state_in_h_state_in_0_Q,
      O => data_enable_state_in_h_N_7763
    );
  data_enable_state_in_h_state_in_ns_i_0_0_0_and2_0_2_28_535 : X_LUT3
    generic map(
      INIT => X"02"
    )
    port map (
      ADR0 => data_enable_cwcount_in(3),
      ADR1 => data_enable_cwcount_in(2),
      ADR2 => data_enable_state_in_h_state_in_6_Q,
      O => data_enable_state_in_h_state_in_ns_i_0_0_0_and2_0_2_28
    );
  data_enable_state_in_h_N_1121_i_536 : X_LUT4
    generic map(
      INIT => X"0EEE"
    )
    port map (
      ADR0 => data_enable_state_in_5_Q,
      ADR1 => data_enable_state_in_h_state_in_6_Q,
      ADR2 => data_enable_state_in_h_state_in_ns_i_0_0_0_and2_0_2_28,
      ADR3 => N_1014_3,
      O => data_enable_state_in_h_N_1121_i
    );
  data_enable_state_in_h_state_in_6_Q_537 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_in_h_N_7763,
      O => data_enable_state_in_h_state_in_6_Q,
      SRST => Reset_l_i_2,
      SSET => data_enable_N_7586,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_in_h_state_in_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_in_h_N_1121_i,
      O => data_enable_state_in_5_Q,
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_in_h_state_in_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_905,
      O => data_enable_state_in_4_Q,
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_in_h_state_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_in_4_Q,
      O => data_enable_state_in_3_Q,
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_in_h_state_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_906,
      O => data_enable_state_in(2),
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_in_h_state_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_in(2),
      O => data_enable_state_in(1),
      SRST => Reset_l_i_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  data_enable_state_in_h_state_in_0_Q_538 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data_enable_state_in(1),
      O => data_enable_state_in_h_state_in_0_Q,
      SRST => Reset_l_i_2,
      SSET => data_enable_state_in_h_N_7738,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  data_enable_state_in_h_state_in_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_910,
      O => data_enable_state_in_7_Q,
      SSET => Reset_l_i_2,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_N_541_i_539 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(0),
      O => segment_N_541_i,
      ADR1 => GND
    );
  segment_N_542_i_540 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(1),
      O => segment_N_542_i,
      ADR1 => GND
    );
  segment_N_543_i_541 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(2),
      O => segment_N_543_i,
      ADR1 => GND
    );
  segment_N_544_i_542 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(3),
      O => segment_N_544_i,
      ADR1 => GND
    );
  segment_N_545_i_543 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(4),
      O => segment_N_545_i,
      ADR1 => GND
    );
  segment_N_546_i_544 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(5),
      O => segment_N_546_i,
      ADR1 => GND
    );
  segment_N_547_i_545 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(6),
      O => segment_N_547_i,
      ADR1 => GND
    );
  segment_N_548_i_546 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(7),
      O => segment_N_548_i,
      ADR1 => GND
    );
  segment_N_549_i_547 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(8),
      O => segment_N_549_i,
      ADR1 => GND
    );
  segment_N_550_i_548 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(9),
      O => segment_N_550_i,
      ADR1 => GND
    );
  segment_N_551_i_549 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(10),
      O => segment_N_551_i,
      ADR1 => GND
    );
  segment_N_552_i_550 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(11),
      O => segment_N_552_i,
      ADR1 => GND
    );
  segment_N_553_i_551 : X_LUT2
    generic map(
      INIT => X"5"
    )
    port map (
      ADR0 => segment_total_len(12),
      O => segment_N_553_i,
      ADR1 => GND
    );
  segment_un1_out_count_1_axb_0_552 : X_LUT3
    generic map(
      INIT => X"56"
    )
    port map (
      ADR0 => segment_out_count(0),
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_state_6_Q,
      O => segment_un1_out_count_1_axb_0
    );
  segment_un1_out_count_1_axb_1_553 : X_LUT3
    generic map(
      INIT => X"56"
    )
    port map (
      ADR0 => segment_out_count_2(1),
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_state_6_Q,
      O => segment_un1_out_count_1_axb_1
    );
  segment_un1_out_count_1_axb_2_554 : X_LUT3
    generic map(
      INIT => X"56"
    )
    port map (
      ADR0 => segment_out_count_2(2),
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_state_6_Q,
      O => segment_un1_out_count_1_axb_2
    );
  segment_total_len_qxu_0_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(0),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(0)
    );
  segment_total_len_qxu_1_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(1),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(1)
    );
  segment_total_len_qxu_2_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(2),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(2)
    );
  segment_total_len_qxu_3_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(3),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(3)
    );
  segment_total_len_qxu_4_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(4),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(4)
    );
  segment_total_len_qxu_5_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(5),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(5)
    );
  segment_total_len_qxu_6_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(6),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(6)
    );
  segment_total_len_qxu_7_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(7),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(7)
    );
  segment_total_len_qxu_8_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(8),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(8)
    );
  segment_total_len_qxu_9_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(9),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(9)
    );
  segment_total_len_qxu_10_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(10),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(10)
    );
  segment_total_len_qxu_11_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(11),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(11)
    );
  segment_total_len_qxu_12_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(12),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(12)
    );
  segment_fifo_rst_555 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => Reset_l_i,
      O => segment_fifo_rst,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  segment_total_len_0_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(0),
      O => segment_total_len(0),
      SET => GND,
      RST => GSR
    );
  segment_total_len_1_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(1),
      O => segment_total_len(1),
      SET => GND,
      RST => GSR
    );
  segment_total_len_2_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(2),
      O => segment_total_len(2),
      SET => GND,
      RST => GSR
    );
  segment_total_len_3_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(3),
      O => segment_total_len(3),
      SET => GND,
      RST => GSR
    );
  segment_total_len_4_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(4),
      O => segment_total_len(4),
      SET => GND,
      RST => GSR
    );
  segment_total_len_5_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(5),
      O => segment_total_len(5),
      SET => GND,
      RST => GSR
    );
  segment_total_len_6_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(6),
      O => segment_total_len(6),
      SET => GND,
      RST => GSR
    );
  segment_total_len_7_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(7),
      O => segment_total_len(7),
      SET => GND,
      RST => GSR
    );
  segment_total_len_8_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(8),
      O => segment_total_len(8),
      SET => GND,
      RST => GSR
    );
  segment_total_len_9_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(9),
      O => segment_total_len(9),
      SET => GND,
      RST => GSR
    );
  segment_total_len_10_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(10),
      O => segment_total_len(10),
      SET => GND,
      RST => GSR
    );
  segment_total_len_11_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(11),
      O => segment_total_len(11),
      SET => GND,
      RST => GSR
    );
  segment_total_len_12_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(12),
      O => segment_total_len(12),
      SET => GND,
      RST => GSR
    );
  segment_total_len_13_Q : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_G_9_0_0,
      CLK => CLK,
      I => segment_total_len_s(13),
      O => segment_total_len(13),
      SET => GND,
      RST => GSR
    );
  segment_N_554_i_556 : X_INV
    port map (
      I => segment_total_len(13),
      O => segment_N_554_i
    );
  segment_G_848_fast_557 : X_LUT4
    generic map(
      INIT => X"1011"
    )
    port map (
      ADR0 => segment_out_state_2_Q,
      ADR1 => segment_N_1386,
      ADR2 => segment_first_cell,
      ADR3 => segment_out_state_6_Q,
      O => segment_G_848_fast
    );
  segment_G_846_fast_558 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => segment_N_1666,
      ADR1 => segment_first_cell,
      ADR2 => segment_out_state_6_Q,
      O => segment_G_846_fast
    );
  segment_in_count_6_4_Q : X_LUT4
    generic map(
      INIT => X"5AA2"
    )
    port map (
      ADR0 => segment_in_count(4),
      ADR1 => segment_in_count(5),
      ADR2 => segment_in_count(2),
      ADR3 => segment_in_count(3),
      O => segment_in_count_6(4)
    );
  segment_in_count_6_5_Q : X_LUT4
    generic map(
      INIT => X"6AA2"
    )
    port map (
      ADR0 => segment_in_count(5),
      ADR1 => segment_in_count(4),
      ADR2 => segment_in_count(2),
      ADR3 => segment_in_count(3),
      O => segment_in_count_6(5)
    );
  segment_in_machine_in_count_13_2_Q : X_LUT4
    generic map(
      INIT => X"8BB8"
    )
    port map (
      ADR0 => segment_sof_in,
      ADR1 => segment_N_8,
      ADR2 => segment_in_state_h_in_state(0),
      ADR3 => segment_in_count(2),
      O => segment_in_count_13(2)
    );
  segment_in_machine_in_count_13_0_Q : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => segment_N_8,
      ADR1 => segment_in_state_h_in_state(0),
      ADR2 => segment_in_count(0),
      ADR3 => segment_data_in(0),
      O => segment_in_count_13(0)
    );
  segment_in_machine_in_count_13_1_Q : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => segment_N_8,
      ADR1 => segment_in_state_h_in_state(0),
      ADR2 => segment_in_count(1),
      ADR3 => segment_data_in(1),
      O => segment_in_count_13(1)
    );
  segment_in_machine_in_count_13_3_Q : X_LUT4
    generic map(
      INIT => X"1450"
    )
    port map (
      ADR0 => segment_N_8,
      ADR1 => segment_in_state_h_in_state(0),
      ADR2 => segment_in_count(3),
      ADR3 => segment_in_count(2),
      O => segment_in_count_13(3)
    );
  segment_in_machine_in_count_13_4_Q : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => segment_N_8,
      ADR1 => segment_in_state_h_in_state(0),
      ADR2 => segment_in_count_6(4),
      ADR3 => segment_in_count(4),
      O => segment_in_count_13(4)
    );
  segment_in_machine_in_count_13_5_Q : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => segment_N_8,
      ADR1 => segment_in_state_h_in_state(0),
      ADR2 => segment_in_count_6(5),
      ADR3 => segment_in_count(5),
      O => segment_in_count_13(5)
    );
  segment_in_machine_in_count_13_6_Q : X_LUT3
    generic map(
      INIT => X"45"
    )
    port map (
      ADR0 => segment_N_8,
      ADR1 => segment_in_count(6),
      ADR2 => segment_in_state_h_in_state(0),
      O => segment_in_count_13(6)
    );
  segment_un1_in_state_559 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => segment_eof_in,
      ADR1 => segment_in_state_h_in_state(1),
      ADR2 => segment_un22_dataen_in,
      ADR3 => segment_un27_dataen_in,
      O => segment_un1_in_state
    );
  segment_in_machine_in_count_13_sn_G_6_i : X_LUT3
    generic map(
      INIT => X"AE"
    )
    port map (
      ADR0 => segment_sof_in,
      ADR1 => segment_eof_in,
      ADR2 => segment_in_state_h_in_state(1),
      O => segment_N_8
    );
  segment_un17_lfifo_we_560 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => segment_dataen_in,
      ADR1 => segment_un8_lfifo_we_5,
      ADR2 => segment_in_state_h_in_state(1),
      ADR3 => segment_in_state_h_in_state(0),
      O => segment_un17_lfifo_we
    );
  segment_in_machine_un9_dataen_in : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => segment_sof_in,
      ADR1 => segment_dataen_in,
      O => segment_un9_dataen_in
    );
  segment_counters_out_count_4_1_0_Q : X_LUT4
    generic map(
      INIT => X"8BB8"
    )
    port map (
      ADR0 => segment_lfifo_out(2),
      ADR1 => segment_out_state_6_Q,
      ADR2 => segment_out_count(0),
      ADR3 => segment_out_state_4_Q,
      O => segment_N_264
    );
  segment_counters_out_count_4_1_1_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => segment_un1_out_count_1_s_1,
      ADR1 => segment_lfifo_out(3),
      ADR2 => segment_out_state_6_Q,
      O => segment_N_265
    );
  segment_un1_out_count_1_axb_3_561 : X_LUT3
    generic map(
      INIT => X"56"
    )
    port map (
      ADR0 => segment_out_count_2(3),
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_state_6_Q,
      O => segment_un1_out_count_1_axb_3
    );
  segment_G_939 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => segment_out_state_6_Q,
      ADR1 => segment_first_cell,
      O => segment_N_1381
    );
  segment_G_949 : X_LUT4
    generic map(
      INIT => X"BAAA"
    )
    port map (
      ADR0 => segment_out_state_0_Q,
      ADR1 => segment_N_1399,
      ADR2 => segment_cur_len_3(0),
      ADR3 => segment_out_state_3_Q,
      O => segment_N_1391
    );
  segment_G_944 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => Reset_l_i_5,
      ADR1 => segment_out_state_3_Q,
      ADR2 => segment_soc_out,
      O => segment_N_1386
    );
  segment_G_934 : X_LUT3
    generic map(
      INIT => X"04"
    )
    port map (
      ADR0 => segment_soc_out,
      ADR1 => segment_out_count(0),
      ADR2 => segment_N_650,
      O => segment_N_1752
    );
  segment_G_181 : X_LUT4
    generic map(
      INIT => X"AAA8"
    )
    port map (
      ADR0 => segment_cur_len_3(0),
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_state_3_Q,
      ADR3 => segment_soc_out,
      O => segment_un1_cur_len_1_c1
    );
  segment_G_183 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_cur_len(1),
      ADR1 => segment_un1_cur_len_1_c1,
      O => segment_un1_cur_len_1_c2
    );
  segment_G_952 : X_LUT4
    generic map(
      INIT => X"577F"
    )
    port map (
      ADR0 => segment_cur_len(3),
      ADR1 => segment_cur_len(2),
      ADR2 => segment_cur_len(1),
      ADR3 => segment_cur_len_3(0),
      O => segment_N_1394
    );
  segment_G_966 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => segment_cur_len_3(0),
      ADR1 => segment_cur_len(3),
      O => segment_N_1408
    );
  segment_un5_lfifo_re_0_0_and2_1 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => segment_lfifo_mt,
      ADR1 => segment_out_state_7_Q,
      O => segment_N_1446
    );
  segment_data_out_0_0_0_and2_2_3_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_3_Q,
      O => segment_N_1468
    );
  segment_data_out_0_0_0_and2_16_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_16_Q,
      O => segment_N_1517
    );
  segment_data_out_0_0_0_and2_0_16_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_16_Q,
      O => segment_N_1518
    );
  segment_data_out_0_0_and2_0_and2_31_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1673,
      ADR1 => segment_dfifo_out_31_Q,
      O => segment_N_1565
    );
  segment_data_out_0_0_and2_0_and2_0_31_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_31_Q,
      O => segment_N_1566
    );
  segment_un52_dfifo_re_2_0_0_and2_1 : X_LUT4
    generic map(
      INIT => X"0040"
    )
    port map (
      ADR0 => segment_N_1394,
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_count(0),
      ADR3 => segment_N_650,
      O => segment_N_1556_1
    );
  segment_un52_dfifo_re_2_0_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_lfifo_out_6_Q,
      ADR1 => segment_N_1556_1,
      O => segment_N_1556
    );
  segment_counters_out_count_4_1_3_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => segment_un1_out_count_1_s_3,
      ADR1 => segment_lfifo_out(5),
      ADR2 => segment_out_state_6_Q,
      O => segment_N_267
    );
  segment_counters_out_count_4_1_2_Q : X_LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      ADR0 => segment_un1_out_count_1_s_2,
      ADR1 => segment_lfifo_out(4),
      ADR2 => segment_out_state_6_Q,
      O => segment_N_266
    );
  segment_G_844 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => segment_out_state_2_Q,
      ADR1 => Reset_l_i_5,
      ADR2 => segment_out_state_3_Q,
      ADR3 => segment_soc_out,
      O => segment_N_1666
    );
  segment_G_846 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => segment_N_1666,
      ADR1 => segment_first_cell,
      ADR2 => segment_out_state_6_Q,
      O => segment_N_1667
    );
  segment_G_847 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => Reset_l_i_5,
      ADR1 => segment_out_state_2_Q,
      O => segment_N_1668
    );
  segment_G_848 : X_LUT4
    generic map(
      INIT => X"1011"
    )
    port map (
      ADR0 => segment_out_state_2_Q,
      ADR1 => segment_N_1386,
      ADR2 => segment_first_cell,
      ADR3 => segment_out_state_6_Q,
      O => segment_N_1673
    );
  segment_data_out_0_0_and2_0_and2_0_24_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_24_Q,
      O => segment_N_1564
    );
  segment_data_out_0_0_and2_0_and2_24_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1673,
      ADR1 => segment_dfifo_out_24_Q,
      O => segment_N_1563
    );
  segment_data_out_0_0_0_and2_0_30_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_30_Q,
      O => segment_N_1544
    );
  segment_data_out_0_0_0_and2_30_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_30_Q,
      O => segment_N_1543
    );
  segment_data_out_0_0_0_and2_0_29_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_29_Q,
      O => segment_N_1542
    );
  segment_data_out_0_0_0_and2_29_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_29_Q,
      O => segment_N_1541
    );
  segment_data_out_0_0_0_and2_0_28_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_28_Q,
      O => segment_N_1540
    );
  segment_data_out_0_0_0_and2_28_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_28_Q,
      O => segment_N_1539
    );
  segment_data_out_0_0_0_and2_0_27_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_27_Q,
      O => segment_N_1538
    );
  segment_data_out_0_0_0_and2_27_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_27_Q,
      O => segment_N_1537
    );
  segment_data_out_0_0_0_and2_0_26_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_26_Q,
      O => segment_N_1536
    );
  segment_data_out_0_0_0_and2_26_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_26_Q,
      O => segment_N_1535
    );
  segment_data_out_0_0_0_and2_0_25_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_25_Q,
      O => segment_N_1534
    );
  segment_data_out_0_0_0_and2_25_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_25_Q,
      O => segment_N_1533
    );
  segment_data_out_0_0_0_and2_0_23_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_23_Q,
      O => segment_N_1532
    );
  segment_data_out_0_0_0_and2_23_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_23_Q,
      O => segment_N_1531
    );
  segment_data_out_0_0_0_and2_0_22_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_22_Q,
      O => segment_N_1530
    );
  segment_data_out_0_0_0_and2_22_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_22_Q,
      O => segment_N_1529
    );
  segment_data_out_0_0_0_and2_0_21_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_21_Q,
      O => segment_N_1528
    );
  segment_data_out_0_0_0_and2_21_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_21_Q,
      O => segment_N_1527
    );
  segment_data_out_0_0_0_and2_0_20_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_20_Q,
      O => segment_N_1526
    );
  segment_data_out_0_0_0_and2_20_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_20_Q,
      O => segment_N_1525
    );
  segment_data_out_0_0_0_and2_0_19_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_19_Q,
      O => segment_N_1524
    );
  segment_data_out_0_0_0_and2_19_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_19_Q,
      O => segment_N_1523
    );
  segment_data_out_0_0_0_and2_0_18_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_18_Q,
      O => segment_N_1522
    );
  segment_data_out_0_0_0_and2_18_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_18_Q,
      O => segment_N_1521
    );
  segment_data_out_0_0_0_and2_0_17_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_17_Q,
      O => segment_N_1520
    );
  segment_data_out_0_0_0_and2_17_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_848_fast,
      ADR1 => segment_dfifo_out_17_Q,
      O => segment_N_1519
    );
  segment_data_out_0_0_0_and2_2_15_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_15_Q,
      O => segment_N_1516
    );
  segment_data_out_0_0_0_and2_2_14_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_14_Q,
      O => segment_N_1512
    );
  segment_data_out_0_0_0_and2_2_13_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_13_Q,
      O => segment_N_1508
    );
  segment_data_out_0_0_0_and2_2_12_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_12_Q,
      O => segment_N_1504
    );
  segment_data_out_0_0_0_and2_2_11_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_11_Q,
      O => segment_N_1500
    );
  segment_data_out_0_0_0_and2_2_10_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_10_Q,
      O => segment_N_1496
    );
  segment_data_out_0_0_0_and2_2_9_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_9_Q,
      O => segment_N_1492
    );
  segment_data_out_0_0_0_and2_2_8_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_8_Q,
      O => segment_N_1488
    );
  segment_data_out_0_0_0_and2_2_7_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_7_Q,
      O => segment_N_1484
    );
  segment_data_out_0_0_0_and2_2_6_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_6_Q,
      O => segment_N_1480
    );
  segment_data_out_0_0_0_and2_2_5_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_5_Q,
      O => segment_N_1476
    );
  segment_data_out_0_0_0_and2_2_4_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_4_Q,
      O => segment_N_1472
    );
  segment_data_out_0_0_0_and2_2_2_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_G_846_fast,
      ADR1 => segment_header_2_Q,
      O => segment_N_1464
    );
  segment_data_out_0_0_0_and2_0_1_Q : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => segment_lfifo_out(1),
      ADR1 => segment_out_state_2_Q,
      ADR2 => Reset_l_i_5,
      O => segment_N_1460
    );
  segment_data_out_0_0_0_and2_1_Q : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => segment_N_1666,
      ADR1 => segment_out_state_6_Q,
      ADR2 => segment_lfifo_out_6_Q,
      ADR3 => segment_dfifo_out_1_Q,
      O => segment_N_1459
    );
  segment_data_out_0_0_0_and2_1_0_Q : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_N_1667,
      ADR1 => segment_header_0_Q,
      O => segment_N_1458
    );
  segment_G_853 : X_LUT4
    generic map(
      INIT => X"2220"
    )
    port map (
      ADR0 => segment_out_state_2_Q,
      ADR1 => Reset_l_i_6,
      ADR2 => segment_lfifo_out(1),
      ADR3 => segment_lfifo_out_0_Q,
      O => segment_N_1672
    );
  segment_G_851 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => segment_out_state_2_Q,
      ADR1 => Reset_l_i_6,
      ADR2 => segment_lfifo_out(1),
      ADR3 => segment_lfifo_out_0_Q,
      O => segment_N_1671
    );
  segment_G_9_0_0_562 : X_LUT4
    generic map(
      INIT => X"F8FF"
    )
    port map (
      ADR0 => segment_first_cell,
      ADR1 => segment_out_state_6_Q,
      ADR2 => segment_out_state_4_Q,
      ADR3 => Reset_l_1,
      O => segment_G_9_0_0
    );
  segment_un52_dfifo_re_0_0_563 : X_LUT4
    generic map(
      INIT => X"BBFB"
    )
    port map (
      ADR0 => segment_un52_dfifo_re_0_0_547,
      ADR1 => segment_N_1381,
      ADR2 => segment_un52_dfifo_re_0_0_and2_0_40,
      ADR3 => segment_N_1394,
      O => segment_un52_dfifo_re_0_0
    );
  segment_un52_dfifo_re_0_0_and2 : X_LUT4
    generic map(
      INIT => X"00E0"
    )
    port map (
      ADR0 => segment_out_count(0),
      ADR1 => segment_N_650,
      ADR2 => segment_soc_out,
      ADR3 => segment_first_cell,
      O => segment_N_1447
    );
  segment_un5_lfifo_re_0_0_564 : X_LUT4
    generic map(
      INIT => X"AFAE"
    )
    port map (
      ADR0 => segment_N_1444,
      ADR1 => segment_N_1391,
      ADR2 => segment_lfifo_mt,
      ADR3 => segment_out_state_7_Q,
      O => segment_un5_lfifo_re_0_0
    );
  segment_un5_lfifo_re_0_0_and2 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => segment_un5_lfifo_re_0_0_and2_60,
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_count(0),
      ADR3 => segment_N_650,
      O => segment_N_1444
    );
  segment_un52_dfifo_re_0_0_and2_2 : X_LUT4
    generic map(
      INIT => X"0400"
    )
    port map (
      ADR0 => segment_N_1408,
      ADR1 => segment_cur_len(1),
      ADR2 => segment_cur_len(2),
      ADR3 => segment_out_state_3_Q,
      O => segment_N_1450
    );
  segment_G_957 : X_LUT3
    generic map(
      INIT => X"DF"
    )
    port map (
      ADR0 => segment_cur_len(2),
      ADR1 => segment_cur_len(1),
      ADR2 => segment_cur_len(3),
      O => segment_N_1399
    );
  segment_G_291 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => segment_out_count_2(1),
      ADR1 => segment_out_count_2(3),
      ADR2 => segment_out_count_2(2),
      O => segment_N_650
    );
  segment_in_machine_un27_dataen_in : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => segment_in_count(2),
      ADR1 => segment_in_count(3),
      ADR2 => segment_in_count(4),
      ADR3 => segment_in_count(5),
      O => segment_un27_dataen_in
    );
  segment_in_machine_un22_dataen_in : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => segment_in_count(3),
      ADR1 => segment_in_count(2),
      ADR2 => segment_in_count(4),
      ADR3 => segment_in_count(5),
      O => segment_un22_dataen_in
    );
  segment_un8_lfifo_we_5_565 : X_LUT3
    generic map(
      INIT => X"EA"
    )
    port map (
      ADR0 => segment_un27_dataen_in,
      ADR1 => segment_un22_dataen_in,
      ADR2 => segment_eof_in,
      O => segment_un8_lfifo_we_5
    );
  segment_un52_dfifo_re_0_0_and2_0_40_566 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => segment_out_state_4_Q,
      ADR1 => segment_out_count(0),
      ADR2 => segment_lfifo_out_6_Q,
      O => segment_un52_dfifo_re_0_0_and2_0_40
    );
  segment_un5_lfifo_re_0_0_and2_60_567 : X_LUT4
    generic map(
      INIT => X"1110"
    )
    port map (
      ADR0 => segment_lfifo_mt,
      ADR1 => segment_lfifo_out_6_Q,
      ADR2 => segment_N_1399,
      ADR3 => segment_cur_len_3(0),
      O => segment_un5_lfifo_re_0_0_and2_60
    );
  segment_un52_dfifo_re_0_0_545_568 : X_LUT4
    generic map(
      INIT => X"FEEE"
    )
    port map (
      ADR0 => segment_N_1446,
      ADR1 => segment_out_state_2_Q,
      ADR2 => segment_N_650,
      ADR3 => segment_out_state_4_Q,
      O => segment_un52_dfifo_re_0_0_545
    );
  segment_un52_dfifo_re_0_0_547_569 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => segment_N_1447,
      ADR1 => segment_un52_dfifo_re_0_0_545,
      ADR2 => segment_N_1450,
      O => segment_un52_dfifo_re_0_0_547
    );
  segment_N_1381_i_570 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => segment_first_cell,
      ADR1 => segment_out_state_6_Q,
      O => segment_N_1381_i
    );
  segment_N_1281_i_571 : X_LUT4
    generic map(
      INIT => X"A280"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => segment_N_1381,
      ADR2 => segment_header_0_Q,
      ADR3 => segment_dfifo_out_0_Q,
      O => segment_N_1281_i
    );
  segment_N_1407_i_572 : X_LUT4
    generic map(
      INIT => X"5556"
    )
    port map (
      ADR0 => segment_cur_len_3(0),
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_state_3_Q,
      ADR3 => segment_soc_out,
      O => segment_N_1407_i
    );
  segment_un1_reset_l_5_i_0_i : X_LUT3
    generic map(
      INIT => X"2A"
    )
    port map (
      ADR0 => Reset_l_1,
      ADR1 => segment_first_cell,
      ADR2 => segment_out_state_6_Q,
      O => segment_total_len_lcry
    );
  segment_output_data_N_1557_i : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => segment_out_state_1_Q,
      ADR1 => segment_out_state_3_Q,
      ADR2 => segment_soc_out,
      O => segment_N_1557_i
    );
  segment_un1_un1_un9_dataen_in_i_573 : X_LUT4
    generic map(
      INIT => X"888A"
    )
    port map (
      ADR0 => segment_un9_dataen_in,
      ADR1 => segment_sof_in,
      ADR2 => segment_un1_in_state,
      ADR3 => segment_N_289,
      O => segment_un1_un1_un9_dataen_in_i
    );
  segment_in_count_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(6),
      O => segment_in_count(6),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_count_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(5),
      O => segment_in_count(5),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_count_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(4),
      O => segment_in_count(4),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_count_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(3),
      O => segment_in_count(3),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_count_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(2),
      O => segment_in_count(2),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_count_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(1),
      O => segment_in_count(1),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_count_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_un1_un1_un9_dataen_in_i,
      CLK => CLK,
      I => segment_in_count_13(0),
      O => segment_in_count(0),
      SRST => Reset_l_i_8,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_header_16_Q_574 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_16_Q,
      O => segment_header_16_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_15_Q_575 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_15_Q,
      O => segment_header_15_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_14_Q_576 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_14_Q,
      O => segment_header_14_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_13_Q_577 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_13_Q,
      O => segment_header_13_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_12_Q_578 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_12_Q,
      O => segment_header_12_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_11_Q_579 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_11_Q,
      O => segment_header_11_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_10_Q_580 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_10_Q,
      O => segment_header_10_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_5,
      SET => GND,
      RST => GSR
    );
  segment_header_9_Q_581 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_9_Q,
      O => segment_header_9_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_8_Q_582 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_8_Q,
      O => segment_header_8_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_7_Q_583 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_7_Q,
      O => segment_header_7_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_6_Q_584 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_6_Q,
      O => segment_header_6_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_5_Q_585 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_5_Q,
      O => segment_header_5_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_4_Q_586 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_4_Q,
      O => segment_header_4_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_3_Q_587 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_3_Q,
      O => segment_header_3_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_2_Q_588 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_2_Q,
      O => segment_header_2_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_31_Q_589 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_31_Q,
      O => segment_header_31_Q,
      SRST => Reset_l_i_9,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_30_Q_590 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_30_Q,
      O => segment_header_30_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_29_Q_591 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_29_Q,
      O => segment_header_29_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_28_Q_592 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_28_Q,
      O => segment_header_28_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_27_Q_593 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_27_Q,
      O => segment_header_27_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_26_Q_594 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_26_Q,
      O => segment_header_26_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_25_Q_595 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_25_Q,
      O => segment_header_25_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_24_Q_596 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_24_Q,
      O => segment_header_24_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_4,
      SET => GND,
      RST => GSR
    );
  segment_header_23_Q_597 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_23_Q,
      O => segment_header_23_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_header_22_Q_598 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_22_Q,
      O => segment_header_22_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_header_21_Q_599 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_21_Q,
      O => segment_header_21_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_header_20_Q_600 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_20_Q,
      O => segment_header_20_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_header_19_Q_601 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_19_Q,
      O => segment_header_19_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_header_18_Q_602 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_18_Q,
      O => segment_header_18_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_header_17_Q_603 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1381_i,
      CLK => CLK,
      I => segment_dfifo_out_17_Q,
      O => segment_header_17_Q,
      SRST => Reset_l_i_10,
      SSET => Reset_l_i_3,
      SET => GND,
      RST => GSR
    );
  segment_first_cell_604 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_N_1557_i,
      CLK => CLK,
      I => segment_out_state_1_Q,
      O => segment_first_cell,
      SSET => Reset_l_i_10,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_soc_out_605 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_out_state_6_Q,
      O => segment_soc_out,
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_dataen_in_606 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => DataEn_APPL_IN,
      O => segment_dataen_in,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_eof_in_607 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => EOF_APPL_IN,
      O => segment_eof_in,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_sof_in_608 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => SOF_APPL_IN,
      O => segment_sof_in,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_soc_out_mod : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_soc_out,
      O => soc8,
      SRST => Reset_l_i_19,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_header_0_Q_609 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1281_i,
      O => segment_header_0_Q,
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_out_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1532,
      O => segment_data_out(23),
      SSET => segment_N_1531,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1564,
      O => segment_data_out(24),
      SSET => segment_N_1563,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1534,
      O => segment_data_out(25),
      SSET => segment_N_1533,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1536,
      O => segment_data_out(26),
      SSET => segment_N_1535,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1538,
      O => segment_data_out(27),
      SSET => segment_N_1537,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1540,
      O => segment_data_out(28),
      SSET => segment_N_1539,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1542,
      O => segment_data_out(29),
      SSET => segment_N_1541,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1544,
      O => segment_data_out(30),
      SSET => segment_N_1543,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1566,
      O => segment_data_out(31),
      SSET => segment_N_1565,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_850,
      O => segment_data_out(8),
      SSET => segment_N_1488,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_851,
      O => segment_data_out(9),
      SSET => segment_N_1492,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_852,
      O => segment_data_out(10),
      SSET => segment_N_1496,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_853,
      O => segment_data_out(11),
      SSET => segment_N_1500,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_854,
      O => segment_data_out(12),
      SSET => segment_N_1504,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_855,
      O => segment_data_out(13),
      SSET => segment_N_1508,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_856,
      O => segment_data_out(14),
      SSET => segment_N_1512,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_857,
      O => segment_data_out(15),
      SSET => segment_N_1516,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1518,
      O => segment_data_out(16),
      SSET => segment_N_1517,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1520,
      O => segment_data_out(17),
      SSET => segment_N_1519,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1522,
      O => segment_data_out(18),
      SSET => segment_N_1521,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1524,
      O => segment_data_out(19),
      SSET => segment_N_1523,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1526,
      O => segment_data_out(20),
      SSET => segment_N_1525,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1528,
      O => segment_data_out(21),
      SSET => segment_N_1527,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1530,
      O => segment_data_out(22),
      SSET => segment_N_1529,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_858,
      O => segment_data_out(0),
      SSET => segment_N_1458,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1460,
      O => segment_data_out(1),
      SSET => segment_N_1459,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_859,
      O => segment_data_out(2),
      SSET => segment_N_1464,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_860,
      O => segment_data_out(3),
      SSET => segment_N_1468,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_861,
      O => segment_data_out(4),
      SSET => segment_N_1472,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_862,
      O => segment_data_out(5),
      SSET => segment_N_1476,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_863,
      O => segment_data_out(6),
      SSET => segment_N_1480,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_out_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_864,
      O => segment_data_out(7),
      SSET => segment_N_1484,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_data_in_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(21),
      O => segment_data_in(21),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(22),
      O => segment_data_in(22),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(23),
      O => segment_data_in(23),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(24),
      O => segment_data_in(24),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(25),
      O => segment_data_in(25),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(26),
      O => segment_data_in(26),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(27),
      O => segment_data_in(27),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(28),
      O => segment_data_in(28),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(29),
      O => segment_data_in(29),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(30),
      O => segment_data_in(30),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(31),
      O => segment_data_in(31),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(6),
      O => segment_data_in(6),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(7),
      O => segment_data_in(7),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(8),
      O => segment_data_in(8),
      SRST => Reset_l_i_20,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(9),
      O => segment_data_in(9),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(10),
      O => segment_data_in(10),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(11),
      O => segment_data_in(11),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(12),
      O => segment_data_in(12),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(13),
      O => segment_data_in(13),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(14),
      O => segment_data_in(14),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(15),
      O => segment_data_in(15),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(16),
      O => segment_data_in(16),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(17),
      O => segment_data_in(17),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(18),
      O => segment_data_in(18),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(19),
      O => segment_data_in(19),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(20),
      O => segment_data_in(20),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(0),
      O => segment_data_in(0),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(1),
      O => segment_data_in(1),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(2),
      O => segment_data_in(2),
      SRST => Reset_l_i_21,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(3),
      O => segment_data_in(3),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(4),
      O => segment_data_in(4),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_data_in_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => D_APPL_IN(5),
      O => segment_data_in(5),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(19),
      O => data8(19),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(20),
      O => data8(20),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(21),
      O => data8(21),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(22),
      O => data8(22),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(23),
      O => data8(23),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(24),
      O => data8(24),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(25),
      O => data8(25),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(26),
      O => data8(26),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(27),
      O => data8(27),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(28),
      O => data8(28),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(29),
      O => data8(29),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(30),
      O => data8(30),
      SRST => Reset_l_i_22,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(31),
      O => data8(31),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(4),
      O => data8(4),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(5),
      O => data8(5),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(6),
      O => data8(6),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(7),
      O => data8(7),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(8),
      O => data8(8),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(9),
      O => data8(9),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(10),
      O => data8(10),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(11),
      O => data8(11),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(12),
      O => data8(12),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(13),
      O => data8(13),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(14),
      O => data8(14),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(15),
      O => data8(15),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(16),
      O => data8(16),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(17),
      O => data8(17),
      SRST => Reset_l_i_23,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(18),
      O => data8(18),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(0),
      O => data8(0),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(1),
      O => data8(1),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(2),
      O => data8(2),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_d_out_mod_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_data_out(3),
      O => data8(3),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_count_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_264,
      O => segment_out_count(0),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_count_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_265,
      O => segment_out_count_2(1),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_count_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_266,
      O => segment_out_count_2(2),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_count_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_267,
      O => segment_out_count_2(3),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_cur_len_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_847,
      O => segment_cur_len(2),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_cur_len_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_848,
      O => segment_cur_len(3),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_cur_len_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1407_i,
      O => segment_cur_len_3(0),
      SRST => Reset_l_i,
      SSET => segment_out_state_6_Q,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  segment_cur_len_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_849,
      O => segment_cur_len(1),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_total_len_s_13_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(12),
      I1 => segment_total_len_qxu(13),
      O => segment_total_len_s(13)
    );
  segment_total_len_qxu_13_Q : X_LUT4
    generic map(
      INIT => X"1BE4"
    )
    port map (
      ADR0 => segment_total_len_lcry,
      ADR1 => segment_GND,
      ADR2 => segment_total_len(13),
      ADR3 => segment_GND,
      O => segment_total_len_qxu(13)
    );
  segment_total_len_s_12_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(11),
      I1 => segment_total_len_qxu(12),
      O => segment_total_len_s(12)
    );
  segment_total_len_s_11_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(10),
      I1 => segment_total_len_qxu(11),
      O => segment_total_len_s(11)
    );
  segment_total_len_s_10_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(9),
      I1 => segment_total_len_qxu(10),
      O => segment_total_len_s(10)
    );
  segment_total_len_s_9_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(8),
      I1 => segment_total_len_qxu(9),
      O => segment_total_len_s(9)
    );
  segment_total_len_s_8_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(7),
      I1 => segment_total_len_qxu(8),
      O => segment_total_len_s(8)
    );
  segment_total_len_s_7_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(6),
      I1 => segment_total_len_qxu(7),
      O => segment_total_len_s(7)
    );
  segment_total_len_s_6_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(5),
      I1 => segment_total_len_qxu(6),
      O => segment_total_len_s(6)
    );
  segment_total_len_s_5_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(4),
      I1 => segment_total_len_qxu(5),
      O => segment_total_len_s(5)
    );
  segment_total_len_s_4_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(3),
      I1 => segment_total_len_qxu(4),
      O => segment_total_len_s(4)
    );
  segment_total_len_s_3_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(2),
      I1 => segment_total_len_qxu(3),
      O => segment_total_len_s(3)
    );
  segment_total_len_s_2_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(1),
      I1 => segment_total_len_qxu(2),
      O => segment_total_len_s(2)
    );
  segment_total_len_s_1_Q : X_XOR2
    port map (
      I0 => segment_total_len_cry(0),
      I1 => segment_total_len_qxu(1),
      O => segment_total_len_s(1)
    );
  segment_total_len_s_0_Q : X_XOR2
    port map (
      I0 => segment_total_len_lcry,
      I1 => segment_total_len_qxu(0),
      O => segment_total_len_s(0)
    );
  segment_un1_out_count_1_s_3_610 : X_XOR2
    port map (
      I0 => segment_un1_out_count_1_cry_2,
      I1 => segment_un1_out_count_1_axb_3,
      O => segment_un1_out_count_1_s_3
    );
  segment_un1_out_count_1_s_2_611 : X_XOR2
    port map (
      I0 => segment_un1_out_count_1_cry_1,
      I1 => segment_un1_out_count_1_axb_2,
      O => segment_un1_out_count_1_s_2
    );
  segment_un1_out_count_1_s_1_612 : X_XOR2
    port map (
      I0 => segment_un1_out_count_1_cry_0,
      I1 => segment_un1_out_count_1_axb_1,
      O => segment_un1_out_count_1_s_1
    );
  segment_un27_data_out_s_13 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_12,
      I1 => segment_N_554_i,
      O => un27_data_out_s_13
    );
  segment_un27_data_out_s_12 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_11,
      I1 => segment_N_553_i,
      O => un27_data_out_s_12
    );
  segment_un27_data_out_s_11 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_10,
      I1 => segment_N_552_i,
      O => un27_data_out_s_11
    );
  segment_un27_data_out_s_10 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_9,
      I1 => segment_N_551_i,
      O => un27_data_out_s_10
    );
  segment_un27_data_out_s_9 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_8,
      I1 => segment_N_550_i,
      O => un27_data_out_s_9
    );
  segment_un27_data_out_s_8 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_7,
      I1 => segment_N_549_i,
      O => un27_data_out_s_8
    );
  segment_un27_data_out_s_7 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_6,
      I1 => segment_N_548_i,
      O => un27_data_out_s_7
    );
  segment_un27_data_out_s_6 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_5,
      I1 => segment_N_547_i,
      O => un27_data_out_s_6
    );
  segment_un27_data_out_s_5 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_4,
      I1 => segment_N_546_i,
      O => un27_data_out_s_5
    );
  segment_un27_data_out_s_4 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_3,
      I1 => segment_N_545_i,
      O => un27_data_out_s_4
    );
  segment_un27_data_out_s_3 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_2,
      I1 => segment_N_544_i,
      O => un27_data_out_s_3
    );
  segment_un27_data_out_s_2 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_1,
      I1 => segment_N_543_i,
      O => un27_data_out_s_2
    );
  segment_un27_data_out_s_1 : X_XOR2
    port map (
      I0 => segment_un27_data_out_cry_0,
      I1 => segment_N_542_i,
      O => un27_data_out_s_1
    );
  segment_GND_613 : X_ZERO
    port map (
      O => segment_GND
    );
  segment_VCC_614 : X_ONE
    port map (
      O => segment_VCC
    );
  segment_total_len_cry_12_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(11),
      SEL => segment_total_len_qxu(12),
      O => segment_total_len_cry_12_O
    );
  segment_total_len_cry_12_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_12_O,
      O => segment_total_len_cry(12)
    );
  segment_total_len_cry_11_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(10),
      SEL => segment_total_len_qxu(11),
      O => segment_total_len_cry_11_O
    );
  segment_total_len_cry_11_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_11_O,
      O => segment_total_len_cry(11)
    );
  segment_total_len_cry_10_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(9),
      SEL => segment_total_len_qxu(10),
      O => segment_total_len_cry_10_O
    );
  segment_total_len_cry_10_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_10_O,
      O => segment_total_len_cry(10)
    );
  segment_total_len_cry_9_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(8),
      SEL => segment_total_len_qxu(9),
      O => segment_total_len_cry_9_O
    );
  segment_total_len_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_9_O,
      O => segment_total_len_cry(9)
    );
  segment_total_len_cry_8_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(7),
      SEL => segment_total_len_qxu(8),
      O => segment_total_len_cry_8_O
    );
  segment_total_len_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_8_O,
      O => segment_total_len_cry(8)
    );
  segment_total_len_cry_7_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(6),
      SEL => segment_total_len_qxu(7),
      O => segment_total_len_cry_7_O
    );
  segment_total_len_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_7_O,
      O => segment_total_len_cry(7)
    );
  segment_total_len_cry_6_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(5),
      SEL => segment_total_len_qxu(6),
      O => segment_total_len_cry_6_O
    );
  segment_total_len_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_6_O,
      O => segment_total_len_cry(6)
    );
  segment_total_len_cry_5_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(4),
      SEL => segment_total_len_qxu(5),
      O => segment_total_len_cry_5_O
    );
  segment_total_len_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_5_O,
      O => segment_total_len_cry(5)
    );
  segment_total_len_cry_4_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(3),
      SEL => segment_total_len_qxu(4),
      O => segment_total_len_cry_4_O
    );
  segment_total_len_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_4_O,
      O => segment_total_len_cry(4)
    );
  segment_total_len_cry_3_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(2),
      SEL => segment_total_len_qxu(3),
      O => segment_total_len_cry_3_O
    );
  segment_total_len_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_3_O,
      O => segment_total_len_cry(3)
    );
  segment_total_len_cry_2_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(1),
      SEL => segment_total_len_qxu(2),
      O => segment_total_len_cry_2_O
    );
  segment_total_len_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_2_O,
      O => segment_total_len_cry(2)
    );
  segment_total_len_cry_1_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_cry(0),
      SEL => segment_total_len_qxu(1),
      O => segment_total_len_cry_1_O
    );
  segment_total_len_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_1_O,
      O => segment_total_len_cry(1)
    );
  segment_total_len_cry_0_Q : X_MUX2
    port map (
      IA => segment_GND,
      IB => segment_total_len_lcry,
      SEL => segment_total_len_qxu(0),
      O => segment_total_len_cry_0_O
    );
  segment_total_len_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_total_len_cry_0_O,
      O => segment_total_len_cry(0)
    );
  segment_un1_out_count_1_cry_2_615 : X_MUX2
    port map (
      IA => segment_out_count_2(2),
      IB => segment_un1_out_count_1_cry_1,
      SEL => segment_un1_out_count_1_axb_2,
      O => segment_un1_out_count_1_cry_2_O
    );
  segment_un1_out_count_1_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un1_out_count_1_cry_2_O,
      O => segment_un1_out_count_1_cry_2
    );
  segment_un1_out_count_1_cry_1_616 : X_MUX2
    port map (
      IA => segment_out_count_2(1),
      IB => segment_un1_out_count_1_cry_0,
      SEL => segment_un1_out_count_1_axb_1,
      O => segment_un1_out_count_1_cry_1_O
    );
  segment_un1_out_count_1_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un1_out_count_1_cry_1_O,
      O => segment_un1_out_count_1_cry_1
    );
  segment_un1_out_count_1_cry_0_617 : X_MUX2
    port map (
      IA => segment_out_count(0),
      IB => segment_GND,
      SEL => segment_un1_out_count_1_axb_0,
      O => segment_un1_out_count_1_cry_0_O
    );
  segment_un1_out_count_1_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un1_out_count_1_cry_0_O,
      O => segment_un1_out_count_1_cry_0
    );
  segment_un27_data_out_cry_12_618 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_11,
      SEL => segment_N_553_i,
      O => segment_un27_data_out_cry_12_O
    );
  segment_un27_data_out_cry_12_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_12_O,
      O => segment_un27_data_out_cry_12
    );
  segment_un27_data_out_cry_11_619 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_10,
      SEL => segment_N_552_i,
      O => segment_un27_data_out_cry_11_O
    );
  segment_un27_data_out_cry_11_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_11_O,
      O => segment_un27_data_out_cry_11
    );
  segment_un27_data_out_cry_10_620 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_9,
      SEL => segment_N_551_i,
      O => segment_un27_data_out_cry_10_O
    );
  segment_un27_data_out_cry_10_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_10_O,
      O => segment_un27_data_out_cry_10
    );
  segment_un27_data_out_cry_9_621 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_8,
      SEL => segment_N_550_i,
      O => segment_un27_data_out_cry_9_O
    );
  segment_un27_data_out_cry_9_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_9_O,
      O => segment_un27_data_out_cry_9
    );
  segment_un27_data_out_cry_8_622 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_7,
      SEL => segment_N_549_i,
      O => segment_un27_data_out_cry_8_O
    );
  segment_un27_data_out_cry_8_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_8_O,
      O => segment_un27_data_out_cry_8
    );
  segment_un27_data_out_cry_7_623 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_6,
      SEL => segment_N_548_i,
      O => segment_un27_data_out_cry_7_O
    );
  segment_un27_data_out_cry_7_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_7_O,
      O => segment_un27_data_out_cry_7
    );
  segment_un27_data_out_cry_6_624 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_5,
      SEL => segment_N_547_i,
      O => segment_un27_data_out_cry_6_O
    );
  segment_un27_data_out_cry_6_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_6_O,
      O => segment_un27_data_out_cry_6
    );
  segment_un27_data_out_cry_5_625 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_4,
      SEL => segment_N_546_i,
      O => segment_un27_data_out_cry_5_O
    );
  segment_un27_data_out_cry_5_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_5_O,
      O => segment_un27_data_out_cry_5
    );
  segment_un27_data_out_cry_4_626 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_3,
      SEL => segment_N_545_i,
      O => segment_un27_data_out_cry_4_O
    );
  segment_un27_data_out_cry_4_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_4_O,
      O => segment_un27_data_out_cry_4
    );
  segment_un27_data_out_cry_3_627 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_2,
      SEL => segment_N_544_i,
      O => segment_un27_data_out_cry_3_O
    );
  segment_un27_data_out_cry_3_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_3_O,
      O => segment_un27_data_out_cry_3
    );
  segment_un27_data_out_cry_2_628 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_1,
      SEL => segment_N_543_i,
      O => segment_un27_data_out_cry_2_O
    );
  segment_un27_data_out_cry_2_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_2_O,
      O => segment_un27_data_out_cry_2
    );
  segment_un27_data_out_cry_1_629 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_un27_data_out_cry_0,
      SEL => segment_N_542_i,
      O => segment_un27_data_out_cry_1_O
    );
  segment_un27_data_out_cry_1_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_1_O,
      O => segment_un27_data_out_cry_1
    );
  segment_un27_data_out_cry_0_630 : X_MUX2
    port map (
      IA => segment_VCC,
      IB => segment_GND,
      SEL => segment_N_541_i,
      O => segment_un27_data_out_cry_0_O
    );
  segment_un27_data_out_cry_0_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_un27_data_out_cry_0_O,
      O => segment_un27_data_out_cry_0
    );
  segment_dfifo_VCC : X_ONE
    port map (
      O => segment_dfifo_N2147483644
    );
  segment_dfifo_GND : X_ZERO
    port map (
      O => segment_dfifo_N2147483641
    );
  segment_dfifo_BU0 : X_RAMB4_S16_S16
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => segment_dfifo_N2147483644,
      ENB => segment_dfifo_N214,
      WEA => segment_dfifo_N216,
      WEB => segment_dfifo_N2147483641,
      RSTA => segment_dfifo_N2147483641,
      RSTB => segment_dfifo_N2147483641,
      CLKA => CLK,
      CLKB => CLK,
      GSR => GSR,
      DIA(15) => segment_data_in(15),
      DIA(14) => segment_data_in(14),
      DIA(13) => segment_data_in(13),
      DIA(12) => segment_data_in(12),
      DIA(11) => segment_data_in(11),
      DIA(10) => segment_data_in(10),
      DIA(9) => segment_data_in(9),
      DIA(8) => segment_data_in(8),
      DIA(7) => segment_data_in(7),
      DIA(6) => segment_data_in(6),
      DIA(5) => segment_data_in(5),
      DIA(4) => segment_data_in(4),
      DIA(3) => segment_data_in(3),
      DIA(2) => segment_data_in(2),
      DIA(1) => segment_data_in(1),
      DIA(0) => segment_data_in(0),
      DOB(15) => segment_dfifo_out_15_Q,
      DOB(14) => segment_dfifo_out_14_Q,
      DOB(13) => segment_dfifo_out_13_Q,
      DOB(12) => segment_dfifo_out_12_Q,
      DOB(11) => segment_dfifo_out_11_Q,
      DOB(10) => segment_dfifo_out_10_Q,
      DOB(9) => segment_dfifo_out_9_Q,
      DOB(8) => segment_dfifo_out_8_Q,
      DOB(7) => segment_dfifo_out_7_Q,
      DOB(6) => segment_dfifo_out_6_Q,
      DOB(5) => segment_dfifo_out_5_Q,
      DOB(4) => segment_dfifo_out_4_Q,
      DOB(3) => segment_dfifo_out_3_Q,
      DOB(2) => segment_dfifo_out_2_Q,
      DOB(1) => segment_dfifo_out_1_Q,
      DOB(0) => segment_dfifo_out_0_Q,
      DOA(15) => NLW_segment_dfifo_BU0_DOA_15_UNCONNECTED,
      DOA(14) => NLW_segment_dfifo_BU0_DOA_14_UNCONNECTED,
      DOA(13) => NLW_segment_dfifo_BU0_DOA_13_UNCONNECTED,
      DOA(12) => NLW_segment_dfifo_BU0_DOA_12_UNCONNECTED,
      DOA(11) => NLW_segment_dfifo_BU0_DOA_11_UNCONNECTED,
      DOA(10) => NLW_segment_dfifo_BU0_DOA_10_UNCONNECTED,
      DOA(9) => NLW_segment_dfifo_BU0_DOA_9_UNCONNECTED,
      DOA(8) => NLW_segment_dfifo_BU0_DOA_8_UNCONNECTED,
      DOA(7) => NLW_segment_dfifo_BU0_DOA_7_UNCONNECTED,
      DOA(6) => NLW_segment_dfifo_BU0_DOA_6_UNCONNECTED,
      DOA(5) => NLW_segment_dfifo_BU0_DOA_5_UNCONNECTED,
      DOA(4) => NLW_segment_dfifo_BU0_DOA_4_UNCONNECTED,
      DOA(3) => NLW_segment_dfifo_BU0_DOA_3_UNCONNECTED,
      DOA(2) => NLW_segment_dfifo_BU0_DOA_2_UNCONNECTED,
      DOA(1) => NLW_segment_dfifo_BU0_DOA_1_UNCONNECTED,
      DOA(0) => NLW_segment_dfifo_BU0_DOA_0_UNCONNECTED,
      DIB(15) => segment_dfifo_N2147483641,
      DIB(14) => segment_dfifo_N2147483641,
      DIB(13) => segment_dfifo_N2147483641,
      DIB(12) => segment_dfifo_N2147483641,
      DIB(11) => segment_dfifo_N2147483641,
      DIB(10) => segment_dfifo_N2147483641,
      DIB(9) => segment_dfifo_N2147483641,
      DIB(8) => segment_dfifo_N2147483641,
      DIB(7) => segment_dfifo_N2147483641,
      DIB(6) => segment_dfifo_N2147483641,
      DIB(5) => segment_dfifo_N2147483641,
      DIB(4) => segment_dfifo_N2147483641,
      DIB(3) => segment_dfifo_N2147483641,
      DIB(2) => segment_dfifo_N2147483641,
      DIB(1) => segment_dfifo_N2147483641,
      DIB(0) => segment_dfifo_N2147483641,
      ADDRB(7) => segment_dfifo_N2147483641,
      ADDRB(6) => segment_dfifo_N206,
      ADDRB(5) => segment_dfifo_N207,
      ADDRB(4) => segment_dfifo_N208,
      ADDRB(3) => segment_dfifo_N209,
      ADDRB(2) => segment_dfifo_N210,
      ADDRB(1) => segment_dfifo_N211,
      ADDRB(0) => segment_dfifo_N212,
      ADDRA(7) => segment_dfifo_N2147483641,
      ADDRA(6) => segment_dfifo_N198,
      ADDRA(5) => segment_dfifo_N199,
      ADDRA(4) => segment_dfifo_N200,
      ADDRA(3) => segment_dfifo_N201,
      ADDRA(2) => segment_dfifo_N202,
      ADDRA(1) => segment_dfifo_N203,
      ADDRA(0) => segment_dfifo_N204
    );
  segment_dfifo_BU1 : X_RAMB4_S16_S16
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => segment_dfifo_N2147483644,
      ENB => segment_dfifo_N214,
      WEA => segment_dfifo_N216,
      WEB => segment_dfifo_N2147483641,
      RSTA => segment_dfifo_N2147483641,
      RSTB => segment_dfifo_N2147483641,
      CLKA => CLK,
      CLKB => CLK,
      GSR => GSR,
      DIA(15) => segment_data_in(31),
      DIA(14) => segment_data_in(30),
      DIA(13) => segment_data_in(29),
      DIA(12) => segment_data_in(28),
      DIA(11) => segment_data_in(27),
      DIA(10) => segment_data_in(26),
      DIA(9) => segment_data_in(25),
      DIA(8) => segment_data_in(24),
      DIA(7) => segment_data_in(23),
      DIA(6) => segment_data_in(22),
      DIA(5) => segment_data_in(21),
      DIA(4) => segment_data_in(20),
      DIA(3) => segment_data_in(19),
      DIA(2) => segment_data_in(18),
      DIA(1) => segment_data_in(17),
      DIA(0) => segment_data_in(16),
      DOB(15) => segment_dfifo_out_31_Q,
      DOB(14) => segment_dfifo_out_30_Q,
      DOB(13) => segment_dfifo_out_29_Q,
      DOB(12) => segment_dfifo_out_28_Q,
      DOB(11) => segment_dfifo_out_27_Q,
      DOB(10) => segment_dfifo_out_26_Q,
      DOB(9) => segment_dfifo_out_25_Q,
      DOB(8) => segment_dfifo_out_24_Q,
      DOB(7) => segment_dfifo_out_23_Q,
      DOB(6) => segment_dfifo_out_22_Q,
      DOB(5) => segment_dfifo_out_21_Q,
      DOB(4) => segment_dfifo_out_20_Q,
      DOB(3) => segment_dfifo_out_19_Q,
      DOB(2) => segment_dfifo_out_18_Q,
      DOB(1) => segment_dfifo_out_17_Q,
      DOB(0) => segment_dfifo_out_16_Q,
      DOA(15) => NLW_segment_dfifo_BU1_DOA_15_UNCONNECTED,
      DOA(14) => NLW_segment_dfifo_BU1_DOA_14_UNCONNECTED,
      DOA(13) => NLW_segment_dfifo_BU1_DOA_13_UNCONNECTED,
      DOA(12) => NLW_segment_dfifo_BU1_DOA_12_UNCONNECTED,
      DOA(11) => NLW_segment_dfifo_BU1_DOA_11_UNCONNECTED,
      DOA(10) => NLW_segment_dfifo_BU1_DOA_10_UNCONNECTED,
      DOA(9) => NLW_segment_dfifo_BU1_DOA_9_UNCONNECTED,
      DOA(8) => NLW_segment_dfifo_BU1_DOA_8_UNCONNECTED,
      DOA(7) => NLW_segment_dfifo_BU1_DOA_7_UNCONNECTED,
      DOA(6) => NLW_segment_dfifo_BU1_DOA_6_UNCONNECTED,
      DOA(5) => NLW_segment_dfifo_BU1_DOA_5_UNCONNECTED,
      DOA(4) => NLW_segment_dfifo_BU1_DOA_4_UNCONNECTED,
      DOA(3) => NLW_segment_dfifo_BU1_DOA_3_UNCONNECTED,
      DOA(2) => NLW_segment_dfifo_BU1_DOA_2_UNCONNECTED,
      DOA(1) => NLW_segment_dfifo_BU1_DOA_1_UNCONNECTED,
      DOA(0) => NLW_segment_dfifo_BU1_DOA_0_UNCONNECTED,
      DIB(15) => segment_dfifo_N2147483641,
      DIB(14) => segment_dfifo_N2147483641,
      DIB(13) => segment_dfifo_N2147483641,
      DIB(12) => segment_dfifo_N2147483641,
      DIB(11) => segment_dfifo_N2147483641,
      DIB(10) => segment_dfifo_N2147483641,
      DIB(9) => segment_dfifo_N2147483641,
      DIB(8) => segment_dfifo_N2147483641,
      DIB(7) => segment_dfifo_N2147483641,
      DIB(6) => segment_dfifo_N2147483641,
      DIB(5) => segment_dfifo_N2147483641,
      DIB(4) => segment_dfifo_N2147483641,
      DIB(3) => segment_dfifo_N2147483641,
      DIB(2) => segment_dfifo_N2147483641,
      DIB(1) => segment_dfifo_N2147483641,
      DIB(0) => segment_dfifo_N2147483641,
      ADDRB(7) => segment_dfifo_N2147483641,
      ADDRB(6) => segment_dfifo_N206,
      ADDRB(5) => segment_dfifo_N207,
      ADDRB(4) => segment_dfifo_N208,
      ADDRB(3) => segment_dfifo_N209,
      ADDRB(2) => segment_dfifo_N210,
      ADDRB(1) => segment_dfifo_N211,
      ADDRB(0) => segment_dfifo_N212,
      ADDRA(7) => segment_dfifo_N2147483641,
      ADDRA(6) => segment_dfifo_N198,
      ADDRA(5) => segment_dfifo_N199,
      ADDRA(4) => segment_dfifo_N200,
      ADDRA(3) => segment_dfifo_N201,
      ADDRA(2) => segment_dfifo_N202,
      ADDRA(1) => segment_dfifo_N203,
      ADDRA(0) => segment_dfifo_N204
    );
  segment_dfifo_BU2 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un52_dfifo_re_0_0,
      ADR1 => segment_dfifo_empty,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N1710
    );
  segment_dfifo_BU3 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un52_dfifo_re_0_0,
      ADR1 => segment_dfifo_empty,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N214
    );
  segment_dfifo_BU4 : X_LUT4
    generic map(
      INIT => X"5555"
    )
    port map (
      ADR0 => segment_dfifo_N212,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2124
    );
  segment_dfifo_BU5 : X_MUX2
    port map (
      IB => segment_dfifo_N2147483641,
      IA => segment_dfifo_N212,
      O => segment_dfifo_N2138,
      SEL => segment_dfifo_N2124
    );
  segment_dfifo_BU6 : X_XOR2
    port map (
      I0 => segment_dfifo_N2147483641,
      I1 => segment_dfifo_N2124,
      O => segment_dfifo_N2116
    );
  segment_dfifo_BU7 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2116,
      O => segment_dfifo_N212,
      RST => segment_dfifo_BU7_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU8 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N211,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2154
    );
  segment_dfifo_BU9 : X_MUX2
    port map (
      IB => segment_dfifo_N2138,
      IA => segment_dfifo_N211,
      O => segment_dfifo_N2168,
      SEL => segment_dfifo_N2154
    );
  segment_dfifo_BU10 : X_XOR2
    port map (
      I0 => segment_dfifo_N2138,
      I1 => segment_dfifo_N2154,
      O => segment_dfifo_N2117
    );
  segment_dfifo_BU11 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2117,
      O => segment_dfifo_N211,
      RST => segment_dfifo_BU11_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU12 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N210,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2184
    );
  segment_dfifo_BU13 : X_MUX2
    port map (
      IB => segment_dfifo_N2168,
      IA => segment_dfifo_N210,
      O => segment_dfifo_N2198,
      SEL => segment_dfifo_N2184
    );
  segment_dfifo_BU14 : X_XOR2
    port map (
      I0 => segment_dfifo_N2168,
      I1 => segment_dfifo_N2184,
      O => segment_dfifo_N2118
    );
  segment_dfifo_BU15 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2118,
      O => segment_dfifo_N210,
      RST => segment_dfifo_BU15_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU16 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N209,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2214
    );
  segment_dfifo_BU17 : X_MUX2
    port map (
      IB => segment_dfifo_N2198,
      IA => segment_dfifo_N209,
      O => segment_dfifo_N2228,
      SEL => segment_dfifo_N2214
    );
  segment_dfifo_BU18 : X_XOR2
    port map (
      I0 => segment_dfifo_N2198,
      I1 => segment_dfifo_N2214,
      O => segment_dfifo_N2119
    );
  segment_dfifo_BU19 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2119,
      O => segment_dfifo_N209,
      RST => segment_dfifo_BU19_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU20 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N208,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2244
    );
  segment_dfifo_BU21 : X_MUX2
    port map (
      IB => segment_dfifo_N2228,
      IA => segment_dfifo_N208,
      O => segment_dfifo_N2258,
      SEL => segment_dfifo_N2244
    );
  segment_dfifo_BU22 : X_XOR2
    port map (
      I0 => segment_dfifo_N2228,
      I1 => segment_dfifo_N2244,
      O => segment_dfifo_N2120
    );
  segment_dfifo_BU23 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2120,
      O => segment_dfifo_N208,
      RST => segment_dfifo_BU23_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU24 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N207,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2274
    );
  segment_dfifo_BU25 : X_MUX2
    port map (
      IB => segment_dfifo_N2258,
      IA => segment_dfifo_N207,
      O => segment_dfifo_N2288,
      SEL => segment_dfifo_N2274
    );
  segment_dfifo_BU26 : X_XOR2
    port map (
      I0 => segment_dfifo_N2258,
      I1 => segment_dfifo_N2274,
      O => segment_dfifo_N2121
    );
  segment_dfifo_BU27 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2121,
      O => segment_dfifo_N207,
      RST => segment_dfifo_BU27_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU28 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N206,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2304
    );
  segment_dfifo_BU29 : X_XOR2
    port map (
      I0 => segment_dfifo_N2288,
      I1 => segment_dfifo_N2304,
      O => segment_dfifo_N2122
    );
  segment_dfifo_BU30 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2122,
      O => segment_dfifo_N206,
      RST => segment_dfifo_BU30_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU31 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N212,
      ADR1 => segment_dfifo_N211,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2514
    );
  segment_dfifo_BU32 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2514,
      O => segment_dfifo_N1764,
      RST => segment_dfifo_BU32_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU33 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N211,
      ADR1 => segment_dfifo_N210,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2590
    );
  segment_dfifo_BU34 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2590,
      O => segment_dfifo_N1763,
      RST => segment_dfifo_BU34_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU35 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N210,
      ADR1 => segment_dfifo_N209,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2666
    );
  segment_dfifo_BU36 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2666,
      O => segment_dfifo_N1762,
      RST => segment_dfifo_BU36_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU37 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N209,
      ADR1 => segment_dfifo_N208,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2742
    );
  segment_dfifo_BU38 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2742,
      O => segment_dfifo_N1761,
      RST => segment_dfifo_BU38_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU39 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N208,
      ADR1 => segment_dfifo_N207,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2818
    );
  segment_dfifo_BU40 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2818,
      O => segment_dfifo_N1760,
      RST => segment_dfifo_BU40_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU41 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N207,
      ADR1 => segment_dfifo_N206,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2894
    );
  segment_dfifo_BU42 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2894,
      O => segment_dfifo_N1759,
      RST => segment_dfifo_BU42_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU43 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N206,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N2970
    );
  segment_dfifo_BU44 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU44_GSR_OR,
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N2970,
      O => segment_dfifo_N1758,
      RST => GND
    );
  segment_dfifo_BU45 : X_LUT4
    generic map(
      INIT => X"fffe"
    )
    port map (
      ADR0 => segment_un52_dfifo_re_0_0,
      ADR1 => segment_dfifo_empty,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3057
    );
  segment_dfifo_BU47 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU47_GSR_OR,
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1828,
      O => segment_dfifo_N1844,
      RST => GND
    );
  segment_dfifo_BU48 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_dfifo_N2147483641,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3061
    );
  segment_dfifo_BU50 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1827,
      O => segment_dfifo_N1843,
      RST => segment_dfifo_BU50_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU51 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1764,
      ADR1 => segment_dfifo_N1828,
      ADR2 => segment_dfifo_N1844,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3046
    );
  segment_dfifo_BU52 : X_MUX2
    port map (
      IB => segment_dfifo_N2147483644,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N3054,
      SEL => segment_dfifo_N3046
    );
  segment_dfifo_BU53 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N2147483641,
      CLK => segment_dfifo_N2147483641,
      I => segment_dfifo_N2147483641,
      O => NLW_segment_dfifo_BU53_O_UNCONNECTED,
      RST => GSR,
      SET => GND
    );
  segment_dfifo_BU54 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1763,
      ADR1 => segment_dfifo_N1827,
      ADR2 => segment_dfifo_N1843,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3045
    );
  segment_dfifo_BU55 : X_MUX2
    port map (
      IB => segment_dfifo_N3054,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N3053,
      SEL => segment_dfifo_N3045
    );
  segment_dfifo_BU56 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1826,
      O => segment_dfifo_N1842,
      RST => segment_dfifo_BU56_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU57 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1762,
      ADR1 => segment_dfifo_N1826,
      ADR2 => segment_dfifo_N1842,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3044
    );
  segment_dfifo_BU58 : X_MUX2
    port map (
      IB => segment_dfifo_N3053,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N3052,
      SEL => segment_dfifo_N3044
    );
  segment_dfifo_BU59 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1825,
      O => segment_dfifo_N1841,
      RST => segment_dfifo_BU59_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU60 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1761,
      ADR1 => segment_dfifo_N1825,
      ADR2 => segment_dfifo_N1841,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3043
    );
  segment_dfifo_BU61 : X_MUX2
    port map (
      IB => segment_dfifo_N3052,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N3051,
      SEL => segment_dfifo_N3043
    );
  segment_dfifo_BU62 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1824,
      O => segment_dfifo_N1840,
      RST => segment_dfifo_BU62_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU63 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1760,
      ADR1 => segment_dfifo_N1824,
      ADR2 => segment_dfifo_N1840,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3042
    );
  segment_dfifo_BU64 : X_MUX2
    port map (
      IB => segment_dfifo_N3051,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N3050,
      SEL => segment_dfifo_N3042
    );
  segment_dfifo_BU65 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1823,
      O => segment_dfifo_N1839,
      RST => segment_dfifo_BU65_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU66 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1759,
      ADR1 => segment_dfifo_N1823,
      ADR2 => segment_dfifo_N1839,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3041
    );
  segment_dfifo_BU67 : X_MUX2
    port map (
      IB => segment_dfifo_N3050,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N3049,
      SEL => segment_dfifo_N3041
    );
  segment_dfifo_BU68 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU68_GSR_OR,
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N1822,
      O => segment_dfifo_N1838,
      RST => GND
    );
  segment_dfifo_BU69 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1758,
      ADR1 => segment_dfifo_N1822,
      ADR2 => segment_dfifo_N1838,
      ADR3 => segment_dfifo_empty,
      O => segment_dfifo_N3040
    );
  segment_dfifo_BU71 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_dfifo_N2147483641,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => NLW_segment_dfifo_BU71_O_UNCONNECTED
    );
  segment_dfifo_BU72 : X_XOR2
    port map (
      I0 => segment_dfifo_N3048,
      I1 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3059
    );
  segment_dfifo_BU73 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU73_GSR_OR,
      CE => segment_dfifo_N3057,
      CLK => CLK,
      I => segment_dfifo_N3059,
      O => segment_dfifo_empty,
      RST => GND
    );
  segment_dfifo_BU74 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un9_dataen_in,
      ADR1 => segment_dfifo_full,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N1714
    );
  segment_dfifo_BU75 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un9_dataen_in,
      ADR1 => segment_dfifo_full,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N216
    );
  segment_dfifo_BU76 : X_LUT4
    generic map(
      INIT => X"5555"
    )
    port map (
      ADR0 => segment_dfifo_N204,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3409
    );
  segment_dfifo_BU77 : X_MUX2
    port map (
      IB => segment_dfifo_N2147483641,
      IA => segment_dfifo_N204,
      O => segment_dfifo_N3423,
      SEL => segment_dfifo_N3409
    );
  segment_dfifo_BU78 : X_XOR2
    port map (
      I0 => segment_dfifo_N2147483641,
      I1 => segment_dfifo_N3409,
      O => segment_dfifo_N3401
    );
  segment_dfifo_BU79 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3401,
      O => segment_dfifo_N204,
      RST => segment_dfifo_BU79_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU80 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N203,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3439
    );
  segment_dfifo_BU81 : X_MUX2
    port map (
      IB => segment_dfifo_N3423,
      IA => segment_dfifo_N203,
      O => segment_dfifo_N3453,
      SEL => segment_dfifo_N3439
    );
  segment_dfifo_BU82 : X_XOR2
    port map (
      I0 => segment_dfifo_N3423,
      I1 => segment_dfifo_N3439,
      O => segment_dfifo_N3402
    );
  segment_dfifo_BU83 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3402,
      O => segment_dfifo_N203,
      RST => segment_dfifo_BU83_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU84 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N202,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3469
    );
  segment_dfifo_BU85 : X_MUX2
    port map (
      IB => segment_dfifo_N3453,
      IA => segment_dfifo_N202,
      O => segment_dfifo_N3483,
      SEL => segment_dfifo_N3469
    );
  segment_dfifo_BU86 : X_XOR2
    port map (
      I0 => segment_dfifo_N3453,
      I1 => segment_dfifo_N3469,
      O => segment_dfifo_N3403
    );
  segment_dfifo_BU87 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3403,
      O => segment_dfifo_N202,
      RST => segment_dfifo_BU87_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU88 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N201,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3499
    );
  segment_dfifo_BU89 : X_MUX2
    port map (
      IB => segment_dfifo_N3483,
      IA => segment_dfifo_N201,
      O => segment_dfifo_N3513,
      SEL => segment_dfifo_N3499
    );
  segment_dfifo_BU90 : X_XOR2
    port map (
      I0 => segment_dfifo_N3483,
      I1 => segment_dfifo_N3499,
      O => segment_dfifo_N3404
    );
  segment_dfifo_BU91 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3404,
      O => segment_dfifo_N201,
      RST => segment_dfifo_BU91_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU92 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N200,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3529
    );
  segment_dfifo_BU93 : X_MUX2
    port map (
      IB => segment_dfifo_N3513,
      IA => segment_dfifo_N200,
      O => segment_dfifo_N3543,
      SEL => segment_dfifo_N3529
    );
  segment_dfifo_BU94 : X_XOR2
    port map (
      I0 => segment_dfifo_N3513,
      I1 => segment_dfifo_N3529,
      O => segment_dfifo_N3405
    );
  segment_dfifo_BU95 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3405,
      O => segment_dfifo_N200,
      RST => segment_dfifo_BU95_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU96 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N199,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3559
    );
  segment_dfifo_BU97 : X_MUX2
    port map (
      IB => segment_dfifo_N3543,
      IA => segment_dfifo_N199,
      O => segment_dfifo_N3573,
      SEL => segment_dfifo_N3559
    );
  segment_dfifo_BU98 : X_XOR2
    port map (
      I0 => segment_dfifo_N3543,
      I1 => segment_dfifo_N3559,
      O => segment_dfifo_N3406
    );
  segment_dfifo_BU99 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3406,
      O => segment_dfifo_N199,
      RST => segment_dfifo_BU99_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU100 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_dfifo_N198,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3589
    );
  segment_dfifo_BU101 : X_XOR2
    port map (
      I0 => segment_dfifo_N3573,
      I1 => segment_dfifo_N3589,
      O => segment_dfifo_N3407
    );
  segment_dfifo_BU102 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3407,
      O => segment_dfifo_N198,
      RST => segment_dfifo_BU102_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU103 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N204,
      ADR1 => segment_dfifo_N203,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3799
    );
  segment_dfifo_BU104 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3799,
      O => segment_dfifo_N1828,
      RST => segment_dfifo_BU104_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU105 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N203,
      ADR1 => segment_dfifo_N202,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3875
    );
  segment_dfifo_BU106 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3875,
      O => segment_dfifo_N1827,
      RST => segment_dfifo_BU106_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU107 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N202,
      ADR1 => segment_dfifo_N201,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N3951
    );
  segment_dfifo_BU108 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N3951,
      O => segment_dfifo_N1826,
      RST => segment_dfifo_BU108_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU109 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N201,
      ADR1 => segment_dfifo_N200,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4027
    );
  segment_dfifo_BU110 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N4027,
      O => segment_dfifo_N1825,
      RST => segment_dfifo_BU110_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU111 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N200,
      ADR1 => segment_dfifo_N199,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4103
    );
  segment_dfifo_BU112 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N4103,
      O => segment_dfifo_N1824,
      RST => segment_dfifo_BU112_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU113 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N199,
      ADR1 => segment_dfifo_N198,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4179
    );
  segment_dfifo_BU114 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N4179,
      O => segment_dfifo_N1823,
      RST => segment_dfifo_BU114_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU115 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_dfifo_N198,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4255
    );
  segment_dfifo_BU116 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU116_GSR_OR,
      CE => segment_dfifo_N1714,
      CLK => CLK,
      I => segment_dfifo_N4255,
      O => segment_dfifo_N1822,
      RST => GND
    );
  segment_dfifo_BU117 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU117_GSR_OR,
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1764,
      O => segment_dfifo_N1780,
      RST => GND
    );
  segment_dfifo_BU118 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1763,
      O => segment_dfifo_N1779,
      RST => segment_dfifo_BU118_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU119 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1762,
      O => segment_dfifo_N1778,
      RST => segment_dfifo_BU119_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU120 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1761,
      O => segment_dfifo_N1777,
      RST => segment_dfifo_BU120_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU121 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1760,
      O => segment_dfifo_N1776,
      RST => segment_dfifo_BU121_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU122 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1759,
      O => segment_dfifo_N1775,
      RST => segment_dfifo_BU122_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU123 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU123_GSR_OR,
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1758,
      O => segment_dfifo_N1774,
      RST => GND
    );
  segment_dfifo_BU124 : X_LUT4
    generic map(
      INIT => X"fffe"
    )
    port map (
      ADR0 => segment_un9_dataen_in,
      ADR1 => segment_dfifo_full,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4500
    );
  segment_dfifo_BU126 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU126_GSR_OR,
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1780,
      O => segment_dfifo_N1788,
      RST => GND
    );
  segment_dfifo_BU127 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_dfifo_N2147483641,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4504
    );
  segment_dfifo_BU129 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU129_GSR_OR,
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1779,
      O => segment_dfifo_N1787,
      RST => GND
    );
  segment_dfifo_BU130 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1828,
      ADR1 => segment_dfifo_N1780,
      ADR2 => segment_dfifo_N1788,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4489
    );
  segment_dfifo_BU131 : X_MUX2
    port map (
      IB => segment_dfifo_N2147483644,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N4497,
      SEL => segment_dfifo_N4489
    );
  segment_dfifo_BU132 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N2147483641,
      CLK => segment_dfifo_N2147483641,
      I => segment_dfifo_N2147483641,
      O => NLW_segment_dfifo_BU132_O_UNCONNECTED,
      RST => GSR,
      SET => GND
    );
  segment_dfifo_BU133 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1827,
      ADR1 => segment_dfifo_N1779,
      ADR2 => segment_dfifo_N1787,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4488
    );
  segment_dfifo_BU134 : X_MUX2
    port map (
      IB => segment_dfifo_N4497,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N4496,
      SEL => segment_dfifo_N4488
    );
  segment_dfifo_BU135 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1778,
      O => segment_dfifo_N1786,
      RST => segment_dfifo_BU135_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU136 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1826,
      ADR1 => segment_dfifo_N1778,
      ADR2 => segment_dfifo_N1786,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4487
    );
  segment_dfifo_BU137 : X_MUX2
    port map (
      IB => segment_dfifo_N4496,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N4495,
      SEL => segment_dfifo_N4487
    );
  segment_dfifo_BU138 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1777,
      O => segment_dfifo_N1785,
      RST => segment_dfifo_BU138_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU139 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1825,
      ADR1 => segment_dfifo_N1777,
      ADR2 => segment_dfifo_N1785,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4486
    );
  segment_dfifo_BU140 : X_MUX2
    port map (
      IB => segment_dfifo_N4495,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N4494,
      SEL => segment_dfifo_N4486
    );
  segment_dfifo_BU141 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1776,
      O => segment_dfifo_N1784,
      RST => segment_dfifo_BU141_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU142 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1824,
      ADR1 => segment_dfifo_N1776,
      ADR2 => segment_dfifo_N1784,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4485
    );
  segment_dfifo_BU143 : X_MUX2
    port map (
      IB => segment_dfifo_N4494,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N4493,
      SEL => segment_dfifo_N4485
    );
  segment_dfifo_BU144 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1775,
      O => segment_dfifo_N1783,
      RST => segment_dfifo_BU144_GSR_OR,
      SET => GND
    );
  segment_dfifo_BU145 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1823,
      ADR1 => segment_dfifo_N1775,
      ADR2 => segment_dfifo_N1783,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4484
    );
  segment_dfifo_BU146 : X_MUX2
    port map (
      IB => segment_dfifo_N4493,
      IA => segment_dfifo_N2147483641,
      O => segment_dfifo_N4492,
      SEL => segment_dfifo_N4484
    );
  segment_dfifo_BU147 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU147_GSR_OR,
      CE => segment_dfifo_N1710,
      CLK => CLK,
      I => segment_dfifo_N1774,
      O => segment_dfifo_N1782,
      RST => GND
    );
  segment_dfifo_BU148 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_dfifo_N1822,
      ADR1 => segment_dfifo_N1774,
      ADR2 => segment_dfifo_N1782,
      ADR3 => segment_dfifo_full,
      O => segment_dfifo_N4483
    );
  segment_dfifo_BU150 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_dfifo_N2147483641,
      ADR1 => segment_dfifo_N2147483641,
      ADR2 => segment_dfifo_N2147483641,
      ADR3 => segment_dfifo_N2147483641,
      O => NLW_segment_dfifo_BU150_O_UNCONNECTED
    );
  segment_dfifo_BU151 : X_XOR2
    port map (
      I0 => segment_dfifo_N4491,
      I1 => segment_dfifo_N2147483641,
      O => segment_dfifo_N4502
    );
  segment_dfifo_BU152 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_dfifo_BU152_GSR_OR,
      CE => segment_dfifo_N4500,
      CLK => CLK,
      I => segment_dfifo_N4502,
      O => segment_dfifo_full,
      RST => GND
    );
  segment_dfifo_BU46 : X_MUX2
    port map (
      IA => segment_dfifo_N2147483641,
      IB => segment_dfifo_N2147483644,
      SEL => NLW_segment_dfifo_BU46_SEL_UNCONNECTED,
      O => segment_dfifo_BU46_O
    );
  segment_dfifo_BU46_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_dfifo_BU46_O,
      O => segment_dfifo_BU46_LO
    );
  segment_dfifo_BU49 : X_MUX2
    port map (
      IA => segment_dfifo_N2147483641,
      IB => segment_dfifo_N2147483644,
      SEL => segment_dfifo_N3061,
      O => segment_dfifo_BU49_O
    );
  segment_dfifo_BU49_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_dfifo_BU49_O,
      O => segment_dfifo_BU49_LO
    );
  segment_dfifo_BU70 : X_MUX2
    port map (
      IA => segment_dfifo_N2147483641,
      IB => segment_dfifo_N3049,
      SEL => segment_dfifo_N3040,
      O => segment_dfifo_BU70_O
    );
  segment_dfifo_BU70_MUXCY_D_BUF : X_BUF
    port map (
      I => segment_dfifo_BU70_O,
      O => segment_dfifo_N3048
    );
  segment_dfifo_BU125 : X_MUX2
    port map (
      IA => segment_dfifo_N2147483641,
      IB => segment_dfifo_N2147483644,
      SEL => NLW_segment_dfifo_BU125_SEL_UNCONNECTED,
      O => segment_dfifo_BU125_O
    );
  segment_dfifo_BU125_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_dfifo_BU125_O,
      O => segment_dfifo_BU125_LO
    );
  segment_dfifo_BU128 : X_MUX2
    port map (
      IA => segment_dfifo_N2147483641,
      IB => segment_dfifo_N2147483644,
      SEL => segment_dfifo_N4504,
      O => segment_dfifo_BU128_O
    );
  segment_dfifo_BU128_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_dfifo_BU128_O,
      O => segment_dfifo_BU128_LO
    );
  segment_dfifo_BU149 : X_MUX2
    port map (
      IA => segment_dfifo_N2147483641,
      IB => segment_dfifo_N4492,
      SEL => segment_dfifo_N4483,
      O => segment_dfifo_BU149_O
    );
  segment_dfifo_BU149_MUXCY_D_BUF : X_BUF
    port map (
      I => segment_dfifo_BU149_O,
      O => segment_dfifo_N4491
    );
  segment_lfifo_VCC : X_ONE
    port map (
      O => segment_lfifo_N1
    );
  segment_lfifo_GND : X_ZERO
    port map (
      O => segment_lfifo_N0
    );
  segment_lfifo_B7 : X_RAMB4_S8_S8
    generic map(
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      XON => FALSE
    )
    port map (
      ENA => segment_lfifo_N1,
      ENB => segment_lfifo_N10,
      WEA => segment_lfifo_N11,
      WEB => segment_lfifo_N0,
      RSTA => segment_lfifo_N0,
      RSTB => segment_lfifo_N0,
      CLKA => CLK,
      CLKB => CLK,
      GSR => GSR,
      DOA(7) => NLW_segment_lfifo_B7_DOA_7_UNCONNECTED,
      DOA(6) => NLW_segment_lfifo_B7_DOA_6_UNCONNECTED,
      DOA(5) => NLW_segment_lfifo_B7_DOA_5_UNCONNECTED,
      DOA(4) => NLW_segment_lfifo_B7_DOA_4_UNCONNECTED,
      DOA(3) => NLW_segment_lfifo_B7_DOA_3_UNCONNECTED,
      DOA(2) => NLW_segment_lfifo_B7_DOA_2_UNCONNECTED,
      DOA(1) => NLW_segment_lfifo_B7_DOA_1_UNCONNECTED,
      DOA(0) => NLW_segment_lfifo_B7_DOA_0_UNCONNECTED,
      DIB(7) => segment_lfifo_N0,
      DIB(6) => segment_lfifo_N0,
      DIB(5) => segment_lfifo_N0,
      DIB(4) => segment_lfifo_N0,
      DIB(3) => segment_lfifo_N0,
      DIB(2) => segment_lfifo_N0,
      DIB(1) => segment_lfifo_N0,
      DIB(0) => segment_lfifo_N0,
      ADDRB(8) => segment_lfifo_N0,
      ADDRB(7) => segment_lfifo_N0,
      ADDRB(6) => segment_lfifo_N0,
      ADDRB(5) => segment_lfifo_N0,
      ADDRB(4) => segment_lfifo_N0,
      ADDRB(3) => segment_lfifo_N6,
      ADDRB(2) => segment_lfifo_N7,
      ADDRB(1) => segment_lfifo_N8,
      ADDRB(0) => segment_lfifo_N9,
      DIA(7) => segment_lfifo_N0,
      DIA(6) => segment_in_count(6),
      DIA(5) => segment_in_count(5),
      DIA(4) => segment_in_count(4),
      DIA(3) => segment_in_count(3),
      DIA(2) => segment_in_count(2),
      DIA(1) => segment_in_count(1),
      DIA(0) => segment_in_count(0),
      ADDRA(8) => segment_lfifo_N0,
      ADDRA(7) => segment_lfifo_N0,
      ADDRA(6) => segment_lfifo_N0,
      ADDRA(5) => segment_lfifo_N0,
      ADDRA(4) => segment_lfifo_N0,
      ADDRA(3) => segment_lfifo_N2,
      ADDRA(2) => segment_lfifo_N3,
      ADDRA(1) => segment_lfifo_N4,
      ADDRA(0) => segment_lfifo_N5,
      DOB(7) => NLW_segment_lfifo_B7_DOB_7_UNCONNECTED,
      DOB(6) => segment_lfifo_out_6_Q,
      DOB(5) => segment_lfifo_out(5),
      DOB(4) => segment_lfifo_out(4),
      DOB(3) => segment_lfifo_out(3),
      DOB(2) => segment_lfifo_out(2),
      DOB(1) => segment_lfifo_out(1),
      DOB(0) => segment_lfifo_out_0_Q
    );
  segment_lfifo_BU0 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un5_lfifo_re_0_0,
      ADR1 => segment_lfifo_mt,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N837
    );
  segment_lfifo_BU1 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un5_lfifo_re_0_0,
      ADR1 => segment_lfifo_mt,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N10
    );
  segment_lfifo_BU2 : X_LUT4
    generic map(
      INIT => X"5555"
    )
    port map (
      ADR0 => segment_lfifo_N9,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1051
    );
  segment_lfifo_BU3 : X_MUX2
    port map (
      IB => segment_lfifo_N0,
      IA => segment_lfifo_N9,
      O => segment_lfifo_N1053,
      SEL => segment_lfifo_N1051
    );
  segment_lfifo_BU4 : X_XOR2
    port map (
      I0 => segment_lfifo_N0,
      I1 => segment_lfifo_N1051,
      O => segment_lfifo_N1047
    );
  segment_lfifo_BU5 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1047,
      O => segment_lfifo_N9,
      RST => segment_lfifo_BU5_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU6 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_lfifo_N8,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1056
    );
  segment_lfifo_BU7 : X_MUX2
    port map (
      IB => segment_lfifo_N1053,
      IA => segment_lfifo_N8,
      O => segment_lfifo_N1058,
      SEL => segment_lfifo_N1056
    );
  segment_lfifo_BU8 : X_XOR2
    port map (
      I0 => segment_lfifo_N1053,
      I1 => segment_lfifo_N1056,
      O => segment_lfifo_N1048
    );
  segment_lfifo_BU9 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1048,
      O => segment_lfifo_N8,
      RST => segment_lfifo_BU9_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU10 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_lfifo_N7,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1061
    );
  segment_lfifo_BU11 : X_MUX2
    port map (
      IB => segment_lfifo_N1058,
      IA => segment_lfifo_N7,
      O => segment_lfifo_N1063,
      SEL => segment_lfifo_N1061
    );
  segment_lfifo_BU12 : X_XOR2
    port map (
      I0 => segment_lfifo_N1058,
      I1 => segment_lfifo_N1061,
      O => segment_lfifo_N1049
    );
  segment_lfifo_BU13 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1049,
      O => segment_lfifo_N7,
      RST => segment_lfifo_BU13_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU14 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_lfifo_N6,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1066
    );
  segment_lfifo_BU15 : X_XOR2
    port map (
      I0 => segment_lfifo_N1063,
      I1 => segment_lfifo_N1066,
      O => segment_lfifo_N1050
    );
  segment_lfifo_BU16 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1050,
      O => segment_lfifo_N6,
      RST => segment_lfifo_BU16_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU17 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N9,
      ADR1 => segment_lfifo_N8,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1234
    );
  segment_lfifo_BU18 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1234,
      O => segment_lfifo_N863,
      RST => segment_lfifo_BU18_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU19 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N8,
      ADR1 => segment_lfifo_N7,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1266
    );
  segment_lfifo_BU20 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1266,
      O => segment_lfifo_N862,
      RST => segment_lfifo_BU20_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU21 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N7,
      ADR1 => segment_lfifo_N6,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1298
    );
  segment_lfifo_BU22 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1298,
      O => segment_lfifo_N861,
      RST => segment_lfifo_BU22_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU23 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N6,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1330
    );
  segment_lfifo_BU24 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU24_GSR_OR,
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N1330,
      O => segment_lfifo_N860,
      RST => GND
    );
  segment_lfifo_BU25 : X_LUT4
    generic map(
      INIT => X"fffe"
    )
    port map (
      ADR0 => segment_un5_lfifo_re_0_0,
      ADR1 => segment_lfifo_mt,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1358
    );
  segment_lfifo_BU27 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU27_GSR_OR,
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N895,
      O => segment_lfifo_N903,
      RST => GND
    );
  segment_lfifo_BU28 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_lfifo_N0,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1360
    );
  segment_lfifo_BU30 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N894,
      O => segment_lfifo_N902,
      RST => segment_lfifo_BU30_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU31 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N863,
      ADR1 => segment_lfifo_N895,
      ADR2 => segment_lfifo_N903,
      ADR3 => segment_lfifo_mt,
      O => segment_lfifo_N1352
    );
  segment_lfifo_BU32 : X_MUX2
    port map (
      IB => segment_lfifo_N1,
      IA => segment_lfifo_N0,
      O => segment_lfifo_N1356,
      SEL => segment_lfifo_N1352
    );
  segment_lfifo_BU33 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N0,
      CLK => segment_lfifo_N0,
      I => segment_lfifo_N0,
      O => NLW_segment_lfifo_BU33_O_UNCONNECTED,
      RST => GSR,
      SET => GND
    );
  segment_lfifo_BU34 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N862,
      ADR1 => segment_lfifo_N894,
      ADR2 => segment_lfifo_N902,
      ADR3 => segment_lfifo_mt,
      O => segment_lfifo_N1351
    );
  segment_lfifo_BU35 : X_MUX2
    port map (
      IB => segment_lfifo_N1356,
      IA => segment_lfifo_N0,
      O => segment_lfifo_N1355,
      SEL => segment_lfifo_N1351
    );
  segment_lfifo_BU36 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N893,
      O => segment_lfifo_N901,
      RST => segment_lfifo_BU36_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU37 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N861,
      ADR1 => segment_lfifo_N893,
      ADR2 => segment_lfifo_N901,
      ADR3 => segment_lfifo_mt,
      O => segment_lfifo_N1350
    );
  segment_lfifo_BU38 : X_MUX2
    port map (
      IB => segment_lfifo_N1355,
      IA => segment_lfifo_N0,
      O => segment_lfifo_N1354,
      SEL => segment_lfifo_N1350
    );
  segment_lfifo_BU39 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU39_GSR_OR,
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N892,
      O => segment_lfifo_N900,
      RST => GND
    );
  segment_lfifo_BU40 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N860,
      ADR1 => segment_lfifo_N892,
      ADR2 => segment_lfifo_N900,
      ADR3 => segment_lfifo_mt,
      O => segment_lfifo_N1349
    );
  segment_lfifo_BU42 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_lfifo_N0,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => NLW_segment_lfifo_BU42_O_UNCONNECTED
    );
  segment_lfifo_BU43 : X_XOR2
    port map (
      I0 => segment_lfifo_N1353,
      I1 => segment_lfifo_N0,
      O => segment_lfifo_N1359
    );
  segment_lfifo_BU44 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU44_GSR_OR,
      CE => segment_lfifo_N1358,
      CLK => CLK,
      I => segment_lfifo_N1359,
      O => segment_lfifo_mt,
      RST => GND
    );
  segment_lfifo_BU45 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un17_lfifo_we,
      ADR1 => segment_lfifo_full,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N839
    );
  segment_lfifo_BU46 : X_LUT4
    generic map(
      INIT => X"2222"
    )
    port map (
      ADR0 => segment_un17_lfifo_we,
      ADR1 => segment_lfifo_full,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N11
    );
  segment_lfifo_BU47 : X_LUT4
    generic map(
      INIT => X"5555"
    )
    port map (
      ADR0 => segment_lfifo_N5,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1521
    );
  segment_lfifo_BU48 : X_MUX2
    port map (
      IB => segment_lfifo_N0,
      IA => segment_lfifo_N5,
      O => segment_lfifo_N1523,
      SEL => segment_lfifo_N1521
    );
  segment_lfifo_BU49 : X_XOR2
    port map (
      I0 => segment_lfifo_N0,
      I1 => segment_lfifo_N1521,
      O => segment_lfifo_N1517
    );
  segment_lfifo_BU50 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1517,
      O => segment_lfifo_N5,
      RST => segment_lfifo_BU50_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU51 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_lfifo_N4,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1526
    );
  segment_lfifo_BU52 : X_MUX2
    port map (
      IB => segment_lfifo_N1523,
      IA => segment_lfifo_N4,
      O => segment_lfifo_N1528,
      SEL => segment_lfifo_N1526
    );
  segment_lfifo_BU53 : X_XOR2
    port map (
      I0 => segment_lfifo_N1523,
      I1 => segment_lfifo_N1526,
      O => segment_lfifo_N1518
    );
  segment_lfifo_BU54 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1518,
      O => segment_lfifo_N4,
      RST => segment_lfifo_BU54_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU55 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_lfifo_N3,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1531
    );
  segment_lfifo_BU56 : X_MUX2
    port map (
      IB => segment_lfifo_N1528,
      IA => segment_lfifo_N3,
      O => segment_lfifo_N1533,
      SEL => segment_lfifo_N1531
    );
  segment_lfifo_BU57 : X_XOR2
    port map (
      I0 => segment_lfifo_N1528,
      I1 => segment_lfifo_N1531,
      O => segment_lfifo_N1519
    );
  segment_lfifo_BU58 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1519,
      O => segment_lfifo_N3,
      RST => segment_lfifo_BU58_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU59 : X_LUT4
    generic map(
      INIT => X"aaaa"
    )
    port map (
      ADR0 => segment_lfifo_N2,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1536
    );
  segment_lfifo_BU60 : X_XOR2
    port map (
      I0 => segment_lfifo_N1533,
      I1 => segment_lfifo_N1536,
      O => segment_lfifo_N1520
    );
  segment_lfifo_BU61 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1520,
      O => segment_lfifo_N2,
      RST => segment_lfifo_BU61_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU62 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N5,
      ADR1 => segment_lfifo_N4,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1704
    );
  segment_lfifo_BU63 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1704,
      O => segment_lfifo_N895,
      RST => segment_lfifo_BU63_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU64 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N4,
      ADR1 => segment_lfifo_N3,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1736
    );
  segment_lfifo_BU65 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1736,
      O => segment_lfifo_N894,
      RST => segment_lfifo_BU65_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU66 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N3,
      ADR1 => segment_lfifo_N2,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1768
    );
  segment_lfifo_BU67 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1768,
      O => segment_lfifo_N893,
      RST => segment_lfifo_BU67_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU68 : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => segment_lfifo_N2,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1800
    );
  segment_lfifo_BU69 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU69_GSR_OR,
      CE => segment_lfifo_N839,
      CLK => CLK,
      I => segment_lfifo_N1800,
      O => segment_lfifo_N892,
      RST => GND
    );
  segment_lfifo_BU70 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU70_GSR_OR,
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N863,
      O => segment_lfifo_N871,
      RST => GND
    );
  segment_lfifo_BU71 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N862,
      O => segment_lfifo_N870,
      RST => segment_lfifo_BU71_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU72 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N861,
      O => segment_lfifo_N869,
      RST => segment_lfifo_BU72_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU73 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU73_GSR_OR,
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N860,
      O => segment_lfifo_N868,
      RST => GND
    );
  segment_lfifo_BU74 : X_LUT4
    generic map(
      INIT => X"fffe"
    )
    port map (
      ADR0 => segment_un17_lfifo_we,
      ADR1 => segment_lfifo_full,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1886
    );
  segment_lfifo_BU76 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU76_GSR_OR,
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N871,
      O => segment_lfifo_N875,
      RST => GND
    );
  segment_lfifo_BU77 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_lfifo_N0,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => segment_lfifo_N1888
    );
  segment_lfifo_BU79 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU79_GSR_OR,
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N870,
      O => segment_lfifo_N874,
      RST => GND
    );
  segment_lfifo_BU80 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N895,
      ADR1 => segment_lfifo_N871,
      ADR2 => segment_lfifo_N875,
      ADR3 => segment_lfifo_full,
      O => segment_lfifo_N1880
    );
  segment_lfifo_BU81 : X_MUX2
    port map (
      IB => segment_lfifo_N1,
      IA => segment_lfifo_N0,
      O => segment_lfifo_N1884,
      SEL => segment_lfifo_N1880
    );
  segment_lfifo_BU82 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N0,
      CLK => segment_lfifo_N0,
      I => segment_lfifo_N0,
      O => NLW_segment_lfifo_BU82_O_UNCONNECTED,
      RST => GSR,
      SET => GND
    );
  segment_lfifo_BU83 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N894,
      ADR1 => segment_lfifo_N870,
      ADR2 => segment_lfifo_N874,
      ADR3 => segment_lfifo_full,
      O => segment_lfifo_N1879
    );
  segment_lfifo_BU84 : X_MUX2
    port map (
      IB => segment_lfifo_N1884,
      IA => segment_lfifo_N0,
      O => segment_lfifo_N1883,
      SEL => segment_lfifo_N1879
    );
  segment_lfifo_BU85 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N869,
      O => segment_lfifo_N873,
      RST => segment_lfifo_BU85_GSR_OR,
      SET => GND
    );
  segment_lfifo_BU86 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N893,
      ADR1 => segment_lfifo_N869,
      ADR2 => segment_lfifo_N873,
      ADR3 => segment_lfifo_full,
      O => segment_lfifo_N1878
    );
  segment_lfifo_BU87 : X_MUX2
    port map (
      IB => segment_lfifo_N1883,
      IA => segment_lfifo_N0,
      O => segment_lfifo_N1882,
      SEL => segment_lfifo_N1878
    );
  segment_lfifo_BU88 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU88_GSR_OR,
      CE => segment_lfifo_N837,
      CLK => CLK,
      I => segment_lfifo_N868,
      O => segment_lfifo_N872,
      RST => GND
    );
  segment_lfifo_BU89 : X_LUT4
    generic map(
      INIT => X"99a5"
    )
    port map (
      ADR0 => segment_lfifo_N892,
      ADR1 => segment_lfifo_N868,
      ADR2 => segment_lfifo_N872,
      ADR3 => segment_lfifo_full,
      O => segment_lfifo_N1877
    );
  segment_lfifo_BU91 : X_LUT4
    generic map(
      INIT => X"ffff"
    )
    port map (
      ADR0 => segment_lfifo_N0,
      ADR1 => segment_lfifo_N0,
      ADR2 => segment_lfifo_N0,
      ADR3 => segment_lfifo_N0,
      O => NLW_segment_lfifo_BU91_O_UNCONNECTED
    );
  segment_lfifo_BU92 : X_XOR2
    port map (
      I0 => segment_lfifo_N1881,
      I1 => segment_lfifo_N0,
      O => segment_lfifo_N1887
    );
  segment_lfifo_BU93 : X_FF
    generic map(
      XON => FALSE
    )
    port map (
      SET => segment_lfifo_BU93_GSR_OR,
      CE => segment_lfifo_N1886,
      CLK => CLK,
      I => segment_lfifo_N1887,
      O => segment_lfifo_full,
      RST => GND
    );
  segment_lfifo_BU26 : X_MUX2
    port map (
      IA => segment_lfifo_N0,
      IB => segment_lfifo_N1,
      SEL => NLW_segment_lfifo_BU26_SEL_UNCONNECTED,
      O => segment_lfifo_BU26_O
    );
  segment_lfifo_BU26_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_lfifo_BU26_O,
      O => segment_lfifo_BU26_LO
    );
  segment_lfifo_BU29 : X_MUX2
    port map (
      IA => segment_lfifo_N0,
      IB => segment_lfifo_N1,
      SEL => segment_lfifo_N1360,
      O => segment_lfifo_BU29_O
    );
  segment_lfifo_BU29_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_lfifo_BU29_O,
      O => segment_lfifo_BU29_LO
    );
  segment_lfifo_BU41 : X_MUX2
    port map (
      IA => segment_lfifo_N0,
      IB => segment_lfifo_N1354,
      SEL => segment_lfifo_N1349,
      O => segment_lfifo_BU41_O
    );
  segment_lfifo_BU41_MUXCY_D_BUF : X_BUF
    port map (
      I => segment_lfifo_BU41_O,
      O => segment_lfifo_N1353
    );
  segment_lfifo_BU75 : X_MUX2
    port map (
      IA => segment_lfifo_N0,
      IB => segment_lfifo_N1,
      SEL => NLW_segment_lfifo_BU75_SEL_UNCONNECTED,
      O => segment_lfifo_BU75_O
    );
  segment_lfifo_BU75_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_lfifo_BU75_O,
      O => segment_lfifo_BU75_LO
    );
  segment_lfifo_BU78 : X_MUX2
    port map (
      IA => segment_lfifo_N0,
      IB => segment_lfifo_N1,
      SEL => segment_lfifo_N1888,
      O => segment_lfifo_BU78_O
    );
  segment_lfifo_BU78_MUXCY_L_BUF : X_BUF
    port map (
      I => segment_lfifo_BU78_O,
      O => segment_lfifo_BU78_LO
    );
  segment_lfifo_BU90 : X_MUX2
    port map (
      IA => segment_lfifo_N0,
      IB => segment_lfifo_N1882,
      SEL => segment_lfifo_N1877,
      O => segment_lfifo_BU90_O
    );
  segment_lfifo_BU90_MUXCY_D_BUF : X_BUF
    port map (
      I => segment_lfifo_BU90_O,
      O => segment_lfifo_N1881
    );
  segment_out_state_h_out_state_ns_0_0_and2_1_Q : X_LUT4
    generic map(
      INIT => X"4454"
    )
    port map (
      ADR0 => segment_lfifo_mt,
      ADR1 => segment_N_1391,
      ADR2 => segment_N_1556_1,
      ADR3 => segment_lfifo_out_6_Q,
      O => segment_out_state_h_N_1554
    );
  segment_out_state_h_out_state_ns_0_0_and2_1_4_Q : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => segment_N_1752,
      ADR1 => segment_N_1394,
      ADR2 => segment_out_state_h_out_state_ns_0_0_and2_1_4_332,
      ADR3 => segment_out_state_6_Q,
      O => segment_out_state_h_N_1552
    );
  segment_out_state_h_out_state_ns_0_0_and2_1_4_332_631 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => segment_out_state_0_Q,
      ADR1 => segment_out_state_7_Q,
      ADR2 => segment_out_state_2_Q,
      ADR3 => segment_out_state_1_Q,
      O => segment_out_state_h_out_state_ns_0_0_and2_1_4_332
    );
  segment_out_state_h_N_304_i_632 : X_LUT4
    generic map(
      INIT => X"EEA4"
    )
    port map (
      ADR0 => segment_soc_out,
      ADR1 => segment_out_state_4_Q,
      ADR2 => segment_out_count(0),
      ADR3 => segment_N_650,
      O => segment_out_state_h_N_304_i
    );
  segment_out_state_h_out_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_out_state_2_Q,
      O => segment_out_state_1_Q,
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_state_h_out_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_865,
      O => segment_out_state_0_Q,
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_state_h_out_state_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_867,
      O => segment_out_state_7_Q,
      SSET => Reset_l_i_1,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  segment_out_state_h_out_state_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_out_state_h_N_1554,
      O => segment_out_state_6_Q,
      SRST => Reset_l_i_1,
      SSET => segment_N_1446,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  segment_out_state_h_out_state_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_out_state_h_N_304_i,
      O => segment_out_state_4_Q,
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_out_state_h_out_state_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_868,
      O => segment_out_state_3_Q,
      SRST => Reset_l_i_1,
      SSET => segment_out_state_h_N_1552,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  segment_out_state_h_out_state_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_N_1556,
      O => segment_out_state_2_Q,
      SRST => Reset_l_i,
      SSET => segment_N_1450,
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  segment_in_state_h_in_state_ns_19_0_and2 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => segment_in_state_h_in_state(0),
      ADR1 => segment_in_state_h_in_state(1),
      O => segment_N_289
    );
  segment_in_state_h_in_state_ns_21 : X_LUT3
    generic map(
      INIT => X"1C"
    )
    port map (
      ADR0 => segment_eof_in,
      ADR1 => segment_in_state_h_in_state(1),
      ADR2 => segment_in_state_h_in_state(0),
      O => segment_in_state_h_N_286
    );
  segment_in_state_h_in_state_ns_18 : X_LUT3
    generic map(
      INIT => X"62"
    )
    port map (
      ADR0 => segment_in_state_h_in_state(1),
      ADR1 => segment_dataen_in,
      ADR2 => segment_eof_in,
      O => segment_N_283
    );
  segment_in_state_h_N_281_i_633 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => segment_sof_in,
      ADR1 => segment_dataen_in,
      ADR2 => segment_in_state_h_N_286,
      ADR3 => segment_in_state_h_in_state(0),
      O => segment_in_state_h_N_281_i
    );
  segment_in_state_h_in_state_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => segment_in_state_h_N_281_i,
      O => segment_in_state_h_in_state(0),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_in_state_h_in_state_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_866,
      O => segment_in_state_h_in_state(1),
      SRST => Reset_l_i_1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_G_63 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => crc_out_crc_gen_count(1),
      ADR1 => crc_out_crc_gen_count(3),
      O => G_63_0
    );
  crc_out_crc_gen_G_62 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => crc_out_crc_gen_count(0),
      ADR1 => crc_out_crc_gen_count(2),
      O => G_62_0
    );
  crc_out_crc_gen_G_4 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => crc_out_crc_gen_count(0),
      ADR1 => crc_out_crc_gen_count(1),
      O => crc_out_crc_gen_un5_count_c2
    );
  crc_out_crc_gen_sof_buf_0_and2 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => crc_out_soc_wire,
      ADR1 => crc_out_crc_gen_is_lastcell,
      O => crc_out_crc_gen_sof_buf
    );
  crc_out_crc_gen_un2_crc_pos_0_and2 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => G_62_0,
      ADR1 => G_63_0,
      ADR2 => crc_out_crc_gen_is_lastcell,
      O => crc_out_crc_pos_wire
    );
  crc_out_crc_gen_crc_out_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(13),
      O => crc_out_crc_out(13),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(12),
      O => crc_out_crc_out(12),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(11),
      O => crc_out_crc_out(11),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(10),
      O => crc_out_crc_out(10),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(9),
      O => crc_out_crc_out(9),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(8),
      O => crc_out_crc_out(8),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(7),
      O => crc_out_crc_out(7),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(6),
      O => crc_out_crc_out(6),
      SRST => Reset_l_i_6_fast,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(5),
      O => crc_out_crc_out(5),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(4),
      O => crc_out_crc_out(4),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(3),
      O => crc_out_crc_out(3),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(2),
      O => crc_out_crc_out(2),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(1),
      O => crc_out_crc_out(1),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(0),
      O => crc_out_crc_out(0),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(28),
      O => crc_out_crc_out(28),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(27),
      O => crc_out_crc_out(27),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(26),
      O => crc_out_crc_out(26),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(25),
      O => crc_out_crc_out(25),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(24),
      O => crc_out_crc_out(24),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(23),
      O => crc_out_crc_out(23),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(22),
      O => crc_out_crc_out(22),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(21),
      O => crc_out_crc_out(21),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(20),
      O => crc_out_crc_out(20),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(19),
      O => crc_out_crc_out(19),
      SRST => Reset_l_i_7,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(18),
      O => crc_out_crc_out(18),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(17),
      O => crc_out_crc_out(17),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(16),
      O => crc_out_crc_out(16),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(15),
      O => crc_out_crc_out(15),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(14),
      O => crc_out_crc_out(14),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(31),
      O => crc_out_crc_out(31),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(30),
      O => crc_out_crc_out(30),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_crc_out_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_crc_gen_dataen_buf,
      CLK => CLK,
      I => crc_out_crc_gen_crc_calc(29),
      O => crc_out_crc_out(29),
      SRST => Reset_l_i_8,
      SSET => crc_out_crc_gen_sof_buf,
      SET => GND,
      RST => GSR
    );
  crc_out_crc_gen_is_lastcell_634 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CE => crc_out_soc_wire,
      CLK => CLK,
      I => crc_out_data_wire(1),
      O => crc_out_crc_gen_is_lastcell,
      SSET => Reset_l_i_8,
      SET => GSR,
      RST => GND,
      SRST => GND
    );
  crc_out_crc_gen_soc_delay_635 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_soc_wire,
      O => crc_out_crc_gen_soc_delay,
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_SOC_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_soc_in,
      O => crc_out_soc_wire,
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_soc_in_636 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => soc8,
      O => crc_out_crc_gen_d_soc_in,
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_dataen_buf_637 : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => N_955_i,
      O => crc_out_crc_gen_dataen_buf,
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_count_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_842,
      O => crc_out_crc_gen_count(0),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_count_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_843,
      O => crc_out_crc_gen_count(1),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_count_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_844,
      O => crc_out_crc_gen_count(2),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_count_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => G_845,
      O => crc_out_crc_gen_count(3),
      SRST => Reset_l_i,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(27),
      O => crc_out_data_wire(27),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(28),
      O => crc_out_data_wire(28),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(29),
      O => crc_out_data_wire(29),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(30),
      O => crc_out_data_wire(30),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(31),
      O => crc_out_data_wire(31),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(12),
      O => crc_out_data_wire(12),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(13),
      O => crc_out_data_wire(13),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(14),
      O => crc_out_data_wire(14),
      SRST => Reset_l_i_24,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(15),
      O => crc_out_data_wire(15),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(16),
      O => crc_out_data_wire(16),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(17),
      O => crc_out_data_wire(17),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(18),
      O => crc_out_data_wire(18),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(19),
      O => crc_out_data_wire(19),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(20),
      O => crc_out_data_wire(20),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(21),
      O => crc_out_data_wire(21),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(22),
      O => crc_out_data_wire(22),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(23),
      O => crc_out_data_wire(23),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(24),
      O => crc_out_data_wire(24),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(25),
      O => crc_out_data_wire(25),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(26),
      O => crc_out_data_wire(26),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(0),
      O => crc_out_data_wire(0),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(1),
      O => crc_out_data_wire(1),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(2),
      O => crc_out_data_wire(2),
      SRST => Reset_l_i_25,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(3),
      O => crc_out_data_wire(3),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(4),
      O => crc_out_data_wire(4),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(5),
      O => crc_out_data_wire(5),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(6),
      O => crc_out_data_wire(6),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(7),
      O => crc_out_data_wire(7),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(8),
      O => crc_out_data_wire(8),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(9),
      O => crc_out_data_wire(9),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(10),
      O => crc_out_data_wire(10),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_D_OUT_MOD_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_gen_d_data_in(11),
      O => crc_out_data_wire(11),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(25),
      O => crc_out_crc_gen_d_data_in(25),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(26),
      O => crc_out_crc_gen_d_data_in(26),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(27),
      O => crc_out_crc_gen_d_data_in(27),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(28),
      O => crc_out_crc_gen_d_data_in(28),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(29),
      O => crc_out_crc_gen_d_data_in(29),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(30),
      O => crc_out_crc_gen_d_data_in(30),
      SRST => Reset_l_i_26,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(31),
      O => crc_out_crc_gen_d_data_in(31),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(10),
      O => crc_out_crc_gen_d_data_in(10),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(11),
      O => crc_out_crc_gen_d_data_in(11),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(12),
      O => crc_out_crc_gen_d_data_in(12),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(13),
      O => crc_out_crc_gen_d_data_in(13),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(14),
      O => crc_out_crc_gen_d_data_in(14),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(15),
      O => crc_out_crc_gen_d_data_in(15),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(16),
      O => crc_out_crc_gen_d_data_in(16),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(17),
      O => crc_out_crc_gen_d_data_in(17),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(18),
      O => crc_out_crc_gen_d_data_in(18),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(19),
      O => crc_out_crc_gen_d_data_in(19),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(20),
      O => crc_out_crc_gen_d_data_in(20),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(21),
      O => crc_out_crc_gen_d_data_in(21),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(22),
      O => crc_out_crc_gen_d_data_in(22),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(23),
      O => crc_out_crc_gen_d_data_in(23),
      SRST => Reset_l_i_27,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(24),
      O => crc_out_crc_gen_d_data_in(24),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(0),
      O => crc_out_crc_gen_d_data_in(0),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(1),
      O => crc_out_crc_gen_d_data_in(1),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(2),
      O => crc_out_crc_gen_d_data_in(2),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(3),
      O => crc_out_crc_gen_d_data_in(3),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(4),
      O => crc_out_crc_gen_d_data_in(4),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(5),
      O => crc_out_crc_gen_d_data_in(5),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(6),
      O => crc_out_crc_gen_d_data_in(6),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(7),
      O => crc_out_crc_gen_d_data_in(7),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(8),
      O => crc_out_crc_gen_d_data_in(8),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_d_data_in_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => data8(9),
      O => crc_out_crc_gen_d_data_in(9),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_gen_crccalc_prexor_thexor0_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(0),
      ADR1 => crc_out_crc_out(0),
      O => crc_out_crc_gen_crccalc_prexored(0)
    );
  crc_out_crc_gen_crccalc_prexor_thexor1_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(1),
      ADR1 => crc_out_crc_out(1),
      O => crc_out_crc_gen_crccalc_prexored(1)
    );
  crc_out_crc_gen_crccalc_prexor_thexor2_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(2),
      ADR1 => crc_out_crc_out(2),
      O => crc_out_crc_gen_crccalc_prexored(2)
    );
  crc_out_crc_gen_crccalc_prexor_thexor3_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(3),
      ADR1 => crc_out_crc_out(3),
      O => crc_out_crc_gen_crccalc_prexored(3)
    );
  crc_out_crc_gen_crccalc_prexor_thexor4_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(4),
      ADR1 => crc_out_crc_out(4),
      O => crc_out_crc_gen_crccalc_prexored(4)
    );
  crc_out_crc_gen_crccalc_prexor_thexor5_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(5),
      ADR1 => crc_out_crc_out(5),
      O => crc_out_crc_gen_crccalc_prexored(5)
    );
  crc_out_crc_gen_crccalc_prexor_thexor6_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(6),
      ADR1 => crc_out_crc_out(6),
      O => crc_out_crc_gen_crccalc_prexored(6)
    );
  crc_out_crc_gen_crccalc_prexor_thexor7_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(7),
      ADR1 => crc_out_crc_out(7),
      O => crc_out_crc_gen_crccalc_prexored(7)
    );
  crc_out_crc_gen_crccalc_prexor_thexor8_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(8),
      ADR1 => crc_out_crc_out(8),
      O => crc_out_crc_gen_crccalc_prexored(8)
    );
  crc_out_crc_gen_crccalc_prexor_thexor9_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(9),
      ADR1 => crc_out_crc_out(9),
      O => crc_out_crc_gen_crccalc_prexored(9)
    );
  crc_out_crc_gen_crccalc_prexor_thexor10_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(10),
      ADR1 => crc_out_crc_out(10),
      O => crc_out_crc_gen_crccalc_prexored(10)
    );
  crc_out_crc_gen_crccalc_prexor_thexor11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(11),
      ADR1 => crc_out_crc_out(11),
      O => crc_out_crc_gen_crccalc_prexored(11)
    );
  crc_out_crc_gen_crccalc_prexor_thexor12_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(12),
      ADR1 => crc_out_crc_out(12),
      O => crc_out_crc_gen_crccalc_prexored(12)
    );
  crc_out_crc_gen_crccalc_prexor_thexor13_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(13),
      ADR1 => crc_out_crc_out(13),
      O => crc_out_crc_gen_crccalc_prexored(13)
    );
  crc_out_crc_gen_crccalc_prexor_thexor14_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(14),
      ADR1 => crc_out_crc_out(14),
      O => crc_out_crc_gen_crccalc_prexored(14)
    );
  crc_out_crc_gen_crccalc_prexor_thexor15_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(15),
      ADR1 => crc_out_crc_out(15),
      O => crc_out_crc_gen_crccalc_prexored(15)
    );
  crc_out_crc_gen_crccalc_prexor_thexor16_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(16),
      ADR1 => crc_out_crc_out(16),
      O => crc_out_crc_gen_crccalc_prexored(16)
    );
  crc_out_crc_gen_crccalc_prexor_thexor17_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(17),
      ADR1 => crc_out_crc_out(17),
      O => crc_out_crc_gen_crccalc_prexored(17)
    );
  crc_out_crc_gen_crccalc_prexor_thexor18_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(18),
      ADR1 => crc_out_crc_out(18),
      O => crc_out_crc_gen_crccalc_prexored(18)
    );
  crc_out_crc_gen_crccalc_prexor_thexor19_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(19),
      ADR1 => crc_out_crc_out(19),
      O => crc_out_crc_gen_crccalc_prexored(19)
    );
  crc_out_crc_gen_crccalc_prexor_thexor20_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(20),
      ADR1 => crc_out_crc_out(20),
      O => crc_out_crc_gen_crccalc_prexored(20)
    );
  crc_out_crc_gen_crccalc_prexor_thexor21_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(21),
      ADR1 => crc_out_crc_out(21),
      O => crc_out_crc_gen_crccalc_prexored(21)
    );
  crc_out_crc_gen_crccalc_prexor_thexor22_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(22),
      ADR1 => crc_out_crc_out(22),
      O => crc_out_crc_gen_crccalc_prexored(22)
    );
  crc_out_crc_gen_crccalc_prexor_thexor23_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(23),
      ADR1 => crc_out_crc_out(23),
      O => crc_out_crc_gen_crccalc_prexored(23)
    );
  crc_out_crc_gen_crccalc_prexor_thexor24_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(24),
      ADR1 => crc_out_crc_out(24),
      O => crc_out_crc_gen_crccalc_prexored(24)
    );
  crc_out_crc_gen_crccalc_prexor_thexor25_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(25),
      ADR1 => crc_out_crc_out(25),
      O => crc_out_crc_gen_crccalc_prexored(25)
    );
  crc_out_crc_gen_crccalc_prexor_thexor26_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(26),
      ADR1 => crc_out_crc_out(26),
      O => crc_out_crc_gen_crccalc_prexored(26)
    );
  crc_out_crc_gen_crccalc_prexor_thexor27_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(27),
      ADR1 => crc_out_crc_out(27),
      O => crc_out_crc_gen_crccalc_prexored(27)
    );
  crc_out_crc_gen_crccalc_prexor_thexor28_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(28),
      ADR1 => crc_out_crc_out(28),
      O => crc_out_crc_gen_crccalc_prexored(28)
    );
  crc_out_crc_gen_crccalc_prexor_thexor29_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(29),
      ADR1 => crc_out_crc_out(29),
      O => crc_out_crc_gen_crccalc_prexored(29)
    );
  crc_out_crc_gen_crccalc_prexor_thexor30_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(30),
      ADR1 => crc_out_crc_out(30),
      O => crc_out_crc_gen_crccalc_prexored(30)
    );
  crc_out_crc_gen_crccalc_prexor_thexor31_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_data_wire(31),
      ADR1 => crc_out_crc_out(31),
      O => crc_out_crc_gen_crccalc_prexored(31)
    );
  crc_out_crc_gen_crccalc_matrix_row0_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row0_xorq_q_350,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q001,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q11,
      ADR3 => crc_out_crc_gen_crccalc_matrix_row0_xorq_q_351,
      O => crc_out_crc_gen_crc_calc(0)
    );
  crc_out_crc_gen_crccalc_matrix_row0_xorq_q_350_638 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(16),
      ADR1 => crc_out_crc_gen_crccalc_prexored(28),
      ADR2 => crc_out_crc_gen_crccalc_prexored(0),
      ADR3 => crc_out_crc_gen_crccalc_prexored(6),
      O => crc_out_crc_gen_crccalc_matrix_row0_xorq_q_350
    );
  crc_out_crc_gen_crccalc_matrix_row0_xorq_q_351_639 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(12),
      ADR1 => crc_out_crc_gen_crccalc_prexored(25),
      ADR2 => crc_out_crc_gen_crccalc_prexored(24),
      ADR3 => crc_out_crc_gen_crccalc_prexored(26),
      O => crc_out_crc_gen_crccalc_matrix_row0_xorq_q_351
    );
  crc_out_crc_gen_crccalc_matrix_row0_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(9),
      ADR1 => crc_out_data_wire(9),
      ADR2 => crc_out_crc_out(10),
      ADR3 => crc_out_data_wire(10),
      O => crc_out_crc_gen_crccalc_matrix_q001
    );
  crc_out_crc_gen_crccalc_matrix_row0_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(30),
      ADR1 => crc_out_data_wire(30),
      ADR2 => crc_out_crc_out(31),
      ADR3 => crc_out_data_wire(31),
      O => crc_out_crc_gen_crccalc_matrix_q111
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row1_xorq_q_188,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row1_xorq_q_186,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q010_0,
      O => crc_out_crc_gen_crc_calc(1)
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq_q_186_640 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q100,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110,
      O => crc_out_crc_gen_crccalc_matrix_row1_xorq_q_186
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq_q_188_641 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q000,
      ADR1 => crc_out_crc_gen_crccalc_prexored(13),
      ADR2 => crc_out_crc_gen_crccalc_prexored(24),
      ADR3 => crc_out_crc_gen_crccalc_prexored(9),
      O => crc_out_crc_gen_crccalc_matrix_row1_xorq_q_188
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq000_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(0),
      ADR1 => crc_out_data_wire(0),
      ADR2 => crc_out_crc_out(1),
      ADR3 => crc_out_data_wire(1),
      O => crc_out_crc_gen_crccalc_matrix_q000
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(6),
      ADR1 => crc_out_data_wire(6),
      ADR2 => crc_out_crc_out(7),
      ADR3 => crc_out_data_wire(7),
      O => crc_out_crc_gen_crccalc_matrix_q010_0
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(11),
      ADR1 => crc_out_data_wire(11),
      ADR2 => crc_out_crc_out(12),
      ADR3 => crc_out_data_wire(12),
      O => crc_out_crc_gen_crccalc_matrix_q010
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(16),
      ADR1 => crc_out_data_wire(16),
      ADR2 => crc_out_crc_out(17),
      ADR3 => crc_out_data_wire(17),
      O => crc_out_crc_gen_crccalc_matrix_q100
    );
  crc_out_crc_gen_crccalc_matrix_row1_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(27),
      ADR1 => crc_out_data_wire(27),
      ADR2 => crc_out_crc_out(28),
      ADR3 => crc_out_data_wire(28),
      O => crc_out_crc_gen_crccalc_matrix_q110
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row2_xorq_q_324,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row2_xorq_q_319,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q001_0,
      O => crc_out_crc_gen_crc_calc(2)
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq_q_319_642 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_out_crc_gen_crccalc_prexored(13),
      ADR2 => crc_out_crc_gen_crccalc_prexored(9),
      O => crc_out_crc_gen_crccalc_matrix_row2_xorq_q_319
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq_q_324_643 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q000,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q101,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q110_0,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q100_0,
      O => crc_out_crc_gen_crccalc_matrix_row2_xorq_q_324
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(2),
      ADR1 => crc_out_data_wire(2),
      ADR2 => crc_out_crc_out(6),
      ADR3 => crc_out_data_wire(6),
      O => crc_out_crc_gen_crccalc_matrix_q001_0
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(7),
      ADR1 => crc_out_data_wire(7),
      ADR2 => crc_out_crc_out(8),
      ADR3 => crc_out_data_wire(8),
      O => crc_out_crc_gen_crccalc_matrix_q010_1
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(14),
      ADR1 => crc_out_data_wire(14),
      ADR2 => crc_out_crc_out(16),
      ADR3 => crc_out_data_wire(16),
      O => crc_out_crc_gen_crccalc_matrix_q100_0
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(17),
      ADR1 => crc_out_data_wire(17),
      ADR2 => crc_out_crc_out(18),
      ADR3 => crc_out_data_wire(18),
      O => crc_out_crc_gen_crccalc_matrix_q101
    );
  crc_out_crc_gen_crccalc_matrix_row2_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(24),
      ADR1 => crc_out_data_wire(24),
      ADR2 => crc_out_crc_out(26),
      ADR3 => crc_out_data_wire(26),
      O => crc_out_crc_gen_crccalc_matrix_q110_0
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row3_xorq_q_89,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row3_xorq_q_88,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q100_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q000_0,
      O => crc_out_crc_gen_crc_calc(3)
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq_q_83_644 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(10),
      ADR1 => crc_out_data_wire(10),
      ADR2 => crc_out_crc_out(3),
      ADR3 => crc_out_data_wire(3),
      O => crc_out_crc_gen_crccalc_matrix_row3_xorq_q_83
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq_q_88_645 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q100_2,
      ADR1 => crc_out_crc_gen_crccalc_prexored(14),
      ADR2 => crc_out_crc_gen_crccalc_prexored(7),
      ADR3 => crc_out_crc_gen_crccalc_prexored(31),
      O => crc_out_crc_gen_crccalc_matrix_row3_xorq_q_88
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq_q_89_646 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_2,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row3_xorq_q_83,
      ADR2 => crc_out_crc_gen_crccalc_prexored(25),
      ADR3 => crc_out_crc_gen_crccalc_prexored(27),
      O => crc_out_crc_gen_crccalc_matrix_row3_xorq_q_89
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(8),
      ADR1 => crc_out_data_wire(8),
      ADR2 => crc_out_crc_out(9),
      ADR3 => crc_out_data_wire(9),
      O => crc_out_crc_gen_crccalc_matrix_q010_2
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(15),
      ADR1 => crc_out_data_wire(15),
      ADR2 => crc_out_crc_out(17),
      ADR3 => crc_out_data_wire(17),
      O => crc_out_crc_gen_crccalc_matrix_q100_1
    );
  crc_out_crc_gen_crccalc_matrix_row3_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(18),
      ADR1 => crc_out_data_wire(18),
      ADR2 => crc_out_crc_out(19),
      ADR3 => crc_out_data_wire(19),
      O => crc_out_crc_gen_crccalc_matrix_q100_2
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row4_xorq_q_237,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row4_xorq_q_236,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q100_2,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q011,
      O => crc_out_crc_gen_crc_calc(4)
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq_q_231_647 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(0),
      ADR1 => crc_out_data_wire(0),
      ADR2 => crc_out_crc_out(25),
      ADR3 => crc_out_data_wire(25),
      O => crc_out_crc_gen_crccalc_matrix_row4_xorq_q_231
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq_q_236_648 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q001_1,
      ADR1 => crc_out_crc_gen_crccalc_prexored(24),
      ADR2 => crc_out_crc_gen_crccalc_prexored(20),
      ADR3 => crc_out_crc_gen_crccalc_prexored(29),
      O => crc_out_crc_gen_crccalc_matrix_row4_xorq_q_236
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq_q_237_649 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row4_xorq_q_231,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q000_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q011_0,
      O => crc_out_crc_gen_crccalc_matrix_row4_xorq_q_237
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq0000_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(2),
      ADR1 => crc_out_data_wire(2),
      ADR2 => crc_out_crc_out(3),
      ADR3 => crc_out_data_wire(3),
      O => crc_out_crc_gen_crccalc_matrix_q000_1
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(4),
      ADR1 => crc_out_data_wire(4),
      ADR2 => crc_out_crc_out(6),
      ADR3 => crc_out_data_wire(6),
      O => crc_out_crc_gen_crccalc_matrix_q001_1
    );
  crc_out_crc_gen_crccalc_matrix_row4_xorq011_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(12),
      ADR1 => crc_out_data_wire(12),
      ADR2 => crc_out_crc_out(15),
      ADR3 => crc_out_data_wire(15),
      O => crc_out_crc_gen_crccalc_matrix_q011
    );
  crc_out_crc_gen_crccalc_matrix_row5_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row5_xorq_q_517,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q00,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q011_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q101_0,
      O => crc_out_crc_gen_crc_calc(5)
    );
  crc_out_crc_gen_crccalc_matrix_row5_xorq_q_514_650 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(13),
      ADR1 => crc_out_crc_gen_crccalc_prexored(19),
      ADR2 => crc_out_crc_gen_crccalc_prexored(6),
      O => crc_out_crc_gen_crccalc_matrix_row5_xorq_q_514
    );
  crc_out_crc_gen_crccalc_matrix_row5_xorq_q_517_651 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row5_xorq_q_514,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q111_0,
      ADR2 => crc_out_crc_gen_crccalc_prexored(24),
      ADR3 => crc_out_crc_gen_crccalc_prexored(5),
      O => crc_out_crc_gen_crccalc_matrix_row5_xorq_q_517
    );
  crc_out_crc_gen_crccalc_matrix_row5_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(3),
      ADR1 => crc_out_data_wire(3),
      ADR2 => crc_out_crc_out(4),
      ADR3 => crc_out_data_wire(4),
      O => crc_out_crc_gen_crccalc_matrix_q001_2
    );
  crc_out_crc_gen_crccalc_matrix_row5_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(20),
      ADR1 => crc_out_data_wire(20),
      ADR2 => crc_out_crc_out(21),
      ADR3 => crc_out_data_wire(21),
      O => crc_out_crc_gen_crccalc_matrix_q101_0
    );
  crc_out_crc_gen_crccalc_matrix_row5_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(28),
      ADR1 => crc_out_data_wire(28),
      ADR2 => crc_out_crc_out(29),
      ADR3 => crc_out_data_wire(29),
      O => crc_out_crc_gen_crccalc_matrix_q111_0
    );
  crc_out_crc_gen_crccalc_matrix_row6_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row6_xorq_q_183,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row6_xorq_q_178,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q011_0,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q000_0,
      O => crc_out_crc_gen_crc_calc(6)
    );
  crc_out_crc_gen_crccalc_matrix_row6_xorq_q_178_652 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(14),
      ADR1 => crc_out_crc_gen_crccalc_prexored(25),
      ADR2 => crc_out_crc_gen_crccalc_prexored(20),
      O => crc_out_crc_gen_crccalc_matrix_row6_xorq_q_178
    );
  crc_out_crc_gen_crccalc_matrix_row6_xorq_q_183_653 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_0,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q101_1,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q110_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q001_3,
      O => crc_out_crc_gen_crccalc_matrix_row6_xorq_q_183
    );
  crc_out_crc_gen_crccalc_matrix_row6_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(4),
      ADR1 => crc_out_data_wire(4),
      ADR2 => crc_out_crc_out(5),
      ADR3 => crc_out_data_wire(5),
      O => crc_out_crc_gen_crccalc_matrix_q001_3
    );
  crc_out_crc_gen_crccalc_matrix_row6_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(21),
      ADR1 => crc_out_data_wire(21),
      ADR2 => crc_out_crc_out(22),
      ADR3 => crc_out_data_wire(22),
      O => crc_out_crc_gen_crccalc_matrix_q101_1
    );
  crc_out_crc_gen_crccalc_matrix_row6_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(29),
      ADR1 => crc_out_data_wire(29),
      ADR2 => crc_out_crc_out(30),
      ADR3 => crc_out_data_wire(30),
      O => crc_out_crc_gen_crccalc_matrix_q110_1
    );
  crc_out_crc_gen_crccalc_matrix_row7_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row7_xorq_q_423,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110_2,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q111_0,
      O => crc_out_crc_gen_crc_calc(7)
    );
  crc_out_crc_gen_crccalc_matrix_row7_xorq_q_419_654 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(15),
      ADR1 => crc_out_crc_gen_crccalc_prexored(16),
      ADR2 => crc_out_crc_gen_crccalc_prexored(10),
      ADR3 => crc_out_crc_gen_crccalc_prexored(21),
      O => crc_out_crc_gen_crccalc_matrix_row7_xorq_q_419
    );
  crc_out_crc_gen_crccalc_matrix_row7_xorq_q_423_655 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q00_0,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row7_xorq_q_419,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q101_2,
      O => crc_out_crc_gen_crccalc_matrix_row7_xorq_q_423
    );
  crc_out_crc_gen_crccalc_matrix_row7_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(3),
      ADR1 => crc_out_data_wire(3),
      ADR2 => crc_out_crc_out(5),
      ADR3 => crc_out_data_wire(5),
      O => crc_out_crc_gen_crccalc_matrix_q001_4
    );
  crc_out_crc_gen_crccalc_matrix_row7_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(22),
      ADR1 => crc_out_data_wire(22),
      ADR2 => crc_out_crc_out(23),
      ADR3 => crc_out_data_wire(23),
      O => crc_out_crc_gen_crccalc_matrix_q101_2
    );
  crc_out_crc_gen_crccalc_matrix_row7_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(24),
      ADR1 => crc_out_data_wire(24),
      ADR2 => crc_out_crc_out(25),
      ADR3 => crc_out_data_wire(25),
      O => crc_out_crc_gen_crccalc_matrix_q110_2
    );
  crc_out_crc_gen_crccalc_matrix_row8_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q00,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row8_xorq_q_523,
      ADR2 => crc_out_crc_gen_crccalc_matrix_row8_xorq_q_522,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q110_3,
      O => crc_out_crc_gen_crc_calc(8)
    );
  crc_out_crc_gen_crccalc_matrix_row8_xorq_q_520 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(8),
      ADR1 => crc_out_data_wire(8),
      ADR2 => crc_out_crc_out(11),
      ADR3 => crc_out_data_wire(11),
      O => crc_out_crc_gen_crccalc_matrix_q011_0
    );
  crc_out_crc_gen_crccalc_matrix_row8_xorq_q_522_656 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(12),
      ADR1 => crc_out_crc_gen_crccalc_matrix_q011_0,
      O => crc_out_crc_gen_crccalc_matrix_row8_xorq_q_522
    );
  crc_out_crc_gen_crccalc_matrix_row8_xorq_q_523_657 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(17),
      ADR1 => crc_out_crc_gen_crccalc_prexored(22),
      ADR2 => crc_out_crc_gen_crccalc_prexored(10),
      ADR3 => crc_out_crc_gen_crccalc_prexored(23),
      O => crc_out_crc_gen_crccalc_matrix_row8_xorq_q_523
    );
  crc_out_crc_gen_crccalc_matrix_row8_xorq00_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q000,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q001_2,
      O => crc_out_crc_gen_crccalc_matrix_q00
    );
  crc_out_crc_gen_crccalc_matrix_row8_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(28),
      ADR1 => crc_out_data_wire(28),
      ADR2 => crc_out_crc_out(31),
      ADR3 => crc_out_data_wire(31),
      O => crc_out_crc_gen_crccalc_matrix_q110_3
    );
  crc_out_crc_gen_crccalc_matrix_row9_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row9_xorq_q_58,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q010_3,
      ADR2 => crc_out_crc_gen_crccalc_prexored(13),
      ADR3 => crc_out_crc_gen_crccalc_prexored(24),
      O => crc_out_crc_gen_crc_calc(9)
    );
  crc_out_crc_gen_crccalc_matrix_row9_xorq_q_50 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(1),
      ADR1 => crc_out_data_wire(1),
      ADR2 => crc_out_crc_out(2),
      ADR3 => crc_out_data_wire(2),
      O => crc_out_crc_gen_crccalc_matrix_q000_0
    );
  crc_out_crc_gen_crccalc_matrix_row9_xorq_q_56_658 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(5),
      ADR1 => crc_out_crc_gen_crccalc_prexored(18),
      ADR2 => crc_out_crc_gen_crccalc_prexored(12),
      ADR3 => crc_out_crc_gen_crccalc_prexored(4),
      O => crc_out_crc_gen_crccalc_matrix_row9_xorq_q_56
    );
  crc_out_crc_gen_crccalc_matrix_row9_xorq_q_58_659 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row9_xorq_q_56,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q000_0,
      ADR2 => crc_out_crc_gen_crccalc_prexored(29),
      ADR3 => crc_out_crc_gen_crccalc_prexored(23),
      O => crc_out_crc_gen_crccalc_matrix_row9_xorq_q_58
    );
  crc_out_crc_gen_crccalc_matrix_row9_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(9),
      ADR1 => crc_out_data_wire(9),
      ADR2 => crc_out_crc_out(11),
      ADR3 => crc_out_data_wire(11),
      O => crc_out_crc_gen_crccalc_matrix_q010_3
    );
  crc_out_crc_gen_crccalc_matrix_row10_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row10_xorq_q_532,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q_531,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q11_0,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q00_0,
      O => crc_out_crc_gen_crc_calc(10)
    );
  crc_out_crc_gen_crccalc_matrix_row10_xorq_q_531 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(14),
      ADR1 => crc_out_data_wire(14),
      ADR2 => crc_out_crc_out(13),
      ADR3 => crc_out_data_wire(13),
      O => crc_out_crc_gen_crccalc_matrix_q_531
    );
  crc_out_crc_gen_crccalc_matrix_row10_xorq_q_532_660 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(19),
      ADR1 => crc_out_crc_gen_crccalc_prexored(16),
      ADR2 => crc_out_crc_gen_crccalc_prexored(26),
      ADR3 => crc_out_crc_gen_crccalc_prexored(9),
      O => crc_out_crc_gen_crccalc_matrix_row10_xorq_q_532
    );
  crc_out_crc_gen_crccalc_matrix_row10_xorq00_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q001_4,
      ADR1 => crc_out_crc_gen_crccalc_prexored(0),
      ADR2 => crc_out_crc_gen_crccalc_prexored(2),
      O => crc_out_crc_gen_crccalc_matrix_q00_0
    );
  crc_out_crc_gen_crccalc_matrix_row11_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row11_xorq_q_298,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row11_xorq_q_296,
      ADR2 => crc_out_crc_gen_crccalc_matrix_row11_xorq_q_294,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q100_3,
      O => crc_out_crc_gen_crc_calc(11)
    );
  crc_out_crc_gen_crccalc_matrix_row11_xorq_q_294_661 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(3),
      ADR1 => crc_out_crc_gen_crccalc_prexored(20),
      ADR2 => crc_out_crc_gen_crccalc_prexored(0),
      ADR3 => crc_out_crc_gen_crccalc_prexored(4),
      O => crc_out_crc_gen_crccalc_matrix_row11_xorq_q_294
    );
  crc_out_crc_gen_crccalc_matrix_row11_xorq_q_296_662 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_4,
      ADR1 => crc_out_crc_gen_crccalc_prexored(14),
      ADR2 => crc_out_crc_gen_crccalc_prexored(17),
      ADR3 => crc_out_crc_gen_crccalc_prexored(1),
      O => crc_out_crc_gen_crccalc_matrix_row11_xorq_q_296
    );
  crc_out_crc_gen_crccalc_matrix_row11_xorq_q_298_663 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_2,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110_3,
      ADR2 => crc_out_crc_gen_crccalc_prexored(9),
      ADR3 => crc_out_crc_gen_crccalc_prexored(12),
      O => crc_out_crc_gen_crccalc_matrix_row11_xorq_q_298
    );
  crc_out_crc_gen_crccalc_matrix_row11_xorq011_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(15),
      ADR1 => crc_out_data_wire(15),
      ADR2 => crc_out_crc_out(16),
      ADR3 => crc_out_data_wire(16),
      O => crc_out_crc_gen_crccalc_matrix_q010_4
    );
  crc_out_crc_gen_crccalc_matrix_row11_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(26),
      ADR1 => crc_out_data_wire(26),
      ADR2 => crc_out_crc_out(27),
      ADR3 => crc_out_data_wire(27),
      O => crc_out_crc_gen_crccalc_matrix_q100_3
    );
  crc_out_crc_gen_crccalc_matrix_row12_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row12_xorq_q_71,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row12_xorq_q_70,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q001_3,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q100_1,
      O => crc_out_crc_gen_crc_calc(12)
    );
  crc_out_crc_gen_crccalc_matrix_row12_xorq_q_67_664 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_out_crc_gen_crccalc_prexored(0),
      ADR2 => crc_out_crc_gen_crccalc_prexored(27),
      O => crc_out_crc_gen_crccalc_matrix_row12_xorq_q_67
    );
  crc_out_crc_gen_crccalc_matrix_row12_xorq_q_70_665 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q001_5,
      ADR1 => crc_out_crc_gen_crccalc_prexored(13),
      ADR2 => crc_out_crc_gen_crccalc_prexored(18),
      ADR3 => crc_out_crc_gen_crccalc_prexored(21),
      O => crc_out_crc_gen_crccalc_matrix_row12_xorq_q_70
    );
  crc_out_crc_gen_crccalc_matrix_row12_xorq_q_71_666 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row12_xorq_q_67,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q000_0,
      ADR2 => crc_out_crc_gen_crccalc_prexored(24),
      ADR3 => crc_out_crc_gen_crccalc_prexored(12),
      O => crc_out_crc_gen_crccalc_matrix_row12_xorq_q_71
    );
  crc_out_crc_gen_crccalc_matrix_row12_xorq010_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(6),
      ADR1 => crc_out_data_wire(6),
      ADR2 => crc_out_crc_out(9),
      ADR3 => crc_out_data_wire(9),
      O => crc_out_crc_gen_crccalc_matrix_q001_5
    );
  crc_out_crc_gen_crccalc_matrix_row13_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row13_xorq_q_269,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row13_xorq_q_267,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q100_0,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q100_2,
      O => crc_out_crc_gen_crc_calc(13)
    );
  crc_out_crc_gen_crccalc_matrix_row13_xorq_q_265_667 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q000_0,
      ADR1 => crc_out_crc_gen_crccalc_prexored(10),
      ADR2 => crc_out_crc_gen_crccalc_prexored(22),
      O => crc_out_crc_gen_crccalc_matrix_row13_xorq_q_265
    );
  crc_out_crc_gen_crccalc_matrix_row13_xorq_q_267_668 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q001_4,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q010_0,
      O => crc_out_crc_gen_crccalc_matrix_row13_xorq_q_267
    );
  crc_out_crc_gen_crccalc_matrix_row13_xorq_q_269_669 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row13_xorq_q_265,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110_3,
      ADR2 => crc_out_crc_gen_crccalc_prexored(13),
      ADR3 => crc_out_crc_gen_crccalc_prexored(25),
      O => crc_out_crc_gen_crccalc_matrix_row13_xorq_q_269
    );
  crc_out_crc_gen_crccalc_matrix_row14_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row14_xorq_q_175,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row14_xorq_q_173,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q001_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q010_5,
      O => crc_out_crc_gen_crc_calc(14)
    );
  crc_out_crc_gen_crccalc_matrix_row14_xorq_q_171_670 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(14),
      ADR1 => crc_out_crc_gen_crccalc_prexored(23),
      ADR2 => crc_out_crc_gen_crccalc_prexored(11),
      O => crc_out_crc_gen_crccalc_matrix_row14_xorq_q_171
    );
  crc_out_crc_gen_crccalc_matrix_row14_xorq_q_173_671 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_1,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q000_1,
      O => crc_out_crc_gen_crccalc_matrix_row14_xorq_q_173
    );
  crc_out_crc_gen_crccalc_matrix_row14_xorq_q_175_672 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row14_xorq_q_171,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q100_1,
      ADR2 => crc_out_crc_gen_crccalc_prexored(26),
      ADR3 => crc_out_crc_gen_crccalc_prexored(29),
      O => crc_out_crc_gen_crccalc_matrix_row14_xorq_q_175
    );
  crc_out_crc_gen_crccalc_matrix_row14_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(19),
      ADR1 => crc_out_data_wire(19),
      ADR2 => crc_out_crc_out(20),
      ADR3 => crc_out_data_wire(20),
      O => crc_out_crc_gen_crccalc_matrix_q010_5
    );
  crc_out_crc_gen_crccalc_matrix_row15_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row15_xorq_q_245,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row15_xorq_q_240,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q001_6,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q010_6,
      O => crc_out_crc_gen_crc_calc(15)
    );
  crc_out_crc_gen_crccalc_matrix_row15_xorq_q_240_673 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(24),
      ADR1 => crc_out_crc_gen_crccalc_prexored(27),
      ADR2 => crc_out_crc_gen_crccalc_prexored(30),
      O => crc_out_crc_gen_crccalc_matrix_row15_xorq_q_240
    );
  crc_out_crc_gen_crccalc_matrix_row15_xorq_q_245_674 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q101_0,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q001_2,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_2,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q011,
      O => crc_out_crc_gen_crccalc_matrix_row15_xorq_q_245
    );
  crc_out_crc_gen_crccalc_matrix_row15_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(5),
      ADR1 => crc_out_data_wire(5),
      ADR2 => crc_out_crc_out(7),
      ADR3 => crc_out_data_wire(7),
      O => crc_out_crc_gen_crccalc_matrix_q001_6
    );
  crc_out_crc_gen_crccalc_matrix_row15_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(16),
      ADR1 => crc_out_data_wire(16),
      ADR2 => crc_out_crc_out(18),
      ADR3 => crc_out_data_wire(18),
      O => crc_out_crc_gen_crccalc_matrix_q010_6
    );
  crc_out_crc_gen_crccalc_matrix_row16_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row16_xorq_q_154,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row16_xorq_q_150,
      ADR2 => crc_out_crc_gen_crccalc_prexored(24),
      ADR3 => crc_out_crc_gen_crccalc_prexored(22),
      O => crc_out_crc_gen_crc_calc(16)
    );
  crc_out_crc_gen_crccalc_matrix_row16_xorq_q_150_675 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(21),
      ADR1 => crc_out_crc_gen_crccalc_prexored(17),
      ADR2 => crc_out_crc_gen_crccalc_prexored(4),
      ADR3 => crc_out_crc_gen_crccalc_prexored(19),
      O => crc_out_crc_gen_crccalc_matrix_row16_xorq_q_150
    );
  crc_out_crc_gen_crccalc_matrix_row16_xorq_q_151_676 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(12),
      ADR1 => crc_out_crc_gen_crccalc_prexored(0),
      ADR2 => crc_out_crc_gen_crccalc_prexored(13),
      ADR3 => crc_out_crc_gen_crccalc_prexored(26),
      O => crc_out_crc_gen_crccalc_matrix_row16_xorq_q_151
    );
  crc_out_crc_gen_crccalc_matrix_row16_xorq_q_154_677 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row16_xorq_q_151,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110_1,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q000_2,
      O => crc_out_crc_gen_crccalc_matrix_row16_xorq_q_154
    );
  crc_out_crc_gen_crccalc_matrix_row16_xorq001_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(5),
      ADR1 => crc_out_data_wire(5),
      ADR2 => crc_out_crc_out(8),
      ADR3 => crc_out_data_wire(8),
      O => crc_out_crc_gen_crccalc_matrix_q000_2
    );
  crc_out_crc_gen_crccalc_matrix_row17_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row17_xorq_q_98,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row17_xorq_q_96,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q100_4,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q_531,
      O => crc_out_crc_gen_crc_calc(17)
    );
  crc_out_crc_gen_crccalc_matrix_row17_xorq_q_91_678 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(1),
      ADR1 => crc_out_data_wire(1),
      ADR2 => crc_out_crc_out(22),
      ADR3 => crc_out_data_wire(22),
      O => crc_out_crc_gen_crccalc_matrix_row17_xorq_q_91
    );
  crc_out_crc_gen_crccalc_matrix_row17_xorq_q_96_679 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_out_crc_gen_crccalc_prexored(5),
      ADR2 => crc_out_crc_gen_crccalc_prexored(27),
      O => crc_out_crc_gen_crccalc_matrix_row17_xorq_q_96
    );
  crc_out_crc_gen_crccalc_matrix_row17_xorq_q_98_680 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q001_5,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row17_xorq_q_91,
      ADR2 => crc_out_crc_gen_crccalc_prexored(18),
      ADR3 => crc_out_crc_gen_crccalc_prexored(20),
      O => crc_out_crc_gen_crccalc_matrix_row17_xorq_q_98
    );
  crc_out_crc_gen_crccalc_matrix_row17_xorq101_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(23),
      ADR1 => crc_out_data_wire(23),
      ADR2 => crc_out_crc_out(25),
      ADR3 => crc_out_data_wire(25),
      O => crc_out_crc_gen_crccalc_matrix_q100_4
    );
  crc_out_crc_gen_crccalc_matrix_row18_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row18_xorq_q_402,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q11_1,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q011_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q001_0,
      O => crc_out_crc_gen_crc_calc(18)
    );
  crc_out_crc_gen_crccalc_matrix_row18_xorq_q_398_681 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(15),
      ADR1 => crc_out_data_wire(15),
      ADR2 => crc_out_crc_out(21),
      ADR3 => crc_out_data_wire(21),
      O => crc_out_crc_gen_crccalc_matrix_row18_xorq_q_398
    );
  crc_out_crc_gen_crccalc_matrix_row18_xorq_q_402_682 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_7,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row18_xorq_q_398,
      ADR2 => crc_out_crc_gen_crccalc_prexored(14),
      ADR3 => crc_out_crc_gen_crccalc_prexored(19),
      O => crc_out_crc_gen_crccalc_matrix_row18_xorq_q_402
    );
  crc_out_crc_gen_crccalc_matrix_row18_xorq100_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(23),
      ADR1 => crc_out_data_wire(23),
      ADR2 => crc_out_crc_out(24),
      ADR3 => crc_out_data_wire(24),
      O => crc_out_crc_gen_crccalc_matrix_q010_7
    );
  crc_out_crc_gen_crccalc_matrix_row19_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row19_xorq_q_159,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row19_xorq_q_157,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_1,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q010_4,
      O => crc_out_crc_gen_crc_calc(19)
    );
  crc_out_crc_gen_crccalc_matrix_row19_xorq_q_157_683 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(20),
      ADR1 => crc_out_crc_gen_crccalc_prexored(11),
      ADR2 => crc_out_crc_gen_crccalc_prexored(25),
      ADR3 => crc_out_crc_gen_crccalc_prexored(3),
      O => crc_out_crc_gen_crccalc_matrix_row19_xorq_q_157
    );
  crc_out_crc_gen_crccalc_matrix_row19_xorq_q_159_684 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_4,
      ADR1 => crc_out_crc_gen_crccalc_prexored(24),
      ADR2 => crc_out_crc_gen_crccalc_prexored(22),
      O => crc_out_crc_gen_crccalc_matrix_row19_xorq_q_159
    );
  crc_out_crc_gen_crccalc_matrix_row19_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(27),
      ADR1 => crc_out_data_wire(27),
      ADR2 => crc_out_crc_out(29),
      ADR3 => crc_out_data_wire(29),
      O => crc_out_crc_gen_crccalc_matrix_q110_4
    );
  crc_out_crc_gen_crccalc_matrix_row20_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row20_xorq_q_120,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row20_xorq_q_118,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q100,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q110_5,
      O => crc_out_crc_gen_crc_calc(20)
    );
  crc_out_crc_gen_crccalc_matrix_row20_xorq_q_118_685 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(4),
      ADR1 => crc_out_crc_gen_crccalc_prexored(21),
      ADR2 => crc_out_crc_gen_crccalc_prexored(26),
      ADR3 => crc_out_crc_gen_crccalc_prexored(12),
      O => crc_out_crc_gen_crccalc_matrix_row20_xorq_q_118
    );
  crc_out_crc_gen_crccalc_matrix_row20_xorq_q_120_686 : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q100_4,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q010_2,
      O => crc_out_crc_gen_crccalc_matrix_row20_xorq_q_120
    );
  crc_out_crc_gen_crccalc_matrix_row20_xorq110_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(28),
      ADR1 => crc_out_data_wire(28),
      ADR2 => crc_out_crc_out(30),
      ADR3 => crc_out_data_wire(30),
      O => crc_out_crc_gen_crccalc_matrix_q110_5
    );
  crc_out_crc_gen_crccalc_matrix_row21_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q11_2,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row21_xorq_q_454,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q001,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q101,
      O => crc_out_crc_gen_crc_calc(21)
    );
  crc_out_crc_gen_crccalc_matrix_row21_xorq_q_454_687 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_0,
      ADR1 => crc_out_crc_gen_crccalc_prexored(13),
      ADR2 => crc_out_crc_gen_crccalc_prexored(5),
      ADR3 => crc_out_crc_gen_crccalc_prexored(22),
      O => crc_out_crc_gen_crccalc_matrix_row21_xorq_q_454
    );
  crc_out_crc_gen_crccalc_matrix_row22_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row22_xorq_q_476,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110_0,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q11_2,
      ADR3 => crc_out_crc_gen_crccalc_matrix_row22_xorq_q_477,
      O => crc_out_crc_gen_crc_calc(22)
    );
  crc_out_crc_gen_crccalc_matrix_row22_xorq_q_476_688 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_6,
      ADR1 => crc_out_crc_gen_crccalc_prexored(9),
      ADR2 => crc_out_crc_gen_crccalc_prexored(0),
      O => crc_out_crc_gen_crccalc_matrix_row22_xorq_q_476
    );
  crc_out_crc_gen_crccalc_matrix_row22_xorq_q_477_689 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010,
      ADR1 => crc_out_crc_gen_crccalc_prexored(14),
      ADR2 => crc_out_crc_gen_crccalc_prexored(19),
      ADR3 => crc_out_crc_gen_crccalc_prexored(23),
      O => crc_out_crc_gen_crccalc_matrix_row22_xorq_q_477
    );
  crc_out_crc_gen_crccalc_matrix_row23_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row23_xorq_q_437,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q11_2,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q001_5,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q000,
      O => crc_out_crc_gen_crc_calc(23)
    );
  crc_out_crc_gen_crccalc_matrix_row23_xorq_q_435_690 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_4,
      ADR1 => crc_out_crc_gen_crccalc_prexored(26),
      ADR2 => crc_out_crc_gen_crccalc_prexored(19),
      O => crc_out_crc_gen_crccalc_matrix_row23_xorq_q_435
    );
  crc_out_crc_gen_crccalc_matrix_row23_xorq_q_437_691 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row23_xorq_q_435,
      ADR1 => crc_out_crc_gen_crccalc_prexored(13),
      ADR2 => crc_out_crc_gen_crccalc_prexored(20),
      ADR3 => crc_out_crc_gen_crccalc_prexored(17),
      O => crc_out_crc_gen_crccalc_matrix_row23_xorq_q_437
    );
  crc_out_crc_gen_crccalc_matrix_row23_xorq11_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(27),
      ADR1 => crc_out_crc_gen_crccalc_prexored(31),
      ADR2 => crc_out_crc_gen_crccalc_prexored(29),
      O => crc_out_crc_gen_crccalc_matrix_q11_2
    );
  crc_out_crc_gen_crccalc_matrix_row24_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row24_xorq_q_339,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q11_3,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q101_0,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q100,
      O => crc_out_crc_gen_crc_calc(24)
    );
  crc_out_crc_gen_crccalc_matrix_row24_xorq_q_339_692 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q011_1,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q000_0,
      ADR2 => crc_out_crc_gen_crccalc_prexored(14),
      ADR3 => crc_out_crc_gen_crccalc_prexored(18),
      O => crc_out_crc_gen_crccalc_matrix_row24_xorq_q_339
    );
  crc_out_crc_gen_crccalc_matrix_row25_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row25_xorq_q_449,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q11_0,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q101,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q101_1,
      O => crc_out_crc_gen_crc_calc(25)
    );
  crc_out_crc_gen_crccalc_matrix_row25_xorq_q_449_693 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q000_1,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q011_0,
      ADR2 => crc_out_crc_gen_crccalc_prexored(19),
      ADR3 => crc_out_crc_gen_crccalc_prexored(15),
      O => crc_out_crc_gen_crccalc_matrix_row25_xorq_q_449
    );
  crc_out_crc_gen_crccalc_matrix_row26_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row26_xorq_q_397,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110_2,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_5,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q101_2,
      O => crc_out_crc_gen_crc_calc(26)
    );
  crc_out_crc_gen_crccalc_matrix_row26_xorq_q_393_694 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(10),
      ADR1 => crc_out_crc_gen_crccalc_prexored(18),
      ADR2 => crc_out_crc_gen_crccalc_prexored(0),
      ADR3 => crc_out_crc_gen_crccalc_prexored(3),
      O => crc_out_crc_gen_crccalc_matrix_row26_xorq_q_393
    );
  crc_out_crc_gen_crccalc_matrix_row26_xorq_q_397_695 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q11_1,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row26_xorq_q_393,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q001_1,
      O => crc_out_crc_gen_crccalc_matrix_row26_xorq_q_397
    );
  crc_out_crc_gen_crccalc_matrix_row26_xorq11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_3,
      ADR1 => crc_out_crc_gen_crccalc_prexored(26),
      O => crc_out_crc_gen_crccalc_matrix_q11_1
    );
  crc_out_crc_gen_crccalc_matrix_row27_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row27_xorq_q_277,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row27_xorq_q_275,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_5,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q001_6,
      O => crc_out_crc_gen_crc_calc(27)
    );
  crc_out_crc_gen_crccalc_matrix_row27_xorq_q_271_696 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(1),
      ADR1 => crc_out_data_wire(1),
      ADR2 => crc_out_crc_out(11),
      ADR3 => crc_out_data_wire(11),
      O => crc_out_crc_gen_crccalc_matrix_row27_xorq_q_271
    );
  crc_out_crc_gen_crccalc_matrix_row27_xorq_q_275_697 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_4,
      ADR1 => crc_out_crc_gen_crccalc_prexored(26),
      ADR2 => crc_out_crc_gen_crccalc_prexored(4),
      O => crc_out_crc_gen_crccalc_matrix_row27_xorq_q_275
    );
  crc_out_crc_gen_crccalc_matrix_row27_xorq_q_277_698 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_2,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row27_xorq_q_271,
      ADR2 => crc_out_crc_gen_crccalc_prexored(21),
      ADR3 => crc_out_crc_gen_crccalc_prexored(23),
      O => crc_out_crc_gen_crccalc_matrix_row27_xorq_q_277
    );
  crc_out_crc_gen_crccalc_matrix_row28_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row28_xorq_q_387,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row28_xorq_q_384,
      ADR2 => crc_out_crc_gen_crccalc_prexored(24),
      ADR3 => crc_out_crc_gen_crccalc_prexored(22),
      O => crc_out_crc_gen_crc_calc(28)
    );
  crc_out_crc_gen_crccalc_matrix_row28_xorq_q_383_699 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(26),
      ADR1 => crc_out_crc_gen_crccalc_prexored(8),
      ADR2 => crc_out_crc_gen_crccalc_prexored(2),
      O => crc_out_crc_gen_crccalc_matrix_row28_xorq_q_383
    );
  crc_out_crc_gen_crccalc_matrix_row28_xorq_q_384_700 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(5),
      ADR1 => crc_out_crc_gen_crccalc_prexored(6),
      ADR2 => crc_out_crc_gen_crccalc_prexored(12),
      ADR3 => crc_out_crc_gen_crccalc_prexored(25),
      O => crc_out_crc_gen_crccalc_matrix_row28_xorq_q_384
    );
  crc_out_crc_gen_crccalc_matrix_row28_xorq_q_387_701 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q11_3,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row28_xorq_q_383,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q101_0,
      O => crc_out_crc_gen_crccalc_matrix_row28_xorq_q_387
    );
  crc_out_crc_gen_crccalc_matrix_row28_xorq11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q110_5,
      ADR1 => crc_out_crc_gen_crccalc_prexored(27),
      O => crc_out_crc_gen_crccalc_matrix_q11_3
    );
  crc_out_crc_gen_crccalc_matrix_row29_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row29_xorq_q_483,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q100_3,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q11_0,
      ADR3 => crc_out_crc_gen_crccalc_matrix_row29_xorq_q_484,
      O => crc_out_crc_gen_crc_calc(29)
    );
  crc_out_crc_gen_crccalc_matrix_row29_xorq_q_483_702 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q101_1,
      ADR1 => crc_out_crc_gen_crccalc_prexored(9),
      ADR2 => crc_out_crc_gen_crccalc_prexored(3),
      O => crc_out_crc_gen_crccalc_matrix_row29_xorq_q_483
    );
  crc_out_crc_gen_crccalc_matrix_row29_xorq_q_484_703 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q100_4,
      ADR1 => crc_out_crc_gen_crccalc_prexored(13),
      ADR2 => crc_out_crc_gen_crccalc_prexored(6),
      ADR3 => crc_out_crc_gen_crccalc_prexored(7),
      O => crc_out_crc_gen_crccalc_matrix_row29_xorq_q_484
    );
  crc_out_crc_gen_crccalc_matrix_row29_xorq11_q : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_prexored(28),
      ADR1 => crc_out_crc_gen_crccalc_prexored(31),
      ADR2 => crc_out_crc_gen_crccalc_prexored(29),
      O => crc_out_crc_gen_crccalc_matrix_q11_0
    );
  crc_out_crc_gen_crccalc_matrix_row30_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row30_xorq_q_167,
      ADR1 => crc_out_crc_gen_crccalc_matrix_row30_xorq_q_165,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q101_2,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q110_1,
      O => crc_out_crc_gen_crc_calc(30)
    );
  crc_out_crc_gen_crccalc_matrix_row30_xorq_q_162 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_out(7),
      ADR1 => crc_out_data_wire(7),
      ADR2 => crc_out_crc_out(10),
      ADR3 => crc_out_data_wire(10),
      O => crc_out_crc_gen_crccalc_matrix_q011_1
    );
  crc_out_crc_gen_crccalc_matrix_row30_xorq_q_165_704 : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q011_1,
      ADR1 => crc_out_crc_gen_crccalc_prexored(14),
      ADR2 => crc_out_crc_gen_crccalc_prexored(4),
      O => crc_out_crc_gen_crccalc_matrix_row30_xorq_q_165
    );
  crc_out_crc_gen_crccalc_matrix_row30_xorq_q_167_705 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q100_3,
      ADR1 => crc_out_crc_gen_crccalc_prexored(24),
      ADR2 => crc_out_crc_gen_crccalc_prexored(8),
      ADR3 => crc_out_crc_gen_crccalc_prexored(28),
      O => crc_out_crc_gen_crccalc_matrix_row30_xorq_q_167
    );
  crc_out_crc_gen_crccalc_matrix_row31_xorq_q : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_row31_xorq_q_365,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q11,
      ADR2 => crc_out_crc_gen_crccalc_matrix_q010_3,
      ADR3 => crc_out_crc_gen_crccalc_matrix_q000_2,
      O => crc_out_crc_gen_crc_calc(31)
    );
  crc_out_crc_gen_crccalc_matrix_row31_xorq_q_365_706 : X_LUT4
    generic map(
      INIT => X"6996"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q010_7,
      ADR1 => crc_out_crc_gen_crccalc_matrix_q110,
      ADR2 => crc_out_crc_gen_crccalc_prexored(25),
      ADR3 => crc_out_crc_gen_crccalc_prexored(15),
      O => crc_out_crc_gen_crccalc_matrix_row31_xorq_q_365
    );
  crc_out_crc_gen_crccalc_matrix_row31_xorq11_q : X_LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      ADR0 => crc_out_crc_gen_crccalc_matrix_q111,
      ADR1 => crc_out_crc_gen_crccalc_prexored(29),
      O => crc_out_crc_gen_crccalc_matrix_q11
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_0_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(0),
      ADR1 => crc_out_crc_out(0),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(0)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_1_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(1),
      ADR1 => crc_out_crc_out(1),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(1)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_2_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(2),
      ADR1 => crc_out_crc_out(2),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(2)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_3_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(3),
      ADR1 => crc_out_crc_out(3),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(3)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_4_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(4),
      ADR1 => crc_out_crc_out(4),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(4)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_5_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(5),
      ADR1 => crc_out_crc_out(5),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(5)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_6_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(6),
      ADR1 => crc_out_crc_out(6),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(6)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_7_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(7),
      ADR1 => crc_out_crc_out(7),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(7)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_8_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(8),
      ADR1 => crc_out_crc_out(8),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(8)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_9_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(9),
      ADR1 => crc_out_crc_out(9),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(9)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_10_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(10),
      ADR1 => crc_out_crc_out(10),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(10)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_11_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(11),
      ADR1 => crc_out_crc_out(11),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(11)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_12_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(12),
      ADR1 => crc_out_crc_out(12),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(12)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_13_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(13),
      ADR1 => crc_out_crc_out(13),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(13)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_14_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(14),
      ADR1 => crc_out_crc_out(14),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(14)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_15_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(15),
      ADR1 => crc_out_crc_out(15),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(15)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_16_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(16),
      ADR1 => crc_out_crc_out(16),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(16)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_17_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(17),
      ADR1 => crc_out_crc_out(17),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(17)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_18_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(18),
      ADR1 => crc_out_crc_out(18),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(18)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_19_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(19),
      ADR1 => crc_out_crc_out(19),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(19)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_20_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(20),
      ADR1 => crc_out_crc_out(20),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(20)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_21_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(21),
      ADR1 => crc_out_crc_out(21),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(21)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_22_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(22),
      ADR1 => crc_out_crc_out(22),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(22)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_23_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(23),
      ADR1 => crc_out_crc_out(23),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(23)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_24_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(24),
      ADR1 => crc_out_crc_out(24),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(24)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_25_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(25),
      ADR1 => crc_out_crc_out(25),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(25)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_26_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(26),
      ADR1 => crc_out_crc_out(26),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(26)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_27_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(27),
      ADR1 => crc_out_crc_out(27),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(27)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_28_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(28),
      ADR1 => crc_out_crc_out(28),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(28)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_29_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(29),
      ADR1 => crc_out_crc_out(29),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(29)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_30_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(30),
      ADR1 => crc_out_crc_out(30),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(30)
    );
  crc_out_crc_set_clk_copy_data_buf_3_0_xor2_31_Q : X_LUT3
    generic map(
      INIT => X"9A"
    )
    port map (
      ADR0 => crc_out_data_wire(31),
      ADR1 => crc_out_crc_out(31),
      ADR2 => crc_out_crc_pos_wire,
      O => crc_out_crc_set_data_buf_3(31)
    );
  crc_out_crc_set_SOC_OUT_MOD : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_soc_wire,
      O => SOC_OUT_MOD,
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_18_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(18),
      O => D_OUT_MOD(18),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_19_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(19),
      O => D_OUT_MOD(19),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_20_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(20),
      O => D_OUT_MOD(20),
      SRST => Reset_l_i_28,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_21_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(21),
      O => D_OUT_MOD(21),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_22_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(22),
      O => D_OUT_MOD(22),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_23_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(23),
      O => D_OUT_MOD(23),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_24_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(24),
      O => D_OUT_MOD(24),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_25_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(25),
      O => D_OUT_MOD(25),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_26_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(26),
      O => D_OUT_MOD(26),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_27_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(27),
      O => D_OUT_MOD(27),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_28_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(28),
      O => D_OUT_MOD(28),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_29_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(29),
      O => D_OUT_MOD(29),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_30_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(30),
      O => D_OUT_MOD(30),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_31_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(31),
      O => D_OUT_MOD(31),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_3_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(3),
      O => D_OUT_MOD(3),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_4_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(4),
      O => D_OUT_MOD(4),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_5_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(5),
      O => D_OUT_MOD(5),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_6_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(6),
      O => D_OUT_MOD(6),
      SRST => Reset_l_i_29,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_7_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(7),
      O => D_OUT_MOD(7),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_8_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(8),
      O => D_OUT_MOD(8),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_9_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(9),
      O => D_OUT_MOD(9),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_10_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(10),
      O => D_OUT_MOD(10),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_11_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(11),
      O => D_OUT_MOD(11),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_12_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(12),
      O => D_OUT_MOD(12),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_13_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(13),
      O => D_OUT_MOD(13),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_14_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(14),
      O => D_OUT_MOD(14),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_15_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(15),
      O => D_OUT_MOD(15),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_16_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(16),
      O => D_OUT_MOD(16),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_17_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(17),
      O => D_OUT_MOD(17),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_0_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(0),
      O => D_OUT_MOD(0),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_1_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(1),
      O => D_OUT_MOD(1),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  crc_out_crc_set_D_OUT_MOD_2_Q : X_SFF
    generic map(
      XON => FALSE
    )
    port map (
      CLK => CLK,
      I => crc_out_crc_set_data_buf_3(2),
      O => D_OUT_MOD(2),
      SRST => Reset_l_i_30,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  segment_dfifo_BU7_GSR_OR_707 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU7_GSR_OR
    );
  segment_dfifo_BU11_GSR_OR_708 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU11_GSR_OR
    );
  segment_dfifo_BU15_GSR_OR_709 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU15_GSR_OR
    );
  segment_dfifo_BU19_GSR_OR_710 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU19_GSR_OR
    );
  segment_dfifo_BU23_GSR_OR_711 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU23_GSR_OR
    );
  segment_dfifo_BU27_GSR_OR_712 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU27_GSR_OR
    );
  segment_dfifo_BU30_GSR_OR_713 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU30_GSR_OR
    );
  segment_dfifo_BU32_GSR_OR_714 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU32_GSR_OR
    );
  segment_dfifo_BU34_GSR_OR_715 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU34_GSR_OR
    );
  segment_dfifo_BU36_GSR_OR_716 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU36_GSR_OR
    );
  segment_dfifo_BU38_GSR_OR_717 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU38_GSR_OR
    );
  segment_dfifo_BU40_GSR_OR_718 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU40_GSR_OR
    );
  segment_dfifo_BU42_GSR_OR_719 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU42_GSR_OR
    );
  segment_dfifo_BU44_GSR_OR_720 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU44_GSR_OR
    );
  segment_dfifo_BU47_GSR_OR_721 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU47_GSR_OR
    );
  segment_dfifo_BU50_GSR_OR_722 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU50_GSR_OR
    );
  segment_dfifo_BU56_GSR_OR_723 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU56_GSR_OR
    );
  segment_dfifo_BU59_GSR_OR_724 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU59_GSR_OR
    );
  segment_dfifo_BU62_GSR_OR_725 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU62_GSR_OR
    );
  segment_dfifo_BU65_GSR_OR_726 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU65_GSR_OR
    );
  segment_dfifo_BU68_GSR_OR_727 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU68_GSR_OR
    );
  segment_dfifo_BU73_GSR_OR_728 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU73_GSR_OR
    );
  segment_dfifo_BU79_GSR_OR_729 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU79_GSR_OR
    );
  segment_dfifo_BU83_GSR_OR_730 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU83_GSR_OR
    );
  segment_dfifo_BU87_GSR_OR_731 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU87_GSR_OR
    );
  segment_dfifo_BU91_GSR_OR_732 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU91_GSR_OR
    );
  segment_dfifo_BU95_GSR_OR_733 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU95_GSR_OR
    );
  segment_dfifo_BU99_GSR_OR_734 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU99_GSR_OR
    );
  segment_dfifo_BU102_GSR_OR_735 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU102_GSR_OR
    );
  segment_dfifo_BU104_GSR_OR_736 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU104_GSR_OR
    );
  segment_dfifo_BU106_GSR_OR_737 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU106_GSR_OR
    );
  segment_dfifo_BU108_GSR_OR_738 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU108_GSR_OR
    );
  segment_dfifo_BU110_GSR_OR_739 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU110_GSR_OR
    );
  segment_dfifo_BU112_GSR_OR_740 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU112_GSR_OR
    );
  segment_dfifo_BU114_GSR_OR_741 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU114_GSR_OR
    );
  segment_dfifo_BU116_GSR_OR_742 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU116_GSR_OR
    );
  segment_dfifo_BU117_GSR_OR_743 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU117_GSR_OR
    );
  segment_dfifo_BU118_GSR_OR_744 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU118_GSR_OR
    );
  segment_dfifo_BU119_GSR_OR_745 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU119_GSR_OR
    );
  segment_dfifo_BU120_GSR_OR_746 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU120_GSR_OR
    );
  segment_dfifo_BU121_GSR_OR_747 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU121_GSR_OR
    );
  segment_dfifo_BU122_GSR_OR_748 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU122_GSR_OR
    );
  segment_dfifo_BU123_GSR_OR_749 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU123_GSR_OR
    );
  segment_dfifo_BU126_GSR_OR_750 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU126_GSR_OR
    );
  segment_dfifo_BU129_GSR_OR_751 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU129_GSR_OR
    );
  segment_dfifo_BU135_GSR_OR_752 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU135_GSR_OR
    );
  segment_dfifo_BU138_GSR_OR_753 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU138_GSR_OR
    );
  segment_dfifo_BU141_GSR_OR_754 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU141_GSR_OR
    );
  segment_dfifo_BU144_GSR_OR_755 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU144_GSR_OR
    );
  segment_dfifo_BU147_GSR_OR_756 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU147_GSR_OR
    );
  segment_dfifo_BU152_GSR_OR_757 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_dfifo_BU152_GSR_OR
    );
  segment_lfifo_BU5_GSR_OR_758 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU5_GSR_OR
    );
  segment_lfifo_BU9_GSR_OR_759 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU9_GSR_OR
    );
  segment_lfifo_BU13_GSR_OR_760 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU13_GSR_OR
    );
  segment_lfifo_BU16_GSR_OR_761 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU16_GSR_OR
    );
  segment_lfifo_BU18_GSR_OR_762 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU18_GSR_OR
    );
  segment_lfifo_BU20_GSR_OR_763 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU20_GSR_OR
    );
  segment_lfifo_BU22_GSR_OR_764 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU22_GSR_OR
    );
  segment_lfifo_BU24_GSR_OR_765 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU24_GSR_OR
    );
  segment_lfifo_BU27_GSR_OR_766 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU27_GSR_OR
    );
  segment_lfifo_BU30_GSR_OR_767 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU30_GSR_OR
    );
  segment_lfifo_BU36_GSR_OR_768 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU36_GSR_OR
    );
  segment_lfifo_BU39_GSR_OR_769 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU39_GSR_OR
    );
  segment_lfifo_BU44_GSR_OR_770 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU44_GSR_OR
    );
  segment_lfifo_BU50_GSR_OR_771 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU50_GSR_OR
    );
  segment_lfifo_BU54_GSR_OR_772 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU54_GSR_OR
    );
  segment_lfifo_BU58_GSR_OR_773 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU58_GSR_OR
    );
  segment_lfifo_BU61_GSR_OR_774 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU61_GSR_OR
    );
  segment_lfifo_BU63_GSR_OR_775 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU63_GSR_OR
    );
  segment_lfifo_BU65_GSR_OR_776 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU65_GSR_OR
    );
  segment_lfifo_BU67_GSR_OR_777 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU67_GSR_OR
    );
  segment_lfifo_BU69_GSR_OR_778 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU69_GSR_OR
    );
  segment_lfifo_BU70_GSR_OR_779 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU70_GSR_OR
    );
  segment_lfifo_BU71_GSR_OR_780 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU71_GSR_OR
    );
  segment_lfifo_BU72_GSR_OR_781 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU72_GSR_OR
    );
  segment_lfifo_BU73_GSR_OR_782 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU73_GSR_OR
    );
  segment_lfifo_BU76_GSR_OR_783 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU76_GSR_OR
    );
  segment_lfifo_BU79_GSR_OR_784 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU79_GSR_OR
    );
  segment_lfifo_BU85_GSR_OR_785 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU85_GSR_OR
    );
  segment_lfifo_BU88_GSR_OR_786 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU88_GSR_OR
    );
  segment_lfifo_BU93_GSR_OR_787 : X_OR2
    port map (
      I0 => segment_fifo_rst,
      I1 => GSR,
      O => segment_lfifo_BU93_GSR_OR
    );
  NlwTieBlock_FrameProc_VCC : X_ONE
    port map (
      O => VCC
    );
  NlwTieBlock_FrameProc_GND : X_ZERO
    port map (
      O => GND
    );
  NlwBlockROC : ROC     port map (O => GSR);
end STRUCTURE;

